package org.modelio.modelfragment.command;

import org.modelio.modelfragment.api.IModelFragmentStereotypes;

import com.modeliosoft.modelio.api.mdac.IMdac;
import com.modeliosoft.modelio.api.mdac.commands.DefaultMdacContextualCommand;
import com.modeliosoft.modelio.api.model.IModelingSession;
import com.modeliosoft.modelio.api.model.ITransaction;
import com.modeliosoft.modelio.api.model.InvalidTransactionException;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.ObList;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;

public class CreateModelFragmentCommand extends DefaultMdacContextualCommand {

	public boolean accept(ObList<IElement> selectedElements, IMdac mdac) {
		// Check that there is only one selected element
		return selectedElements.size() == 1 
				&& selectedElements.get(0).equals(Modelio.getInstance().getModelingSession().getModel().getRoot());
	}


	public void actionPerformed(ObList<IElement> selectedElements, IMdac mdac) {
		IModelingSession session =  Modelio.getInstance().getModelingSession();
		ITransaction transaction = session.createTransaction("Create Model fragment definition");
		try{
			IArtifact comp = session.getModel().createArtifact();
			comp.setOwner(session.getModel().getRoot());
			comp.addExtension(session.getMetamodelExtensions().getStereotype(IArtifact.class, IModelFragmentStereotypes.MODELFRAGMENT));
			session.commit(transaction);
			transaction = null;
		} catch (StereotypeNotFoundException e) {
			transaction = null;
			e.printStackTrace();
		} catch (InvalidTransactionException e) {
			// Transaction already rollbacked
			transaction = null;
		} finally {
			if (transaction != null)
				session.rollback(transaction);
		}

	}
}
