/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package org.modelio.modelfragment.command.ihm;

import com.modeliosoft.modelio.api.modelio.Version;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;
import org.modelio.modelfragment.utils.I18nMessageService;

@objid ("be401dfe-fe92-11dd-8b31-0014222a9f79")
public class EditDependenciesLabelProvider extends LabelProvider {

    @objid ("be474543-fe92-11dd-8b31-0014222a9f79")
    @Override
    public Image getImage(Object element) {
        return null;
    }

    @objid ("be4280a6-fe92-11dd-8b31-0014222a9f79")
    @Override
    public String getText(Object element) {
        EditFragmentAdapter adapter = (EditFragmentAdapter) element;
        Version version = adapter.getFragmentVersion();
        if (version == null) {
            return adapter.getFragmentName() + " (" + I18nMessageService.getString("PackageRamcDialog.NoVersion") + ")";
        } else {
            return adapter.getFragmentName() +
                   " (" +
                   version.getMajorVersion() +
                   "." +
                   version.getMinorVersion() +
                   "." +
                   version.getBuildVersion() +
                   ")";
        }
    }

}
