/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package org.modelio.modelfragment.command.ihm;

import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.part.PluginTransfer;
import org.modelio.modelfragment.utils.I18nMessageService;
import org.modelio.modelfragment.utils.ResourcesManager;

import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.modelio.Version;
import com.modeliosoft.modelio.api.ui.ModelioDialog;
import com.modeliosoft.modelio.api.ui.UIColor;
import com.modeliosoft.modelio.api.ui.dnd.LinuxDropTarget;
import com.modeliosoft.modelio.api.ui.dnd.ModelElementTransfer;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

@objid ("be401dfb-fe92-11dd-8b31-0014222a9f79")
public class EditFragmentDialog extends ModelioDialog {
    @objid ("be47452d-fe92-11dd-8b31-0014222a9f79")
    protected Button createButton = null;

    @objid ("be474515-fe92-11dd-8b31-0014222a9f79")
    protected Button cancelButton = null;

    @objid ("be474510-fe92-11dd-8b31-0014222a9f79")
    protected EditFragmentDataModel dataModel = null;

//    @objid ("be44e2e9-fe92-11dd-8b31-0014222a9f79")
//    private Label fragPathLabel = null;

//    @objid ("be44e2ae-fe92-11dd-8b31-0014222a9f79")
//    protected Text fragPathText = null;

//    @objid ("be49a78a-fe92-11dd-8b31-0014222a9f79")
//    private Button fragPathButton = null;

//    @objid ("be49a78b-fe92-11dd-8b31-0014222a9f79")
//    private Image fileChooserImage = null;

//    @objid ("be49a78c-fe92-11dd-8b31-0014222a9f79")
//    protected FileDialog fragPathChooser = null;

    @objid ("be49a76b-fe92-11dd-8b31-0014222a9f79")
    private Label fragNameLabel = null;

    @objid ("be49a770-fe92-11dd-8b31-0014222a9f79")
    private Label fragVersionLabel = null;

    @objid ("be49a771-fe92-11dd-8b31-0014222a9f79")
    private Label fragDescriptionLabel = null;

    @objid ("be401e12-fe92-11dd-8b31-0014222a9f79")
    private Label fragDependenciesLabel = null;

    @objid ("be401e13-fe92-11dd-8b31-0014222a9f79")
    protected Text fragNameText = null;

    @objid ("be428085-fe92-11dd-8b31-0014222a9f79")
    protected Text fragVersionText = null;

    @objid ("be44e31e-fe92-11dd-8b31-0014222a9f79")
    protected Text fragDescriptionText = null;

    @objid ("be47452e-fe92-11dd-8b31-0014222a9f79")
    private TableViewer fragDependenciesList = null;

    @objid ("be49a783-fe92-11dd-8b31-0014222a9f79")
    protected EditFragmentController controller = null;

    @objid ("bdf28c9f-ff45-11dd-95ab-0014222a9f79")
    private Label fragManifestationsLabel = null;

    @objid ("be0801cc-ff45-11dd-95ab-0014222a9f79")
    private TableViewer fragManifestationsList = null;

    @objid ("25a7d838-ff6f-11dd-95ab-0014222a9f79")
    protected Label fragFilesLabel = null;

    @objid ("25aeff43-ff6f-11dd-95ab-0014222a9f79")
    protected TableViewer fragFilesList = null;

    @objid ("25b161a2-ff6f-11dd-95ab-0014222a9f79")
    private Image dropAreaImage = null;

    @objid ("b391adf6-ff73-11dd-95ab-0014222a9f79")
    protected Button addFilesButton = null;

    @objid ("b3941054-ff73-11dd-95ab-0014222a9f79")
    protected Button removeFilesButton = null;

    @objid ("b3c3bf5c-ff73-11dd-95ab-0014222a9f79")
    private Image deleteImage = null;
    
    protected FileDialog filesChooser = null;


    @objid ("be47451a-fe92-11dd-8b31-0014222a9f79")
    public EditFragmentDialog(Shell parentShell, EditFragmentDataModel dataModel) {
        super(parentShell);
        this.dataModel = dataModel;
        this.setShellStyle(SWT.MODELESS | SWT.DIALOG_TRIM | SWT.RESIZE);
        
        this.dropAreaImage = new Image(Display.getDefault(), 
        		ResourcesManager.getInstance().getImage("droparea_21.png"));
   
//        		AbstractUIPlugin.imageDescriptorFromPlugin(frags.PLUGIN_ID,
//                                                                        "icons/droparea_21.png")
//                                             .createImage();
//        this.deleteImage = AbstractUIPlugin.imageDescriptorFromPlugin(frags.PLUGIN_ID,
//                                                                      "icons/delete_16.png").createImage();
//        this.fileChooserImage = AbstractUIPlugin.imageDescriptorFromPlugin(frags.PLUGIN_ID,
//                                                                           "icons/fileChooser_16.png")
//                                                .createImage();
    }

    @objid ("be44e306-fe92-11dd-8b31-0014222a9f79")
    @Override
    public void addButtonsInButtonBar(Composite parent) {
        this.createButton = this.createButton(parent,
                                              IDialogConstants.OK_ID,
                                              I18nMessageService.getString("EditRamcDialog.Modify"),
                                              true);
        this.cancelButton = this.createButton(parent,
                                              IDialogConstants.CANCEL_ID,
                                              I18nMessageService.getString("EditRamcDialog.Cancel"),
                                              false);
    }

    @objid ("be44e30b-fe92-11dd-8b31-0014222a9f79")
    @Override
    public Control createContentArea(Composite parent) {
        Composite area = new Composite(parent, SWT.NONE);
        area.setLayoutData(new GridData(GridData.FILL_BOTH));
        area.setLayout(new GridLayout());
        
        TabFolder tabFolder = new TabFolder(area, SWT.NONE);
        tabFolder.setLayoutData(new GridData(GridData.FILL_BOTH));
        
        TabItem mainTab = new TabItem(tabFolder, SWT.NONE);
        mainTab.setText(I18nMessageService.getString("EditRamcDialog.MainTab"));
//        TabItem filesTab = new TabItem(tabFolder, SWT.NONE);
//        filesTab.setText(I18nMessageService.getString("EditRamcDialog.FilesTab"));
        
        Composite mainArea = new Composite(tabFolder, SWT.NONE);
        mainTab.setControl(mainArea);
        //mainArea.setLayoutData(new GridData(GridData.FILL_BOTH));
        
        GridLayout mainAreaLayout = new GridLayout(3, false);
        mainArea.setLayout(mainAreaLayout);
        
        this.controller = new EditFragmentController(this.dataModel, this);
        
        IArtifact modelComponent = this.dataModel.getModelComponent();
        
        boolean isModelComponentEditable = modelComponent.getElementStatus().isModifiable();
        
        this.createFragmentNameField(mainArea, isModelComponentEditable);
        this.createFragmentVersionField(mainArea, isModelComponentEditable);
//        this.createFragmentPathField(mainArea, isModelComponentEditable);
        this.createDescriptionField(mainArea, isModelComponentEditable);
        this.createManifestationsField(mainArea, isModelComponentEditable);
        this.createDependenciesField(mainArea, isModelComponentEditable);
        
//        Composite filesArea = new Composite(tabFolder, SWT.NONE);
//        filesTab.setControl(filesArea);
//        GridLayout filesAreaLayout = new GridLayout(3, false);
//        filesArea.setLayout(filesAreaLayout);
//        filesArea.setLayoutData(new GridData(GridData.FILL_BOTH));
        
//        this.createFilesField(filesArea, isModelComponentEditable);
        
        this.refresh();
        
        this.addListener(this.controller);
        return area;
    }

    @objid ("be474508-fe92-11dd-8b31-0014222a9f79")
    private void createFragmentPathField(Composite area, boolean isModelComponentEditable) {
        // model component path chooser:
        //-------------------
//        this.fragPathLabel = new Label(area, SWT.NONE);
//        this.fragPathLabel.setText(I18nMessageService.getString("EditRamcDialog.ModelComponentPath"));
//        this.fragPathText = new Text(area, SWT.BORDER);
//        this.fragPathText.setEditable(isModelComponentEditable);
//        
//        if (!isModelComponentEditable) {
//            this.fragPathText.setForeground(UIColor.EDITOR_ROTEXT_FG);
//            this.fragPathText.setBackground(UIColor.TEXT_READONLY_BG);
//        }
//        
//        final GridData gd_fragPathLabel = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
//        this.fragPathLabel.setLayoutData(gd_fragPathLabel);
//        
//        final GridData gd_fragPathText = new GridData(SWT.FILL, SWT.UP, true, false, 1, 1);
//        this.fragPathText.setLayoutData(gd_fragPathText);
        
//        if (isModelComponentEditable) {
//            this.fragPathButton = new Button(area, SWT.NONE);
//            this.fragPathButton.setImage(this.fileChooserImage);
//        
//            this.fragPathChooser = new FileDialog(this.getShell(), SWT.OPEN);
//            this.fragPathChooser.setFilterExtensions(new String[] { "*.frag" });
//            this.fragPathChooser.setFilterNames(new String[] { I18nMessageService.getString("EditRamcDialog.RamcFiles") });
//            this.fragPathButton.addSelectionListener(new SelectionListener() {
//                @Override
//                public void widgetDefaultSelected(SelectionEvent e) {
//                }
//        
//                @Override
//                public void widgetSelected(SelectionEvent e) {
//                    String fileName = EditFragmentDialog.this.fragPathChooser.open();
//                    if (fileName != null) {
//                        EditFragmentDialog.this.fragPathText.setText(fileName);
//                        EditFragmentDialog.this.dataModel.setModelComponentPath(new File(fileName));
//                    }
//                }
//            });
        
//            final GridData gd_fragPathButton = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
//            gd_fragPathButton.heightHint = 21;
//            gd_fragPathButton.widthHint = 21;
//            this.fragPathButton.setLayoutData(gd_fragPathButton);
//        } else {
            Composite emptyComposite = new Composite(area, SWT.NONE);
        
            final GridData gd_emptyComposite = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
            gd_emptyComposite.heightHint = 21;
            gd_emptyComposite.widthHint = 21;
            emptyComposite.setLayoutData(gd_emptyComposite);
//        }
    }

    @objid ("be44e305-fe92-11dd-8b31-0014222a9f79")
    @Override
    public void init() {
        this.setLogoImage(null);
        
        // Put the I18nMessageService in the banner area
        IArtifact modelComponent = this.dataModel.getModelComponent();
        
        boolean isModelComponentEditable = modelComponent.getElementStatus().isModifiable();
        
        if (isModelComponentEditable) {
            this.getShell().setText(I18nMessageService.getString("EditRamcDialog.EditRamcDialogTitle"));
            this.setTitle(I18nMessageService.getString("EditRamcDialog.EditRamcDialogTitle"));
            this.setMessage(I18nMessageService.getString("EditRamcDialog.EditRamcMessage"));
        } else {
            this.getShell().setText(I18nMessageService.getString("EditRamcDialog.ViewRamcDialogTitle"));
            this.setTitle(I18nMessageService.getString("EditRamcDialog.ViewRamcDialogTitle"));
            this.setMessage(I18nMessageService.getString("EditRamcDialog.ViewRamcMessage"));
        }
        
        Point parentLocation = this.getShell().getParent().getLocation();
        
        this.getShell().setLocation(parentLocation.x + 300, parentLocation.y + 200);
        this.getShell().setSize(500, 600);
        this.getShell().setMinimumSize(500, 550);
        
        this.updateButtons(this.controller.validateData());
    }

    @objid ("be47457b-fe92-11dd-8b31-0014222a9f79")
    @Override
    public boolean close() {
        this.removeListener(this.controller);
//        if (this.fileChooserImage != null) {
//            this.fileChooserImage.dispose();
//            this.fileChooserImage = null;
//        }
        if (this.dropAreaImage != null) {
            this.dropAreaImage.dispose();
            this.dropAreaImage = null;
        }
        if (this.deleteImage != null) {
            this.deleteImage.dispose();
            this.deleteImage = null;
        }
        return super.close();
    }
   

    @objid ("be47456c-fe92-11dd-8b31-0014222a9f79")
    private void createDependenciesField(Composite area, boolean isModelComponentEditable) {
        // frag dependencies field:
        //-------------------------
        this.fragDependenciesLabel = new Label(area, SWT.NONE);
        this.fragDependenciesLabel.setText(I18nMessageService.getString("EditRamcDialog.RamcDependencies"));
        
        this.initDependenciesListViewer(area, isModelComponentEditable);
        
        Label targetLabel = new Label(area, SWT.NONE);
        targetLabel.setImage(this.dropAreaImage);
        
        final GridData gd_fragDependenciesLabel = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        this.fragDependenciesLabel.setLayoutData(gd_fragDependenciesLabel);
        
        final GridData gd_targetLabel = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        gd_targetLabel.heightHint = 21;
        gd_targetLabel.widthHint = 21;
        targetLabel.setLayoutData(gd_targetLabel);
    }

    @objid ("be47456a-fe92-11dd-8b31-0014222a9f79")
    private void createDescriptionField(Composite area, boolean isModelComponentEditable) {
        // model component name field:
        //-----------------
        this.fragDescriptionLabel = new Label(area, SWT.NONE);
        this.fragDescriptionLabel.setText(I18nMessageService.getString("EditRamcDialog.RamcDescription"));
        
        this.fragDescriptionText = new Text(area, SWT.BORDER | SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
        this.fragDescriptionText.setEditable(isModelComponentEditable);
        
        if (!isModelComponentEditable) {
            this.fragDescriptionText.setForeground(UIColor.EDITOR_ROTEXT_FG);
            this.fragDescriptionText.setBackground(UIColor.TEXT_READONLY_BG);
        }
        
        Composite emptyComposite = new Composite(area, SWT.NONE);
        
        final GridData gd_fragDescriptionLabel = new GridData(SWT.LEFT, SWT.UP, false, false);
        this.fragDescriptionLabel.setLayoutData(gd_fragDescriptionLabel);
        
        final GridData gd_fragDescriptionText = new GridData(SWT.FILL, SWT.FILL, true, true);
        this.fragDescriptionText.setLayoutData(gd_fragDescriptionText);
        
        final GridData gd_emptyComposite = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        gd_emptyComposite.heightHint = 21;
        gd_emptyComposite.widthHint = 21;
        emptyComposite.setLayoutData(gd_emptyComposite);
    }

    @objid ("be474550-fe92-11dd-8b31-0014222a9f79")
    private void createFragmentVersionField(Composite area, boolean isModelComponentEditable) {
        // model component name field:
        //-----------------
        this.fragVersionLabel = new Label(area, SWT.NONE);
        this.fragVersionLabel.setText(I18nMessageService.getString("EditRamcDialog.RamcVersion"));
        
        this.fragVersionText = new Text(area, SWT.BORDER);
        this.fragVersionText.setEditable(isModelComponentEditable);
        
        if (!isModelComponentEditable) {
            this.fragVersionText.setForeground(UIColor.EDITOR_ROTEXT_FG);
            this.fragVersionText.setBackground(UIColor.TEXT_READONLY_BG);
        }
        
        Composite emptyComposite = new Composite(area, SWT.NONE);
        
        final GridData gd_fragVersionLabel = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        this.fragVersionLabel.setLayoutData(gd_fragVersionLabel);
        
        final GridData gd_fragVersionText = new GridData(SWT.FILL, SWT.UP, true, false, 1, 1);
        this.fragVersionText.setLayoutData(gd_fragVersionText);
        
        final GridData gd_emptyComposite = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        gd_emptyComposite.heightHint = 21;
        gd_emptyComposite.widthHint = 21;
        emptyComposite.setLayoutData(gd_emptyComposite);
    }

    @objid ("be44e31a-fe92-11dd-8b31-0014222a9f79")
    private void createFragmentNameField(Composite area, boolean isModelComponentEditable) {
        // model component name field:
        //-----------------
        this.fragNameLabel = new Label(area, SWT.NONE);
        this.fragNameLabel.setText(I18nMessageService.getString("EditRamcDialog.RamcName"));
        
        this.fragNameText = new Text(area, SWT.BORDER);
        this.fragNameText.setEditable(isModelComponentEditable);
        
        if (!isModelComponentEditable) {
            this.fragNameText.setForeground(UIColor.EDITOR_ROTEXT_FG);
            this.fragNameText.setBackground(UIColor.TEXT_READONLY_BG);
        }
        
        Composite emptyComposite = new Composite(area, SWT.NONE);
        
        final GridData gd_fragNameLabel = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        this.fragNameLabel.setLayoutData(gd_fragNameLabel);
        
        final GridData gd_fragNameText = new GridData(SWT.FILL, SWT.UP, true, false, 1, 1);
        this.fragNameText.setLayoutData(gd_fragNameText);
        
        final GridData gd_emptyComposite = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        gd_emptyComposite.heightHint = 21;
        gd_emptyComposite.widthHint = 21;
        emptyComposite.setLayoutData(gd_emptyComposite);
    }

    @objid ("be4280a9-fe92-11dd-8b31-0014222a9f79")
    private void addListener(EditFragmentController listener) {
        
        this.fragNameText.addModifyListener(listener);
//        this.fragPathText.addModifyListener(listener);
        this.fragVersionText.addModifyListener(listener);
        this.fragDescriptionText.addModifyListener(listener);
    }

    @objid ("be44e314-fe92-11dd-8b31-0014222a9f79")
    private void removeListener(EditFragmentController listener) {
        this.fragNameText.removeModifyListener(listener);
//        this.fragPathText.removeModifyListener(listener);
        this.fragVersionText.removeModifyListener(listener);
        this.fragDescriptionText.removeModifyListener(listener);
        
    }

    @objid ("be428088-fe92-11dd-8b31-0014222a9f79")
    public void refresh() {
        this.fragNameText.setText(this.dataModel.getFragmentName());
        
        String fragVersion = this.dataModel.getFragmentVersion();
        if ((fragVersion == null)  || (fragVersion.equals(""))) {
            this.fragVersionText.setText("0.0.00");
        } else {
        	 this.fragVersionText.setText(fragVersion);
//            String buildVersion = String.format("%02d", fragVersion.getBuildVersion());
//            this.fragVersionText.setText(fragVersion.getMajorVersion() +
//                                         "." +
//                                         fragVersion.getMinorVersion() +
//                                         "." +
//                                         buildVersion);
        }
        
//        this.fragPathText.setText("");
        
        this.fragDescriptionText.setText(this.dataModel.getFragmentDescription());
        
        this.fragDependenciesList.setInput(this.dataModel.getParentFragments());
        this.fragManifestationsList.setInput(this.dataModel.getManifestedElements());
//        this.fragFilesList.setInput(this.dataModel.getExportedFiles());
    }

    @objid ("be44e31f-fe92-11dd-8b31-0014222a9f79")
    private void initDependenciesListViewer(Composite area, boolean isModelComponentEditable) {
        this.fragDependenciesList = new TableViewer(area, SWT.BORDER | SWT.SINGLE | SWT.V_SCROLL);
        
        this.fragDependenciesList.setContentProvider(new EditDependenciesContentProvider());
        this.fragDependenciesList.setLabelProvider(new EditDependenciesLabelProvider());
        
        if (isModelComponentEditable) {
            int operations = DND.DROP_MOVE;
            Transfer[] types = new Transfer[] { ModelElementTransfer.getInstance(),
                    PluginTransfer.getInstance() };
            DropTarget target;
            if (System.getProperty("os.name").equals("Linux")) {
                target = new LinuxDropTarget(this.fragDependenciesList.getTable(), operations);
            } else {
                target = new DropTarget(this.fragDependenciesList.getTable(), operations);
            }
            target.setTransfer(types);
            EditDependenciesDropListener dropListener = new EditDependenciesDropListener(this,
                                                                                         this.controller,
                                                                                         this.dataModel.getModelComponent());
            target.addDropListener(dropListener);
        
            this.fragDependenciesList.getTable().addKeyListener(new KeyListener() {
        
                @Override
                public void keyPressed(KeyEvent e) {
                }
        
                @Override
                public void keyReleased(KeyEvent e) {
                    if (e.keyCode == SWT.DEL) {
                        Table table = (Table) e.getSource();
                        TableItem[] items = table.getSelection();
                        for (TableItem item : items) {
                            EditFragmentAdapter adapter = (EditFragmentAdapter) item.getData();
                            EditFragmentDialog.this.controller.removeRequiredFragment(adapter);
                        }
                    }
                    EditFragmentDialog.this.refresh();
                }
        
            });
        } else {
            this.fragDependenciesList.getTable().setForeground(UIColor.EDITOR_ROTEXT_FG);
            this.fragDependenciesList.getTable().setBackground(UIColor.TEXT_READONLY_BG);
        }
        
        final GridData gd_fragDependenciesList = new GridData(SWT.FILL, SWT.FILL, true, false);
        gd_fragDependenciesList.heightHint = 50;
        this.fragDependenciesList.getTable().setLayoutData(gd_fragDependenciesList);
    }

    @objid ("be49a76d-fe92-11dd-8b31-0014222a9f79")
    public String getVersion() {
        return this.fragVersionText.getText();
    }

    @objid ("be4280db-fe92-11dd-8b31-0014222a9f79")
    public String getDescription() {
        return this.fragDescriptionText.getText();
    }

//    @objid ("be44e307-fe92-11dd-8b31-0014222a9f79")
//    public String getFragmentPath() {
//        return this.fragPathText.getText();
//    }

    @objid ("be474573-fe92-11dd-8b31-0014222a9f79")
    public void invalidateFragmentVersion(boolean invalid) {
        IArtifact modelComponent = this.dataModel.getModelComponent();
        
        boolean isModelComponentEditable = modelComponent.getElementStatus().isModifiable();
        
        if (isModelComponentEditable) {
            if (invalid == true) {
                this.fragVersionText.setForeground(this.fragVersionText.getDisplay()
                                                                       .getSystemColor(SWT.COLOR_RED));
            } else {
                this.fragVersionText.setForeground(this.fragVersionText.getDisplay()
                                                                       .getSystemColor(SWT.COLOR_DARK_GREEN));
            }
        } else {
            this.fragVersionText.setForeground(UIColor.EDITOR_ROTEXT_FG);
        }
    }

    @objid ("be44e319-fe92-11dd-8b31-0014222a9f79")
    public void updateButtons(boolean canPackage) {
        if (this.createButton != null) {
            this.createButton.setEnabled(canPackage);
        }
    }

//    @objid ("be474544-fe92-11dd-8b31-0014222a9f79")
//    public void invalidateFragmentPath(boolean invalid) {
//        IArtifact modelComponent = this.dataModel.getModelComponent();
//        
//        boolean isModelComponentEditable = modelComponent.getElementStatus().isModifiable();
//        
//        if (isModelComponentEditable) {
//            if (invalid == true) {
//                this.fragPathText.setForeground(this.fragPathText.getDisplay().getSystemColor(SWT.COLOR_RED));
//            } else {
//                this.fragPathText.setForeground(this.fragPathText.getDisplay()
//                                                                 .getSystemColor(SWT.COLOR_DARK_GREEN));
//            }
//        } else {
//            this.fragPathText.setForeground(UIColor.EDITOR_ROTEXT_FG);
//        }
//    }

    @objid ("cbf9afb9-feb2-11dd-8b31-0014222a9f79")
    public String getFragmentName() {
        return this.fragNameText.getText();
    }

    @objid ("cbfc1212-feb2-11dd-8b31-0014222a9f79")
    public void invalidateFragmentName(boolean invalid) {
        IArtifact modelComponent = this.dataModel.getModelComponent();
        
        boolean isModelComponentEditable = modelComponent.getElementStatus().isModifiable();
        
        if (isModelComponentEditable) {
            if (invalid == true) {
                this.fragNameText.setForeground(this.fragNameText.getDisplay().getSystemColor(SWT.COLOR_RED));
            } else {
                this.fragNameText.setForeground(this.fragNameText.getDisplay()
                                                                 .getSystemColor(SWT.COLOR_DARK_GREEN));
            }
        } else {
            this.fragNameText.setForeground(UIColor.EDITOR_ROTEXT_FG);
        }
    }

    @objid ("bda3df07-ff45-11dd-95ab-0014222a9f79")
    private void createManifestationsField(Composite area, boolean isModelComponentEditable) {
        // frag manifestations field:
        //---------------------------
        this.fragManifestationsLabel = new Label(area, SWT.NONE);
        this.fragManifestationsLabel.setText(I18nMessageService.getString("EditRamcDialog.RamcManifestationLabel"));
        
        this.initManifestationsListViewer(area, isModelComponentEditable);
        
        Label targetLabel = new Label(area, SWT.NONE);
        targetLabel.setImage(this.dropAreaImage);
        
        final GridData gd_fragManifestationsLabel = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        this.fragManifestationsLabel.setLayoutData(gd_fragManifestationsLabel);
        
        final GridData gd_targetLabel = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
        gd_targetLabel.heightHint = 21;
        gd_targetLabel.widthHint = 21;
        targetLabel.setLayoutData(gd_targetLabel);
    }

    @objid ("bda6415f-ff45-11dd-95ab-0014222a9f79")
    private void initManifestationsListViewer(Composite area, boolean isModelComponentEditable) {
        this.fragManifestationsList = new TableViewer(area, SWT.BORDER | SWT.SINGLE | SWT.V_SCROLL);
        
        this.fragManifestationsList.setContentProvider(new EditManifestationsContentProvider());
        this.fragManifestationsList.setLabelProvider(new EditManifestationsLabelProvider());
        
        if (isModelComponentEditable) {
            int operations = DND.DROP_MOVE;
            Transfer[] types = new Transfer[] { ModelElementTransfer.getInstance(),
                    PluginTransfer.getInstance() };
            DropTarget target;
            if (System.getProperty("os.name").equals("Linux")) {
                target = new LinuxDropTarget(this.fragManifestationsList.getTable(), operations);
            } else {
                target = new DropTarget(this.fragManifestationsList.getTable(), operations);
            }
            target.setTransfer(types);
            EditManifestationsDropListener dropListener = new EditManifestationsDropListener(this,
                                                                                             this.controller);
            target.addDropListener(dropListener);
        
            this.fragManifestationsList.getTable().addKeyListener(new KeyListener() {
        
                @Override
                public void keyPressed(KeyEvent e) {
                }
        
                @Override
                public void keyReleased(KeyEvent e) {
                    if (e.keyCode == SWT.DEL) {
                        Table table = (Table) e.getSource();
                        TableItem[] items = table.getSelection();
                        for (TableItem item : items) {
                            EditManifestedAdapter adapter = (EditManifestedAdapter) item.getData();
                            EditFragmentDialog.this.controller.removeExportedAdapter(adapter);
                        }
                    }
                    EditFragmentDialog.this.refresh();
                }
        
            });
        } else {
            this.fragManifestationsList.getTable().setForeground(UIColor.EDITOR_ROTEXT_FG);
            this.fragManifestationsList.getTable().setBackground(UIColor.TEXT_READONLY_BG);
        }
        
        final GridData gd_fragManifestationsList = new GridData(SWT.FILL, SWT.FILL, true, false);
        gd_fragManifestationsList.heightHint = 100;
        this.fragManifestationsList.getTable().setLayoutData(gd_fragManifestationsList);
    }

//    @objid ("253ef0bc-ff6f-11dd-95ab-0014222a9f79")
//    private void createFilesField(Composite area, boolean isModelComponentEditable) {
//        
//        // frag file field:
//        //-----------------
//        this.fragFilesLabel = new Label(area, SWT.NONE);
//        this.fragFilesLabel.setText(I18nMessageService.getString("EditRamcDialog.RamcFilesLabel"));
//        
//        this.initFilesListViewer(area, isModelComponentEditable);
//        
//        Composite buttonComposite = new Composite(area, SWT.NONE);
//        GridLayout l_buttonComposite = new GridLayout(1, false);
//        l_buttonComposite.horizontalSpacing = 0;
//        l_buttonComposite.marginWidth = 0;
//        buttonComposite.setLayout(l_buttonComposite);
//        
//        final GridData gd_buttonComposite = new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1);
//        gd_buttonComposite.widthHint = 21;
//        buttonComposite.setLayoutData(gd_buttonComposite);
//        
//        if (isModelComponentEditable) {
//            this.addFilesButton = new Button(buttonComposite, SWT.NONE);
//            this.addFilesButton.setImage(this.fileChooserImage);
//        
//            this.removeFilesButton = new Button(buttonComposite, SWT.NONE);
//            this.removeFilesButton.setImage(this.deleteImage);
//        
//            this.filesChooser = new FileDialog(this.getShell(), SWT.OPEN | SWT.MULTI);
//            final String projectPath = "";
//            this.filesChooser.setFilterPath(projectPath);
//            /*fragFilesChooser.setFilterExtensions(new String[] {"*.frag"});
//            fragFilesChooser.setFilterNames(new String[] {I18nMessageService.getString("EditfragDialog.fragFiles")});*/
//        
//            this.addFilesButton.addSelectionListener(new SelectionListener() {
//                @Override
//                public void widgetDefaultSelected(SelectionEvent e) {
//                }
//        
//                @Override
//                public void widgetSelected(SelectionEvent e) {
//                    EditFragmentDialog.this.filesChooser.open();
//                    String[] filenames = EditFragmentDialog.this.filesChooser.getFileNames();
//                    String path = EditFragmentDialog.this.filesChooser.getFilterPath();
//                    String relativePath = "";
//                    File relativeFile = null;
//                    if (filenames != null) {
//                        if (path.startsWith(projectPath)) {
//                            for (String filename : filenames) {
//                                relativePath = path.replace(projectPath, "");
//                                relativeFile = new File(relativePath, filename);
//                                EditFragmentDialog.this.dataModel.addExportedFile(relativeFile);
//                            }
//                        } else {
//                            StringBuffer fileNamesList = new StringBuffer();
//                            File badLocationFile = null;
//                            for (String filename : filenames) {
//                                badLocationFile = new File(path, filename);
//                                fileNamesList.append(badLocationFile.getPath());
//                            }
//                            MessageDialog.openError(EditFragmentDialog.this.addFilesButton.getShell(),
//                                                    I18nMessageService.getString("EditRamcDialog.FileNotInProjectTitle"),
//                                                    I18nMessageService.getString("EditRamcDialog.FileNotInProjectMessage",
//                                                                        path +
//                                                                                File.separatorChar +
//                                                                                fileNamesList.toString()));
//                        }
//                    }
//        
//                    EditFragmentDialog.this.refresh();
//                }
//            });
//        
//            this.removeFilesButton.addSelectionListener(new SelectionListener() {
//                @Override
//                public void widgetDefaultSelected(SelectionEvent e) {
//                }
//        
//                @Override
//                public void widgetSelected(SelectionEvent e) {
//                    Table table = EditFragmentDialog.this.fragFilesList.getTable();
//                    TableItem[] items = table.getSelection();
//                    for (TableItem item : items) {
//                        File file = (File) item.getData();
//                        EditFragmentDialog.this.dataModel.removeExportedFile(file);
//                    }
//                    EditFragmentDialog.this.refresh();
//                }
//            });
//        }
//        
//        final GridData gd_fragFilesLabel = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
//        this.fragFilesLabel.setLayoutData(gd_fragFilesLabel);
//        
//        if (isModelComponentEditable) {
//            final GridData gd_addFilesButton = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
//            gd_addFilesButton.heightHint = 21;
//            gd_addFilesButton.widthHint = 21;
//            this.addFilesButton.setLayoutData(gd_addFilesButton);
//        
//            final GridData gd_removeFilesButton = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
//            gd_removeFilesButton.horizontalSpan = 0;
//            gd_removeFilesButton.heightHint = 21;
//            gd_removeFilesButton.widthHint = 21;
//            this.removeFilesButton.setLayoutData(gd_removeFilesButton);
//        }
//        
//        Composite emptyComposite1 = new Composite(area, SWT.NONE);
//        
//        Label exportedFileDescription = new Label(area, SWT.WRAP);
//        exportedFileDescription.setText(I18nMessageService.getString("EditRamcDialog.ExportedFileDescription"));
//        //exportedFileDescription.setEditable(false);
//        exportedFileDescription.setForeground(UIColor.LABEL_TIP_FG);
//        //exportedFileDescription.setBackground(UIColor.TEXT_READONLY_BG);
//        
//        Composite emptyComposite2 = new Composite(area, SWT.NONE);
//        
//        final GridData gd_emptyComposite1 = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
//        gd_emptyComposite1.heightHint = 21;
//        gd_emptyComposite1.widthHint = 21;
//        emptyComposite1.setLayoutData(gd_emptyComposite1);
//        
//        final GridData gd_exportedFileDescription = new GridData(SWT.FILL, SWT.UP, true, false, 1, 1);
//        gd_exportedFileDescription.heightHint = 40;
//        exportedFileDescription.setLayoutData(gd_exportedFileDescription);
//        
//        final GridData gd_emptyComposite2 = new GridData(SWT.LEFT, SWT.UP, false, false, 1, 1);
//        gd_emptyComposite2.heightHint = 21;
//        gd_emptyComposite2.widthHint = 21;
//        emptyComposite2.setLayoutData(gd_emptyComposite2);
//    }

//    @objid ("25415316-ff6f-11dd-95ab-0014222a9f79")
//    private void initFilesListViewer(Composite area, boolean isModelComponentEditable) {
//        this.fragFilesList = new TableViewer(area, SWT.BORDER | SWT.V_SCROLL | SWT.MULTI);
//        
//        this.fragFilesList.setContentProvider(new EditFilesContentProvider());
//        this.fragFilesList.setLabelProvider(new EditFilesLabelProvider());
//        
//        if (isModelComponentEditable) {
//            this.fragFilesList.getTable().addKeyListener(new KeyListener() {
//        
//                @Override
//                public void keyPressed(KeyEvent e) {
//                }
//        
//                @Override
//                public void keyReleased(KeyEvent e) {
//                    if (e.keyCode == SWT.DEL) {
//                        Table table = (Table) e.getSource();
//                        TableItem[] items = table.getSelection();
//                        for (TableItem item : items) {
//                            File file = (File) item.getData();
//                            EditFragmentDialog.this.dataModel.removeExportedFile(file);
//                        }
//                    }
//                    EditFragmentDialog.this.refresh();
//                }
//        
//            });
//        } else {
//            this.fragFilesList.getTable().setForeground(UIColor.EDITOR_ROTEXT_FG);
//            this.fragFilesList.getTable().setBackground(UIColor.TEXT_READONLY_BG);
//        }
//        
//        final GridData gd_fragFilesList = new GridData(SWT.FILL, SWT.FILL, true, true);
//        this.fragFilesList.getTable().setLayoutData(gd_fragFilesList);
//    }

    @objid ("7436ae04-027f-11de-af8a-0014222a9f79")
    public boolean close(int code) {
        this.setReturnCode(code);
        return this.close();
    }

//    @objid ("7a97d449-0f2f-11de-a5d5-0014222a9f79")
//    @Override
//    protected String getHelpId() {
//        return "/com.modeliosoft.modelio.documentation.modeler/html/Model_components_development.html";
//    }

}
