/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package org.modelio.modelfragment.command.ihm;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.core.app.StandardImageService;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

@objid ("19ac6529-ff46-11dd-95ab-0014222a9f79")
public class EditManifestationsLabelProvider extends LabelProvider {

    @objid ("19ac652f-ff46-11dd-95ab-0014222a9f79")
    @Override
    public Image getImage(Object obj) {
        EditManifestedAdapter adapter = (EditManifestedAdapter) obj;
        IElement element = adapter.getElement();
        return StandardImageService.getStereotypedImage(element, null);
    }

    @objid ("19ac6530-ff46-11dd-95ab-0014222a9f79")
    @Override
    public String getText(Object obj) {
        EditManifestedAdapter adapter = (EditManifestedAdapter) obj;
        IElement element = adapter.getElement();
        
        if (element instanceof IModelElement) {
            IModelElement me = (IModelElement) element;
            return me.getName();
        } else {
            return element.toString();
        }
    }

}
