package org.modelio.modelfragment.model;

import org.modelio.modelfragment.api.IModelFragmentTagTypes;

import com.modeliosoft.modelio.api.model.IModelingSession;
import com.modeliosoft.modelio.api.model.ITransaction;
import com.modeliosoft.modelio.api.model.IUmlModel;
import com.modeliosoft.modelio.api.model.InvalidTransactionException;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.NoteTypeNotFoundException;
import com.modeliosoft.modelio.api.utils.TagTypeNotFoundException;

public class DeployedFragment {

	private IComponent _deployed = null;

	private String _descName = "description";
	
	

	public DeployedFragment(IComponent component){
		this._deployed = component;
	}


	public void  setName(String name){
		this._deployed.setName(name);
	}

	public String getName(){
		return this._deployed.getName();
	}


	public void setVersion(String version){
		IModelingSession session = Modelio.getInstance().getModelingSession();
//		ITransaction tr = session.createTransaction("change version");
		try{
			ITagParameter tagVersion = null;
			for (ITaggedValue currentTag : this._deployed.getTag()){
				if (currentTag.getDefinition().getName().equals(IModelFragmentTagTypes.MODELFRAGMENTDEPLOYED_VERSION)){
					tagVersion = currentTag.getQualifier();
					break;
				}

			}

			if (tagVersion == null){
				IUmlModel model = session.getModel();
				ITaggedValue tag = model.createTaggedValue(IModelFragmentTagTypes.MODELFRAGMENTDEPLOYED_VERSION, this._deployed);
				tagVersion = model.createTagParameter();
				tagVersion.setAnnoted(tag);
				tag.setQualifier(tagVersion);

			}

			tagVersion.setValue(version);
//			session.commit(tr);
//			tr = null;
//		} catch (InvalidTransactionException e) {
//			// Transaction already rollbacked
//			tr = null;
		} catch (TagTypeNotFoundException e) {
			e.printStackTrace();
//		} finally {
//			if (tr != null)
//				session.rollback(tr);
		}
	}


	public String getVersion(){
		String result = "";
		for(ITaggedValue tag : this._deployed.getTag()){
			if (tag.getName().equals(IModelFragmentTagTypes.MODELFRAGMENTDEPLOYED_VERSION)){
				return tag.getQualifier().getValue();
			}
		}
		return result;
	}


	public void setDescription(String description){
		IModelingSession session = Modelio.getInstance().getModelingSession();
		ITransaction tr = session.createTransaction("change version");
		try{
			INote descriptionNote = this._deployed.getNote(_descName);


			if (descriptionNote == null){
				IUmlModel model = session.getModel();
				descriptionNote = model.createNote(_descName, this._deployed, description);
			}else
				descriptionNote.setContent(description);

			session.commit(tr);
			tr = null;
		} catch (InvalidTransactionException e) {
			// Transaction already rollbacked
			tr = null;
		} catch (NoteTypeNotFoundException e) {
			e.printStackTrace();
		} finally {
			if (tr != null)
				session.rollback(tr);
		}
	}


	public String getDescription(){
		String result = "";
		for (INote note : this._deployed.getDescriptor()){
			if (note.getModel().getName().equals("description")){
				return note.getContent();
			}
		}

		return result;
	}



	public IComponent getDeployedFragment(){
		return this._deployed;
	}

}
