/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.dialog;

import java.text.MessageFormat;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

@objid ("03818bb9-4583-11e0-b54c-00137279a832")
public class ResourceDlg {
    @objid ("03818bba-4583-11e0-b54c-00137279a832")
    private static final String BUNDLE_NAME = "com.modeliosoft.modelio.xmi.dialog.Resource";

    @objid ("0383ee09-4583-11e0-b54c-00137279a832")
    private static final ResourceBundle RESOURCE_BUNDLE;


    @objid ("0383ee0b-4583-11e0-b54c-00137279a832")
    private ResourceDlg() {
    }

    @objid ("0383ee0d-4583-11e0-b54c-00137279a832")
    public static String getString(String key) {
        try {
            return RESOURCE_BUNDLE.getString(key);
        } catch (MissingResourceException e) {
            return '!' + key + '!';
        }
    }

    @objid ("0383ee11-4583-11e0-b54c-00137279a832")
    public static String getString(String key, Object... params) {
        try {
            return MessageFormat.format(RESOURCE_BUNDLE.getString(key), params);
        } catch (MissingResourceException e) {
            return '!' + key + '!';
        }
    }


static {
        String language;
        try {
            // TODO fix bug
            // language = Modelio.getInstance().getContext().getLanguage();
            language = Locale.getDefault().getLanguage();
            if (!("fr".equalsIgnoreCase(language))) {
                language = "us";
            }
        } catch (Exception e) {
            // set default value
            language = "us"; 
        }

        RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME, new Locale(language));
    }
}
