/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.generation;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IConstraint;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCaseDependency;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

@objid ("0399633c-4583-11e0-b54c-00137279a832")
public class GenericMetamodelVisitor extends OwnershipMetamodelVisitor {

    @objid ("0399633e-4583-11e0-b54c-00137279a832")
    public GenericMetamodelVisitor() {
        super();
    }

    @objid ("039bc58d-4583-11e0-b54c-00137279a832")
    public GenericMetamodelVisitor(IParseModelBehavior behavior) {
        super(behavior);
    }

    @Override
    @objid ("039bc590-4583-11e0-b54c-00137279a832")
    public Object visitAssociationEnd(final IAssociationEnd param) {
        Object lObject = super.visitAssociationEnd(param);
        param.getRelated().accept(this);
        return lObject;
    }

    @Override
    @objid ("039bc596-4583-11e0-b54c-00137279a832")
    public Object visitModelElement(final IModelElement param) {
        Object lObject = super.visitModelElement(param);
        for (IConstraint constraint : param.getConstraintDefinition()) {
            constraint.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("039e27e8-4583-11e0-b54c-00137279a832")
    public Object visitUseCase(final IUseCase param) {
        Object lObject = super.visitUseCase(param);
        for (IUseCaseDependency dep : param.getUsed()) {
            dep.accept(this);
        }
        return lObject;
    }

}
