/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.generation;

import com.modeliosoft.modelio.api.model.analyst.IDictionary;
import com.modeliosoft.modelio.api.model.analyst.IEnumeratedPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IProperty;
import com.modeliosoft.modelio.api.model.analyst.IPropertyEnumerationLitteral;
import com.modeliosoft.modelio.api.model.analyst.IPropertySet;
import com.modeliosoft.modelio.api.model.analyst.IPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValue;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValueSet;
import com.modeliosoft.modelio.api.model.analyst.IRequirement;
import com.modeliosoft.modelio.api.model.analyst.IRequirementContainer;
import com.modeliosoft.modelio.api.model.analyst.IRequirementElement;
import com.modeliosoft.modelio.api.model.analyst.ITerm;
import com.modeliosoft.modelio.api.model.extension.IProject;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptCallEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptChangeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptTimeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityParameterNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallBehaviorAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallOperationAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICentralBufferNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IClause;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IConditionalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IControlFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDataStoreNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDecisionMergeNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IFlowFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IForkJoinNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInitialNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInstanceNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInterruptibleActivityRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ILoopNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IMessageFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IObjectFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOutputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IValuePin;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehaviorParameter;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IOpaqueBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ICombinedFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IDurationConstraint;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionOccurenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGate;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGeneralOrdering;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionOperand;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionUse;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IPartDecomposition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IChoicePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IConnectionPointReference;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IDeepHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEntryPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IExitPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IFinalState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IForkPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInitialPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInternalTransition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJoinPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJunctionPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IShallowHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateInvariant;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITerminatePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.information.IInformationFlow;
import com.modeliosoft.modelio.api.model.uml.information.IInformationItem;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IAbstraction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IConstraint;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElementRealization;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalNote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalTaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INoteType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IUsage;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IAttribute;
import com.modeliosoft.modelio.api.model.uml.statik.IAttributeLink;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IBinding;
import com.modeliosoft.modelio.api.model.uml.statik.IClass;
import com.modeliosoft.modelio.api.model.uml.statik.IClassAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaboration;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.model.uml.statik.IConnector;
import com.modeliosoft.modelio.api.model.uml.statik.IConnectorEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IDataFlow;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IElementImport;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralization;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IManifestation;
import com.modeliosoft.modelio.api.model.uml.statik.INamespaceUse;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageImport;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.model.uml.statik.IProvidedInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IRaisedException;
import com.modeliosoft.modelio.api.model.uml.statik.IRequiredInterface;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameterSubstitution;
import com.modeliosoft.modelio.api.model.uml.usecase.IActor;
import com.modeliosoft.modelio.api.model.uml.usecase.IExtensionPoint;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCaseDependency;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.gui.ProgressBarComposite;

@objid ("039e27ee-4583-11e0-b54c-00137279a832")
public interface IParseModelBehavior {

    @objid ("039e27ef-4583-11e0-b54c-00137279a832")
    ProgressBarComposite getProgressBar();

    @objid ("039e27f1-4583-11e0-b54c-00137279a832")
    void visitActivityFinalNode(IActivityFinalNode arg0);

    @objid ("03a08a41-4583-11e0-b54c-00137279a832")
    void visitPackage(IPackage arg0);

    @objid ("03a08a43-4583-11e0-b54c-00137279a832")
    void visitClass(IClass arg0);

    @objid ("03a08a45-4583-11e0-b54c-00137279a832")
    void visitAttribute(IAttribute arg0);

    @objid ("03a08a47-4583-11e0-b54c-00137279a832")
    void visitAssociationEnd(IAssociationEnd arg0);

    @objid ("03a08a49-4583-11e0-b54c-00137279a832")
    void visitTaggedValue(ITaggedValue arg0);

    @objid ("03a08a4b-4583-11e0-b54c-00137279a832")
    void visitAssociation(IAssociation arg0);

    @objid ("03a08a4d-4583-11e0-b54c-00137279a832")
    void visitOperation(IOperation arg0);

    @objid ("03a08a4f-4583-11e0-b54c-00137279a832")
    void visitParameter(IParameter arg0);

    @objid ("03a08a51-4583-11e0-b54c-00137279a832")
    void visitActor(IActor arg0);

    @objid ("03a08a53-4583-11e0-b54c-00137279a832")
    void visitComponent(IComponent arg0);

    @objid ("03a08a55-4583-11e0-b54c-00137279a832")
    void visitGeneralization(IGeneralization arg0);

    @objid ("03a08a57-4583-11e0-b54c-00137279a832")
    void visitElementImport(IElementImport arg0);

    @objid ("03a08a59-4583-11e0-b54c-00137279a832")
    void visitRaisedException(IRaisedException arg0);

    @objid ("03a2ec9b-4583-11e0-b54c-00137279a832")
    void visitInterface(IInterface arg0);

    @objid ("03a2ec9d-4583-11e0-b54c-00137279a832")
    void visitDataType(IDataType arg0);

    @objid ("03a2ec9f-4583-11e0-b54c-00137279a832")
    void visitEnumeration(IEnumeration arg0);

    @objid ("03a2eca1-4583-11e0-b54c-00137279a832")
    void visitEnumerationLiteral(IEnumerationLiteral arg0);

    @objid ("03a2eca3-4583-11e0-b54c-00137279a832")
    void visitDependency(IDependency arg0);

    @objid ("03a2eca5-4583-11e0-b54c-00137279a832")
    void visitNote(INote arg0);

    @objid ("03a2eca7-4583-11e0-b54c-00137279a832")
    void visitConstraint(IConstraint arg0);

    @objid ("03a2eca9-4583-11e0-b54c-00137279a832")
    void visitPackageImport(IPackageImport arg0);

    @objid ("03a2ecab-4583-11e0-b54c-00137279a832")
    void visitPackageMerge(IPackageMerge arg0);

    @objid ("03a2ecad-4583-11e0-b54c-00137279a832")
    void visitUsage(IUsage arg0);

    @objid ("03a2ecaf-4583-11e0-b54c-00137279a832")
    void visitAbstraction(IAbstraction arg0);

    @objid ("03a2ecb1-4583-11e0-b54c-00137279a832")
    void visitInterfaceRealization(IInterfaceRealization arg0);

    @objid ("03a2ecb3-4583-11e0-b54c-00137279a832")
    void visitDataFlow(IDataFlow arg0);

    @objid ("03a2ecb5-4583-11e0-b54c-00137279a832")
    void visitAcceptCallEventAction(IAcceptCallEventAction param);

    @objid ("03a2ecb7-4583-11e0-b54c-00137279a832")
    void visitAcceptChangeEventAction(IAcceptChangeEventAction param);

    @objid ("03a2ecb9-4583-11e0-b54c-00137279a832")
    void visitAcceptSignalAction(IAcceptSignalAction param);

    @objid ("03a2ecbb-4583-11e0-b54c-00137279a832")
    void visitAcceptTimeEventAction(IAcceptTimeEventAction param);

    @objid ("03a2ecbd-4583-11e0-b54c-00137279a832")
    void visitActivity(IActivity param);

    @objid ("03a2ecbf-4583-11e0-b54c-00137279a832")
    void visitActivityParameterNode(IActivityParameterNode param);

    @objid ("03a54ef4-4583-11e0-b54c-00137279a832")
    void visitActivityPartition(IActivityPartition param);

    @objid ("03a54ef6-4583-11e0-b54c-00137279a832")
    void visitArtifact(IArtifact param);

    @objid ("03a54ef8-4583-11e0-b54c-00137279a832")
    void visitAttributeLink(IAttributeLink param);

    @objid ("03a54efa-4583-11e0-b54c-00137279a832")
    void visitBehaviorParameter(IBehaviorParameter param);

    @objid ("03a54efc-4583-11e0-b54c-00137279a832")
    void visitBindableInstance(IBindableInstance param);

    @objid ("03a54efe-4583-11e0-b54c-00137279a832")
    void visitBinding(IBinding param);

    @objid ("03a54f00-4583-11e0-b54c-00137279a832")
    void visitCallBehaviorAction(ICallBehaviorAction param);

    @objid ("03a54f02-4583-11e0-b54c-00137279a832")
    void visitCallOperationAction(ICallOperationAction param);

    @objid ("03a7b14e-4583-11e0-b54c-00137279a832")
    void visitCentralBufferNode(ICentralBufferNode param);

    @objid ("03a7b150-4583-11e0-b54c-00137279a832")
    void visitChoicePseudoState(IChoicePseudoState param);

    @objid ("03a7b152-4583-11e0-b54c-00137279a832")
    void visitClassAssociation(IClassAssociation param);

    @objid ("03a7b154-4583-11e0-b54c-00137279a832")
    void visitClause(IClause param);

    @objid ("03a7b156-4583-11e0-b54c-00137279a832")
    void visitCollaboration(ICollaboration param);

    @objid ("03a7b158-4583-11e0-b54c-00137279a832")
    void visitCollaborationUse(ICollaborationUse param);

    @objid ("03a7b15a-4583-11e0-b54c-00137279a832")
    void visitCombinedFragment(ICombinedFragment param);

    @objid ("03ac7603-4583-11e0-b54c-00137279a832")
    void visitConditionalNode(IConditionalNode param);

    @objid ("03ac7605-4583-11e0-b54c-00137279a832")
    void visitConnectionPointReference(IConnectionPointReference param);

    @objid ("03aed85c-4583-11e0-b54c-00137279a832")
    void visitConnector(IConnector param);

    @objid ("03aed85e-4583-11e0-b54c-00137279a832")
    void visitConnectorEnd(IConnectorEnd param);

    @objid ("03aed860-4583-11e0-b54c-00137279a832")
    void visitControlFlow(IControlFlow param);

    @objid ("03aed862-4583-11e0-b54c-00137279a832")
    void visitDataStoreNode(IDataStoreNode param);

    @objid ("03aed864-4583-11e0-b54c-00137279a832")
    void visitDecisionMergeNode(IDecisionMergeNode param);

    @objid ("03aed866-4583-11e0-b54c-00137279a832")
    void visitDeepHistoryPseudoState(IDeepHistoryPseudoState param);

    @objid ("03b13ab6-4583-11e0-b54c-00137279a832")
    void visitDictionary(IDictionary param);

    @objid ("03b13ab8-4583-11e0-b54c-00137279a832")
    void visitDurationConstraint(IDurationConstraint param);

    @objid ("03b13aba-4583-11e0-b54c-00137279a832")
    void visitElementRealization(IElementRealization param);

    @objid ("03b13abc-4583-11e0-b54c-00137279a832")
    void visitEntryPointPseudoState(IEntryPointPseudoState param);

    @objid ("03b13abe-4583-11e0-b54c-00137279a832")
    void visitEnumeratedPropertyType(IEnumeratedPropertyType param);

    @objid ("03b13ac0-4583-11e0-b54c-00137279a832")
    void visitEvent(IEvent param);

    @objid ("03b39d10-4583-11e0-b54c-00137279a832")
    void visitExecutionOccurenceSpecification(IExecutionOccurenceSpecification param);

    @objid ("03b39d12-4583-11e0-b54c-00137279a832")
    void visitExecutionSpecification(IExecutionSpecification param);

    @objid ("03b39d14-4583-11e0-b54c-00137279a832")
    void visitExitPointPseudoState(IExitPointPseudoState param);

    @objid ("03b39d16-4583-11e0-b54c-00137279a832")
    void visitExtensionPoint(IExtensionPoint param);

    @objid ("03b39d18-4583-11e0-b54c-00137279a832")
    void visitFlowFinalNode(IFlowFinalNode param);

    @objid ("03b5ff6a-4583-11e0-b54c-00137279a832")
    void visitFinalState(IFinalState param);

    @objid ("03b5ff6c-4583-11e0-b54c-00137279a832")
    void visitForkJoinNode(IForkJoinNode param);

    @objid ("03b5ff6e-4583-11e0-b54c-00137279a832")
    void visitForkPseudoState(IForkPseudoState param);

    @objid ("03b5ff70-4583-11e0-b54c-00137279a832")
    void visitGeneralOrdering(IGeneralOrdering param);

    @objid ("03b5ff72-4583-11e0-b54c-00137279a832")
    void visitInformationFlow(IInformationFlow param);

    @objid ("03b5ff74-4583-11e0-b54c-00137279a832")
    void visitGate(IGate param);

    @objid ("03b861c5-4583-11e0-b54c-00137279a832")
    void visitInformationItem(IInformationItem param);

    @objid ("03b861c7-4583-11e0-b54c-00137279a832")
    void visitInitialNode(IInitialNode param);

    @objid ("03bac41e-4583-11e0-b54c-00137279a832")
    void visitInitialPseudoState(IInitialPseudoState param);

    @objid ("03bac420-4583-11e0-b54c-00137279a832")
    void visitInputPin(IInputPin param);

    @objid ("03bac422-4583-11e0-b54c-00137279a832")
    void visitInstance(IInstance param);

    @objid ("03bac424-4583-11e0-b54c-00137279a832")
    void visitInstanceNode(IInstanceNode param);

    @objid ("03bd2678-4583-11e0-b54c-00137279a832")
    void visitInteraction(IInteraction param);

    @objid ("03bd267a-4583-11e0-b54c-00137279a832")
    void visitInteractionOperand(IInteractionOperand param);

    @objid ("03bd267c-4583-11e0-b54c-00137279a832")
    void visitInteractionUse(IInteractionUse param);

    @objid ("03bd267e-4583-11e0-b54c-00137279a832")
    void visitInternalTransition(IInternalTransition param);

    @objid ("03bd2680-4583-11e0-b54c-00137279a832")
    void visitInterruptibleActivityRegion(IInterruptibleActivityRegion param);

    @objid ("03bf88d2-4583-11e0-b54c-00137279a832")
    void visitJoinPseudoState(IJoinPseudoState param);

    @objid ("03bf88d4-4583-11e0-b54c-00137279a832")
    void visitJunctionPseudoState(IJunctionPseudoState param);

    @objid ("03bf88d6-4583-11e0-b54c-00137279a832")
    void visitLifeline(ILifeline param);

    @objid ("03bf88d8-4583-11e0-b54c-00137279a832")
    void visitLink(ILink param);

    @objid ("03bf88da-4583-11e0-b54c-00137279a832")
    void visitLinkEnd(ILinkEnd param);

    @objid ("03c1eb2d-4583-11e0-b54c-00137279a832")
    void visitLocalNote(ILocalNote param);

    @objid ("03c1eb2f-4583-11e0-b54c-00137279a832")
    void visitLocalTaggedValue(ILocalTaggedValue param);

    @objid ("03c1eb31-4583-11e0-b54c-00137279a832")
    void visitLoopNode(ILoopNode param);

    @objid ("03c1eb33-4583-11e0-b54c-00137279a832")
    void visitManifestation(IManifestation param);

    @objid ("03c44d86-4583-11e0-b54c-00137279a832")
    void visitMessage(IMessage param);

    @objid ("03c44d88-4583-11e0-b54c-00137279a832")
    void visitMessageFlow(IMessageFlow param);

    @objid ("03c44d8a-4583-11e0-b54c-00137279a832")
    void visitNamespaceUse(INamespaceUse param);

    @objid ("03c44d8c-4583-11e0-b54c-00137279a832")
    void visitNode(INode param);

    @objid ("03c6afe0-4583-11e0-b54c-00137279a832")
    void visitNoteType(INoteType param);

    @objid ("03c6afe2-4583-11e0-b54c-00137279a832")
    void visitObjectFlow(IObjectFlow param);

    @objid ("03c6afe4-4583-11e0-b54c-00137279a832")
    void visitOpaqueAction(IOpaqueAction param);

    @objid ("03c6afe6-4583-11e0-b54c-00137279a832")
    void visitOpaqueBehavior(IOpaqueBehavior param);

    @objid ("03c9123a-4583-11e0-b54c-00137279a832")
    void visitOutputPin(IOutputPin param);

    @objid ("03c9123c-4583-11e0-b54c-00137279a832")
    void visitPartDecomposition(IPartDecomposition param);

    @objid ("03c9123e-4583-11e0-b54c-00137279a832")
    void visitPort(IPort param);

    @objid ("03c91240-4583-11e0-b54c-00137279a832")
    void visitProject(IProject param);

    @objid ("03cb7494-4583-11e0-b54c-00137279a832")
    void visitProperty(IProperty param);

    @objid ("03cb7496-4583-11e0-b54c-00137279a832")
    void visitPropertyEnumerationLitteral(IPropertyEnumerationLitteral param);

    @objid ("03cb7498-4583-11e0-b54c-00137279a832")
    void visitPropertySet(IPropertySet param);

    @objid ("03cb749a-4583-11e0-b54c-00137279a832")
    void visitPropertyType(IPropertyType param);

    @objid ("03cdd6ee-4583-11e0-b54c-00137279a832")
    void visitPropertyValue(IPropertyValue param);

    @objid ("03cdd6f0-4583-11e0-b54c-00137279a832")
    void visitPropertyValueSet(IPropertyValueSet param);

    @objid ("03cdd6f2-4583-11e0-b54c-00137279a832")
    void visitProvidedInterface(IProvidedInterface param);

    @objid ("03d03948-4583-11e0-b54c-00137279a832")
    void visitRegion(IRegion param);

    @objid ("03d0394a-4583-11e0-b54c-00137279a832")
    void visitRequiredInterface(IRequiredInterface param);

    @objid ("03d0394c-4583-11e0-b54c-00137279a832")
    void visitRequirement(IRequirement param);

    @objid ("03d0394e-4583-11e0-b54c-00137279a832")
    void visitRequirementContainer(IRequirementContainer param);

    @objid ("03d29ba3-4583-11e0-b54c-00137279a832")
    void visitRequirementElement(IRequirementElement param);

    @objid ("03d29ba5-4583-11e0-b54c-00137279a832")
    void visitSendSignalAction(ISendSignalAction param);

    @objid ("03d29ba7-4583-11e0-b54c-00137279a832")
    void visitShallowHistoryPseudoState(IShallowHistoryPseudoState param);

    @objid ("03d4fdfc-4583-11e0-b54c-00137279a832")
    void visitSignal(ISignal param);

    @objid ("03d4fdfe-4583-11e0-b54c-00137279a832")
    void visitState(IState param);

    @objid ("03d4fe00-4583-11e0-b54c-00137279a832")
    void visitStateInvariant(IStateInvariant param);

    @objid ("03d4fe02-4583-11e0-b54c-00137279a832")
    void visitStateMachine(IStateMachine param);

    @objid ("03d76056-4583-11e0-b54c-00137279a832")
    void visitStereotype(IStereotype param);

    @objid ("03d76058-4583-11e0-b54c-00137279a832")
    void visitStructuredActivityNode(IStructuredActivityNode param);

    @objid ("03d7605a-4583-11e0-b54c-00137279a832")
    void visitSubstitution(ISubstitution param);

    @objid ("03d9c2b0-4583-11e0-b54c-00137279a832")
    void visitTagParameter(ITagParameter param);

    @objid ("03d9c2b2-4583-11e0-b54c-00137279a832")
    void visitTagType(ITagType param);

    @objid ("03d9c2b4-4583-11e0-b54c-00137279a832")
    void visitTemplateBinding(ITemplateBinding param);

    @objid ("03dc250a-4583-11e0-b54c-00137279a832")
    void visitTemplateParameter(ITemplateParameter param);

    @objid ("03dc250c-4583-11e0-b54c-00137279a832")
    void visitTemplateParameterSubstitution(ITemplateParameterSubstitution param);

    @objid ("03dc250e-4583-11e0-b54c-00137279a832")
    void visitTerm(ITerm param);

    @objid ("03dc2510-4583-11e0-b54c-00137279a832")
    void visitTerminatePseudoState(ITerminatePseudoState param);

    @objid ("03de8764-4583-11e0-b54c-00137279a832")
    void visitTransition(ITransition param);

    @objid ("03de8766-4583-11e0-b54c-00137279a832")
    void visitUseCase(IUseCase param);

    @objid ("03de8768-4583-11e0-b54c-00137279a832")
    void visitUseCaseDependency(IUseCaseDependency param);

    @objid ("76d0c07c-5c0e-11e1-9a0a-0027103f347d")
    void visitValuePin(final IValuePin param);

}
