/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.generation;

import com.modeliosoft.modelio.api.model.analyst.IAnalystProject;
import com.modeliosoft.modelio.api.model.analyst.IDictionary;
import com.modeliosoft.modelio.api.model.analyst.IDictionaryElement;
import com.modeliosoft.modelio.api.model.analyst.IEnumeratedPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IProperty;
import com.modeliosoft.modelio.api.model.analyst.IPropertyEnumerationLitteral;
import com.modeliosoft.modelio.api.model.analyst.IPropertySet;
import com.modeliosoft.modelio.api.model.analyst.IPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValue;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValueSet;
import com.modeliosoft.modelio.api.model.analyst.IRequirement;
import com.modeliosoft.modelio.api.model.analyst.IRequirementContainer;
import com.modeliosoft.modelio.api.model.analyst.IRequirementElement;
import com.modeliosoft.modelio.api.model.analyst.ITerm;
import com.modeliosoft.modelio.api.model.diagrams.IAbstractDiagram;
import com.modeliosoft.modelio.api.model.extension.IProject;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptCallEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptChangeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptTimeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityEdge;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityGroup;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityParameterNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallBehaviorAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallOperationAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICentralBufferNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IClause;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IConditionalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IControlFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IControlNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDataStoreNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDecisionMergeNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IFlowFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IForkJoinNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInitialNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInstanceNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInterruptibleActivityRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ILoopNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IMessageFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IObjectFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IObjectNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOutputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IValuePin;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehaviorParameter;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IOpaqueBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ICombinedFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IDurationConstraint;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionOccurenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGate;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGeneralOrdering;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionOperand;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionUse;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessageEnd;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IOccurrenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IPartDecomposition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IAbstractPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IChoicePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IConnectionPointReference;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IDeepHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEntryPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IExitPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IFinalState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IForkPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInitialPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInternalTransition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJoinPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJunctionPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IShallowHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateInvariant;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateVertex;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITerminatePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.information.IInformationFlow;
import com.modeliosoft.modelio.api.model.uml.information.IInformationItem;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IAbstraction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IConstraint;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElementRealization;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalNote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalTaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INoteType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IUsage;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IAttribute;
import com.modeliosoft.modelio.api.model.uml.statik.IAttributeLink;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IBinding;
import com.modeliosoft.modelio.api.model.uml.statik.IClass;
import com.modeliosoft.modelio.api.model.uml.statik.IClassAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaboration;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.model.uml.statik.IConnector;
import com.modeliosoft.modelio.api.model.uml.statik.IConnectorEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IDataFlow;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IElementImport;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.api.model.uml.statik.IFeature;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralClass;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralization;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IManifestation;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.INamespaceUse;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageImport;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.model.uml.statik.IProvidedInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IRaisedException;
import com.modeliosoft.modelio.api.model.uml.statik.IRequiredInterface;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameterSubstitution;
import com.modeliosoft.modelio.api.model.uml.usecase.IActor;
import com.modeliosoft.modelio.api.model.uml.usecase.IExtensionPoint;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCaseDependency;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.DefaultMetamodelVisitor;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ObjingModelNavigation;
import com.modeliosoft.modelio.xmi.util.ProfileUtils;

@objid ("03ea7327-4583-11e0-b54c-00137279a832")
public class OwnershipMetamodelVisitor extends DefaultMetamodelVisitor {
    @objid ("03ea7328-4583-11e0-b54c-00137279a832")
    private IParseModelBehavior behavior;


    @objid ("03ea732a-4583-11e0-b54c-00137279a832")
    public OwnershipMetamodelVisitor() {
    }

    @objid ("03ea732c-4583-11e0-b54c-00137279a832")
    public OwnershipMetamodelVisitor(IParseModelBehavior behavior) {
        this.behavior = behavior;
    }

    @objid ("03ea732f-4583-11e0-b54c-00137279a832")
    public void setBehavior(IParseModelBehavior behavior) {
        this.behavior = behavior;
    }

    @Override
    @objid ("03ecd580-4583-11e0-b54c-00137279a832")
    public Object visitAbstraction(final IAbstraction param) {
        this.behavior.visitAbstraction(param);
        return super.visitAbstraction(param);
    }

    @Override
    @objid ("03ecd586-4583-11e0-b54c-00137279a832")
    public Object visitActivity(final IActivity param) {
        this.behavior.visitActivity(param);
        Object lObject = super.visitActivity(param);
        for (IActivityGroup i : param.getOwnedGroup()) {
            i.accept(this);
        }
        for (IActivityNode i : param.getOwnedNode()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("03ecd58c-4583-11e0-b54c-00137279a832")
    public Object visitActor(final IActor param) {
        this.behavior.visitActor(param);
        return super.visitActor(param);
    }

    @Override
    @objid ("03ef37de-4583-11e0-b54c-00137279a832")
    public Object visitArtifact(final IArtifact param) {
        this.behavior.visitArtifact(param);
        Object lObject = super.visitArtifact(param);
        for (IManifestation i : param.getUtilized()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("03ef37e4-4583-11e0-b54c-00137279a832")
    public Object visitAssociation(final IAssociation param) {
        this.behavior.visitAssociation(param);
        Object lObject = super.visitAssociation(param);
        IClassAssociation lLinkToClass = param.getLinkToClass();
        if (lLinkToClass != null) {
            lLinkToClass.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("03f19a35-4583-11e0-b54c-00137279a832")
    public Object visitAssociationEnd(final IAssociationEnd param) {
        this.behavior.visitAssociationEnd(param);
        Object lObject = super.visitAssociationEnd(param);
        for (IAttribute i : param.getQualifier()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("03f19a3b-4583-11e0-b54c-00137279a832")
    public Object visitAttribute(final IAttribute param) {
        this.behavior.visitAttribute(param);
        return super.visitAttribute(param);
    }

    @Override
    @objid ("03f3fc8e-4583-11e0-b54c-00137279a832")
    public Object visitAttributeLink(final IAttributeLink param) {
        this.behavior.visitAttributeLink (param);
        return super.visitAttributeLink(param);
    }

    @Override
    @objid ("03f3fc94-4583-11e0-b54c-00137279a832")
    public Object visitBehavior(final IBehavior param) {
        Object lObject = super.visitBehavior(param);
        for (IEvent i : param.getEComponent()) {
            i.accept(this);
        }
        for (ICollaboration i : param.getOwnedCollaboration()) {
            i.accept(this);
        }
        for (IBehaviorParameter i : param.getParameter()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("03f65ee9-4583-11e0-b54c-00137279a832")
    public Object visitBindableInstance(final IBindableInstance param) {
        this.behavior.visitBindableInstance (param);
        return super.visitBindableInstance(param);
    }

    @Override
    @objid ("03f65eef-4583-11e0-b54c-00137279a832")
    public Object visitBinding(final IBinding param) {
        this.behavior.visitBinding (param);
        return super.visitBinding(param);
    }

    @Override
    @objid ("03f8c143-4583-11e0-b54c-00137279a832")
    public Object visitClass(final IClass param) {
        this.behavior.visitClass(param);
        return super.visitClass(param);
    }

    @Override
    @objid ("03f8c149-4583-11e0-b54c-00137279a832")
    public Object visitClassAssociation(final IClassAssociation param) {
        this.behavior.visitClassAssociation(param);
        return super.visitClassAssociation(param);
    }

    @Override
    @objid ("03fb239c-4583-11e0-b54c-00137279a832")
    public Object visitClassifier(final IClassifier param) {
        Object lObject = super.visitClassifier(param);
        for (IBindableInstance i : param.getInternalStructure()) {
            if (i instanceof IPort)
                ((IPort) i).accept(this);
            else    
                i.accept(this);
        }
        for (IFeature i : param.getPart()) {
            i.accept(this);
        }
        for (ISubstitution i : param.getSubstitued()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("03fb23a2-4583-11e0-b54c-00137279a832")
    public Object visitCollaboration(final ICollaboration param) {
        this.behavior.visitCollaboration(param);
        return super.visitCollaboration(param);
    }

    @Override
    @objid ("03fb23a8-4583-11e0-b54c-00137279a832")
    public Object visitCollaborationUse(final ICollaborationUse param) {
        this.behavior.visitCollaborationUse (param);
        Object lObject = super.visitCollaborationUse(param);
        for (IBinding i: param.getRoleBinding()) { i.accept(this); }
        return lObject;
    }

    @Override
    @objid ("03fd85fa-4583-11e0-b54c-00137279a832")
    public Object visitComponent(final IComponent param) {
        this.behavior.visitComponent(param);
        return super.visitComponent(param);
    }

    @Override
    @objid ("03fd8600-4583-11e0-b54c-00137279a832")
    public Object visitConnector(final IConnector param) {
        this.behavior.visitConnector (param);
        return super.visitConnector(param);
    }

    @Override
    @objid ("03ffe854-4583-11e0-b54c-00137279a832")
    public Object visitConnectorEnd(final IConnectorEnd param) {
        this.behavior.visitConnectorEnd (param);
        Object lObject = super.visitConnectorEnd(param);
        
        ILink i = param.getLinkNode(); 
        i.accept(this);
        return lObject;
    }

    @Override
    @objid ("03ffe85a-4583-11e0-b54c-00137279a832")
    public Object visitConstraint(final IConstraint param) {
        this.behavior.visitConstraint(param);
        return super.visitConstraint(param);
    }

    @Override
    @objid ("04024aab-4583-11e0-b54c-00137279a832")
    public Object visitDataFlow(final IDataFlow param) {
        // behavior.visitDataFlow (param);
        // Object lObject = super.visitDataFlow(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("04024ab1-4583-11e0-b54c-00137279a832")
    public Object visitDataType(final IDataType param) {
        this.behavior.visitDataType(param);
        return super.visitDataType(param);
    }

    @Override
    @objid ("0404ad05-4583-11e0-b54c-00137279a832")
    public Object visitDependency(final IDependency param) {
        this.behavior.visitDependency(param);
        return super.visitDependency(param);
    }

    @Override
    @objid ("0404ad0b-4583-11e0-b54c-00137279a832")
    public Object visitDictionary(final IDictionary param) {
        // behavior.visitDictionary (param);
        // Object lObject = super.visitDictionary(param);
        // IPropertyValueSet lDefaultSet = param.getDefaultSet(); if
        // (lDefaultSet != null) { lDefaultSet.accept(this); }
        // for (IDictionaryElement i: param.getOwned()) { i.accept(this); }
        // return lObject;
        return null;
    }

    @Override
    @objid ("04070f5e-4583-11e0-b54c-00137279a832")
    public Object visitDictionaryElement(final IDictionaryElement param) {
        // Object lObject = super.visitDictionaryElement(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("04070f64-4583-11e0-b54c-00137279a832")
    public Object visitElement(final IElement param) {
        Object lObject = super.visitElement(param);
        // getdiagramElement() not supported... (IAbstractDiagram)
        // getundefined() not supported... (IViewElement)
        return lObject;
    }

    @Override
    @objid ("040971b8-4583-11e0-b54c-00137279a832")
    public Object visitElementImport(final IElementImport param) {
        this.behavior.visitElementImport(param);
        return super.visitElementImport(param);
    }

    @Override
    @objid ("040971be-4583-11e0-b54c-00137279a832")
    public Object visitElementRealization(final IElementRealization param) {
        this.behavior.visitElementRealization(param);
        return super.visitElementRealization(param);
    }

    @Override
    @objid ("040bd412-4583-11e0-b54c-00137279a832")
    public Object visitEnumeratedPropertyType(final IEnumeratedPropertyType param) {
        // behavior.visitEnumeratedPropertyType (param);
        // Object lObject = super.visitEnumeratedPropertyType(param);
        // for (IPropertyEnumerationLitteral i: param.getLitteral()) {
        // i.accept(this); }
        // return lObject;
        return null;
    }

    @Override
    @objid ("040bd418-4583-11e0-b54c-00137279a832")
    public Object visitEnumeration(final IEnumeration param) {
        this.behavior.visitEnumeration(param);
        Object lObject = super.visitEnumeration(param);
        for (IEnumerationLiteral i : param.getValue()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("040bd41e-4583-11e0-b54c-00137279a832")
    public Object visitEnumerationLiteral(final IEnumerationLiteral param) {
        this.behavior.visitEnumerationLiteral(param);
        return super.visitEnumerationLiteral(param);
    }

    @Override
    @objid ("040e3670-4583-11e0-b54c-00137279a832")
    public Object visitEvent(final IEvent param) {
        this.behavior.visitEvent (param);
        return super.visitEvent(param);
    }

    @Override
    @objid ("040e3676-4583-11e0-b54c-00137279a832")
    public Object visitExtensionPoint(final IExtensionPoint param) {
        this.behavior.visitExtensionPoint(param);
        return super.visitExtensionPoint(param);
    }

    @Override
    @objid ("041098ca-4583-11e0-b54c-00137279a832")
    public Object visitFeature(final IFeature param) {
        return super.visitFeature(param);
    }

    @Override
    @objid ("041098d0-4583-11e0-b54c-00137279a832")
    public Object visitGeneralClass(final IGeneralClass param) {
        return super.visitGeneralClass(param);
    }

    @Override
    @objid ("0412fb24-4583-11e0-b54c-00137279a832")
    public Object visitGeneralization(final IGeneralization param) {
        this.behavior.visitGeneralization(param);
        return super.visitGeneralization(param);
    }

    @Override
    @objid ("0412fb2a-4583-11e0-b54c-00137279a832")
    public Object visitInstance(final IInstance param) {
        this.behavior.visitInstance (param);
        Object lObject = super.visitInstance(param);
        for (IBindableInstance i: param.getPart()) { 
            if (i instanceof IPort)
                ((IPort)i).accept(this);
            else
                i.accept(this);
        }
        
        for (IAttributeLink i: param.getSlot()) { 
            i.accept(this);}
        
        for (ILinkEnd i: param.getConnection()) { 
            if (i instanceof IConnectorEnd)
                ((IConnectorEnd)i).accept(this);
            else
                i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04155d7e-4583-11e0-b54c-00137279a832")
    public Object visitInteraction(final IInteraction param) {
        this.behavior.visitInteraction(param);
        Object lObject = super.visitInteraction(param);
        for (IGate i : param.getFormalGate()) {
            i.accept(this);
        }
        for (IInteractionFragment i : param.getFragment()) {
            i.accept(this);
        }
        for (ILifeline i : param.getOwnedLine()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04155d84-4583-11e0-b54c-00137279a832")
    public Object visitInterface(final IInterface param) {
        this.behavior.visitInterface(param);
        return super.visitInterface(param);
    }

    @Override
    @objid ("0417bfd7-4583-11e0-b54c-00137279a832")
    public Object visitInterfaceRealization(final IInterfaceRealization param) {
        this.behavior.visitInterfaceRealization(param);
        return super.visitInterfaceRealization(param);
    }

    @Override
    @objid ("0417bfdd-4583-11e0-b54c-00137279a832")
    public Object visitInternalTransition(final IInternalTransition param) {
        this.behavior.visitInternalTransition(param);
        return super.visitInternalTransition(param);
    }

    @Override
    @objid ("041a2232-4583-11e0-b54c-00137279a832")
    public Object visitLink(final ILink param) {
        this.behavior.visitLink (param);
        return super.visitLink(param);
    }

    @Override
    @objid ("041a2238-4583-11e0-b54c-00137279a832")
    public Object visitLinkEnd(final ILinkEnd param) {
        this.behavior.visitLinkEnd (param);
        Object lObject = super.visitLinkEnd(param);
        
        ILink i = param.getLinkNode(); 
        i.accept(this);
        return lObject;
    }

    @Override
    @objid ("041c848b-4583-11e0-b54c-00137279a832")
    public Object visitLocalNote(final ILocalNote param) {
        // behavior.visitLocalNote (param);
        // Object lObject = super.visitLocalNote(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("041c8491-4583-11e0-b54c-00137279a832")
    public Object visitLocalTaggedValue(final ILocalTaggedValue param) {
        // behavior.visitLocalTaggedValue (param);
        // Object lObject = super.visitLocalTaggedValue(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("041ee6e6-4583-11e0-b54c-00137279a832")
    public Object visitManifestation(final IManifestation param) {
        this.behavior.visitManifestation(param);
        return super.visitManifestation(param);
    }

    @Override
    @objid ("041ee6ec-4583-11e0-b54c-00137279a832")
    public Object visitMessage(final IMessage param) {
        // behavior.visitMessage (param);
        // Object lObject = super.visitMessage(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("04214940-4583-11e0-b54c-00137279a832")
    public Object visitModelElement(final IModelElement param) {
        Object lObject = super.visitModelElement(param);
        for (IDependency i : param.getDependsOnDependency()) {
            i.accept(this);
        }
        for (INote i : param.getDescriptor()) {
            i.accept(this);
        }
        for (ITaggedValue i : param.getTag()) {
            if (!(ObjingModelNavigation.mustBeExported(i)))
                i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04214946-4583-11e0-b54c-00137279a832")
    public Object visitModelTree(final IModelTree param) {
        Object lObject = super.visitModelTree(param);
        for (IModelTree i : param.getOwnedElement()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("0423ab9a-4583-11e0-b54c-00137279a832")
    public Object visitNameSpace(final INameSpace param) {
        Object lObject = super.visitNameSpace(param);
        for (IInstance i : param.getDeclared()) {
            i.accept(this);
        }
        for (IBehavior i : param.getOwnedBehavior()) {
            i.accept(this);
        }
        for (ICollaborationUse i : param.getOwnedCollaborationUse()) {
            i.accept(this);
        }
        for (IDataFlow i : param.getOwnedDataFlow()) {
            i.accept(this);
        }
        for (IElementImport i : param.getOwnedImport()) {
            i.accept(this);
        }
        for (IInformationFlow i : param.getOwnedInformationFlow()) {
            i.accept(this);
        }
        for (IPackageImport i : param.getOwnedPackageImport()) {
            i.accept(this);
        }
        for (IGeneralization i : param.getParent()) {
            i.accept(this);
        }
        for (IInterfaceRealization i : param.getRealized()) {
            i.accept(this);
        }
        for (ITemplateParameter i : param.getTemplate()) {
            i.accept(this);
        }
        for (ITemplateBinding i : param.getTemplateInstanciation()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("0423aba0-4583-11e0-b54c-00137279a832")
    public Object visitNamespaceUse(final INamespaceUse param) {
        this.behavior.visitNamespaceUse(param);
        return super.visitNamespaceUse(param);
    }

    @Override
    @objid ("04260df4-4583-11e0-b54c-00137279a832")
    public Object visitNode(final INode param) {
        this.behavior.visitNode(param);
        return super.visitNode(param);
    }

    @Override
    @objid ("04260dfa-4583-11e0-b54c-00137279a832")
    public Object visitNote(final INote param) {
        this.behavior.visitNote(param);
        return super.visitNote(param);
    }

    @Override
    @objid ("0428704e-4583-11e0-b54c-00137279a832")
    public Object visitNoteType(final INoteType param) {
        this.behavior.visitNoteType(param);
        Object lObject = super.visitNoteType(param);
        // IPointOfView not supported... (param.getContext)
        return lObject;
    }

    @Override
    @objid ("042ad2a4-4583-11e0-b54c-00137279a832")
    public Object visitOperation(final IOperation param) {
        this.behavior.visitOperation(param);
        Object lObject = super.visitOperation(param);
        for (ICollaboration i : param.getExample()) {
            i.accept(this);
        }
        for (IParameter i : param.getIO()) {
            i.accept(this);
        }
        for (IBehavior i : param.getOwnedBehavior()) {
            i.accept(this);
        }
        for (ICollaborationUse i : param.getOwnedCollaborationUse()) {
            i.accept(this);
        }
        for (IElementImport i : param.getOwnedImport()) {
            i.accept(this);
        }
        for (IPackageImport i : param.getOwnedPackageImport()) {
            i.accept(this);
        }
        IParameter lReturn = param.getReturn();
        if (lReturn != null) {
            lReturn.accept(this);
        }
        for (ITemplateParameter i : param.getTemplate()) {
            i.accept(this);
        }
        for (ITemplateBinding i : param.getTemplateInstanciation()) {
            i.accept(this);
        }
        for (IRaisedException i : param.getThrown()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("042ad2aa-4583-11e0-b54c-00137279a832")
    public Object visitPackage(final IPackage param) {
        this.behavior.visitPackage(param);
        Object lObject = super.visitPackage(param);
        for (IPackageMerge i : param.getMerge()) {
            i.accept(this);
        }
        
        if (param.equals(Modelio.getInstance().getModelingSession().getModel().getRoot()))
            Modelio.getInstance().getModelingSession().getModel().getUmlProject().accept(this);
        // IItem not supported... (param.getPart)
        // getRepresented() not supported... (IProject)
        return lObject;
    }

    @Override
    @objid ("042d34fe-4583-11e0-b54c-00137279a832")
    public Object visitPackageImport(final IPackageImport param) {
        this.behavior.visitPackageImport(param);
        return super.visitPackageImport(param);
    }

    @Override
    @objid ("042d3504-4583-11e0-b54c-00137279a832")
    public Object visitPackageMerge(final IPackageMerge param) {
        this.behavior.visitPackageMerge(param);
        return super.visitPackageMerge(param);
    }

    @Override
    @objid ("042f975d-4583-11e0-b54c-00137279a832")
    public Object visitParameter(final IParameter param) {
        this.behavior.visitParameter(param);
        return super.visitParameter(param);
    }

    @Override
    @objid ("0431f9b2-4583-11e0-b54c-00137279a832")
    public Object visitPort(final IPort param) {
        this.behavior.visitPort (param);
        Object lObject = super.visitPort(param);
        for (IProvidedInterface i: param.getProvided()) {
            i.accept(this);
        }
        for (IRequiredInterface i: param.getRequired()) {
            i.accept(this);
        }
        return lObject;
        //        return null;
    }

    @Override
    @objid ("0431f9b8-4583-11e0-b54c-00137279a832")
    public Object visitProject(final IProject param) {
        //         behavior.visitProject (param);
        Object lObject = super.visitProject(param);
        //         IPackage lModel = param.getModel(); if (lModel != null) {
        //         lModel.accept(this); 
        //         }
        // // IItem not supported... (param.getRootItem)
        IAnalystProject lRootRequirement = param.getRootRequirement(); 
        if (lRootRequirement != null) {
            lRootRequirement.accept(this); }
        return lObject;
        //        return null;
    }

    @Override
    @objid ("04345c0c-4583-11e0-b54c-00137279a832")
    public Object visitProperty(final IProperty param) {
        // behavior.visitProperty (param);
        // Object lObject = super.visitProperty(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("04345c12-4583-11e0-b54c-00137279a832")
    public Object visitPropertyEnumerationLitteral(final IPropertyEnumerationLitteral param) {
        // behavior.visitPropertyEnumerationLitteral (param);
        // Object lObject = super.visitPropertyEnumerationLitteral(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("0436be67-4583-11e0-b54c-00137279a832")
    public Object visitPropertySet(final IPropertySet param) {
        // behavior.visitPropertySet (param);
        // Object lObject = super.visitPropertySet(param);
        // for (IProperty i: param.getOwned()) { i.accept(this); }
        // return lObject;
        return null;
    }

    @Override
    @objid ("0436be6d-4583-11e0-b54c-00137279a832")
    public Object visitPropertyType(final IPropertyType param) {
        // behavior.visitPropertyType (param);
        // Object lObject = super.visitPropertyType(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("043920c1-4583-11e0-b54c-00137279a832")
    public Object visitPropertyValue(final IPropertyValue param) {
        // behavior.visitPropertyValue (param);
        // Object lObject = super.visitPropertyValue(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("043920c7-4583-11e0-b54c-00137279a832")
    public Object visitPropertyValueSet(final IPropertyValueSet param) {
        // behavior.visitPropertyValueSet (param);
        // Object lObject = super.visitPropertyValueSet(param);
        // for (IPropertyValue i: param.getValue()) { i.accept(this); }
        // return lObject;
        return null;
    }

    @Override
    @objid ("043b831d-4583-11e0-b54c-00137279a832")
    public Object visitProvidedInterface(final IProvidedInterface param) {
        this.behavior.visitProvidedInterface (param);
        return super.visitProvidedInterface(param);
    }

    @Override
    @objid ("043de578-4583-11e0-b54c-00137279a832")
    public Object visitRaisedException(final IRaisedException param) {
        this.behavior.visitRaisedException(param);
        return super.visitRaisedException(param);
    }

    @Override
    @objid ("044047ce-4583-11e0-b54c-00137279a832")
    public Object visitRequiredInterface(final IRequiredInterface param) {
        this.behavior.visitRequiredInterface (param);
        return super.visitRequiredInterface(param);
    }

    @Override
    @objid ("044047d4-4583-11e0-b54c-00137279a832")
    public Object visitRegion(final IRegion param) {
        this.behavior.visitRegion(param);
        Object lObject = super.visitRegion(param);
        
        for (IStateVertex pseudoState : param.getSub()){
        
            if( pseudoState instanceof IFinalState){
                IFinalState state = (IFinalState) pseudoState;
                state.accept(this);
            }else if( pseudoState instanceof IState){
                IState state = (IState) pseudoState;
                state.accept(this);
            }else if (pseudoState instanceof IConnectionPointReference){
                IConnectionPointReference connectionPointReference = (IConnectionPointReference) pseudoState;
                connectionPointReference.accept(this);
            }else if (pseudoState instanceof IAbstractPseudoState){
                IAbstractPseudoState abstractPseudoState = (IAbstractPseudoState) pseudoState;
                abstractPseudoState.accept(this);
            }
        
        }
        return lObject;
    }

    @Override
    @objid ("0442aa28-4583-11e0-b54c-00137279a832")
    public Object visitRequirement(final IRequirement param) {
        this.behavior.visitRequirement (param);
        return super.visitRequirement(param);
    }

    @Override
    @objid ("0442aa2e-4583-11e0-b54c-00137279a832")
    public Object visitRequirementContainer(final IRequirementContainer param) {
        if (ProfileUtils.isAnalystDeployed()){
            this.behavior.visitRequirementContainer (param);
            //         Object lObject = super.visitRequirementContainer(param);
            // IPropertyValueSet lDefaultSet = param.getDefaultSet(); if
            // (lDefaultSet != null) { lDefaultSet.accept(this); }
            for (IRequirementElement i: param.getOwned()) { i.accept(this); }
        }
        //         return lObject;
        return null;
    }

    @Override
    @objid ("04450c83-4583-11e0-b54c-00137279a832")
    public Object visitRequirementElement(final IRequirementElement param) {
        return super.visitRequirementElement(param);
    }

    @Override
    @objid ("04450c89-4583-11e0-b54c-00137279a832")
    public Object visitSignal(final ISignal param) {
        this.behavior.visitSignal(param);
        return super.visitSignal(param);
    }

    @Override
    @objid ("04450c8f-4583-11e0-b54c-00137279a832")
    public Object visitState(final IState param) {
        this.behavior.visitState(param);
        Object lObject = super.visitState(param);
        for (IConnectionPointReference i : param.getConnection()) {
            i.accept(this);
        }
        for (IInternalTransition i : param.getInternal()) {
            i.accept(this);
        }
        
        for (IRegion i : param.getOwnedRegion()) {
            i.accept(this);
        }
        
        for(IEntryPointPseudoState i : param.getEntryPoint()){
            i.accept(this);
        }
        
        for(IExitPointPseudoState i : param.getExitPoint()){
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04476ee0-4583-11e0-b54c-00137279a832")
    public Object visitStateMachine(final IStateMachine param) {
        this.behavior.visitStateMachine(param);
        Object lObject = super.visitStateMachine(param);
        
        IRegion lTop = param.getTop();
        if (lTop != null) {
            lTop.accept(this);
        }
        
        for (IEvent event : param.getEComponent()){
            event.accept(this);    
        }
        
        for (IEntryPointPseudoState entry : param.getEntryPoint()){
            entry.accept(this);
        }
        
        for (IExitPointPseudoState exit : param.getExitPoint()){
            exit.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("0449d136-4583-11e0-b54c-00137279a832")
    public Object visitStateVertex(final IStateVertex param) {
        Object lObject = super.visitStateVertex(param);
        for (ITransition i : param.getOutGoing()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("0449d13c-4583-11e0-b54c-00137279a832")
    public Object visitStereotype(final IStereotype param) {
        //        behavior.visitStereotype(param);
        //        Object lObject = super.visitStereotype(param);
        //        for (INoteType i: param.getRequiredNote()) { i.accept(this); }
        //        for (ITagType i: param.getRequiredTag()) { i.accept(this); }
        //        for (IConstraint i: param.getStereotypeConstraint()) {
        //        i.accept(this); }
        // // IPointOfView not supported... (param.getContext)
        //        return lObject;
        return null;
    }

    @Override
    @objid ("044e95ea-4583-11e0-b54c-00137279a832")
    public Object visitSubstitution(final ISubstitution param) {
        this.behavior.visitSubstitution(param);
        return super.visitSubstitution(param);
    }

    @Override
    @objid ("044e95f0-4583-11e0-b54c-00137279a832")
    public Object visitTaggedValue(final ITaggedValue param) {
        this.behavior.visitTaggedValue (param);
        return super.visitTaggedValue(param);
    }

    @Override
    @objid ("0450f848-4583-11e0-b54c-00137279a832")
    public Object visitTagParameter(final ITagParameter param) {
        //        behavior.visitTagParameter (param);
        //        Object lObject = super.visitTagParameter(param);
        //        return lObject;
        return null;
    }

    @Override
    @objid ("0450f84e-4583-11e0-b54c-00137279a832")
    public Object visitTagType(final ITagType param) {
        this.behavior.visitTagType (param);
        return super.visitTagType(param);
    }

    @Override
    @objid ("04535aa3-4583-11e0-b54c-00137279a832")
    public Object visitTemplateBinding(final ITemplateBinding param) {
        this.behavior.visitTemplateBinding (param);
        Object lObject = super.visitTemplateBinding(param);
        for (ITemplateParameterSubstitution i:
            param.getParameterSubstitution()) { i.accept(this); }
        return lObject;
    }

    @Override
    @objid ("0455bcf8-4583-11e0-b54c-00137279a832")
    public Object visitTemplateParameter(final ITemplateParameter param) {
        this.behavior.visitTemplateParameter (param);
        Object lObject = super.visitTemplateParameter(param);
        IModelElement lOwnedParameterElement = param.getOwnedParameterElement(); 
        if (lOwnedParameterElement != null) { 
            lOwnedParameterElement.accept(this); 
        }
        return lObject;
    }

    @Override
    @objid ("0455bcfe-4583-11e0-b54c-00137279a832")
    public Object visitTemplateParameterSubstitution(final ITemplateParameterSubstitution param) {
        this.behavior.visitTemplateParameterSubstitution (param);
        return super.visitTemplateParameterSubstitution(param);
    }

    @Override
    @objid ("04581f53-4583-11e0-b54c-00137279a832")
    public Object visitTerm(final ITerm param) {
        // behavior.visitTerm (param);
        // Object lObject = super.visitTerm(param);
        // IPropertyValueSet lProperties = param.getProperties(); if
        // (lProperties != null) { lProperties.accept(this); }
        // return lObject;
        return null;
    }

    @Override
    @objid ("04581f59-4583-11e0-b54c-00137279a832")
    public Object visitTransition(final ITransition param) {
        this.behavior.visitTransition(param);
        Object lObject = super.visitTransition(param);
        /*String lGuard = param.getGuard();
        if (lGuard != null) {
            lGuard.accept(this);
        }
        String lPost = param.getPost();
        if (lPost != null) {
            lPost.accept(this);
        }*/
        return lObject;
    }

    @Override
    @objid ("045a81b0-4583-11e0-b54c-00137279a832")
    public Object visitUsage(final IUsage param) {
        this.behavior.visitUsage(param);
        return super.visitUsage(param);
    }

    @Override
    @objid ("045ce406-4583-11e0-b54c-00137279a832")
    public Object visitUseCase(final IUseCase param) {
        this.behavior.visitUseCase(param);
        Object lObject = super.visitUseCase(param);
        for (IExtensionPoint i : param.getOwnedExtension()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("045ce40c-4583-11e0-b54c-00137279a832")
    public Object visitUseCaseDependency(final IUseCaseDependency param) {
        this.behavior.visitUseCaseDependency(param);
        return super.visitUseCaseDependency(param);
    }

    @Override
    @objid ("045f4661-4583-11e0-b54c-00137279a832")
    public Object visitAbstractDiagram(final IAbstractDiagram param) {
        // Object lObject = super.visitAbstractDiagram(param);
        // // getrepresented() not supported... (IElement)
        // return lObject;
        return null;
    }

    @Override
    @objid ("045f4667-4583-11e0-b54c-00137279a832")
    public Object visitAbstractPseudoState(final IAbstractPseudoState param) {
        return super.visitAbstractPseudoState(param);
    }

    @Override
    @objid ("0461a8be-4583-11e0-b54c-00137279a832")
    public Object visitAcceptCallEventAction(final IAcceptCallEventAction param) {
        this.behavior.visitAcceptCallEventAction(param);
        return super.visitAcceptCallEventAction(param);
    }

    @Override
    @objid ("04640b14-4583-11e0-b54c-00137279a832")
    public Object visitAcceptChangeEventAction(final IAcceptChangeEventAction param) {
        this.behavior.visitAcceptChangeEventAction(param);
        return super.visitAcceptChangeEventAction(param);
    }

    @Override
    @objid ("04640b1a-4583-11e0-b54c-00137279a832")
    public Object visitAcceptSignalAction(final IAcceptSignalAction param) {
        this.behavior.visitAcceptSignalAction(param);
        return super.visitAcceptSignalAction(param);
    }

    @Override
    @objid ("04666d6f-4583-11e0-b54c-00137279a832")
    public Object visitAcceptTimeEventAction(final IAcceptTimeEventAction param) {
        this.behavior.visitAcceptTimeEventAction(param);
        return super.visitAcceptTimeEventAction(param);
    }

    @Override
    @objid ("04666d75-4583-11e0-b54c-00137279a832")
    public Object visitActivityAction(final IActivityAction param) {
        Object lObject = super.visitActivityAction(param);
        for (IInputPin i : param.getInput()) {
            i.accept(this);
        }
        for (IOutputPin i : param.getOutput()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("0468cfcd-4583-11e0-b54c-00137279a832")
    public Object visitActivityEdge(final IActivityEdge param) {
        return super.visitActivityEdge(param);
    }

    @Override
    @objid ("046b3222-4583-11e0-b54c-00137279a832")
    public Object visitActivityFinalNode(final IActivityFinalNode param) {
        this.behavior.visitActivityFinalNode(param);
        return super.visitActivityFinalNode(param);
    }

    @Override
    @objid ("046b3228-4583-11e0-b54c-00137279a832")
    public Object visitActivityGroup(final IActivityGroup param) {
        return super.visitActivityGroup(param);
    }

    @Override
    @objid ("046d947d-4583-11e0-b54c-00137279a832")
    public Object visitActivityNode(final IActivityNode param) {
        Object lObject = super.visitActivityNode(param);
        for (IActivityEdge i : param.getOutgoing()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("046ff6d6-4583-11e0-b54c-00137279a832")
    public Object visitActivityParameterNode(final IActivityParameterNode param) {
        this.behavior.visitActivityParameterNode(param);
        return super.visitActivityParameterNode(param);
    }

    @Override
    @objid ("046ff6dc-4583-11e0-b54c-00137279a832")
    public Object visitActivityPartition(final IActivityPartition param) {
        this.behavior.visitActivityPartition(param);
        Object lObject = super.visitActivityPartition(param);
        for (IActivityNode i : param.getContainedNode()) {
            i.accept(this);
        }
        for (IMessageFlow i : param.getOutgoing()) {
            i.accept(this);
        }
        for (IActivityPartition i : param.getSubPartition()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04725933-4583-11e0-b54c-00137279a832")
    public Object visitBehaviorParameter(final IBehaviorParameter param) {
        this.behavior.visitBehaviorParameter (param);
        return super.visitBehaviorParameter(param);
    }

    @Override
    @objid ("0474bb8a-4583-11e0-b54c-00137279a832")
    public Object visitCallAction(final ICallAction param) {
        return super.visitCallAction(param);
    }

    @Override
    @objid ("0474bb90-4583-11e0-b54c-00137279a832")
    public Object visitCallBehaviorAction(final ICallBehaviorAction param) {
        this.behavior.visitCallBehaviorAction(param);
        return super.visitCallBehaviorAction(param);
    }

    @Override
    @objid ("04771de5-4583-11e0-b54c-00137279a832")
    public Object visitCallOperationAction(final ICallOperationAction param) {
        this.behavior.visitCallOperationAction(param);
        return super.visitCallOperationAction(param);
    }

    @Override
    @objid ("04771deb-4583-11e0-b54c-00137279a832")
    public Object visitCentralBufferNode(final ICentralBufferNode param) {
        this.behavior.visitCentralBufferNode(param);
        return super.visitCentralBufferNode(param);
    }

    @Override
    @objid ("04798042-4583-11e0-b54c-00137279a832")
    public Object visitChoicePseudoState(final IChoicePseudoState param) {
        this.behavior.visitChoicePseudoState (param);
        return super.visitChoicePseudoState(param);
    }

    @Override
    @objid ("047be298-4583-11e0-b54c-00137279a832")
    public Object visitClause(final IClause param) {
        this.behavior.visitClause(param);
        Object lObject = super.visitClause(param);
        for (IActivityNode i : param.getBody()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("047be29e-4583-11e0-b54c-00137279a832")
    public Object visitCombinedFragment(final ICombinedFragment param) {
        this.behavior.visitCombinedFragment(param);
        Object lObject = super.visitCombinedFragment(param);
        for (IGate i : param.getFragmentGate()) {
            i.accept(this);
        }
        for (IInteractionOperand i : param.getOperand()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("047e44f6-4583-11e0-b54c-00137279a832")
    public Object visitConditionalNode(final IConditionalNode param) {
        this.behavior.visitConditionalNode(param);
        Object lObject = super.visitConditionalNode(param);
        for (IClause i : param.getOwnedClause()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("0480a74c-4583-11e0-b54c-00137279a832")
    public Object visitConnectionPointReference(final IConnectionPointReference param) {
        this.behavior.visitConnectionPointReference (param);
        return super.visitConnectionPointReference(param);
    }

    @Override
    @objid ("0480a752-4583-11e0-b54c-00137279a832")
    public Object visitControlFlow(final IControlFlow param) {
        this.behavior.visitControlFlow(param);
        return super.visitControlFlow(param);
    }

    @Override
    @objid ("048309a8-4583-11e0-b54c-00137279a832")
    public Object visitControlNode(final IControlNode param) {
        return super.visitControlNode(param);
    }

    @Override
    @objid ("04856c00-4583-11e0-b54c-00137279a832")
    public Object visitDataStoreNode(final IDataStoreNode param) {
        this.behavior.visitDataStoreNode(param);
        return super.visitDataStoreNode(param);
    }

    @Override
    @objid ("04856c06-4583-11e0-b54c-00137279a832")
    public Object visitDecisionMergeNode(final IDecisionMergeNode param) {
        this.behavior.visitDecisionMergeNode(param);
        return super.visitDecisionMergeNode(param);
    }

    @Override
    @objid ("0487ce5b-4583-11e0-b54c-00137279a832")
    public Object visitDeepHistoryPseudoState(final IDeepHistoryPseudoState param) {
        this.behavior.visitDeepHistoryPseudoState (param);
        return super.visitDeepHistoryPseudoState(param);
    }

    @Override
    @objid ("048a30b4-4583-11e0-b54c-00137279a832")
    public Object visitDurationConstraint(final IDurationConstraint param) {
        // behavior.visitDurationConstraint (param);
        // Object lObject = super.visitDurationConstraint(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("048a30ba-4583-11e0-b54c-00137279a832")
    public Object visitEntryPointPseudoState(final IEntryPointPseudoState param) {
        this.behavior.visitEntryPointPseudoState (param);
        return super.visitEntryPointPseudoState(param);
    }

    @Override
    @objid ("048c930f-4583-11e0-b54c-00137279a832")
    public Object visitExecutionOccurenceSpecification(final IExecutionOccurenceSpecification param) {
        this.behavior.visitExecutionOccurenceSpecification(param);
        return super.visitExecutionOccurenceSpecification(param);
    }

    @Override
    @objid ("048ef568-4583-11e0-b54c-00137279a832")
    public Object visitExecutionSpecification(final IExecutionSpecification param) {
        this.behavior.visitExecutionSpecification(param);
        return super.visitExecutionSpecification(param);
    }

    @Override
    @objid ("048ef56e-4583-11e0-b54c-00137279a832")
    public Object visitExitPointPseudoState(final IExitPointPseudoState param) {
        this.behavior.visitExitPointPseudoState (param);
        return super.visitExitPointPseudoState(param);
    }

    @Override
    @objid ("049157c4-4583-11e0-b54c-00137279a832")
    public Object visitFinalNode(final IFinalNode param) {
        return super.visitFinalNode(param);
    }

    @Override
    @objid ("0493ba1c-4583-11e0-b54c-00137279a832")
    public Object visitFinalState(final IFinalState param) {
        this.behavior.visitFinalState(param);
        return super.visitFinalState(param);
    }

    @Override
    @objid ("0493ba22-4583-11e0-b54c-00137279a832")
    public Object visitFlowFinalNode(final IFlowFinalNode param) {
        this.behavior.visitFlowFinalNode(param);
        return super.visitFlowFinalNode(param);
    }

    @Override
    @objid ("04961c78-4583-11e0-b54c-00137279a832")
    public Object visitForkJoinNode(final IForkJoinNode param) {
        this.behavior.visitForkJoinNode(param);
        return super.visitForkJoinNode(param);
    }

    @Override
    @objid ("04987ed0-4583-11e0-b54c-00137279a832")
    public Object visitForkPseudoState(final IForkPseudoState param) {
        this.behavior.visitForkPseudoState (param);
        return super.visitForkPseudoState(param);
    }

    @Override
    @objid ("04987ed6-4583-11e0-b54c-00137279a832")
    public Object visitGate(final IGate param) {
        this.behavior.visitGate(param);
        return super.visitGate(param);
    }

    @Override
    @objid ("049ae12e-4583-11e0-b54c-00137279a832")
    public Object visitGeneralOrdering(final IGeneralOrdering param) {
        // behavior.visitGeneralOrdering (param);
        // Object lObject = super.visitGeneralOrdering(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("049d4384-4583-11e0-b54c-00137279a832")
    public Object visitInformationFlow(final IInformationFlow param) {
        this.behavior.visitInformationFlow (param);
        return super.visitInformationFlow(param);
    }

    @Override
    @objid ("049fa5de-4583-11e0-b54c-00137279a832")
    public Object visitInformationItem(final IInformationItem param) {
        this.behavior.visitInformationItem (param);
        return super.visitInformationItem(param);
    }

    @Override
    @objid ("049fa5e4-4583-11e0-b54c-00137279a832")
    public Object visitInitialNode(final IInitialNode param) {
        this.behavior.visitInitialNode(param);
        return super.visitInitialNode(param);
    }

    @Override
    @objid ("04a20839-4583-11e0-b54c-00137279a832")
    public Object visitInitialPseudoState(final IInitialPseudoState param) {
        this.behavior.visitInitialPseudoState (param);
        return super.visitInitialPseudoState(param);
    }

    @Override
    @objid ("04a46a92-4583-11e0-b54c-00137279a832")
    public Object visitInputPin(final IInputPin param) {
        this.behavior.visitInputPin(param);
        return super.visitInputPin(param);
    }

    @Override
    @objid ("04a6ccec-4583-11e0-b54c-00137279a832")
    public Object visitInstanceNode(final IInstanceNode param) {
        this.behavior.visitInstanceNode(param);
        return super.visitInstanceNode(param);
    }

    @Override
    @objid ("04a6ccf2-4583-11e0-b54c-00137279a832")
    public Object visitInteractionFragment(final IInteractionFragment param) {
        return super.visitInteractionFragment(param);
    }

    @Override
    @objid ("04a92f4b-4583-11e0-b54c-00137279a832")
    public Object visitInteractionOperand(final IInteractionOperand param) {
        this.behavior.visitInteractionOperand(param);
        Object lObject = super.visitInteractionOperand(param);
        for (IInteractionFragment i : param.getFragment()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04ab91a4-4583-11e0-b54c-00137279a832")
    public Object visitInteractionUse(final IInteractionUse param) {
        this.behavior.visitInteractionUse(param);
        Object lObject = super.visitInteractionUse(param);
        for (IGate i : param.getActualGate()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04adf3fb-4583-11e0-b54c-00137279a832")
    public Object visitInterruptibleActivityRegion(final IInterruptibleActivityRegion param) {
        this.behavior.visitInterruptibleActivityRegion(param);
        return super.visitInterruptibleActivityRegion(param);
    }

    @Override
    @objid ("04b05654-4583-11e0-b54c-00137279a832")
    public Object visitJoinPseudoState(final IJoinPseudoState param) {
        this.behavior.visitJoinPseudoState (param);
        return super.visitJoinPseudoState(param);
    }

    @Override
    @objid ("04b0565a-4583-11e0-b54c-00137279a832")
    public Object visitJunctionPseudoState(final IJunctionPseudoState param) {
        this.behavior.visitJunctionPseudoState (param);
        return super.visitJunctionPseudoState(param);
    }

    @Override
    @objid ("04b2b8b2-4583-11e0-b54c-00137279a832")
    public Object visitLifeline(final ILifeline param) {
        this.behavior.visitLifeline(param);
        return super.visitLifeline(param);
    }

    @Override
    @objid ("04b51b09-4583-11e0-b54c-00137279a832")
    public Object visitLoopNode(final ILoopNode param) {
        this.behavior.visitLoopNode(param);
        return super.visitLoopNode(param);
    }

    @Override
    @objid ("04b77d62-4583-11e0-b54c-00137279a832")
    public Object visitMessageEnd(final IMessageEnd param) {
        Object lObject = super.visitMessageEnd(param);
        IMessage lSentMessage = param.getSentMessage();
        if (lSentMessage != null) {
            lSentMessage.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04b9dfbc-4583-11e0-b54c-00137279a832")
    public Object visitMessageFlow(final IMessageFlow param) {
        // behavior.visitMessageFlow (param);
        // Object lObject = super.visitMessageFlow(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("04b9dfc2-4583-11e0-b54c-00137279a832")
    public Object visitObjectFlow(final IObjectFlow param) {
        this.behavior.visitObjectFlow(param);
        return super.visitObjectFlow(param);
    }

    @Override
    @objid ("04bc4218-4583-11e0-b54c-00137279a832")
    public Object visitObjectNode(final IObjectNode param) {
        return  super.visitObjectNode(param);
    }

    @Override
    @objid ("04bea470-4583-11e0-b54c-00137279a832")
    public Object visitOccurrenceSpecification(final IOccurrenceSpecification param) {
        Object lObject = super.visitOccurrenceSpecification(param);
        for (IGeneralOrdering i : param.getToAfter()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04c106ca-4583-11e0-b54c-00137279a832")
    public Object visitOpaqueAction(final IOpaqueAction param) {
        this.behavior.visitOpaqueAction(param);
        return super.visitOpaqueAction(param);
    }

    @Override
    @objid ("04c36924-4583-11e0-b54c-00137279a832")
    public Object visitOpaqueBehavior(final IOpaqueBehavior param) {
        // behavior.visitOpaqueBehavior (param);
        // Object lObject = super.visitOpaqueBehavior(param);
        // return lObject;
        return null;
    }

    @Override
    @objid ("04c3692a-4583-11e0-b54c-00137279a832")
    public Object visitOutputPin(final IOutputPin param) {
        this.behavior.visitOutputPin(param);
        return super.visitOutputPin(param);
    }

    @Override
    @objid ("04c5cb82-4583-11e0-b54c-00137279a832")
    public Object visitPartDecomposition(final IPartDecomposition param) {
        this.behavior.visitPartDecomposition(param);
        return super.visitPartDecomposition(param);
    }

    @Override
    @objid ("04c82dd8-4583-11e0-b54c-00137279a832")
    public Object visitPin(final IPin param) {
        return super.visitPin(param);
    }

    @Override
    @objid ("04ca9032-4583-11e0-b54c-00137279a832")
    public Object visitSendSignalAction(final ISendSignalAction param) {
        this.behavior.visitSendSignalAction(param);
        return super.visitSendSignalAction(param);
    }

    @Override
    @objid ("04ccf28c-4583-11e0-b54c-00137279a832")
    public Object visitShallowHistoryPseudoState(final IShallowHistoryPseudoState param) {
        this.behavior.visitShallowHistoryPseudoState (param);
        return super.visitShallowHistoryPseudoState(param);
    }

    @Override
    @objid ("04ccf292-4583-11e0-b54c-00137279a832")
    public Object visitStateInvariant(final IStateInvariant param) {
        this.behavior.visitStateInvariant(param);
        return super.visitStateInvariant(param);
    }

    @Override
    @objid ("04cf54ea-4583-11e0-b54c-00137279a832")
    public Object visitStructuredActivityNode(final IStructuredActivityNode param) {
        this.behavior.visitStructuredActivityNode(param);
        Object lObject = super.visitStructuredActivityNode(param);
        for (IActivityNode i : param.getBody()) {
            i.accept(this);
        }
        return lObject;
    }

    @Override
    @objid ("04d1b740-4583-11e0-b54c-00137279a832")
    public Object visitTerminatePseudoState(final ITerminatePseudoState param) {
        this.behavior.visitTerminatePseudoState (param);
        return super.visitTerminatePseudoState(param);
    }

    @Override
    @objid ("04d4199a-4583-11e0-b54c-00137279a832")
    public Object visitAnalystProject(final IAnalystProject param) {
        // behavior.visitRequirementContainer (param);
        // Object lObject = super.visitRequirementContainer(param);
        // IPropertyValueSet lDefaultSet = param.getDefaultSet(); if
        // (lDefaultSet != null) { lDefaultSet.accept(this); }
        param.getRequirementRoot().accept(this);
        // return lObject;
        return null;
    }

    @Override
    @objid ("774751c9-5c0e-11e1-9a0a-0027103f347d")
    public Object visitValuePin(final IValuePin param) {
        this.behavior.visitValuePin(param);
        return super.visitValuePin(param);
    }

}
