/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.generation;

import com.modeliosoft.modelio.api.model.analyst.IDictionary;
import com.modeliosoft.modelio.api.model.analyst.IEnumeratedPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IProperty;
import com.modeliosoft.modelio.api.model.analyst.IPropertyEnumerationLitteral;
import com.modeliosoft.modelio.api.model.analyst.IPropertySet;
import com.modeliosoft.modelio.api.model.analyst.IPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValue;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValueSet;
import com.modeliosoft.modelio.api.model.analyst.IRequirement;
import com.modeliosoft.modelio.api.model.analyst.IRequirementContainer;
import com.modeliosoft.modelio.api.model.analyst.ITerm;
import com.modeliosoft.modelio.api.model.extension.IProject;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptCallEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptChangeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptTimeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityEdge;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityParameterNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallBehaviorAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallOperationAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICentralBufferNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IClause;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IConditionalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IControlFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDataStoreNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDecisionMergeNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IFlowFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IForkJoinNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInitialNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInstanceNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInterruptibleActivityRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ILoopNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IMessageFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IObjectFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOutputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehaviorParameter;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IOpaqueBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ObEventTypeEnum;
import com.modeliosoft.modelio.api.model.uml.behavior.communication.ICommunicationChannel;
import com.modeliosoft.modelio.api.model.uml.behavior.communication.ICommunicationInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.communication.ICommunicationMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.communication.ICommunicationNode;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ICombinedFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IDurationConstraint;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionOccurenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGate;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGeneralOrdering;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionOperand;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionUse;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IPartDecomposition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IAbstractPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IChoicePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IConnectionPointReference;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IDeepHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEntryPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IExitPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IFinalState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IForkPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInitialPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInternalTransition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJoinPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJunctionPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IShallowHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateInvariant;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITerminatePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.information.IInformationFlow;
import com.modeliosoft.modelio.api.model.uml.information.IInformationItem;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IAbstraction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IConstraint;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElementRealization;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalNote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalTaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INoteType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IProfile;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IUsage;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IAttribute;
import com.modeliosoft.modelio.api.model.uml.statik.IAttributeLink;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IBinding;
import com.modeliosoft.modelio.api.model.uml.statik.IClass;
import com.modeliosoft.modelio.api.model.uml.statik.IClassAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaboration;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.model.uml.statik.IConnector;
import com.modeliosoft.modelio.api.model.uml.statik.IConnectorEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IDataFlow;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IElementImport;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralization;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IManifestation;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.model.uml.statik.INamespaceUse;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageImport;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.model.uml.statik.IProvidedInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IRaisedException;
import com.modeliosoft.modelio.api.model.uml.statik.IRequiredInterface;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameterSubstitution;
import com.modeliosoft.modelio.api.model.uml.usecase.IActor;
import com.modeliosoft.modelio.api.model.uml.usecase.IExtensionPoint;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCaseDependency;
import com.modeliosoft.modelio.api.utils.DefaultMetamodelVisitor;
import com.modeliosoft.modelio.api.utils.ObList;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMI;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import com.modeliosoft.modelio.xmi.util.ModelerModuleStereotypes;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ObjingModelNavigation;
import com.modeliosoft.modelio.xmi.util.PrimitiveTypeMapper;
import com.modeliosoft.modelio.xmi.util.XMILogs;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.ActivityEdge;
import org.eclipse.uml2.uml.ControlNode;
import org.eclipse.uml2.uml.DecisionNode;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ForkNode;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Pseudostate;
import org.eclipse.uml2.uml.PseudostateKind;
import org.eclipse.uml2.uml.TemplateBinding;
import org.eclipse.uml2.uml.TemplateParameter;
import org.eclipse.uml2.uml.Transition;
import org.eclipse.uml2.uml.TransitionKind;
import org.eclipse.uml2.uml.UMLFactory;

/**
 * This class creates an Ecore element corresponding to given Modelio element.
 * It is used when a Modelio element has a reference to another element not already exported.
 * @author ebrosse
 */
@objid ("04d419a0-4583-11e0-b54c-00137279a832")
public class PartialCreationExportVisitor {
    @objid ("04d419a1-4583-11e0-b54c-00137279a832")
     CreationExportMapper mapper;

    @objid ("04d419a2-4583-11e0-b54c-00137279a832")
     PartialExportMap partialMap;

    @objid ("04d419a3-4583-11e0-b54c-00137279a832")
     CompositionOwnerVisitor ownerVisitor = new CompositionOwnerVisitor();

    @objid ("04d419a4-4583-11e0-b54c-00137279a832")
     Element ecoreElt;


    /**
     * The default constructor
     */
    @objid ("04d419a5-4583-11e0-b54c-00137279a832")
    public PartialCreationExportVisitor() {
        this.ecoreElt = null;
        this.mapper = new CreationExportMapper();
        this.partialMap = PartialExportMap.getInstance();
    }

    /**
     * This is method supervise the Ecore element creation
     * @param objingElt : the referenced Modelio element
     * @return the corresponding Ecore element
     */
    @objid ("04d67bf4-4583-11e0-b54c-00137279a832")
    public Element createPartialEcoreElt(final IElement objingElt) {
        this.ecoreElt = null;
        Element ecoreEltFromMap = this.partialMap.get(objingElt.getIdentifier());
        if (ecoreEltFromMap == null) {
            this.mapper.accept(objingElt);
            if (this.ecoreElt != null)
                this.partialMap.put(objingElt.getIdentifier(), this.ecoreElt);
        }
        return this.ecoreElt;
    }

    /**
     * This method returns the CreationExportMapper
     * @return the CreationExportMapper
     */
    @objid ("04d67bf9-4583-11e0-b54c-00137279a832")
    public CreationExportMapper getMapper() {
        // Automatically generated method. Please delete this comment before entering specific code.
        return this.mapper;
    }

    /**
     * This methods returns the map containing all "partial" exports
     * @return the PartilaExportMap
     */
    @objid ("04d67bfd-4583-11e0-b54c-00137279a832")
    public PartialExportMap getPartialMap() {
        // Automatically generated method. Please delete this comment before entering specific code.
        return this.partialMap;
    }

    /**
     * This method returns the Modelio Composition Visitor
     * @return the CompositionOwnerVisitor
     */
    @objid ("04d67c01-4583-11e0-b54c-00137279a832")
    public CompositionOwnerVisitor getOwnerVisitor() {
        // Automatically generated method. Please delete this comment before entering specific code.
        return this.ownerVisitor;
    }

    @objid ("04d8de51-4583-11e0-b54c-00137279a832")
    private class CreationExportMapper extends DefaultMetamodelVisitor {

        @objid ("04d8de52-4583-11e0-b54c-00137279a832")
        public void accept(IElement objingElt) {
            objingElt.accept(this);
        }

        @Override
        @objid ("04d8de55-4583-11e0-b54c-00137279a832")
        public Object visitAbstraction(IAbstraction objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAbstraction();
            return null;
        }

        @Override
        @objid ("04d8de5b-4583-11e0-b54c-00137279a832")
        public Object visitAbstractPseudoState(IAbstractPseudoState objingElt) {
            return null;
        }

        @Override
        @objid ("04db40ac-4583-11e0-b54c-00137279a832")
        public Object visitAcceptCallEventAction(IAcceptCallEventAction objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAcceptEventAction();
            return null;
        }

        @Override
        @objid ("04db40b2-4583-11e0-b54c-00137279a832")
        public Object visitAcceptChangeEventAction(IAcceptChangeEventAction objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAcceptEventAction();
            return null;
        }

        @Override
        @objid ("04dda303-4583-11e0-b54c-00137279a832")
        public Object visitAcceptSignalAction(IAcceptSignalAction objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAcceptEventAction();
            if (GenerationProperties.getInstance().isRoundtripEnabled()){
                ObjingEAnnotation.setSignal(PartialCreationExportVisitor.this.ecoreElt, "signal");
            }
            return null;
        }

        @Override
        @objid ("04dda309-4583-11e0-b54c-00137279a832")
        public Object visitAcceptTimeEventAction(IAcceptTimeEventAction objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAcceptEventAction();
            return null;
        }

        @Override
        @objid ("04e0055d-4583-11e0-b54c-00137279a832")
        public Object visitActivity(IActivity objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createActivity();
            return null;
        }

        @Override
        @objid ("04e00563-4583-11e0-b54c-00137279a832")
        public Object visitActivityFinalNode(IActivityFinalNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createActivityFinalNode();
            return null;
        }

        @Override
        @objid ("04e267b7-4583-11e0-b54c-00137279a832")
        public Object visitActivityParameterNode(IActivityParameterNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createActivityParameterNode();
            return null;
        }

        @Override
        @objid ("04e267bd-4583-11e0-b54c-00137279a832")
        public Object visitActivityPartition(IActivityPartition objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createActivityPartition();
            return null;
        }

        @Override
        @objid ("04e4ca11-4583-11e0-b54c-00137279a832")
        public Object visitActor(IActor objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createActor();
            return null;
        }

        @Override
        @objid ("04e4ca17-4583-11e0-b54c-00137279a832")
        public Object visitArtifact(IArtifact objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2DEPLOYMENTSPECIFICATION)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDeploymentSpecification();
            }else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createArtifact();
            return null;
        }

        @Override
        @objid ("04e4ca1d-4583-11e0-b54c-00137279a832")
        public Object visitAssociation(IAssociation objingElt) {
            if (ObjingModelNavigation.isClassAssociation(objingElt)) {
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAssociationClass();
                // Case of an AssociationClass - the keys for an ecore
                // AssociationClass are:
                // - the ID of the objing Association
                // - the ID of the objing ClassAssociation
                // - the ID of the objing Class representing the
                // ClassAssociation
                IClassAssociation classAssoc = objingElt.getLinkToClass();
                PartialCreationExportVisitor.this.partialMap.put(classAssoc.getIdentifier(), PartialCreationExportVisitor.this.ecoreElt);
                PartialCreationExportVisitor.this.partialMap.put(classAssoc.getClassPart().getIdentifier(), PartialCreationExportVisitor.this.ecoreElt);
            } else{
                if (objingElt.isStereotyped(XMIStereotypes.UML2COMMUNICATIONPATH)){
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCommunicationPath();
                }else if (objingElt.isStereotyped(XMIStereotypes.UML2EXTENSION)){
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExtension();
                }else{
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAssociation();
                }
            }
            return null;
        }

        @Override
        @objid ("04e4ca23-4583-11e0-b54c-00137279a832")
        public Object visitAssociationEnd(IAssociationEnd objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2EXTENSIONEND)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExtensionEnd();
            }
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createProperty();
            return null;
        }

        @Override
        @objid ("04f3182c-4583-11e0-b54c-00137279a832")
        public Object visitAttribute(IAttribute objingElt) {
            IElement obOwner = objingElt.getCompositionOwner();
            
            if (obOwner instanceof IActor || obOwner instanceof IUseCase) {
                PartialCreationExportVisitor.this.ecoreElt = null;
            }else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createProperty();
            return null;
        }

        @Override
        @objid ("04f31832-4583-11e0-b54c-00137279a832")
        public Object visitAttributeLink(IAttributeLink objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createSlot();
            return null;
        }

        @Override
        @objid ("04f7dce0-4583-11e0-b54c-00137279a832")
        public Object visitBehaviorParameter(IBehaviorParameter objingElt) {
            // BehaviorParameters are not exported (report to the
            // "setRepresentedRealParameter()" method of the
            // ActivityParameterNode
            // mapper for more details.
            return null;
        }

        @Override
        @objid ("04fa3f3f-4583-11e0-b54c-00137279a832")
        public Object visitBindableInstance(IBindableInstance objingElt) {
            IElement root = ObjingModelNavigation.getBindableInstanceOwner(objingElt);
            
            if (root instanceof IInstance){
                PartialCreationExportVisitor.this.ecoreElt =  UMLFactory.eINSTANCE.createSlot();
            
            }else {
                IModelElement representedFeature = objingElt.getRepresentedFeature();
                Property part = null;
                if ((representedFeature != null) && (representedFeature instanceof IAssociationEnd)){
                    part = (Property) GenerationProperties.getInstance().getMappedElement(representedFeature);
                }else{
                    part = UMLFactory.eINSTANCE.createProperty();
                }
            
                part.setIsComposite(true);
                PartialCreationExportVisitor.this.ecoreElt = part;
            }
            return null;
        }

        @Override
        @objid ("04fa3f45-4583-11e0-b54c-00137279a832")
        public Object visitBinding(IBinding objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDependency();
            return null;
        }

        @Override
        @objid ("04fca198-4583-11e0-b54c-00137279a832")
        public Object visitCallBehaviorAction(ICallBehaviorAction objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCallBehaviorAction();
            return null;
        }

        @Override
        @objid ("04ff03ee-4583-11e0-b54c-00137279a832")
        public Object visitCallOperationAction(ICallOperationAction objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCallOperationAction();
            return null;
        }

        @Override
        @objid ("04ff03f4-4583-11e0-b54c-00137279a832")
        public Object visitCentralBufferNode(ICentralBufferNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCentralBufferNode();
            return null;
        }

        @Override
        @objid ("05016648-4583-11e0-b54c-00137279a832")
        public Object visitChoicePseudoState(IChoicePseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.CHOICE_LITERAL);
            return null;
        }

        @Override
        @objid ("0501664e-4583-11e0-b54c-00137279a832")
        public Object visitClass(IClass objingElt) {
            if (ObjingModelNavigation.isClassAssociation(objingElt)) {
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAssociationClass();
                // Case of an AssociationClass - the keys for an ecore
                // AssociationClass are:
                // - the ID of the objing Association
                // - the ID of the objing ClassAssociation
                // - the ID of the objing Class representing the
                // ClassAssociation
                ObList<IClassAssociation> classAssocList = objingElt
                        .getLinkToAssociation();
                // A Class cannot represent more than one ClassAssociation
                // (audit rule 204)
                if (classAssocList != null && classAssocList.size() == 1) {
                    IClassAssociation classAssoc = classAssocList.get(0);
                    PartialCreationExportVisitor.this.partialMap.put(classAssoc.getIdentifier(), PartialCreationExportVisitor.this.ecoreElt);
                    PartialCreationExportVisitor.this.partialMap.put(classAssoc.getAssociationPart().getIdentifier(),
                            PartialCreationExportVisitor.this.ecoreElt);
                }
            
            } else {
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createClass();
            }
            return null;
        }

        @Override
        @objid ("0503c8a2-4583-11e0-b54c-00137279a832")
        public Object visitClassAssociation(IClassAssociation objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAssociationClass();
            // Case of an AssociationClass - the keys for an ecore
            // AssociationClass are:
            // - the ID of the objing Association
            // - the ID of the objing ClassAssociation
            // - the ID of the objing Class representing the ClassAssociation
            PartialCreationExportVisitor.this.partialMap.put(objingElt.getAssociationPart().getIdentifier(), PartialCreationExportVisitor.this.ecoreElt);
            PartialCreationExportVisitor.this.partialMap.put(objingElt.getClassPart().getIdentifier(), PartialCreationExportVisitor.this.ecoreElt);
            return null;
        }

        @Override
        @objid ("0503c8a8-4583-11e0-b54c-00137279a832")
        public Object visitClause(IClause objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createClause();
            return null;
        }

        @Override
        @objid ("05062afc-4583-11e0-b54c-00137279a832")
        public Object visitCollaboration(ICollaboration objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCollaboration();
            return null;
        }

        @Override
        @objid ("05062b02-4583-11e0-b54c-00137279a832")
        public Object visitCollaborationUse(ICollaborationUse objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCollaborationUse();
            return null;
        }

        @Override
        @objid ("05088d56-4583-11e0-b54c-00137279a832")
        public Object visitCombinedFragment(ICombinedFragment objingElt) {
            // Particular case of a sequence diagram element
            // ecoreElt = UMLFactory.eINSTANCE.createCombinedFragment();
            return null;
        }

        @Override
        @objid ("05088d5c-4583-11e0-b54c-00137279a832")
        public Object visitCommunicationChannel(ICommunicationChannel objingElt) {
            return null;
        }

        @Override
        @objid ("050aefb0-4583-11e0-b54c-00137279a832")
        public Object visitCommunicationInteraction(ICommunicationInteraction objingElt) {
            return null;
        }

        @Override
        @objid ("050aefb6-4583-11e0-b54c-00137279a832")
        public Object visitCommunicationMessage(ICommunicationMessage objingElt) {
            return null;
        }

        @Override
        @objid ("050d520a-4583-11e0-b54c-00137279a832")
        public Object visitCommunicationNode(ICommunicationNode objingElt) {
            return null;
        }

        @Override
        @objid ("050d5210-4583-11e0-b54c-00137279a832")
        public Object visitComponent(IComponent objingElt) {
            if (ObjingModelNavigation.isClassAssociation(objingElt))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAssociationClass();
            else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createComponent();
            return null;
        }

        @Override
        @objid ("050fb464-4583-11e0-b54c-00137279a832")
        public Object visitConditionalNode(IConditionalNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createConditionalNode();
            return null;
        }

        @Override
        @objid ("050fb46a-4583-11e0-b54c-00137279a832")
        public Object visitConnectionPointReference(IConnectionPointReference objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createConnectionPointReference();
            return null;
        }

        @Override
        @objid ("051216be-4583-11e0-b54c-00137279a832")
        public Object visitConnector(IConnector objingElt) {
            IElement root = ObjingModelNavigation.getConnectorOwner(objingElt);
            
            if (root != null){
                if (root instanceof IInstance){
                    if (objingElt.getCompositionOwner().getCompositionOwner().equals(root) || (GenerationProperties.getInstance().isRoundtripEnabled()))
                        PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInstanceSpecification();
                    else{
                        XMILogs xmilogs = XMILogs.getInstance();
                        String message = XMI.I18N.getMessage("logFile.warning.unsupportedExport", 
                                objingElt.getName(), 
                                objingElt.getClass().getSimpleName());
                        xmilogs.writelnInLog(message);
            
                        GenerationProperties.getInstance().getReportModel().addError(message, objingElt);
            
                        PartialCreationExportVisitor.this.ecoreElt = null;
                    }
            
                }else 
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createConnector();
            }else{
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createConnector();
            }
            return null;
        }

        @Override
        @objid ("051216c4-4583-11e0-b54c-00137279a832")
        public Object visitConnectorEnd(IConnectorEnd objingElt) {
            IElement root  = ObjingModelNavigation.getBindableInstanceOwner(objingElt);
            IElement owner = objingElt.getCompositionOwner();
            
            if ((owner instanceof IInstance) && (owner.getCompositionOwner().equals(root))){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createConnectorEnd();
            }else if (root instanceof IInstance){
                if (GenerationProperties.getInstance().isRoundtripEnabled()){
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createSlot();
                }else{
                    XMILogs xmilogs = XMILogs.getInstance();
                    String message = XMI.I18N.getMessage("logFile.warning.unsupportedExport", 
                            objingElt.getName(), 
                            objingElt.getClass().getSimpleName());
                    xmilogs.writelnInLog(message);
                    GenerationProperties.getInstance().getReportModel().addError(message, objingElt);
                    PartialCreationExportVisitor.this.ecoreElt = null;
                }
            }else {
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createConnectorEnd();
            }
            return null;
        }

        @Override
        @objid ("05193dcc-4583-11e0-b54c-00137279a832")
        public Object visitConstraint(IConstraint objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createConstraint();
            return null;
        }

        @Override
        @objid ("05193dd2-4583-11e0-b54c-00137279a832")
        public Object visitControlFlow(IControlFlow objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createControlFlow();
            return null;
        }

        @Override
        @objid ("051ba027-4583-11e0-b54c-00137279a832")
        public Object visitDataFlow(IDataFlow objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInformationFlow();
            return null;
        }

        @Override
        @objid ("051ba02d-4583-11e0-b54c-00137279a832")
        public Object visitDataStoreNode(IDataStoreNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDataStoreNode();
            return null;
        }

        @Override
        @objid ("051e0284-4583-11e0-b54c-00137279a832")
        public Object visitDataType(IDataType objingElt) {
            IElement obOwner = objingElt.getCompositionOwner();
            
            if (obOwner instanceof ISignal) {
                PartialCreationExportVisitor.this.ecoreElt = null;
            }else{
                if (PrimitiveTypeMapper.isPredefinedType(objingElt)){
                    PartialCreationExportVisitor.this.ecoreElt =  PrimitiveTypeMapper.getEcoreType(objingElt);
                }else if (objingElt.isElementary()){
            
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPrimitiveType();
                }else
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDataType();
            }
            return null;
        }

        @Override
        @objid ("051e028a-4583-11e0-b54c-00137279a832")
        public Object visitDecisionMergeNode(IDecisionMergeNode objingElt) {
            boolean isMergeNode = false;
            boolean isDecisionNode = false;
            if (ObjingModelNavigation.isMergeNode(objingElt))
                isMergeNode = true;
            else if (ObjingModelNavigation.isDecisionNode(objingElt))
                isDecisionNode = true;
            
            ControlNode ecoreNode = null;
            if (isDecisionNode)
                ecoreNode = UMLFactory.eINSTANCE.createDecisionNode();
            else
                ecoreNode = UMLFactory.eINSTANCE.createMergeNode();
            
            // If the DecisionMerge is not only Decision or Merge, we create a
            // special structure:
            // a Merge connected to a Decision by a flow.
            if (!isMergeNode && !isDecisionNode) {
                DecisionNode decisionNode = UMLFactory.eINSTANCE
                        .createDecisionNode();
            
                IActivityEdge typeOfEdge = null;
                ObList<IActivityEdge> objingInc = objingElt.getIncoming();
                ObList<IActivityEdge> objingOut = objingElt.getOutgoing();
            
                if (objingInc.size() > 0) {
                    typeOfEdge = objingInc.get(0);
                } else if (objingOut.size() > 0) {
                    typeOfEdge = objingOut.get(0);
                }
            
                ActivityEdge ecoreFlow = null;
                if (typeOfEdge instanceof IControlFlow)
                    ecoreFlow = UMLFactory.eINSTANCE.createControlFlow();
                else
                    ecoreFlow = UMLFactory.eINSTANCE.createObjectFlow();
            
                IActivity enclosingActivity = (IActivity) ObjingModelNavigation
                        .getEnclosingElement(objingElt, IActivity.class,
                                PartialCreationExportVisitor.this.ownerVisitor);
            
                if (enclosingActivity != null) {
                    Element ecoreActivity = GenerationProperties.getInstance()
                            .getMappedElement(enclosingActivity);
                    if (ecoreActivity instanceof Activity) {
                        Activity owner = (Activity) ecoreActivity;
                        owner.getEdges().add(ecoreFlow);
                    }
                }
            
                ecoreFlow.setSource(ecoreNode);
                ecoreFlow.setTarget(decisionNode);
            }
            
            PartialCreationExportVisitor.this.ecoreElt = ecoreNode;
            return null;
        }

        @Override
        @objid ("052064de-4583-11e0-b54c-00137279a832")
        public Object visitDeepHistoryPseudoState(IDeepHistoryPseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.DEEP_HISTORY_LITERAL);
            return null;
        }

        @Override
        @objid ("052064e4-4583-11e0-b54c-00137279a832")
        public Object visitDependency(IDependency objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2ASSOCIATIONREFERENCE) 
                    || objingElt.isStereotyped(XMIStereotypes.UML2METHODREFERENCE)
                    || objingElt.isStereotyped(XMIStereotypes.UML2STRUCTURALFEATUREREFERENCE)
                    || objingElt.isStereotyped(XMIStereotypes.UML2CLASSIFIERREFERENCE)
                    || objingElt.isStereotyped(XMIStereotypes.UML2ENDCREATIONDATAREFERENCE)
                    || objingElt.isStereotyped(XMIStereotypes.UML2ENDDESTRUCTIONDATAREFERENCE)
                    || objingElt.isStereotyped(XMIStereotypes.UML2EXCEPTIONTYPEREFERENCE)  
                    || objingElt.isStereotyped(XMIStereotypes.UML2EVENT)
                    || objingElt.isStereotyped(ModelerModuleStereotypes.PART)){
                PartialCreationExportVisitor.this.ecoreElt = null;
            }else if (objingElt.isStereotyped(XMIStereotypes.UML2COMPONENTREALIZATION)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createComponentRealization();
            }else if (objingElt.isStereotyped(XMIStereotypes.UML2DEPLOYMENT)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDeployment();
            }else if (objingElt.isStereotyped(XMIStereotypes.UML2PROTOCOLCONFORMANCE)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createProtocolConformance();
            }else if (objingElt.isStereotyped(ModelerModuleStereotypes.SATISFY)
                    ||objingElt.isStereotyped(ModelerModuleStereotypes.VERIFY)
                    ||objingElt.isStereotyped(ModelerModuleStereotypes.DERIVE)
                    ||objingElt.isStereotyped(XMIStereotypes.UML2ABSTRACTION)){
                PartialCreationExportVisitor.this.ecoreElt =  UMLFactory.eINSTANCE.createAbstraction();
            }else{
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDependency();
            }
            return null;
        }

        @Override
        @objid ("0522c738-4583-11e0-b54c-00137279a832")
        public Object visitDictionary(IDictionary objingElt) {
            return null;
        }

        @Override
        @objid ("0525298e-4583-11e0-b54c-00137279a832")
        public Object visitDurationConstraint(IDurationConstraint objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDurationConstraint();
            return null;
        }

        @Override
        @objid ("05252994-4583-11e0-b54c-00137279a832")
        public Object visitElementImport(IElementImport objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createElementImport();
            return null;
        }

        @Override
        @objid ("05278be8-4583-11e0-b54c-00137279a832")
        public Object visitElementRealization(IElementRealization objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createRealization();
            return null;
        }

        @Override
        @objid ("05278bee-4583-11e0-b54c-00137279a832")
        public Object visitEntryPointPseudoState(IEntryPointPseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.ENTRY_POINT_LITERAL);
            return null;
        }

        @Override
        @objid ("0529ee43-4583-11e0-b54c-00137279a832")
        public Object visitEnumeratedPropertyType(IEnumeratedPropertyType objingElt) {
            return null;
        }

        @Override
        @objid ("0529ee49-4583-11e0-b54c-00137279a832")
        public Object visitEnumeration(IEnumeration objingElt) {
            IElement obOwner = objingElt.getCompositionOwner();
            
            if (obOwner instanceof ISignal) {
                PartialCreationExportVisitor.this.ecoreElt = null;
            }else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createEnumeration();
            return null;
        }

        @Override
        @objid ("052c509d-4583-11e0-b54c-00137279a832")
        public Object visitEnumerationLiteral(IEnumerationLiteral objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createEnumerationLiteral();
            return null;
        }

        @Override
        @objid ("052c50a3-4583-11e0-b54c-00137279a832")
        public Object visitEvent(IEvent objingElt) {
            ObEventTypeEnum eventType = objingElt.getKind();
            if (eventType != null){
                switch (eventType){
                case CALL_EVENT :
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCallEvent();
                    break;
                case SIGNAL_EVENT :
                    PartialCreationExportVisitor.this.ecoreElt =  UMLFactory.eINSTANCE.createSignalEvent();
                    break;
                case TIME_EVENT :
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createTimeEvent();
                    break;
                case CHANGE_EVENT :
                    PartialCreationExportVisitor.this.ecoreElt =  UMLFactory.eINSTANCE.createChangeEvent(); 
                    break;
                }
            }
            
            else if (objingElt.isStereotyped(XMIStereotypes.UML2CREATIONEVENT)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCreationEvent();
            }else if (objingElt.isStereotyped(XMIStereotypes.UML2DESTRUCTIONEVENT)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDestructionEvent();
            }else if (objingElt.isStereotyped(XMIStereotypes.UML2EXECUTIONEVENT)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExecutionEvent();
            }else
                PartialCreationExportVisitor.this.ecoreElt = null;
            return null;
        }

        @Override
        @objid ("052eb2fa-4583-11e0-b54c-00137279a832")
        public Object visitExecutionOccurenceSpecification(IExecutionOccurenceSpecification objingElt) {
            return null;
        }

        @Override
        @objid ("05311550-4583-11e0-b54c-00137279a832")
        public Object visitExecutionSpecification(IExecutionSpecification objingElt) {
            return null;
        }

        @Override
        @objid ("05311556-4583-11e0-b54c-00137279a832")
        public Object visitExitPointPseudoState(IExitPointPseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.EXIT_POINT_LITERAL);
            return null;
        }

        @Override
        @objid ("053377aa-4583-11e0-b54c-00137279a832")
        public Object visitExtensionPoint(IExtensionPoint objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExtensionPoint();
            return null;
        }

        @Override
        @objid ("053377b0-4583-11e0-b54c-00137279a832")
        public Object visitFinalState(IFinalState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createFinalState();
            return null;
        }

        @Override
        @objid ("0535da05-4583-11e0-b54c-00137279a832")
        public Object visitFlowFinalNode(IFlowFinalNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createFlowFinalNode();
            return null;
        }

        @Override
        @objid ("0535da0b-4583-11e0-b54c-00137279a832")
        public Object visitForkJoinNode(IForkJoinNode objingElt) {
            boolean isJoinNode = false;
            boolean isForkNode = false;
            if (ObjingModelNavigation.isJoinNode(objingElt))
                isJoinNode = true;
            else if (ObjingModelNavigation.isForkNode(objingElt))
                isForkNode = true;
            
            ControlNode ecoreNode = null;
            if (isForkNode)
                ecoreNode = UMLFactory.eINSTANCE.createForkNode();
            else
                ecoreNode = UMLFactory.eINSTANCE.createJoinNode();
            
            // If the ForkJoin is not only Fork or Join, we create a special
            // structure:
            // a Join connected to a Fork by a flow.
            if (!isJoinNode && !isForkNode) {
                ForkNode forkNode = UMLFactory.eINSTANCE.createForkNode();
            
                IActivityEdge typeOfEdge = null;
                ObList<IActivityEdge> objingInc = objingElt.getIncoming();
                ObList<IActivityEdge> objingOut = objingElt.getOutgoing();
            
                if (objingInc.size() > 0) {
                    typeOfEdge = objingInc.get(0);
                } else if (objingOut.size() > 0) {
                    typeOfEdge = objingOut.get(0);
                }
            
                ActivityEdge ecoreFlow = null;
                if (typeOfEdge instanceof IControlFlow)
                    ecoreFlow = UMLFactory.eINSTANCE.createControlFlow();
                else
                    ecoreFlow = UMLFactory.eINSTANCE.createObjectFlow();
            
                IActivity enclosingActivity = (IActivity) ObjingModelNavigation
                        .getEnclosingElement(objingElt, IActivity.class,
                                PartialCreationExportVisitor.this.ownerVisitor);
            
                if (enclosingActivity != null) {
                    Element ecoreActivity = GenerationProperties.getInstance()
                            .getMappedElement(enclosingActivity);
                    if (ecoreActivity instanceof Activity) {
                        Activity owner = (Activity) ecoreActivity;
                        owner.getEdges().add(ecoreFlow);
                    }
                }
            
                ecoreFlow.setSource(ecoreNode);
                ecoreFlow.setTarget(forkNode);
            }
            
            PartialCreationExportVisitor.this.ecoreElt = ecoreNode;
            return null;
        }

        @Override
        @objid ("05383c62-4583-11e0-b54c-00137279a832")
        public Object visitForkPseudoState(IForkPseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.FORK_LITERAL);
            return null;
        }

        @Override
        @objid ("05383c68-4583-11e0-b54c-00137279a832")
        public Object visitGate(IGate objingElt) {
            // Particular case of a sequence diagram element
            // ecoreElt = UMLFactory.eINSTANCE.createGate();
            return null;
        }

        @Override
        @objid ("053a9ebc-4583-11e0-b54c-00137279a832")
        public Object visitGeneralOrdering(IGeneralOrdering objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createGeneralOrdering();
            return null;
        }

        @Override
        @objid ("053d0112-4583-11e0-b54c-00137279a832")
        public Object visitGeneralization(IGeneralization objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createGeneralization();
            return null;
        }

        @Override
        @objid ("053d0118-4583-11e0-b54c-00137279a832")
        public Object visitInformationFlow(IInformationFlow objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInformationFlow();
            return null;
        }

        @Override
        @objid ("053f636c-4583-11e0-b54c-00137279a832")
        public Object visitInformationItem(IInformationItem objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInformationItem();
            return null;
        }

        @Override
        @objid ("053f6372-4583-11e0-b54c-00137279a832")
        public Object visitInitialNode(IInitialNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInitialNode();
            return null;
        }

        @Override
        @objid ("0541c5c7-4583-11e0-b54c-00137279a832")
        public Object visitInitialPseudoState(IInitialPseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            return null;
        }

        @Override
        @objid ("0541c5cd-4583-11e0-b54c-00137279a832")
        public Object visitInputPin(IInputPin objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2EXPANSIONNODE))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExpansionNode();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2ACTIONINPUTPIN))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createActionInputPin();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2VALUE))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createValuePin();
            else{
                //                if (objingElt.getValue().length() > 0)
                //                    ecoreElt =UMLFactory.eINSTANCE.createValuePin();
                //                else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInputPin();
            }
            return null;
        }

        @Override
        @objid ("05442827-4583-11e0-b54c-00137279a832")
        public Object visitInstance(IInstance objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInstanceSpecification();
            return null;
        }

        @Override
        @objid ("05468a7e-4583-11e0-b54c-00137279a832")
        public Object visitInstanceNode(IInstanceNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCentralBufferNode();
            if (GenerationProperties.getInstance().isRoundtripEnabled()){
                ObjingEAnnotation.setType(PartialCreationExportVisitor.this.ecoreElt, "InstanceNode");
            }
            return null;
        }

        @Override
        @objid ("05468a84-4583-11e0-b54c-00137279a832")
        public Object visitInteraction(IInteraction objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInteraction();
            return null;
        }

        @Override
        @objid ("0548ecd9-4583-11e0-b54c-00137279a832")
        public Object visitInteractionOperand(IInteractionOperand objingElt) {
            // Particular case of a sequence diagram element
            // ecoreElt = UMLFactory.eINSTANCE.createInteractionOperand();
            return null;
        }

        @Override
        @objid ("054b4f2e-4583-11e0-b54c-00137279a832")
        public Object visitInteractionUse(IInteractionUse objingElt) {
            // Particular case of a sequence diagram element
            // ecoreElt = UMLFactory.eINSTANCE.createInteractionUse();
            return null;
        }

        @Override
        @objid ("054b4f34-4583-11e0-b54c-00137279a832")
        public Object visitInterface(IInterface objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInterface();
            return null;
        }

        @Override
        @objid ("054db188-4583-11e0-b54c-00137279a832")
        public Object visitInterfaceRealization(IInterfaceRealization objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInterfaceRealization();
            return null;
        }

        @Override
        @objid ("054db18e-4583-11e0-b54c-00137279a832")
        public Object visitInternalTransition(IInternalTransition objingElt) {
            if (objingElt.getBehaviorEffect() == null){
                Transition result = UMLFactory.eINSTANCE.createTransition();
                result.setKind(TransitionKind.INTERNAL_LITERAL);
                PartialCreationExportVisitor.this.ecoreElt =  result;
            }else{
                PartialCreationExportVisitor.this.ecoreElt =   null;
            }
            return null;
        }

        @Override
        @objid ("055013e4-4583-11e0-b54c-00137279a832")
        public Object visitInterruptibleActivityRegion(IInterruptibleActivityRegion objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInterruptibleActivityRegion();
            return null;
        }

        @Override
        @objid ("055013ea-4583-11e0-b54c-00137279a832")
        public Object visitJoinPseudoState(IJoinPseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.JOIN_LITERAL);
            return UMLFactory.eINSTANCE.createPseudostate();
        }

        @Override
        @objid ("05527641-4583-11e0-b54c-00137279a832")
        public Object visitJunctionPseudoState(IJunctionPseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.JUNCTION_LITERAL);
            return null;
        }

        @Override
        @objid ("0554d896-4583-11e0-b54c-00137279a832")
        public Object visitLifeline(ILifeline objingElt) {
            // Particular case of a sequence diagram element
            // ecoreElt = UMLFactory.eINSTANCE.createLifeline();
            return null;
        }

        @Override
        @objid ("0554d89c-4583-11e0-b54c-00137279a832")
        public Object visitLink(ILink objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInstanceSpecification();
            return null;
        }

        @Override
        @objid ("05573af1-4583-11e0-b54c-00137279a832")
        public Object visitLinkEnd(ILinkEnd objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createSlot();
            return null;
        }

        @Override
        @objid ("05573af7-4583-11e0-b54c-00137279a832")
        public Object visitLocalNote(ILocalNote objingElt) {
            return null;
        }

        @Override
        @objid ("05599d4e-4583-11e0-b54c-00137279a832")
        public Object visitLocalTaggedValue(ILocalTaggedValue objingElt) {
            return null;
        }

        @Override
        @objid ("055bffa4-4583-11e0-b54c-00137279a832")
        public Object visitLoopNode(ILoopNode objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createLoopNode();
            return null;
        }

        @Override
        @objid ("055bffaa-4583-11e0-b54c-00137279a832")
        public Object visitManifestation(IManifestation objingElt) {
            if (ObjingModelNavigation.isManifestationMappable(objingElt))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createManifestation();
            else{
                String message = XMI.I18N.getMessage("logFile.warning.export.noumlmanifestation", objingElt.getName());
                XMILogs.getInstance().writelnInLog(message);
                GenerationProperties.getInstance().getReportModel().addError(message, objingElt);
                PartialCreationExportVisitor.this.ecoreElt = null;
            }
            return null;
        }

        @Override
        @objid ("055e6202-4583-11e0-b54c-00137279a832")
        public Object visitMessage(IMessage objingElt) {
            // Particular case of a sequence diagram element
            // ecoreElt = UMLFactory.eINSTANCE.createMessage();
            return null;
        }

        @Override
        @objid ("0560c458-4583-11e0-b54c-00137279a832")
        public Object visitMessageFlow(IMessageFlow objingElt) {
            return null;
        }

        @Override
        @objid ("0560c45e-4583-11e0-b54c-00137279a832")
        public Object visitNamespaceUse(INamespaceUse objingElt) {
            return null;
        }

        @Override
        @objid ("056326b2-4583-11e0-b54c-00137279a832")
        public Object visitNode(INode objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2DEVICE))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDevice();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2EXECUTIONENVIRONMENT))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExecutionEnvironment();
            else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createNode();
            return null;
        }

        @Override
        @objid ("056326b8-4583-11e0-b54c-00137279a832")
        public Object visitNote(INote objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createComment();
            return null;
        }

        @Override
        @objid ("0565890e-4583-11e0-b54c-00137279a832")
        public Object visitNoteType(INoteType objingElt) {
            return null;
        }

        @Override
        @objid ("0567eb66-4583-11e0-b54c-00137279a832")
        public Object visitObjectFlow(IObjectFlow objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2EXCEPTIONHANDLER))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExceptionHandler();
            else 
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createObjectFlow();
            return null;
        }

        @Override
        @objid ("0567eb6c-4583-11e0-b54c-00137279a832")
        public Object visitOpaqueAction(IOpaqueAction objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2VALUESPECIFICATIONACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createValueSpecificationAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2CREATEOBJECTACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCreateObjectAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2CREATELINKACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCreateLinkAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2READLINKACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReadLinkAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2DESTROYLINKACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDestroyLinkAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2CLEARASSOCIATIONACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createClearAssociationAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2ADDSTRUCTURALFEATUREVALUEACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAddStructuralFeatureValueAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2READSTRUCTURALFEATUREACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReadStructuralFeatureAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2READEXTENTACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReadExtentAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2DESTROYOBJECTACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createDestroyObjectAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2CREATELINKACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createCreateLinkAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2ADDVARIABLEVALUEACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createAddVariableValueAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2CLEARSTRUCTURALFEATUREACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createClearStructuralFeatureAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2CLEARVARIABLEACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createClearVariableAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2RAISEEXCEPTIONACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createRaiseExceptionAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2READISCLASSIFIEROBJECTACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReadIsClassifiedObjectAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2READLINKOBJECTENDACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReadLinkObjectEndAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2READLINKOBJECTENDQUALIFIERACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReadLinkObjectEndQualifierAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2READSELFACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReadSelfAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2READVARIABLEACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReadVariableAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2RECLASSIFYOBJECTACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReclassifyObjectAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2REDUCEACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReduceAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2REMOVESTRUCTURALFEATUREACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createRemoveStructuralFeatureValueAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2REMOVEVARIABLEVALUEACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createRemoveVariableValueAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2REPLYACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReplyAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2SENDOBJECTACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createSendObjectAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2STARTCLASSIFIERBEHAVIORACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createStartClassifierBehaviorAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2TESTIDENTITYACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createTestIdentityAction();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2UNMARSHALLACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createUnmarshallAction();
            else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createOpaqueAction();
            return null;
        }

        @Override
        @objid ("056a4dc0-4583-11e0-b54c-00137279a832")
        public Object visitOpaqueBehavior(IOpaqueBehavior objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createOpaqueBehavior();
            return null;
        }

        @Override
        @objid ("056a4dc6-4583-11e0-b54c-00137279a832")
        public Object visitOperation(IOperation objingElt) {
            IElement objingOwner = objingElt.getCompositionOwner();
            
            if (objingOwner instanceof IActor
                    || objingOwner instanceof IUseCase
                    || objingOwner instanceof ISignal) {
                PartialCreationExportVisitor.this.ecoreElt = null;
            }else{
                if (objingElt.isStereotyped(XMIStereotypes.UML2RECEPTION)){
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createReception();
                }else if (objingElt.isStereotyped(XMIStereotypes.UML2REDEFINABLETEMPLATESIGNATURE)){
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createRedefinableTemplateSignature();
                }else if (objingElt.isStereotyped(XMIStereotypes.UML2TEMPLATESIGNATURE)){
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createTemplateSignature();
                }else{
            
                    PartialCreationExportVisitor.this.ecoreElt =  UMLFactory.eINSTANCE.createOperation();
                }
            }
            return null;
        }

        @Override
        @objid ("056cb01c-4583-11e0-b54c-00137279a832")
        public Object visitOutputPin(IOutputPin objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2EXPANSIONNODE))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExpansionNode();
            else{
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createOutputPin();
            }
            return null;
        }

        @Override
        @objid ("056f1274-4583-11e0-b54c-00137279a832")
        public Object visitPackage(IPackage objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPackage();
            return null;
        }

        @Override
        @objid ("056f127a-4583-11e0-b54c-00137279a832")
        public Object visitPackageImport(IPackageImport objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPackageImport();
            return null;
        }

        @Override
        @objid ("057174ce-4583-11e0-b54c-00137279a832")
        public Object visitPackageMerge(IPackageMerge objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPackageMerge();
            return null;
        }

        @Override
        @objid ("057174d4-4583-11e0-b54c-00137279a832")
        public Object visitParameter(IParameter objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2CLASSIFIERTEMPLATEPARAMETER))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createClassifierTemplateParameter();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2OPERATIONTEMPLATEPARAMETER))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createOperationTemplateParameter();
            else    
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createParameter();
            return null;
        }

        @Override
        @objid ("0573d72a-4583-11e0-b54c-00137279a832")
        public Object visitPartDecomposition(IPartDecomposition objingElt) {
            // Particular case of a sequence diagram element
            // ecoreElt = UMLFactory.eINSTANCE.createPartDecomposition();
            return null;
        }

        @Override
        @objid ("05763982-4583-11e0-b54c-00137279a832")
        public Object visitPort(IPort objingElt) {
            IElement objOwner = ObjingModelNavigation.getBindableInstanceOwner(objingElt);
            
            if ( objOwner instanceof IInstance)
                PartialCreationExportVisitor.this.ecoreElt =  UMLFactory.eINSTANCE.createSlot();
            else{
                IModelElement representedFeature = objingElt.getRepresentedFeature();
                if ((representedFeature != null) && (representedFeature instanceof IPort) && !(representedFeature.getCompositionOwner() instanceof IInstance)){
                    PartialCreationExportVisitor.this.ecoreElt = GenerationProperties.getInstance().getMappedElement(representedFeature);
                }else{
                    PartialCreationExportVisitor.this.ecoreElt =  UMLFactory.eINSTANCE.createPort();
                }
            }
            return null;
        }

        @Override
        @objid ("05763988-4583-11e0-b54c-00137279a832")
        public Object visitProject(IProject objingElt) {
            return null;
        }

        @Override
        @objid ("05789bde-4583-11e0-b54c-00137279a832")
        public Object visitProperty(IProperty objingElt) {
            return null;
        }

        @Override
        @objid ("057afe36-4583-11e0-b54c-00137279a832")
        public Object visitPropertyEnumerationLitteral(IPropertyEnumerationLitteral objingElt) {
            return null;
        }

        @Override
        @objid ("057afe3c-4583-11e0-b54c-00137279a832")
        public Object visitPropertySet(IPropertySet objingElt) {
            return null;
        }

        @Override
        @objid ("057d6091-4583-11e0-b54c-00137279a832")
        public Object visitPropertyType(IPropertyType objingElt) {
            return null;
        }

        @Override
        @objid ("057d6097-4583-11e0-b54c-00137279a832")
        public Object visitPropertyValue(IPropertyValue objingElt) {
            return null;
        }

        @Override
        @objid ("057fc2ee-4583-11e0-b54c-00137279a832")
        public Object visitPropertyValueSet(IPropertyValueSet objingElt) {
            return null;
        }

        @Override
        @objid ("05822544-4583-11e0-b54c-00137279a832")
        public Object visitProvidedInterface(IProvidedInterface objingElt) {
            IPort owner = objingElt.getProviding();
            if (owner.getBase() == null){
                PartialCreationExportVisitor.this.ecoreElt =  null;
            }else{
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInterfaceRealization();
            }
            return null;
        }

        @Override
        @objid ("058487a0-4583-11e0-b54c-00137279a832")
        public Object visitRaisedException(IRaisedException objingElt) {
            return null;
        }

        @Override
        @objid ("0586e9f8-4583-11e0-b54c-00137279a832")
        public Object visitRegion(IRegion objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createRegion();
            return null;
        }

        @Override
        @objid ("0586e9fe-4583-11e0-b54c-00137279a832")
        public Object visitRequiredInterface(IRequiredInterface objingElt) {
            return null;
        }

        @Override
        @objid ("05894c52-4583-11e0-b54c-00137279a832")
        public Object visitRequirement(IRequirement objingElt) {
            GenerationProperties.getInstance();
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createClass();
            return null;
        }

        @Override
        @objid ("058baeac-4583-11e0-b54c-00137279a832")
        public Object visitRequirementContainer(IRequirementContainer objingElt) {
            Package result  = UMLFactory.eINSTANCE.createPackage();
            ObjingEAnnotation.setRequirementContainer(result, true);
            return null;
        }

        @Override
        @objid ("058baeb2-4583-11e0-b54c-00137279a832")
        public Object visitSendSignalAction(ISendSignalAction objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2BROADCASTSIGNALACTION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createBroadcastSignalAction();
            else    
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createSendSignalAction();
            return null;
        }

        @Override
        @objid ("058e1106-4583-11e0-b54c-00137279a832")
        public Object visitShallowHistoryPseudoState(IShallowHistoryPseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.SHALLOW_HISTORY_LITERAL);
            return null;
        }

        @Override
        @objid ("058e110c-4583-11e0-b54c-00137279a832")
        public Object visitSignal(ISignal objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createSignal();
            return null;
        }

        @Override
        @objid ("05907365-4583-11e0-b54c-00137279a832")
        public Object visitState(IState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createState();
            return null;
        }

        @Override
        @objid ("0592d5ba-4583-11e0-b54c-00137279a832")
        public Object visitStateInvariant(IStateInvariant objingElt) {
            // Particular case of a sequence diagram element
            // ecoreElt = UMLFactory.eINSTANCE.createStateInvariant();
            return null;
        }

        @Override
        @objid ("0592d5c0-4583-11e0-b54c-00137279a832")
        public Object visitStateMachine(IStateMachine objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createStateMachine();
            return null;
        }

        @Override
        @objid ("0592d5c6-4583-11e0-b54c-00137279a832")
        public Object visitStereotype(IStereotype objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = null;
            return null;
        }

        @Override
        @objid ("05953814-4583-11e0-b54c-00137279a832")
        public Object visitStructuredActivityNode(IStructuredActivityNode objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2EXPANSIONREGION))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExpansionRegion();
            else if (objingElt.isStereotyped(XMIStereotypes.UML2SEQUENCENODE))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createSequenceNode();
            else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createStructuredActivityNode();
            return null;
        }

        @Override
        @objid ("0595381a-4583-11e0-b54c-00137279a832")
        public Object visitSubstitution(ISubstitution objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createSubstitution();
            return null;
        }

        @Override
        @objid ("05979a72-4583-11e0-b54c-00137279a832")
        public Object visitTagParameter(ITagParameter objingElt) {
            return null;
        }

        @Override
        @objid ("059c5f22-4583-11e0-b54c-00137279a832")
        public Object visitTagType(ITagType objingElt) {
            return null;
        }

        @Override
        @objid ("059ec17e-4583-11e0-b54c-00137279a832")
        public Object visitTaggedValue(ITaggedValue objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = null;
            return null;
        }

        @Override
        @objid ("05a123d6-4583-11e0-b54c-00137279a832")
        public Object visitTemplateBinding(ITemplateBinding objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createTemplateBinding();
            return null;
        }

        @Override
        @objid ("05a123dc-4583-11e0-b54c-00137279a832")
        public Object visitTemplateParameter(ITemplateParameter objingElt) {
            if (objingElt.isStereotyped(XMIStereotypes.UML2CONNECTABLEELEMENTTEMPLATEPARAMETER)){
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createConnectableElementTemplateParameter();
            }else
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createTemplateParameter();
            return null;
        }

        @Override
        @objid ("05a38634-4583-11e0-b54c-00137279a832")
        public Object visitTemplateParameterSubstitution(ITemplateParameterSubstitution objingElt) {
            Element ecoreOwner = GenerationProperties.getInstance().getMappedElement(objingElt.getCompositionOwner());
            
            if (ecoreOwner instanceof TemplateBinding)   
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createTemplateParameterSubstitution();
            else 
                PartialCreationExportVisitor.this.ecoreElt = null;
            return null;
        }

        @Override
        @objid ("05a5e88a-4583-11e0-b54c-00137279a832")
        public Object visitTerm(ITerm objingElt) {
            return null;
        }

        @Override
        @objid ("05a5e890-4583-11e0-b54c-00137279a832")
        public Object visitTerminatePseudoState(ITerminatePseudoState objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createPseudostate();
            ((Pseudostate) PartialCreationExportVisitor.this.ecoreElt).setKind(PseudostateKind.TERMINATE_LITERAL);
            return null;
        }

        @Override
        @objid ("05a84ae8-4583-11e0-b54c-00137279a832")
        public Object visitTransition(ITransition objingElt) {
            if (!( objingElt instanceof IInternalTransition)){
                if (ObjingModelNavigation.isProtocolTransition(objingElt))
                    PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createProtocolTransition();
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createTransition();
            }
            PartialCreationExportVisitor.this.ecoreElt = null;
            return null;
        }

        @Override
        @objid ("05aaad3e-4583-11e0-b54c-00137279a832")
        public Object visitUsage(IUsage objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createUsage();
            return null;
        }

        @Override
        @objid ("05aaad44-4583-11e0-b54c-00137279a832")
        public Object visitUseCase(IUseCase objingElt) {
            PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createUseCase();
            return null;
        }

        @Override
        @objid ("05ad0f9c-4583-11e0-b54c-00137279a832")
        public Object visitUseCaseDependency(IUseCaseDependency objingElt) {
            if (ObjingModelNavigation.isStereotyped(objingElt, XMI.I18N
                    .getString("objing.java.stereotype.extend")))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createExtend();
            else if (ObjingModelNavigation.isStereotyped(objingElt, XMI.I18N
                    .getString("objing.java.stereotype.include")))
                PartialCreationExportVisitor.this.ecoreElt = UMLFactory.eINSTANCE.createInclude();
            else
                PartialCreationExportVisitor.this.ecoreElt = null;
            return null;
        }

        @Override
        @objid ("7f8660ee-1a74-11e1-8103-0027103f347d")
        public Object visitProfile(final IProfile objingElt) {
            return null;
        }

        @objid ("4871c5d9-5d30-11e1-bceb-0027103f347d")
        public CreationExportMapper() {
            super();
        }

    }

}
