/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.generation;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.Element;

@objid ("05af71f2-4583-11e0-b54c-00137279a832")
public class PartialExportMap {
    @objid ("05af71f3-4583-11e0-b54c-00137279a832")
    private static PartialExportMap theSingleInstance;

    @objid ("05af71f4-4583-11e0-b54c-00137279a832")
    private Map<String, Element> modelMap;


    @objid ("05af71f8-4583-11e0-b54c-00137279a832")
    private PartialExportMap() {
        modelMap = new HashMap<String, Element>();
    }

    @objid ("05af71fa-4583-11e0-b54c-00137279a832")
    public static PartialExportMap getInstance() {
        if (theSingleInstance == null)
            theSingleInstance = new PartialExportMap();
        return theSingleInstance;
    }

    @objid ("05af71fe-4583-11e0-b54c-00137279a832")
    public void clear() {
        modelMap.clear();
    }

    @objid ("05b1d44c-4583-11e0-b54c-00137279a832")
    public boolean containsKey(String key) {
        return modelMap.containsKey(key);
    }

    @objid ("05b1d451-4583-11e0-b54c-00137279a832")
    public Element get(String key) {
        return modelMap.get(key);
    }

    @objid ("05b1d456-4583-11e0-b54c-00137279a832")
    public boolean isEmpty() {
        return modelMap.isEmpty();
    }

    @objid ("05b1d45a-4583-11e0-b54c-00137279a832")
    public Set<String> keySet() {
        return modelMap.keySet();
    }

    @objid ("05b436aa-4583-11e0-b54c-00137279a832")
    public int size() {
        return modelMap.size();
    }

    @objid ("05b436ae-4583-11e0-b54c-00137279a832")
    public Collection<Element> values() {
        return modelMap.values();
    }

    @objid ("05b69900-4583-11e0-b54c-00137279a832")
    public boolean containsValue(Element val) {
        return modelMap.containsValue(val);
    }

    @objid ("05b69905-4583-11e0-b54c-00137279a832")
    public Element put(String key, Element value) {
        return modelMap.put(key, value);
    }

    @objid ("05b6990b-4583-11e0-b54c-00137279a832")
    public Element remove(String key) {
        return modelMap.remove(key);
    }

}
