/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.generation;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.Element;

@objid ("05bdc00e-4583-11e0-b54c-00137279a832")
public class TotalExportMap {
    @objid ("05bdc00f-4583-11e0-b54c-00137279a832")
    private static TotalExportMap theSingleInstance;

    @objid ("05bdc010-4583-11e0-b54c-00137279a832")
    private Map<String, Element> modelMap;


    @objid ("05bdc014-4583-11e0-b54c-00137279a832")
    private TotalExportMap() {
        modelMap = new HashMap<String, Element>();
    }

    @objid ("05bdc016-4583-11e0-b54c-00137279a832")
    public static TotalExportMap getInstance() {
        if (theSingleInstance == null)
            theSingleInstance = new TotalExportMap();
        return theSingleInstance;
    }

    @objid ("05bdc01a-4583-11e0-b54c-00137279a832")
    public void clear() {
        modelMap.clear();
    }

    @objid ("05bdc01c-4583-11e0-b54c-00137279a832")
    public boolean containsKey(String key) {
        return modelMap.containsKey(key);
    }

    @objid ("05c0226a-4583-11e0-b54c-00137279a832")
    public Element get(String key) {
        return modelMap.get(key);
    }

    @objid ("05c0226f-4583-11e0-b54c-00137279a832")
    public boolean isEmpty() {
        return modelMap.isEmpty();
    }

    @objid ("05c02273-4583-11e0-b54c-00137279a832")
    public Set<String> keySet() {
        return modelMap.keySet();
    }

    @objid ("05c284c6-4583-11e0-b54c-00137279a832")
    public int size() {
        return modelMap.size();
    }

    @objid ("05c284ca-4583-11e0-b54c-00137279a832")
    public Collection<Element> values() {
        return modelMap.values();
    }

    @objid ("05c284d0-4583-11e0-b54c-00137279a832")
    public boolean containsValue(Element val) {
        return modelMap.containsValue(val);
    }

    @objid ("05c4e720-4583-11e0-b54c-00137279a832")
    public Element put(String key, Element value) {
        return modelMap.put(key, value);
    }

    @objid ("05c4e726-4583-11e0-b54c-00137279a832")
    public Element remove(String key) {
        return modelMap.remove(key);
    }

}
