/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.generation;

import com.modeliosoft.modelio.api.model.analyst.IDictionary;
import com.modeliosoft.modelio.api.model.analyst.IEnumeratedPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IProperty;
import com.modeliosoft.modelio.api.model.analyst.IPropertyEnumerationLitteral;
import com.modeliosoft.modelio.api.model.analyst.IPropertySet;
import com.modeliosoft.modelio.api.model.analyst.IPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValue;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValueSet;
import com.modeliosoft.modelio.api.model.analyst.IRequirement;
import com.modeliosoft.modelio.api.model.analyst.IRequirementContainer;
import com.modeliosoft.modelio.api.model.analyst.IRequirementElement;
import com.modeliosoft.modelio.api.model.analyst.ITerm;
import com.modeliosoft.modelio.api.model.extension.IProject;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptCallEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptChangeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptTimeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityParameterNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallBehaviorAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallOperationAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICentralBufferNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IClause;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IConditionalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IControlFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDataStoreNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDecisionMergeNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IFlowFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IForkJoinNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInitialNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInstanceNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInterruptibleActivityRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ILoopNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IMessageFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IObjectFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOutputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IValuePin;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehaviorParameter;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IOpaqueBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ICombinedFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IDurationConstraint;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionOccurenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGate;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGeneralOrdering;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionOperand;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionUse;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IPartDecomposition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IChoicePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IConnectionPointReference;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IDeepHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEntryPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IExitPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IFinalState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IForkPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInitialPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInternalTransition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJoinPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJunctionPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IShallowHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateInvariant;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITerminatePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.information.IInformationFlow;
import com.modeliosoft.modelio.api.model.uml.information.IInformationItem;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IAbstraction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IConstraint;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElementRealization;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalNote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalTaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INoteType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IUsage;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IAttribute;
import com.modeliosoft.modelio.api.model.uml.statik.IAttributeLink;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IBinding;
import com.modeliosoft.modelio.api.model.uml.statik.IClass;
import com.modeliosoft.modelio.api.model.uml.statik.IClassAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaboration;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.model.uml.statik.IConnector;
import com.modeliosoft.modelio.api.model.uml.statik.IConnectorEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IDataFlow;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IElementImport;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralization;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IManifestation;
import com.modeliosoft.modelio.api.model.uml.statik.INamespaceUse;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageImport;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.model.uml.statik.IProvidedInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IRaisedException;
import com.modeliosoft.modelio.api.model.uml.statik.IRequiredInterface;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameterSubstitution;
import com.modeliosoft.modelio.api.model.uml.usecase.IActor;
import com.modeliosoft.modelio.api.model.uml.usecase.IExtensionPoint;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCaseDependency;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.gui.ProgressBarComposite;
import com.modeliosoft.modelio.xmi.model.objing.*;

@objid ("05c74976-4583-11e0-b54c-00137279a832")
public class XMIExportBehavior implements IParseModelBehavior {
    @objid ("05c74977-4583-11e0-b54c-00137279a832")
    private ExportModel exportModel;

    @objid ("05c74978-4583-11e0-b54c-00137279a832")
    private ProgressBarComposite currentProgressBar;


    @objid ("05c74979-4583-11e0-b54c-00137279a832")
    public XMIExportBehavior() {
        this.exportModel = new ExportModel();
    }

    @objid ("05c7497b-4583-11e0-b54c-00137279a832")
    public XMIExportBehavior(ProgressBarComposite progressBar) {
        this.currentProgressBar = progressBar;
        this.exportModel = new ExportModel(progressBar);
    }

    @objid ("05c7497e-4583-11e0-b54c-00137279a832")
    public ProgressBarComposite getProgressBar() {
        return this.currentProgressBar;
    }

    @objid ("05c74982-4583-11e0-b54c-00137279a832")
    public void visitActivityFinalNode(final IActivityFinalNode param) {
        OActivityFinalNode element = new OActivityFinalNode(param);
        this.exportModel.export(element);
    }

    @objid ("05c9abd0-4583-11e0-b54c-00137279a832")
    public void visitAssociationEnd(final IAssociationEnd param) {
        OAssociationEnd element = new OAssociationEnd(param);
        this.exportModel.export(element);
    }

    @objid ("05c9abd3-4583-11e0-b54c-00137279a832")
    public void visitAttribute(final IAttribute param) {
        OAttribute element = new OAttribute(param);
        this.exportModel.export(element);
    }

    @objid ("05c9abd6-4583-11e0-b54c-00137279a832")
    public void visitClass(final IClass param) {
        OClass element = new OClass(param);
        this.exportModel.export(element);
    }

    @objid ("05c9abd9-4583-11e0-b54c-00137279a832")
    public void visitPackage(final IPackage param) {
        OPackage element = new OPackage(param);
        this.exportModel.export(element);
    }

    @objid ("05c9abdc-4583-11e0-b54c-00137279a832")
    public void visitTaggedValue(final ITaggedValue param) {
        OTaggedValue element = new OTaggedValue(param);
        this.exportModel.export(element);
    }

    @objid ("05c9abdf-4583-11e0-b54c-00137279a832")
    public void visitAssociation(final IAssociation param) {
        OAssociation element = new OAssociation(param);
        this.exportModel.export(element);
    }

    @objid ("05cc0e2a-4583-11e0-b54c-00137279a832")
    public void visitOperation(final IOperation param) {
        OOperation element = new OOperation(param);
        this.exportModel.export(element);
    }

    @objid ("05cc0e2d-4583-11e0-b54c-00137279a832")
    public void visitParameter(final IParameter param) {
        OParameter element = new OParameter(param);
        this.exportModel.export(element);
    }

    @objid ("05cc0e30-4583-11e0-b54c-00137279a832")
    public void visitActor(final IActor param) {
        OActor element = new OActor(param);
        this.exportModel.export(element);
    }

    @objid ("05cc0e33-4583-11e0-b54c-00137279a832")
    public void visitComponent(final IComponent param) {
        OComponent element = new OComponent(param);
        this.exportModel.export(element);
    }

    @objid ("05ce7084-4583-11e0-b54c-00137279a832")
    public void visitGeneralization(final IGeneralization param) {
        OGeneralization element = new OGeneralization(param);
        this.exportModel.export(element);
    }

    @objid ("05ce7087-4583-11e0-b54c-00137279a832")
    public void visitElementImport(final IElementImport param) {
        OElementImport element = new OElementImport(param);
        this.exportModel.export(element);
    }

    @objid ("05ce708a-4583-11e0-b54c-00137279a832")
    public void visitRaisedException(final IRaisedException param) {
        ORaisedException element = new ORaisedException(param);
        this.exportModel.export(element);
    }

    @objid ("05ce708d-4583-11e0-b54c-00137279a832")
    public void visitRegion(final IRegion param) {
        ORegion element = new ORegion(param);
        this.exportModel.export(element);
    }

    @objid ("05ce7090-4583-11e0-b54c-00137279a832")
    public void visitDataType(final IDataType param) {
        ODataType element = new ODataType(param);
        this.exportModel.export(element);
    }

    @objid ("05d0d2de-4583-11e0-b54c-00137279a832")
    public void visitInterface(final IInterface param) {
        OInterface element = new OInterface(param);
        this.exportModel.export(element);
    }

    @objid ("05d0d2e1-4583-11e0-b54c-00137279a832")
    public void visitEnumeration(final IEnumeration param) {
        OEnumeration element = new OEnumeration(param);
        this.exportModel.export(element);
    }

    @objid ("05d0d2e4-4583-11e0-b54c-00137279a832")
    public void visitEnumerationLiteral(final IEnumerationLiteral param) {
        OEnumerationLiteral element = new OEnumerationLiteral(param);
        this.exportModel.export(element);
    }

    @objid ("05d0d2e7-4583-11e0-b54c-00137279a832")
    public void visitDependency(final IDependency param) {
        ODependency element = new ODependency(param);
        this.exportModel.export(element);
    }

    @objid ("05d0d2ea-4583-11e0-b54c-00137279a832")
    public void visitNote(final INote param) {
        ONote element = new ONote(param);
        this.exportModel.export(element);
    }

    @objid ("05d33538-4583-11e0-b54c-00137279a832")
    public void visitConstraint(final IConstraint param) {
        OConstraint element = new OConstraint(param);
        this.exportModel.export(element);
    }

    @objid ("05d3353b-4583-11e0-b54c-00137279a832")
    public void visitPackageImport(final IPackageImport param) {
        OPackageImport element = new OPackageImport(param);
        this.exportModel.export(element);
    }

    @objid ("05d3353e-4583-11e0-b54c-00137279a832")
    public void visitPackageMerge(final IPackageMerge param) {
        OPackageMerge element = new OPackageMerge(param);
        this.exportModel.export(element);
    }

    @objid ("05d33541-4583-11e0-b54c-00137279a832")
    public void visitUsage(final IUsage param) {
        OUsage element = new OUsage(param);
        this.exportModel.export(element);
    }

    @objid ("05d33544-4583-11e0-b54c-00137279a832")
    public void visitAbstraction(final IAbstraction param) {
        OAbstraction element = new OAbstraction(param);
        this.exportModel.export(element);
    }

    @objid ("05d59792-4583-11e0-b54c-00137279a832")
    public void visitInterfaceRealization(final IInterfaceRealization param) {
        OInterfaceRealization element = new OInterfaceRealization(param);
        this.exportModel.export(element);
    }

    @objid ("05d59795-4583-11e0-b54c-00137279a832")
    public void visitDataFlow(final IDataFlow param) {
        ODataFlow element = new ODataFlow(param);
        this.exportModel.export(element);
    }

    @objid ("05d59798-4583-11e0-b54c-00137279a832")
    public void visitAcceptCallEventAction(final IAcceptCallEventAction param) {
        OAcceptCallEventAction element = new OAcceptCallEventAction(param);
        this.exportModel.export(element);
    }

    @objid ("05d5979b-4583-11e0-b54c-00137279a832")
    public void visitAcceptChangeEventAction(final IAcceptChangeEventAction param) {
        OAcceptChangeEventAction element = new OAcceptChangeEventAction(param);
        this.exportModel.export(element);
    }

    @objid ("05d5979e-4583-11e0-b54c-00137279a832")
    public void visitAcceptSignalAction(final IAcceptSignalAction param) {
        OAcceptSignalAction element = new OAcceptSignalAction(param);
        this.exportModel.export(element);
    }

    @objid ("05d7f9ee-4583-11e0-b54c-00137279a832")
    public void visitAcceptTimeEventAction(final IAcceptTimeEventAction param) {
        OAcceptTimeEventAction element = new OAcceptTimeEventAction(param);
        this.exportModel.export(element);
    }

    @objid ("05d7f9f1-4583-11e0-b54c-00137279a832")
    public void visitActivity(final IActivity param) {
        OActivity element = new OActivity(param);
        this.exportModel.export(element);
    }

    @objid ("05d7f9f4-4583-11e0-b54c-00137279a832")
    public void visitActivityParameterNode(final IActivityParameterNode param) {
        OActivityParameterNode element = new OActivityParameterNode(param);
        this.exportModel.export(element);
    }

    @objid ("05d7f9f7-4583-11e0-b54c-00137279a832")
    public void visitActivityPartition(final IActivityPartition param) {
        OActivityPartition element = new OActivityPartition(param);
        this.exportModel.export(element);
    }

    @objid ("05da5c46-4583-11e0-b54c-00137279a832")
    public void visitArtifact(final IArtifact param) {
        OArtifact element = new OArtifact(param);
        this.exportModel.export(element);
    }

    @objid ("05da5c49-4583-11e0-b54c-00137279a832")
    public void visitAttributeLink(final IAttributeLink param) {
        OAttributeLink element = new OAttributeLink(param);
        this.exportModel.export(element);
    }

    @objid ("05da5c4c-4583-11e0-b54c-00137279a832")
    public void visitBehaviorParameter(final IBehaviorParameter param) {
        OBehaviorParameter element = new OBehaviorParameter(param);
        this.exportModel.export(element);
    }

    @objid ("05da5c4f-4583-11e0-b54c-00137279a832")
    public void visitBindableInstance(final IBindableInstance param) {
        OBindableInstance element = new OBindableInstance(param);
        this.exportModel.export(element);
    }

    @objid ("05dcbea0-4583-11e0-b54c-00137279a832")
    public void visitBinding(final IBinding param) {
        OBinding element = new OBinding(param);
        this.exportModel.export(element);
    }

    @objid ("05dcbea3-4583-11e0-b54c-00137279a832")
    public void visitCallBehaviorAction(final ICallBehaviorAction param) {
        OCallBehaviorAction element = new OCallBehaviorAction(param);
        this.exportModel.export(element);
    }

    @objid ("05dcbea6-4583-11e0-b54c-00137279a832")
    public void visitCallOperationAction(final ICallOperationAction param) {
        OCallOperationAction element = new OCallOperationAction(param);
        this.exportModel.export(element);
    }

    @objid ("05dcbea9-4583-11e0-b54c-00137279a832")
    public void visitCentralBufferNode(final ICentralBufferNode param) {
        OCentralBufferNode element = new OCentralBufferNode(param);
        this.exportModel.export(element);
    }

    @objid ("05df20fa-4583-11e0-b54c-00137279a832")
    public void visitChoicePseudoState(final IChoicePseudoState param) {
        OChoicePseudoState element = new OChoicePseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("05df20fd-4583-11e0-b54c-00137279a832")
    public void visitClassAssociation(final IClassAssociation param) {
        OClassAssociation element = new OClassAssociation(param);
        this.exportModel.export(element);
    }

    @objid ("05df2100-4583-11e0-b54c-00137279a832")
    public void visitClause(final IClause param) {
        OClause element = new OClause(param);
        this.exportModel.export(element);
    }

    @objid ("05df2103-4583-11e0-b54c-00137279a832")
    public void visitCollaboration(final ICollaboration param) {
        OCollaboration element = new OCollaboration(param);
        this.exportModel.export(element);
    }

    @objid ("05e18354-4583-11e0-b54c-00137279a832")
    public void visitCollaborationUse(final ICollaborationUse param) {
        OCollaborationUse element = new OCollaborationUse(param);
        this.exportModel.export(element);
    }

    @objid ("05e18357-4583-11e0-b54c-00137279a832")
    public void visitCombinedFragment(final ICombinedFragment param) {
        OCombinedFragment element = new OCombinedFragment(param);
        this.exportModel.export(element);
    }

    @objid ("05e1835a-4583-11e0-b54c-00137279a832")
    public void visitConditionalNode(final IConditionalNode param) {
        OConditionalNode element = new OConditionalNode(param);
        this.exportModel.export(element);
    }

    @objid ("05e1835d-4583-11e0-b54c-00137279a832")
    public void visitConnectionPointReference(final IConnectionPointReference param) {
        OConnectionPointReference element = new OConnectionPointReference(
                param);
        this.exportModel.export(element);
    }

    @objid ("05e3e5ae-4583-11e0-b54c-00137279a832")
    public void visitConnector(final IConnector param) {
        OConnector element = new OConnector(param);
        this.exportModel.export(element);
    }

    @objid ("05e3e5b1-4583-11e0-b54c-00137279a832")
    public void visitConnectorEnd(final IConnectorEnd param) {
        OConnectorEnd element = new OConnectorEnd(param);
        this.exportModel.export(element);
    }

    @objid ("05e3e5b4-4583-11e0-b54c-00137279a832")
    public void visitControlFlow(final IControlFlow param) {
        OControlFlow element = new OControlFlow(param);
        this.exportModel.export(element);
    }

    @objid ("05e64808-4583-11e0-b54c-00137279a832")
    public void visitDataStoreNode(final IDataStoreNode param) {
        ODataStoreNode element = new ODataStoreNode(param);
        this.exportModel.export(element);
    }

    @objid ("05e6480b-4583-11e0-b54c-00137279a832")
    public void visitDecisionMergeNode(final IDecisionMergeNode param) {
        ODecisionMergeNode element = new ODecisionMergeNode(param);
        this.exportModel.export(element);
    }

    @objid ("05eb0cbc-4583-11e0-b54c-00137279a832")
    public void visitDeepHistoryPseudoState(final IDeepHistoryPseudoState param) {
        ODeepHistoryPseudoState element = new ODeepHistoryPseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("05eb0cbf-4583-11e0-b54c-00137279a832")
    public void visitDictionary(final IDictionary param) {
        ODictionary element = new ODictionary(param);
        this.exportModel.export(element);
    }

    @objid ("05eb0cc2-4583-11e0-b54c-00137279a832")
    public void visitDurationConstraint(final IDurationConstraint param) {
        ODurationConstraint element = new ODurationConstraint(param);
        this.exportModel.export(element);
    }

    @objid ("05ed6f16-4583-11e0-b54c-00137279a832")
    public void visitElementRealization(final IElementRealization param) {
        OElementRealization element = new OElementRealization(param);
        this.exportModel.export(element);
    }

    @objid ("05ed6f19-4583-11e0-b54c-00137279a832")
    public void visitEntryPointPseudoState(final IEntryPointPseudoState param) {
        OEntryPointPseudoState element = new OEntryPointPseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("05ed6f1c-4583-11e0-b54c-00137279a832")
    public void visitEnumeratedPropertyType(final IEnumeratedPropertyType param) {
        OEnumeratedPropertyType element = new OEnumeratedPropertyType(param);
        this.exportModel.export(element);
    }

    @objid ("05efd170-4583-11e0-b54c-00137279a832")
    public void visitEvent(final IEvent param) {
        OEvent element = new OEvent(param);
        this.exportModel.export(element);
    }

    @objid ("05efd173-4583-11e0-b54c-00137279a832")
    public void visitExecutionOccurenceSpecification(final IExecutionOccurenceSpecification param) {
        OExecutionOccurenceSpecification element = new OExecutionOccurenceSpecification(
                param);
        this.exportModel.export(element);
    }

    @objid ("05efd176-4583-11e0-b54c-00137279a832")
    public void visitExecutionSpecification(final IExecutionSpecification param) {
        OExecutionSpecification element = new OExecutionSpecification(param);
        this.exportModel.export(element);
    }

    @objid ("05efd179-4583-11e0-b54c-00137279a832")
    public void visitExitPointPseudoState(final IExitPointPseudoState param) {
        OExitPointPseudoState element = new OExitPointPseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("05f233cb-4583-11e0-b54c-00137279a832")
    public void visitExtensionPoint(final IExtensionPoint param) {
        OExtensionPoint element = new OExtensionPoint(param);
        this.exportModel.export(element);
    }

    @objid ("05f233ce-4583-11e0-b54c-00137279a832")
    public void visitFlowFinalNode(final IFlowFinalNode param) {
        OFlowFinalNode element = new OFlowFinalNode(param);
        this.exportModel.export(element);
    }

    @objid ("05f233d1-4583-11e0-b54c-00137279a832")
    public void visitForkJoinNode(final IForkJoinNode param) {
        OForkJoinNode element = new OForkJoinNode(param);
        this.exportModel.export(element);
    }

    @objid ("05f49624-4583-11e0-b54c-00137279a832")
    public void visitFinalState(final IFinalState param) {
        OFinalState element = new OFinalState(param);
        this.exportModel.export(element);
    }

    @objid ("05f49627-4583-11e0-b54c-00137279a832")
    public void visitForkPseudoState(final IForkPseudoState param) {
        OForkPseudoState element = new OForkPseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("05f4962a-4583-11e0-b54c-00137279a832")
    public void visitGate(final IGate param) {
        OGate element = new OGate(param);
        this.exportModel.export(element);
    }

    @objid ("05f6f87e-4583-11e0-b54c-00137279a832")
    public void visitGeneralOrdering(final IGeneralOrdering param) {
        OGeneralOrdering element = new OGeneralOrdering(param);
        this.exportModel.export(element);
    }

    @objid ("05f6f881-4583-11e0-b54c-00137279a832")
    public void visitInformationFlow(final IInformationFlow param) {
        OInformationFlow element = new OInformationFlow(param);
        this.exportModel.export(element);
    }

    @objid ("05f6f884-4583-11e0-b54c-00137279a832")
    public void visitInformationItem(final IInformationItem param) {
        OInformationItem element = new OInformationItem(param);
        this.exportModel.export(element);
    }

    @objid ("05f6f887-4583-11e0-b54c-00137279a832")
    public void visitInitialNode(final IInitialNode param) {
        OInitialNode element = new OInitialNode(param);
        this.exportModel.export(element);
    }

    @objid ("05f95ad8-4583-11e0-b54c-00137279a832")
    public void visitInitialPseudoState(final IInitialPseudoState param) {
        OInitialPseudoState element = new OInitialPseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("05f95adb-4583-11e0-b54c-00137279a832")
    public void visitInputPin(final IInputPin param) {
        OInputPin element = new OInputPin(param);
        this.exportModel.export(element);
    }

    @objid ("05f95ade-4583-11e0-b54c-00137279a832")
    public void visitInstance(final IInstance param) {
        OInstance element = new OInstance(param);
        this.exportModel.export(element);
    }

    @objid ("05fbbd32-4583-11e0-b54c-00137279a832")
    public void visitInstanceNode(final IInstanceNode param) {
        OInstanceNode element = new OInstanceNode(param);
        this.exportModel.export(element);
    }

    @objid ("05fbbd35-4583-11e0-b54c-00137279a832")
    public void visitInteraction(final IInteraction param) {
        OInteraction element = new OInteraction(param);
        this.exportModel.export(element);
    }

    @objid ("05fbbd38-4583-11e0-b54c-00137279a832")
    public void visitInteractionOperand(final IInteractionOperand param) {
        OInteractionOperand element = new OInteractionOperand(param);
        this.exportModel.export(element);
    }

    @objid ("05fe1f8c-4583-11e0-b54c-00137279a832")
    public void visitInteractionUse(final IInteractionUse param) {
        OInteractionUse element = new OInteractionUse(param);
        this.exportModel.export(element);
    }

    @objid ("05fe1f8f-4583-11e0-b54c-00137279a832")
    public void visitInternalTransition(final IInternalTransition param) {
        OInternalTransition element = new OInternalTransition(param);
        this.exportModel.export(element);
    }

    @objid ("05fe1f92-4583-11e0-b54c-00137279a832")
    public void visitInterruptibleActivityRegion(final IInterruptibleActivityRegion param) {
        OInterruptibleActivityRegion element = new OInterruptibleActivityRegion(
                param);
        this.exportModel.export(element);
    }

    @objid ("060081e6-4583-11e0-b54c-00137279a832")
    public void visitJoinPseudoState(final IJoinPseudoState param) {
        OJoinPseudoState element = new OJoinPseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("060081e9-4583-11e0-b54c-00137279a832")
    public void visitJunctionPseudoState(final IJunctionPseudoState param) {
        OJunctionPseudoState element = new OJunctionPseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("060081ec-4583-11e0-b54c-00137279a832")
    public void visitLifeline(final ILifeline param) {
        OLifeline element = new OLifeline(param);
        this.exportModel.export(element);
    }

    @objid ("0602e440-4583-11e0-b54c-00137279a832")
    public void visitLink(final ILink param) {
        OLink element = new OLink(param);
        this.exportModel.export(element);
    }

    @objid ("0602e443-4583-11e0-b54c-00137279a832")
    public void visitLinkEnd(final ILinkEnd param) {
        OLinkEnd element = new OLinkEnd(param);
        this.exportModel.export(element);
    }

    @objid ("0602e446-4583-11e0-b54c-00137279a832")
    public void visitLocalNote(final ILocalNote param) {
        OLocalNote element = new OLocalNote(param);
        this.exportModel.export(element);
    }

    @objid ("0605469a-4583-11e0-b54c-00137279a832")
    public void visitLocalTaggedValue(final ILocalTaggedValue param) {
        OLocalTaggedValue element = new OLocalTaggedValue(param);
        this.exportModel.export(element);
    }

    @objid ("0605469d-4583-11e0-b54c-00137279a832")
    public void visitLoopNode(final ILoopNode param) {
        OLoopNode element = new OLoopNode(param);
        this.exportModel.export(element);
    }

    @objid ("060546a0-4583-11e0-b54c-00137279a832")
    public void visitManifestation(final IManifestation param) {
        OManifestation element = new OManifestation(param);
        this.exportModel.export(element);
    }

    @objid ("0607a8f4-4583-11e0-b54c-00137279a832")
    public void visitMessage(final IMessage param) {
        OMessage element = new OMessage(param);
        this.exportModel.export(element);
    }

    @objid ("0607a8f7-4583-11e0-b54c-00137279a832")
    public void visitMessageFlow(final IMessageFlow param) {
        OMessageFlow element = new OMessageFlow(param);
        this.exportModel.export(element);
    }

    @objid ("0607a8fa-4583-11e0-b54c-00137279a832")
    public void visitNamespaceUse(final INamespaceUse param) {
        ONamespaceUse element = new ONamespaceUse(param);
        this.exportModel.export(element);
    }

    @objid ("060a0b4e-4583-11e0-b54c-00137279a832")
    public void visitNode(final INode param) {
        ONode element = new ONode(param);
        this.exportModel.export(element);
    }

    @objid ("060a0b51-4583-11e0-b54c-00137279a832")
    public void visitNoteType(final INoteType param) {
        ONoteType element = new ONoteType(param);
        this.exportModel.export(element);
    }

    @objid ("060a0b54-4583-11e0-b54c-00137279a832")
    public void visitObjectFlow(final IObjectFlow param) {
        OObjectFlow element = new OObjectFlow(param);
        this.exportModel.export(element);
    }

    @objid ("060c6da8-4583-11e0-b54c-00137279a832")
    public void visitOpaqueAction(final IOpaqueAction param) {
        OOpaqueAction element = new OOpaqueAction(param);
        this.exportModel.export(element);
    }

    @objid ("060c6dab-4583-11e0-b54c-00137279a832")
    public void visitOpaqueBehavior(final IOpaqueBehavior param) {
        OOpaqueBehavior element = new OOpaqueBehavior(param);
        this.exportModel.export(element);
    }

    @objid ("060c6dae-4583-11e0-b54c-00137279a832")
    public void visitOutputPin(final IOutputPin param) {
        OOutputPin element = new OOutputPin(param);
        this.exportModel.export(element);
    }

    @objid ("060ed003-4583-11e0-b54c-00137279a832")
    public void visitPartDecomposition(final IPartDecomposition param) {
        OPartDecomposition element = new OPartDecomposition(param);
        this.exportModel.export(element);
    }

    @objid ("060ed006-4583-11e0-b54c-00137279a832")
    public void visitPort(final IPort param) {
        OPort element = new OPort(param);
        this.exportModel.export(element);
    }

    @objid ("0611325c-4583-11e0-b54c-00137279a832")
    public void visitProject(final IProject param) {
        OProject element = new OProject(param);
        this.exportModel.export(element);
    }

    @objid ("0611325f-4583-11e0-b54c-00137279a832")
    public void visitProperty(final IProperty param) {
        OProperty element = new OProperty(param);
        this.exportModel.export(element);
    }

    @objid ("06113262-4583-11e0-b54c-00137279a832")
    public void visitPropertyEnumerationLitteral(final IPropertyEnumerationLitteral param) {
        OPropertyEnumerationLitteral element = new OPropertyEnumerationLitteral(
                param);
        this.exportModel.export(element);
    }

    @objid ("061394b6-4583-11e0-b54c-00137279a832")
    public void visitPropertySet(final IPropertySet param) {
        OPropertySet element = new OPropertySet(param);
        this.exportModel.export(element);
    }

    @objid ("061394b9-4583-11e0-b54c-00137279a832")
    public void visitPropertyType(final IPropertyType param) {
        OPropertyType element = new OPropertyType(param);
        this.exportModel.export(element);
    }

    @objid ("0615f710-4583-11e0-b54c-00137279a832")
    public void visitPropertyValue(final IPropertyValue param) {
        OPropertyValue element = new OPropertyValue(param);
        this.exportModel.export(element);
    }

    @objid ("0615f713-4583-11e0-b54c-00137279a832")
    public void visitPropertyValueSet(final IPropertyValueSet param) {
        OPropertyValueSet element = new OPropertyValueSet(param);
        this.exportModel.export(element);
    }

    @objid ("0615f716-4583-11e0-b54c-00137279a832")
    public void visitProvidedInterface(final IProvidedInterface param) {
        OProvidedInterface element = new OProvidedInterface(param);
        this.exportModel.export(element);
    }

    @objid ("0618596d-4583-11e0-b54c-00137279a832")
    public void visitRequiredInterface(final IRequiredInterface param) {
        ORequiredInterface element = new ORequiredInterface(param);
        this.exportModel.export(element);
    }

    @objid ("061abbc4-4583-11e0-b54c-00137279a832")
    public void visitRequirement(final IRequirement param) {
        ORequirement element = new ORequirement(param);
        this.exportModel.export(element);
    }

    @objid ("061abbc7-4583-11e0-b54c-00137279a832")
    public void visitRequirementContainer(final IRequirementContainer param) {
        ORequirementContainer element = new ORequirementContainer(param);
        this.exportModel.export(element);
    }

    @objid ("061abbca-4583-11e0-b54c-00137279a832")
    public void visitRequirementElement(final IRequirementElement param) {
        ORequirementElement element = new ORequirementElement(param);
        this.exportModel.export(element);
    }

    @objid ("061d1e1e-4583-11e0-b54c-00137279a832")
    public void visitSendSignalAction(final ISendSignalAction param) {
        OSendSignalAction element = new OSendSignalAction(param);
        this.exportModel.export(element);
    }

    @objid ("061d1e21-4583-11e0-b54c-00137279a832")
    public void visitShallowHistoryPseudoState(final IShallowHistoryPseudoState param) {
        OShallowHistoryPseudoState element = new OShallowHistoryPseudoState(
                param);
        this.exportModel.export(element);
    }

    @objid ("061f8078-4583-11e0-b54c-00137279a832")
    public void visitSignal(final ISignal param) {
        OSignal element = new OSignal(param);
        this.exportModel.export(element);
    }

    @objid ("061f807b-4583-11e0-b54c-00137279a832")
    public void visitState(final IState param) {
        OState element = new OState(param);
        this.exportModel.export(element);
    }

    @objid ("061f807e-4583-11e0-b54c-00137279a832")
    public void visitStateInvariant(final IStateInvariant param) {
        OStateInvariant element = new OStateInvariant(param);
        this.exportModel.export(element);
    }

    @objid ("0621e2d2-4583-11e0-b54c-00137279a832")
    public void visitStateMachine(final IStateMachine param) {
        OStateMachine element = new OStateMachine(param);
        this.exportModel.export(element);
    }

    @objid ("0621e2d5-4583-11e0-b54c-00137279a832")
    public void visitStereotype(final IStereotype param) {
        OStereotype element = new OStereotype(param);
        this.exportModel.export(element);
    }

    @objid ("0624452c-4583-11e0-b54c-00137279a832")
    public void visitStructuredActivityNode(final IStructuredActivityNode param) {
        OStructuredActivityNode element = new OStructuredActivityNode(param);
        this.exportModel.export(element);
    }

    @objid ("0624452f-4583-11e0-b54c-00137279a832")
    public void visitSubstitution(final ISubstitution param) {
        OSubstitution element = new OSubstitution(param);
        this.exportModel.export(element);
    }

    @objid ("06244532-4583-11e0-b54c-00137279a832")
    public void visitTagParameter(final ITagParameter param) {
        OTagParameter element = new OTagParameter(param);
        this.exportModel.export(element);
    }

    @objid ("0626a787-4583-11e0-b54c-00137279a832")
    public void visitTagType(final ITagType param) {
        OTagType element = new OTagType(param);
        this.exportModel.export(element);
    }

    @objid ("0626a78a-4583-11e0-b54c-00137279a832")
    public void visitTemplateBinding(final ITemplateBinding param) {
        OTemplateBinding element = new OTemplateBinding(param);
        this.exportModel.export(element);
    }

    @objid ("062909e0-4583-11e0-b54c-00137279a832")
    public void visitTemplateParameter(final ITemplateParameter param) {
        OTemplateParameter element = new OTemplateParameter(param);
        this.exportModel.export(element);
    }

    @objid ("062909e3-4583-11e0-b54c-00137279a832")
    public void visitTemplateParameterSubstitution(final ITemplateParameterSubstitution param) {
        OTemplateParameterSubstitution element = new OTemplateParameterSubstitution(
                param);
        this.exportModel.export(element);
    }

    @objid ("062909e6-4583-11e0-b54c-00137279a832")
    public void visitTerm(final ITerm param) {
        OTerm element = new OTerm(param);
        this.exportModel.export(element);
    }

    @objid ("062b6c3c-4583-11e0-b54c-00137279a832")
    public void visitTerminatePseudoState(final ITerminatePseudoState param) {
        OTerminatePseudoState element = new OTerminatePseudoState(param);
        this.exportModel.export(element);
    }

    @objid ("062b6c3f-4583-11e0-b54c-00137279a832")
    public void visitTransition(final ITransition param) {
        OTransition element = new OTransition(param);
        this.exportModel.export(element);
    }

    @objid ("062dce94-4583-11e0-b54c-00137279a832")
    public void visitUseCase(final IUseCase param) {
        OUseCase element = new OUseCase(param);
        this.exportModel.export(element);
    }

    @objid ("062dce97-4583-11e0-b54c-00137279a832")
    public void visitUseCaseDependency(final IUseCaseDependency param) {
        OUseCaseDependency element = new OUseCaseDependency(param);
        this.exportModel.export(element);
    }

    @Override
    @objid ("76ba2ae8-5c0e-11e1-9a0a-0027103f347d")
    public void visitValuePin(final IValuePin param) {
        OValuePin element = new OValuePin(param);
        this.exportModel.export(element);
    }

}
