/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.gui;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;
import javax.swing.border.EtchedBorder;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

/**
 * This class create a swing line separation.
 * It is a Swing EtchedBorder
 * 
 * @author ebrosse
 */
@objid ("063030f5-4583-11e0-b54c-00137279a832")
public class BottomSeparatorLineBorder extends EtchedBorder {

    /**
     * Constructor of the line with need the swing type of the EtchedBorder
     * @param etchType : the swing type of the border
     */
    @objid ("063030f6-4583-11e0-b54c-00137279a832")
    public BottomSeparatorLineBorder(final int etchType) {
        super(etchType);
    }

    @Override
    @objid ("063030f9-4583-11e0-b54c-00137279a832")
    public Insets getBorderInsets(Component c) {
        return new Insets(0, 0, 5, 0);
    }

    @Override
    @objid ("0632934c-4583-11e0-b54c-00137279a832")
    public Insets getBorderInsets(Component c, Insets insets) {
        insets.left = insets.right = insets.top = 0;
        insets.bottom = 5;
        return insets;
    }

    @Override
    @objid ("06329353-4583-11e0-b54c-00137279a832")
    public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
        int w = width;
        int h = height;
        
        g.translate(x, y);
        
        g.setColor(this.etchType == LOWERED ? getShadowColor(c) : getHighlightColor(c));
        g.drawLine(0, h - 3, w - 1, h - 3);
        
        g.setColor(this.etchType == LOWERED ? getHighlightColor(c) : getShadowColor(c));
        
        g.drawLine(0, h - 2, w - 1, h - 2);
        g.translate(-x, -y);
    }

}
