/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.gui;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Insets;
import javax.swing.border.EtchedBorder;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

/**
 * This class creates the top SWT line.
 * It is a SWT EtchedBorder.
 * @author ebrosse
 */
@objid ("06ba7957-4583-11e0-b54c-00137279a832")
public class TopSeparatorLineBorder extends EtchedBorder {

    /**
     * Default constructor
     * @param etchType : the SWT type of the EtchedBorder
     */
    @objid ("06ba7958-4583-11e0-b54c-00137279a832")
    public TopSeparatorLineBorder(final int etchType) {
        super(etchType);
    }

    @Override
    @objid ("06ba795b-4583-11e0-b54c-00137279a832")
    public Insets getBorderInsets(Component c) {
        return new Insets(5, 0, 0, 0);
    }

    @Override
    @objid ("06bcdbaf-4583-11e0-b54c-00137279a832")
    public Insets getBorderInsets(Component c, Insets insets) {
        insets.left = insets.right = insets.bottom = 0;
        insets.top = 5;
        return insets;
    }

    @Override
    @objid ("06bcdbb6-4583-11e0-b54c-00137279a832")
    public void paintBorder(Component c, Graphics g, int x, int y, int width, int height) {
        int w = width;
               
        g.translate(x, y);
        
        g.setColor(this.etchType == LOWERED ? getShadowColor(c) : getHighlightColor(c));
        g.drawLine(0, 0, w - 1, 0);
        
        g.setColor(this.etchType == LOWERED ? getHighlightColor(c) : getShadowColor(c));
        g.drawLine(0, 1, w - 1, 1);
        
        g.translate(-x, -y);
    }

}
