/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.ArrayList;
import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IAbstraction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.emf.common.util.EList;
import org.eclipse.uml2.uml.Abstraction;
import org.eclipse.uml2.uml.OpaqueExpression;

@objid ("06fad8d3-4583-11e0-b54c-00137279a832")
public class EAbstraction extends EDependency implements IEElement {

    @Override
    @objid ("06fad8d4-4583-11e0-b54c-00137279a832")
    public List<IDependency> createObjingElt() {
        return new ArrayList<IDependency>();
    }

    @objid ("06fad8da-4583-11e0-b54c-00137279a832")
    public EAbstraction(Abstraction element) {
        super(element);
    }

    @objid ("06fd3b31-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
    }

    @objid ("06fd3b34-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
        super.attach(objingElt);
    }

    @objid ("06ff9d84-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
         
        if (objingElt instanceof IDependency) {
            setMapping((IAbstraction) objingElt);
        }
    }

    @objid ("06ff9d87-4583-11e0-b54c-00137279a832")
    private void setMapping(IAbstraction objingElt) {
        OpaqueExpression opaqueExpr = ((Abstraction)getEcoreElement()).getMapping();
        String objingMapping = "";
        EList<String> bodies = opaqueExpr.getBodies();
        int i = 0;
        int size = bodies.size();
        for (Object body : bodies) {
            i++;
            objingMapping += (String) body;
            if (size > 1 && i < size)
                objingMapping += "|";
        }
                
        objingElt.setMapping(objingMapping);
    }

    @objid ("06ff9d8d-4583-11e0-b54c-00137279a832")
    public EAbstraction() {
    }

}
