/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import org.eclipse.uml2.uml.ActionInputPin;

@objid ("0719d763-4583-11e0-b54c-00137279a832")
public class EActionInputPin extends EInputPin implements IEElement {

    @objid ("0719d764-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        IInputPin result = Modelio.getInstance().getModelingSession().getModel()
        .createInputPin();
        try{
            result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                    .getStereotype(IInputPin.class, XMIStereotypes.UML2ACTIONINPUTPIN));
        }catch(StereotypeNotFoundException e){
            e.printStackTrace(Modelio.err);
        }
        return  result;
    }

    @objid ("0719d768-4583-11e0-b54c-00137279a832")
    public EActionInputPin(ActionInputPin element) {
        super(element);
    }

    @objid ("071c39c3-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("071e9c18-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("071e9c1d-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("071e9c20-4583-11e0-b54c-00137279a832")
    public EActionInputPin() {
    }

}
