/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInternalTransition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.State;

@objid ("0720fe70-4583-11e0-b54c-00137279a832")
public class EActivity extends ENamedElement implements IEElement {

    @objid ("0720fe71-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
        .createActivity();
    }

    @objid ("0720fe75-4583-11e0-b54c-00137279a832")
    public EActivity(Activity element) {
        super(element);
    }

    @objid ("072360cb-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        Activity ecoreElement = (Activity) getEcoreElement();
        Element ecoreOwner = getEcoreElement().getOwner();
        IActivity objingAct = (IActivity) objingElt;
        INameSpace objingOwner = null; 
        
        if (ecoreOwner != null) {
            IElement tempOwner = (IElement) revProp.getMappedElement(ecoreOwner);
        
            if (tempOwner != null) {
                if (tempOwner instanceof INameSpace){
                    objingOwner = (INameSpace) tempOwner;
                }else if (tempOwner instanceof IState){
        
                    objingOwner = EcoreModelNavigation.getNearestNameSpace(ecoreOwner);
                    
                    Behavior entry = ((State)ecoreOwner).getEntry();
                    Behavior exit = ((State)ecoreOwner).getExit();
                    Behavior doActivity = ((State)ecoreOwner).getDoActivity();
        
                    if ((entry != null) && (entry.equals(ecoreElement))){
                        IInternalTransition transition = Modelio.getInstance().getModelingSession().getModel().createInternalTransition();
                        transition.setSComposed((IState)objingOwner);
                        transition.setBehaviorEffect(objingAct);
                        transition.setReceivedEvents("Entry");
                    }else if ((exit != null) && (exit.equals(ecoreElement))){    
                        IInternalTransition transition = Modelio.getInstance().getModelingSession().getModel().createInternalTransition();
                        transition.setSComposed((IState)objingOwner);
                        transition.setBehaviorEffect(objingAct);
                        transition.setReceivedEvents("Exit");
                    }else if ((doActivity != null) && (doActivity.equals(ecoreElement))){
                        IInternalTransition transition = Modelio.getInstance().getModelingSession().getModel().createInternalTransition();
                        transition.setSComposed((IState)objingOwner);
                        transition.setBehaviorEffect(objingAct);
                        transition.setReceivedEvents("Do");
                    }
                }else if (tempOwner instanceof ITransition){
                    objingOwner = EcoreModelNavigation.getNearestNameSpace(ecoreOwner);
                        
                    ((ITransition)objingOwner).setBehaviorEffect(objingAct);
                }
            }
            
        }
        
        if (objingOwner != null)
            objingAct.setOwner(objingOwner);
        else 
            objingAct.setOwner(ReverseProperties.getInstance().getExternalPackage());
    }

    @objid ("072360ce-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("072360d3-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setReadOnly((IActivity) objingElt);
        setSingleExecution((IActivity) objingElt);
        setReentrant((IActivity) objingElt);
    }

    @objid ("0725c324-4583-11e0-b54c-00137279a832")
    private void setReadOnly(IActivity activity) {
        activity.setReadOnly(((Activity)getEcoreElement()).isReadOnly());
    }

    @objid ("0725c327-4583-11e0-b54c-00137279a832")
    private void setSingleExecution(IActivity activity) {
        activity.setSingleExecution(((Activity)getEcoreElement()).isSingleExecution());
    }

    @objid ("0725c32a-4583-11e0-b54c-00137279a832")
    private void setReentrant(IActivity activity) {
        activity.setReentrant(((Activity)getEcoreElement()).isReentrant());
    }

    @objid ("0725c32d-4583-11e0-b54c-00137279a832")
    public EActivity() {
    }

}
