/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityParameterNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ObObjectNodeOrderingKindEnum;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehaviorParameter;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralClass;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.emf.common.util.EList;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.ActivityParameterNode;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.ObjectNodeOrderingKind;
import org.eclipse.uml2.uml.OpaqueBehavior;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.ValueSpecification;

@objid ("07341140-4583-11e0-b54c-00137279a832")
public class EActivityParameterNode extends EActivityNode implements IEElement {

    @objid ("07341141-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createActivityParameterNode();
    }

    @objid ("07341145-4583-11e0-b54c-00137279a832")
    public EActivityParameterNode(ActivityParameterNode element) {
        super(element);
    }

    @objid ("0736739a-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("0736739d-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("073673a2-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        
        setControlType((IActivityParameterNode) objingElt);
        setOrdering((IActivityParameterNode) objingElt);
        setSelectionBehavior((IActivityParameterNode) objingElt);
        setUpperBound((IActivityParameterNode) objingElt);
        setType((IActivityParameterNode) objingElt);
        // setRepresented((IActivityParameterNode)objingElt);
        // setRepresentedAttribute((IActivityParameterNode)objingElt);
        // setRepresentedRole((IActivityParameterNode)objingElt);
        setRepresentedRealParameter((IActivityParameterNode) objingElt);
        setState((IActivityParameterNode) objingElt);
    }

    @objid ("0738d5fd-4583-11e0-b54c-00137279a832")
    private void setControlType(IActivityParameterNode node) {
        node.setControlType(((ActivityParameterNode)getEcoreElement()).isControlType());
    }

    @objid ("0738d600-4583-11e0-b54c-00137279a832")
    private void setOrdering(IActivityParameterNode node) {
        ActivityParameterNode ecoreElement    = ((ActivityParameterNode)getEcoreElement());
            switch (ecoreElement.getOrdering().getValue()) {
            case ObjectNodeOrderingKind.FIFO:
                node.setOrdering(ObObjectNodeOrderingKindEnum.F_I_F_O);
                break;
            case ObjectNodeOrderingKind.LIFO:
                node.setOrdering(ObObjectNodeOrderingKindEnum.L_I_F_O);
                break;
            case ObjectNodeOrderingKind.ORDERED:
                node.setOrdering(ObObjectNodeOrderingKindEnum.ORDERED);
                break;
            case ObjectNodeOrderingKind.UNORDERED:
                node.setOrdering(ObObjectNodeOrderingKindEnum.UNORDERED);
                break;
            default:
                node.setOrdering(ObObjectNodeOrderingKindEnum.F_I_F_O);
            }
    }

    @objid ("073b384e-4583-11e0-b54c-00137279a832")
    private void setSelectionBehavior(IActivityParameterNode node) {
        Behavior ecoreBehavior = ((ActivityParameterNode)getEcoreElement()).getSelection();
        if (ecoreBehavior instanceof OpaqueBehavior) {
            String objingBehavior = "";
            for (Object body : ((OpaqueBehavior) ecoreBehavior).getBodies()) {
                objingBehavior = objingBehavior.concat((String) body);
            }
            node.setSelectionBehavior(objingBehavior);
        } else if (ecoreBehavior != null) {
            String behaviorName = ecoreBehavior.getName();
            if (behaviorName != null)
                node.setSelectionBehavior(behaviorName);
        }
    }

    @objid ("073b3851-4583-11e0-b54c-00137279a832")
    private void setUpperBound(IActivityParameterNode node) {
        ValueSpecification ecoreUpperBound = ((ActivityParameterNode)getEcoreElement()).getUpperBound();
        if (ecoreUpperBound != null) {
            String stringValue = ecoreUpperBound.stringValue();
            if (stringValue != null)
                node.setUpperBound(stringValue);
        }
    }

    @objid ("073b3854-4583-11e0-b54c-00137279a832")
    private void setType(IActivityParameterNode node) {
        Type ecoreType = ((ActivityParameterNode)getEcoreElement()).getType();
        if (ecoreType != null) {
            node.setType((IGeneralClass) ReverseProperties.getInstance().getMappedElement(ecoreType)); 
        }
    }

    @objid ("073b3857-4583-11e0-b54c-00137279a832")
    private void setRepresentedRealParameter(IActivityParameterNode node) {
        Parameter ecoreParam = ((ActivityParameterNode)getEcoreElement()).getParameter();
        if (ecoreParam != null) {
            Object objingParam =  ReverseProperties.getInstance().getMappedElement(ecoreParam);
            if (objingParam instanceof IParameter) {
                Activity ecoreActivity = EcoreModelNavigation
                .getOwnerActivity(((ActivityParameterNode)getEcoreElement()));
                if (ecoreActivity != null) {
                    Object objingActivity =  ReverseProperties.getInstance()
                    .getMappedElement(ecoreActivity);
                    if (objingActivity instanceof IActivity) {
                        IBehaviorParameter objingBehaviorParam = null;
                
                        if (objingParam instanceof IBehaviorParameter)
                            objingBehaviorParam = (IBehaviorParameter) objingParam;
                        else
                            objingBehaviorParam = Modelio.getInstance().getModelingSession().getModel().createBehaviorParameter();
                
                        objingBehaviorParam.setOwner((IActivity) objingActivity);
                
                        String name = ecoreParam.getName();
                        if (EcoreModelNavigation.isNotNull(name))
                            objingBehaviorParam.setName(name);
                        else 
                            objingBehaviorParam.setName("");
                
                        objingBehaviorParam
                        .setMapped((IParameter) objingParam);
                        node.setRepresentedRealParameter(objingBehaviorParam);
                
                        Type ecoreType = ecoreParam.getType();
                        if (ecoreType != null) {
                            Object objingType =  ReverseProperties.getInstance()
                            .getMappedElement(ecoreType);
                            if (objingType instanceof IGeneralClass)
                                objingBehaviorParam
                                .setType((IGeneralClass) objingType);
                        }
                    }
                }
            }
        }
    }

    @objid ("073b385a-4583-11e0-b54c-00137279a832")
    private void setState(IActivityParameterNode node) {
        EList<?> ecoreStates = ((ActivityParameterNode)getEcoreElement()).getInStates();
        if (ecoreStates != null && ecoreStates.size() > 0) {
            State ecoreState = (State) ecoreStates.get(0);
            if (ecoreState != null) {
                Object objingState =  ReverseProperties.getInstance().getMappedElement(ecoreState);
                if (objingState instanceof IState)
                    node.setInState((IState) objingState);
            }
        }
    }

    @objid ("073b385d-4583-11e0-b54c-00137279a832")
    public EActivityParameterNode() {
    }

}
