/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.ActivityPartition;
import org.eclipse.uml2.uml.Element;

@objid ("073d9aa9-4583-11e0-b54c-00137279a832")
public class EActivityPartition extends ENamedElement implements IEElement {

    @objid ("073d9aaa-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createActivityPartition();
    }

    @objid ("073d9aae-4583-11e0-b54c-00137279a832")
    public EActivityPartition(ActivityPartition element) {
        super(element);
    }

    @objid ("073ffd06-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
                
        Element ecoreOwner = getEcoreElement().getOwner();
        IActivityPartition objingPartition = (IActivityPartition) objingElt;
                
        if (ecoreOwner != null) {
            if (ecoreOwner instanceof ActivityPartition) {
                IActivityPartition objingOwner = (IActivityPartition) revProp
                        .getMappedElement(ecoreOwner);
                
                if (objingOwner != null)
                    objingPartition.setSuperPartition(objingOwner);
            } else if (ecoreOwner instanceof Activity) {
                IActivity objingOwner = (IActivity) revProp
                        .getMappedElement(ecoreOwner);
                
                if (objingOwner != null)
                    objingPartition.setInActivity(objingOwner);
            } else {
                revProp.deleteElement(getEcoreElement(), objingElt);
            }
        }
    }

    @objid ("073ffd09-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("073ffd0e-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setDimension((IActivityPartition) objingElt);
        setExternal((IActivityPartition) objingElt);
        setRepresented((IActivityPartition) objingElt);
    }

    @objid ("07425f5d-4583-11e0-b54c-00137279a832")
    private void setDimension(IActivityPartition partition) {
        partition.setDimension(((ActivityPartition)getEcoreElement()).isDimension());
    }

    @objid ("07425f60-4583-11e0-b54c-00137279a832")
    private void setExternal(IActivityPartition partition) {
        partition.setExternal(((ActivityPartition)getEcoreElement()).isExternal());
    }

    @objid ("07425f63-4583-11e0-b54c-00137279a832")
    private void setRepresented(IActivityPartition partition) {
        Element ecoreRepresentation = ((ActivityPartition)getEcoreElement()).getRepresents();
        if ( ecoreRepresentation != null) {
            IElement representation = (IElement) ReverseProperties.getInstance().getMappedElement(ecoreRepresentation);
            if ((representation != null ) && (representation instanceof IModelElement)){
                partition.setRepresented((IModelElement) representation);
            }
        }
    }

    @objid ("07425f66-4583-11e0-b54c-00137279a832")
    public EActivityPartition() {
    }

}
