/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IProfile;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.model.uml.usecase.IActor;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.Element;

@objid ("0744c1b6-4583-11e0-b54c-00137279a832")
public class EActor extends ENamedElement implements IEElement {

    @objid ("0744c1b7-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession()
        .getModel().createActor();
    }

    @objid ("0744c1bb-4583-11e0-b54c-00137279a832")
    public EActor(Actor element) {
        super(element);
    }

    @objid ("07472411-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        
        Element ecoreOwner = getEcoreElement().getOwner();
        
        Object objingOwner =  revProp.getMappedElement(ecoreOwner);
        
        if ((objingOwner != null)  
                && (objingOwner instanceof IModelTree)
                && !(objingOwner instanceof IProfile)) {
             ((IActor) objingElt).setOwner((IModelTree)objingOwner);
        }else{
             ((IActor) objingElt).setOwner(revProp.getExternalPackage());
        }
    }

    @objid ("07472414-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("07472419-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0749866a-4583-11e0-b54c-00137279a832")
    public EActor() {
    }

}
