/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Artifact;
import org.eclipse.uml2.uml.Element;

@objid ("075efb94-4583-11e0-b54c-00137279a832")
public class EArtifact extends ENamedElement implements IEElement {

    @objid ("075efb95-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession()
        .getModel().createArtifact();
    }

    @objid ("075efb99-4583-11e0-b54c-00137279a832")
    public EArtifact(Artifact element) {
        super(element);
    }

    @objid ("07615dee-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        // I take the model map
        ReverseProperties revProp = ReverseProperties.getInstance();
        
        // I take the ecore Imported and Importing
        Element ecoreOwner = getEcoreElement().getOwner();
        
        Object objingOwner =  revProp.getMappedElement(ecoreOwner);
        
        if (objingOwner instanceof IModelTree) {
            ((IArtifact) objingElt).setOwner((IModelTree)objingOwner);          
        }else {
             ((IArtifact) objingElt).setOwner(ReverseProperties.getInstance().getExternalPackage()); 
        }
    }

    @objid ("07615df1-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("07615df6-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setFileName((IArtifact) objingElt);
    }

    @objid ("0763c049-4583-11e0-b54c-00137279a832")
    private void setFileName(IArtifact objingElt) {
        String name = ((Artifact)getEcoreElement()).getFileName();
        if (EcoreModelNavigation.isNotNull(name))
            objingElt.setFileName(name);
        else 
            objingElt.setFileName("");
    }

    @objid ("0763c04c-4583-11e0-b54c-00137279a832")
    public EArtifact() {
    }

}
