/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.ArrayList;
import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Artifact;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Property;

@objid ("0763c04e-4583-11e0-b54c-00137279a832")
public class EAssociation extends ENamedElement implements IEElement {

    @objid ("0763c04f-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        if (EcoreModelNavigation.hasTwoValidEnds((Association)getEcoreElement()))
            return Modelio.getInstance().getModelingSession().getModel().createAssociation();
        return null;
    }

    @objid ("076622af-4583-11e0-b54c-00137279a832")
    public EAssociation(Association element) {
        super(element);
    }

    @objid ("07688502-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        // // If the element is an association Class then we take the
        // Association
        // // of the association Class
        // IAssociation objingAssoc = null;
        // if (objingElt instanceof IClassAssociation) {
        // objingAssoc = ((IClassAssociation) objingElt).getAssociationPart();
        // } else {
        // objingAssoc = (IAssociation) objingElt;
        // }
        
        IAssociation objingAssoc = (IAssociation) objingElt;
        
        for (Object memberEnd : ((Association)getEcoreElement()).getMemberEnds()) {
            Object ends = revProp.getMappedElement((Element) memberEnd);
            IAssociationEnd objingAssocEnd = null;
            for (IModelElement end : (ArrayList<IModelElement>) ends ){
                if (end instanceof IAssociationEnd){
                    objingAssocEnd = (IAssociationEnd) end;
                    break;
                }
            }
        
            if ((objingAssocEnd != null) && (!(((Property)memberEnd).getType() instanceof Artifact))){
                // Links the AssociationEnd to the Association:
                objingAssocEnd.setRelated(objingAssoc);
            }
        }
    }

    @objid ("07688505-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("076ae756-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("076ae75c-4583-11e0-b54c-00137279a832")
    public EAssociation() {
    }

}
