/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.BroadcastSignalAction;
import org.eclipse.uml2.uml.Signal;

@objid ("07852139-4583-11e0-b54c-00137279a832")
public class EBroadcastSignalAction extends EActivityNode implements IEElement {
    @objid ("0785213a-4583-11e0-b54c-00137279a832")
    private BroadcastSignalAction ecoreElement;


    @objid ("0785213b-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        ISendSignalAction result = Modelio.getInstance().getModelingSession().getModel()
        .createSendSignalAction();
        try{
            result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                    .getStereotype(ISendSignalAction.class, XMIStereotypes.UML2BROADCASTSIGNALACTION));
        }catch(StereotypeNotFoundException e){
            e.printStackTrace(Modelio.err);
        }
        return result;
    }

    @objid ("0789e5e8-4583-11e0-b54c-00137279a832")
    public EBroadcastSignalAction(BroadcastSignalAction element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0789e5f1-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("0789e5f4-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("078c4846-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setSignal((ISendSignalAction) objingElt);
    }

    @objid ("078eaaa0-4583-11e0-b54c-00137279a832")
    private void setSignal(ISendSignalAction action) {
        Signal ecoreSignal = ecoreElement.getSignal();
                
        if (ecoreSignal != null) {
            Object objingSignal =  ReverseProperties.getInstance().getMappedElement(ecoreSignal);
            if (objingSignal instanceof ISignal)
                action.setSent((ISignal) objingSignal);
        }
    }

    @objid ("078eaaa3-4583-11e0-b54c-00137279a832")
    public EBroadcastSignalAction() {
    }

}
