/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallBehaviorAction;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehavior;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.CallBehaviorAction;

@objid ("078eaaa5-4583-11e0-b54c-00137279a832")
public class ECallBehaviorAction extends EActivityNode implements IEElement {
    @objid ("07910cf6-4583-11e0-b54c-00137279a832")
    private CallBehaviorAction ecoreElement;


    @objid ("07910cf7-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createCallBehaviorAction();
    }

    @objid ("07910cfb-4583-11e0-b54c-00137279a832")
    public ECallBehaviorAction(CallBehaviorAction element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("07910d04-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("07936f50-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("07936f55-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setSynchronous((ICallBehaviorAction) objingElt);
        setBehavior((ICallBehaviorAction) objingElt);
    }

    @objid ("0795d1b3-4583-11e0-b54c-00137279a832")
    private void setSynchronous(ICallBehaviorAction action) {
        action.setSynchronous(ecoreElement.isSynchronous());
    }

    @objid ("0795d1b6-4583-11e0-b54c-00137279a832")
    private void setBehavior(ICallBehaviorAction action) {
        Behavior ecoreBehavior = ecoreElement.getBehavior();
                
        if (ecoreBehavior != null) {
            Object objingBehavior =  ReverseProperties.getInstance().getMappedElement(ecoreBehavior);
            if (objingBehavior instanceof IBehavior) {
                action.setCalled((IBehavior) objingBehavior);
            }
        }
    }

    @objid ("0795d1b9-4583-11e0-b54c-00137279a832")
    public ECallBehaviorAction() {
    }

}
