/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ObEventTypeEnum;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.CallEvent;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Transition;

@objid ("07983405-4583-11e0-b54c-00137279a832")
public class ECallEvent extends ENamedElement implements IEElement {
    @objid ("07983406-4583-11e0-b54c-00137279a832")
    private CallEvent ecoreElement;


    @objid ("07983407-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        Element ecoreOwner = ecoreElement.getOwner();
        if (ecoreOwner instanceof Transition){
            IEvent result = Modelio.getInstance().getModelingSession().getModel().createEvent();
            result.setKind(ObEventTypeEnum.CALL_EVENT);
            return result;
        }
        return null;
    }

    @objid ("0798340b-4583-11e0-b54c-00137279a832")
    public ECallEvent(CallEvent element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("079a9662-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        if (((IEvent) objingElt).getComposed() == null){
            Element ecoreOwner = ecoreElement.getOwner();
            if (ecoreOwner instanceof Transition){
                IStateMachine sm = (IStateMachine) ReverseProperties.getInstance().getMappedElement(((Transition) ecoreOwner).getContainer().getStateMachine());
                sm.addEComponent((IEvent)objingElt);
            }else{
                Modelio.getInstance().getModelingSession().getModel().deleteElement(objingElt);
            }
        }
    }

    @objid ("079a9665-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("079a966a-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setOperation(objingElt);
    }

    @objid ("079a966d-4583-11e0-b54c-00137279a832")
    public ECallEvent() {
    }

    @objid ("079cf8bc-4583-11e0-b54c-00137279a832")
    private void setOperation(IElement objingElt) {
        Operation operation =    ecoreElement.getOperation();
        if (operation != null){
            IElement objOperation = (IElement) ReverseProperties.getInstance().getMappedElement(operation);
            if (objOperation instanceof IOperation){
                ((IEvent) objingElt).setCalled((IOperation) objOperation);
            }
        }
    }

}
