/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallOperationAction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.Operation;

@objid ("079cf8bf-4583-11e0-b54c-00137279a832")
public class ECallOperationAction extends EActivityNode implements IEElement {
    @objid ("079cf8c0-4583-11e0-b54c-00137279a832")
    private CallOperationAction ecoreElement;


    @objid ("079cf8c1-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createCallOperationAction();
    }

    @objid ("079f5b12-4583-11e0-b54c-00137279a832")
    public ECallOperationAction(CallOperationAction element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("079f5b1b-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("079f5b1e-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("07a1bd6f-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setSynchronous((ICallOperationAction) objingElt);
        setOperation((ICallOperationAction) objingElt);
    }

    @objid ("07a41fc9-4583-11e0-b54c-00137279a832")
    private void setSynchronous(ICallOperationAction action) {
        action.setSynchronous(ecoreElement.isSynchronous());
    }

    @objid ("07a41fcc-4583-11e0-b54c-00137279a832")
    private void setOperation(ICallOperationAction action) {
        Operation ecoreOperation = ecoreElement.getOperation();
                
        if (ecoreOperation != null) {
            Object objingOperation =  ReverseProperties.getInstance().getMappedElement(ecoreOperation);
            if (objingOperation instanceof IOperation)
                action.setCalled((IOperation) objingOperation);
        }
    }

    @objid ("07a41fcf-4583-11e0-b54c-00137279a832")
    public ECallOperationAction() {
    }

}
