/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.reverse.PartialImportMap;
import com.modeliosoft.modelio.xmi.reverse.TotalImportMap;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.ClassifierTemplateParameter;

@objid ("07c31e5e-4583-11e0-b54c-00137279a832")
public class EClassifierTemplateParameter extends EElement implements IEElement {
    @objid ("07c31e5f-4583-11e0-b54c-00137279a832")
    private ClassifierTemplateParameter ecoreElement;


    @objid ("07c31e60-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        ITemplateParameter result = Modelio.getInstance().getModelingSession().getModel().createTemplateParameter();
        try{
            result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                    ITemplateParameter.class, XMIStereotypes.UML2CLASSIFIERTEMPLATEPARAMETER));
        }catch(StereotypeNotFoundException e){
            e.printStackTrace(Modelio.err);
        }
        return result;
    }

    @objid ("07c580b6-4583-11e0-b54c-00137279a832")
    public EClassifierTemplateParameter(ClassifierTemplateParameter element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("07c580bf-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        IElement objingOperation  = (IElement) ReverseProperties.getInstance()
        .getMappedElement(ecoreElement.getOwner());
        
        if (objingOperation instanceof IOperation) {
            ((IOperation) objingOperation)
            .addTemplate((ITemplateParameter) objingElt);
        
        } else {
            PartialImportMap.getInstance().remove(ecoreElement);
            TotalImportMap.getInstance().remove(ecoreElement);
            Modelio.getInstance().getModelingSession().getModel()
            .deleteElement(objingElt);
        }
    }

    @objid ("07c7e30e-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("07c7e313-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {

    	super.setProperties(objingElt);
    }

    @objid ("07c7e316-4583-11e0-b54c-00137279a832")
    public EClassifierTemplateParameter() {
    }

}
