/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaboration;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Collaboration;
import org.eclipse.uml2.uml.CollaborationUse;

@objid ("07ee08ae-4583-11e0-b54c-00137279a832")
public class ECollaborationUse extends ENamedElement implements IEElement {
    @objid ("07ee08af-4583-11e0-b54c-00137279a832")
    private CollaborationUse ecoreElement;


    @objid ("07ee08b0-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createCollaborationUse();
    }

    @objid ("07f06b06-4583-11e0-b54c-00137279a832")
    public ECollaborationUse(CollaborationUse element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("07f06b0f-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ecoreElement.getOwner();
        
        IElement objOwner = (IElement)  ReverseProperties.getInstance().getMappedElement(ecoreElement.getOwner());
                
        if (objOwner instanceof INameSpace)
            ((INameSpace)objOwner).addOwnedCollaborationUse((ICollaborationUse)objingElt);
    }

    @objid ("07f06b12-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("07f2cd63-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setType((ICollaborationUse) objingElt);
    }

    @objid ("07f2cd66-4583-11e0-b54c-00137279a832")
    private void setType(ICollaborationUse objingElt) {
        Collaboration type = ecoreElement.getType();
        if (type != null) {
            IElement objType = (IElement)  ReverseProperties.getInstance().getMappedElement(type);
                
            if (objType instanceof ICollaboration)
                objingElt.setType((ICollaboration) objType);
        }
    }

    @objid ("07f2cd6c-4583-11e0-b54c-00137279a832")
    public ECollaborationUse() {
    }

}
