/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.CommunicationPath;

@objid ("08037dd6-4583-11e0-b54c-00137279a832")
public class ECommunicationPath extends ENamedElement implements IEElement {

    @objid ("08037dd7-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        IAssociation objingAssoc = null;
        
        if (EcoreModelNavigation.hasTwoValidEnds((Association)getEcoreElement())){
            objingAssoc = Modelio.getInstance().getModelingSession().getModel().createAssociation();
        
            try{
                objingAssoc.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                        .getStereotype(IAssociation.class, XMIStereotypes.UML2COMMUNICATIONPATH));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
        }
        return objingAssoc;
    }

    @objid ("0808428a-4583-11e0-b54c-00137279a832")
    public ECommunicationPath(CommunicationPath element) {
        super(element);
    }

    @objid ("08084293-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
    }

    @objid ("080aa4e5-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("080aa4ea-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("080aa4ed-4583-11e0-b54c-00137279a832")
    public ECommunicationPath() {
    }

}
