/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IConditionalNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.ConditionalNode;

@objid ("0818f300-4583-11e0-b54c-00137279a832")
public class EConditionalNode extends EStructuredActivityNode implements IEElement {
    @objid ("0818f301-4583-11e0-b54c-00137279a832")
    private ConditionalNode ecoreElement;


    @objid ("0818f302-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createConditionalNode();
    }

    @objid ("0818f306-4583-11e0-b54c-00137279a832")
    public EConditionalNode(ConditionalNode element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0818f30f-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("081b555c-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("081b5561-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        // Part of the Properties are setted when mapping the super type
        // (StructuredActivityNode)
                
        // Properties specific to ConditionalNodes:
        setIsAssured((IConditionalNode) objingElt);
        setDeterminate((IConditionalNode) objingElt);
    }

    @objid ("081b5564-4583-11e0-b54c-00137279a832")
    private void setIsAssured(IConditionalNode node) {
        node.setAssured(ecoreElement.isAssured());
    }

    @objid ("081b5567-4583-11e0-b54c-00137279a832")
    private void setDeterminate(IConditionalNode node) {
        node.setDeterminate(ecoreElement.isDeterminate());
    }

    @objid ("081db7b4-4583-11e0-b54c-00137279a832")
    public EConditionalNode() {
    }

}
