/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IConnectionPointReference;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEntryPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IExitPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.ConnectionPointReference;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.State;

@objid ("0827411c-4583-11e0-b54c-00137279a832")
public class EConnectionPointReference extends ENamedElement implements IEElement {
    @objid ("0827411d-4583-11e0-b54c-00137279a832")
    private ConnectionPointReference ecoreElement;


    @objid ("0827411e-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createConnectionPointReference();
    }

    @objid ("08274122-4583-11e0-b54c-00137279a832")
    public EConnectionPointReference(ConnectionPointReference element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0829a376-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        State ecoreOwner = ecoreElement.getState();
        if (ecoreOwner != null){
            Object temp =  ReverseProperties.getInstance().getMappedElement(ecoreOwner);
            if( temp instanceof IState){
                ((IConnectionPointReference) objingElt).setOwnerState((IState) temp);
            }
            
        }
    }

    @objid ("0829a379-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0829a37e-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setExit((IConnectionPointReference) objingElt);
        setEntry((IConnectionPointReference) objingElt);
    }

    @objid ("0829a381-4583-11e0-b54c-00137279a832")
    private void setEntry(IConnectionPointReference objingElt) {
        for(Object connection : ecoreElement.getEntries()){
            Object temp =  ReverseProperties.getInstance().getMappedElement((Element)connection);
            if ((temp != null) && (temp instanceof IEntryPointPseudoState)){
                objingElt.setEntry((IEntryPointPseudoState) temp);
            }
        }
    }

    @objid ("0829a384-4583-11e0-b54c-00137279a832")
    private void setExit(IConnectionPointReference objingElt) {
        for(Object connection : ecoreElement.getExits()){
            Object temp =  ReverseProperties.getInstance().getMappedElement((Element)connection);
            if ((temp != null) && (temp instanceof IExitPointPseudoState)){
                objingElt.setExit((IExitPointPseudoState) temp);
            }
        }
    }

    @objid ("082c05d3-4583-11e0-b54c-00137279a832")
    public EConnectionPointReference() {
    }

}
