/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.Element;

@objid ("082c05d5-4583-11e0-b54c-00137279a832")
public class EConnector extends EFeature implements IEElement {
    @objid ("082c05d6-4583-11e0-b54c-00137279a832")
    private Connector ecoreElement;


    @objid ("082c05d7-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createConnector();
    }

    @objid ("08332cde-4583-11e0-b54c-00137279a832")
    public EConnector(Connector element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("08332ce7-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ILink objingLink = (ILink) objingElt;
        
        for (Object memberEnd : ecoreElement.getEnds()) {
            ILinkEnd objingLinkEnd = (ILinkEnd)  ReverseProperties.getInstance()
            .getMappedElement((Element) memberEnd);
        
            if (objingLinkEnd != null) {
                // Links the AssociationEnd to the Association:
                    objingLinkEnd.setLinkNode(objingLink);
            }
        }
    }

    @objid ("08332cea-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("08358f39-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        setBase((ILink) objingElt);
        super.setProperties(objingElt);
    }

    @objid ("08358f3f-4583-11e0-b54c-00137279a832")
    private void setBase(ILink objingElt) {
        Association type = ecoreElement.getType();
        
        if (type != null){
            IElement objAssociation = (IElement)  ReverseProperties.getInstance().getMappedElement(type);
            if (objAssociation instanceof IAssociation)
                objingElt.setBase((IAssociation)objAssociation);
        }
    }

    @objid ("08358f42-4583-11e0-b54c-00137279a832")
    public EConnector() {
    }

}
