/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaboration;
import com.modeliosoft.modelio.api.model.uml.statik.IConnectorEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.ObList;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.reverse.PartialImportMap;
import com.modeliosoft.modelio.xmi.reverse.TotalImportMap;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.ConnectableElement;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.StructuredClassifier;
import org.eclipse.uml2.uml.Type;

@objid ("0837f192-4583-11e0-b54c-00137279a832")
public class EConnectorEnd extends EElement implements IEElement {
    @objid ("0837f193-4583-11e0-b54c-00137279a832")
    private ConnectorEnd ecoreElement;

    @objid ("0837f194-4583-11e0-b54c-00137279a832")
    private ConnectableElement role = null;


    @objid ("0837f195-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createConnectorEnd();
    }

    @objid ("0837f19d-4583-11e0-b54c-00137279a832")
    public EConnectorEnd(ConnectorEnd element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("083a53f1-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        Element temp = ecoreElement.getOwner(); 
        
        Object obTemp = null;
        if (temp != null){
            obTemp = ReverseProperties.getInstance().getMappedElement(temp);
            if (obTemp instanceof ILink){
                ILink objLink = (ILink) obTemp;
                objLink.addConnection((ILinkEnd) objingElt);
            }
        }
        
        if (((IConnectorEnd)objingElt).getLinked() == null){
            role = ecoreElement.getRole();        
            if (role != null){
                obTemp = ReverseProperties.getInstance().getMappedElement(role);
                if (obTemp instanceof IPort){
                    IPort objOwner = (IPort) obTemp;
                    objOwner.addConnection((ILinkEnd) objingElt);
                }else if  ((obTemp instanceof IInstance) && (!(obTemp instanceof IPort) || !(role.getOwner() instanceof Property))) {        
                    IInstance objOwner = (IInstance) obTemp;
                    objOwner.addConnection((ILinkEnd) objingElt);
                }else if (obTemp instanceof List){
                    boolean exist = false;
                    IBindableInstance objOwner = null;
                    for (Object objingTemp : (List) obTemp){
                        if (objingTemp instanceof IBindableInstance){
                            exist = true;
                            objOwner = (IBindableInstance) objingTemp;
                            break;
                        }
        
                    }
        
                    if (!exist){
                        objOwner = Modelio.getInstance().getModelingSession().getModel().createBindableInstance();
                        attachBindableInstance(objOwner);
                        setBindableInstanceProperties(objOwner);
                        ((List<IModelElement>)obTemp).add(objOwner);
                        PartialImportMap.getInstance().put(role, obTemp);
                        TotalImportMap.getInstance().put(role, obTemp);
                    }
        
                    if (objOwner != null)
                        objOwner.addConnection((ILinkEnd) objingElt);
        
                }
            }
        }
    }

    @objid ("083a53f4-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("083a53f9-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        setIsOrdered((ILinkEnd)objingElt);
        setIsUnique((ILinkEnd)objingElt);
        setMax((ILinkEnd)objingElt);
        setMin((ILinkEnd)objingElt);
        //        setPartWithPort((ILinkEnd)objingElt);
        if ( ReverseProperties.getInstance().isRoundtripEnabled()){
            setName((ILinkEnd) objingElt); 
            setIsNavigable((ILinkEnd)objingElt);
        }
        

    	super.setProperties(objingElt);
    }

    @objid ("083cb646-4583-11e0-b54c-00137279a832")
    private void setName(ILinkEnd linkEnd) {
        linkEnd.setName(ObjingEAnnotation.getName(ecoreElement));
    }

    @objid ("083cb649-4583-11e0-b54c-00137279a832")
    private void setIsNavigable(ILinkEnd linkEnd) {
        linkEnd.setNavigable(ObjingEAnnotation.isNavigable(ecoreElement));
    }

    @objid ("083cb64c-4583-11e0-b54c-00137279a832")
    private void setIsOrdered(ILinkEnd linkEnd) {
        linkEnd.setOrdered(ecoreElement.isOrdered());
    }

    @objid ("083cb64f-4583-11e0-b54c-00137279a832")
    private void setIsUnique(ILinkEnd linkEnd) {
        linkEnd.setUnique(ecoreElement.isUnique());
    }

    @objid ("083cb652-4583-11e0-b54c-00137279a832")
    private void setMin(ILinkEnd objingElt) {
        objingElt.setMultiplicityMin(EcoreModelNavigation.getMultiplicityMin(ecoreElement));
    }

    @objid ("083cb655-4583-11e0-b54c-00137279a832")
    private void setMax(ILinkEnd objingElt) {
        objingElt.setMultiplicityMin(EcoreModelNavigation.getMultiplicityMax(ecoreElement));
    }

    @objid ("083f18a2-4583-11e0-b54c-00137279a832")
    public EConnectorEnd() {
    }

    @objid ("083f18a4-4583-11e0-b54c-00137279a832")
    private void setBindableInstanceProperties(IInstance objingElt) {
        setName(objingElt);
        setBase(objingElt);
        
        if ( ReverseProperties.getInstance().isRoundtripEnabled()){
            setIsConstant((IInstance) objingElt);
            setValue((IInstance) objingElt);
            setMultiMax((IInstance) objingElt);
            setMultiMin((IInstance) objingElt);
        }
    }

    @objid ("083f18a7-4583-11e0-b54c-00137279a832")
    private void setName(IInstance objingElt) {
        String  name = role.getName();
        if (name != null){
            objingElt.setName(name);
        }
    }

    @objid ("083f18aa-4583-11e0-b54c-00137279a832")
    private void setBase(IInstance objingElt) {
        Type type = role.getType();
        if (type != null){
            IElement base =(IElement)  ReverseProperties.getInstance().getMappedElement(type);
            if (base instanceof INameSpace)
                objingElt.setBase((INameSpace) base);
        }
    }

    @objid ("083f18ad-4583-11e0-b54c-00137279a832")
    private void setIsConstant(IInstance objingElt) {
        objingElt.setConstant(ObjingEAnnotation.isConstant(role));
    }

    @objid ("08417afb-4583-11e0-b54c-00137279a832")
    private void setMultiMax(IInstance objingElt) {
        String value =  ObjingEAnnotation.getMultiMax(role);
        if (value != null)
            objingElt.setMultiplicityMax(value);
    }

    @objid ("08417afe-4583-11e0-b54c-00137279a832")
    private void setValue(IInstance objingElt) {
        String value =  ObjingEAnnotation.getValue(role);
        if (value != null)
            objingElt.setValue(value);
    }

    @objid ("08417b01-4583-11e0-b54c-00137279a832")
    private void setMultiMin(IInstance objingElt) {
        String value =  ObjingEAnnotation.getMultiMin(role);
        if (value != null)
            objingElt.setMultiplicityMin(value);
    }

    @objid ("08417b04-4583-11e0-b54c-00137279a832")
    private void attachBindableInstance(IBindableInstance objingElt) {
        // The objing element is an BindableInstance
        
        Element ecoreOwner = role.getOwner();
        
        IElement objingOwner = (IElement)  ReverseProperties.getInstance().getMappedElement(ecoreOwner);
        
        Boolean attached = false ;
        
        if ( ReverseProperties.getInstance().isRoundtripEnabled()){
        
            if (ObjingEAnnotation.isDeleted(role)){
                attached = true;
                Modelio.getInstance().getModelingSession().getModel().deleteElement(objingElt);
        
            }else {
                String ownerID = ObjingEAnnotation.getOwner(role);  
        
                if ((ownerID != null) && (ecoreOwner instanceof StructuredClassifier)){
        
                    for (Object attribute : ((StructuredClassifier) ecoreOwner).getOwnedAttributes()){
                        if (attribute instanceof Property){
                            Property prop = (Property) attribute;
                            List<String> ids =  ObjingEAnnotation.getObjingIDs(prop);
                            if (ids.size() > 0){
                                String id =ids.get(0);
                                if (id.equals(ownerID)){
                                    ((IBindableInstance)  ReverseProperties.getInstance().getMappedElement(prop)).addPart(objingElt);
                                    attached = true;
                                }
                            }
                        }
                    }
                }
            }
        }
        
        
        if (!attached){ 
            if (objingOwner instanceof IClassifier){
                ((IClassifier) objingOwner).addInternalStructure(objingElt);
            }else if ((objingOwner instanceof ICollaboration))
                objingElt.setOwner((ICollaboration) objingOwner);
            else if ((objingOwner instanceof IInteraction)){
                ObList<?> collabList =  ((IInteraction) objingOwner).getOwnedCollaboration();
                ICollaboration collab = null;
                if (!collabList.isEmpty()){
                    collab = ((ICollaboration)collabList.get(0));
                }else{
                    collab = Modelio.getInstance().getModelingSession().getModel().createCollaboration();
                    collab.setName("locals");
                    ((IInteraction) objingOwner).addOwnedCollaboration(collab);
                }
        
                if (collab.getCompositionOwner() instanceof IBehavior)
                    collab.addDeclared(objingElt);
                else
                    collab.addRepresentingInstance(objingElt);
            }
        }
    }

}
