/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDecisionMergeNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.DecisionNode;
import org.eclipse.uml2.uml.OpaqueBehavior;

@objid ("088b63e0-4583-11e0-b54c-00137279a832")
public class EDecisionNode extends EActivityNode implements IEElement {
    @objid ("088b63e1-4583-11e0-b54c-00137279a832")
    private DecisionNode ecoreElement;


    @objid ("088b63e2-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createDecisionMergeNode();
    }

    @objid ("088b63e6-4583-11e0-b54c-00137279a832")
    public EDecisionNode(DecisionNode element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("088b63ef-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("088dc63c-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("088dc641-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setDecisionInput((IDecisionMergeNode) objingElt);
    }

    @objid ("0890289b-4583-11e0-b54c-00137279a832")
    private void setDecisionInput(IDecisionMergeNode node) {
        Behavior decisionInput = ecoreElement.getDecisionInput();
        if (decisionInput != null && decisionInput instanceof OpaqueBehavior) {
            for (Object body : ((OpaqueBehavior) decisionInput).getBodies()) {
                if (!"".equals(body)) {
                    node.setDecisionInputBehavior((String) body);
                    break;
                }
            }
        }
    }

    @objid ("0890289e-4583-11e0-b54c-00137279a832")
    public EDecisionNode() {
    }

}
