/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import org.eclipse.uml2.uml.Device;

@objid ("08bfd79c-4583-11e0-b54c-00137279a832")
public class EDevice extends ENamedElement implements IEElement {

    @objid ("08bfd79d-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        IModelElement objElt = Modelio.getInstance().getModelingSession()
        .getModel().createNode();
        
        try{
            objElt.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(INode.class, XMIStereotypes.UML2DEVICE));
        }catch(StereotypeNotFoundException e){
            e.printStackTrace(Modelio.err);
        }
        return objElt;
    }

    @objid ("08bfd7a1-4583-11e0-b54c-00137279a832")
    public EDevice(Device element) {
        super(element);
    }

    @objid ("08c239fa-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        // Done by the super class Class
    }

    @objid ("08c239fd-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("08c23a02-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("08c49c50-4583-11e0-b54c-00137279a832")
    public EDevice() {
    }

}
