/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IProfile;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Enumeration;

@objid ("08eac1f1-4583-11e0-b54c-00137279a832")
public class EEnumeration extends EDataType implements IEElement {

    @objid ("08eac1f3-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance()
                .getModelingSession().getModel().createEnumeration();
    }

    @objid ("08eac1f7-4583-11e0-b54c-00137279a832")
    public EEnumeration(Enumeration element) {
        super(element);
    }

    @objid ("08ed244f-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        IModelTree objingOwner = EcoreModelNavigation.getNearestEnumerationOwner((Enumeration) getEcoreElement());
        
        if (objingOwner != null){
            IModelTree objingDTImport = (IModelTree) objingElt;
            if (objingOwner instanceof IProfile){
                objingDTImport.setOwner(ReverseProperties.getInstance().getExternalPackage());
            }else{
                objingDTImport.setOwner(objingOwner);
            }
        }
    }

    @objid ("08ed2452-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("08ed2457-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setElementary((IEnumeration) objingElt);
    }

    @objid ("08ef86a4-4583-11e0-b54c-00137279a832")
    private void setElementary(IEnumeration objingElt) {
        // Audit Rule number 80 (Warning): "An Enumeration is always primitive."
        objingElt.setElementary(true);
    }

    @objid ("08ef86a7-4583-11e0-b54c-00137279a832")
    public EEnumeration() {
    }

}
