/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.EnumerationLiteral;

@objid ("08ef86a9-4583-11e0-b54c-00137279a832")
public class EEnumerationLiteral extends ENamedElement implements IEElement {
    @objid ("08ef86aa-4583-11e0-b54c-00137279a832")
    private EnumerationLiteral ecoreElement;


    @objid ("08ef86ab-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createEnumerationLiteral();
    }

    @objid ("08f1e8ff-4583-11e0-b54c-00137279a832")
    public EEnumerationLiteral(EnumerationLiteral element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("08f1e908-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        Object objingEnumeration = ReverseProperties.getInstance()
                .getMappedElement(ecoreElement.getEnumeration());
                
        if ((objingEnumeration != null) && (objingEnumeration instanceof IEnumeration)) {
            IEnumerationLiteral objingLiteral = (IEnumerationLiteral) objingElt;
            objingLiteral.setValuated((IEnumeration)objingEnumeration);
        }
    }

    @objid ("08f1e90b-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("08f44b5b-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        // Sorting literals is no more usefull as the visit respects order of
        // elements.
        // private void setOrder(IEnumerationLiteral literal) {
        // IEnumeration objingEnum = literal.getValuated();
        //
        // if (objingEnum != null) {
        // IList<IEnumerationLiteral> objingLiterals = objingEnum.getValue();
        //
        // Enumeration ecoreEnum = ecoreElement.getEnumeration();
        // EList ecoreLiterals = ecoreEnum.getOwnedLiterals();
        //
        // if (ecoreLiterals.size() == objingLiterals.size()) {
        // // Order objing literals
        // ReverseProperties revProp = ReverseProperties.getInstance();
        // for (Object elt : ecoreLiterals) {
        // IElement objingEL = (IElement)
        // revProp.getMappedElement((Element)elt);
        // if (objingEL instanceof IEnumerationLiteral) {
        // objingEnum.removeValue((IEnumerationLiteral) objingEL);
        // objingEnum.addValue((IEnumerationLiteral) objingEL);
        // }
        // }
        // }
        // }
        // }
    }

    @objid ("08f44b61-4583-11e0-b54c-00137279a832")
    public EEnumerationLiteral() {
    }

}
