/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ExecutionEvent;

@objid ("09075e2a-4583-11e0-b54c-00137279a832")
public class EExecutionEvent extends ENamedElement implements IEElement {

    @objid ("09075e2c-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        Element ecoreOwner = getEcoreElement().getOwner();
        IElement objingOwner = (IElement) ReverseProperties.getInstance().getMappedElement(ecoreOwner);
        if (objingOwner instanceof IBehavior){
            IEvent result = Modelio.getInstance().getModelingSession().getModel().createEvent();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IEvent.class, XMIStereotypes.UML2EXECUTIONEVENT));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            return result;
        }
        return null;
    }

    @objid ("09075e30-4583-11e0-b54c-00137279a832")
    public EExecutionEvent(ExecutionEvent element) {
        super(element);
    }

    @objid ("0909c089-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
    }

    @objid ("0909c08c-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("090c22dc-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("090c22df-4583-11e0-b54c-00137279a832")
    public EExecutionEvent() {
    }

}
