/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOutputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ExpansionNode;

@objid ("0910e798-4583-11e0-b54c-00137279a832")
public class EExpansionNode extends ENamedElement implements IEElement {
    @objid ("0910e799-4583-11e0-b54c-00137279a832")
    private boolean isInput = false;


    @objid ("091349ea-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        ExpansionNode ecoreElt = (ExpansionNode)getEcoreElement();
        IModelElement objElement = null;
        if (ecoreElt.getRegionAsInput()!= null){
            objElement =  Modelio.getInstance().getModelingSession().getModel().createInputPin();
        }else{
            objElement =  Modelio.getInstance().getModelingSession().getModel().createOutputPin();
        }
        try{
            objElement.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(IPin.class, XMIStereotypes.UML2EXPANSIONNODE));
        }catch(StereotypeNotFoundException e){
               e.printStackTrace(Modelio.err);
        }
        return objElement;
    }

    @objid ("091349ee-4583-11e0-b54c-00137279a832")
    public EExpansionNode(ExpansionNode element) {
        super(element);
        if (element.getRegionAsInput()!= null){
            isInput = true;
        }else{
            isInput = false;
        }
    }

    @objid ("091349f7-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ExpansionNode ecoreElement = (ExpansionNode) getEcoreElement();
        Element region = ecoreElement.getOwner();
                
        IElement objOwner = (IElement) ReverseProperties.getInstance().getMappedElement(region);
                
        if ((objOwner != null) && (objOwner instanceof IStructuredActivityNode)){
                
            if (isInput)
                ((IStructuredActivityNode)objOwner).addInput((IInputPin) objingElt);
            else
                ((IStructuredActivityNode)objOwner).addOutput((IOutputPin) objingElt);
        }else{
            Modelio.getInstance().getModelingSession().getModel().deleteElement(objingElt);
        }
    }

    @objid ("0915ac44-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0915ac49-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0915ac4c-4583-11e0-b54c-00137279a832")
    public EExpansionNode() {
    }

}
