/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.IModelingSession;
import com.modeliosoft.modelio.api.model.IUmlModel;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.plugin.XMITagTypes;
import org.eclipse.uml2.uml.ExpansionRegion;

@objid ("09180e9e-4583-11e0-b54c-00137279a832")
public class EExpansionRegion extends EActivityNode implements IEElement {
    @objid ("09180e9f-4583-11e0-b54c-00137279a832")
    private ExpansionRegion ecoreElement = null;


    @objid ("09180ea0-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        IStructuredActivityNode region =  Modelio.getInstance().getModelingSession().getModel()
        .createStructuredActivityNode();
                
        try{
            region.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(IStructuredActivityNode.class, XMIStereotypes.UML2EXPANSIONREGION));
        }catch(StereotypeNotFoundException e){
             e.printStackTrace(Modelio.err);
        }
        return region;
    }

    @objid ("09180ea4-4583-11e0-b54c-00137279a832")
    public EExpansionRegion(ExpansionRegion element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("091a70f9-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("091a70fc-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("091a7101-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setMode((IStructuredActivityNode) objingElt);
    }

    @objid ("091a7104-4583-11e0-b54c-00137279a832")
    public EExpansionRegion() {
    }

    @objid ("091f35ac-4583-11e0-b54c-00137279a832")
    private void setMode(IStructuredActivityNode objingElt) {
        String mode = ecoreElement.getMode().getName();
        if ((mode != null) && (!mode.equals("")))
            try{
                IModelingSession session = Modelio.getInstance().getModelingSession();
                IUmlModel model = session.getModel();
                ITaggedValue objTag = model.createTaggedValue();        
                objTag.setAnnoted(objingElt);
                objTag.setDefinition(session.getMetamodelExtensions().getTagType(IStructuredActivityNode.class, XMITagTypes.UML2EXPANSIONREGION_MODE));
                ITagParameter value = model.createTagParameter(mode, objTag);
                objTag.addActual(value);
            }catch(Exception e){
                e.printStackTrace(Modelio.err);
            }
    }

}
