/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IFeature;
import com.modeliosoft.modelio.api.model.uml.statik.ObVisibilityModeEnum;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Feature;
import org.eclipse.uml2.uml.VisibilityKind;

@objid ("093bd1e4-4583-11e0-b54c-00137279a832")
public class EFeature extends ENamedElement {
    @objid ("093bd1e5-4583-11e0-b54c-00137279a832")
    private Feature ecoreFeatureElt;


    @objid ("093bd1e6-4583-11e0-b54c-00137279a832")
    public EFeature(Feature element) {
        super(element);
        ecoreFeatureElt = element;
    }

    @objid ("093bd1e9-4583-11e0-b54c-00137279a832")
    public void setVisibility(IElement objingElt) {
        if (objingElt instanceof IFeature) {
            IFeature objingElement = (IFeature) objingElt;
            switch (ecoreFeatureElt.getVisibility().getValue()) {
            case VisibilityKind.PACKAGE:
                objingElement
                        .setVisibility(ObVisibilityModeEnum.PACKAGE_VISIBILITY);
                break;
            case VisibilityKind.PRIVATE:
                objingElement.setVisibility(ObVisibilityModeEnum.PRIVATE);
                break;
            case VisibilityKind.PROTECTED:
                objingElement.setVisibility(ObVisibilityModeEnum.PROTECTED);
                break;
            case VisibilityKind.PUBLIC:
                objingElement.setVisibility(ObVisibilityModeEnum.PUBLIC);
                break;
            default:
                objingElement.setVisibility(ObVisibilityModeEnum.PUBLIC);
            }
            
            if (ReverseProperties.getInstance().isRoundtripEnabled())
                if (ObjingEAnnotation.isUndefined(ecoreFeatureElt))
                    objingElement.setVisibility(ObVisibilityModeEnum.VISIBILITY_UNDEFINED);
        }
    }

    @objid ("093bd1ec-4583-11e0-b54c-00137279a832")
    public EFeature() {
    }

    @objid ("6aff29b7-1a76-11e1-8103-0027103f347d")
    public void setProperties(final IElement objingElt) {
        super.setProperties(objingElt);
    }

}
