/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IForkJoinNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.ForkNode;

@objid ("094c825a-4583-11e0-b54c-00137279a832")
public class EForkNode extends EActivityNode implements IEElement {
    @objid ("094c825b-4583-11e0-b54c-00137279a832")
    private ForkNode ecoreElement;


    @objid ("094c825c-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createForkJoinNode();
    }

    @objid ("094c8260-4583-11e0-b54c-00137279a832")
    public EForkNode(ForkNode element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("094ee4b4-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("094ee4b7-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("094ee4bc-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setJoinSpec((IForkJoinNode) objingElt);
        setCombineDuplicate((IForkJoinNode) objingElt);
    }

    @objid ("09514719-4583-11e0-b54c-00137279a832")
    private void setCombineDuplicate(IForkJoinNode node) {
        if (ReverseProperties.getInstance().isRoundtripEnabled())
            node.setCombineDuplicate(ObjingEAnnotation.isCombineDuplicate(ecoreElement));
    }

    @objid ("0951471c-4583-11e0-b54c-00137279a832")
    private void setJoinSpec(IForkJoinNode node) {
        if (ReverseProperties.getInstance().isRoundtripEnabled())
        node.setJoinSpec(ObjingEAnnotation.getJoinSpec(ecoreElement));
    }

    @objid ("0953a968-4583-11e0-b54c-00137279a832")
    public EForkNode() {
    }

}
