/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ObObjectNodeOrderingKindEnum;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralClass;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import com.modeliosoft.modelio.xmi.util.XMILogs;
import org.eclipse.emf.common.util.EList;
import org.eclipse.uml2.uml.Action;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.CallAction;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.ObjectNodeOrderingKind;
import org.eclipse.uml2.uml.OpaqueBehavior;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.TestIdentityAction;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.ValuePin;
import org.eclipse.uml2.uml.ValueSpecification;

@objid ("099408eb-4583-11e0-b54c-00137279a832")
public class EInputPin extends EPin implements IEElement {
    @objid ("099408ed-4583-11e0-b54c-00137279a832")
    private InputPin ecoreElement;


    @objid ("099408ef-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        IInputPin element = Modelio.getInstance().getModelingSession().getModel()
        .createInputPin();
        if (ecoreElement.getOwner() instanceof TestIdentityAction){
            if (((TestIdentityAction)ecoreElement.getOwner()).getFirst().equals(ecoreElement)){
                try{
                    IStereotype stereo = Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                    .getStereotype(IInputPin.class, XMIStereotypes.UML2FIRST);
                    element.addExtension(stereo);
                }catch(StereotypeNotFoundException e){
                    Modelio.err.println("StereotypeNotFoundException : ");
                    e.printStackTrace(Modelio.err);
                }
            }else  if (((TestIdentityAction)ecoreElement.getOwner()).getSecond().equals(ecoreElement)){
                try{
                    IStereotype stereo = Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                    .getStereotype(IInputPin.class, XMIStereotypes.UML2SECOND);
                    element.addExtension(stereo);
                }catch(StereotypeNotFoundException e){
                    Modelio.err.println("StereotypeNotFoundException : ");
                    e.printStackTrace(Modelio.err);
                }
            }
        }else if (ecoreElement.getOwner() instanceof CallOperationAction){
            InputPin input = ((CallOperationAction)ecoreElement.getOwner()).getTarget();
            if ((input != null) && (input.equals(ecoreElement))){
                try{
                    IStereotype stereo = Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                    .getStereotype(IInputPin.class, XMIStereotypes.UML2TARGET);
                    element.addExtension(stereo);
                }catch(StereotypeNotFoundException e){
                    Modelio.err.println("StereotypeNotFoundException : ");
                    e.printStackTrace(Modelio.err);
                }
            }
        }
        return element;
    }

    @objid ("09966b41-4583-11e0-b54c-00137279a832")
    public EInputPin(InputPin element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("09966b4a-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        attachToAction(objingElt);
    }

    @objid ("09966b4d-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0998cd9d-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        // Properties defined on ModelElement
        super.setProperties(objingElt); 
        
        // Properties defined on ObjectNode
        setControlType((IInputPin) objingElt);
        setOrdering((IInputPin) objingElt);
        setSelectionBehavior((IInputPin) objingElt);
        setType((IInputPin) objingElt);
        // setRepresented((IInputPin)objingElt);
        // setRepresentedAttribute((IInputPin)objingElt);
        // setRepresentedRole((IInputPin)objingElt);
        // setRepresentedRealParameter((IInputPin)objingElt);
        setState((IInputPin) objingElt);
        
        // Properties defined on Pin
        setControl((IInputPin) objingElt);
        setExpansionEAnnotation((IInputPin) objingElt);
        setMatched((IInputPin) objingElt);
        
        // Properties defined on InputPin
        // setSelf((IInputPin)objingElt);
        setValue((IInputPin) objingElt);
    }

    @objid ("0998cda0-4583-11e0-b54c-00137279a832")
    private void attachToAction(IElement objingElt) {
        Action ecoreAction = (Action) getEcoreElement().getOwner();
        
        Object objingAction = ReverseProperties.getInstance().getMappedElement(ecoreAction);
        if (objingAction instanceof IActivityAction) 
            ((IInputPin) objingElt).setInputing((IActivityAction) objingAction);
        else{
            XMILogs.getInstance().writelnInLog("owner of pin was " + objingAction.getClass().getSimpleName());
            Modelio.getInstance().getModelingSession().getModel().deleteElement(objingElt);
        }
    }

    @objid ("099b2ffd-4583-11e0-b54c-00137279a832")
    private void setControlType(IInputPin pin) {
        pin.setControlType(ecoreElement.isControlType());
    }

    @objid ("099b3000-4583-11e0-b54c-00137279a832")
    private void setOrdering(IInputPin pin) {
        switch (ecoreElement.getOrdering().getValue()) {
        case ObjectNodeOrderingKind.FIFO:
            pin.setOrdering(ObObjectNodeOrderingKindEnum.F_I_F_O);
            break;
        case ObjectNodeOrderingKind.LIFO:
            pin.setOrdering(ObObjectNodeOrderingKindEnum.L_I_F_O);
            break;
        case ObjectNodeOrderingKind.ORDERED:
            pin.setOrdering(ObObjectNodeOrderingKindEnum.ORDERED);
            break;
        case ObjectNodeOrderingKind.UNORDERED:
            pin.setOrdering(ObObjectNodeOrderingKindEnum.UNORDERED);
            break;
        default:
            pin.setOrdering(ObObjectNodeOrderingKindEnum.F_I_F_O);
        }
    }

    @objid ("099b3003-4583-11e0-b54c-00137279a832")
    private void setSelectionBehavior(IInputPin pin) {
        Behavior ecoreBehavior = ecoreElement.getSelection();
        if (ecoreBehavior instanceof OpaqueBehavior) {
            String objingBehavior = "";
            for (Object body : ((OpaqueBehavior) ecoreBehavior).getBodies()) {
                objingBehavior = objingBehavior.concat((String) body);
            }
            pin.setSelectionBehavior(objingBehavior);
        } else if (ecoreBehavior != null) {
            String behaviorName = ecoreBehavior.getName();
            if (behaviorName != null)
                pin.setSelectionBehavior(behaviorName);
        }
    }

    @objid ("099d9251-4583-11e0-b54c-00137279a832")
    private void setType(IInputPin pin) {
        Type ecoreType = ecoreElement.getType();
        if (ecoreType != null) {
        
            Object objingType = ReverseProperties.getInstance().getMappedElement(ecoreType);
            if (objingType instanceof IGeneralClass)
                pin.setType((IGeneralClass) objingType);
        
        }
    }

    @objid ("099d9254-4583-11e0-b54c-00137279a832")
    private void setState(IInputPin pin) {
        EList<?> ecoreStates = ecoreElement.getInStates();
        if (ecoreStates != null && ecoreStates.size() > 0) {
            State ecoreState = (State) ecoreStates.get(0);
            if (ecoreState != null) {
                Object objingState = ReverseProperties.getInstance().getMappedElement(ecoreState);
                if (objingState instanceof IState)
                    pin.setInState((IState) objingState);
            }
        }
    }

    @objid ("099d9257-4583-11e0-b54c-00137279a832")
    private void setControl(IInputPin pin) {
        pin.setControl(ecoreElement.isControl());
    }

    @objid ("099d925a-4583-11e0-b54c-00137279a832")
    private void setExpansionEAnnotation(IInputPin pin) {
        pin.setExpansion(ObjingEAnnotation.isExpansion(ecoreElement));
    }

    @objid ("099ff4a8-4583-11e0-b54c-00137279a832")
    private void setMatched(IInputPin pin) {
        Element ecoreOwnerElt = ecoreElement.getOwner();
        Object obOwner = ReverseProperties.getInstance().getMappedElement(ecoreOwnerElt);
        
        if ((ecoreOwnerElt instanceof CallAction) && (obOwner instanceof ICallAction)){
        
            List<Parameter> ecoreParamList = EcoreModelNavigation
            .getMatchedParameters(ecoreElement);
        
            List<InputPin> inputPinList = ((CallAction) ecoreOwnerElt).getArguments();
            
            for (Parameter ecoreParam : ecoreParamList) {
        
                if (((ecoreElement.getType() != null)
                        && (ecoreParam.getType() != null)
                        && (ecoreElement.getType().equals(ecoreParam.getType())))
                        && (EcoreModelNavigation.getMultiplicityMax(ecoreElement).equals(EcoreModelNavigation.getMultiplicityMax(ecoreParam)))
                        && (EcoreModelNavigation.getMultiplicityMin(ecoreElement).equals(EcoreModelNavigation.getMultiplicityMin(ecoreParam)))
                        && (ecoreParamList.indexOf(ecoreParam) == inputPinList.indexOf(ecoreElement))
        //                        && (EcoreModelNavigation.getOrdering(ecoreParam) == EcoreModelNavigation.getOrdering(ecoreElement))
                        ){
        
                    Object obParam = ReverseProperties.getInstance()
                    .getMappedElement(ecoreParam);
        
                    if (obParam instanceof IParameter) {
                        pin.setMatched((IParameter) obParam);
                    }
                }
            }
        }
    }

    @objid ("099ff4b0-4583-11e0-b54c-00137279a832")
    public EInputPin() {
    }

    @objid ("6b1c0200-1a76-11e1-8103-0027103f347d")
    private void setValue(final IInputPin pin) {
        //        if (ecoreElement instanceof ValuePin) {
        //            ValueSpecification valueSpecif = ((ValuePin) ecoreElement)
        //            .getValue();
        //            if (valueSpecif != null) {
        //                String value = valueSpecif.stringValue();
        //                if (value != null)
        //                    pin.setValue(value); 
        //            }
        //        }
    }

}
