/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.InstanceSpecification;
import org.eclipse.uml2.uml.InstanceValue;

@objid ("09abe06a-4583-11e0-b54c-00137279a832")
public class EInstanceValue extends ENamedElement implements IEElement {
    @objid ("09abe06b-4583-11e0-b54c-00137279a832")
    private InstanceValue ecoreElement;


    @objid ("09abe06c-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        try{
        InstanceSpecification instance = ecoreElement.getInstance();
                
        if (instance != null) {
            Object temp = ReverseProperties.getInstance().getMappedElement(instance);
            if (temp instanceof IInstance){
                IInstance objInstance = (IInstance) temp;
                if (objInstance instanceof IBindableInstance){
                    if ((((IBindableInstance) objInstance).getInternalOwner()== null) && (((IBindableInstance) objInstance).getOwner() == null))
                        ((IBindableInstance) objInstance).setCluster(
                            (IInstance) ReverseProperties.getInstance().getMappedElement(ecoreElement.getInstance()));
                }
            }
        }
        }catch(ClassCastException e){
            e.printStackTrace(Modelio.err);
        }
        return null;
    }

    @objid ("09abe070-4583-11e0-b54c-00137279a832")
    public EInstanceValue(InstanceValue element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("09ae42c7-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        // TODO Auto-generated method stub
    }

    @objid ("09ae42ca-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("09ae42cf-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("09ae42d2-4583-11e0-b54c-00137279a832")
    public EInstanceValue() {
    }

}
