/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.model.uml.statik.IProvidedInterface;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Port;

@objid ("09d6cac0-4583-11e0-b54c-00137279a832")
public class EInterfaceRealization extends ENamedElement implements IEElement {
    @objid ("09d6cac1-4583-11e0-b54c-00137279a832")
    private InterfaceRealization ecoreElement;


    @objid ("09d6cac2-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        if ((ecoreElement.getClients().size() > 0) && (ecoreElement.getClients().get(0) instanceof Port))
            return Modelio.getInstance().getModelingSession().getModel().createProvidedInterface();
        else if (((ecoreElement.getClients().size() > 0) && (ecoreElement.getClients().get(0) instanceof IInterface))
                || (ecoreElement.getContract() != null))
            return  Modelio.getInstance().getModelingSession().getModel().createInterfaceRealization();
        else 
            return null;
    }

    @objid ("09d6cac5-4583-11e0-b54c-00137279a832")
    public EInterfaceRealization(InterfaceRealization element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("09d92d1f-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        // I take the ecore Imported and Importing
        Interface ecoreContract = ecoreElement.getContract();
        BehavioredClassifier ecoreClassifier = ecoreElement
        .getImplementingClassifier();
        
        boolean attached = false;
        if (ecoreContract != null && ecoreClassifier != null) {
            IInterface objingContract = (IInterface) ReverseProperties.getInstance()
            .getMappedElement(ecoreContract);
            INameSpace objingClassifier = (INameSpace) ReverseProperties.getInstance()
            .getMappedElement(ecoreClassifier);
        
            // I set to the objingElt Imported Importing previousely find
            if (objingContract != null && objingClassifier != null) {
                IInterfaceRealization objingRImport = (IInterfaceRealization) objingElt;
                objingRImport.setImplementer(objingClassifier);
                objingRImport.setImplemented(objingContract);
                attached = true;
            }
        }
        
        if ((ecoreElement.getClients().get(0) instanceof Port)){
            IPort objPort = (IPort) ReverseProperties.getInstance().getMappedElement(ecoreElement.getClients().get(0));
            objPort.addProvided((IProvidedInterface)objingElt);
            ((IProvidedInterface)objingElt).setProviding(objPort);
            for (NamedElement element : ecoreElement.getSuppliers()){
                Object obj =  ReverseProperties.getInstance().getMappedElement(element);
                if (obj instanceof IInterface){
                    ((IProvidedInterface)objingElt).addProvidedElement((IInterface)obj);
                }
            }
            attached = true;
        }
        
        if ((!attached)  && (ecoreElement.getSuppliers().get(0) instanceof Interface)
                && (ecoreElement.getClients().get(0) instanceof BehavioredClassifier)){
            ecoreContract = (Interface) ecoreElement.getSuppliers().get(0);
            ecoreClassifier = (BehavioredClassifier) ecoreElement.getClients().get(0);
        
            IInterface objingContract = (IInterface) ReverseProperties.getInstance()
            .getMappedElement(ecoreContract);
            INameSpace objingClassifier = (INameSpace) ReverseProperties.getInstance()
            .getMappedElement(ecoreClassifier);
        
            // I set to the objingElt Imported Importing previousely find
            if (objingContract != null && objingClassifier != null) {
                IInterfaceRealization objingRImport = (IInterfaceRealization) objingElt;
                objingRImport.setImplementer(objingClassifier);
                objingRImport.setImplemented(objingContract);
            }
        }
    }

    @objid ("09d92d22-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("09db8f72-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        
        //        if (objingElt instanceof IInterfaceRealization)
        //                if ((ecoreElement.getClients().get(0) instanceof Port)){
        //                    IPort objPort = (IPort) revProp.getMappedElement(ecoreElement.getClients().get(0));
        //                }
    }

    @objid ("09db8f78-4583-11e0-b54c-00137279a832")
    public EInterfaceRealization() {
    }

}
