/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityEdge;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInterruptibleActivityRegion;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.ActivityEdge;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.InterruptibleActivityRegion;

@objid ("09db8f7a-4583-11e0-b54c-00137279a832")
public class EInterruptibleActivityRegion extends EElement implements IEElement {
    @objid ("09db8f7b-4583-11e0-b54c-00137279a832")
    private InterruptibleActivityRegion ecoreElement;


    @objid ("09ddf1cc-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createInterruptibleActivityRegion();
    }

    @objid ("09ddf1d4-4583-11e0-b54c-00137279a832")
    public EInterruptibleActivityRegion(InterruptibleActivityRegion element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("09e05427-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        Element ecoreOwner = ecoreElement.getOwner();
                
        if (ecoreOwner != null) {
            Object objingOwner = ReverseProperties.getInstance().getMappedElement(ecoreOwner);
                
            if (objingOwner instanceof IActivity)
                ((IInterruptibleActivityRegion) objingElt)
                        .setInActivity((IActivity) objingOwner);
        }
    }

    @objid ("09e0542a-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("09e0542f-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        setInterrupts((IInterruptibleActivityRegion) objingElt);
        setName((IInterruptibleActivityRegion) objingElt);

    	super.setProperties(objingElt);
    }

    @objid ("09e05432-4583-11e0-b54c-00137279a832")
    private void setInterrupts(IInterruptibleActivityRegion region) {
        for (Object ecoreInterruptingEdge : ecoreElement.getInterruptingEdges()) {
            Object objingInterruptingEdge = ReverseProperties.getInstance()
                    .getMappedElement((ActivityEdge) ecoreInterruptingEdge);
            if (objingInterruptingEdge instanceof IActivityEdge)
                ((IActivityEdge) objingInterruptingEdge).setInterrupts(region);
        }
    }

    @objid ("09e2b680-4583-11e0-b54c-00137279a832")
    private void setName(IInterruptibleActivityRegion region) {
        if (ReverseProperties.getInstance().isRoundtripEnabled())
        region.setName(ObjingEAnnotation.getName(ecoreElement));
    }

    @objid ("09e2b683-4583-11e0-b54c-00137279a832")
    public EInterruptibleActivityRegion() {
    }

}
