/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IForkJoinNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.JoinNode;
import org.eclipse.uml2.uml.ValueSpecification;

@objid ("09f366fc-4583-11e0-b54c-00137279a832")
public class EJoinNode extends EActivityNode implements IEElement {
    @objid ("09f366fd-4583-11e0-b54c-00137279a832")
    private JoinNode ecoreElement;


    @objid ("09f366fe-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createForkJoinNode();
    }

    @objid ("09f5c951-4583-11e0-b54c-00137279a832")
    public EJoinNode(JoinNode element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("09f5c95a-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("09f82baa-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("09f82baf-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        
        setJoinSpec((IForkJoinNode) objingElt);
        setCombineDuplicate((IForkJoinNode) objingElt);
    }

    @objid ("09fa8e0a-4583-11e0-b54c-00137279a832")
    private void setJoinSpec(IForkJoinNode node) {
        ValueSpecification joinSpec = ecoreElement.getJoinSpec();
        if (joinSpec != null) {
            String value = joinSpec.stringValue();
            if (value != null)
                node.setJoinSpec(value);
        }
    }

    @objid ("09fa8e0d-4583-11e0-b54c-00137279a832")
    private void setCombineDuplicate(IForkJoinNode node) {
        node.setCombineDuplicate(ecoreElement.isCombineDuplicate());
    }

    @objid ("09fa8e10-4583-11e0-b54c-00137279a832")
    public EJoinNode() {
    }

}
