/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IProfile;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Node;

@objid ("0a5c4e75-4583-11e0-b54c-00137279a832")
public class ENode extends ENamedElement implements IEElement {

    @objid ("0a5eb0c8-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession()
        .getModel().createNode();
    }

    @objid ("0a5eb0cc-4583-11e0-b54c-00137279a832")
    public ENode(Node element) {
        super(element);
    }

    @objid ("0a5eb0d5-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        
        Element ecoreOwner = getEcoreElement().getOwner();
        
        IModelElement objingOwner = (IModelElement) revProp
        .getMappedElement(ecoreOwner);
        INode objingCollab = (INode) objingElt;
        
        if (objingOwner instanceof IProfile) {
            objingCollab.setOwner(revProp.getExternalPackage());
        } else if (objingOwner instanceof IModelTree) {
            objingCollab.setOwner((IModelTree) objingOwner);
        } else {
            objingCollab.setOwner(revProp.getExternalPackage());
        }
    }

    @objid ("0a611322-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0a611327-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0a61132a-4583-11e0-b54c-00137279a832")
    public ENode() {
    }

}
