/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.ArrayList;
import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.OpaqueAction;

@objid ("0a7b4d08-4583-11e0-b54c-00137279a832")
public class EOpaqueAction extends EActivityNode implements IEElement {
    @objid ("0a7daf5a-4583-11e0-b54c-00137279a832")
    private OpaqueAction ecoreElement;


    @objid ("0a7daf5b-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
        .createOpaqueAction();
    }

    @objid ("0a7daf5f-4583-11e0-b54c-00137279a832")
    public EOpaqueAction(OpaqueAction element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0a7daf62-4583-11e0-b54c-00137279a832")
    public List<String> getObjingClassName() {
        List<String> result = new ArrayList<String>();
        result.add("");
        return result;
    }

    @objid ("0a8011b4-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("0a8011b7-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0a8011bc-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setBody((IOpaqueAction) objingElt);
    }

    @objid ("0a82741a-4583-11e0-b54c-00137279a832")
    private void setBody(IOpaqueAction action) {
        String bodies = "";
        for (Object body : ecoreElement.getBodies()) {
            bodies = bodies.concat((String) body);
        }
        action.setBody(bodies);
    }

    @objid ("0a82741d-4583-11e0-b54c-00137279a832")
    public EOpaqueAction() {
    }

}
