/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.core.app.O;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Component;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.Profile;

@objid ("0aafc0c3-4583-11e0-b54c-00137279a832")
public class EPackage extends ENamedElement implements IEElement {

    @objid ("0ab22316-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        for (Package ecoremodel : ReverseProperties.getInstance().getEcoreModel()){
            if (getEcoreElement().equals(ecoremodel)){
                return Modelio.getInstance().getModelingSession().getModel().getRoot();
                }
        }
        if (ObjingEAnnotation.isRequirementContainer(getEcoreElement()))
            return O.getDefault().getModelingSession().getModelFactory().createRequirementContainer();
        IPackage objingElt = Modelio.getInstance().getModelingSession().getModel().createPackage();
        ((IPackage)objingElt).setName(((NamedElement)getEcoreElement()).getName());
        return  objingElt;
    }

    @objid ("0ab2231a-4583-11e0-b54c-00137279a832")
    public EPackage(Package element) {
        super(element);
    }

    @objid ("0ab22323-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        Element ecoreOwner = getEcoreElement().getOwner();
        
        IElement objingOwner = (IElement) revProp.getMappedElement(ecoreOwner);
        IPackage objingPkg = (IPackage) objingElt;
        if (ecoreOwner instanceof Profile) {
              objingPkg.setOwner(revProp.getExternalPackage());
        }else if (ecoreOwner instanceof Package) {
            objingPkg.setOwner((IPackage) objingOwner);
        }else if (ecoreOwner instanceof Component){
            objingPkg.setOwner((IComponent) objingOwner);
        }
    }

    @objid ("0ab48571-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0ab48576-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        //        setVisibility(objingElt);
        if (ReverseProperties.getInstance().isRoundtripEnabled()) {
            setAbstractEAnnotation((IPackage) objingElt);
            setInstantiableEAnnotation((IPackage) objingElt);
            setLeafEAnnotation((IPackage) objingElt);
            setRootEAnnotation((IPackage) objingElt);
        }
    }

    @objid ("0ab4857c-4583-11e0-b54c-00137279a832")
    private void setAbstractEAnnotation(IPackage objingElt) {
        objingElt.setAbstract(ObjingEAnnotation.isAbstract((((Package)getEcoreElement()))));
    }

    @objid ("0ab4857f-4583-11e0-b54c-00137279a832")
    private void setInstantiableEAnnotation(IPackage objingElt) {
        objingElt.setInstantiable(ObjingEAnnotation.isInstantiable((((Package)getEcoreElement()))));
    }

    @objid ("0ab48582-4583-11e0-b54c-00137279a832")
    private void setLeafEAnnotation(IPackage objingElt) {
        objingElt.setLeaf(ObjingEAnnotation.isLeaf((((Package)getEcoreElement()))));
    }

    @objid ("0ab48585-4583-11e0-b54c-00137279a832")
    private void setRootEAnnotation(IPackage objingElt) {
        objingElt.setRoot(ObjingEAnnotation.isRoot((((Package)getEcoreElement()))));
    }

    @objid ("0ab48588-4583-11e0-b54c-00137279a832")
    public EPackage() {
    }

}
