/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageMerge;

@objid ("0abbac83-4583-11e0-b54c-00137279a832")
public class EPackageMerge extends EElement implements IEElement {
    @objid ("0abbac84-4583-11e0-b54c-00137279a832")
    private PackageMerge ecoreElement;


    @objid ("0abbac85-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance()
                .getModelingSession().getModel().createPackageMerge();
    }

    @objid ("0abe0ede-4583-11e0-b54c-00137279a832")
    public EPackageMerge(PackageMerge element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0ac535e6-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
                
        // I take the ecore Imported and Importing
        Package ecoreMergedPackage = ecoreElement.getMergedPackage();
        Package ecoreReceivingPackage = ecoreElement.getReceivingPackage();
                
        IPackage objingMergedPackage = (IPackage) revProp
                .getMappedElement(ecoreMergedPackage);
        IPackage objingReceivingPackage = (IPackage) revProp
                .getMappedElement(ecoreReceivingPackage);
                
        if (objingMergedPackage != null && objingReceivingPackage != null) {
            IPackageMerge objingPMImport = (IPackageMerge) objingElt;
            objingPMImport.setMergedPackage(objingMergedPackage);
            objingPMImport.setReceivingPackage(objingReceivingPackage);
        }
    }

    @objid ("0ac535e9-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0ac535ee-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        setName((IPackageMerge) objingElt);

    	super.setProperties(objingElt);
    }

    @objid ("0ac535f1-4583-11e0-b54c-00137279a832")
    private void setName(IPackageMerge objingElt) {
    }

    @objid ("0ac535f4-4583-11e0-b54c-00137279a832")
    public EPackageMerge() {
    }

}
