/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IPin;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.Pin;
import org.eclipse.uml2.uml.ValueSpecification;

@objid ("0add0d6f-4583-11e0-b54c-00137279a832")
public class EPin extends EActivityNode implements IEElement {

    @objid ("0add0d71-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return null;
    }

    @objid ("0adf6fc5-4583-11e0-b54c-00137279a832")
    public EPin(Pin element) {
        super(element);
    }

    @objid ("0adf6fce-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
    }

    @objid ("0ae1d21e-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0ae1d223-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        
            
        setUpperBound((IPin) objingElt);
    }

    @objid ("0ae1d226-4583-11e0-b54c-00137279a832")
    public EPin() {
    }

    @objid ("68d7999a-1a76-11e1-8103-0027103f347d")
    private void setUpperBound(final IPin pin) {
        Pin ecoreElement = (Pin) this.getEcoreElement();
        ValueSpecification ecoreUpperBound = ecoreElement.getUpperBound();
        if (ecoreUpperBound != null) {
            String stringValue = ecoreUpperBound.stringValue();
            if (stringValue != null)
                pin.setUpperBound(stringValue);
        }else{
            ecoreUpperBound = ecoreElement.getUpperValue();
            if (ecoreUpperBound != null) {
                String stringValue = ecoreUpperBound.stringValue();
                if (stringValue != null)
                    pin.setUpperBound(stringValue);
            }
        }
    }

}
