/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.ObVisibilityModeEnum;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ProfileUtils;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.VisibilityKind;

@objid ("0af9a9a6-4583-11e0-b54c-00137279a832")
public class EProfile extends ENamedElement implements IEElement {
    @objid ("0af9a9a7-4583-11e0-b54c-00137279a832")
    private Profile ecoreElement;


    @objid ("0af9a9a8-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return ProfileUtils.createObjProfile(ecoreElement);
    }

    @objid ("0afc0bfc-4583-11e0-b54c-00137279a832")
    public EProfile(Profile element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0afc0c05-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        // TODO Auto-generated method stub
    }

    @objid ("0afc0c08-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0afe6e59-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        if (objingElt instanceof INameSpace)
            setVisibility((INameSpace) objingElt);
    }

    @objid ("0afe6e5c-4583-11e0-b54c-00137279a832")
    public EProfile() {
    }

    @objid ("9142e5c7-b156-11e1-9c24-0027103f347d")
    private void setVisibility(INameSpace objingElt) {
        NamedElement ecoreNamedElt = (NamedElement) getEcoreElement();
        if (objingElt.getElementStatus().isModifiable()){
            switch (ecoreNamedElt.getVisibility().getValue()) {
            case VisibilityKind.PACKAGE:
                objingElt
                .setVisibility(ObVisibilityModeEnum.PACKAGE_VISIBILITY);
                break;
            case VisibilityKind.PRIVATE:
                objingElt.setVisibility(ObVisibilityModeEnum.PRIVATE);
                break;
            case VisibilityKind.PROTECTED:
                objingElt.setVisibility(ObVisibilityModeEnum.PROTECTED);
                break;
            case VisibilityKind.PUBLIC:
                objingElt.setVisibility(ObVisibilityModeEnum.PUBLIC);
                break;
            default:
                objingElt.setVisibility(ObVisibilityModeEnum.PUBLIC);
            }
        
            if (ObjingEAnnotation.isUndefined(ecoreNamedElt))
                objingElt.setVisibility(ObVisibilityModeEnum.VISIBILITY_UNDEFINED);
        }
    }

}
