/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.emf.common.util.EList;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.ProtocolTransition;

@objid ("0b307fbc-4583-11e0-b54c-00137279a832")
public class EProtocolTransition extends ETransition implements IEElement {
    @objid ("0b307fbd-4583-11e0-b54c-00137279a832")
    private boolean isInternalTransition;

    @objid ("0b32e212-4583-11e0-b54c-00137279a832")
    private ProtocolTransition ecoreElement;


    @objid ("0b32e213-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        if (isInternalTransition)
            return Modelio.getInstance().getModelingSession().getModel()
            .createInternalTransition();
        return Modelio.getInstance().getModelingSession().getModel()
        .createTransition();
    }

    @objid ("0b32e217-4583-11e0-b54c-00137279a832")
    public EProtocolTransition(ProtocolTransition element) {
        super(element);
        ecoreElement = element;
        isInternalTransition = EcoreModelNavigation
        .isInternalTransition(element);
    }

    @objid ("0b35446c-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("0b35446f-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0b354474-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setProcessed((ITransition) objingElt);
    }

    @objid ("0b354477-4583-11e0-b54c-00137279a832")
    private void setProcessed(ITransition transition) {
        EList<?> referreds = ecoreElement.getReferreds();
        if (referreds.size() > 0) {
            Operation ecoreOp = (Operation) referreds.get(0);
            Object objingOp = ReverseProperties.getInstance().getMappedElement(ecoreOp);
            if (objingOp instanceof IOperation) {
                transition.setProcessed((IOperation) objingOp);
            }
        }
    }

    @objid ("0b37a6c6-4583-11e0-b54c-00137279a832")
    public EProtocolTransition() {
    }

}
