/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.ArrayList;
import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.reverse.PartialImportMap;
import com.modeliosoft.modelio.xmi.reverse.TotalImportMap;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.RedefinableTemplateSignature;

@objid ("0bb13eb6-4583-11e0-b54c-00137279a832")
public class ERedefinableTemplateSignature extends ENamedElement implements IEElement {
    @objid ("0bb13eb7-4583-11e0-b54c-00137279a832")
    private RedefinableTemplateSignature ecoreElement;


    @objid ("0bb13eb8-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        Element ecoreOwner = ecoreElement.getOwner();
        Object objingOwner =  ReverseProperties.getInstance().getMappedElement(ecoreOwner);
        if ((objingOwner instanceof IClassifier)  && !(objingOwner instanceof IEnumeration)){
            IOperation result = Modelio.getInstance().getModelingSession().getModel().createOperation();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IOperation.class, XMIStereotypes.UML2REDEFINABLETEMPLATESIGNATURE));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            return result;
        }else 
            return null;
    }

    @objid ("0bb3a10e-4583-11e0-b54c-00137279a832")
    public ERedefinableTemplateSignature(RedefinableTemplateSignature element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0bb3a111-4583-11e0-b54c-00137279a832")
    public List<String> getObjingClassName() {
        List<String> result = new ArrayList<String>();
        result.add("");
        return result;
    }

    @objid ("0bb3a117-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        if (objingElt != null) {
            ReverseProperties revProp = ReverseProperties.getInstance();
        
            Element ecoreOwner = ecoreElement.getOwner();
            IElement objingOwner = (IElement) revProp
            .getMappedElement(ecoreOwner);
        
            if (objingOwner instanceof IClassifier)
                ((IOperation) objingElt).setOwner((IClassifier) objingOwner);
            else {
                PartialImportMap.getInstance().remove(ecoreElement);
                TotalImportMap.getInstance().remove(ecoreElement);
                Modelio.getInstance().getModelingSession().getModel()
                .deleteElement(objingElt);
            }
        }
    }

    @objid ("0bb3a11a-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0bb6036b-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0bb6036e-4583-11e0-b54c-00137279a832")
    public ERedefinableTemplateSignature() {
    }

}
