/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.StateMachine;

@objid ("0bbf8cd0-4583-11e0-b54c-00137279a832")
public class ERegion extends ENamedElement implements IEElement {
    @objid ("0bbf8cd1-4583-11e0-b54c-00137279a832")
    private Region ecoreElement;


    @objid ("0bbf8cd2-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        IRegion region = null;
                
        Element ecoreElt = ecoreElement.getOwner();
                
        if  ( ecoreElt instanceof StateMachine){
            region = ((IStateMachine) ReverseProperties.getInstance().getMappedElement(ecoreElt)).getTop();
        
        }else{
            region = Modelio.getInstance().getModelingSession().getModel().createRegion();
        }
        return region;
    }

    @objid ("0bbf8cd6-4583-11e0-b54c-00137279a832")
    public ERegion(Region element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0bc1ef32-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        IElement objOwner = (IElement) ReverseProperties.getInstance().getMappedElement(ecoreElement.getOwner());
         
        
        if ((objOwner != null ) && (objOwner instanceof IState)){
            ((IState) objOwner).addOwnedRegion((IRegion)objingElt);
            ((IRegion)objingElt).setParent((IState) objOwner);
        }
        
        
        if ((objOwner != null ) && (objOwner instanceof IStateMachine)){
            ((IStateMachine) objOwner).setTop((IRegion)objingElt);
            ((IRegion)objingElt).setRepresented((IStateMachine) objOwner);
            
        }
        
                
                //        if (ecoreOwner != null) {
                //        Object objingOwner = ReverseProperties.getInstance().getMappedElement(ecoreOwner);
                //        if (objingOwner instanceof IState) {
                //        ((IState) objingElt).setParent((IState) objingOwner);
                //        } else if (objingOwner instanceof IStateMachine) {
                //        EList rootRegionList = ((StateMachine) ecoreOwner).getRegions();
                //        if (rootRegionList.size() == 1) {
                //        ((IStateMachine) objingOwner).setTop((IState) objingElt);
                //        } else {
                //        // Case of 2 root regions: creation of the composite state:
                //        IState objingRegionContainer = Modelio.getInstance()
                //        .getModelingSession().getModel().createState();
                //        IState topState = ((IStateMachine) objingOwner).getTop();
                //        objingRegionContainer.setParent(topState);
                //        ((IStateMachine) objingOwner)
                //        .addTopStates(objingRegionContainer);
                //        objingRegionContainer.setConcurrent(true);
                //        String name = ecoreElement.getName();
                //        if (EcoreModelNavigation.isNotNull(name))
                //        objingRegionContainer.setName(name);
                //        ((IState) objingElt).setParent(objingRegionContainer);
                //        }
                //        }
                //        }
    }

    @objid ("0bc1ef35-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0bc45184-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0bc4518a-4583-11e0-b54c-00137279a832")
    public ERegion() {
    }

}
