/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import org.eclipse.uml2.uml.ReplyAction;

@objid ("0bd501fc-4583-11e0-b54c-00137279a832")
public class EReplyAction extends ENamedElement implements IEElement {

    @objid ("0bd501fe-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        IOpaqueAction result = Modelio.getInstance().getModelingSession().getModel().createOpaqueAction();
        try{
            result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                    IOpaqueAction.class, XMIStereotypes.UML2REPLYACTION));
        }catch(StereotypeNotFoundException e){
            e.printStackTrace(Modelio.err);
        }
        return result;
    }

    @objid ("0bd76454-4583-11e0-b54c-00137279a832")
    public EReplyAction(ReplyAction element) {
        super(element);
    }

    @objid ("0bd7645d-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
    }

    @objid ("0bd76460-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0bd9c6b1-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0bd9c6b4-4583-11e0-b54c-00137279a832")
    public EReplyAction() {
    }

}
