/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import org.eclipse.uml2.uml.SequenceNode;

@objid ("0bf662e6-4583-11e0-b54c-00137279a832")
public class ESequenceNode extends ENamedElement implements IEElement {

    @objid ("0bf662e8-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        IStructuredActivityNode result =  Modelio.getInstance().getModelingSession().getModel()
                .createStructuredActivityNode();
        try{
            result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                    IStructuredActivityNode.class, XMIStereotypes.UML2SEQUENCENODE));
        }catch(StereotypeNotFoundException e){
            e.printStackTrace(Modelio.err);
        }
        return result;
    }

    @objid ("0bf662ec-4583-11e0-b54c-00137279a832")
    public ESequenceNode(SequenceNode element) {
        super(element);
    }

    @objid ("0bf8c546-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        // Mapping done in the super class mapper: StructuredActivityNode
    }

    @objid ("0bf8c549-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0bf8c54e-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0bfb279a-4583-11e0-b54c-00137279a832")
    public ESequenceNode() {
    }

}
