/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ObKindOfStateMachineEnum;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ProtocolStateMachine;
import org.eclipse.uml2.uml.StateMachine;

@objid ("0c34600a-4583-11e0-b54c-00137279a832")
public class EStateMachine extends ENamedElement implements IEElement {
    @objid ("0c34600b-4583-11e0-b54c-00137279a832")
    private StateMachine ecoreElement;


    @objid ("0c34600c-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
        .createStateMachine();
    }

    @objid ("0c346010-4583-11e0-b54c-00137279a832")
    public EStateMachine(StateMachine element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0c36c265-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        Element ecoreOwner = ecoreElement.getOwner();
        
        IElement objingOwner = (IElement) ReverseProperties.getInstance()
        .getMappedElement(ecoreOwner);
        if (ecoreOwner != null) {
            if (objingOwner instanceof INameSpace){
                ((IBehavior) objingElt).setOwner((INameSpace)objingOwner);
            }else if (objingOwner instanceof IOperation){
                ((IBehavior) objingElt).setOwnerOperation((IOperation)objingOwner);
            }else{
                objingOwner = EcoreModelNavigation.getNearestStateMachineOwner(ecoreElement);
        
                if (ecoreOwner != null) {
                    if (objingOwner instanceof INameSpace){
                        ((IBehavior) objingElt).setOwner((INameSpace)objingOwner);
                    }else if (objingOwner instanceof IOperation){
                        ((IBehavior) objingElt).setOwnerOperation((IOperation)objingOwner);
                    }
                }
        
            }
        }
    }

    @objid ("0c36c268-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0c36c26d-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setKind((IStateMachine) objingElt);
        //        createAndSetTopState((IStateMachine) objingElt);
        if (ReverseProperties.getInstance().isRoundtripEnabled())
            setReentrant((IStateMachine) objingElt);
    }

    @objid ("0c36c270-4583-11e0-b54c-00137279a832")
    private void setReentrant(IStateMachine objingElt) {
        objingElt.setReentrant(ObjingEAnnotation.isReentrant(ecoreElement));
    }

    @objid ("0c3924c1-4583-11e0-b54c-00137279a832")
    private void setKind(IStateMachine machine) {
        if (ecoreElement instanceof ProtocolStateMachine)
            machine.setKind(ObKindOfStateMachineEnum.PROTOCOL);
        else
            machine.setKind(ObKindOfStateMachineEnum.DYNAMIC);
    }

    @objid ("0c3924c4-4583-11e0-b54c-00137279a832")
    public EStateMachine() {
    }

}
