/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.StructuredActivityNode;

@objid ("0c4772da-4583-11e0-b54c-00137279a832")
public class EStructuredActivityNode extends EActivityNode implements IEElement {
    @objid ("0c4772db-4583-11e0-b54c-00137279a832")
    private StructuredActivityNode ecoreElement = null;


    @objid ("0c4772dc-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createStructuredActivityNode();
    }

    @objid ("0c4772e0-4583-11e0-b54c-00137279a832")
    public EStructuredActivityNode(StructuredActivityNode element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0c49d536-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        super.attach(objingElt);
    }

    @objid ("0c49d539-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0c49d53e-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
        setMustIsolate((IStructuredActivityNode) objingElt);
    }

    @objid ("0c4e99e8-4583-11e0-b54c-00137279a832")
    private void setMustIsolate(IStructuredActivityNode node) {
        node.setmustIsolate(ecoreElement.isMustIsolate());
    }

    @objid ("0c4e99eb-4583-11e0-b54c-00137279a832")
    public EStructuredActivityNode() {
    }

}
