/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Substitution;

@objid ("0c55c0f8-4583-11e0-b54c-00137279a832")
public class ESubstitution extends ENamedElement implements IEElement {
    @objid ("0c55c0f9-4583-11e0-b54c-00137279a832")
    private Substitution ecoreElement;


    @objid ("0c55c0fa-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        ISubstitution objingPkg = Modelio.getInstance()
                .getModelingSession().getModel().createSubstitution();
        return objingPkg;
    }

    @objid ("0c582350-4583-11e0-b54c-00137279a832")
    public ESubstitution(Substitution element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0c582359-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        // I take the model map
        ReverseProperties revProp = ReverseProperties.getInstance();
                
        // I take the ecore Imported and Importing
        Classifier ecoreContract = ecoreElement.getContract();
        Classifier ecoreClassifier = (Classifier) ecoreElement.getClients()
                .get(0);
                
        IClassifier objingContract = (IClassifier) revProp
                .getMappedElement(ecoreContract);
        IClassifier objingClassifier = (IClassifier) revProp
                .getMappedElement(ecoreClassifier);
                
        // I set to the objingElt Imported Importing previousely find
        if (objingContract != null && objingClassifier != null) {
            ISubstitution objingRImport = (ISubstitution) objingElt;
            objingRImport.setContract(objingContract);
            objingRImport.setSubstitutingClassifier(objingClassifier);
        }
    }

    @objid ("0c58235c-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0c5a85ac-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0c5a85b2-4583-11e0-b54c-00137279a832")
    public ESubstitution() {
    }

}
