/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.TemplateBinding;
import org.eclipse.uml2.uml.TemplateSignature;

@objid ("0c5ce804-4583-11e0-b54c-00137279a832")
public class ETemplateBinding extends EElement implements IEElement {

    @objid ("0c5ce805-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createTemplateBinding();
    }

    @objid ("0c5ce80d-4583-11e0-b54c-00137279a832")
    public ETemplateBinding(TemplateBinding element) {
        super(element);
    }

    @objid ("0c5f4a64-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        IElement objOwner = (IElement) ReverseProperties.getInstance().getMappedElement(getEcoreElement().getOwner());
                
        if (objOwner instanceof IOperation){
            ((ITemplateBinding)objingElt).setBoundOperation(((IOperation) objOwner));
        }else if (objOwner instanceof INameSpace){
            ((ITemplateBinding)objingElt).setBoundElement(((INameSpace) objOwner));
        }else{
            Modelio.getInstance().getModelingSession().getModel().deleteElement(objingElt);
        }
    }

    @objid ("0c5f4a67-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0c5f4a6c-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        setTemplate(objingElt);
    }

    @objid ("0c61acb8-4583-11e0-b54c-00137279a832")
    public ETemplateBinding() {
    }

    @objid ("0c61acba-4583-11e0-b54c-00137279a832")
    private void setTemplate(IElement objingElt) {
        TemplateSignature signature = ((TemplateBinding) getEcoreElement()).getSignature();
        if (signature != null){
            Element template = signature.getTemplate();
            if (template != null){
                IElement objTemplate = (IElement) ReverseProperties.getInstance().getMappedElement(template);
                if (objTemplate instanceof IOperation){
                    ((ITemplateBinding) objingElt).setInstanciatedTemplateOperation((IOperation) objTemplate);
                }else if (objTemplate instanceof INameSpace){
                    ((ITemplateBinding) objingElt).setInstanciatedTemplate((INameSpace) objTemplate);
                }
                
            }
        }
    }

}
