/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.TemplateParameter;

@objid ("0c640f12-4583-11e0-b54c-00137279a832")
public class ETemplateParameter extends EElement implements IEElement {

    @objid ("0c640f13-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createTemplateParameter();
    }

    @objid ("0c640f1b-4583-11e0-b54c-00137279a832")
    public ETemplateParameter(TemplateParameter element) {
        super(element);
    }

    @objid ("0c667170-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        IElement objOwner = (IElement) ReverseProperties.getInstance().getMappedElement(getEcoreElement().getOwner().getOwner());
        
        if (objOwner instanceof INameSpace){
            ((ITemplateParameter) objingElt).setParameterized((INameSpace)objOwner);
        }else if (objOwner instanceof IOperation){
            ((ITemplateParameter) objingElt).setParameterizedOperation((IOperation)objOwner);
        }else{
            Modelio.getInstance().getModelingSession().getModel().deleteElement(objingElt);
        }
    }

    @objid ("0c667173-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0c667178-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        setName(objingElt);
        setIsValueParameter(objingElt);
        setDefault(objingElt);
        setParameteredElement(objingElt);
    }

    @objid ("0c68d3c6-4583-11e0-b54c-00137279a832")
    public ETemplateParameter() {
    }

    @objid ("0c68d3c8-4583-11e0-b54c-00137279a832")
    private void setParameteredElement(IElement objElement) {
        Element type = ((TemplateParameter) getEcoreElement()).getParameteredElement();
        if (type != null){
            IElement objType = (IElement) ReverseProperties.getInstance().getMappedElement(type);
            if (objType instanceof IModelElement){
                ((ITemplateParameter) objElement).setType((IModelElement) objType);
            }
        }
    }

    @objid ("0c68d3cb-4583-11e0-b54c-00137279a832")
    private void setDefault(IElement objingElt) {
        Element ecoreDefault = ((TemplateParameter) getEcoreElement()).getDefault();
        if (ecoreDefault != null){
            if (ecoreDefault instanceof LiteralString){
                ((ITemplateParameter) objingElt).setDefaultValue(((LiteralString) ecoreDefault).getValue());
            }else{
                IElement objType = (IElement) ReverseProperties.getInstance().getMappedElement(ecoreDefault);
                if (objType instanceof IModelElement){
                    ((ITemplateParameter) objingElt).setDefaultType((IModelElement) objType);
                }
            }
        }
    }

    @objid ("0c68d3d1-4583-11e0-b54c-00137279a832")
    private void setIsValueParameter(IElement objingElt) {
        ((ITemplateParameter) objingElt).setValueParameter(ObjingEAnnotation.isValueParameter((getEcoreElement())));
    }

    @objid ("0c68d3d4-4583-11e0-b54c-00137279a832")
    private void setName(IElement objingElt) {
        ((ITemplateParameter) objingElt).setName(ObjingEAnnotation.getName(getEcoreElement()));
    }

}
