/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameterSubstitution;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.TemplateParameterSubstitution;

@objid ("0c6b3620-4583-11e0-b54c-00137279a832")
public class ETemplateParameterSubstitution extends EElement implements IEElement {

    @objid ("0c6b3621-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel().createTemplateParameterSubstitution();
    }

    @objid ("0c6d987b-4583-11e0-b54c-00137279a832")
    public ETemplateParameterSubstitution(TemplateParameterSubstitution element) {
        super(element);
    }

    @objid ("0c6d9884-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        IElement objOwner = (IElement) ReverseProperties.getInstance().getMappedElement(getEcoreElement().getOwner());
                
        if (objOwner instanceof ITemplateBinding){
            ((ITemplateBinding)objOwner).addParameterSubstitution(((ITemplateParameterSubstitution) objingElt));
        }else{
            Modelio.getInstance().getModelingSession().getModel().deleteElement(objingElt);
        }
    }

    @objid ("0c6ffad4-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0c6ffad9-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        setValue(objingElt);
        setActual(objingElt);
        setFormal(objingElt);
    }

    @objid ("0c6ffadc-4583-11e0-b54c-00137279a832")
    public ETemplateParameterSubstitution() {
    }

    @objid ("0c6ffade-4583-11e0-b54c-00137279a832")
    private void setFormal(IElement objingElt) {
        Element formal = ((TemplateParameterSubstitution)getEcoreElement()).getFormal();
        if (formal != null){
            IElement objFormal = (IElement)ReverseProperties.getInstance().getMappedElement(formal);
            if ((objFormal != null) && (objFormal instanceof ITemplateParameter)){
                ((ITemplateParameterSubstitution) objingElt).setFormalParameter((ITemplateParameter) objFormal);
            }
        }
    }

    @objid ("0c6ffae1-4583-11e0-b54c-00137279a832")
    private void setActual(IElement objingElt) {
        //        EList<ParameterableElement> list = ((TemplateParameterSubstitution)getEcoreElement()).getActuals();
        //        if (list.size() > 0){
        //            Element actual  =  list.get(0);
                    Element actual  =  ((TemplateParameterSubstitution)getEcoreElement()).getActual();
                    IElement objActual = (IElement)ReverseProperties.getInstance().getMappedElement(actual);
                    if ((objActual != null) && (objActual instanceof IModelElement)){
                        ((ITemplateParameterSubstitution) objingElt).setActual((IModelElement) objActual);
                    }
        //        }
    }

    @objid ("0c725d2f-4583-11e0-b54c-00137279a832")
    private void setValue(IElement objingElt) {
        ((ITemplateParameterSubstitution) objingElt).setValue(ObjingEAnnotation.getValue(getEcoreElement()));
    }

}
