/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.TemplateSignature;

@objid ("0c725d32-4583-11e0-b54c-00137279a832")
public class ETemplateSignature extends EElement implements IEElement {
    @objid ("0c725d33-4583-11e0-b54c-00137279a832")
    private TemplateSignature ecoreElement;


    @objid ("0c725d34-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        if (ObjingEAnnotation.isDeleted(ecoreElement)){
            return null;
        }else{
            Element ecoreOwner = ecoreElement.getOwner();
            Object objingOwner =  ReverseProperties.getInstance().getMappedElement(ecoreOwner);
            if ((objingOwner instanceof IClassifier)  && !(objingOwner instanceof IEnumeration)){
                IOperation result = Modelio.getInstance().getModelingSession().getModel().createOperation();
                try{
                    result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                            IOperation.class, XMIStereotypes.UML2TEMPLATESIGNATURE));
        
                }catch(StereotypeNotFoundException e){
                    e.printStackTrace(Modelio.err); 
        
                }
                return result;
            }
            return null;
        }
    }

    @objid ("0c74bf8d-4583-11e0-b54c-00137279a832")
    public ETemplateSignature(TemplateSignature element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0c7721e2-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
    }

    @objid ("0c7721e5-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0c7721ea-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        // TODO Auto-generated method stub
    }

    @objid ("0c7721ed-4583-11e0-b54c-00137279a832")
    public ETemplateSignature() {
    }

}
