/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.CallEvent;
import org.eclipse.uml2.uml.ChangeEvent;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Event;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.SignalEvent;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.TimeEvent;
import org.eclipse.uml2.uml.Transition;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.ValueSpecification;

@objid ("0ca6d0ea-4583-11e0-b54c-00137279a832")
public class ETrigger extends ENamedElement implements IEElement {
    @objid ("0ca6d0eb-4583-11e0-b54c-00137279a832")
    private Trigger ecoreElement;


    @objid ("0ca6d0ec-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        createAndAttachEvent();
        return null;
    }

    @objid ("0ca6d0f0-4583-11e0-b54c-00137279a832")
    public ETrigger(Trigger element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0ca93345-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        // TODO Auto-generated method stub
    }

    @objid ("0ca93348-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0ca9334d-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0ca93350-4583-11e0-b54c-00137279a832")
    public ETrigger() {
    }

    @objid ("0cab959f-4583-11e0-b54c-00137279a832")
    private void createAndAttachEvent() {
        ReverseProperties revProp = ReverseProperties.getInstance();
        
        Element ecoreEvent = ecoreElement.getEvent();
        if (ecoreElement.getEvent() != null){
            IElement objEvent = (IElement) revProp.getMappedElement(ecoreEvent);
            if (objEvent != null){
                Element ecoreOwner = ecoreElement.getOwner();
                if (ecoreOwner instanceof Transition){
                    IStateMachine sm = (IStateMachine) revProp.getMappedElement(EcoreModelNavigation.getMostEnclosingStateMachine((Transition) ecoreOwner));
                    sm.addEComponent((IEvent)objEvent);
                    setEventProperties((IEvent)objEvent);
                }else if (ecoreOwner instanceof StateMachine){
                    IStateMachine sm = (IStateMachine) revProp.getMappedElement(ecoreOwner);
                    sm.addEComponent((IEvent)objEvent);
                    setEventProperties((IEvent)objEvent);
                }else{
                    Modelio.getInstance().getModelingSession().getModel().deleteElement(objEvent);
                }
            }
        }
    }

    @objid ("0cab95a1-4583-11e0-b54c-00137279a832")
    private void setEventProperties(IEvent objingElt) {
        Event event = ecoreElement.getEvent();
        
        if (event != null){
            setName(objingElt, event);
            if (event instanceof SignalEvent){
                setSignal(objingElt,(SignalEvent)event);
            }else     if (event instanceof CallEvent){
                setOperation(objingElt,(CallEvent)event);
            }else     if (event instanceof ChangeEvent){
                setExpression(objingElt, (ChangeEvent) event);
            }else     if (event instanceof TimeEvent){
                setExpression(objingElt, (TimeEvent) event);
            }
        }
    }

    @objid ("0cab95a4-4583-11e0-b54c-00137279a832")
    private void setName(IElement objingElt, Event event) {
        String name = event.getName();
        if (name != null){
            ((IEvent) objingElt).setName(name);
        }
    }

    @objid ("0cab95a8-4583-11e0-b54c-00137279a832")
    private void setSignal(IElement objingElt, SignalEvent event) {
        Signal signal =    event.getSignal();
        if (signal != null){
            IElement objSignal = (IElement) ReverseProperties.getInstance().getMappedElement(signal);
            if (objSignal instanceof ISignal){
                ((IEvent) objingElt).setModel((ISignal) objSignal);
            }
        }
    }

    @objid ("0cab95ac-4583-11e0-b54c-00137279a832")
    private void setOperation(IElement objingElt, CallEvent event) {
        Operation operation =    event.getOperation();
        if (operation != null){
            IElement objOperation = (IElement) ReverseProperties.getInstance().getMappedElement(operation);
            if (objOperation instanceof IOperation){
                ((IEvent) objingElt).setCalled((IOperation) objOperation);
            }
        }
    }

    @objid ("0cadf7f8-4583-11e0-b54c-00137279a832")
    private void setExpression(IEvent objingElt, ChangeEvent event) {
        ValueSpecification value = event.getChangeExpression();
        
        if (value != null){
        
            String typeString = value.stringValue();
            if (typeString != null)
                objingElt.setExpression(typeString);
            else{
                boolean bool = value.booleanValue();
                if (bool)
                    objingElt.setExpression(String.valueOf(bool));
                else{
                    Integer inte = value.integerValue();
                    if (inte != null)
                        objingElt.setExpression(String.valueOf(inte));
                }
            }
        }
    }

    @objid ("0cadf7fc-4583-11e0-b54c-00137279a832")
    private void setExpression(IEvent objingElt, TimeEvent event) {
        ValueSpecification value =    event.getWhen();
        
        if (value != null){
            String expr = value.stringValue();
            if (expr != null){
                ((IEvent) objingElt).setExpression(expr);
            }
        }
    }

}
