/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore;

import java.util.List;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IProfile;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.UseCase;

@objid ("0cc10aca-4583-11e0-b54c-00137279a832")
public class EUseCase extends ENamedElement implements IEElement {
    @objid ("0cc10acb-4583-11e0-b54c-00137279a832")
    private UseCase ecoreElement;


    @objid ("0cc10acc-4583-11e0-b54c-00137279a832")
    public IElement createObjingElt() {
        return Modelio.getInstance()
        .getModelingSession().getModel().createUseCase();
    }

    @objid ("0cc36d23-4583-11e0-b54c-00137279a832")
    public EUseCase(UseCase element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0cc36d2c-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        
        Element ecoreOwner = ecoreElement.getOwner();
        
        Object objingOwner = revProp.getMappedElement(ecoreOwner);
        
        if ( (objingOwner != null) 
                && (objingOwner instanceof IModelTree) 
                && !(objingOwner instanceof IProfile)) {
            ((IUseCase) objingElt).setOwner((IModelTree)objingOwner);
        }else{
            ((IUseCase) objingElt).setOwner(revProp.getExternalPackage());
        }
    }

    @objid ("0cc36d2f-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElt) {
    }

    @objid ("0cc5cf80-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        super.setProperties(objingElt);
    }

    @objid ("0cc5cf86-4583-11e0-b54c-00137279a832")
    public EUseCase() {
    }

}
