/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore.sequence;

import java.util.ArrayList;
import java.util.List;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGate;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.model.ecore.IEElement;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.Gate;
import org.eclipse.uml2.uml.Message;

@objid ("0d2068e3-4583-11e0-b54c-00137279a832")
public class GateImportMapper extends SequenceElementImportMapper implements IEElement {
    @objid ("0d2068e4-4583-11e0-b54c-00137279a832")
     Gate ecoreElement;


    @objid ("0d2068e5-4583-11e0-b54c-00137279a832")
    public Object createObjingElt() {
        return Modelio.getInstance().getModelingSession().getModel()
                .createGate();
    }

    @objid ("0d22cb33-4583-11e0-b54c-00137279a832")
    public GateImportMapper(Gate element) {
        super(element);
        ecoreElement = element;
    }

    @objid ("0d22cb36-4583-11e0-b54c-00137279a832")
    public List<String> getObjingClassName() {
        List<String> result = new ArrayList<String>();
         result.add("Gate");
        return result;
    }

    @objid ("0d22cb3c-4583-11e0-b54c-00137279a832")
    public void attach(IElement objingElt) {
    }

    @objid ("0d252d8c-4583-11e0-b54c-00137279a832")
    public void attach(List<Object> objingElts) {
    }

    @objid ("0d252d91-4583-11e0-b54c-00137279a832")
    public void setProperties(IElement objingElt) {
        if (objingElt instanceof IGate) {
            setName((IGate) objingElt);
            insertInDiagram((IGate) objingElt);
        }
    }

    @objid ("0d252d94-4583-11e0-b54c-00137279a832")
    private void insertInDiagram(IGate gate) {
        ReverseProperties revProp = ReverseProperties.getInstance();
               
        Message ecoreMsg = ecoreElement.getMessage();
        if (ecoreMsg != null) {
            Object objingM = revProp.getMappedElement(ecoreMsg);
        }
    }

}
