/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.ecore.sequence;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.model.ecore.ENamedElement;
import com.modeliosoft.modelio.xmi.model.ecore.IEElement;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import org.eclipse.uml2.uml.NamedElement;

@objid ("0d60c85c-4583-11e0-b54c-00137279a832")
public abstract class SequenceElementImportMapper extends ENamedElement implements IEElement {
    @objid ("0d60c85d-4583-11e0-b54c-00137279a832")
    protected NamedElement ecoreIF;


    @objid ("0d60c85e-4583-11e0-b54c-00137279a832")
    public SequenceElementImportMapper(NamedElement element) {
        super(element);
        ecoreIF = element;
    }

    @objid ("0d60c861-4583-11e0-b54c-00137279a832")
    protected void setName(IModelElement objingElt) {
        String name = ecoreIF.getName();
        if (EcoreModelNavigation.isNotNull(name))
            objingElt.setName(name);
        else 
            objingElt.setName("");
    }

}
