/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptCallEventAction;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.ReceiveOperationEvent;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0d7178cc-4583-11e0-b54c-00137279a832")
public class OAcceptCallEventAction extends OActivityNode implements IOElement {
    @objid ("0d7178cd-4583-11e0-b54c-00137279a832")
    private IAcceptCallEventAction objingElement;

    @objid ("0d7178cf-4583-11e0-b54c-00137279a832")
    private GenerationProperties genProp = GenerationProperties.getInstance();


    @objid ("0d7178d0-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createAcceptEventAction();
    }

    @objid ("0d7178d4-4583-11e0-b54c-00137279a832")
    public OAcceptCallEventAction() {
    }

    @objid ("0d7178d6-4583-11e0-b54c-00137279a832")
    public OAcceptCallEventAction(IAcceptCallEventAction element) {
        super(element);
        objingElement = element;
    }

    @objid ("0d73db2b-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0d73db2f-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setCalled((AcceptEventAction) ecoreElt);
    }

    @objid ("0d763d8f-4583-11e0-b54c-00137279a832")
    private void setCalled(AcceptEventAction action) {
        IOperation objingOperation = objingElement.getCalled();
        if (objingOperation != null) {
            Element ecoreOperation = genProp.getMappedElement(objingOperation);
            if ((ecoreOperation != null) && (ecoreOperation instanceof Operation)) {
                Trigger trigger = UMLFactory.eINSTANCE.createTrigger();
                ReceiveOperationEvent event = UMLFactory.eINSTANCE
                        .createReceiveOperationEvent();
                action.getTriggers().add(trigger);
                trigger.setEvent(event);
                event.setOperation((Operation) ecoreOperation);
                
                // Attach the Event to the model via composition relation:
                Package nearestPkg = action.getNearestPackage();
                nearestPkg.getPackagedElements().add(event);
            }
        }
    }

}
