/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptChangeEventAction;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.ChangeEvent;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0d789fda-4583-11e0-b54c-00137279a832")
public class OAcceptChangeEventAction extends OActivityNode implements IOElement {
    @objid ("0d789fdb-4583-11e0-b54c-00137279a832")
    private IAcceptChangeEventAction objingElement;


    @objid ("0d789fde-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createAcceptEventAction();
    }

    @objid ("0d789fe2-4583-11e0-b54c-00137279a832")
    public OAcceptChangeEventAction() {
    }

    @objid ("0d789fe4-4583-11e0-b54c-00137279a832")
    public OAcceptChangeEventAction(IAcceptChangeEventAction element) {
        super(element);
        objingElement = element;
    }

    @objid ("0d7b0238-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0d7b023c-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setChangeExpression((AcceptEventAction) ecoreElt);
    }

    @objid ("0d7d649b-4583-11e0-b54c-00137279a832")
    private void setChangeExpression(AcceptEventAction action) {
        String changeExpression = objingElement.getchangeExpresion();
                
        if ((changeExpression != null) && (!changeExpression.equals(""))){
                
            Trigger trigger = UMLFactory.eINSTANCE.createTrigger();
            action.getTriggers().add(trigger);
                
            ChangeEvent changeEvent = UMLFactory.eINSTANCE.createChangeEvent();
            trigger.setEvent(changeEvent);
                
            LiteralString literal = UMLFactory.eINSTANCE.createLiteralString();
            changeEvent.setChangeExpression(literal);
            literal.setValue(changeExpression);
                
            // Attach the Event to the model via composition relation:
                Package nearestPkg = action.getNearestPackage();
                nearestPkg.getPackagedElements().add(changeEvent);
        }
    }

}
