/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptTimeEventAction;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.TimeEvent;
import org.eclipse.uml2.uml.TimeExpression;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0d86edf6-4583-11e0-b54c-00137279a832")
public class OAcceptTimeEventAction extends OActivityNode implements IOElement {
    @objid ("0d86edf7-4583-11e0-b54c-00137279a832")
    private IAcceptTimeEventAction objingElement;


    @objid ("0d86edfa-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createAcceptEventAction();
    }

    @objid ("0d86edfe-4583-11e0-b54c-00137279a832")
    public OAcceptTimeEventAction() {
    }

    @objid ("0d86ee00-4583-11e0-b54c-00137279a832")
    public OAcceptTimeEventAction(IAcceptTimeEventAction element) {
        super(element);
        objingElement = element;
    }

    @objid ("0d895054-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0d895058-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setTimeExpression((AcceptEventAction) ecoreElt);
    }

    @objid ("0d8bb2b7-4583-11e0-b54c-00137279a832")
    private void setTimeExpression(AcceptEventAction action) {
        String timeExpression = objingElement.gettimeExpresion();
                
        if ((timeExpression != null) && (!timeExpression.equals(""))){
            Trigger trigger = UMLFactory.eINSTANCE.createTrigger();
            action.getTriggers().add(trigger);
                
            TimeEvent timeEvent = UMLFactory.eINSTANCE.createTimeEvent();
            trigger.setEvent(timeEvent);
              
            
            TimeExpression time = UMLFactory.eINSTANCE.createTimeExpression();
            LiteralString literal = UMLFactory.eINSTANCE.createLiteralString();
            literal.setValue(timeExpression);
            time.setExpr(literal);
            timeEvent.setWhen(time);
            
            // Attach the Event to the model via composition relation:
            Package nearestPkg = action.getNearestPackage();
            nearestPkg.getPackagedElements().add(timeEvent);
        }
    }

}
