/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityParameterNode;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehaviorParameter;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.ActivityParameterNode;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0da38a3c-4583-11e0-b54c-00137279a832")
public class OActivityParameterNode extends OObjectNode implements IOElement {

    @objid ("0da5ec8b-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createActivityParameterNode();
    }

    @objid ("0da5ec8f-4583-11e0-b54c-00137279a832")
    public OActivityParameterNode() {
    }

    @objid ("0da5ec91-4583-11e0-b54c-00137279a832")
    public OActivityParameterNode(IActivityParameterNode element) {
        super(element);
    }

    @objid ("0da84ee5-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0da84ee9-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setRepresentedRealParameter((ActivityParameterNode) ecoreElt);
    }

    @objid ("0dad139e-4583-11e0-b54c-00137279a832")
    private void setRepresentedRealParameter(ActivityParameterNode node) {
        IBehaviorParameter behaviorParam = ((IActivityParameterNode) getObjingElement())
                .getRepresentedRealParameter();
        if (behaviorParam != null) {
            IParameter objingParam = behaviorParam.getMapped();
            if (objingParam != null) {
                Element ecoreParam = GenerationProperties.getInstance().getMappedElement(objingParam);
                if (ecoreParam instanceof Parameter) {
                    node.setParameter((Parameter) ecoreParam);
                }
            }else{
                Element ecoreParam = GenerationProperties.getInstance().getMappedElement(behaviorParam);
                if (ecoreParam instanceof Parameter) {
                    node.setParameter((Parameter) ecoreParam);
                }
            }
        }
    }

}
