/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.ActivityPartition;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0daf75f0-4583-11e0-b54c-00137279a832")
public class OActivityPartition extends OActivityGroup implements IOElement {
    @objid ("0daf75f1-4583-11e0-b54c-00137279a832")
    private IActivityPartition objingElement;


    @objid ("0daf75f2-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createActivityPartition();
    }

    @objid ("0daf75f6-4583-11e0-b54c-00137279a832")
    public OActivityPartition() {
    }

    @objid ("0daf75f8-4583-11e0-b54c-00137279a832")
    public OActivityPartition(IActivityPartition element) {
        super(element);
        objingElement = element;
    }

    @objid ("0db1d84e-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0db1d852-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setDimension((ActivityPartition) ecoreElt);
        setExternal((ActivityPartition) ecoreElt);
        setRepresented((ActivityPartition) ecoreElt);
    }

    @objid ("0db43aa8-4583-11e0-b54c-00137279a832")
    private void setDimension(ActivityPartition partition) {
        partition.setIsDimension(objingElement.isDimension());
    }

    @objid ("0db43aab-4583-11e0-b54c-00137279a832")
    private void setExternal(ActivityPartition partition) {
        partition.setIsExternal(objingElement.isExternal());
    }

    @objid ("0db43aae-4583-11e0-b54c-00137279a832")
    private void setRepresented(ActivityPartition partition) {
        IElement representation = objingElement.getRepresented();
        if (representation != null) {
            Element ecoreRepresentation = GenerationProperties.getInstance().getMappedElement(representation);
            if (ecoreRepresentation != null)
                partition.setRepresents(ecoreRepresentation);
        }
    }

}
