/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallBehaviorAction;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehavior;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import com.modeliosoft.modelio.xmi.util.NotFoundException;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.CallBehaviorAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0e02e849-4583-11e0-b54c-00137279a832")
public class OCallBehaviorAction extends OActivityNode implements IOElement {
    @objid ("0e02e84a-4583-11e0-b54c-00137279a832")
    private ICallBehaviorAction objingElement;


    @objid ("0e02e84c-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createCallBehaviorAction();
    }

    @objid ("0e054a99-4583-11e0-b54c-00137279a832")
    public OCallBehaviorAction() {
    }

    @objid ("0e054a9b-4583-11e0-b54c-00137279a832")
    public OCallBehaviorAction(ICallBehaviorAction element) {
        super(element);
        objingElement = element;
    }

    @objid ("0e07acf3-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0e07acf7-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setSynchronous((CallBehaviorAction) ecoreElt);
        setBehavior((CallBehaviorAction) ecoreElt);
    }

    @objid ("0e0a0f54-4583-11e0-b54c-00137279a832")
    private void setSynchronous(CallBehaviorAction action) {
        action.setIsSynchronous(objingElement.isSynchronous());
    }

    @objid ("0e0a0f57-4583-11e0-b54c-00137279a832")
    private void setBehavior(CallBehaviorAction action) {
        IBehavior objingBehavior = objingElement.getCalled();
                
        if (objingBehavior != null) {
            Element ecoreBehavior =  GenerationProperties.getInstance().getMappedElement(objingBehavior);
                
            if (ecoreBehavior != null) {
                if (ecoreBehavior instanceof Behavior)
                    action.setBehavior((Behavior) ecoreBehavior);
                else{
                    action.destroy();
                    throw new NotFoundException("The Behavior \""
                            + objingBehavior.getName()
                            + "\" has not been mapped correctly.");
                }
            }
        }
    }

}
