/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallOperationAction;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import com.modeliosoft.modelio.xmi.util.NotFoundException;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0e0c71a6-4583-11e0-b54c-00137279a832")
public class OCallOperationAction extends OActivityNode implements IOElement {
    @objid ("0e0c71a7-4583-11e0-b54c-00137279a832")
    private ICallOperationAction objingElement;


    @objid ("0e0c71a9-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createCallOperationAction();
    }

    @objid ("0e0c71ad-4583-11e0-b54c-00137279a832")
    public OCallOperationAction() {
    }

    @objid ("0e0c71af-4583-11e0-b54c-00137279a832")
    public OCallOperationAction(ICallOperationAction element) {
        super(element);
        objingElement = element;
    }

    @objid ("0e0ed404-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0e0ed408-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setSynchronous((CallOperationAction) ecoreElt);
        setOperation((CallOperationAction) ecoreElt);
    }

    @objid ("0e113666-4583-11e0-b54c-00137279a832")
    private void setSynchronous(CallOperationAction action) {
        action.setIsSynchronous(objingElement.isSynchronous());
    }

    @objid ("0e113669-4583-11e0-b54c-00137279a832")
    private void setOperation(CallOperationAction ecoreElt) {
        IOperation objingOperation = objingElement.getCalled();
                
        if (objingOperation != null) {
            Element ecoreOperation =  GenerationProperties.getInstance().getMappedElement(objingOperation);
                
            if (ecoreOperation != null) {
                if (ecoreOperation instanceof Operation) {
                    ecoreElt.setOperation((Operation) ecoreOperation);
                } else{
                    ecoreElt.destroy();
                    throw new NotFoundException("The Operation \""
                            + objingOperation.getName()
                            + "\" has not been mapped correctly.");
                }
            } 
        }
    }

}
