/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Collaboration;
import org.eclipse.uml2.uml.CollaborationUse;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0e4347bc-4583-11e0-b54c-00137279a832")
public class OCollaborationUse extends OModelElement implements IOElement {
    @objid ("0e4347bd-4583-11e0-b54c-00137279a832")
     GenerationProperties genProp = GenerationProperties.getInstance();

    @objid ("0e4347be-4583-11e0-b54c-00137279a832")
    private ICollaborationUse objingElt;


    @objid ("0e4347bf-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createCollaborationUse();
    }

    @objid ("0e4347c3-4583-11e0-b54c-00137279a832")
    public OCollaborationUse() {
    }

    @objid ("0e4347c5-4583-11e0-b54c-00137279a832")
    public OCollaborationUse(ICollaborationUse param) {
        super(param);
        objingElt = param;
    }

    @objid ("0e45aa1c-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        Element ecoreOwner = genProp.getMappedElement(objingElt.getCompositionOwner());
                
        if (ecoreOwner instanceof Classifier)
            ((Classifier)ecoreOwner).getCollaborationUses().add((CollaborationUse) ecoreElt);
    }

    @objid ("0e45aa20-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setType((CollaborationUse)ecoreElt);
    }

    @objid ("0e45aa23-4583-11e0-b54c-00137279a832")
    private void setType(CollaborationUse ecoreElt) {
        IElement objType = objingElt.getType();
        if (objType != null) {
            Element ecoreType = genProp.getMappedElement(objType);
                
            if (ecoreType instanceof Collaboration)
                ecoreElt.setType((Collaboration)ecoreType);
        }
    }

}
