/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IConditionalNode;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import org.eclipse.uml2.uml.ConditionalNode;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0e565a8c-4583-11e0-b54c-00137279a832")
public class OConditionalNode extends OElement implements IOElement {
    @objid ("0e565a8d-4583-11e0-b54c-00137279a832")
    private IConditionalNode objingElement;


    @objid ("0e565a8e-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createConditionalNode();
    }

    @objid ("0e565a92-4583-11e0-b54c-00137279a832")
    public OConditionalNode() {
    }

    @objid ("0e565a94-4583-11e0-b54c-00137279a832")
    public OConditionalNode(IConditionalNode element) {
        super(element);
        objingElement = element;
    }

    @objid ("0e58bcec-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        // Done when mapping the super type (StructuredActivityNode)
    }

    @objid ("0e58bcf0-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        // Part of the Properties are setted when mapping the super type
        // (StructuredActivityNode)
                
        // Properties specific to ConditionalNodes:
        setIsAssured((ConditionalNode) ecoreElt);
        setDeterminate((ConditionalNode) ecoreElt);
    }

    @objid ("0e58bcf3-4583-11e0-b54c-00137279a832")
    private void setIsAssured(ConditionalNode node) {
        node.setIsAssured(objingElement.isAssured());
    }

    @objid ("0e58bcf6-4583-11e0-b54c-00137279a832")
    private void setDeterminate(ConditionalNode node) {
        node.setIsDeterminate(objingElement.isDeterminate());
    }

}
