/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.statik.IDataFlow;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.InformationFlow;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageableElement;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0e8144e0-4583-11e0-b54c-00137279a832")
public class ODataFlow extends OModelElement implements IOElement {
    @objid ("0e8144e1-4583-11e0-b54c-00137279a832")
    private IDataFlow objingElement;


    @objid ("0e8144e2-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return  UMLFactory.eINSTANCE.createInformationFlow();
    }

    @objid ("0e8144e6-4583-11e0-b54c-00137279a832")
    public ODataFlow() {
    }

    @objid ("0e8144e8-4583-11e0-b54c-00137279a832")
    public ODataFlow(IDataFlow element) {
        super(element);
        objingElement = element;
    }

    @objid ("0e83a740-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        GenerationProperties genProp = GenerationProperties.getInstance();
                
        INameSpace objingOrigin = objingElement.getOrigin();
                
        if (objingOrigin != null) {
            NamedElement ecoreOrigin = (NamedElement) genProp
                    .getMappedElement(objingOrigin);
                
            if (ecoreOrigin != null) {
                Package ecorePkg = ecoreOrigin.getNearestPackage();
                ecorePkg.getPackagedElements().add((PackageableElement)ecoreElt);
                ((InformationFlow) ecoreElt).getInformationSources().add(
                        ecoreOrigin);
            }
        }
    }

    @objid ("0e83a744-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setDestinationElement((InformationFlow) ecoreElt);
    }

    @objid ("0e860994-4583-11e0-b54c-00137279a832")
    private void setDestinationElement(InformationFlow ecoreIF) {
        GenerationProperties genProp = GenerationProperties.getInstance();
                
        INameSpace objingDestination = objingElement.getDestination();
                
        if (objingDestination != null) {
            NamedElement ecoreDestination = (NamedElement) genProp
                    .getMappedElement(objingDestination);
                
            if (ecoreDestination != null)
                ((InformationFlow) ecoreIF).getInformationTargets().add(
                        ecoreDestination);
        }
    }

}
