/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.state.IEntryPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Pseudostate;
import org.eclipse.uml2.uml.PseudostateKind;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0ec8cb6c-4583-11e0-b54c-00137279a832")
public class OEntryPointPseudoState extends OModelElement implements IOElement {
    @objid ("0ec8cb6d-4583-11e0-b54c-00137279a832")
    private GenerationProperties genProp = GenerationProperties.getInstance();

    @objid ("0ec8cb6e-4583-11e0-b54c-00137279a832")
    private IEntryPointPseudoState objingElement;


    @objid ("0ec8cb70-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createPseudostate();
    }

    @objid ("0ec8cb74-4583-11e0-b54c-00137279a832")
    public OEntryPointPseudoState() {
    }

    @objid ("0ec8cb76-4583-11e0-b54c-00137279a832")
    public OEntryPointPseudoState(IEntryPointPseudoState param) {
        super(param);                
        this.objingElement = param;
    }

    @objid ("0ecb2dcb-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        IStateMachine objSM = this.objingElement.getEntryOfMachine();
               
        if (objSM == null){
            IRegion region = this.objingElement.getParent();
            if (region == null){
                IState state = this.objingElement.getEntryOf();
                Element ecoreState =  this.genProp.getMappedElement(state);
                if (ecoreState instanceof State){
                    ((State)ecoreState).getConnectionPoints().add((Pseudostate)ecoreElt);
                }
            }else{
                Element ecoreRegion =  this.genProp.getMappedElement(region);
                if (ecoreRegion instanceof Region){
                    ((Region)ecoreRegion).getSubvertices().add((Pseudostate)ecoreElt);
                }
            }
        }else{
            Element ecoreSM =  this.genProp.getMappedElement(objSM);
            if (ecoreSM instanceof StateMachine){
                ((StateMachine)ecoreSM).getConnectionPoints().add((Pseudostate)ecoreElt);
            }
        }
    }

    @objid ("0ecb2dcf-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setKind((Pseudostate)ecoreElt);
    }

    @objid ("0ecb2dd5-4583-11e0-b54c-00137279a832")
    private void setKind(Pseudostate pseudostate) {
        pseudostate.setKind(PseudostateKind.ENTRY_POINT_LITERAL);
    }

}
