/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Enumeration;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0ed71989-4583-11e0-b54c-00137279a832")
public class OEnumerationLiteral extends OModelElement implements IOElement {
    @objid ("0ed7198a-4583-11e0-b54c-00137279a832")
    private IEnumerationLiteral objingElement;


    @objid ("0ed7198c-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE
        .createEnumerationLiteral();
    }

    @objid ("0ed71990-4583-11e0-b54c-00137279a832")
    public OEnumerationLiteral() {
    }

    @objid ("0ed71992-4583-11e0-b54c-00137279a832")
    public OEnumerationLiteral(IEnumerationLiteral element) {
        super(element);
        objingElement = element;
    }

    @objid ("0ed97bea-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        GenerationProperties genProp = GenerationProperties.getInstance();
        // EnumerationLiteral ecoreEnumLiteral = (EnumerationLiteral)ecoreElt;
        
        IEnumeration objingEnum = objingElement.getValuated();
        
        if (objingEnum != null) {
            Enumeration ecoreEnum = (Enumeration) genProp
            .getMappedElement(objingEnum);
        
            if (ecoreEnum != null) {
                // ecoreEnumLiteral.setEnumeration(ecoreEnum);
                ecoreEnum.getOwnedLiterals().add((EnumerationLiteral)ecoreElt);
            }
        }
    }

    @objid ("0ed97bee-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
    }

}
