/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInstanceNode;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0f5a3ae1-4583-11e0-b54c-00137279a832")
public class OInstanceNode extends OObjectNode implements IOElement {

    @objid ("0f5a3ae5-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        Element ecoreElt = UMLFactory.eINSTANCE.createCentralBufferNode();
        if (GenerationProperties.getInstance().isRoundtripEnabled()){
            ObjingEAnnotation.setType(ecoreElt, "InstanceNode");
        }
        return ecoreElt;
    }

    @objid ("0f5a3ae9-4583-11e0-b54c-00137279a832")
    public OInstanceNode() {
    }

    @objid ("0f5c9d38-4583-11e0-b54c-00137279a832")
    public OInstanceNode(IInstanceNode element) {
        super(element);
    }

    @objid ("0f5c9d41-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0f5eff92-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
    }

}
