/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("0f793973-4583-11e0-b54c-00137279a832")
public class OInterfaceRealization extends OElement implements IOElement {
    @objid ("0f793974-4583-11e0-b54c-00137279a832")
    private IInterfaceRealization objingElement;


    @objid ("0f793975-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE
                .createInterfaceRealization();
    }

    @objid ("0f793979-4583-11e0-b54c-00137279a832")
    public OInterfaceRealization() {
    }

    @objid ("0f7b9bca-4583-11e0-b54c-00137279a832")
    public OInterfaceRealization(IInterfaceRealization element) {
        super(element);
        objingElement = element;
    }

    @objid ("0f7b9bd3-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        GenerationProperties genProp = GenerationProperties.getInstance();
                
        INameSpace objingImplementerNS = objingElement.getImplementer();
        IInterface objingImplementedItf = objingElement.getImplemented();
                
        if (objingImplementerNS != null && objingImplementedItf != null) {
            // Gets or creates the ecore implementer Namespace:
            BehavioredClassifier ecoreImplementerNS = (BehavioredClassifier) genProp
                    .getMappedElement(objingImplementerNS);
                
            // Gets or creates the ecore implemented Interface:
            Interface ecoreImplementedItf = (Interface) genProp
                    .getMappedElement(objingImplementedItf);
                
            if (ecoreImplementerNS != null && ecoreImplementedItf != null) {
                InterfaceRealization ecoreItfReal = (InterfaceRealization) ecoreElt;
                ecoreItfReal.setContract(ecoreImplementedItf);
                ecoreItfReal.setImplementingClassifier(ecoreImplementerNS);
            }
        }
    }

    @objid ("0f7dfe24-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        // Nothing TODO
    }

}
