/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.IUMLTypes;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralClass;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.ClearAssociationAction;
import org.eclipse.uml2.uml.CreateObjectAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.LiteralInteger;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.OpaqueAction;
import org.eclipse.uml2.uml.OpaqueExpression;
import org.eclipse.uml2.uml.ReadExtentAction;
import org.eclipse.uml2.uml.StructuralFeature;
import org.eclipse.uml2.uml.StructuralFeatureAction;
import org.eclipse.uml2.uml.UMLFactory;
import org.eclipse.uml2.uml.ValueSpecificationAction;

@objid ("0ff2d163-4583-11e0-b54c-00137279a832")
public class OOpaqueAction extends OActivityNode implements IOElement {
    @objid ("0ff2d164-4583-11e0-b54c-00137279a832")
    private IOpaqueAction objingElement;


    @objid ("0ff2d167-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        if (objingElement.isStereotyped(XMIStereotypes.UML2VALUESPECIFICATIONACTION))
            return UMLFactory.eINSTANCE.createValueSpecificationAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2CREATEOBJECTACTION))
            return UMLFactory.eINSTANCE.createCreateObjectAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2CREATELINKACTION))
            return UMLFactory.eINSTANCE.createCreateLinkAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2READLINKACTION))
            return UMLFactory.eINSTANCE.createReadLinkAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2DESTROYLINKACTION))
            return UMLFactory.eINSTANCE.createDestroyLinkAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2CLEARASSOCIATIONACTION))
            return UMLFactory.eINSTANCE.createClearAssociationAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2ADDSTRUCTURALFEATUREVALUEACTION))
            return UMLFactory.eINSTANCE.createAddStructuralFeatureValueAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2READSTRUCTURALFEATUREACTION))
            return UMLFactory.eINSTANCE.createReadStructuralFeatureAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2READEXTENTACTION))
            return UMLFactory.eINSTANCE.createReadExtentAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2DESTROYOBJECTACTION))
            return UMLFactory.eINSTANCE.createDestroyObjectAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2CREATELINKACTION))
            return UMLFactory.eINSTANCE.createCreateLinkAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2ADDVARIABLEVALUEACTION))
            return UMLFactory.eINSTANCE.createAddVariableValueAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2CLEARSTRUCTURALFEATUREACTION))
            return UMLFactory.eINSTANCE.createClearStructuralFeatureAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2CLEARVARIABLEACTION))
            return UMLFactory.eINSTANCE.createClearVariableAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2RAISEEXCEPTIONACTION))
            return UMLFactory.eINSTANCE.createRaiseExceptionAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2READISCLASSIFIEROBJECTACTION))
            return UMLFactory.eINSTANCE.createReadIsClassifiedObjectAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2READLINKOBJECTENDACTION))
            return UMLFactory.eINSTANCE.createReadLinkObjectEndAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2READLINKOBJECTENDQUALIFIERACTION))
            return UMLFactory.eINSTANCE.createReadLinkObjectEndQualifierAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2READSELFACTION))
            return UMLFactory.eINSTANCE.createReadSelfAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2READVARIABLEACTION))
            return UMLFactory.eINSTANCE.createReadVariableAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2RECLASSIFYOBJECTACTION))
            return UMLFactory.eINSTANCE.createReclassifyObjectAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2REDUCEACTION))
            return UMLFactory.eINSTANCE.createReduceAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2REMOVESTRUCTURALFEATUREACTION))
            return UMLFactory.eINSTANCE.createRemoveStructuralFeatureValueAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2REMOVEVARIABLEVALUEACTION))
            return UMLFactory.eINSTANCE.createRemoveVariableValueAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2REPLYACTION))
            return UMLFactory.eINSTANCE.createReplyAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2SENDOBJECTACTION))
            return UMLFactory.eINSTANCE.createSendObjectAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2STARTCLASSIFIERBEHAVIORACTION))
            return UMLFactory.eINSTANCE.createStartClassifierBehaviorAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2TESTIDENTITYACTION))
            return UMLFactory.eINSTANCE.createTestIdentityAction();
        else if (objingElement.isStereotyped(XMIStereotypes.UML2UNMARSHALLACTION))
            return UMLFactory.eINSTANCE.createUnmarshallAction();
        else
            return UMLFactory.eINSTANCE.createOpaqueAction();
    }

    @objid ("0ff533b9-4583-11e0-b54c-00137279a832")
    public OOpaqueAction() {
    }

    @objid ("0ff533bb-4583-11e0-b54c-00137279a832")
    public OOpaqueAction(IOpaqueAction element) {
        super(element);
        objingElement = element;
    }

    @objid ("0ff533c4-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("0ff79615-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        
        if (ecoreElt instanceof OpaqueAction){
            setBody((OpaqueAction) ecoreElt);
        }else if (ecoreElt instanceof ValueSpecificationAction){
            setValue((ValueSpecificationAction) ecoreElt);
        }else if (ecoreElt instanceof CreateObjectAction){
            setClassifier((CreateObjectAction) ecoreElt);
        }else if (ecoreElt instanceof ReadExtentAction){
            setClassifier((ReadExtentAction) ecoreElt);
        }else if (ecoreElt instanceof ClearAssociationAction){
            setAssociation((ClearAssociationAction) ecoreElt);
        }else if (ecoreElt instanceof StructuralFeatureAction){
            setFeature((StructuralFeatureAction) ecoreElt);
        }
    }

    @objid ("0ff9f872-4583-11e0-b54c-00137279a832")
    private void setBody(OpaqueAction action) {
        action.getBodies().add(objingElement.getBody());
    }

    @objid ("0ff9f875-4583-11e0-b54c-00137279a832")
    private void setValue(ValueSpecificationAction ecoreElt) {
        if (objingElement.getOutput().size() > 0){
        
            IGeneralClass primitiveType = objingElement.getOutput().get(0).getType();
        
            IUMLTypes umlTypes = Modelio.getInstance().getModelingSession()
                    .getModel().getUmlTypes();
            IDataType  obINTEGER= umlTypes.getINTEGER();
            IDataType obSTRING = umlTypes.getSTRING();
        
            String tagValue = "";
            for (ITaggedValue tag : objingElement.getTag()){
                if (tag.getDefinition().getName().equals("Value")){
                    for (ITagParameter params : tag.getActual()){
                        tagValue = params.getValue();
                        break;
                    }
                }
            }
        
            if (!tagValue.equals("")){
                if ((obINTEGER != null) &&  obINTEGER.equals(primitiveType)){
                    try{
                        LiteralInteger literal = UMLFactory.eINSTANCE.createLiteralInteger();
                        literal.setValue(Integer.valueOf(tagValue));
                        ecoreElt.setValue(literal);
                    }catch(NumberFormatException e){
                        LiteralString literal = UMLFactory.eINSTANCE.createLiteralString();
                        literal.setValue(tagValue);
                        ecoreElt.setValue(literal);
                    }
        
        
                } else if ((obSTRING != null) &&  obSTRING.equals(primitiveType)){
                    LiteralString literal = UMLFactory.eINSTANCE.createLiteralString();
                    literal.setValue(tagValue);
                    ecoreElt.setValue(literal);
                }else{
                    OpaqueExpression opaqueExpression = UMLFactory.eINSTANCE.createOpaqueExpression();
                    opaqueExpression.getBodies().add(tagValue);
                    ecoreElt.setValue(opaqueExpression);
                }
            }
        }
    }

    @objid ("0ff9f878-4583-11e0-b54c-00137279a832")
    private void setFeature(StructuralFeatureAction ecoreElt) {
        for (IDependency depend : objingElement.getDependsOnDependency()){
            if (depend.isStereotyped(XMIStereotypes.UML2STRUCTURALFEATUREREFERENCE)){
                Element structuralFeature = GenerationProperties.getInstance().getMappedElement(depend.getDependsOn());
                if (structuralFeature instanceof StructuralFeature){
                    ecoreElt.setStructuralFeature((StructuralFeature)structuralFeature);
                }
            }
        }
    }

    @objid ("0ff9f87b-4583-11e0-b54c-00137279a832")
    private void setAssociation(ClearAssociationAction ecoreElt) {
        for (IDependency depend : objingElement.getDependsOnDependency()){
            if (depend.isStereotyped(XMIStereotypes.UML2ASSOCIATIONREFERENCE)){
                Element classifier = GenerationProperties.getInstance().getMappedElement(depend.getDependsOn());
                if (classifier instanceof Association){
                    ecoreElt.setAssociation((Association)classifier);
                }
            }
        }
    }

    @objid ("0ffc5ac6-4583-11e0-b54c-00137279a832")
    private void setClassifier(ReadExtentAction ecoreElt) {
        for (IDependency depend : objingElement.getDependsOnDependency()){
            if (depend.isStereotyped(XMIStereotypes.UML2CLASSIFIERREFERENCE)){
                Element classifier = GenerationProperties.getInstance().getMappedElement(depend.getDependsOn());
                if (classifier instanceof Classifier){
                    ecoreElt.setClassifier((Classifier)classifier);
                }
            }
        }
    }

    @objid ("0ffc5ac9-4583-11e0-b54c-00137279a832")
    private void setClassifier(CreateObjectAction ecoreElt) {
        for (IDependency depend : objingElement.getDependsOnDependency()){
            if (depend.isStereotyped(XMIStereotypes.UML2CLASSIFIERREFERENCE)){
                Element classifier = GenerationProperties.getInstance().getMappedElement(depend.getDependsOn());
                if (classifier instanceof Classifier){
                    ecoreElt.setClassifier((Classifier)classifier);
                }
            }
        }
    }

}
