/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageMerge;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("10274521-4583-11e0-b54c-00137279a832")
public class OPackageMerge extends OElement implements IOElement {
    @objid ("10274522-4583-11e0-b54c-00137279a832")
    private IPackageMerge objingElement;


    @objid ("10274523-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createPackageMerge();
    }

    @objid ("1029a775-4583-11e0-b54c-00137279a832")
    public OPackageMerge() {
    }

    @objid ("1029a777-4583-11e0-b54c-00137279a832")
    public OPackageMerge(IPackageMerge element) {
        super(element);
        objingElement = element;
    }

    @objid ("102c09ce-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        GenerationProperties genProp = GenerationProperties.getInstance();
        PackageMerge ecorePkgMerge = (PackageMerge) ecoreElt;
                
        IPackage objingMergedPackage = objingElement.getMergedPackage();
        IPackage objingReceivingPackage = objingElement.getReceivingPackage();
                
        if (objingMergedPackage != null && objingReceivingPackage != null) {
            // Gets or creates the ecore merged Package:
            Package ecoreMergedPackage = (Package) genProp
                    .getMappedElement(objingMergedPackage);
                
            // Gets or creates the ecore receiving Package:
            Package ecoreReceivingPackage = (Package) genProp
                    .getMappedElement(objingReceivingPackage);
                
            if (ecoreMergedPackage != null && ecoreReceivingPackage != null) {
                ecorePkgMerge.setMergedPackage(ecoreMergedPackage);
                ecorePkgMerge.setReceivingPackage(ecoreReceivingPackage);
                ecoreReceivingPackage.getPackageMerges().add((PackageMerge)ecoreElt);
            }
        }
    }

    @objid ("102c09d2-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        // setMergedPackage((PackageMerge)ecoreElt); -> DONE IN linkEcoreElt()
        // OPERATION
    }

}
