/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IPin;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Pin;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("678984b0-1a76-11e1-8103-0027103f347d")
public class OPin extends OObjectNode implements IOElement {

    @objid ("678984b1-1a76-11e1-8103-0027103f347d")
    public OPin() {
    }

    @objid ("6789abc2-1a76-11e1-8103-0027103f347d")
    public OPin(final IPin element) {
        super(element);
    }

    @Override
    @objid ("6789abc6-1a76-11e1-8103-0027103f347d")
    public void attach(final Element ecoreElt, final CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @Override
    @objid ("6789f9e8-1a76-11e1-8103-0027103f347d")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createPin();
    }

    @objid ("678a20f9-1a76-11e1-8103-0027103f347d")
    private void setExpansionEAnnotation(final Pin pin) {
        ObjingEAnnotation.setExpansion(pin, ((IPin)getObjingElement()).isExpansion());
    }

    @Override
    @objid ("678a480a-1a76-11e1-8103-0027103f347d")
    public void setProperties(final Element ecoreElt) {
        super.setProperties(ecoreElt);
        if (ecoreElt instanceof Pin){
            setControl((Pin) ecoreElt);
            setExpansionEAnnotation((Pin) ecoreElt);
        }
    }

    @objid ("678abd42-1a76-11e1-8103-0027103f347d")
    private void setControl(final Pin pin) {
        pin.setIsControl(((IPin)getObjingElement()).isControl());
    }

}
