/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("10712e00-4583-11e0-b54c-00137279a832")
public class ORegion extends OModelElement implements IOElement {
    @objid ("10712e01-4583-11e0-b54c-00137279a832")
    private GenerationProperties genProp = GenerationProperties.getInstance();

    @objid ("10712e02-4583-11e0-b54c-00137279a832")
    private IRegion objingElement;


    @objid ("10712e03-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return  UMLFactory.eINSTANCE.createRegion();
    }

    @objid ("10712e07-4583-11e0-b54c-00137279a832")
    public ORegion(IRegion element) {
        super(element);       
        objingElement = element;
    }

    @objid ("1073905e-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        IElement objingOwner = objingElement.getParent();
        
        if (objingOwner == null)
            objingOwner = objingElement.getRepresented();
                
        Element ecoreOwner = genProp.getMappedElement(objingOwner);
        
        if (ecoreOwner instanceof State) {
            ((State) ecoreOwner).getRegions().add((Region) ecoreElt);
            
        }else if (ecoreOwner instanceof StateMachine){
            ((StateMachine) ecoreOwner).getRegions().add((Region) ecoreElt);
        }
    }

    @objid ("10739062-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
    }

}
