/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.analyst.IRequirement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import com.modeliosoft.modelio.xmi.util.ModelerModuleStereotypes;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.PackageableElement;
import org.eclipse.uml2.uml.UMLFactory;
import org.eclipse.uml2.uml.VisibilityKind;

@objid ("107d19c2-4583-11e0-b54c-00137279a832")
public class ORequirement extends OElement implements IOElement {
    @objid ("107d19c3-4583-11e0-b54c-00137279a832")
    private GenerationProperties genProp = GenerationProperties.getInstance();


    @objid ("107d19c4-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return  UMLFactory.eINSTANCE.createClass();
    }

    @objid ("107d19c8-4583-11e0-b54c-00137279a832")
    public ORequirement() {
    }

    @objid ("107f7c1c-4583-11e0-b54c-00137279a832")
    public ORequirement(IRequirement param) {
        super(param);
    }

    @objid ("107f7c25-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        if (ecoreElt != null){
            GenerationProperties genProp = GenerationProperties.getInstance();
            if (isRequirementPart()){
                genProp.getEcoreModel().getPackagedElements().remove((PackageableElement)ecoreElt);
                ((Class)genProp.getMappedElement(getRequirementOwner())).getNestedClassifiers().add((Class) ecoreElt);
            }else
                genProp.getEcoreModel().getPackagedElements().add((PackageableElement)ecoreElt);
        }
    }

    @objid ("107f7c29-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        if (ecoreElt != null){
            genProp.addSysMLExported((IRequirement) getObjingElement());
            ((Class)ecoreElt).setName(((IRequirement)getObjingElement()).getName());
            ((Class)ecoreElt).setVisibility(VisibilityKind.PUBLIC_LITERAL);
            ((Class)ecoreElt).setIsAbstract(false);
        }
    }

    @objid ("1081de76-4583-11e0-b54c-00137279a832")
    private boolean isRequirementPart() {
        for (IDependency dependency : ((IModelElement)getObjingElement()).getDependsOnDependency()){
            if (dependency.isStereotyped(ModelerModuleStereotypes.PART)){
                return true;
            }
        }
        return false;
    }

    @objid ("1081de7a-4583-11e0-b54c-00137279a832")
    private IRequirement getRequirementOwner() {
        for (IDependency dependency : ((IModelElement)getObjingElement()).getDependsOnDependency()){
            if (dependency.isStereotyped(ModelerModuleStereotypes.PART)){
        
                return (IRequirement) dependency.getDependsOn();
            }
        }
        return null;
    }

}
