/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.analyst.IRequirementContainer;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import com.modeliosoft.modelio.xmi.util.NotFoundException;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.ObjingModelNavigation;
import org.eclipse.uml2.uml.Component;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageableElement;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("108440d0-4583-11e0-b54c-00137279a832")
public class ORequirementContainer extends OElement implements IOElement {

    @objid ("108440d1-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        Package result  = UMLFactory.eINSTANCE.createPackage();
        ObjingEAnnotation.setRequirementContainer(result, true);
        return result;
    }

    @objid ("108440d5-4583-11e0-b54c-00137279a832")
    public ORequirementContainer() {
    }

    @objid ("108440d7-4583-11e0-b54c-00137279a832")
    public ORequirementContainer(IRequirementContainer param) {
        super(param);
    }

    @objid ("1086a330-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        GenerationProperties genProp = GenerationProperties.getInstance();
        
        IElement objingOwner = ownerVisitor.getCompositionOwner((IRequirementContainer)getObjingElement());
                
        if (objingOwner != null) {// else : case of the root package
            Element ecoreOwner = genProp.getMappedElement(objingOwner);
                
            if (ecoreOwner != null) {
                if (ecoreOwner instanceof Package) {
                    Package ownerIsPkg = (Package) ecoreOwner;
                    ownerIsPkg.getPackagedElements().add((PackageableElement)ecoreElt);
                } else if (ecoreOwner instanceof Component) {
                    Component ownerIsCmpnt = (Component) ecoreOwner;
                    ownerIsCmpnt.getPackagedElements().add((PackageableElement)ecoreElt);
                }
                else {
                    ecoreElt.destroy();
                    throw new NotFoundException("Owner Class ("
                            + ecoreOwner.getClass().getSimpleName()
                            + ") Not Found");
                }
            }
        }
    }

    @objid ("1086a334-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        this.setName((Package) ecoreElt);
    }

    @objid ("6795451a-1a76-11e1-8103-0027103f347d")
    private void setName(final Package ecoreElt) {
        String name = ((IRequirementContainer)getObjingElement()).getName();
        if (ObjingModelNavigation.isNotNullOrEmpty(name))
            ecoreElt.setName(name);
    }

}
