/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.SendSignalAction;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("108dca38-4583-11e0-b54c-00137279a832")
public class OSendSignalAction extends OActivityNode implements IOElement {
    @objid ("108dca39-4583-11e0-b54c-00137279a832")
    private ISendSignalAction objingElement;

    @objid ("108dca3b-4583-11e0-b54c-00137279a832")
    private GenerationProperties genProp = GenerationProperties.getInstance();


    @objid ("108dca3c-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        if (objingElement.getExtension().contains(XMIStereotypes.UML2BROADCASTSIGNALACTION))
            return UMLFactory.eINSTANCE.createSendSignalAction();
        else
            return UMLFactory.eINSTANCE.createSendSignalAction();
    }

    @objid ("108dca3f-4583-11e0-b54c-00137279a832")
    public OSendSignalAction() {
    }

    @objid ("108dca41-4583-11e0-b54c-00137279a832")
    public OSendSignalAction(ISendSignalAction element) {
        super(element);
        objingElement = element;
    }

    @objid ("10902c96-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("10902c9a-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setSignal((SendSignalAction) ecoreElt);
    }

    @objid ("10928ef9-4583-11e0-b54c-00137279a832")
    private void setSignal(SendSignalAction action) {
        ISignal objingSignal = objingElement.getSent();
        
        if (objingSignal != null) {
            Element ecoreSignal = genProp.getMappedElement(objingSignal);
            if (ecoreSignal instanceof Signal)
                action.setSignal((Signal) ecoreSignal);
        }
    }

}
