/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("10a33f62-4583-11e0-b54c-00137279a832")
public class OState extends OModelElement implements IOElement {
    @objid ("10a33f65-4583-11e0-b54c-00137279a832")
    private IState objingElement;

    @objid ("10a33f66-4583-11e0-b54c-00137279a832")
    private GenerationProperties genProp = GenerationProperties.getInstance();


    @objid ("10a33f67-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createState();
    }

    @objid ("10a33f6b-4583-11e0-b54c-00137279a832")
    public OState() {
    }

    @objid ("10a33f6d-4583-11e0-b54c-00137279a832")
    public OState(IState param) {
        super(param);
        objingElement = param;
    }

    @objid ("10a5a1c0-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        Element ecoreOwner = genProp.getMappedElement(objingElement.getParent());
                    
        if (ecoreOwner instanceof Region){
            ((Region) ecoreOwner).getSubvertices().add((State) ecoreElt);
        }
    }

    @objid ("10a5a1c4-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
                setSubMachine((State) ecoreElt);
    }

    @objid ("10a5a1c7-4583-11e0-b54c-00137279a832")
    private void setSubMachine(State ecoreElt) {
        IStateMachine objingSubMachine = objingElement.getSubMachine();
        if (objingSubMachine != null) {
            Element ecoreSubMachine = genProp
                    .getMappedElement(objingSubMachine);
            if (ecoreSubMachine instanceof StateMachine) {
                ecoreElt.setSubmachine((StateMachine) ecoreSubMachine);
            
                
            }
        }
    }

}
