/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.plugin.XMITagTypes;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.ObjingModelNavigation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ExpansionKind;
import org.eclipse.uml2.uml.ExpansionRegion;
import org.eclipse.uml2.uml.StructuredActivityNode;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("10b65236-4583-11e0-b54c-00137279a832")
public class OStructuredActivityNode extends OActivityNode implements IOElement {
    @objid ("10b65237-4583-11e0-b54c-00137279a832")
    private IStructuredActivityNode objingElement;


    @objid ("10b6523a-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        if (((IModelElement)getObjingElement()).isStereotyped(XMIStereotypes.UML2EXPANSIONREGION))
            return UMLFactory.eINSTANCE.createExpansionRegion();
        else if (((IModelElement)getObjingElement()).isStereotyped(XMIStereotypes.UML2SEQUENCENODE))
            return UMLFactory.eINSTANCE.createSequenceNode();
        else
            return UMLFactory.eINSTANCE.createStructuredActivityNode();
    }

    @objid ("10b6523d-4583-11e0-b54c-00137279a832")
    public OStructuredActivityNode() {
    }

    @objid ("10b8b48d-4583-11e0-b54c-00137279a832")
    public OStructuredActivityNode(IStructuredActivityNode element) {
        super(element);
        objingElement = element;
    }

    @objid ("10b8b496-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @objid ("10bb16e6-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
                
                if (ecoreElt instanceof ExpansionRegion){
           setMode((ExpansionRegion)ecoreElt);
                }else{
           setMustIsolate((StructuredActivityNode) ecoreElt);
                }
    }

    @objid ("10bd7945-4583-11e0-b54c-00137279a832")
    private void setMustIsolate(StructuredActivityNode node) {
        node.setMustIsolate(objingElement.ismustIsolate());
    }

    @objid ("10bd7948-4583-11e0-b54c-00137279a832")
    private void setMode(ExpansionRegion ecoreElt) {
        String mode = ObjingModelNavigation.getTaggedValue((IModelElement) getObjingElement(), XMITagTypes.UML2EXPANSIONREGION_MODE);
        if (!mode.equals("")){
            for (ExpansionKind currentMode : ExpansionKind.VALUES){
                if (currentMode.getName().equals(mode)){
                    ecoreElt.setMode(currentMode);
                }
            }
        
        }
    }

}
