/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.Substitution;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("10bfdb9a-4583-11e0-b54c-00137279a832")
public class OSubstitution extends OModelElement implements IOElement {
    @objid ("10bfdb9b-4583-11e0-b54c-00137279a832")
    private ISubstitution objingElement;


    @objid ("10bfdb9c-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createSubstitution();
    }

    @objid ("10bfdba0-4583-11e0-b54c-00137279a832")
    public OSubstitution() {
    }

    @objid ("10bfdba2-4583-11e0-b54c-00137279a832")
    public OSubstitution(ISubstitution param) {
        super(param);
        objingElement = param;
    }

    @objid ("10c23df6-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        GenerationProperties genProp = GenerationProperties.getInstance();
                
        IClassifier objingSubstituting = objingElement
                .getSubstitutingClassifier();
        IClassifier objingContract = objingElement.getContract();
                
        if (objingSubstituting != null && objingContract != null) {
            // Gets or creates the ecore "substituting" element:
            Classifier ecoreSubstituting = (Classifier) genProp
                    .getMappedElement(objingSubstituting);
                
            // Gets or creates the ecore "contract" element:
            Classifier ecoreContract = (Classifier) genProp
                    .getMappedElement(objingContract);
                
            if (ecoreSubstituting != null && ecoreContract != null) {
                Substitution ecoreSubstitution = (Substitution) ecoreElt;
                
                ecoreSubstitution.setSubstitutingClassifier(ecoreSubstituting);
                ecoreSubstitution.setContract(ecoreContract);
                
                Package ecorePkg = ecoreSubstituting.getNearestPackage();
                ecorePkg.getPackagedElements().add(ecoreSubstitution);
            }
        }
    }

    @objid ("10c23dfa-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
    }

}
