/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IMetaclassReference;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.generation.TotalExportMap;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import com.modeliosoft.modelio.xmi.util.PrimitiveTypeMapper;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.PrimitiveType;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Stereotype;

@objid ("10c4a04e-4583-11e0-b54c-00137279a832")
public class OTaggedValue extends OElement implements IOElement {
    @objid ("10c4a04f-4583-11e0-b54c-00137279a832")
    private ITaggedValue objingElement;

    @objid ("10c4a056-4583-11e0-b54c-00137279a832")
    private PrimitiveType booleanType = PrimitiveTypeMapper.getBoolean();

    @objid ("10c4a057-4583-11e0-b54c-00137279a832")
    private PrimitiveType stringType = PrimitiveTypeMapper.getString();


    @objid ("10c4a058-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return setTaggedValues(objingElement);
    }

    @Override
    @objid ("10c4a05c-4583-11e0-b54c-00137279a832")
    public String getObjingID() {
        return objingElement.getIdentifier();
    }

    @Override
    @objid ("10c702aa-4583-11e0-b54c-00137279a832")
    public IElement getObjingElement() {
        return objingElement;
    }

    @objid ("10c702af-4583-11e0-b54c-00137279a832")
    public OTaggedValue() {
    }

    @objid ("10c702b1-4583-11e0-b54c-00137279a832")
    public OTaggedValue(ITaggedValue element) {
        super(element);
        objingElement = element;
    }

    @objid ("10c9650a-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
    }

    @objid ("10c9650e-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
    }

    @objid ("10c96511-4583-11e0-b54c-00137279a832")
    private Property setTaggedValues(ITaggedValue obTaggedValue) {
        if( GenerationProperties.getInstance().isRoundtripEnabled()){
            return createValueEAnnotation();
        }else{
            return createValue();
        }
    }

    @objid ("10d550c6-4583-11e0-b54c-00137279a832")
    private Property createValueEAnnotation() {
        IModelElement element = objingElement.getAnnoted();
                
        ITagType tagType = objingElement.getDefinition(); 
                
        // r?cuperation du stereotype
                
        IStereotype obStereotype = tagType.getOwnerStereotype();
        Stereotype stereotype = null;
                
        if (obStereotype != null){
                
            IStereotype appliedSterotype = null;
            for (IStereotype extension : element.getExtension()){
                IStereotype temp = extension;
                while (temp != null ){
                    if (temp.equals(obStereotype)){
                        appliedSterotype = extension;
                        TotalExportMap totalCreationMap = TotalExportMap.getInstance();
                        stereotype = (Stereotype) totalCreationMap.get(appliedSterotype.getIdentifier());
                    }
                
                    temp = temp.getParent();
                
                }
            }
                
        }else{
            IMetaclassReference obReference = tagType.getOwnerReference();    
            TotalExportMap totalCreationMap = TotalExportMap.getInstance();
            stereotype = (Stereotype) totalCreationMap.get(obReference.getIdentifier());
        }
                
        if (stereotype != null){
                
            String name = tagType.getName();
            if (tagType.getParamNumber().equals("0")){
                return stereotype.getOwnedAttribute(name, booleanType); 
                //            }else if (tagType.getParamNumber().equals("1")){
                //                return stereotype.getOwnedAttribute(name, stringType); 
                //            }else if (tagType.getParamNumber().equals("*")){
                //
                //                //Cas tableau de string
                ////                int i = 0; 
                //                for (ITagParameter tagParameter : objingElement.getActual() ){
                //
                ////                    String currentName = name + "_" + String.valueOf(i);
                //                    Property property = stereotype.getOwnedAttribute(name, stringType); 
                //
                ////                    if (property == null){
                ////                        Property propertyTemp = stereotype.getOwnedAttribute( name + "_0", stringType); 
                ////                        copy(propertyTemp, currentName, i,stereotype);
                ////                    }
                ////
                ////                    i++;
                //                }
                //                return stereotype.getOwnedAttribute(name+"_0", stringType); 
            }else {
                return stereotype.getOwnedAttribute(name, stringType); 
            }
                
        }
        return null;
    }

    @objid ("10d550d0-4583-11e0-b54c-00137279a832")
    private Property createValue() {
        IModelElement element = objingElement.getAnnoted();
                
        ITagType tagType = objingElement.getDefinition(); 
                
        // r?cuperation du stereotype
                
        IStereotype obStereotype = tagType.getOwnerStereotype();
        Stereotype stereotype = null;
                
        if (obStereotype != null){
                
            IStereotype appliedSterotype = null;
            for (IStereotype extension : element.getExtension()){
                IStereotype temp = extension;
                while (temp != null ){
                    if (temp.equals(obStereotype)){
                        appliedSterotype = extension;
                        TotalExportMap totalCreationMap = TotalExportMap.getInstance();
                        stereotype = (Stereotype) totalCreationMap.get(appliedSterotype.getIdentifier());
                    }
                
                    temp = temp.getParent();
                
                }
            }
                
        }else{
            IMetaclassReference obReference = tagType.getOwnerReference();    
            TotalExportMap totalCreationMap = TotalExportMap.getInstance();
            stereotype = (Stereotype) totalCreationMap.get(obReference.getIdentifier());
        }
                
        if (stereotype != null){
                
            String name = tagType.getName(); 
            
            if (tagType.getParamNumber().equals("0")){
                return stereotype.getOwnedAttribute(name, booleanType); 
            }else {
                return stereotype.getOwnedAttribute(name, stringType); 
            }
        }
        return null;
    }

}
