/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing;

import com.modeliosoft.modelio.api.model.uml.behavior.activity.IValuePin;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ExpansionNode;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.UMLFactory;
import org.eclipse.uml2.uml.ValuePin;

@objid ("111a74fc-4583-11e0-b54c-00137279a832")
public class OValuePin extends OInputPin implements IOElement {

    @Override
    @objid ("111a74fd-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt, CompositionOwnerVisitor ownerVisitor) {
        super.attach(ecoreElt, ownerVisitor);
    }

    @Override
    @objid ("111f39ab-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return super.createEcoreElt();
    }

    @Override
    @objid ("111f39b0-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        if (!(ecoreElt instanceof ExpansionNode)){
            setValue((InputPin) ecoreElt);
        }
    }

    @objid ("476cfd93-5c0f-11e1-9a0a-0027103f347d")
    public OValuePin() {
    }

    @objid ("476d24a4-5c0f-11e1-9a0a-0027103f347d")
    public OValuePin(final IValuePin element) {
        super(element);
    }

    @objid ("4778bd8f-5c0f-11e1-9a0a-0027103f347d")
    private void setValue(final InputPin pin) {
        String objingValue = ((IValuePin)getObjingElement()).getValue();
        if (objingValue.length() > 0 && pin instanceof ValuePin) {
            LiteralString literal = UMLFactory.eINSTANCE.createLiteralString();
            literal.setName("Value");
            literal.setValue(objingValue);
            ((ValuePin) pin).setValue(literal);
        }
    }

}
