/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing.profile;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.generation.ProfileExportVisitorImpl;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import com.modeliosoft.modelio.xmi.util.ProfileUtils;
import org.eclipse.uml2.uml.Stereotype;

@objid ("1123fe65-4583-11e0-b54c-00137279a832")
public class PExportGeneralization implements IExportProfileElement {
    @objid ("1123fe66-4583-11e0-b54c-00137279a832")
    private String baseClass = "";

    @objid ("1123fe67-4583-11e0-b54c-00137279a832")
    private IStereotype stereotype = null;


    @objid ("1123fe6b-4583-11e0-b54c-00137279a832")
    public PExportGeneralization(String baseClass, IStereotype stereotype) {
        this.baseClass = baseClass;
        this.stereotype = stereotype;
    }

    @objid ("112660b8-4583-11e0-b54c-00137279a832")
    public void accept(ProfileExportVisitorImpl visitor) {
        visitor.visit(this);
    }

    @objid ("112660bb-4583-11e0-b54c-00137279a832")
    public void visit() {
        Stereotype ecoreStereotype = (Stereotype)  GenerationProperties.getInstance().getMappedElement(this.stereotype);
        
        for (String newMetaclassName : ProfileUtils.getEcoreNameClass(this.baseClass)){
            ProfileUtils.addReference(ecoreStereotype, newMetaclassName);
        }
    }

}
