/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing.sequence;

import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionOccurenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionOperand;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessageEnd;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.OccurrenceSpecification;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("114ee8bb-4583-11e0-b54c-00137279a832")
public class ExecutionOccurenceSpecificationMapper extends MessageEndMapper {

    @objid ("114ee8bc-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        super.createEcoreElt();
        IExecutionOccurenceSpecification objiingExecOccu = (IExecutionOccurenceSpecification) objingElement;
        if (objingMessageSent != null) {
            return UMLFactory.eINSTANCE.createMessageOccurrenceSpecification();
        } else {
            IInteraction enclosingInteraction = objiingExecOccu
                    .getEnclosingInteraction();
            if (enclosingInteraction != null) {
                IInteractionFragment previous = enclosingInteraction
                        .getPrevious(objiingExecOccu);
                // if previous obMessageEnd we may have a sent Message Message
                if (previous instanceof IMessageEnd) {
                    objingMessageSent = ((IMessageEnd) previous).getSentMessage();
                    if (objingMessageSent != null) {
                        return UMLFactory.eINSTANCE
                                .createMessageOccurrenceSpecification();
                    }
                }
            } else {
                IInteractionOperand enclosingInteractionOperand = objiingExecOccu
                        .getEnclosingOperand();
                if (enclosingInteractionOperand != null) {
                    IInteractionFragment previous = enclosingInteractionOperand
                            .getPrevious(objiingExecOccu);
                    // if previous obMessageEnd we may have a sent Message
                    // Message
                    if (previous instanceof IMessageEnd) {
                        objingMessageSent = ((IMessageEnd) previous)
                                .getSentMessage();
                        if (objingMessageSent != null) {
                            return UMLFactory.eINSTANCE
                                    .createMessageOccurrenceSpecification();
                        }
                    }
                }
            }
        }
        // If we recieve a message form a gate on an interactionuse for exemple,
        // the previous is not a message end but we need to set the receiveEvent
        // on message
        if (objingMessageSent == null) {
            objingMessageSent = ((IExecutionOccurenceSpecification) objingElement)
                    .getReceivedMessage();
            if (objingMessageSent != null) {
                return UMLFactory.eINSTANCE
                        .createMessageOccurrenceSpecification();
            }
        }
        return UMLFactory.eINSTANCE.createExecutionOccurrenceSpecification();
    }

    @objid ("11514b0c-4583-11e0-b54c-00137279a832")
    public ExecutionOccurenceSpecificationMapper(IElement param, MainMapper mapper) {
        super(param, mapper);
    }

    @Override
    @objid ("11514b10-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt) {
        super.attach(ecoreElt);
    }

    @Override
    @objid ("11514b14-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
                //                if (ecoreElt instanceof ExecutionOccurrenceSpecification) {
                //                    setExecution((ExecutionOccurrenceSpecification) ecoreElt);
                //        
                //                }
        setStartOrFinishOnExecutionSpecification((OccurrenceSpecification) ecoreElt);
    }

    @objid ("1153ad66-4583-11e0-b54c-00137279a832")
    private void setStartOrFinishOnExecutionSpecification(OccurrenceSpecification specification) {
        IExecutionSpecification objingExecSp = ((IExecutionOccurenceSpecification) objingElement)
        .getStarted();
        
        if (objingExecSp == null){
        
             objingExecSp = ((IExecutionOccurenceSpecification) objingElement)
            .getFinished();
        }else{
            new ExecutionSpecificationMapper(objingExecSp, mapper, true);
        }
        
        if (objingExecSp != null) {
            new ExecutionSpecificationMapper(objingExecSp, mapper, true);
        }
    }

}
