/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing.sequence;

import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGate;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionFragment;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Gate;
import org.eclipse.uml2.uml.Interaction;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("1158721d-4583-11e0-b54c-00137279a832")
public class GateMapper extends MessageEndMapper {

    @Override
    @objid ("1158721e-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        super.createEcoreElt();
        if (objingMessageSent == null) {
            IGate objiingExecOccu = (IGate) objingElement;
            objingMessageSent = objiingExecOccu.getReceivedMessage();
            /*
             * IInteraction objingInteraction = this.getOwnerInteraction();
             * IInteractionFragment previous =
             * objingInteraction.getPrevious(objiingExecOccu); if(previous
             * instanceof IMessageEnd) { objingMessage =
             * ((IMessageEnd)previous).getSentMessage(); }
             */
        }
        return UMLFactory.eINSTANCE.createGate();
    }

    @objid ("11587223-4583-11e0-b54c-00137279a832")
    public GateMapper(IElement param, MainMapper mapper) {
        super(param, mapper);
    }

    @Override
    @objid ("11587227-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt) {
        super.attach(ecoreElt);
    }

    @Override
    @objid ("115ad477-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        super.setProperties(ecoreElt);
        setGateName(ecoreElt);
    }

    @Override
    @objid ("115ad47b-4583-11e0-b54c-00137279a832")
    protected IInteraction getInteraction(IInteractionFragment objingElement) {
        return ((IGate) objingElement).getOwnerInteraction();
    }

    @Override
    @objid ("115ad481-4583-11e0-b54c-00137279a832")
    protected void addFragementToInteraction(Interaction ecoreInteraction, Element ecoreElt) {
        ecoreInteraction.getFormalGates().add((Gate)ecoreElt);
    }

    @objid ("115d36d1-4583-11e0-b54c-00137279a832")
    private void setGateName(Element ecoreElt) {
        IGate objingGate = (IGate) objingElement;
                
        IGate formalGate = objingGate.getFormal();
        if (formalGate != null) {
            String formalGateName = formalGate.getName();
            if (EcoreModelNavigation.isNotNull(formalGateName))
                ((NamedElement) ecoreElt).setName(formalGateName);
            else 
                 ((NamedElement) ecoreElt).setName("");
        }
    }

}
