/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing.sequence;

import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ICombinedFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionOperand;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.CombinedFragment;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.InteractionConstraint;
import org.eclipse.uml2.uml.InteractionOperand;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.UMLFactory;

@objid ("115d36d4-4583-11e0-b54c-00137279a832")
public class InteractionOperandMapper extends BaseMapper {

    @Override
    @objid ("115d36d5-4583-11e0-b54c-00137279a832")
    public Element createEcoreElt() {
        return UMLFactory.eINSTANCE.createInteractionOperand();
    }

    @objid ("115d36da-4583-11e0-b54c-00137279a832")
    private void setAndCreateFragement() {
        IInteractionFragment current = ((IInteractionOperand) objingElement)
                .getStart();
        while (current != null) {
            mapper.createElement(current);
            current = ((IInteractionOperand) objingElement).getNext(current);
        }
    }

    @objid ("115f9929-4583-11e0-b54c-00137279a832")
    public InteractionOperandMapper(IElement param, MainMapper mapper) {
        super(param, mapper);
    }

    @Override
    @objid ("115f992d-4583-11e0-b54c-00137279a832")
    public void attach(Element ecoreElt) {
        // attachInteractionFragment(ecoreElt);
        GenerationProperties genProp = GenerationProperties.getInstance();
        ICombinedFragment objCombin = ((IInteractionOperand) objingElement)
                .getOwnerFragment();
        CombinedFragment fragment = (CombinedFragment) genProp
                .getMappedElement(objCombin);
        if (fragment != null)
            fragment.getOperands().add((InteractionOperand)ecoreElt);
    }

    @Override
    @objid ("115f9931-4583-11e0-b54c-00137279a832")
    public void setProperties(Element ecoreElt) {
        setGuard((InteractionOperand) ecoreElt);
        // To navigate and create all fragement on the InteractionOperand
        setAndCreateFragement();
    }

    @objid ("115f9935-4583-11e0-b54c-00137279a832")
    private void setGuard(InteractionOperand ecoreElt) {
        String objGuard = ((IInteractionOperand) objingElement).getGuard();
        if (objGuard != null && objGuard.trim().length() != 0) {
            // Constraint creation
            InteractionConstraint constraint = UMLFactory.eINSTANCE
                    .createInteractionConstraint();
            // new LiteralString for constraint value
            LiteralString valueSpecification = UMLFactory.eINSTANCE
                    .createLiteralString();
            valueSpecification.setValue(objGuard);
            constraint.setSpecification(valueSpecification);
            ecoreElt.setGuard(constraint);
        }
    }

}
