/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing.sequence;

import java.lang.reflect.Constructor;
import java.util.ArrayList;
import java.util.Hashtable;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessageEnd;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.CompositionOwnerVisitor;
import org.eclipse.uml2.uml.Event;

@objid ("116b84f7-4583-11e0-b54c-00137279a832")
public class MainMapper {
    @objid ("116b84f8-4583-11e0-b54c-00137279a832")
    private static final String PACKAGE_NAME = "com.modeliosoft.modelio.xmi.model.objing.sequence.";

    @objid ("116de745-4583-11e0-b54c-00137279a832")
    private ArrayList<LifelineMapper> lifeLine = new ArrayList<LifelineMapper>();

    @objid ("116de748-4583-11e0-b54c-00137279a832")
    private CompositionOwnerVisitor genericOwner = new CompositionOwnerVisitor();

    @objid ("116de749-4583-11e0-b54c-00137279a832")
    private Hashtable<String, Event> ecoreEvents = new Hashtable<String, Event>();


    @objid ("116de74d-4583-11e0-b54c-00137279a832")
    public MainMapper(CompositionOwnerVisitor genericOwner) {
        this.genericOwner = genericOwner;
    }

    @objid ("116de750-4583-11e0-b54c-00137279a832")
    public CompositionOwnerVisitor getGenericOwner() {
        return this.genericOwner;
    }

    @objid ("116de754-4583-11e0-b54c-00137279a832")
    public Event getEvent(EventMapper eventMapper) {
        return this.ecoreEvents.get(eventMapper.getClass().getName());
    }

    @objid ("117049a0-4583-11e0-b54c-00137279a832")
    public void createElement(IInteractionFragment element) {
        String className = element.getClass().getSimpleName().substring(2)
                + "Mapper";
        try {
            Class<?> classe = Class.forName(PACKAGE_NAME + className);
            // Class[] types = {element.getClass()};
            Class<?>[] types = { IElement.class, MainMapper.class };
            Constructor<?> constructeur;
            constructeur = classe.getConstructor(types);
            Object[] params = { element, this };
            constructeur.newInstance(params);
            // print(element);
        } catch (java.lang.reflect.InvocationTargetException e) {
            e.getCause().printStackTrace();
        } catch (java.lang.ClassNotFoundException e) {
            // e.printStackTrace();
            Modelio.out.println(element.getClass().getSimpleName()
                    + " not implemented " + " implemente " + className);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @objid ("117049a3-4583-11e0-b54c-00137279a832")
    public void createLifeline(ILifeline element) {
        this.lifeLine.add(new LifelineMapper(element, this));
    }

    @objid ("117049a6-4583-11e0-b54c-00137279a832")
    public void print(IInteractionFragment element) {
        Modelio.out.print("Element : " + element.getName());
        if (element instanceof IMessageEnd) {
            IMessage mes = ((IMessageEnd) element).getSentMessage();
            if (mes != null) {
                Modelio.out.print("\tavec Message ===>" + mes.getName());
            }
        }
        for (ILifeline life : element.getCovered()) {
            Modelio.out.print("\tfrom : " + life.getName());
        }
        Modelio.out.println("");
    }

    @objid ("117049a9-4583-11e0-b54c-00137279a832")
    public void addEvent(EventMapper eventMapper, Event event) {
        this.ecoreEvents.put(eventMapper.getClass().getName(), event);
    }

}
