/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.model.objing.sequence;

import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessageEnd;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.NamedElement;

@objid ("6599f762-1a76-11e1-8103-0027103f347d")
public class UMLEventMapper extends EventMapper {

    @Override
    @objid ("659a1e74-1a76-11e1-8103-0027103f347d")
    public Element createEcoreElt() {
        return GenerationProperties.getInstance().getMappedElement(getEvent());
    }

    @objid ("659a6c98-1a76-11e1-8103-0027103f347d")
    public UMLEventMapper(final NamedElement ecoreMessOccSpec, final IElement objingElement, final MainMapper mapper) {
        super(ecoreMessOccSpec, objingElement, mapper);
    }

    @objid ("659b08e0-1a76-11e1-8103-0027103f347d")
    private IEvent getEvent() {
        IMessageEnd messageEnd = (IMessageEnd) objingElement;
        for (IDependency dep : messageEnd.getDependsOnDependency()){
            if (dep.isStereotyped("UML2Event") && (dep.getDependsOn() instanceof IEvent))
                    return (IEvent) dep.getDependsOn();
        }
        return null;
    }

}
