/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.plugin.activator;

import com.modeliosoft.modelio.bridges.Cpp2JavaUtils.PluginClassFinder;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMI;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.plugin.AbstractUIPlugin;
import org.osgi.framework.BundleContext;

/**
 * Activator of the XMI plugin
 * @author ebrosse
 */
@objid ("1191aa8a-4583-11e0-b54c-00137279a832")
public class Activator extends AbstractUIPlugin {
    @objid ("1191aa8f-4583-11e0-b54c-00137279a832")
    private static Activator plugin;


    /**
     * The default constructor
     */
    @objid ("1191aa91-4583-11e0-b54c-00137279a832")
    public Activator() {
    }

    @Override
    @objid ("11940ce4-4583-11e0-b54c-00137279a832")
    public void start(final BundleContext context) throws Exception {
        super.start(context);
        plugin = this;
        // Registering the plugin
        PluginClassFinder.registerClassLoader(XMI.PLUGIN_ID, this.getClass().getClassLoader());
    }

    @Override
    @objid ("11940ce8-4583-11e0-b54c-00137279a832")
    public void stop(final BundleContext context) throws Exception {
        plugin = null;
        super.stop(context);
    }

    /**
     * @return the default activator
     */
    @objid ("11940cec-4583-11e0-b54c-00137279a832")
    public static Activator getDefault() {
        return plugin;
    }

    /**
     * @param path : path of the image
     * @return the image
     */
    @objid ("11940cf1-4583-11e0-b54c-00137279a832")
    public static ImageDescriptor getImageDescriptor(final String path) {
        return imageDescriptorFromPlugin(XMI.PLUGIN_ID, path);
    }

}
