/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.plugin.handlers;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IProfile;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.gui.SwtWizardExportProfile;
import com.modeliosoft.modelio.xmi.util.GenerationProperties;
import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.PlatformUI;

/**
 * @author ebrosse
 */
@objid ("11966f44-4583-11e0-b54c-00137279a832")
public class ExportProfile extends AbstractHandler {
    @objid ("11966f45-4583-11e0-b54c-00137279a832")
     IProfile selectedProfile = null;


    @Override
    @objid ("11966f46-4583-11e0-b54c-00137279a832")
    public Object execute(ExecutionEvent event) throws ExecutionException {
        GenerationProperties genProp = GenerationProperties.getInstance();
        genProp.initialize();
        genProp.setTimeDisplayerActivated(false);
        genProp.setSelectedPackage(this.selectedProfile);
        Shell objing = null;
        if (!(System.getProperty("os.name").equals("Linux"))) {
            objing = Display.getDefault().getActiveShell();
        }
        
        SwtWizardExportProfile dialog = new SwtWizardExportProfile(objing);
        dialog.setSelectedElt(this.selectedProfile);
        dialog.open();
        return null;
    }

    @Override
    @objid ("1198d198-4583-11e0-b54c-00137279a832")
    public boolean isEnabled() {
        ISelection selection = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getSelectionService().getSelection();
        if (selection instanceof IStructuredSelection){
            StructuredSelection structuredSelection = (StructuredSelection) selection;        
            if (structuredSelection.size() == 1)
                if (structuredSelection.getFirstElement() instanceof IAdaptable){
                    IAdaptable adaptable = (IAdaptable) structuredSelection.getFirstElement();
                    Object adapted = adaptable.getAdapter(IElement.class);
                    if(adapted instanceof IProfile){
                        this.selectedProfile = (IProfile) adapted;
                        return true;
                    }
                }
        }
        return false;
    }

}
