/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.preferences;

import com.modeliosoft.modelio.core.ui.ktable.types.IPropertyType;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

/**
 * @author ebrosse
 */
@objid ("1214cbe0-4583-11e0-b54c-00137279a832")
public interface IPreferencesModel {

    /**
     * @return the column number
     */
    @objid ("1214cbe1-4583-11e0-b54c-00137279a832")
    int getColumnNumber();

    /**
     * @return the rows number
     */
    @objid ("1214cbe3-4583-11e0-b54c-00137279a832")
    int getRowsNumber();

    /**
     * @param row : index of the row
     * @param col : index of the column
     * @return the value at (row, col)
     */
    @objid ("1214cbe5-4583-11e0-b54c-00137279a832")
    Object getValueAt(int row, int col);

    /**
     * @param row : index of the row
     * @param col : index of the col
     * @param value : value which will be set at (row, col)
     */
    @objid ("1214cbe9-4583-11e0-b54c-00137279a832")
    void setValueAt(int row, int col, Object value);

    /**
     * @param row : index of the row
     * @param col : index of the col
     * @return the type at (row, col)
     */
    @objid ("1214cbed-4583-11e0-b54c-00137279a832")
    IPropertyType getTypeAt(int row, int col);

    /**
     * @param row : index of the row
     * @param col : index of the col
     * @return true if the cell (row, col) is editable
     */
    @objid ("1214cbf1-4583-11e0-b54c-00137279a832")
    boolean isEditable(int row, int col);

    /**
     * @param row : index of the row
     * @return the description of the row at the specified index
     */
    @objid ("1214cbf5-4583-11e0-b54c-00137279a832")
    String getDescriptionKey(int row);

}
