/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.preferences;

import com.modeliosoft.modelio.javadesigner.annotations.objid;

/**
 * @author ebrosse
 */
@objid ("12388f2e-4583-11e0-b54c-00137279a832")
public class PreferenceData {
    @objid ("12388f2f-4583-11e0-b54c-00137279a832")
    private String key = null;

    @objid ("12388f30-4583-11e0-b54c-00137279a832")
    private String value = null;


    /**
     * @param key : key of the data
     * @param value : value of the data associated to the specified key
     */
    @objid ("12388f31-4583-11e0-b54c-00137279a832")
    public PreferenceData(final String key, final String value) {
        super();
        this.key = key;
        this.value = value;
    }

    /**
     * @param key : key of the data
     */
    @objid ("123af180-4583-11e0-b54c-00137279a832")
    public void setKey(final String key) {
        this.key = key;
    }

    /**
     * @param value : value of the data
     */
    @objid ("123af183-4583-11e0-b54c-00137279a832")
    public void setValue(final String value) {
        this.value = value;
    }

    /**
     * @return the key
     */
    @objid ("123af186-4583-11e0-b54c-00137279a832")
    public String getKey() {
        return this.key;
    }

    /**
     * @return the value
     */
    @objid ("123af18a-4583-11e0-b54c-00137279a832")
    public String getValue() {
        return this.value;
    }

}
