/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.NamedElement;

@objid ("12552b5e-4583-11e0-b54c-00137279a832")
public class ENameSpacing {
    @objid ("12552b5f-4583-11e0-b54c-00137279a832")
    private String separator = ".";

    @objid ("12552b60-4583-11e0-b54c-00137279a832")
    private String[] fullNameSpace = null;

    @objid ("12552b63-4583-11e0-b54c-00137279a832")
    private StringBuilder nameSpacing = new StringBuilder("");

    @objid ("12552b64-4583-11e0-b54c-00137279a832")
    private NamedElement selectedElt;


    @objid ("12552b65-4583-11e0-b54c-00137279a832")
    public String getNameSpacing() {
        StringBuilder strReturn = new StringBuilder("");
                
        int cpt = 1;
        for (String currentStr : fullNameSpace) {
            // We don't add the first element in the String as it is the name of
            // the Ecore Messages.
            if (cpt > 1) {
                strReturn.append(currentStr);
                // In case of the last element, we don't add the delimiter at
                // the end.
                if (cpt < fullNameSpace.length)
                    strReturn.append(separator);
            }
            cpt++;
        }
        return strReturn.toString();
    }

    @objid ("12578db8-4583-11e0-b54c-00137279a832")
    public String getNameSpacing(String newDelimiter) {
        StringBuilder strReturn = new StringBuilder("");
                
        int cpt = 1;
        for (String currentStr : fullNameSpace) {
            // We don't add the first element in the String as it is the name of
            // the Ecore Messages.
            if (cpt > 1) {
                strReturn.append(currentStr);
                // In case of the last element, we don't add the delimiter at
                // the end.
                if (cpt < fullNameSpace.length)
                    strReturn.append(newDelimiter);
            }
            cpt++;
        }
        return strReturn.toString();
    }

    @objid ("12578dbd-4583-11e0-b54c-00137279a832")
    public String[] getSplittedNameSpacing(boolean withModel) {
        if (withModel)
            return fullNameSpace;
        else {
            String[] withoutModel = new String[fullNameSpace.length - 1];
                
            int cpt = 0;
            for (String elt : fullNameSpace) {
                if (cpt != 0)
                    withoutModel[cpt - 1] = elt;
                cpt++;
            }
                
            return withoutModel;
        }
    }

    @objid ("12578dc3-4583-11e0-b54c-00137279a832")
    public String getSeparator() {
        return separator;
    }

    @objid ("12578dc7-4583-11e0-b54c-00137279a832")
    public void setSeparator(String delimiter) {
        separator = delimiter;
    }

    @objid ("1259f012-4583-11e0-b54c-00137279a832")
    public NamedElement getSelectedElt() {
        return selectedElt;
    }

    @objid ("1259f016-4583-11e0-b54c-00137279a832")
    private StringBuilder createStringNameSpace() {
        nameSpacing = nameSpacing.append(selectedElt.getQualifiedName());
        String nameSpace = nameSpacing.toString();
        fullNameSpace = nameSpace.split("::");
        return nameSpacing;
    }

    @objid ("1259f01a-4583-11e0-b54c-00137279a832")
    public ENameSpacing(NamedElement element) {
        selectedElt = element;
        createStringNameSpace();
    }

}
