/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import java.util.HashMap;
import java.util.Map;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.*;
import org.eclipse.uml2.uml.Abstraction;
import org.eclipse.uml2.uml.AcceptCallAction;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.Action;
import org.eclipse.uml2.uml.ActionExecutionSpecification;
import org.eclipse.uml2.uml.ActionInputPin;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.ActivityEdge;
import org.eclipse.uml2.uml.ActivityFinalNode;
import org.eclipse.uml2.uml.ActivityGroup;
import org.eclipse.uml2.uml.ActivityNode;
import org.eclipse.uml2.uml.ActivityParameterNode;
import org.eclipse.uml2.uml.ActivityPartition;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.AddStructuralFeatureValueAction;
import org.eclipse.uml2.uml.AddVariableValueAction;
import org.eclipse.uml2.uml.AnyReceiveEvent;
import org.eclipse.uml2.uml.Artifact;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.AssociationClass;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.BehaviorExecutionSpecification;
import org.eclipse.uml2.uml.BehavioralFeature;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.BroadcastSignalAction;
import org.eclipse.uml2.uml.CallAction;
import org.eclipse.uml2.uml.CallBehaviorAction;
import org.eclipse.uml2.uml.CallEvent;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.CentralBufferNode;
import org.eclipse.uml2.uml.ChangeEvent;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.ClassifierTemplateParameter;
import org.eclipse.uml2.uml.Clause;
import org.eclipse.uml2.uml.ClearAssociationAction;
import org.eclipse.uml2.uml.ClearStructuralFeatureAction;
import org.eclipse.uml2.uml.ClearVariableAction;
import org.eclipse.uml2.uml.Collaboration;
import org.eclipse.uml2.uml.CollaborationUse;
import org.eclipse.uml2.uml.CombinedFragment;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.CommunicationPath;
import org.eclipse.uml2.uml.Component;
import org.eclipse.uml2.uml.ComponentRealization;
import org.eclipse.uml2.uml.ConditionalNode;
import org.eclipse.uml2.uml.ConnectableElement;
import org.eclipse.uml2.uml.ConnectableElementTemplateParameter;
import org.eclipse.uml2.uml.ConnectionPointReference;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.eclipse.uml2.uml.ConsiderIgnoreFragment;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.Continuation;
import org.eclipse.uml2.uml.ControlFlow;
import org.eclipse.uml2.uml.ControlNode;
import org.eclipse.uml2.uml.CreateLinkAction;
import org.eclipse.uml2.uml.CreateLinkObjectAction;
import org.eclipse.uml2.uml.CreateObjectAction;
import org.eclipse.uml2.uml.CreationEvent;
import org.eclipse.uml2.uml.DataStoreNode;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.DecisionNode;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.DeployedArtifact;
import org.eclipse.uml2.uml.Deployment;
import org.eclipse.uml2.uml.DeploymentSpecification;
import org.eclipse.uml2.uml.DeploymentTarget;
import org.eclipse.uml2.uml.DestroyLinkAction;
import org.eclipse.uml2.uml.DestroyObjectAction;
import org.eclipse.uml2.uml.DestructionEvent;
import org.eclipse.uml2.uml.Device;
import org.eclipse.uml2.uml.DirectedRelationship;
import org.eclipse.uml2.uml.Duration;
import org.eclipse.uml2.uml.DurationConstraint;
import org.eclipse.uml2.uml.DurationInterval;
import org.eclipse.uml2.uml.DurationObservation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ElementImport;
import org.eclipse.uml2.uml.EncapsulatedClassifier;
import org.eclipse.uml2.uml.Enumeration;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.Event;
import org.eclipse.uml2.uml.ExceptionHandler;
import org.eclipse.uml2.uml.ExecutableNode;
import org.eclipse.uml2.uml.ExecutionEnvironment;
import org.eclipse.uml2.uml.ExecutionEvent;
import org.eclipse.uml2.uml.ExecutionOccurrenceSpecification;
import org.eclipse.uml2.uml.ExecutionSpecification;
import org.eclipse.uml2.uml.ExpansionNode;
import org.eclipse.uml2.uml.ExpansionRegion;
import org.eclipse.uml2.uml.Expression;
import org.eclipse.uml2.uml.Extend;
import org.eclipse.uml2.uml.Extension;
import org.eclipse.uml2.uml.ExtensionEnd;
import org.eclipse.uml2.uml.ExtensionPoint;
import org.eclipse.uml2.uml.Feature;
import org.eclipse.uml2.uml.FinalNode;
import org.eclipse.uml2.uml.FinalState;
import org.eclipse.uml2.uml.FlowFinalNode;
import org.eclipse.uml2.uml.ForkNode;
import org.eclipse.uml2.uml.FunctionBehavior;
import org.eclipse.uml2.uml.Gate;
import org.eclipse.uml2.uml.GeneralOrdering;
import org.eclipse.uml2.uml.Generalization;
import org.eclipse.uml2.uml.GeneralizationSet;
import org.eclipse.uml2.uml.Image;
import org.eclipse.uml2.uml.Include;
import org.eclipse.uml2.uml.InformationFlow;
import org.eclipse.uml2.uml.InformationItem;
import org.eclipse.uml2.uml.InitialNode;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.InstanceSpecification;
import org.eclipse.uml2.uml.InstanceValue;
import org.eclipse.uml2.uml.Interaction;
import org.eclipse.uml2.uml.InteractionConstraint;
import org.eclipse.uml2.uml.InteractionFragment;
import org.eclipse.uml2.uml.InteractionOperand;
import org.eclipse.uml2.uml.InteractionUse;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.eclipse.uml2.uml.InterruptibleActivityRegion;
import org.eclipse.uml2.uml.Interval;
import org.eclipse.uml2.uml.IntervalConstraint;
import org.eclipse.uml2.uml.InvocationAction;
import org.eclipse.uml2.uml.JoinNode;
import org.eclipse.uml2.uml.Lifeline;
import org.eclipse.uml2.uml.LinkAction;
import org.eclipse.uml2.uml.LinkEndCreationData;
import org.eclipse.uml2.uml.LinkEndData;
import org.eclipse.uml2.uml.LinkEndDestructionData;
import org.eclipse.uml2.uml.LiteralBoolean;
import org.eclipse.uml2.uml.LiteralInteger;
import org.eclipse.uml2.uml.LiteralNull;
import org.eclipse.uml2.uml.LiteralSpecification;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.LiteralUnlimitedNatural;
import org.eclipse.uml2.uml.LoopNode;
import org.eclipse.uml2.uml.Manifestation;
import org.eclipse.uml2.uml.MergeNode;
import org.eclipse.uml2.uml.Message;
import org.eclipse.uml2.uml.MessageEnd;
import org.eclipse.uml2.uml.MessageEvent;
import org.eclipse.uml2.uml.MessageOccurrenceSpecification;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.MultiplicityElement;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.Node;
import org.eclipse.uml2.uml.ObjectFlow;
import org.eclipse.uml2.uml.ObjectNode;
import org.eclipse.uml2.uml.Observation;
import org.eclipse.uml2.uml.OccurrenceSpecification;
import org.eclipse.uml2.uml.OpaqueAction;
import org.eclipse.uml2.uml.OpaqueBehavior;
import org.eclipse.uml2.uml.OpaqueExpression;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.OperationTemplateParameter;
import org.eclipse.uml2.uml.OutputPin;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageImport;
import org.eclipse.uml2.uml.PackageMerge;
import org.eclipse.uml2.uml.PackageableElement;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.ParameterSet;
import org.eclipse.uml2.uml.ParameterableElement;
import org.eclipse.uml2.uml.PartDecomposition;
import org.eclipse.uml2.uml.Pin;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.PrimitiveType;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.ProfileApplication;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.ProtocolConformance;
import org.eclipse.uml2.uml.ProtocolStateMachine;
import org.eclipse.uml2.uml.ProtocolTransition;
import org.eclipse.uml2.uml.Pseudostate;
import org.eclipse.uml2.uml.QualifierValue;
import org.eclipse.uml2.uml.RaiseExceptionAction;
import org.eclipse.uml2.uml.ReadExtentAction;
import org.eclipse.uml2.uml.ReadIsClassifiedObjectAction;
import org.eclipse.uml2.uml.ReadLinkAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction;
import org.eclipse.uml2.uml.ReadSelfAction;
import org.eclipse.uml2.uml.ReadStructuralFeatureAction;
import org.eclipse.uml2.uml.ReadVariableAction;
import org.eclipse.uml2.uml.Realization;
import org.eclipse.uml2.uml.ReceiveOperationEvent;
import org.eclipse.uml2.uml.ReceiveSignalEvent;
import org.eclipse.uml2.uml.Reception;
import org.eclipse.uml2.uml.ReclassifyObjectAction;
import org.eclipse.uml2.uml.RedefinableElement;
import org.eclipse.uml2.uml.RedefinableTemplateSignature;
import org.eclipse.uml2.uml.ReduceAction;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.Relationship;
import org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction;
import org.eclipse.uml2.uml.RemoveVariableValueAction;
import org.eclipse.uml2.uml.ReplyAction;
import org.eclipse.uml2.uml.SendObjectAction;
import org.eclipse.uml2.uml.SendOperationEvent;
import org.eclipse.uml2.uml.SendSignalAction;
import org.eclipse.uml2.uml.SendSignalEvent;
import org.eclipse.uml2.uml.SequenceNode;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.SignalEvent;
import org.eclipse.uml2.uml.Slot;
import org.eclipse.uml2.uml.StartClassifierBehaviorAction;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateInvariant;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.StringExpression;
import org.eclipse.uml2.uml.StructuralFeature;
import org.eclipse.uml2.uml.StructuralFeatureAction;
import org.eclipse.uml2.uml.StructuredActivityNode;
import org.eclipse.uml2.uml.StructuredClassifier;
import org.eclipse.uml2.uml.Substitution;
import org.eclipse.uml2.uml.TemplateBinding;
import org.eclipse.uml2.uml.TemplateParameter;
import org.eclipse.uml2.uml.TemplateParameterSubstitution;
import org.eclipse.uml2.uml.TemplateSignature;
import org.eclipse.uml2.uml.TemplateableElement;
import org.eclipse.uml2.uml.TestIdentityAction;
import org.eclipse.uml2.uml.TimeConstraint;
import org.eclipse.uml2.uml.TimeEvent;
import org.eclipse.uml2.uml.TimeExpression;
import org.eclipse.uml2.uml.TimeInterval;
import org.eclipse.uml2.uml.TimeObservation;
import org.eclipse.uml2.uml.Transition;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.TypedElement;
import org.eclipse.uml2.uml.UnmarshallAction;
import org.eclipse.uml2.uml.Usage;
import org.eclipse.uml2.uml.UseCase;
import org.eclipse.uml2.uml.ValuePin;
import org.eclipse.uml2.uml.ValueSpecification;
import org.eclipse.uml2.uml.ValueSpecificationAction;
import org.eclipse.uml2.uml.Variable;
import org.eclipse.uml2.uml.VariableAction;
import org.eclipse.uml2.uml.Vertex;
import org.eclipse.uml2.uml.WriteLinkAction;
import org.eclipse.uml2.uml.WriteStructuralFeatureAction;
import org.eclipse.uml2.uml.WriteVariableAction;
import org.eclipse.uml2.uml.util.UMLSwitch;

@objid ("13fd8df2-4583-11e0-b54c-00137279a832")
public class OwnedCompositionUml2Visitor extends UMLSwitch<Object> {
    @objid ("13fd8df3-4583-11e0-b54c-00137279a832")
    private XMIImportBehavior behavior;

    @objid ("13fd8df4-4583-11e0-b54c-00137279a832")
    private Map<Object, Object> visitorMap;


    @objid ("13fd8df8-4583-11e0-b54c-00137279a832")
    public OwnedCompositionUml2Visitor(XMIImportBehavior behavior, Package ecoreRootModel) {
        this.behavior = behavior;
        this.visitorMap = new HashMap<Object, Object>();
        
        ReverseProperties.getInstance();
        if (ecoreRootModel instanceof Model)
            this.visitorMap.put(ecoreRootModel, ecoreRootModel);
    }

    @Override
    @objid ("13fd8dfc-4583-11e0-b54c-00137279a832")
    public Object doSwitch(EObject inputElement) {
        if (inputElement != null)
            return super.doSwitch(inputElement);
        else
            return null;
    }

    @Override
    @objid ("13fd8e01-4583-11e0-b54c-00137279a832")
    public Object caseAbstraction(Abstraction inputAbstraction) {
        Object theResult = visitorMap.get(inputAbstraction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AbstractionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputAbstraction, inputAbstraction);
            behavior.visitAbstraction(inputAbstraction);
            this.doSwitch((EObject) inputAbstraction.getMapping());
        }
        return null;
    }

    @Override
    @objid ("13fff050-4583-11e0-b54c-00137279a832")
    public Object caseAcceptCallAction(AcceptCallAction inputAcceptCallAction) {
        Object theResult = visitorMap.get(inputAcceptCallAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AcceptCallActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputAcceptCallAction, inputAcceptCallAction);
            behavior.visitAcceptCallAction(inputAcceptCallAction);
            this.doSwitch((EObject) inputAcceptCallAction
                    .getReturnInformation());
        }
        return null;
    }

    @Override
    @objid ("13fff056-4583-11e0-b54c-00137279a832")
    public Object caseAcceptEventAction(AcceptEventAction inputAcceptEventAction) {
        Object theResult = visitorMap.get(inputAcceptEventAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AcceptEventActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputAcceptEventAction, inputAcceptEventAction);
            behavior.visitAcceptEventAction(inputAcceptEventAction);
            for (Object result : inputAcceptEventAction.getResults()) {
                this.doSwitch((EObject) result);
            }
            for (Object trigger : inputAcceptEventAction.getTriggers()) {
                this.doSwitch((EObject) trigger);
            }
        }
        return null;
    }

    @Override
    @objid ("140252a7-4583-11e0-b54c-00137279a832")
    public Object caseAction(Action inputAction) {
        for (Object output : inputAction.getOutputs()) {
            this.doSwitch((EObject) output);
        }
        for (Object input : inputAction.getInputs()) {
            this.doSwitch((EObject) input);
        }
        for (Object localPrecondition : inputAction.getLocalPreconditions()) {
            this.doSwitch((EObject) localPrecondition);
        }
        for (Object localPostcondition : inputAction.getLocalPostconditions()) {
            this.doSwitch((EObject) localPostcondition);
        }
        return null;
    }

    @Override
    @objid ("140252ad-4583-11e0-b54c-00137279a832")
    public Object caseActionExecutionSpecification(ActionExecutionSpecification inputActionExecutionSpecification) {
        Object theResult = visitorMap.get(inputActionExecutionSpecification);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActionExecutionSpecificationImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputActionExecutionSpecification,
                    inputActionExecutionSpecification);
            behavior
            .visitActionExecutionSpecification(inputActionExecutionSpecification);
        }
        return null;
    }

    @Override
    @objid ("140252b3-4583-11e0-b54c-00137279a832")
    public Object caseActionInputPin(ActionInputPin inputActionInputPin) {
        Object theResult = visitorMap.get(inputActionInputPin);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActionInputPinImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputActionInputPin, inputActionInputPin);
            behavior.visitActionInputPin(inputActionInputPin);
            this.doSwitch((EObject) inputActionInputPin.getFromAction());
        }
        return null;
    }

    @Override
    @objid ("1404b505-4583-11e0-b54c-00137279a832")
    public Object caseActivity(Activity inputActivity) {
        Object theResult = visitorMap.get(inputActivity);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActivityImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputActivity, inputActivity);
            behavior.visitActivity(inputActivity);
            for (Object structuredNode : inputActivity.getStructuredNodes()) {
                this.doSwitch((EObject) structuredNode);
            }
            for (Object variable : inputActivity.getVariables()) {
                this.doSwitch((EObject) variable);
            }
            for (Object node : inputActivity.getNodes()) {
                this.doSwitch((EObject) node);
            }
            for (Object edge : inputActivity.getEdges()) {
                this.doSwitch((EObject) edge);
            }
            for (Object group : inputActivity.getGroups()) {
                this.doSwitch((EObject) group);
            }
        }
        return null;
    }

    @Override
    @objid ("1404b50b-4583-11e0-b54c-00137279a832")
    public Object caseActivityEdge(ActivityEdge inputActivityEdge) {
        this.doSwitch((EObject) inputActivityEdge.getGuard());
        this.doSwitch((EObject) inputActivityEdge.getWeight());
        return null;
    }

    @Override
    @objid ("1407175b-4583-11e0-b54c-00137279a832")
    public Object caseActivityFinalNode(ActivityFinalNode inputActivityFinalNode) {
        Object theResult = visitorMap.get(inputActivityFinalNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActivityFinalNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputActivityFinalNode, inputActivityFinalNode);
            behavior.visitActivityFinalNode(inputActivityFinalNode);
        }
        return null;
    }

    @Override
    @objid ("14071761-4583-11e0-b54c-00137279a832")
    public Object caseActivityGroup(ActivityGroup inputActivityGroup) {
        for (Object subgroup : inputActivityGroup.getSubgroups()) {
            this.doSwitch((EObject) subgroup);
        }
        return null;
    }

    @Override
    @objid ("140979b4-4583-11e0-b54c-00137279a832")
    public Object caseActivityNode(ActivityNode inputActivityNode) {
        return null;
    }

    @Override
    @objid ("140979ba-4583-11e0-b54c-00137279a832")
    public Object caseActivityParameterNode(ActivityParameterNode inputActivityParameterNode) {
        Object theResult = visitorMap.get(inputActivityParameterNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActivityParameterNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputActivityParameterNode,
                    inputActivityParameterNode);
            behavior.visitActivityParameterNode(inputActivityParameterNode);
        }
        return null;
    }

    @Override
    @objid ("140979c0-4583-11e0-b54c-00137279a832")
    public Object caseActivityPartition(ActivityPartition inputActivityPartition) {
        Object theResult = visitorMap.get(inputActivityPartition);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActivityPartitionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputActivityPartition, inputActivityPartition);
            behavior.visitActivityPartition(inputActivityPartition);
            for (Object subpartition : inputActivityPartition
                    .getSubpartitions()) {
                this.doSwitch((EObject) subpartition);
            }
        }
        return null;
    }

    @Override
    @objid ("140bdc12-4583-11e0-b54c-00137279a832")
    public Object caseActor(Actor inputActor) {
        Object theResult = visitorMap.get(inputActor);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActorImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputActor, inputActor);
            behavior.visitActor(inputActor);
        }
        return null;
    }

    @Override
    @objid ("140bdc18-4583-11e0-b54c-00137279a832")
    public Object caseAddStructuralFeatureValueAction(AddStructuralFeatureValueAction inputAddStructuralFeatureValueAction) {
        Object theResult = visitorMap.get(inputAddStructuralFeatureValueAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AddStructuralFeatureValueActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputAddStructuralFeatureValueAction,
                    inputAddStructuralFeatureValueAction);
            behavior
            .visitAddStructuralFeatureValueAction(inputAddStructuralFeatureValueAction);
            this.doSwitch((EObject) inputAddStructuralFeatureValueAction
                    .getInsertAt());
        }
        return null;
    }

    @Override
    @objid ("140e3e69-4583-11e0-b54c-00137279a832")
    public Object caseAddVariableValueAction(AddVariableValueAction inputAddVariableValueAction) {
        Object theResult = visitorMap.get(inputAddVariableValueAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AddVariableValueActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputAddVariableValueAction,
                    inputAddVariableValueAction);
            behavior.visitAddVariableValueAction(inputAddVariableValueAction);
            this.doSwitch((EObject) inputAddVariableValueAction.getInsertAt());
        }
        return null;
    }

    @Override
    @objid ("140e3e6f-4583-11e0-b54c-00137279a832")
    public Object caseAnyReceiveEvent(AnyReceiveEvent inputAnyReceiveEvent) {
        Object theResult = visitorMap.get(inputAnyReceiveEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AnyReceiveEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputAnyReceiveEvent, inputAnyReceiveEvent);
            behavior.visitAnyReceiveEvent(inputAnyReceiveEvent);
        }
        return null;
    }

    @Override
    @objid ("1410a0c2-4583-11e0-b54c-00137279a832")
    public Object caseArtifact(Artifact inputArtifact) {
        Object theResult = visitorMap.get(inputArtifact);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ArtifactImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputArtifact, inputArtifact);
            behavior.visitArtifact(inputArtifact);
            for (Object nestedArtifact : inputArtifact.getNestedArtifacts()) {
                this.doSwitch((EObject) nestedArtifact);
            }
            for (Object manifestation : inputArtifact.getManifestations()) {
                this.doSwitch((EObject) manifestation);
            }
            for (Object ownedOperation : inputArtifact.getOwnedOperations()) {
                this.doSwitch((EObject) ownedOperation);
            }
            for (Object ownedAttribute : inputArtifact.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
        }
        return null;
    }

    @Override
    @objid ("1410a0c8-4583-11e0-b54c-00137279a832")
    public Object caseAssociation(Association inputAssociation) {
        Object theResult = visitorMap.get(inputAssociation);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        
        if (theResult == null
                || !("AssociationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
        
            visitorMap.put(inputAssociation, inputAssociation);
            behavior.visitAssociation(inputAssociation);
            for (Object ownedEnd : inputAssociation.getMemberEnds()) {
                this.doSwitch((EObject) ownedEnd);
            }
        
        }
        return null;
    }

    @Override
    @objid ("1410a0ce-4583-11e0-b54c-00137279a832")
    public Object caseAssociationClass(AssociationClass inputAssociationClass) {
        Object theResult = visitorMap.get(inputAssociationClass);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AssociationClassImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputAssociationClass, inputAssociationClass);
            behavior.visitAssociationClass(inputAssociationClass);
        }
        return null;
    }

    @Override
    @objid ("14130321-4583-11e0-b54c-00137279a832")
    public Object caseBehavior(Behavior inputBehavior) {
        for (Object ownedParameter : inputBehavior.getOwnedParameters()) {
            this.doSwitch((EObject) ownedParameter);
        }
        for (Object precondition : inputBehavior.getPreconditions()) {
            this.doSwitch((EObject) precondition);
        }
        for (Object postcondition : inputBehavior.getPostconditions()) {
            this.doSwitch((EObject) postcondition);
        }
        for (Object ownedParameterSet : inputBehavior.getOwnedParameterSets()) {
            this.doSwitch((EObject) ownedParameterSet);
        }
        return null;
    }

    @Override
    @objid ("14130327-4583-11e0-b54c-00137279a832")
    public Object caseBehavioralFeature(BehavioralFeature inputBehavioralFeature) {
        for (Object ownedParameter : inputBehavioralFeature
                .getOwnedParameters()) {
            this.doSwitch((EObject) ownedParameter);
        }
        for (Object ownedParameterSet : inputBehavioralFeature
                .getOwnedParameterSets()) {
            this.doSwitch((EObject) ownedParameterSet);
        }
        return null;
    }

    @Override
    @objid ("1415657a-4583-11e0-b54c-00137279a832")
    public Object caseBehavioredClassifier(BehavioredClassifier inputBehavioredClassifier) {
        for (Object ownedBehavior : inputBehavioredClassifier
                .getOwnedBehaviors()) {
            this.doSwitch((EObject) ownedBehavior);
        }
        for (Object interfaceRealization : inputBehavioredClassifier
                .getInterfaceRealizations()) {
            this.doSwitch((EObject) interfaceRealization);
        }
        for (Object ownedTrigger : inputBehavioredClassifier.getOwnedTriggers()) {
            this.doSwitch((EObject) ownedTrigger);
        }
        return null;
    }

    @Override
    @objid ("14156580-4583-11e0-b54c-00137279a832")
    public Object caseBehaviorExecutionSpecification(BehaviorExecutionSpecification inputBehaviorExecutionSpecification) {
        Object theResult = visitorMap.get(inputBehaviorExecutionSpecification);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("BehaviorExecutionSpecificationImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputBehaviorExecutionSpecification,
                    inputBehaviorExecutionSpecification);
            behavior
            .visitBehaviorExecutionSpecification(inputBehaviorExecutionSpecification);
        }
        return null;
    }

    @Override
    @objid ("1417c7d1-4583-11e0-b54c-00137279a832")
    public Object caseBroadcastSignalAction(BroadcastSignalAction inputBroadcastSignalAction) {
        Object theResult = visitorMap.get(inputBroadcastSignalAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("BroadcastSignalActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputBroadcastSignalAction,
                    inputBroadcastSignalAction);
            behavior.visitBroadcastSignalAction(inputBroadcastSignalAction);
        }
        return null;
    }

    @Override
    @objid ("141c8c86-4583-11e0-b54c-00137279a832")
    public Object caseCallAction(CallAction inputCallAction) {
        for (Object result : inputCallAction.getResults()) {
            this.doSwitch((EObject) result);
        }
        return null;
    }

    @Override
    @objid ("141eeede-4583-11e0-b54c-00137279a832")
    public Object caseCallBehaviorAction(CallBehaviorAction inputCallBehaviorAction) {
        Object theResult = visitorMap.get(inputCallBehaviorAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CallBehaviorActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCallBehaviorAction, inputCallBehaviorAction);
            behavior.visitCallBehaviorAction(inputCallBehaviorAction);
        }
        return null;
    }

    @Override
    @objid ("141eeee4-4583-11e0-b54c-00137279a832")
    public Object caseCallEvent(CallEvent inputCallEvent) {
        Object theResult = visitorMap.get(inputCallEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CallEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCallEvent, inputCallEvent);
            behavior.visitCallEvent(inputCallEvent);
        }
        return null;
    }

    @Override
    @objid ("1423b393-4583-11e0-b54c-00137279a832")
    public Object caseCallOperationAction(CallOperationAction inputCallOperationAction) {
        Object theResult = visitorMap.get(inputCallOperationAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CallOperationActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCallOperationAction, inputCallOperationAction);
            behavior.visitCallOperationAction(inputCallOperationAction);
            this.doSwitch((EObject) inputCallOperationAction.getTarget());
        }
        return null;
    }

    @Override
    @objid ("142615f0-4583-11e0-b54c-00137279a832")
    public Object caseCentralBufferNode(CentralBufferNode inputCentralBufferNode) {
        Object theResult = visitorMap.get(inputCentralBufferNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CentralBufferNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCentralBufferNode, inputCentralBufferNode);
            behavior.visitCentralBufferNode(inputCentralBufferNode);
        }
        return null;
    }

    @Override
    @objid ("142615f6-4583-11e0-b54c-00137279a832")
    public Object caseChangeEvent(ChangeEvent inputChangeEvent) {
        Object theResult = visitorMap.get(inputChangeEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ChangeEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputChangeEvent, inputChangeEvent);
            behavior.visitChangeEvent(inputChangeEvent);
            this.doSwitch((EObject) inputChangeEvent.getChangeExpression());
        }
        return null;
    }

    @Override
    @objid ("14287847-4583-11e0-b54c-00137279a832")
    public Object caseClass(Class inputClass) {
        Object theResult = visitorMap.get(inputClass);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClassImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputClass, inputClass);
            behavior.visitClass(inputClass);
            for (Object nestedClassifier : inputClass.getNestedClassifiers()) {
                this.doSwitch((EObject) nestedClassifier);
            }
            for (Object ownedAttribute : inputClass.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
            for (Object ownedOperation : inputClass.getOwnedOperations()) {
                this.doSwitch((EObject) ownedOperation);
            }
            for (Object ownedReception : inputClass.getOwnedReceptions()) {
                this.doSwitch((EObject) ownedReception);
            }
        }
        return null;
    }

    @Override
    @objid ("1428784d-4583-11e0-b54c-00137279a832")
    public Object caseClassifier(Classifier inputClassifier) {
        for (Object generalization : inputClassifier.getGeneralizations()) {
            this.doSwitch((EObject) generalization);
        }
        for (Object substitution : inputClassifier.getSubstitutions()) {
            this.doSwitch((EObject) substitution);
        }
        for (Object collaborationUse : inputClassifier.getCollaborationUses()) {
            this.doSwitch((EObject) collaborationUse);
        }
        for (Object ownedUseCase : inputClassifier.getOwnedUseCases()) {
            this.doSwitch((EObject) ownedUseCase);
        }
        this.doSwitch((EObject) inputClassifier.getOwnedTemplateSignature());
        return null;
    }

    @Override
    @objid ("142adaa1-4583-11e0-b54c-00137279a832")
    public Object caseClassifierTemplateParameter(ClassifierTemplateParameter inputClassifierTemplateParameter) {
        Object theResult = visitorMap.get(inputClassifierTemplateParameter);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClassifierTemplateParameterImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputClassifierTemplateParameter,
                    inputClassifierTemplateParameter);
            behavior
            .visitClassifierTemplateParameter(inputClassifierTemplateParameter);
        }
        return null;
    }

    @Override
    @objid ("142adaa7-4583-11e0-b54c-00137279a832")
    public Object caseClause(Clause inputClause) {
        Object theResult = visitorMap.get(inputClause);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClauseImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputClause, inputClause);
            behavior.visitClause(inputClause);
        }
        return null;
    }

    @Override
    @objid ("142d3cfe-4583-11e0-b54c-00137279a832")
    public Object caseClearAssociationAction(ClearAssociationAction inputClearAssociationAction) {
        Object theResult = visitorMap.get(inputClearAssociationAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClearAssociationActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputClearAssociationAction,
                    inputClearAssociationAction);
            behavior.visitClearAssociationAction(inputClearAssociationAction);
            this.doSwitch((EObject) inputClearAssociationAction.getObject());
        }
        return null;
    }

    @Override
    @objid ("142d3d04-4583-11e0-b54c-00137279a832")
    public Object caseClearStructuralFeatureAction(ClearStructuralFeatureAction inputClearStructuralFeatureAction) {
        Object theResult = visitorMap.get(inputClearStructuralFeatureAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClearStructuralFeatureActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputClearStructuralFeatureAction,
                    inputClearStructuralFeatureAction);
            behavior
            .visitClearStructuralFeatureAction(inputClearStructuralFeatureAction);
        }
        return null;
    }

    @Override
    @objid ("142f9f58-4583-11e0-b54c-00137279a832")
    public Object caseClearVariableAction(ClearVariableAction inputClearVariableAction) {
        Object theResult = visitorMap.get(inputClearVariableAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClearVariableActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputClearVariableAction, inputClearVariableAction);
            behavior.visitClearVariableAction(inputClearVariableAction);
        }
        return null;
    }

    @Override
    @objid ("1436c662-4583-11e0-b54c-00137279a832")
    public Object caseCollaboration(Collaboration inputCollaboration) {
        Object theResult = visitorMap.get(inputCollaboration);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CollaborationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCollaboration, inputCollaboration);
            behavior.visitCollaboration(inputCollaboration);
        }
        return null;
    }

    @Override
    @objid ("1436c668-4583-11e0-b54c-00137279a832")
    public Object caseCollaborationUse(CollaborationUse inputCollaborationUse) {
        Object theResult = visitorMap.get(inputCollaborationUse);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CollaborationUseImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCollaborationUse, inputCollaborationUse);
            behavior.visitCollaborationUse(inputCollaborationUse);
            for (Object roleBinding : inputCollaborationUse.getRoleBindings()) {
                this.doSwitch((EObject) roleBinding);
            }
        }
        return null;
    }

    @Override
    @objid ("143928bc-4583-11e0-b54c-00137279a832")
    public Object caseCombinedFragment(CombinedFragment inputCombinedFragment) {
        Object theResult = visitorMap.get(inputCombinedFragment);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CombinedFragmentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCombinedFragment, inputCombinedFragment);
            behavior.visitCombinedFragment(inputCombinedFragment);
            for (Object operand : inputCombinedFragment.getOperands()) {
                this.doSwitch((EObject) operand);
            }
            for (Object cfragmentGate : inputCombinedFragment
                    .getCfragmentGates()) {
                this.doSwitch((EObject) cfragmentGate);
            }
        }
        return null;
    }

    @Override
    @objid ("143928c2-4583-11e0-b54c-00137279a832")
    public Object caseComment(Comment inputComment) {
        Object theResult = visitorMap.get(inputComment);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CommentImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputComment, inputComment);
            behavior.visitComment(inputComment);
        }
        return null;
    }

    @Override
    @objid ("143928c8-4583-11e0-b54c-00137279a832")
    public Object caseCommunicationPath(CommunicationPath inputCommunicationPath) {
        Object theResult = visitorMap.get(inputCommunicationPath);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CommunicationPathImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCommunicationPath, inputCommunicationPath);
            behavior.visitCommunicationPath(inputCommunicationPath);
        }
        return null;
    }

    @Override
    @objid ("143b8b1a-4583-11e0-b54c-00137279a832")
    public Object caseComponent(Component inputComponent) {
        Object theResult = visitorMap.get(inputComponent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ComponentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputComponent, inputComponent);
            behavior.visitComponent(inputComponent);
            for (Object realization : inputComponent.getRealizations()) {
                this.doSwitch((EObject) realization);
            }
            for (Object packagedElement : inputComponent.getPackagedElements()) {
                this.doSwitch((EObject) packagedElement);
            }
        }
        return null;
    }

    @Override
    @objid ("143b8b20-4583-11e0-b54c-00137279a832")
    public Object caseComponentRealization(ComponentRealization inputComponentRealization) {
        Object theResult = visitorMap.get(inputComponentRealization);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ComponentRealizationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap
            .put(inputComponentRealization, inputComponentRealization);
            behavior.visitComponentRealization(inputComponentRealization);
        }
        return null;
    }

    @Override
    @objid ("143ded74-4583-11e0-b54c-00137279a832")
    public Object caseConditionalNode(ConditionalNode inputConditionalNode) {
        Object theResult = visitorMap.get(inputConditionalNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConditionalNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputConditionalNode, inputConditionalNode);
            behavior.visitConditionalNode(inputConditionalNode);
            for (Object clause : inputConditionalNode.getClauses()) {
                this.doSwitch((EObject) clause);
            }
            for (Object result : inputConditionalNode.getResults()) {
                this.doSwitch((EObject) result);
            }
        }
        return null;
    }

    @Override
    @objid ("143ded7a-4583-11e0-b54c-00137279a832")
    public Object caseConnectableElement(ConnectableElement inputConnectableElement) {
        return null;
    }

    @Override
    @objid ("1442b224-4583-11e0-b54c-00137279a832")
    public Object caseConnectableElementTemplateParameter(ConnectableElementTemplateParameter inputConnectableElementTemplateParameter) {
        Object theResult = visitorMap
        .get(inputConnectableElementTemplateParameter);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConnectableElementTemplateParameterImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputConnectableElementTemplateParameter,
                    inputConnectableElementTemplateParameter);
            behavior
            .visitConnectableElementTemplateParameter(inputConnectableElementTemplateParameter);
        }
        return null;
    }

    @Override
    @objid ("1442b22a-4583-11e0-b54c-00137279a832")
    public Object caseConnectionPointReference(ConnectionPointReference inputConnectionPointReference) {
        Object theResult = visitorMap.get(inputConnectionPointReference);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConnectionPointReferenceImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputConnectionPointReference,
                    inputConnectionPointReference);
            behavior
            .visitConnectionPointReference(inputConnectionPointReference);
        }
        return null;
    }

    @Override
    @objid ("1445147e-4583-11e0-b54c-00137279a832")
    public Object caseConnector(Connector inputConnector) {
        Object theResult = visitorMap.get(inputConnector);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConnectorImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputConnector, inputConnector);
            behavior.visitConnector(inputConnector);
            for (Object end : inputConnector.getEnds()) {
                this.doSwitch((EObject) end);
            }
        }
        return null;
    }

    @Override
    @objid ("14451484-4583-11e0-b54c-00137279a832")
    public Object caseConnectorEnd(ConnectorEnd inputConnectorEnd) {
        Object theResult = visitorMap.get(inputConnectorEnd);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConnectorEndImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputConnectorEnd, inputConnectorEnd);
            behavior.visitConnectorEnd(inputConnectorEnd);
        }
        return null;
    }

    @Override
    @objid ("144776d8-4583-11e0-b54c-00137279a832")
    public Object caseConsiderIgnoreFragment(ConsiderIgnoreFragment inputConsiderIgnoreFragment) {
        Object theResult = visitorMap.get(inputConsiderIgnoreFragment);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConsiderIgnoreFragmentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputConsiderIgnoreFragment,
                    inputConsiderIgnoreFragment);
            behavior.visitConsiderIgnoreFragment(inputConsiderIgnoreFragment);
        }
        return null;
    }

    @Override
    @objid ("144776de-4583-11e0-b54c-00137279a832")
    public Object caseConstraint(Constraint inputConstraint) {
        Object theResult = visitorMap.get(inputConstraint);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputConstraint, inputConstraint);
            behavior.visitConstraint(inputConstraint);
            this.doSwitch((EObject) inputConstraint.getSpecification());
        }
        return null;
    }

    @Override
    @objid ("144c3b8c-4583-11e0-b54c-00137279a832")
    public Object caseContinuation(Continuation inputContinuation) {
        Object theResult = visitorMap.get(inputContinuation);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ContinuationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputContinuation, inputContinuation);
            behavior.visitContinuation(inputContinuation);
        }
        return null;
    }

    @Override
    @objid ("144e9dea-4583-11e0-b54c-00137279a832")
    public Object caseControlFlow(ControlFlow inputControlFlow) {
        Object theResult = visitorMap.get(inputControlFlow);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ControlFlowImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputControlFlow, inputControlFlow);
            behavior.visitControlFlow(inputControlFlow);
        }
        return null;
    }

    @Override
    @objid ("144e9df0-4583-11e0-b54c-00137279a832")
    public Object caseControlNode(ControlNode inputControlNode) {
        return null;
    }

    @Override
    @objid ("14510044-4583-11e0-b54c-00137279a832")
    public Object caseCreateLinkAction(CreateLinkAction inputCreateLinkAction) {
        Object theResult = visitorMap.get(inputCreateLinkAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CreateLinkActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCreateLinkAction, inputCreateLinkAction);
            behavior.visitCreateLinkAction(inputCreateLinkAction);
            for (Object endData : inputCreateLinkAction.getEndData()) {
                this.doSwitch((EObject) endData);
            }
        }
        return null;
    }

    @Override
    @objid ("1451004a-4583-11e0-b54c-00137279a832")
    public Object caseCreateLinkObjectAction(CreateLinkObjectAction inputCreateLinkObjectAction) {
        Object theResult = visitorMap.get(inputCreateLinkObjectAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CreateLinkObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCreateLinkObjectAction,
                    inputCreateLinkObjectAction);
            behavior.visitCreateLinkObjectAction(inputCreateLinkObjectAction);
            this.doSwitch((EObject) inputCreateLinkObjectAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("1453629e-4583-11e0-b54c-00137279a832")
    public Object caseCreateObjectAction(CreateObjectAction inputCreateObjectAction) {
        Object theResult = visitorMap.get(inputCreateObjectAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CreateObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCreateObjectAction, inputCreateObjectAction);
            behavior.visitCreateObjectAction(inputCreateObjectAction);
            this.doSwitch((EObject) inputCreateObjectAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("145362a4-4583-11e0-b54c-00137279a832")
    public Object caseCreationEvent(CreationEvent inputCreationEvent) {
        Object theResult = visitorMap.get(inputCreationEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CreationEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputCreationEvent, inputCreationEvent);
            behavior.visitCreationEvent(inputCreationEvent);
        }
        return null;
    }

    @Override
    @objid ("1455c4f8-4583-11e0-b54c-00137279a832")
    public Object caseDataStoreNode(DataStoreNode inputDataStoreNode) {
        Object theResult = visitorMap.get(inputDataStoreNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DataStoreNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDataStoreNode, inputDataStoreNode);
            behavior.visitDataStoreNode(inputDataStoreNode);
        }
        return null;
    }

    @Override
    @objid ("1458274e-4583-11e0-b54c-00137279a832")
    public Object caseDataType(DataType inputDataType) {
        Object theResult = visitorMap.get(inputDataType);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DataTypeImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputDataType, inputDataType);
            behavior.visitDataType(inputDataType);
            for (Object ownedAttribute : inputDataType.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
            for (Object ownedOperation : inputDataType.getOwnedOperations()) {
                this.doSwitch((EObject) ownedOperation);
            }
        }
        return null;
    }

    @Override
    @objid ("14582754-4583-11e0-b54c-00137279a832")
    public Object caseDecisionNode(DecisionNode inputDecisionNode) {
        Object theResult = visitorMap.get(inputDecisionNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DecisionNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDecisionNode, inputDecisionNode);
            behavior.visitDecisionNode(inputDecisionNode);
        }
        return null;
    }

    @Override
    @objid ("145a89a8-4583-11e0-b54c-00137279a832")
    public Object caseDependency(Dependency inputDependency) {
        Object theResult = visitorMap.get(inputDependency);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DependencyImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDependency, inputDependency);
            behavior.visitDependency(inputDependency);
        }
        return null;
    }

    @Override
    @objid ("145a89ae-4583-11e0-b54c-00137279a832")
    public Object caseDeployedArtifact(DeployedArtifact inputDeployedArtifact) {
        return null;
    }

    @Override
    @objid ("145cec02-4583-11e0-b54c-00137279a832")
    public Object caseDeployment(Deployment inputDeployment) {
        Object theResult = visitorMap.get(inputDeployment);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DeploymentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDeployment, inputDeployment);
            behavior.visitDeployment(inputDeployment);
            for (Object configuration : inputDeployment.getConfigurations()) {
                this.doSwitch((EObject) configuration);
            }
        }
        return null;
    }

    @Override
    @objid ("145cec08-4583-11e0-b54c-00137279a832")
    public Object caseDeploymentSpecification(DeploymentSpecification inputDeploymentSpecification) {
        Object theResult = visitorMap.get(inputDeploymentSpecification);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DeploymentSpecificationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDeploymentSpecification,
                    inputDeploymentSpecification);
            behavior.visitDeploymentSpecification(inputDeploymentSpecification);
        }
        return null;
    }

    @Override
    @objid ("145f4e5c-4583-11e0-b54c-00137279a832")
    public Object caseDeploymentTarget(DeploymentTarget inputDeploymentTarget) {
        for (Object deployment : inputDeploymentTarget.getDeployments()) {
            this.doSwitch((EObject) deployment);
        }
        return null;
    }

    @Override
    @objid ("145f4e62-4583-11e0-b54c-00137279a832")
    public Object caseDestroyLinkAction(DestroyLinkAction inputDestroyLinkAction) {
        Object theResult = visitorMap.get(inputDestroyLinkAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DestroyLinkActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDestroyLinkAction, inputDestroyLinkAction);
            behavior.visitDestroyLinkAction(inputDestroyLinkAction);
            for (Object endData : inputDestroyLinkAction.getEndData()) {
                this.doSwitch((EObject) endData);
            }
        }
        return null;
    }

    @Override
    @objid ("1461b0b6-4583-11e0-b54c-00137279a832")
    public Object caseDestroyObjectAction(DestroyObjectAction inputDestroyObjectAction) {
        Object theResult = visitorMap.get(inputDestroyObjectAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DestroyObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDestroyObjectAction, inputDestroyObjectAction);
            behavior.visitDestroyObjectAction(inputDestroyObjectAction);
            this.doSwitch((EObject) inputDestroyObjectAction.getTarget());
        }
        return null;
    }

    @Override
    @objid ("1461b0bc-4583-11e0-b54c-00137279a832")
    public Object caseDestructionEvent(DestructionEvent inputDestructionEvent) {
        Object theResult = visitorMap.get(inputDestructionEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DestructionEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDestructionEvent, inputDestructionEvent);
            behavior.visitDestructionEvent(inputDestructionEvent);
        }
        return null;
    }

    @Override
    @objid ("14641311-4583-11e0-b54c-00137279a832")
    public Object caseDevice(Device inputDevice) {
        Object theResult = visitorMap.get(inputDevice);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DeviceImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputDevice, inputDevice);
            behavior.visitDevice(inputDevice);
        }
        return null;
    }

    @Override
    @objid ("14641317-4583-11e0-b54c-00137279a832")
    public Object caseDirectedRelationship(DirectedRelationship inputDirectedRelationship) {
        return null;
    }

    @Override
    @objid ("1466756b-4583-11e0-b54c-00137279a832")
    public Object caseDuration(Duration inputDuration) {
        Object theResult = visitorMap.get(inputDuration);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DurationImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputDuration, inputDuration);
            behavior.visitDuration(inputDuration);
        }
        return null;
    }

    @Override
    @objid ("14667571-4583-11e0-b54c-00137279a832")
    public Object caseDurationConstraint(DurationConstraint inputDurationConstraint) {
        Object theResult = visitorMap.get(inputDurationConstraint);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DurationConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDurationConstraint, inputDurationConstraint);
            behavior.visitDurationConstraint(inputDurationConstraint);
            this.doSwitch((EObject) inputDurationConstraint.getSpecification());
        }
        return null;
    }

    @Override
    @objid ("1468d7c8-4583-11e0-b54c-00137279a832")
    public Object caseDurationInterval(DurationInterval inputDurationInterval) {
        Object theResult = visitorMap.get(inputDurationInterval);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DurationIntervalImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDurationInterval, inputDurationInterval);
            behavior.visitDurationInterval(inputDurationInterval);
        }
        return null;
    }

    @Override
    @objid ("1468d7ce-4583-11e0-b54c-00137279a832")
    public Object caseDurationObservation(final DurationObservation inputDurationIservation) {
        Object theResult = visitorMap.get(inputDurationIservation);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DurationIservationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputDurationIservation, inputDurationIservation);
            behavior.visitDurationObservation(inputDurationIservation);
        }
        return null;
    }

    @Override
    @objid ("146b3a22-4583-11e0-b54c-00137279a832")
    public Object caseElement(Element inputElement) {
        for (Object ownedElement : inputElement.getOwnedElements()) {
            this.doSwitch((EObject) ownedElement);
        }
        for (Object ownedComment : inputElement.getOwnedComments()) {
            this.doSwitch((EObject) ownedComment);
        }
        return null;
    }

    @Override
    @objid ("146d9c78-4583-11e0-b54c-00137279a832")
    public Object caseElementImport(ElementImport inputElementImport) {
        Object theResult = visitorMap.get(inputElementImport);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ElementImportImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputElementImport, inputElementImport);
            behavior.visitElementImport(inputElementImport);
        }
        return null;
    }

    @Override
    @objid ("146d9c7e-4583-11e0-b54c-00137279a832")
    public Object caseEncapsulatedClassifier(EncapsulatedClassifier inputEncapsulatedClassifier) {
        for (Object ownedPort : inputEncapsulatedClassifier.getOwnedPorts()) {
            this.doSwitch((EObject) ownedPort);
        }
        return null;
    }

    @Override
    @objid ("146ffed2-4583-11e0-b54c-00137279a832")
    public Object caseEnumeration(Enumeration inputEnumeration) {
        Object theResult = visitorMap.get(inputEnumeration);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("EnumerationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputEnumeration, inputEnumeration);
            behavior.visitEnumeration(inputEnumeration);
            for (Object ownedLiteral : inputEnumeration.getOwnedLiterals()) {
                this.doSwitch((EObject) ownedLiteral);
            }
        }
        return null;
    }

    @Override
    @objid ("146ffed8-4583-11e0-b54c-00137279a832")
    public Object caseEnumerationLiteral(EnumerationLiteral inputEnumerationLiteral) {
        Object theResult = visitorMap.get(inputEnumerationLiteral);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("EnumerationLiteralImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputEnumerationLiteral, inputEnumerationLiteral);
            behavior.visitEnumerationLiteral(inputEnumerationLiteral);
        }
        return null;
    }

    @Override
    @objid ("1472612c-4583-11e0-b54c-00137279a832")
    public Object caseEvent(Event inputEvent) {
        return null;
    }

    @Override
    @objid ("14726132-4583-11e0-b54c-00137279a832")
    public Object caseExceptionHandler(ExceptionHandler inputExceptionHandler) {
        Object theResult = visitorMap.get(inputExceptionHandler);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExceptionHandlerImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputExceptionHandler, inputExceptionHandler);
            behavior.visitExceptionHandler(inputExceptionHandler);
        }
        return null;
    }

    @Override
    @objid ("1474c387-4583-11e0-b54c-00137279a832")
    public Object caseExecutableNode(ExecutableNode inputExecutableNode) {
        for (Object handler : inputExecutableNode.getHandlers()) {
            this.doSwitch((EObject) handler);
        }
        return null;
    }

    @Override
    @objid ("1474c38d-4583-11e0-b54c-00137279a832")
    public Object caseExecutionEnvironment(ExecutionEnvironment inputExecutionEnvironment) {
        Object theResult = visitorMap.get(inputExecutionEnvironment);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExecutionEnvironmentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap
            .put(inputExecutionEnvironment, inputExecutionEnvironment);
            behavior.visitExecutionEnvironment(inputExecutionEnvironment);
        }
        return null;
    }

    @Override
    @objid ("147725e4-4583-11e0-b54c-00137279a832")
    public Object caseExecutionEvent(ExecutionEvent inputExecutionEvent) {
        Object theResult = visitorMap.get(inputExecutionEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExecutionEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputExecutionEvent, inputExecutionEvent);
            behavior.visitExecutionEvent(inputExecutionEvent);
        }
        return null;
    }

    @Override
    @objid ("1479883a-4583-11e0-b54c-00137279a832")
    public Object caseExecutionOccurrenceSpecification(ExecutionOccurrenceSpecification inputExecutionOccurrenceSpecification) {
        Object theResult = visitorMap
        .get(inputExecutionOccurrenceSpecification);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExecutionOccurrenceSpecificationImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputExecutionOccurrenceSpecification,
                    inputExecutionOccurrenceSpecification);
            behavior
            .visitExecutionOccurrenceSpecification(inputExecutionOccurrenceSpecification);
        }
        return null;
    }

    @Override
    @objid ("14798840-4583-11e0-b54c-00137279a832")
    public Object caseExecutionSpecification(ExecutionSpecification inputExecutionSpecification) {
        return null;
    }

    @Override
    @objid ("147bea94-4583-11e0-b54c-00137279a832")
    public Object caseExpansionNode(ExpansionNode inputExpansionNode) {
        Object theResult = visitorMap.get(inputExpansionNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExpansionNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputExpansionNode, inputExpansionNode);
            behavior.visitExpansionNode(inputExpansionNode);
        }
        return null;
    }

    @Override
    @objid ("147bea9a-4583-11e0-b54c-00137279a832")
    public Object caseExpansionRegion(ExpansionRegion inputExpansionRegion) {
        Object theResult = visitorMap.get(inputExpansionRegion);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExpansionRegionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputExpansionRegion, inputExpansionRegion);
            behavior.visitExpansionRegion(inputExpansionRegion);
        }
        return null;
    }

    @Override
    @objid ("147e4cef-4583-11e0-b54c-00137279a832")
    public Object caseExpression(Expression inputExpression) {
        Object theResult = visitorMap.get(inputExpression);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExpressionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputExpression, inputExpression);
            behavior.visitExpression(inputExpression);
            for (Object operand : inputExpression.getOperands()) {
                this.doSwitch((EObject) operand);
            }
        }
        return null;
    }

    @Override
    @objid ("147e4cf5-4583-11e0-b54c-00137279a832")
    public Object caseExtend(Extend inputExtend) {
        Object theResult = visitorMap.get(inputExtend);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExtendImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputExtend, inputExtend);
            behavior.visitExtend(inputExtend);
            this.doSwitch((EObject) inputExtend.getCondition());
        }
        return null;
    }

    @Override
    @objid ("1480af4c-4583-11e0-b54c-00137279a832")
    public Object caseExtension(Extension inputExtension) {
        Object theResult = visitorMap.get(inputExtension);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExtensionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputExtension, inputExtension);
            behavior.visitExtension(inputExtension);
            for (Object ownedEnd : inputExtension.getOwnedEnds()) {
                this.doSwitch((EObject) ownedEnd);
            }
        }
        return null;
    }

    @Override
    @objid ("148311a2-4583-11e0-b54c-00137279a832")
    public Object caseExtensionEnd(ExtensionEnd inputExtensionEnd) {
        Object theResult = visitorMap.get(inputExtensionEnd);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExtensionEndImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputExtensionEnd, inputExtensionEnd);
            behavior.visitExtensionEnd(inputExtensionEnd);
        }
        return null;
    }

    @Override
    @objid ("148311a8-4583-11e0-b54c-00137279a832")
    public Object caseExtensionPoint(ExtensionPoint inputExtensionPoint) {
        Object theResult = visitorMap.get(inputExtensionPoint);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExtensionPointImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputExtensionPoint, inputExtensionPoint);
            behavior.visitExtensionPoint(inputExtensionPoint);
        }
        return null;
    }

    @Override
    @objid ("148573fc-4583-11e0-b54c-00137279a832")
    public Object caseFeature(Feature inputFeature) {
        return null;
    }

    @Override
    @objid ("14857402-4583-11e0-b54c-00137279a832")
    public Object caseFinalNode(FinalNode inputFinalNode) {
        return null;
    }

    @Override
    @objid ("1487d657-4583-11e0-b54c-00137279a832")
    public Object caseFinalState(FinalState inputFinalState) {
        Object theResult = visitorMap.get(inputFinalState);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("FinalStateImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputFinalState, inputFinalState);
            behavior.visitFinalState(inputFinalState);
        }
        return null;
    }

    @Override
    @objid ("148a38b0-4583-11e0-b54c-00137279a832")
    public Object caseFlowFinalNode(FlowFinalNode inputFlowFinalNode) {
        Object theResult = visitorMap.get(inputFlowFinalNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("FlowFinalNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputFlowFinalNode, inputFlowFinalNode);
            behavior.visitFlowFinalNode(inputFlowFinalNode);
        }
        return null;
    }

    @Override
    @objid ("148a38b6-4583-11e0-b54c-00137279a832")
    public Object caseForkNode(ForkNode inputForkNode) {
        Object theResult = visitorMap.get(inputForkNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ForkNodeImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputForkNode, inputForkNode);
            behavior.visitForkNode(inputForkNode);
        }
        return null;
    }

    @Override
    @objid ("148c9b0a-4583-11e0-b54c-00137279a832")
    public Object caseFunctionBehavior(FunctionBehavior inputFunctionBehavior) {
        Object theResult = visitorMap.get(inputFunctionBehavior);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("FunctionBehaviorImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputFunctionBehavior, inputFunctionBehavior);
            behavior.visitFunctionBehavior(inputFunctionBehavior);
        }
        return null;
    }

    @Override
    @objid ("148c9b10-4583-11e0-b54c-00137279a832")
    public Object caseGate(Gate inputGate) {
        Object theResult = visitorMap.get(inputGate);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("GateImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputGate, inputGate);
            behavior.visitGate(inputGate);
        }
        return null;
    }

    @Override
    @objid ("148efd66-4583-11e0-b54c-00137279a832")
    public Object caseGeneralization(Generalization inputGeneralization) {
        Object theResult = visitorMap.get(inputGeneralization);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("GeneralizationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputGeneralization, inputGeneralization);
            behavior.visitGeneralization(inputGeneralization);
        }
        return null;
    }

    @Override
    @objid ("14915fbe-4583-11e0-b54c-00137279a832")
    public Object caseGeneralizationSet(GeneralizationSet inputGeneralizationSet) {
        Object theResult = visitorMap.get(inputGeneralizationSet);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("GeneralizationSetImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputGeneralizationSet, inputGeneralizationSet);
            behavior.visitGeneralizationSet(inputGeneralizationSet);
        }
        return null;
    }

    @Override
    @objid ("14915fc4-4583-11e0-b54c-00137279a832")
    public Object caseGeneralOrdering(GeneralOrdering inputGeneralOrdering) {
        Object theResult = visitorMap.get(inputGeneralOrdering);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("GeneralOrderingImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputGeneralOrdering, inputGeneralOrdering);
            behavior.visitGeneralOrdering(inputGeneralOrdering);
        }
        return null;
    }

    @Override
    @objid ("1493c218-4583-11e0-b54c-00137279a832")
    public Object caseImage(Image inputImage) {
        Object theResult = visitorMap.get(inputImage);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ImageImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputImage, inputImage);
            behavior.visitImage(inputImage);
        }
        return null;
    }

    @Override
    @objid ("1493c21e-4583-11e0-b54c-00137279a832")
    public Object caseInclude(Include inputInclude) {
        Object theResult = visitorMap.get(inputInclude);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("IncludeImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputInclude, inputInclude);
            behavior.visitInclude(inputInclude);
        }
        return null;
    }

    @Override
    @objid ("14962473-4583-11e0-b54c-00137279a832")
    public Object caseInformationFlow(InformationFlow inputInformationFlow) {
        Object theResult = visitorMap.get(inputInformationFlow);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InformationFlowImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInformationFlow, inputInformationFlow);
            behavior.visitInformationFlow(inputInformationFlow);
        }
        return null;
    }

    @Override
    @objid ("149886cc-4583-11e0-b54c-00137279a832")
    public Object caseInformationItem(InformationItem inputInformationItem) {
        Object theResult = visitorMap.get(inputInformationItem);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InformationItemImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInformationItem, inputInformationItem);
            behavior.visitInformationItem(inputInformationItem);
        }
        return null;
    }

    @Override
    @objid ("149886d2-4583-11e0-b54c-00137279a832")
    public Object caseInitialNode(InitialNode inputInitialNode) {
        Object theResult = visitorMap.get(inputInitialNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InitialNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInitialNode, inputInitialNode);
            behavior.visitInitialNode(inputInitialNode);
        }
        return null;
    }

    @Override
    @objid ("149ae926-4583-11e0-b54c-00137279a832")
    public Object caseInputPin(InputPin inputInputPin) {
        Object theResult = visitorMap.get(inputInputPin);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InputPinImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputInputPin, inputInputPin);
            behavior.visitInputPin(inputInputPin);
        }
        return null;
    }

    @Override
    @objid ("149ae92c-4583-11e0-b54c-00137279a832")
    public Object caseInstanceSpecification(InstanceSpecification inputInstanceSpecification) {
        Object theResult = visitorMap.get(inputInstanceSpecification);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InstanceSpecificationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInstanceSpecification,
                    inputInstanceSpecification);
            behavior.visitInstanceSpecification(inputInstanceSpecification);
            for (Object slot : inputInstanceSpecification.getSlots()) {
                this.doSwitch((EObject) slot);
            }
            this.doSwitch((EObject) inputInstanceSpecification
                    .getSpecification());
        }
        return null;
    }

    @Override
    @objid ("149d4b84-4583-11e0-b54c-00137279a832")
    public Object caseInstanceValue(InstanceValue inputInstanceValue) {
        Object theResult = visitorMap.get(inputInstanceValue);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InstanceValueImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInstanceValue, inputInstanceValue);
            behavior.visitInstanceValue(inputInstanceValue);
        }
        return null;
    }

    @Override
    @objid ("149faddb-4583-11e0-b54c-00137279a832")
    public Object caseInteraction(Interaction inputInteraction) {
        Object theResult = visitorMap.get(inputInteraction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InteractionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInteraction, inputInteraction);
            behavior.visitInteraction(inputInteraction);
            for (Object lifeline : inputInteraction.getLifelines()) {
                this.doSwitch((EObject) lifeline);
            }
            for (Object message : inputInteraction.getMessages()) {
                this.doSwitch((EObject) message);
            }
            for (Object fragment : inputInteraction.getFragments()) {
                this.doSwitch((EObject) fragment);
            }
            for (Object action : inputInteraction.getActions()) {
                this.doSwitch((EObject) action);
            }
            for (Object formalGate : inputInteraction.getFormalGates()) {
                this.doSwitch((EObject) formalGate);
            }
        }
        return null;
    }

    @Override
    @objid ("14a21034-4583-11e0-b54c-00137279a832")
    public Object caseInteractionConstraint(InteractionConstraint inputInteractionConstraint) {
        Object theResult = visitorMap.get(inputInteractionConstraint);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InteractionConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInteractionConstraint,
                    inputInteractionConstraint);
            behavior.visitInteractionConstraint(inputInteractionConstraint);
            this.doSwitch((EObject) inputInteractionConstraint.getMinint());
            this.doSwitch((EObject) inputInteractionConstraint.getMaxint());
        }
        return null;
    }

    @Override
    @objid ("14a2103a-4583-11e0-b54c-00137279a832")
    public Object caseInteractionFragment(InteractionFragment inputInteractionFragment) {
        for (Object generalOrdering : inputInteractionFragment
                .getGeneralOrderings()) {
            this.doSwitch((EObject) generalOrdering);
        }
        return null;
    }

    @Override
    @objid ("14a4728f-4583-11e0-b54c-00137279a832")
    public Object caseInteractionOperand(InteractionOperand inputInteractionOperand) {
        Object theResult = visitorMap.get(inputInteractionOperand);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InteractionOperandImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInteractionOperand, inputInteractionOperand);
            behavior.visitInteractionOperand(inputInteractionOperand);
            this.doSwitch((EObject) inputInteractionOperand.getGuard());
            for (Object fragment : inputInteractionOperand.getFragments()) {
                this.doSwitch((EObject) fragment);
            }
        }
        return null;
    }

    @Override
    @objid ("14a47295-4583-11e0-b54c-00137279a832")
    public Object caseInteractionUse(InteractionUse inputInteractionUse) {
        Object theResult = visitorMap.get(inputInteractionUse);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InteractionUseImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInteractionUse, inputInteractionUse);
            behavior.visitInteractionUse(inputInteractionUse);
            for (Object actualGate : inputInteractionUse.getActualGates()) {
                this.doSwitch((EObject) actualGate);
            }
            for (Object argument : inputInteractionUse.getArguments()) {
                this.doSwitch((EObject) argument);
            }
        }
        return null;
    }

    @Override
    @objid ("14a6d4ed-4583-11e0-b54c-00137279a832")
    public Object caseInterface(Interface inputInterface) {
        Object theResult = visitorMap.get(inputInterface);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InterfaceImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputInterface, inputInterface);
            behavior.visitInterface(inputInterface);
            for (Object ownedAttribute : inputInterface.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
            for (Object ownedOperation : inputInterface.getOwnedOperations()) {
                this.doSwitch((EObject) ownedOperation);
            }
            for (Object nestedClassifier : inputInterface
                    .getNestedClassifiers()) {
                this.doSwitch((EObject) nestedClassifier);
            }
            for (Object ownedReception : inputInterface.getOwnedReceptions()) {
                this.doSwitch((EObject) ownedReception);
            }
            this.doSwitch((EObject) inputInterface.getProtocol());
        }
        return null;
    }

    @Override
    @objid ("14a93742-4583-11e0-b54c-00137279a832")
    public Object caseInterfaceRealization(InterfaceRealization inputInterfaceRealization) {
        Object theResult = visitorMap.get(inputInterfaceRealization);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InterfaceRealizationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap
            .put(inputInterfaceRealization, inputInterfaceRealization);
            behavior.visitInterfaceRealization(inputInterfaceRealization);
        }
        return null;
    }

    @Override
    @objid ("14a93748-4583-11e0-b54c-00137279a832")
    public Object caseInterruptibleActivityRegion(InterruptibleActivityRegion inputInterruptibleActivityRegion) {
        Object theResult = visitorMap.get(inputInterruptibleActivityRegion);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InterruptibleActivityRegionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputInterruptibleActivityRegion,
                    inputInterruptibleActivityRegion);
            behavior
            .visitInterruptibleActivityRegion(inputInterruptibleActivityRegion);
        }
        return null;
    }

    @Override
    @objid ("14ab999e-4583-11e0-b54c-00137279a832")
    public Object caseInterval(Interval inputInterval) {
        Object theResult = visitorMap.get(inputInterval);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("IntervalImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputInterval, inputInterval);
            behavior.visitInterval(inputInterval);
        }
        return null;
    }

    @Override
    @objid ("14adfbf6-4583-11e0-b54c-00137279a832")
    public Object caseIntervalConstraint(IntervalConstraint inputIntervalConstraint) {
        Object theResult = visitorMap.get(inputIntervalConstraint);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("IntervalConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputIntervalConstraint, inputIntervalConstraint);
            behavior.visitIntervalConstraint(inputIntervalConstraint);
            this.doSwitch((EObject) inputIntervalConstraint.getSpecification());
        }
        return null;
    }

    @Override
    @objid ("14adfbfc-4583-11e0-b54c-00137279a832")
    public Object caseInvocationAction(InvocationAction inputInvocationAction) {
        for (Object argument : inputInvocationAction.getArguments()) {
            this.doSwitch((EObject) argument);
        }
        return null;
    }

    @Override
    @objid ("14b05e51-4583-11e0-b54c-00137279a832")
    public Object caseJoinNode(JoinNode inputJoinNode) {
        Object theResult = visitorMap.get(inputJoinNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("JoinNodeImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputJoinNode, inputJoinNode);
            behavior.visitJoinNode(inputJoinNode);
            this.doSwitch((EObject) inputJoinNode.getJoinSpec());
        }
        return null;
    }

    @Override
    @objid ("14b05e57-4583-11e0-b54c-00137279a832")
    public Object caseLifeline(Lifeline inputLifeline) {
        Object theResult = visitorMap.get(inputLifeline);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LifelineImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputLifeline, inputLifeline);
            behavior.visitLifeline(inputLifeline);
            this.doSwitch((EObject) inputLifeline.getSelector());
        }
        return null;
    }

    @Override
    @objid ("14b2c0af-4583-11e0-b54c-00137279a832")
    public Object caseLinkAction(LinkAction inputLinkAction) {
        for (Object endData : inputLinkAction.getEndData()) {
            this.doSwitch((EObject) endData);
        }
        for (Object inputValue : inputLinkAction.getInputValues()) {
            this.doSwitch((EObject) inputValue);
        }
        return null;
    }

    @Override
    @objid ("14b52304-4583-11e0-b54c-00137279a832")
    public Object caseLinkEndCreationData(LinkEndCreationData inputLinkEndCreationData) {
        Object theResult = visitorMap.get(inputLinkEndCreationData);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LinkEndCreationDataImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputLinkEndCreationData, inputLinkEndCreationData);
            behavior.visitLinkEndCreationData(inputLinkEndCreationData);
        }
        return null;
    }

    @Override
    @objid ("14b5230a-4583-11e0-b54c-00137279a832")
    public Object caseLinkEndData(LinkEndData inputLinkEndData) {
        Object theResult = visitorMap.get(inputLinkEndData);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LinkEndDataImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputLinkEndData, inputLinkEndData);
            behavior.visitLinkEndData(inputLinkEndData);
            for (Object qualifier : inputLinkEndData.getQualifiers()) {
                this.doSwitch((EObject) qualifier);
            }
        }
        return null;
    }

    @Override
    @objid ("14b78562-4583-11e0-b54c-00137279a832")
    public Object caseLinkEndDestructionData(LinkEndDestructionData inputLinkEndDestructionData) {
        Object theResult = visitorMap.get(inputLinkEndDestructionData);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LinkEndDestructionDataImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputLinkEndDestructionData,
                    inputLinkEndDestructionData);
            behavior.visitLinkEndDestructionData(inputLinkEndDestructionData);
        }
        return null;
    }

    @Override
    @objid ("14b9e7b8-4583-11e0-b54c-00137279a832")
    public Object caseLiteralBoolean(LiteralBoolean inputLiteralBoolean) {
        Object theResult = visitorMap.get(inputLiteralBoolean);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralBooleanImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputLiteralBoolean, inputLiteralBoolean);
            behavior.visitLiteralBoolean(inputLiteralBoolean);
        }
        return null;
    }

    @Override
    @objid ("14b9e7be-4583-11e0-b54c-00137279a832")
    public Object caseLiteralInteger(LiteralInteger inputLiteralInteger) {
        Object theResult = visitorMap.get(inputLiteralInteger);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralIntegerImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputLiteralInteger, inputLiteralInteger);
            behavior.visitLiteralInteger(inputLiteralInteger);
        }
        return null;
    }

    @Override
    @objid ("14bc4a15-4583-11e0-b54c-00137279a832")
    public Object caseLiteralNull(LiteralNull inputLiteralNull) {
        Object theResult = visitorMap.get(inputLiteralNull);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralNullImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputLiteralNull, inputLiteralNull);
            behavior.visitLiteralNull(inputLiteralNull);
        }
        return null;
    }

    @Override
    @objid ("14beac6c-4583-11e0-b54c-00137279a832")
    public Object caseLiteralSpecification(LiteralSpecification inputLiteralSpecification) {
        return null;
    }

    @Override
    @objid ("14beac72-4583-11e0-b54c-00137279a832")
    public Object caseLiteralString(LiteralString inputLiteralString) {
        Object theResult = visitorMap.get(inputLiteralString);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralStringImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputLiteralString, inputLiteralString);
            behavior.visitLiteralString(inputLiteralString);
        }
        return null;
    }

    @Override
    @objid ("14c10ec7-4583-11e0-b54c-00137279a832")
    public Object caseLiteralUnlimitedNatural(LiteralUnlimitedNatural inputLiteralUnlimitedNatural) {
        Object theResult = visitorMap.get(inputLiteralUnlimitedNatural);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralUnlimitedNaturalImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputLiteralUnlimitedNatural,
                    inputLiteralUnlimitedNatural);
            behavior.visitLiteralUnlimitedNatural(inputLiteralUnlimitedNatural);
        }
        return null;
    }

    @Override
    @objid ("14c37120-4583-11e0-b54c-00137279a832")
    public Object caseLoopNode(LoopNode inputLoopNode) {
        Object theResult = visitorMap.get(inputLoopNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LoopNodeImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputLoopNode, inputLoopNode);
            behavior.visitLoopNode(inputLoopNode);
            for (Object result : inputLoopNode.getResults()) {
                this.doSwitch((EObject) result);
            }
            for (Object loopVariableInput : inputLoopNode
                    .getLoopVariableInputs()) {
                this.doSwitch((EObject) loopVariableInput);
            }
        }
        return null;
    }

    @Override
    @objid ("14c37126-4583-11e0-b54c-00137279a832")
    public Object caseManifestation(Manifestation inputManifestation) {
        Object theResult = visitorMap.get(inputManifestation);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ManifestationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputManifestation, inputManifestation);
            behavior.visitManifestation(inputManifestation);
        }
        return null;
    }

    @Override
    @objid ("14c5d37b-4583-11e0-b54c-00137279a832")
    public Object caseMergeNode(MergeNode inputMergeNode) {
        Object theResult = visitorMap.get(inputMergeNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("MergeNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputMergeNode, inputMergeNode);
            behavior.visitMergeNode(inputMergeNode);
        }
        return null;
    }

    @Override
    @objid ("14c835d4-4583-11e0-b54c-00137279a832")
    public Object caseMessage(Message inputMessage) {
        Object theResult = visitorMap.get(inputMessage);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("MessageImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputMessage, inputMessage);
            behavior.visitMessage(inputMessage);
            for (Object argument : inputMessage.getArguments()) {
                this.doSwitch((EObject) argument);
            }
        }
        return null;
    }

    @Override
    @objid ("14c835da-4583-11e0-b54c-00137279a832")
    public Object caseMessageEnd(MessageEnd inputMessageEnd) {
        return null;
    }

    @Override
    @objid ("14ca982e-4583-11e0-b54c-00137279a832")
    public Object caseMessageEvent(MessageEvent inputMessageEvent) {
        return null;
    }

    @Override
    @objid ("14ccfa88-4583-11e0-b54c-00137279a832")
    public Object caseMessageOccurrenceSpecification(MessageOccurrenceSpecification inputMessageOccurrenceSpecification) {
        Object theResult = visitorMap.get(inputMessageOccurrenceSpecification);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("MessageOccurrenceSpecificationImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputMessageOccurrenceSpecification,
                    inputMessageOccurrenceSpecification);
            behavior
            .visitMessageOccurrenceSpecification(inputMessageOccurrenceSpecification);
        }
        return null;
    }

    @Override
    @objid ("14ccfa8e-4583-11e0-b54c-00137279a832")
    public Object caseModel(Model inputModel) {
        Object theResult = visitorMap.get(inputModel);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ModelImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputModel, inputModel);
            behavior.visitModel(inputModel);
        }
        return null;
    }

    @Override
    @objid ("14cf5ce2-4583-11e0-b54c-00137279a832")
    public Object caseMultiplicityElement(MultiplicityElement inputMultiplicityElement) {
        this.doSwitch((EObject) inputMultiplicityElement.getUpperValue());
        this.doSwitch((EObject) inputMultiplicityElement.getLowerValue());
        return null;
    }

    @Override
    @objid ("14d1bf3c-4583-11e0-b54c-00137279a832")
    public Object caseNamedElement(NamedElement inputNamedElement) {
        this.doSwitch((EObject) inputNamedElement.getNameExpression());
        return null;
    }

    @Override
    @objid ("14d1bf42-4583-11e0-b54c-00137279a832")
    public Object caseNamespace(Namespace inputNamespace) {
        for (Object elementImport : inputNamespace.getElementImports()) {
            this.doSwitch((EObject) elementImport);
        }
        for (Object packageImport : inputNamespace.getPackageImports()) {
            this.doSwitch((EObject) packageImport);
        }
        for (Object ownedRule : inputNamespace.getOwnedRules()) {
            this.doSwitch((EObject) ownedRule);
        }
        for (Object ownedMember : inputNamespace.getOwnedMembers()) {
            this.doSwitch((EObject) ownedMember);
        }
        return null;
    }

    @Override
    @objid ("14d42196-4583-11e0-b54c-00137279a832")
    public Object caseNode(Node inputNode) {
        Object theResult = visitorMap.get(inputNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("NodeImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputNode, inputNode);
            behavior.visitNode(inputNode);
            for (Object nestedNode : inputNode.getNestedNodes()) {
                this.doSwitch((EObject) nestedNode);
            }
        }
        return null;
    }

    @Override
    @objid ("14d683f0-4583-11e0-b54c-00137279a832")
    public Object caseObjectFlow(ObjectFlow inputObjectFlow) {
        Object theResult = visitorMap.get(inputObjectFlow);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ObjectFlowImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputObjectFlow, inputObjectFlow);
            behavior.visitObjectFlow(inputObjectFlow);
        }
        return null;
    }

    @Override
    @objid ("14d683f6-4583-11e0-b54c-00137279a832")
    public Object caseObjectNode(ObjectNode inputObjectNode) {
        this.doSwitch((EObject) inputObjectNode.getUpperBound());
        return null;
    }

    @Override
    @objid ("14d8e64a-4583-11e0-b54c-00137279a832")
    public Object caseObservation(final Observation inputIservation) {
        return null;
    }

    @Override
    @objid ("14db48a4-4583-11e0-b54c-00137279a832")
    public Object caseOccurrenceSpecification(OccurrenceSpecification inputOccurrenceSpecification) {
        Object theResult = visitorMap.get(inputOccurrenceSpecification);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OccurrenceSpecificationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputOccurrenceSpecification,
                    inputOccurrenceSpecification);
            behavior.visitOccurrenceSpecification(inputOccurrenceSpecification);
        }
        return null;
    }

    @Override
    @objid ("14db48aa-4583-11e0-b54c-00137279a832")
    public Object caseOpaqueAction(OpaqueAction inputOpaqueAction) {
        Object theResult = visitorMap.get(inputOpaqueAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OpaqueActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputOpaqueAction, inputOpaqueAction);
            behavior.visitOpaqueAction(inputOpaqueAction);
            for (Object inputValue : inputOpaqueAction.getInputValues()) {
                this.doSwitch((EObject) inputValue);
            }
            for (Object outputValue : inputOpaqueAction.getOutputValues()) {
                this.doSwitch((EObject) outputValue);
            }
        }
        return null;
    }

    @Override
    @objid ("14ddaaff-4583-11e0-b54c-00137279a832")
    public Object caseOpaqueBehavior(OpaqueBehavior inputOpaqueBehavior) {
        Object theResult = visitorMap.get(inputOpaqueBehavior);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OpaqueBehaviorImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputOpaqueBehavior, inputOpaqueBehavior);
            behavior.visitOpaqueBehavior(inputOpaqueBehavior);
        }
        return null;
    }

    @Override
    @objid ("14e00d58-4583-11e0-b54c-00137279a832")
    public Object caseOpaqueExpression(OpaqueExpression inputOpaqueExpression) {
        Object theResult = visitorMap.get(inputOpaqueExpression);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OpaqueExpressionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputOpaqueExpression, inputOpaqueExpression);
            behavior.visitOpaqueExpression(inputOpaqueExpression);
        }
        return null;
    }

    @Override
    @objid ("14e00d5e-4583-11e0-b54c-00137279a832")
    public Object caseOperation(Operation inputOperation) {
        Object theResult = visitorMap.get(inputOperation);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OperationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputOperation, inputOperation);
            behavior.visitOperation(inputOperation);
            for (Object precondition : inputOperation.getPreconditions()) {
                this.doSwitch((EObject) precondition);
            }
            for (Object postcondition : inputOperation.getPostconditions()) {
                this.doSwitch((EObject) postcondition);
            }
            this.doSwitch((EObject) inputOperation.getBodyCondition());
            for (Object ownedParameter : inputOperation.getOwnedParameters()) {
                this.doSwitch((EObject) ownedParameter);
            }
        }
        return null;
    }

    @Override
    @objid ("14e26fb4-4583-11e0-b54c-00137279a832")
    public Object caseOperationTemplateParameter(OperationTemplateParameter inputOperationTemplateParameter) {
        Object theResult = visitorMap.get(inputOperationTemplateParameter);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OperationTemplateParameterImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputOperationTemplateParameter,
                    inputOperationTemplateParameter);
            behavior
            .visitOperationTemplateParameter(inputOperationTemplateParameter);
        }
        return null;
    }

    @Override
    @objid ("14e4d20c-4583-11e0-b54c-00137279a832")
    public Object caseOutputPin(OutputPin inputOutputPin) {
        Object theResult = visitorMap.get(inputOutputPin);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OutputPinImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputOutputPin, inputOutputPin);
            behavior.visitOutputPin(inputOutputPin);
        }
        return null;
    }

    @Override
    @objid ("14e4d212-4583-11e0-b54c-00137279a832")
    public Object casePackage(Package inputPackage) {
        Object theResult = visitorMap.get(inputPackage);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PackageImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputPackage, inputPackage);
            // [CVI]: ignore visit of relations defined at "Package" level for
            // an element of type "Model"
            if (inputPackage instanceof Model)
                return null;
        
            behavior.visitPackage(inputPackage);
            for (Object packageMerge : inputPackage.getPackageMerges()) {
                this.doSwitch((EObject) packageMerge);
            }
            for (Object packagedElement : inputPackage.getPackagedElements()) {
                this.doSwitch((EObject) packagedElement);
            }
            for (Object ownedType : inputPackage.getOwnedTypes()) {
                this.doSwitch((EObject) ownedType);
            }
            for (Object nestedPackage : inputPackage.getNestedPackages()) {
                this.doSwitch((EObject) nestedPackage);
            }
            for (Object profileApplication : inputPackage
                    .getProfileApplications()) {
                this.doSwitch((EObject) profileApplication);
            }
        }
        return null;
    }

    @Override
    @objid ("14e7346a-4583-11e0-b54c-00137279a832")
    public Object casePackageableElement(PackageableElement inputPackageableElement) {
        return null;
    }

    @Override
    @objid ("14e996c0-4583-11e0-b54c-00137279a832")
    public Object casePackageImport(PackageImport inputPackageImport) {
        Object theResult = visitorMap.get(inputPackageImport);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PackageImportImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputPackageImport, inputPackageImport);
            behavior.visitPackageImport(inputPackageImport);
        }
        return null;
    }

    @Override
    @objid ("14ebf91a-4583-11e0-b54c-00137279a832")
    public Object casePackageMerge(PackageMerge inputPackageMerge) {
        Object theResult = visitorMap.get(inputPackageMerge);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PackageMergeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputPackageMerge, inputPackageMerge);
            behavior.visitPackageMerge(inputPackageMerge);
        }
        return null;
    }

    @Override
    @objid ("14ee5b74-4583-11e0-b54c-00137279a832")
    public Object caseParameter(Parameter inputParameter) {
        Object theResult = visitorMap.get(inputParameter);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ParameterImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputParameter, inputParameter);
            behavior.visitParameter(inputParameter);
            this.doSwitch((EObject) inputParameter.getDefaultValue());
        }
        return null;
    }

    @Override
    @objid ("14ee5b7a-4583-11e0-b54c-00137279a832")
    public Object caseParameterableElement(ParameterableElement inputParameterableElement) {
        return null;
    }

    @Override
    @objid ("14f0bdcf-4583-11e0-b54c-00137279a832")
    public Object caseParameterSet(ParameterSet inputParameterSet) {
        Object theResult = visitorMap.get(inputParameterSet);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ParameterSetImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputParameterSet, inputParameterSet);
            behavior.visitParameterSet(inputParameterSet);
            for (Object condition : inputParameterSet.getConditions()) {
                this.doSwitch((EObject) condition);
            }
        }
        return null;
    }

    @Override
    @objid ("14f32028-4583-11e0-b54c-00137279a832")
    public Object casePartDecomposition(PartDecomposition inputPartDecomposition) {
        Object theResult = visitorMap.get(inputPartDecomposition);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PartDecompositionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputPartDecomposition, inputPartDecomposition);
            behavior.visitPartDecomposition(inputPartDecomposition);
        }
        return null;
    }

    @Override
    @objid ("14f3202e-4583-11e0-b54c-00137279a832")
    public Object casePin(Pin inputPin) {
        Object theResult = visitorMap.get(inputPin);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PinImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputPin, inputPin);
            behavior.visitPin(inputPin);
        }
        return null;
    }

    @Override
    @objid ("14f58286-4583-11e0-b54c-00137279a832")
    public Object casePort(Port inputPort) {
        Object theResult = visitorMap.get(inputPort);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PortImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputPort, inputPort);
            behavior.visitPort(inputPort);
        }
        return null;
    }

    @Override
    @objid ("14f7e4dc-4583-11e0-b54c-00137279a832")
    public Object casePrimitiveType(PrimitiveType inputPrimitiveType) {
        Object theResult = visitorMap.get(inputPrimitiveType);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PrimitiveTypeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputPrimitiveType, inputPrimitiveType);
            behavior.visitPrimitiveType(inputPrimitiveType);
        
            for (Object ownedTemplateBinding : inputPrimitiveType.getTemplateBindings()) {
                this.doSwitch((EObject) ownedTemplateBinding);
            }
        }
        return null;
    }

    @Override
    @objid ("14fa4736-4583-11e0-b54c-00137279a832")
    public Object caseProfile(Profile inputProfile) {
        Object theResult = visitorMap.get(inputProfile);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProfileImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputProfile, inputProfile);
            behavior.visitProfile(inputProfile);
            for (Object ownedStereotype : inputProfile.getOwnedStereotypes()) {
                this.doSwitch((EObject) ownedStereotype);
            }
           
            //                    for (Object metaclassReference : inputProfile
            //                            .getMetaclassReferences()) {
            //                        this.doSwitch((EObject) metaclassReference);
            //                    }
            //                    for (Object metamodelReference : inputProfile
            //                            .getMetamodelReferences()) {
            //                        this.doSwitch((EObject) metamodelReference);
            //                    }
        }
        return null;
    }

    @Override
    @objid ("14fa473c-4583-11e0-b54c-00137279a832")
    public Object caseProfileApplication(ProfileApplication inputProfileApplication) {
        Object theResult = visitorMap.get(inputProfileApplication);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProfileApplicationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputProfileApplication, inputProfileApplication);
            behavior.visitProfileApplication(inputProfileApplication);
            try{
                this.doSwitch( inputProfileApplication.getAppliedProfile());
            }catch(Exception e ){
                e.printStackTrace(Modelio.err);
            }
        
        }
        return null;
    }

    @Override
    @objid ("14fca991-4583-11e0-b54c-00137279a832")
    public Object caseProperty(Property inputProperty) {
        Object theResult = visitorMap.get(inputProperty);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PropertyImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputProperty, inputProperty);
            behavior.visitProperty(inputProperty);
            this.doSwitch((EObject) inputProperty.getDefaultValue());
            for (Object qualifier : inputProperty.getQualifiers()) {
                this.doSwitch((EObject) qualifier);
            }
        }
        return null;
    }

    @Override
    @objid ("14ff0bea-4583-11e0-b54c-00137279a832")
    public Object caseProtocolConformance(ProtocolConformance inputProtocolConformance) {
        Object theResult = visitorMap.get(inputProtocolConformance);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProtocolConformanceImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputProtocolConformance, inputProtocolConformance);
            behavior.visitProtocolConformance(inputProtocolConformance);
        }
        return null;
    }

    @Override
    @objid ("15016e44-4583-11e0-b54c-00137279a832")
    public Object caseProtocolStateMachine(ProtocolStateMachine inputProtocolStateMachine) {
        Object theResult = visitorMap.get(inputProtocolStateMachine);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProtocolStateMachineImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap
            .put(inputProtocolStateMachine, inputProtocolStateMachine);
            behavior.visitProtocolStateMachine(inputProtocolStateMachine);
            for (Object conformance : inputProtocolStateMachine
                    .getConformances()) {
                this.doSwitch((EObject) conformance);
            }
        }
        return null;
    }

    @Override
    @objid ("15016e4a-4583-11e0-b54c-00137279a832")
    public Object caseProtocolTransition(ProtocolTransition inputProtocolTransition) {
        Object theResult = visitorMap.get(inputProtocolTransition);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProtocolTransitionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputProtocolTransition, inputProtocolTransition);
            behavior.visitProtocolTransition(inputProtocolTransition);
            this.doSwitch((EObject) inputProtocolTransition.getPostCondition());
            this.doSwitch((EObject) inputProtocolTransition.getPreCondition());
        }
        return null;
    }

    @Override
    @objid ("1503d09f-4583-11e0-b54c-00137279a832")
    public Object casePseudostate(Pseudostate inputPseudostate) {
        Object theResult = visitorMap.get(inputPseudostate);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PseudostateImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputPseudostate, inputPseudostate);
            behavior.visitPseudostate(inputPseudostate);
        }
        return null;
    }

    @Override
    @objid ("150632f8-4583-11e0-b54c-00137279a832")
    public Object caseQualifierValue(QualifierValue inputQualifierValue) {
        Object theResult = visitorMap.get(inputQualifierValue);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("QualifierValueImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputQualifierValue, inputQualifierValue);
            behavior.visitQualifierValue(inputQualifierValue);
        }
        return null;
    }

    @Override
    @objid ("150632fe-4583-11e0-b54c-00137279a832")
    public Object caseRaiseExceptionAction(RaiseExceptionAction inputRaiseExceptionAction) {
        Object theResult = visitorMap.get(inputRaiseExceptionAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RaiseExceptionActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap
            .put(inputRaiseExceptionAction, inputRaiseExceptionAction);
            behavior.visitRaiseExceptionAction(inputRaiseExceptionAction);
            this.doSwitch((EObject) inputRaiseExceptionAction.getException());
        }
        return null;
    }

    @Override
    @objid ("15089556-4583-11e0-b54c-00137279a832")
    public Object caseReadExtentAction(ReadExtentAction inputReadExtentAction) {
        Object theResult = visitorMap.get(inputReadExtentAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadExtentActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReadExtentAction, inputReadExtentAction);
            behavior.visitReadExtentAction(inputReadExtentAction);
            this.doSwitch((EObject) inputReadExtentAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("150af7ac-4583-11e0-b54c-00137279a832")
    public Object caseReadIsClassifiedObjectAction(ReadIsClassifiedObjectAction inputReadIsClassifiedObjectAction) {
        Object theResult = visitorMap.get(inputReadIsClassifiedObjectAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadIsClassifiedObjectActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputReadIsClassifiedObjectAction,
                    inputReadIsClassifiedObjectAction);
            behavior
            .visitReadIsClassifiedObjectAction(inputReadIsClassifiedObjectAction);
            this.doSwitch((EObject) inputReadIsClassifiedObjectAction
                    .getResult());
            this.doSwitch((EObject) inputReadIsClassifiedObjectAction
                    .getObject());
        }
        return null;
    }

    @Override
    @objid ("150d5a06-4583-11e0-b54c-00137279a832")
    public Object caseReadLinkAction(ReadLinkAction inputReadLinkAction) {
        Object theResult = visitorMap.get(inputReadLinkAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadLinkActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReadLinkAction, inputReadLinkAction);
            behavior.visitReadLinkAction(inputReadLinkAction);
            this.doSwitch((EObject) inputReadLinkAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("150d5a0c-4583-11e0-b54c-00137279a832")
    public Object caseReadLinkObjectEndAction(ReadLinkObjectEndAction inputReadLinkObjectEndAction) {
        Object theResult = visitorMap.get(inputReadLinkObjectEndAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadLinkObjectEndActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReadLinkObjectEndAction,
                    inputReadLinkObjectEndAction);
            behavior.visitReadLinkObjectEndAction(inputReadLinkObjectEndAction);
            this.doSwitch((EObject) inputReadLinkObjectEndAction.getObject());
            this.doSwitch((EObject) inputReadLinkObjectEndAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("150fbc64-4583-11e0-b54c-00137279a832")
    public Object caseReadLinkObjectEndQualifierAction(ReadLinkObjectEndQualifierAction inputReadLinkObjectEndQualifierAction) {
        Object theResult = visitorMap
        .get(inputReadLinkObjectEndQualifierAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadLinkObjectEndQualifierActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputReadLinkObjectEndQualifierAction,
                    inputReadLinkObjectEndQualifierAction);
            behavior
            .visitReadLinkObjectEndQualifierAction(inputReadLinkObjectEndQualifierAction);
            this.doSwitch((EObject) inputReadLinkObjectEndQualifierAction
                    .getObject());
            this.doSwitch((EObject) inputReadLinkObjectEndQualifierAction
                    .getResult());
        }
        return null;
    }

    @Override
    @objid ("15121eba-4583-11e0-b54c-00137279a832")
    public Object caseReadSelfAction(ReadSelfAction inputReadSelfAction) {
        Object theResult = visitorMap.get(inputReadSelfAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadSelfActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReadSelfAction, inputReadSelfAction);
            behavior.visitReadSelfAction(inputReadSelfAction);
            this.doSwitch((EObject) inputReadSelfAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("15148114-4583-11e0-b54c-00137279a832")
    public Object caseReadStructuralFeatureAction(ReadStructuralFeatureAction inputReadStructuralFeatureAction) {
        Object theResult = visitorMap.get(inputReadStructuralFeatureAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadStructuralFeatureActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputReadStructuralFeatureAction,
                    inputReadStructuralFeatureAction);
            behavior
            .visitReadStructuralFeatureAction(inputReadStructuralFeatureAction);
            this.doSwitch((EObject) inputReadStructuralFeatureAction
                    .getResult());
        }
        return null;
    }

    @Override
    @objid ("1514811a-4583-11e0-b54c-00137279a832")
    public Object caseReadVariableAction(ReadVariableAction inputReadVariableAction) {
        Object theResult = visitorMap.get(inputReadVariableAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadVariableActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReadVariableAction, inputReadVariableAction);
            behavior.visitReadVariableAction(inputReadVariableAction);
            this.doSwitch((EObject) inputReadVariableAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("1516e372-4583-11e0-b54c-00137279a832")
    public Object caseRealization(Realization inputRealization) {
        Object theResult = visitorMap.get(inputRealization);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RealizationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputRealization, inputRealization);
            behavior.visitRealization(inputRealization);
        }
        return null;
    }

    @Override
    @objid ("151945c8-4583-11e0-b54c-00137279a832")
    public Object caseReceiveOperationEvent(ReceiveOperationEvent inputReceiveOperationEvent) {
        Object theResult = visitorMap.get(inputReceiveOperationEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReceiveOperationEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReceiveOperationEvent,
                    inputReceiveOperationEvent);
            behavior.visitReceiveOperationEvent(inputReceiveOperationEvent);
        }
        return null;
    }

    @Override
    @objid ("151ba822-4583-11e0-b54c-00137279a832")
    public Object caseReceiveSignalEvent(ReceiveSignalEvent inputReceiveSignalEvent) {
        Object theResult = visitorMap.get(inputReceiveSignalEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReceiveSignalEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReceiveSignalEvent, inputReceiveSignalEvent);
            behavior.visitReceiveSignalEvent(inputReceiveSignalEvent);
        }
        return null;
    }

    @Override
    @objid ("151ba828-4583-11e0-b54c-00137279a832")
    public Object caseReception(Reception inputReception) {
        Object theResult = visitorMap.get(inputReception);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReceptionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReception, inputReception);
            behavior.visitReception(inputReception);
        }
        return null;
    }

    @Override
    @objid ("151e0a80-4583-11e0-b54c-00137279a832")
    public Object caseReclassifyObjectAction(ReclassifyObjectAction inputReclassifyObjectAction) {
        Object theResult = visitorMap.get(inputReclassifyObjectAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReclassifyObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReclassifyObjectAction,
                    inputReclassifyObjectAction);
            behavior.visitReclassifyObjectAction(inputReclassifyObjectAction);
            this.doSwitch((EObject) inputReclassifyObjectAction.getObject());
        }
        return null;
    }

    @Override
    @objid ("15206cd6-4583-11e0-b54c-00137279a832")
    public Object caseRedefinableElement(RedefinableElement inputRedefinableElement) {
        return null;
    }

    @Override
    @objid ("1522cf30-4583-11e0-b54c-00137279a832")
    public Object caseRedefinableTemplateSignature(RedefinableTemplateSignature inputRedefinableTemplateSignature) {
        Object theResult = visitorMap.get(inputRedefinableTemplateSignature);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RedefinableTemplateSignatureImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputRedefinableTemplateSignature,
                    inputRedefinableTemplateSignature);
            behavior
            .visitRedefinableTemplateSignature(inputRedefinableTemplateSignature);
        }
        return null;
    }

    @Override
    @objid ("1522cf36-4583-11e0-b54c-00137279a832")
    public Object caseReduceAction(ReduceAction inputReduceAction) {
        Object theResult = visitorMap.get(inputReduceAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReduceActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReduceAction, inputReduceAction);
            behavior.visitReduceAction(inputReduceAction);
            this.doSwitch((EObject) inputReduceAction.getResult());
            this.doSwitch((EObject) inputReduceAction.getCollection());
        }
        return null;
    }

    @Override
    @objid ("1525318f-4583-11e0-b54c-00137279a832")
    public Object caseRegion(Region inputRegion) {
        Object theResult = visitorMap.get(inputRegion);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RegionImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputRegion, inputRegion);
            behavior.visitRegion(inputRegion);
            for (Object subvertex : inputRegion.getSubvertices()) {
                this.doSwitch((EObject) subvertex);
            }
            for (Object transition : inputRegion.getTransitions()) {
                this.doSwitch((EObject) transition);
            }
        }
        return null;
    }

    @Override
    @objid ("152793e5-4583-11e0-b54c-00137279a832")
    public Object caseRelationship(Relationship inputRelationship) {
        return null;
    }

    @Override
    @objid ("1529f63e-4583-11e0-b54c-00137279a832")
    public Object caseRemoveStructuralFeatureValueAction(RemoveStructuralFeatureValueAction inputRemoveStructuralFeatureValueAction) {
        Object theResult = visitorMap
        .get(inputRemoveStructuralFeatureValueAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RemoveStructuralFeatureValueActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputRemoveStructuralFeatureValueAction,
                    inputRemoveStructuralFeatureValueAction);
            behavior
            .visitRemoveStructuralFeatureValueAction(inputRemoveStructuralFeatureValueAction);
            this.doSwitch((EObject) inputRemoveStructuralFeatureValueAction
                    .getRemoveAt());
        }
        return null;
    }

    @Override
    @objid ("152c5898-4583-11e0-b54c-00137279a832")
    public Object caseRemoveVariableValueAction(RemoveVariableValueAction inputRemoveVariableValueAction) {
        Object theResult = visitorMap.get(inputRemoveVariableValueAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RemoveVariableValueActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputRemoveVariableValueAction,
                    inputRemoveVariableValueAction);
            behavior
            .visitRemoveVariableValueAction(inputRemoveVariableValueAction);
            this.doSwitch((EObject) inputRemoveVariableValueAction
                    .getRemoveAt());
        }
        return null;
    }

    @Override
    @objid ("152c589e-4583-11e0-b54c-00137279a832")
    public Object caseReplyAction(ReplyAction inputReplyAction) {
        Object theResult = visitorMap.get(inputReplyAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReplyActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputReplyAction, inputReplyAction);
            behavior.visitReplyAction(inputReplyAction);
            this.doSwitch((EObject) inputReplyAction.getReturnInformation());
            for (Object replyValue : inputReplyAction.getReplyValues()) {
                this.doSwitch((EObject) replyValue);
            }
        }
        return null;
    }

    @Override
    @objid ("152ebaf4-4583-11e0-b54c-00137279a832")
    public Object caseSendObjectAction(SendObjectAction inputSendObjectAction) {
        Object theResult = visitorMap.get(inputSendObjectAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SendObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputSendObjectAction, inputSendObjectAction);
            behavior.visitSendObjectAction(inputSendObjectAction);
            this.doSwitch((EObject) inputSendObjectAction.getTarget());
            this.doSwitch((EObject) inputSendObjectAction.getRequest());
        }
        return null;
    }

    @Override
    @objid ("15311d4c-4583-11e0-b54c-00137279a832")
    public Object caseSendOperationEvent(SendOperationEvent inputSendOperationEvent) {
        Object theResult = visitorMap.get(inputSendOperationEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SendOperationEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputSendOperationEvent, inputSendOperationEvent);
            behavior.visitSendOperationEvent(inputSendOperationEvent);
        }
        return null;
    }

    @Override
    @objid ("15337fa6-4583-11e0-b54c-00137279a832")
    public Object caseSendSignalAction(SendSignalAction inputSendSignalAction) {
        Object theResult = visitorMap.get(inputSendSignalAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SendSignalActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputSendSignalAction, inputSendSignalAction);
            behavior.visitSendSignalAction(inputSendSignalAction);
            this.doSwitch((EObject) inputSendSignalAction.getTarget());
        }
        return null;
    }

    @Override
    @objid ("1535e200-4583-11e0-b54c-00137279a832")
    public Object caseSendSignalEvent(SendSignalEvent inputSendSignalEvent) {
        Object theResult = visitorMap.get(inputSendSignalEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SendSignalEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputSendSignalEvent, inputSendSignalEvent);
            behavior.visitSendSignalEvent(inputSendSignalEvent);
        }
        return null;
    }

    @Override
    @objid ("1538445a-4583-11e0-b54c-00137279a832")
    public Object caseSequenceNode(SequenceNode inputSequenceNode) {
        Object theResult = visitorMap.get(inputSequenceNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SequenceNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputSequenceNode, inputSequenceNode);
            behavior.visitSequenceNode(inputSequenceNode);
            for (Object executableNode : inputSequenceNode.getExecutableNodes()) {
                this.doSwitch((EObject) executableNode);
            }
        }
        return null;
    }

    @Override
    @objid ("15384460-4583-11e0-b54c-00137279a832")
    public Object caseSignal(Signal inputSignal) {
        Object theResult = visitorMap.get(inputSignal);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SignalImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputSignal, inputSignal);
            behavior.visitSignal(inputSignal);
            for (Object ownedAttribute : inputSignal.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
        }
        return null;
    }

    @Override
    @objid ("153aa6b5-4583-11e0-b54c-00137279a832")
    public Object caseSignalEvent(SignalEvent inputSignalEvent) {
        Object theResult = visitorMap.get(inputSignalEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SignalEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputSignalEvent, inputSignalEvent);
            behavior.visitSignalEvent(inputSignalEvent);
        }
        return null;
    }

    @Override
    @objid ("153d090e-4583-11e0-b54c-00137279a832")
    public Object caseSlot(Slot inputSlot) {
        Object theResult = visitorMap.get(inputSlot);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SlotImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputSlot, inputSlot);
            behavior.visitSlot(inputSlot);
            for (Object value : inputSlot.getValues()) {
                this.doSwitch((EObject) value);
            }
        }
        return null;
    }

    @Override
    @objid ("153f6b68-4583-11e0-b54c-00137279a832")
    public Object caseStartClassifierBehaviorAction(StartClassifierBehaviorAction inputStartClassifierBehaviorAction) {
        Object theResult = visitorMap.get(inputStartClassifierBehaviorAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StartClassifierBehaviorActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputStartClassifierBehaviorAction,
                    inputStartClassifierBehaviorAction);
            behavior
            .visitStartClassifierBehaviorAction(inputStartClassifierBehaviorAction);
            this.doSwitch((EObject) inputStartClassifierBehaviorAction
                    .getObject());
        }
        return null;
    }

    @Override
    @objid ("1541cdc2-4583-11e0-b54c-00137279a832")
    public Object caseState(State inputState) {
        Object theResult = visitorMap.get(inputState);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StateImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputState, inputState);
            behavior.visitState(inputState);
            for (Object connection : inputState.getConnections()) {
                this.doSwitch((EObject) connection);
            }
            for (Object region : inputState.getRegions()) {
                this.doSwitch((EObject) region);
            }
            this.doSwitch((EObject) inputState.getStateInvariant());
            this.doSwitch((EObject) inputState.getEntry());
            this.doSwitch((EObject) inputState.getExit());
            this.doSwitch((EObject) inputState.getDoActivity());
            for (Object connectionPoint : inputState.getConnectionPoints()) {
                this.doSwitch((EObject) connectionPoint);
            }
            for (Object deferrableTrigger : inputState.getDeferrableTriggers()) {
                this.doSwitch((EObject) deferrableTrigger);
            }
        }
        return null;
    }

    @Override
    @objid ("1541cdc8-4583-11e0-b54c-00137279a832")
    public Object caseStateInvariant(StateInvariant inputStateInvariant) {
        Object theResult = visitorMap.get(inputStateInvariant);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StateInvariantImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputStateInvariant, inputStateInvariant);
            behavior.visitStateInvariant(inputStateInvariant);
            this.doSwitch((EObject) inputStateInvariant.getInvariant());
        }
        return null;
    }

    @Override
    @objid ("1544301f-4583-11e0-b54c-00137279a832")
    public Object caseStateMachine(StateMachine inputStateMachine) {
        Object theResult = visitorMap.get(inputStateMachine);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StateMachineImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputStateMachine, inputStateMachine);
            behavior.visitStateMachine(inputStateMachine);
            for (Object region : inputStateMachine.getRegions()) {
                this.doSwitch((EObject) region);
            }
            for (Object connectionPoint : inputStateMachine
                    .getConnectionPoints()) {
                this.doSwitch((EObject) connectionPoint);
            }
        }
        return null;
    }

    @Override
    @objid ("15469276-4583-11e0-b54c-00137279a832")
    public Object caseStereotype(Stereotype inputStereotype) {
        Object theResult = visitorMap.get(inputStereotype);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StereotypeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputStereotype, inputStereotype);
            behavior.visitStereotype(inputStereotype);
            for (Object icon : inputStereotype.getIcons()) {
                this.doSwitch((EObject) icon);
            }
        }
        return null;
    }

    @Override
    @objid ("1548f4d0-4583-11e0-b54c-00137279a832")
    public Object caseStringExpression(StringExpression inputStringExpression) {
        Object theResult = visitorMap.get(inputStringExpression);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StringExpressionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputStringExpression, inputStringExpression);
            behavior.visitStringExpression(inputStringExpression);
            for (Object subExpression : inputStringExpression
                    .getSubExpressions()) {
                this.doSwitch((EObject) subExpression);
            }
        }
        return null;
    }

    @Override
    @objid ("154b572a-4583-11e0-b54c-00137279a832")
    public Object caseStructuralFeature(StructuralFeature inputStructuralFeature) {
        return null;
    }

    @Override
    @objid ("154b5730-4583-11e0-b54c-00137279a832")
    public Object caseStructuralFeatureAction(StructuralFeatureAction inputStructuralFeatureAction) {
        this.doSwitch((EObject) inputStructuralFeatureAction.getObject());
        return null;
    }

    @Override
    @objid ("154db987-4583-11e0-b54c-00137279a832")
    public Object caseStructuredActivityNode(StructuredActivityNode inputStructuredActivityNode) {
        Object theResult = visitorMap.get(inputStructuredActivityNode);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StructuredActivityNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputStructuredActivityNode,
                    inputStructuredActivityNode);
            behavior.visitStructuredActivityNode(inputStructuredActivityNode);
            for (Object variable : inputStructuredActivityNode.getVariables()) {
                this.doSwitch((EObject) variable);
            }
            for (Object node : inputStructuredActivityNode.getNodes()) {
                this.doSwitch((EObject) node);
            }
            for (Object edge : inputStructuredActivityNode.getEdges()) {
                this.doSwitch((EObject) edge);
            }
        }
        return null;
    }

    @Override
    @objid ("15501bde-4583-11e0-b54c-00137279a832")
    public Object caseStructuredClassifier(StructuredClassifier inputStructuredClassifier) {
        for (Object ownedAttribute : inputStructuredClassifier
                .getOwnedAttributes()) {
            this.doSwitch((EObject) ownedAttribute);
        }
        for (Object ownedConnector : inputStructuredClassifier
                .getOwnedConnectors()) {
            this.doSwitch((EObject) ownedConnector);
        }
        return null;
    }

    @Override
    @objid ("15527e38-4583-11e0-b54c-00137279a832")
    public Object caseSubstitution(Substitution inputSubstitution) {
        Object theResult = visitorMap.get(inputSubstitution);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SubstitutionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputSubstitution, inputSubstitution);
            behavior.visitSubstitution(inputSubstitution);
        }
        return null;
    }

    @Override
    @objid ("1554e092-4583-11e0-b54c-00137279a832")
    public Object caseTemplateableElement(TemplateableElement inputTemplateableElement) {
        for (Object templateBinding : inputTemplateableElement
                .getTemplateBindings()) {
            this.doSwitch((EObject) templateBinding);
        }
        this.doSwitch((EObject) inputTemplateableElement
                .getOwnedTemplateSignature());
        return null;
    }

    @Override
    @objid ("1554e098-4583-11e0-b54c-00137279a832")
    public Object caseTemplateBinding(TemplateBinding inputTemplateBinding) {
        Object theResult = visitorMap.get(inputTemplateBinding);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TemplateBindingImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTemplateBinding, inputTemplateBinding);
            behavior.visitTemplateBinding(inputTemplateBinding);
            for (Object parameterSubstitution : inputTemplateBinding
                    .getParameterSubstitutions()) {
                this.doSwitch((EObject) parameterSubstitution);
            }
        }
        return null;
    }

    @Override
    @objid ("155742f0-4583-11e0-b54c-00137279a832")
    public Object caseTemplateParameter(TemplateParameter inputTemplateParameter) {
        Object theResult = visitorMap.get(inputTemplateParameter);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TemplateParameterImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTemplateParameter, inputTemplateParameter);
            behavior.visitTemplateParameter(inputTemplateParameter);
            this.doSwitch((EObject) inputTemplateParameter
                    .getOwnedParameteredElement());
            this.doSwitch((EObject) inputTemplateParameter.getOwnedDefault());
        }
        return null;
    }

    @Override
    @objid ("1559a546-4583-11e0-b54c-00137279a832")
    public Object caseTemplateParameterSubstitution(TemplateParameterSubstitution inputTemplateParameterSubstitution) {
        Object theResult = visitorMap.get(inputTemplateParameterSubstitution);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TemplateParameterSubstitutionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            visitorMap.put(inputTemplateParameterSubstitution,
                    inputTemplateParameterSubstitution);
            behavior
            .visitTemplateParameterSubstitution(inputTemplateParameterSubstitution);
            //            for (Object ownedActual : inputTemplateParameterSubstitution
            //                    .getOwnedActuals()) {
            //                this.doSwitch((EObject) ownedActual);
            //            }
        
            this.doSwitch((EObject) inputTemplateParameterSubstitution.getOwnedActual());
        
        }
        return null;
    }

    @Override
    @objid ("155c07a0-4583-11e0-b54c-00137279a832")
    public Object caseTemplateSignature(TemplateSignature inputTemplateSignature) {
        Object theResult = visitorMap.get(inputTemplateSignature);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TemplateSignatureImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTemplateSignature, inputTemplateSignature);
            behavior.visitTemplateSignature(inputTemplateSignature);
            for (Object ownedParameter : inputTemplateSignature
                    .getOwnedParameters()) {
                this.doSwitch((EObject) ownedParameter);
            }
        }
        return null;
    }

    @Override
    @objid ("155e69fa-4583-11e0-b54c-00137279a832")
    public Object caseTestIdentityAction(TestIdentityAction inputTestIdentityAction) {
        Object theResult = visitorMap.get(inputTestIdentityAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TestIdentityActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTestIdentityAction, inputTestIdentityAction);
            behavior.visitTestIdentityAction(inputTestIdentityAction);
            this.doSwitch((EObject) inputTestIdentityAction.getFirst());
            this.doSwitch((EObject) inputTestIdentityAction.getSecond());
            this.doSwitch((EObject) inputTestIdentityAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("155e6a00-4583-11e0-b54c-00137279a832")
    public Object caseTimeConstraint(TimeConstraint inputTimeConstraint) {
        Object theResult = visitorMap.get(inputTimeConstraint);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTimeConstraint, inputTimeConstraint);
            behavior.visitTimeConstraint(inputTimeConstraint);
            this.doSwitch((EObject) inputTimeConstraint.getSpecification());
        }
        return null;
    }

    @Override
    @objid ("1560cc58-4583-11e0-b54c-00137279a832")
    public Object caseTimeEvent(TimeEvent inputTimeEvent) {
        Object theResult = visitorMap.get(inputTimeEvent);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTimeEvent, inputTimeEvent);
            behavior.visitTimeEvent(inputTimeEvent);
            this.doSwitch((EObject) inputTimeEvent.getWhen());
        }
        return null;
    }

    @Override
    @objid ("15632eaf-4583-11e0-b54c-00137279a832")
    public Object caseTimeExpression(TimeExpression inputTimeExpression) {
        Object theResult = visitorMap.get(inputTimeExpression);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeExpressionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTimeExpression, inputTimeExpression);
            behavior.visitTimeExpression(inputTimeExpression);
        }
        return null;
    }

    @Override
    @objid ("15659108-4583-11e0-b54c-00137279a832")
    public Object caseTimeInterval(TimeInterval inputTimeInterval) {
        Object theResult = visitorMap.get(inputTimeInterval);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeIntervalImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTimeInterval, inputTimeInterval);
            behavior.visitTimeInterval(inputTimeInterval);
        }
        return null;
    }

    @Override
    @objid ("1567f362-4583-11e0-b54c-00137279a832")
    public Object caseTimeObservation(final TimeObservation inputTimeIservation) {
        Object theResult = visitorMap.get(inputTimeIservation);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeIservationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTimeIservation, inputTimeIservation);
            behavior.visitTimeIservation(inputTimeIservation);
        }
        return null;
    }

    @Override
    @objid ("156a55bc-4583-11e0-b54c-00137279a832")
    public Object caseTransition(Transition inputTransition) {
        Object theResult = visitorMap.get(inputTransition);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TransitionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputTransition, inputTransition);
            behavior.visitTransition(inputTransition);
            this.doSwitch((EObject) inputTransition.getGuard());
            this.doSwitch((EObject) inputTransition.getEffect());
            for (Object trigger : inputTransition.getTriggers()) {
                this.doSwitch((EObject) trigger);
            }
        }
        return null;
    }

    @Override
    @objid ("156a55c2-4583-11e0-b54c-00137279a832")
    public Object caseTrigger(Trigger inputTrigger) {
        Object theResult = visitorMap.get(inputTrigger);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TriggerImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputTrigger, inputTrigger);
            behavior.visitTrigger(inputTrigger);
        }
        return null;
    }

    @Override
    @objid ("156cb81a-4583-11e0-b54c-00137279a832")
    public Object caseType(Type inputType) {
        return null;
    }

    @Override
    @objid ("156f1a70-4583-11e0-b54c-00137279a832")
    public Object caseTypedElement(TypedElement inputTypedElement) {
        return null;
    }

    @Override
    @objid ("15717cca-4583-11e0-b54c-00137279a832")
    public Object caseUnmarshallAction(UnmarshallAction inputUnmarshallAction) {
        Object theResult = visitorMap.get(inputUnmarshallAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("UnmarshallActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputUnmarshallAction, inputUnmarshallAction);
            behavior.visitUnmarshallAction(inputUnmarshallAction);
            for (Object result : inputUnmarshallAction.getResults()) {
                this.doSwitch((EObject) result);
            }
            this.doSwitch((EObject) inputUnmarshallAction.getObject());
        }
        return null;
    }

    @Override
    @objid ("1573df24-4583-11e0-b54c-00137279a832")
    public Object caseUsage(Usage inputUsage) {
        Object theResult = visitorMap.get(inputUsage);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("UsageImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputUsage, inputUsage);
            behavior.visitUsage(inputUsage);
        }
        return null;
    }

    @Override
    @objid ("1576417e-4583-11e0-b54c-00137279a832")
    public Object caseUseCase(UseCase inputUseCase) {
        Object theResult = visitorMap.get(inputUseCase);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("UseCaseImpl".equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputUseCase, inputUseCase);
            behavior.visitUseCase(inputUseCase);
            for (Object include : inputUseCase.getIncludes()) {
                this.doSwitch((EObject) include);
            }
            for (Object extend : inputUseCase.getExtends()) {
                this.doSwitch((EObject) extend);
            }
            for (Object extensionPoint : inputUseCase.getExtensionPoints()) {
                this.doSwitch((EObject) extensionPoint);
            }
        }
        return null;
    }

    @Override
    @objid ("1578a3d8-4583-11e0-b54c-00137279a832")
    public Object caseValuePin(ValuePin inputValuePin) {
        Object theResult = visitorMap.get(inputValuePin);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ValuePinImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputValuePin, inputValuePin);
            behavior.visitValuePin(inputValuePin);
            this.doSwitch((EObject) inputValuePin.getValue());
        }
        return null;
    }

    @Override
    @objid ("157b0632-4583-11e0-b54c-00137279a832")
    public Object caseValueSpecification(ValueSpecification inputValueSpecification) {
        return null;
    }

    @Override
    @objid ("157b0638-4583-11e0-b54c-00137279a832")
    public Object caseValueSpecificationAction(ValueSpecificationAction inputValueSpecificationAction) {
        Object theResult = visitorMap.get(inputValueSpecificationAction);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ValueSpecificationActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            visitorMap.put(inputValueSpecificationAction,
                    inputValueSpecificationAction);
            behavior
            .visitValueSpecificationAction(inputValueSpecificationAction);
            this.doSwitch((EObject) inputValueSpecificationAction.getValue());
            this.doSwitch((EObject) inputValueSpecificationAction.getResult());
        }
        return null;
    }

    @Override
    @objid ("157d688f-4583-11e0-b54c-00137279a832")
    public Object caseVariable(Variable inputVariable) {
        Object theResult = visitorMap.get(inputVariable);
        // If this concrete element is inherited by another concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("VariableImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            visitorMap.put(inputVariable, inputVariable);
            behavior.visitVariable(inputVariable);
        }
        return null;
    }

    @Override
    @objid ("157fcae6-4583-11e0-b54c-00137279a832")
    public Object caseVariableAction(VariableAction inputVariableAction) {
        return null;
    }

    @Override
    @objid ("15822d40-4583-11e0-b54c-00137279a832")
    public Object caseVertex(Vertex inputVertex) {
        return null;
    }

    @Override
    @objid ("15848f9a-4583-11e0-b54c-00137279a832")
    public Object caseWriteLinkAction(WriteLinkAction inputWriteLinkAction) {
        return null;
    }

    @Override
    @objid ("1586f1f4-4583-11e0-b54c-00137279a832")
    public Object caseWriteStructuralFeatureAction(WriteStructuralFeatureAction inputWriteStructuralFeatureAction) {
        this.doSwitch((EObject) inputWriteStructuralFeatureAction.getValue());
        return null;
    }

    @Override
    @objid ("1589544e-4583-11e0-b54c-00137279a832")
    public Object caseWriteVariableAction(WriteVariableAction inputWriteVariableAction) {
        this.doSwitch((EObject) inputWriteVariableAction.getValue());
        return null;
    }

    @objid ("15895454-4583-11e0-b54c-00137279a832")
    public XMIImportBehavior getBehavior() {
        return this.behavior;
    }

    @objid ("158bb6a9-4583-11e0-b54c-00137279a832")
    public Map<Object, Object> getVisitorMap() {
        return this.visitorMap;
    }

}
