/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import java.util.ArrayList;
import java.util.List;
import com.modeliosoft.modelio.api.model.IUmlModel;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ObEventTypeEnum;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IProfile;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAttribute;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IClass;
import com.modeliosoft.modelio.api.model.uml.statik.IClassAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IManifestation;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.StereotypeNotFoundException;
import com.modeliosoft.modelio.core.app.O;
import com.modeliosoft.modelio.core.log.LOG;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMI;
import com.modeliosoft.modelio.xmi.plugin.XMIStereotypes;
import com.modeliosoft.modelio.xmi.util.EcoreModelNavigation;
import com.modeliosoft.modelio.xmi.util.ModelUtils;
import com.modeliosoft.modelio.xmi.util.ObjingEAnnotation;
import com.modeliosoft.modelio.xmi.util.PrimitiveTypeMapper;
import com.modeliosoft.modelio.xmi.util.ProfileUtils;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import com.modeliosoft.modelio.xmi.util.XMILogs;
import org.eclipse.uml2.uml.*;
import org.eclipse.uml2.uml.Abstraction;
import org.eclipse.uml2.uml.AcceptCallAction;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.ActionExecutionSpecification;
import org.eclipse.uml2.uml.ActionInputPin;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.ActivityFinalNode;
import org.eclipse.uml2.uml.ActivityParameterNode;
import org.eclipse.uml2.uml.ActivityPartition;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.AddStructuralFeatureValueAction;
import org.eclipse.uml2.uml.AddVariableValueAction;
import org.eclipse.uml2.uml.AnyReceiveEvent;
import org.eclipse.uml2.uml.Artifact;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.AssociationClass;
import org.eclipse.uml2.uml.BehaviorExecutionSpecification;
import org.eclipse.uml2.uml.BroadcastSignalAction;
import org.eclipse.uml2.uml.CallBehaviorAction;
import org.eclipse.uml2.uml.CallEvent;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.CentralBufferNode;
import org.eclipse.uml2.uml.ChangeEvent;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.ClassifierTemplateParameter;
import org.eclipse.uml2.uml.Clause;
import org.eclipse.uml2.uml.ClearAssociationAction;
import org.eclipse.uml2.uml.ClearStructuralFeatureAction;
import org.eclipse.uml2.uml.ClearVariableAction;
import org.eclipse.uml2.uml.Collaboration;
import org.eclipse.uml2.uml.CollaborationUse;
import org.eclipse.uml2.uml.CombinedFragment;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.CommunicationPath;
import org.eclipse.uml2.uml.Component;
import org.eclipse.uml2.uml.ComponentRealization;
import org.eclipse.uml2.uml.ConditionalNode;
import org.eclipse.uml2.uml.ConnectableElementTemplateParameter;
import org.eclipse.uml2.uml.ConnectionPointReference;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.eclipse.uml2.uml.ConsiderIgnoreFragment;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.Continuation;
import org.eclipse.uml2.uml.ControlFlow;
import org.eclipse.uml2.uml.CreateLinkAction;
import org.eclipse.uml2.uml.CreateLinkObjectAction;
import org.eclipse.uml2.uml.CreateObjectAction;
import org.eclipse.uml2.uml.CreationEvent;
import org.eclipse.uml2.uml.DataStoreNode;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.DecisionNode;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.Deployment;
import org.eclipse.uml2.uml.DeploymentSpecification;
import org.eclipse.uml2.uml.DestroyLinkAction;
import org.eclipse.uml2.uml.DestroyObjectAction;
import org.eclipse.uml2.uml.DestructionEvent;
import org.eclipse.uml2.uml.Device;
import org.eclipse.uml2.uml.Duration;
import org.eclipse.uml2.uml.DurationConstraint;
import org.eclipse.uml2.uml.DurationInterval;
import org.eclipse.uml2.uml.DurationObservation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ElementImport;
import org.eclipse.uml2.uml.Enumeration;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.ExceptionHandler;
import org.eclipse.uml2.uml.ExecutionEnvironment;
import org.eclipse.uml2.uml.ExecutionEvent;
import org.eclipse.uml2.uml.ExecutionOccurrenceSpecification;
import org.eclipse.uml2.uml.ExpansionNode;
import org.eclipse.uml2.uml.ExpansionRegion;
import org.eclipse.uml2.uml.Expression;
import org.eclipse.uml2.uml.Extend;
import org.eclipse.uml2.uml.Extension;
import org.eclipse.uml2.uml.ExtensionEnd;
import org.eclipse.uml2.uml.ExtensionPoint;
import org.eclipse.uml2.uml.FinalState;
import org.eclipse.uml2.uml.FlowFinalNode;
import org.eclipse.uml2.uml.ForkNode;
import org.eclipse.uml2.uml.FunctionBehavior;
import org.eclipse.uml2.uml.Gate;
import org.eclipse.uml2.uml.GeneralOrdering;
import org.eclipse.uml2.uml.Generalization;
import org.eclipse.uml2.uml.GeneralizationSet;
import org.eclipse.uml2.uml.Image;
import org.eclipse.uml2.uml.Include;
import org.eclipse.uml2.uml.InformationFlow;
import org.eclipse.uml2.uml.InformationItem;
import org.eclipse.uml2.uml.InitialNode;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.InstanceSpecification;
import org.eclipse.uml2.uml.InstanceValue;
import org.eclipse.uml2.uml.Interaction;
import org.eclipse.uml2.uml.InteractionConstraint;
import org.eclipse.uml2.uml.InteractionOperand;
import org.eclipse.uml2.uml.InteractionUse;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.eclipse.uml2.uml.InterruptibleActivityRegion;
import org.eclipse.uml2.uml.Interval;
import org.eclipse.uml2.uml.IntervalConstraint;
import org.eclipse.uml2.uml.JoinNode;
import org.eclipse.uml2.uml.Lifeline;
import org.eclipse.uml2.uml.LinkEndCreationData;
import org.eclipse.uml2.uml.LinkEndData;
import org.eclipse.uml2.uml.LinkEndDestructionData;
import org.eclipse.uml2.uml.LiteralBoolean;
import org.eclipse.uml2.uml.LiteralInteger;
import org.eclipse.uml2.uml.LiteralNull;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.LiteralUnlimitedNatural;
import org.eclipse.uml2.uml.LoopNode;
import org.eclipse.uml2.uml.Manifestation;
import org.eclipse.uml2.uml.MergeNode;
import org.eclipse.uml2.uml.Message;
import org.eclipse.uml2.uml.MessageOccurrenceSpecification;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.Node;
import org.eclipse.uml2.uml.ObjectFlow;
import org.eclipse.uml2.uml.OccurrenceSpecification;
import org.eclipse.uml2.uml.OpaqueAction;
import org.eclipse.uml2.uml.OpaqueBehavior;
import org.eclipse.uml2.uml.OpaqueExpression;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.OperationTemplateParameter;
import org.eclipse.uml2.uml.OutputPin;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageImport;
import org.eclipse.uml2.uml.PackageMerge;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.ParameterSet;
import org.eclipse.uml2.uml.PartDecomposition;
import org.eclipse.uml2.uml.Pin;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.PrimitiveType;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.ProfileApplication;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.ProtocolConformance;
import org.eclipse.uml2.uml.ProtocolStateMachine;
import org.eclipse.uml2.uml.ProtocolTransition;
import org.eclipse.uml2.uml.Pseudostate;
import org.eclipse.uml2.uml.QualifierValue;
import org.eclipse.uml2.uml.RaiseExceptionAction;
import org.eclipse.uml2.uml.ReadExtentAction;
import org.eclipse.uml2.uml.ReadIsClassifiedObjectAction;
import org.eclipse.uml2.uml.ReadLinkAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction;
import org.eclipse.uml2.uml.ReadSelfAction;
import org.eclipse.uml2.uml.ReadStructuralFeatureAction;
import org.eclipse.uml2.uml.ReadVariableAction;
import org.eclipse.uml2.uml.Realization;
import org.eclipse.uml2.uml.ReceiveOperationEvent;
import org.eclipse.uml2.uml.ReceiveSignalEvent;
import org.eclipse.uml2.uml.Reception;
import org.eclipse.uml2.uml.ReclassifyObjectAction;
import org.eclipse.uml2.uml.RedefinableTemplateSignature;
import org.eclipse.uml2.uml.ReduceAction;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction;
import org.eclipse.uml2.uml.RemoveVariableValueAction;
import org.eclipse.uml2.uml.ReplyAction;
import org.eclipse.uml2.uml.SendObjectAction;
import org.eclipse.uml2.uml.SendOperationEvent;
import org.eclipse.uml2.uml.SendSignalAction;
import org.eclipse.uml2.uml.SendSignalEvent;
import org.eclipse.uml2.uml.SequenceNode;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.SignalEvent;
import org.eclipse.uml2.uml.Slot;
import org.eclipse.uml2.uml.StartClassifierBehaviorAction;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateInvariant;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.StringExpression;
import org.eclipse.uml2.uml.StructuredActivityNode;
import org.eclipse.uml2.uml.Substitution;
import org.eclipse.uml2.uml.TemplateBinding;
import org.eclipse.uml2.uml.TemplateParameter;
import org.eclipse.uml2.uml.TemplateParameterSubstitution;
import org.eclipse.uml2.uml.TemplateSignature;
import org.eclipse.uml2.uml.TestIdentityAction;
import org.eclipse.uml2.uml.TimeConstraint;
import org.eclipse.uml2.uml.TimeEvent;
import org.eclipse.uml2.uml.TimeExpression;
import org.eclipse.uml2.uml.TimeInterval;
import org.eclipse.uml2.uml.TimeObservation;
import org.eclipse.uml2.uml.Transition;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.UnmarshallAction;
import org.eclipse.uml2.uml.Usage;
import org.eclipse.uml2.uml.UseCase;
import org.eclipse.uml2.uml.ValuePin;
import org.eclipse.uml2.uml.ValueSpecificationAction;
import org.eclipse.uml2.uml.Variable;
import org.eclipse.uml2.uml.util.UMLSwitch;

@objid ("158e1902-4583-11e0-b54c-00137279a832")
public class PartialCreationImportVisitor {
    @objid ("158e1903-4583-11e0-b54c-00137279a832")
     Object objingElt;

    @objid ("158e1904-4583-11e0-b54c-00137279a832")
    private CreationImportMapper mapper;

    @objid ("158e1905-4583-11e0-b54c-00137279a832")
    private PartialImportMap partialMap;

    @objid ("158e1906-4583-11e0-b54c-00137279a832")
    private IPackage externalElementsPkg = null;

    @objid ("6fa8556a-1a76-11e1-8103-0027103f347d")
    private final int defaut = 42;


    @objid ("158e1908-4583-11e0-b54c-00137279a832")
    public PartialCreationImportVisitor() {
        this.objingElt = null;
        this.mapper = new CreationImportMapper();
        this.partialMap = PartialImportMap.getInstance();
    }

    @objid ("158e1912-4583-11e0-b54c-00137279a832")
    public CreationImportMapper getMapper() {
        // Automatically generated method. Please delete this comment before entering specific code.
        return this.mapper;
    }

    @objid ("15907b5e-4583-11e0-b54c-00137279a832")
    public PartialImportMap getPartialMap() {
        // Automatically generated method. Please delete this comment before entering specific code.
        return this.partialMap;
    }

    @objid ("15907b62-4583-11e0-b54c-00137279a832")
    public IPackage getExternalElementsPkg() {
        // Automatically generated method. Please delete this comment before entering specific code.
        return this.externalElementsPkg;
    }

    @objid ("6fab14ae-1a76-11e1-8103-0027103f347d")
    public Object createPartialObjingElt(final Element ecoreElt) {
        if (ecoreElt != null) {
            this.objingElt = null;
            Object objingEltFromMap = this.partialMap.get(ecoreElt);
        
            if (objingEltFromMap == null) {
                List<String> objingIDs = ObjingEAnnotation.getObjingIDs(ecoreElt);
                if (objingIDs != null ){
                    if ( (objingIDs.size() == 1) && (!objingIDs.get(0).equals(""))){
                        objingEltFromMap = Modelio.getInstance().getModelingSession().findElementById("Element", objingIDs.get(0));
                    }else  if ( objingIDs.size() > 1){
                        ArrayList<IElement> temp  = new ArrayList<IElement>();
                        for (String objingID : objingIDs){
                            IElement result = Modelio.getInstance().getModelingSession().findElementById("Element", objingID);
                            if (result != null)
                                temp.add((result));
                        }
        
                        if (temp.size() > 0)
                            objingEltFromMap = temp;
                    }
                }
            }
        
            if (objingEltFromMap == null) {
                this.mapper.accept(ecoreElt);
                this.partialMap.put(ecoreElt, this.objingElt);
                objingEltFromMap = this.objingElt;
            }else {
                this.partialMap.put(ecoreElt, objingEltFromMap);
            }
            return objingEltFromMap;
        } else{
            LOG.warning(XMI.PLUGIN_ID, "Ecore element is null.");
            throw new RuntimeException("Ecore element is null.");
        }
    }

    @objid ("6fab3bc0-1a76-11e1-8103-0027103f347d")
    public Object getObjingElt() {
        // Automatically generated method. Please delete this comment before entering specific code.
        return this.objingElt;
    }

    @objid ("1592ddb6-4583-11e0-b54c-00137279a832")
    private class CreationImportMapper extends UMLSwitch<Object> {
        @objid ("158e1907-4583-11e0-b54c-00137279a832")
         IUmlModel objingModelFactory = Modelio.getInstance()
    	.getModelingSession().getModel();


        @objid ("1592ddb7-4583-11e0-b54c-00137279a832")
        public void accept(Element ecoreElt) {
            doSwitch(ecoreElt);
        }

        @Override
        @objid ("1592ddba-4583-11e0-b54c-00137279a832")
        public Object caseAbstraction(Abstraction ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = new ArrayList<IDependency>();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1592ddc0-4583-11e0-b54c-00137279a832")
        public Object caseAcceptCallAction(AcceptCallAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15954010-4583-11e0-b54c-00137279a832")
        public Object caseAcceptEventAction(AcceptEventAction ecoreElt) {
            if (EcoreModelNavigation.hasReceiveOperationEvent(ecoreElt)) {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAcceptCallEventAction();
            
            } else if (EcoreModelNavigation.hasSignalEvent(ecoreElt)) {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAcceptSignalAction();
            
            } else if (EcoreModelNavigation.hasChangeEvent(ecoreElt)) {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAcceptChangeEventAction();
            
            } else if (EcoreModelNavigation.hasTimeEvent(ecoreElt)) {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAcceptTimeEventAction();
            }else    if (ReverseProperties.getInstance().isRoundtripEnabled()){
                String signal = ObjingEAnnotation.getSignal(ecoreElt);
                if ((signal != null) && (signal.equals("signal")))
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAcceptSignalAction();
            }else
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAcceptCallEventAction();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15954016-4583-11e0-b54c-00137279a832")
        public Object caseActionExecutionSpecification(ActionExecutionSpecification ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1595401c-4583-11e0-b54c-00137279a832")
        public Object caseActionInputPin(ActionInputPin ecoreElt) {
            IInputPin result = this.objingModelFactory.createInputPin();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                        .getStereotype(IInputPin.class, XMIStereotypes.UML2ACTIONINPUTPIN));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1597a26e-4583-11e0-b54c-00137279a832")
        public Object caseActivity(Activity ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createActivity();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1597a274-4583-11e0-b54c-00137279a832")
        public Object caseActivityFinalNode(ActivityFinalNode ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("159a04c5-4583-11e0-b54c-00137279a832")
        public Object caseActivityParameterNode(ActivityParameterNode ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createActivityParameterNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("159a04cb-4583-11e0-b54c-00137279a832")
        public Object caseActivityPartition(ActivityPartition ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createActivityPartition();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("159c671e-4583-11e0-b54c-00137279a832")
        public Object caseActor(Actor ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createActor();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("159c6724-4583-11e0-b54c-00137279a832")
        public Object caseAddStructuralFeatureValueAction(AddStructuralFeatureValueAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("159c672a-4583-11e0-b54c-00137279a832")
        public Object caseAddVariableValueAction(AddVariableValueAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("159ec979-4583-11e0-b54c-00137279a832")
        public Object caseAnyReceiveEvent(AnyReceiveEvent ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("159ec97f-4583-11e0-b54c-00137279a832")
        public Object caseArtifact(Artifact ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createArtifact();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a12bd2-4583-11e0-b54c-00137279a832")
        public Object caseAssociation(Association ecoreElt) {
            if (EcoreModelNavigation.hasTwoValidEnds(ecoreElt))
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAssociation();            
            else                  
                PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a12bd8-4583-11e0-b54c-00137279a832")
        public Object caseAssociationClass(AssociationClass ecoreElt) {
            // Creation of the association class
            IClassAssociation objingClassAssociation = this.objingModelFactory.createClassAssociation();
            // Creation of the Class
            IClass objingClass = this.objingModelFactory.createClass();
            // Creation of the Association
            IAssociation objingAssociation = this.objingModelFactory.createAssociation();
            // Set of the class and Association
            objingClassAssociation.setClassPart(objingClass);
            objingClassAssociation.setAssociationPart(objingAssociation);
            PartialCreationImportVisitor.this.objingElt = objingClass;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a12bde-4583-11e0-b54c-00137279a832")
        public Object caseBehaviorExecutionSpecification(BehaviorExecutionSpecification ecoreElt) {
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a38e30-4583-11e0-b54c-00137279a832")
        public Object caseBroadcastSignalAction(BroadcastSignalAction ecoreElt) {
            ISendSignalAction result = this.objingModelFactory.createSendSignalAction();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                        .getStereotype(ISendSignalAction.class, XMIStereotypes.UML2BROADCASTSIGNALACTION));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a38e36-4583-11e0-b54c-00137279a832")
        public Object caseCallBehaviorAction(CallBehaviorAction ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createCallBehaviorAction();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a5f089-4583-11e0-b54c-00137279a832")
        public Object caseCallEvent(CallEvent ecoreElt) {
            ecoreElt.getOwner();
            
            IEvent result = this.objingModelFactory.createEvent();
            result.setKind(ObEventTypeEnum.CALL_EVENT);
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a5f08f-4583-11e0-b54c-00137279a832")
        public Object caseCallOperationAction(CallOperationAction ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createCallOperationAction();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a852e1-4583-11e0-b54c-00137279a832")
        public Object caseCentralBufferNode(CentralBufferNode ecoreElt) {
            if (ReverseProperties.getInstance().isRoundtripEnabled()){
                String type = ObjingEAnnotation.getType(ecoreElt);
                if  ((type != null) && (type.equals("InstanceNode")))
                    PartialCreationImportVisitor.this.objingElt =  this.objingModelFactory.createInstanceNode();
                else
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createCentralBufferNode();
            }else 
            
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createCentralBufferNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15a852e7-4583-11e0-b54c-00137279a832")
        public Object caseChangeEvent(ChangeEvent ecoreElt) {
            ecoreElt.getOwner();
            IEvent result = this.objingModelFactory.createEvent();
            result.setKind(ObEventTypeEnum.CHANGE_EVENT);
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15aab53a-4583-11e0-b54c-00137279a832")
        public Object caseClass(Class ecoreElt) {
            if (!EcoreModelNavigation.isMetaclass(ecoreElt))
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createClass();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15aab540-4583-11e0-b54c-00137279a832")
        public Object caseClassifierTemplateParameter(ClassifierTemplateParameter ecoreElt) {
            IModelElement result = this.objingModelFactory.createTemplateParameter();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        ITemplateParameter.class, XMIStereotypes.UML2CLASSIFIERTEMPLATEPARAMETER));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            
            PartialCreationImportVisitor.this.objingElt =  result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15aab546-4583-11e0-b54c-00137279a832")
        public Object caseClause(Clause ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createClause();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15ad1798-4583-11e0-b54c-00137279a832")
        public Object caseClearAssociationAction(ClearAssociationAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15ad179e-4583-11e0-b54c-00137279a832")
        public Object caseClearStructuralFeatureAction(ClearStructuralFeatureAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15af79ef-4583-11e0-b54c-00137279a832")
        public Object caseClearVariableAction(ClearVariableAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15af79f5-4583-11e0-b54c-00137279a832")
        public Object caseCollaboration(Collaboration ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createCollaboration();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15b1dc4c-4583-11e0-b54c-00137279a832")
        public Object caseCollaborationUse(CollaborationUse ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createCollaborationUse();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15b1dc52-4583-11e0-b54c-00137279a832")
        public Object caseCombinedFragment(CombinedFragment ecoreElt) {
            // Particular case of a sequence diagram element
            //            PartialCreationImportVisitor.this.objingElt = Modelio.getInstance().getModelingSession()
            //            .getModel().createCombinedFragment();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15b43ea3-4583-11e0-b54c-00137279a832")
        public Object caseComment(Comment ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = new ArrayList<INote>();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15b43ea9-4583-11e0-b54c-00137279a832")
        public Object caseCommunicationPath(CommunicationPath ecoreElt) {
            if (EcoreModelNavigation.hasTwoValidEnds(ecoreElt)){
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAssociation();     
                try{
                    ((IModelElement)PartialCreationImportVisitor.this.objingElt).addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(IAssociation.class, XMIStereotypes.UML2COMMUNICATIONPATH));
                }catch(StereotypeNotFoundException e){
                    e.printStackTrace(Modelio.err);
                }
            } else                  
                PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15b6a0fc-4583-11e0-b54c-00137279a832")
        public Object caseComponent(Component ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createComponent();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15b6a102-4583-11e0-b54c-00137279a832")
        public Object caseComponentRealization(ComponentRealization ecoreElt) {
            IDependency result = this.objingModelFactory.createDependency();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IDependency.class, XMIStereotypes.UML2COMPONENTREALIZATION));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15b90356-4583-11e0-b54c-00137279a832")
        public Object caseConditionalNode(ConditionalNode ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createConditionalNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15b9035c-4583-11e0-b54c-00137279a832")
        public Object caseConnectableElementTemplateParameter(ConnectableElementTemplateParameter ecoreElt) {
            ITemplateParameter result = this.objingModelFactory.createTemplateParameter();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        ITemplateParameter.class, XMIStereotypes.UML2CONNECTABLEELEMENTTEMPLATEPARAMETER));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15bb65b0-4583-11e0-b54c-00137279a832")
        public Object caseConnectionPointReference(ConnectionPointReference ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createConnectionPointReference();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15bb65b6-4583-11e0-b54c-00137279a832")
        public Object caseConnector(Connector ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createConnector();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15bdc80a-4583-11e0-b54c-00137279a832")
        public Object caseConnectorEnd(ConnectorEnd ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createConnectorEnd();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c02a64-4583-11e0-b54c-00137279a832")
        public Object caseConsiderIgnoreFragment(ConsiderIgnoreFragment ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c02a6a-4583-11e0-b54c-00137279a832")
        public Object caseConstraint(Constraint ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c02a70-4583-11e0-b54c-00137279a832")
        public Object caseContinuation(Continuation ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c28cc3-4583-11e0-b54c-00137279a832")
        public Object caseControlFlow(ControlFlow ecoreElt) {
            ActivityNode ecoreSource = ecoreElt.getSource();
            ActivityNode ecoreTarget = ecoreElt.getTarget();
            if ((ecoreSource != null) && (ecoreTarget != null)) {
                Object objingSource = ReverseProperties.getInstance().getMappedElement(ecoreSource);
                if (objingSource != null){
                    if (objingSource instanceof IActivityNode)
                        PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createControlFlow();
                }
            }
            PartialCreationImportVisitor.this.objingElt =  null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c28cc9-4583-11e0-b54c-00137279a832")
        public Object caseCreateLinkAction(CreateLinkAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c4ef1c-4583-11e0-b54c-00137279a832")
        public Object caseCreateLinkObjectAction(CreateLinkObjectAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c4ef22-4583-11e0-b54c-00137279a832")
        public Object caseCreateObjectAction(CreateObjectAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c75176-4583-11e0-b54c-00137279a832")
        public Object caseCreationEvent(CreationEvent ecoreElt) {
            ecoreElt.getOwner();
            IEvent result = this.objingModelFactory.createEvent();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IEvent.class, XMIStereotypes.UML2CREATIONEVENT));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c7517c-4583-11e0-b54c-00137279a832")
        public Object caseDataStoreNode(DataStoreNode ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createDataStoreNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c9b3d0-4583-11e0-b54c-00137279a832")
        public Object caseDataType(DataType ecoreElt) {
            if (PrimitiveTypeMapper.isPredefinedType(ecoreElt))
                PartialCreationImportVisitor.this.objingElt = PrimitiveTypeMapper.getPredefinedType(ecoreElt);
            else 
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createDataType();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15c9b3d6-4583-11e0-b54c-00137279a832")
        public Object caseDecisionNode(DecisionNode ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15cc162a-4583-11e0-b54c-00137279a832")
        public Object caseDependency(Dependency ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = new ArrayList<IDependency>();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15cc1630-4583-11e0-b54c-00137279a832")
        public Object caseDeployment(Deployment ecoreElt) {
            IDependency result = this.objingModelFactory.createDependency();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IDependency.class, XMIStereotypes.UML2DEPLOYMENT));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15ce7883-4583-11e0-b54c-00137279a832")
        public Object caseDeploymentSpecification(DeploymentSpecification ecoreElt) {
            IArtifact result = this.objingModelFactory.createArtifact();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IArtifact.class, XMIStereotypes.UML2DEPLOYMENTSPECIFICATION));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15ce7889-4583-11e0-b54c-00137279a832")
        public Object caseDestroyLinkAction(DestroyLinkAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15d0dade-4583-11e0-b54c-00137279a832")
        public Object caseDestroyObjectAction(DestroyObjectAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15d0dae4-4583-11e0-b54c-00137279a832")
        public Object caseDestructionEvent(DestructionEvent ecoreElt) {
            ecoreElt.getOwner();
            IEvent result = this.objingModelFactory.createEvent();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IEvent.class, XMIStereotypes.UML2DESTRUCTIONEVENT));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15d33d39-4583-11e0-b54c-00137279a832")
        public Object caseDevice(Device ecoreElt) {
            IModelElement objElt = this.objingModelFactory.createNode();
            try{
                objElt.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(INode.class, XMIStereotypes.UML2DEVICE));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = objElt;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15d59f8e-4583-11e0-b54c-00137279a832")
        public Object caseDuration(Duration ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15d59f94-4583-11e0-b54c-00137279a832")
        public Object caseDurationConstraint(DurationConstraint ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createDurationConstraint();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15d801e8-4583-11e0-b54c-00137279a832")
        public Object caseDurationInterval(DurationInterval ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15d801ee-4583-11e0-b54c-00137279a832")
        public Object caseDurationObservation(DurationObservation ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15da6442-4583-11e0-b54c-00137279a832")
        public Object caseElementImport(ElementImport ecoreElt) {
            ReverseProperties revProp = ReverseProperties.getInstance();
            
            PackageableElement ecoreImported = ecoreElt.getImportedElement();
            ecoreElt.getImportingNamespace();
            
            // with the ecore I take de IjingElement
            INameSpace objingImported = (INameSpace) revProp
            .getMappedElement(ecoreImported);
            // I set to the PartialCreationImportVisitor.this.objingElt Imported Importing previousely find
            if ((objingImported != null)  && !(objingImported instanceof IProfile)){
            
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createElementImport();
            }else {
                PartialCreationImportVisitor.this.objingElt = null;
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15dcc69c-4583-11e0-b54c-00137279a832")
        public Object caseEnumeration(Enumeration ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createEnumeration();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15dcc6a2-4583-11e0-b54c-00137279a832")
        public Object caseEnumerationLiteral(EnumerationLiteral ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createEnumerationLiteral();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15df28f6-4583-11e0-b54c-00137279a832")
        public Object caseExceptionHandler(ExceptionHandler ecoreElt) {
            PartialCreationImportVisitor.this.objingElt =  ModelUtils.createExceptionHandler(ecoreElt);
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15df28fc-4583-11e0-b54c-00137279a832")
        public Object caseExecutionEnvironment(ExecutionEnvironment ecoreElt) {
            INode result = this.objingModelFactory.createNode();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                        .getStereotype(INode.class, XMIStereotypes.UML2EXECUTIONENVIRONMENT));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15e18b50-4583-11e0-b54c-00137279a832")
        public Object caseExecutionEvent(ExecutionEvent ecoreElt) {
            ecoreElt.getOwner();     
            IEvent result = this.objingModelFactory.createEvent();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IEvent.class, XMIStereotypes.UML2EXECUTIONEVENT));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15e18b56-4583-11e0-b54c-00137279a832")
        public Object caseExecutionOccurrenceSpecification(ExecutionOccurrenceSpecification ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15e3edaa-4583-11e0-b54c-00137279a832")
        public Object caseExpansionNode(ExpansionNode ecoreElt) {
            IModelElement temp = null;
            if (ecoreElt.getRegionAsInput()!= null){
                temp =  this.objingModelFactory.createInputPin();
            }else{
                temp =  this.objingModelFactory.createOutputPin();
            }
            
            try{
                temp.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(IPin.class, XMIStereotypes.UML2EXPANSIONNODE));
            }catch(StereotypeNotFoundException excep){
            
            }
                      
            PartialCreationImportVisitor.this.objingElt = temp;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15e3edb0-4583-11e0-b54c-00137279a832")
        public Object caseExpansionRegion(ExpansionRegion ecoreElt) {
            IStructuredActivityNode region = this.objingModelFactory.createStructuredActivityNode();
            try{
                region.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(IStructuredActivityNode.class, XMIStereotypes.UML2EXPANSIONREGION));
            }catch(StereotypeNotFoundException excep){
            
            }
            PartialCreationImportVisitor.this.objingElt = region;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15e65005-4583-11e0-b54c-00137279a832")
        public Object caseExpression(Expression ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15e6500b-4583-11e0-b54c-00137279a832")
        public Object caseExtend(Extend ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createUseCaseDependency();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15e8b260-4583-11e0-b54c-00137279a832")
        public Object caseExtension(Extension ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15e8b266-4583-11e0-b54c-00137279a832")
        public Object caseExtensionEnd(ExtensionEnd ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15eb14bc-4583-11e0-b54c-00137279a832")
        public Object caseExtensionPoint(ExtensionPoint ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createExtensionPoint();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15eb14c2-4583-11e0-b54c-00137279a832")
        public Object caseFinalState(FinalState ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15ed7717-4583-11e0-b54c-00137279a832")
        public Object caseFlowFinalNode(FlowFinalNode ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createFlowFinalNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15efd96c-4583-11e0-b54c-00137279a832")
        public Object caseForkNode(ForkNode ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15efd972-4583-11e0-b54c-00137279a832")
        public Object caseFunctionBehavior(FunctionBehavior ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15f23bc6-4583-11e0-b54c-00137279a832")
        public Object caseGate(Gate ecoreElt) {
            // Particular case of a sequence diagram element
            //            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createGate();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15f23bcc-4583-11e0-b54c-00137279a832")
        public Object caseGeneralOrdering(GeneralOrdering ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createGeneralOrdering();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15f49e20-4583-11e0-b54c-00137279a832")
        public Object caseGeneralization(Generalization ecoreElt) {
            ReverseProperties revProp = ReverseProperties.getInstance();
            
            Classifier ecoreGeneral = ecoreElt.getGeneral();
            Classifier ecoreSpecific = ecoreElt.getSpecific();
            
            IElement objingGeneral = (IElement) revProp
            .getMappedElement(ecoreGeneral);
            IElement objingSpecific = (IElement) revProp
            .getMappedElement(ecoreSpecific);
            
            if (objingGeneral instanceof INameSpace
                    && objingSpecific instanceof INameSpace
                    && (!PrimitiveTypeMapper.isPredefinedType(ecoreGeneral))) {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createGeneralization();
            }else{
                XMILogs xmilogs = XMILogs.getInstance();
                xmilogs.writelnInLog(XMI.I18N.getMessage("logFile.warning.unsupportedEnds", " "
                        , "IGeneralization", objingGeneral.getClass().getSimpleName(), objingSpecific.getClass().getSimpleName()));
            
               PartialCreationImportVisitor.this.objingElt = null;
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15f49e26-4583-11e0-b54c-00137279a832")
        public Object caseGeneralizationSet(GeneralizationSet ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15f7007b-4583-11e0-b54c-00137279a832")
        public Object caseImage(Image ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15f70081-4583-11e0-b54c-00137279a832")
        public Object caseInclude(Include ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createUseCaseDependency();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15f962d8-4583-11e0-b54c-00137279a832")
        public Object caseInformationFlow(InformationFlow ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInformationFlow();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15fbc52e-4583-11e0-b54c-00137279a832")
        public Object caseInformationItem(InformationItem ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInformationItem();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15fbc534-4583-11e0-b54c-00137279a832")
        public Object caseInitialNode(InitialNode ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInitialNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15fe2788-4583-11e0-b54c-00137279a832")
        public Object caseInputPin(InputPin ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInputPin();
            if (ecoreElt.getOwner() instanceof TestIdentityAction){
                if (((TestIdentityAction)ecoreElt.getOwner()).getFirst().equals(ecoreElt)){
                    try{
                        IStereotype stereo = Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                        .getStereotype(IInputPin.class, XMIStereotypes.UML2FIRST);
                        ((IModelElement)PartialCreationImportVisitor.this.objingElt).addExtension(stereo);
                    }catch(StereotypeNotFoundException e){
                        e.printStackTrace(Modelio.err);
                    }
                }else  if (((TestIdentityAction)ecoreElt.getOwner()).getSecond().equals(ecoreElt)){
                    try{
                        IStereotype stereo = Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                        .getStereotype(IInputPin.class, XMIStereotypes.UML2SECOND);
                        ((IModelElement)PartialCreationImportVisitor.this.objingElt).addExtension(stereo);
                    }catch(StereotypeNotFoundException e){
                        e.printStackTrace(Modelio.err);
                    }
                }
            }else if (ecoreElt.getOwner() instanceof CallOperationAction){
                InputPin temp = ((CallOperationAction)ecoreElt.getOwner()).getTarget();
                if ((temp != null) &&(temp.equals(ecoreElt))){
                    try{
                        IStereotype stereo = Modelio.getInstance().getModelingSession().getMetamodelExtensions()
                        .getStereotype(IInputPin.class, XMIStereotypes.UML2TARGET);
                        ((IModelElement)PartialCreationImportVisitor.this.objingElt).addExtension(stereo);
                    }catch(StereotypeNotFoundException e){
                        e.printStackTrace(Modelio.err);
                    }
                }
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("15fe278e-4583-11e0-b54c-00137279a832")
        public Object caseInstanceSpecification(InstanceSpecification ecoreElt) {
            if (ReverseProperties.getInstance().isRoundtripEnabled()){
                if (ObjingEAnnotation.isConnector(ecoreElt)){
                    PartialCreationImportVisitor.this.objingElt =  this.objingModelFactory.createConnector();
                    return PartialCreationImportVisitor.this.defaut;
                }else if (ObjingEAnnotation.isLink(ecoreElt)){
                    PartialCreationImportVisitor.this.objingElt =  this.objingModelFactory.createLink();
                    return PartialCreationImportVisitor.this.defaut;
                }
            }
            if (EcoreModelNavigation.isAssocInstance(ecoreElt)){
                if (EcoreModelNavigation.isConnector(ecoreElt)){
                    PartialCreationImportVisitor.this.objingElt =  this.objingModelFactory.createConnector();
                    return PartialCreationImportVisitor.this.defaut;
                }else  if (EcoreModelNavigation.isLink(ecoreElt)){
                    PartialCreationImportVisitor.this.objingElt =  this.objingModelFactory.createLink();
                    return PartialCreationImportVisitor.this.defaut;
                }
            
            }
            PartialCreationImportVisitor.this.objingElt =  this.objingModelFactory.createInstance();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("160089e3-4583-11e0-b54c-00137279a832")
        public Object caseInstanceValue(InstanceValue ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("160089e9-4583-11e0-b54c-00137279a832")
        public Object caseInteraction(Interaction ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInteraction();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1602ec3f-4583-11e0-b54c-00137279a832")
        public Object caseInteractionConstraint(InteractionConstraint ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16054e96-4583-11e0-b54c-00137279a832")
        public Object caseInteractionOperand(InteractionOperand ecoreElt) {
            // Particular case of a sequence diagram element
            //            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInteractionOperand();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16054e9c-4583-11e0-b54c-00137279a832")
        public Object caseInteractionUse(InteractionUse ecoreElt) {
            // Particular case of a sequence diagram element
            //            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInteractionUse();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1607b0f0-4583-11e0-b54c-00137279a832")
        public Object caseInterface(Interface ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInterface();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1607b0f6-4583-11e0-b54c-00137279a832")
        public Object caseInterfaceRealization(InterfaceRealization ecoreElt) {
            if ((ecoreElt.getClients().size() > 0) && (ecoreElt.getClients().get(0) instanceof Port))
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createProvidedInterface();
            else if (((ecoreElt.getClients().size() > 0) && (ecoreElt.getClients().get(0) instanceof IInterface))
                    || (ecoreElt.getContract() != null))
                PartialCreationImportVisitor.this.objingElt =  this.objingModelFactory.createInterfaceRealization();
            else 
                PartialCreationImportVisitor.this.objingElt =  null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("160a134b-4583-11e0-b54c-00137279a832")
        public Object caseInterruptibleActivityRegion(InterruptibleActivityRegion ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInterruptibleActivityRegion();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("160a1351-4583-11e0-b54c-00137279a832")
        public Object caseInterval(Interval ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("160c75a8-4583-11e0-b54c-00137279a832")
        public Object caseIntervalConstraint(IntervalConstraint ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("160ed7fe-4583-11e0-b54c-00137279a832")
        public Object caseJoinNode(JoinNode ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("160ed804-4583-11e0-b54c-00137279a832")
        public Object caseLifeline(Lifeline ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createLifeline();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16113a58-4583-11e0-b54c-00137279a832")
        public Object caseLinkEndCreationData(LinkEndCreationData ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16113a5e-4583-11e0-b54c-00137279a832")
        public Object caseLinkEndData(LinkEndData ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16139cb4-4583-11e0-b54c-00137279a832")
        public Object caseLinkEndDestructionData(LinkEndDestructionData ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1615ff0c-4583-11e0-b54c-00137279a832")
        public Object caseLiteralBoolean(LiteralBoolean ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1615ff12-4583-11e0-b54c-00137279a832")
        public Object caseLiteralInteger(LiteralInteger ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16186166-4583-11e0-b54c-00137279a832")
        public Object caseLiteralNull(LiteralNull ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1618616c-4583-11e0-b54c-00137279a832")
        public Object caseLiteralString(LiteralString ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("161ac3c2-4583-11e0-b54c-00137279a832")
        public Object caseLiteralUnlimitedNatural(LiteralUnlimitedNatural ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("161d261a-4583-11e0-b54c-00137279a832")
        public Object caseLoopNode(LoopNode ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createLoopNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("161d2620-4583-11e0-b54c-00137279a832")
        public Object caseManifestation(Manifestation ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = new ArrayList<IManifestation>();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("161f8874-4583-11e0-b54c-00137279a832")
        public Object caseMergeNode(MergeNode ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("161f887a-4583-11e0-b54c-00137279a832")
        public Object caseMessage(Message ecoreElt) {
            // TODO assert mapping is correct
            //            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createMessage();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1621ead2-4583-11e0-b54c-00137279a832")
        public Object caseMessageOccurrenceSpecification(MessageOccurrenceSpecification ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16244d28-4583-11e0-b54c-00137279a832")
        public Object caseModel(Model ecoreElt) {
            boolean root = false;
            for (Package ecoremodel : ReverseProperties.getInstance().getEcoreModel()){
                if (ecoreElt.equals(ecoremodel)){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.getRoot();
                    root = true;
                }
            }
            
            if (! root) {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createPackage();
                ((IPackage)PartialCreationImportVisitor.this.objingElt).setName(ecoreElt.getName());
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16244d2e-4583-11e0-b54c-00137279a832")
        public Object caseNode(Node ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1626af83-4583-11e0-b54c-00137279a832")
        public Object caseObjectFlow(ObjectFlow ecoreElt) {
            ActivityNode ecoreSource = ecoreElt.getSource();
            ActivityNode ecoreTarget = ecoreElt.getTarget();
            if ((ecoreSource != null) && (ecoreTarget != null)) {
                Object objingSource = ReverseProperties.getInstance().getMappedElement(ecoreSource);
                if ((objingSource != null)&& (objingSource instanceof IActivityNode)){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createObjectFlow();
                }else{
                    PartialCreationImportVisitor.this.objingElt =  null;
                }
            }else{
                PartialCreationImportVisitor.this.objingElt =  null;
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1626af89-4583-11e0-b54c-00137279a832")
        public Object caseOccurrenceSpecification(OccurrenceSpecification ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("162911e0-4583-11e0-b54c-00137279a832")
        public Object caseOpaqueAction(OpaqueAction ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createOpaqueAction();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("162b7436-4583-11e0-b54c-00137279a832")
        public Object caseOpaqueBehavior(OpaqueBehavior ecoreElt) {
            Element ecoreOwner = ecoreElt.getOwner();
            ReverseProperties revProp = ReverseProperties.getInstance();
            
            Object objOwner = revProp.getMappedElement(ecoreOwner);
            if (objOwner instanceof ITransition){
                String content = "";
                for (String temp : ecoreElt.getBodies()){
                    content = content + temp;
                }
                ((ITransition) objOwner).setEffect(content);
                PartialCreationImportVisitor.this.objingElt = null;
            }else if (revProp.isRoundtripEnabled() && ObjingEAnnotation.isDeleted(ecoreElt)){
                PartialCreationImportVisitor.this.objingElt = null;
                return null;
            }else
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createOpaqueBehavior();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("162b743c-4583-11e0-b54c-00137279a832")
        public Object caseOpaqueExpression(OpaqueExpression ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("162dd694-4583-11e0-b54c-00137279a832")
        public Object caseOperation(Operation ecoreElt) {
            Element ecoreOwner = ecoreElt.getOwner();
            Object objingOwner =  ReverseProperties.getInstance().getMappedElement(ecoreOwner);
            if ((objingOwner instanceof IClassifier)  && !(objingOwner instanceof IEnumeration)){
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createOperation();
            } else
                PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("163038ea-4583-11e0-b54c-00137279a832")
        public Object caseOperationTemplateParameter(OperationTemplateParameter ecoreElt) {
            IParameter result = this.objingModelFactory.createParameter();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IParameter.class, XMIStereotypes.UML2OPERATIONTEMPLATEPARAMETER));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("163038f0-4583-11e0-b54c-00137279a832")
        public Object caseOutputPin(OutputPin ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createOutputPin();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16329b45-4583-11e0-b54c-00137279a832")
        public Object casePackage(Package ecoreElt) {
            for (Package ecoremodel : ReverseProperties.getInstance().getEcoreModel()){
                if (ecoreElt.equals(ecoremodel)){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.getRoot();}
            }
            if (ObjingEAnnotation.isRequirementContainer(ecoreElt))
                PartialCreationImportVisitor.this.objingElt = O.getDefault().getModelingSession().getModelFactory().createRequirementContainer();
            else{
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createPackage();
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1634fd9e-4583-11e0-b54c-00137279a832")
        public Object casePackageImport(PackageImport ecoreElt) {
            ReverseProperties revProp = ReverseProperties.getInstance();
            Package ecoreImported = ecoreElt.getImportedPackage();
            
            Package model = EcoreModelNavigation.getRoot(ecoreImported);
            
            if  ((model != null)  && revProp.getEcoreModel().contains(model) ){
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createPackageImport();
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16375ff8-4583-11e0-b54c-00137279a832")
        public Object casePackageMerge(PackageMerge ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createPackageMerge();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16375ffe-4583-11e0-b54c-00137279a832")
        public Object caseParameter(Parameter ecoreElt) {
            boolean isBehavior = !(ReverseProperties.getInstance().getMappedElement(ecoreElt.getOwner()) instanceof IOperation);
            
            if (isBehavior)
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createBehaviorParameter();
            else 
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createParameter();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1639c253-4583-11e0-b54c-00137279a832")
        public Object caseParameterSet(ParameterSet ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("163c24ac-4583-11e0-b54c-00137279a832")
        public Object casePartDecomposition(PartDecomposition ecoreElt) {
            // Particular case of a sequence diagram element
            //            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createPartDecomposition();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("163c24b2-4583-11e0-b54c-00137279a832")
        public Object casePin(Pin ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("163e8707-4583-11e0-b54c-00137279a832")
        public Object casePort(Port ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createPort();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1640e960-4583-11e0-b54c-00137279a832")
        public Object casePrimitiveType(PrimitiveType ecoreElt) {
            if (PrimitiveTypeMapper.isPredefinedType(ecoreElt))
                PartialCreationImportVisitor.this.objingElt =  PrimitiveTypeMapper.getPredefinedType(ecoreElt);
            else 
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createDataType();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1640e966-4583-11e0-b54c-00137279a832")
        public Object caseProfile(Profile ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16434bba-4583-11e0-b54c-00137279a832")
        public Object caseProfileApplication(ProfileApplication ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16434bc0-4583-11e0-b54c-00137279a832")
        public Object caseProperty(Property ecoreElt) {
            Element ecoreOwner = ecoreElt.getOwner();
            if (ecoreOwner instanceof Stereotype){
            
                ProfileUtils.visitProperty(ecoreElt);
                PartialCreationImportVisitor.this.objingElt = null;
            
            }else{
                List<IModelElement> result = new ArrayList<IModelElement>();
            
                if (EcoreModelNavigation.isAssocEnd(ecoreElt)) {
            
                    if (EcoreModelNavigation.hasTwoValidEnds(ecoreElt.getAssociation()) 
                            && (EcoreModelNavigation.isValid(ecoreElt))){
                        result.add(this.objingModelFactory.createAssociationEnd());
                    }
            
                } else if (EcoreModelNavigation.isPart(ecoreElt) ){
                    IBindableInstance inst = this.objingModelFactory.createBindableInstance();
                    if (EcoreModelNavigation.isAssocEnd(ecoreElt)){
                        inst.setRepresentedFeature(result.get(0));
                    }
                    result.add(inst);
            
                } else if (EcoreModelNavigation.isPort(ecoreElt)){
                    result.add(this.objingModelFactory.createPort());
                }
            
                if (result.size() == 0){
            
                    IElement objingOwner = (IElement) ReverseProperties.getInstance().getMappedElement(ecoreOwner);
            
                    if ((objingOwner instanceof IClassifier) ||  
                            ((ecoreOwner instanceof Property) && (EcoreModelNavigation.isAssocEnd((Property)ecoreOwner))))
                        result.add(this.objingModelFactory.createAttribute());
                }
            
                PartialCreationImportVisitor.this.objingElt = result;
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1645ae19-4583-11e0-b54c-00137279a832")
        public Object caseProtocolConformance(ProtocolConformance ecoreElt) {
            IDependency result = this.objingModelFactory.createDependency();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IDependency.class, XMIStereotypes.UML2PROTOCOLCONFORMANCE));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1648106e-4583-11e0-b54c-00137279a832")
        public Object caseProtocolStateMachine(ProtocolStateMachine ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createStateMachine();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("164a72c8-4583-11e0-b54c-00137279a832")
        public Object caseProtocolTransition(ProtocolTransition ecoreElt) {
            if (EcoreModelNavigation.isInternalTransition(ecoreElt)) {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInternalTransition();
            } else {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createTransition();
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("164a72ce-4583-11e0-b54c-00137279a832")
        public Object casePseudostate(Pseudostate ecoreElt) {
            switch (ecoreElt.getKind().getValue()) {
            case PseudostateKind.INITIAL:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInitialPseudoState();
            
                break;
            case PseudostateKind.DEEP_HISTORY:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createDeepHistoryPseudoState();
            
                break;
            case PseudostateKind.SHALLOW_HISTORY:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createShallowHistoryPseudoState();
            
                break;
            case PseudostateKind.JOIN:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createJoinPseudoState();
            
                break;
            case PseudostateKind.FORK:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createForkPseudoState();
            
                break;
            case PseudostateKind.JUNCTION:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createJunctionPseudoState();
            
                break;
            case PseudostateKind.CHOICE:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createChoicePseudoState();
            
                break;
            case PseudostateKind.ENTRY_POINT:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createEntryPointPseudoState();
            
                break;
            case PseudostateKind.EXIT_POINT:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createExitPointPseudoState();
            
                break;
            case PseudostateKind.TERMINATE:
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createTerminatePseudoState();
            
                break;
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("164cd522-4583-11e0-b54c-00137279a832")
        public Object caseQualifierValue(QualifierValue ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("164f377c-4583-11e0-b54c-00137279a832")
        public Object caseRaiseExceptionAction(RaiseExceptionAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("164f3782-4583-11e0-b54c-00137279a832")
        public Object caseReadExtentAction(ReadExtentAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("165199d7-4583-11e0-b54c-00137279a832")
        public Object caseReadIsClassifiedObjectAction(ReadIsClassifiedObjectAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1653fc30-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkAction(ReadLinkAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1653fc36-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkObjectEndAction(ReadLinkObjectEndAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16565e8b-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkObjectEndQualifierAction(ReadLinkObjectEndQualifierAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1658c0e4-4583-11e0-b54c-00137279a832")
        public Object caseReadSelfAction(ReadSelfAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1658c0ea-4583-11e0-b54c-00137279a832")
        public Object caseReadStructuralFeatureAction(ReadStructuralFeatureAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("165b233f-4583-11e0-b54c-00137279a832")
        public Object caseReadVariableAction(ReadVariableAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("165d8598-4583-11e0-b54c-00137279a832")
        public Object caseRealization(Realization ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("165d859e-4583-11e0-b54c-00137279a832")
        public Object caseReceiveOperationEvent(ReceiveOperationEvent ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("165fe7f4-4583-11e0-b54c-00137279a832")
        public Object caseReceiveSignalEvent(ReceiveSignalEvent ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16624a4c-4583-11e0-b54c-00137279a832")
        public Object caseReception(Reception ecoreElt) {
            Element ecoreOwner = ecoreElt.getOwner();
            Object objingOwner =  ReverseProperties.getInstance().getMappedElement(ecoreOwner);
            if ((objingOwner instanceof IClassifier)  && !(objingOwner instanceof IEnumeration)){
                IOperation operation = this.objingModelFactory.createOperation();
                try{
                    IStereotype ster = Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(IOperation.class, XMIStereotypes.UML2RECEPTION);
                    operation.addExtension(ster);
                    PartialCreationImportVisitor.this.objingElt = operation;
                }catch(StereotypeNotFoundException e){
                    e.printStackTrace(Modelio.err);
                }
            }
            PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16624a52-4583-11e0-b54c-00137279a832")
        public Object caseReclassifyObjectAction(ReclassifyObjectAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1664acab-4583-11e0-b54c-00137279a832")
        public Object caseRedefinableTemplateSignature(RedefinableTemplateSignature ecoreElt) {
            Element ecoreOwner = ecoreElt.getOwner();
            Object objingOwner =  ReverseProperties.getInstance().getMappedElement(ecoreOwner);
            if ((objingOwner instanceof IClassifier)  && !(objingOwner instanceof IEnumeration)){
            
                IOperation result = this.objingModelFactory.createOperation();
                try{
                    result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                            IOperation.class, XMIStereotypes.UML2REDEFINABLETEMPLATESIGNATURE));
                }catch(StereotypeNotFoundException e){
                    e.printStackTrace(Modelio.err);
                }
                PartialCreationImportVisitor.this.objingElt = result;
            }else 
                PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16670f00-4583-11e0-b54c-00137279a832")
        public Object caseReduceAction(ReduceAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1669715a-4583-11e0-b54c-00137279a832")
        public Object caseRegion(Region ecoreElt) {
            Element ecoreOwner = ecoreElt.getOwner();
            
            if  ( ecoreOwner instanceof StateMachine){
                PartialCreationImportVisitor.this.objingElt = ((IStateMachine) ReverseProperties.getInstance().getMappedElement(ecoreOwner)).getTop();
            }else
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createRegion();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16697160-4583-11e0-b54c-00137279a832")
        public Object caseRemoveStructuralFeatureValueAction(RemoveStructuralFeatureValueAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("166bd3b5-4583-11e0-b54c-00137279a832")
        public Object caseRemoveVariableValueAction(RemoveVariableValueAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("166e360e-4583-11e0-b54c-00137279a832")
        public Object caseReplyAction(ReplyAction ecoreElt) {
            IOpaqueAction result = this.objingModelFactory.createOpaqueAction();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IOpaqueAction.class, XMIStereotypes.UML2REPLYACTION));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("166e3614-4583-11e0-b54c-00137279a832")
        public Object caseSendObjectAction(SendObjectAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1670986c-4583-11e0-b54c-00137279a832")
        public Object caseSendOperationEvent(SendOperationEvent ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1672fac2-4583-11e0-b54c-00137279a832")
        public Object caseSendSignalAction(SendSignalAction ecoreElt) {
            // TODO assert mapping is correct
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createSendSignalAction();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16755d1c-4583-11e0-b54c-00137279a832")
        public Object caseSendSignalEvent(SendSignalEvent ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16755d22-4583-11e0-b54c-00137279a832")
        public Object caseSequenceNode(SequenceNode ecoreElt) {
            IStructuredActivityNode result =  this.objingModelFactory.createStructuredActivityNode();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IStructuredActivityNode.class, XMIStereotypes.UML2SEQUENCENODE));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1677bf77-4583-11e0-b54c-00137279a832")
        public Object caseSignal(Signal ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createSignal();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("167a21d0-4583-11e0-b54c-00137279a832")
        public Object caseSignalEvent(SignalEvent ecoreElt) {
            ecoreElt.getOwner();
            IEvent result = this.objingModelFactory.createEvent();
            result.setKind(ObEventTypeEnum.SIGNAL_EVENT);
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("167a21d6-4583-11e0-b54c-00137279a832")
        public Object caseSlot(Slot ecoreElt) {
            if (ReverseProperties.getInstance().isRoundtripEnabled()){
                if (ObjingEAnnotation.isPort(ecoreElt)){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createPort();
                    return PartialCreationImportVisitor.this.defaut;
                }else if (ObjingEAnnotation.isBindableInstance(ecoreElt)){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createBindableInstance();
                    return PartialCreationImportVisitor.this.defaut;
                }else if (ObjingEAnnotation.isConnector(ecoreElt.getOwner())){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createConnectorEnd();
                    return PartialCreationImportVisitor.this.defaut;
                }else if (ObjingEAnnotation.isLink(ecoreElt.getOwner())){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createLinkEnd();
                    return PartialCreationImportVisitor.this.defaut;
                }else if (ObjingEAnnotation.isAttributeLink(ecoreElt)){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAttributeLink();
                    return PartialCreationImportVisitor.this.defaut;
                }
            }
            
            
            Element feature = ecoreElt.getDefiningFeature();
            InstanceSpecification ecoreOwner = ecoreElt.getOwningInstance();
            
            if (feature != null){
                Object objFeature = ReverseProperties.getInstance().getMappedElement(feature);
                if  (feature instanceof Port){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createPort();
                    return PartialCreationImportVisitor.this.defaut;
                }else if (objFeature  instanceof IAttribute){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createAttributeLink();
                    return PartialCreationImportVisitor.this.defaut;
                }else if (EcoreModelNavigation.isConnector(ecoreOwner) ){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createConnectorEnd();
                    return PartialCreationImportVisitor.this.defaut;
                }else if (EcoreModelNavigation.isLink(ecoreOwner) ){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createLinkEnd();
                    return PartialCreationImportVisitor.this.defaut;
                }else if ((feature instanceof Property ) && ((Property)feature).isComposite()){
                    PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createBindableInstance();
                    return PartialCreationImportVisitor.this.defaut;
                }
            }
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createBindableInstance();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("167c842d-4583-11e0-b54c-00137279a832")
        public Object caseStartClassifierBehaviorAction(StartClassifierBehaviorAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("167ee684-4583-11e0-b54c-00137279a832")
        public Object caseState(State ecoreElt) {
            if (ecoreElt.getContainer() != null)
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createState();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("168148de-4583-11e0-b54c-00137279a832")
        public Object caseStateInvariant(StateInvariant ecoreElt) {
            // Particular case of a sequence diagram element
            //            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createStateInvariant();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("168148e4-4583-11e0-b54c-00137279a832")
        public Object caseStateMachine(StateMachine ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createStateMachine();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1683ab3d-4583-11e0-b54c-00137279a832")
        public Object caseStereotype(Stereotype ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = null;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16860d93-4583-11e0-b54c-00137279a832")
        public Object caseStringExpression(StringExpression ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16886fec-4583-11e0-b54c-00137279a832")
        public Object caseStructuredActivityNode(StructuredActivityNode ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createStructuredActivityNode();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16886ff2-4583-11e0-b54c-00137279a832")
        public Object caseSubstitution(Substitution ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createSubstitution();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("168ad24a-4583-11e0-b54c-00137279a832")
        public Object caseTemplateBinding(TemplateBinding ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createTemplateBinding();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("168d34a0-4583-11e0-b54c-00137279a832")
        public Object caseTemplateParameter(TemplateParameter ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createTemplateParameter();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("168f96fa-4583-11e0-b54c-00137279a832")
        public Object caseTemplateParameterSubstitution(TemplateParameterSubstitution ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createTemplateParameterSubstitution();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("168f9700-4583-11e0-b54c-00137279a832")
        public Object caseTemplateSignature(TemplateSignature ecoreElt) {
            if (ObjingEAnnotation.isDeleted(ecoreElt)){
                PartialCreationImportVisitor.this.objingElt = null;
            }else{
                Element ecoreOwner = ecoreElt.getOwner();
                Object objingOwner =  ReverseProperties.getInstance().getMappedElement(ecoreOwner);
                if ((objingOwner instanceof IClassifier)  && !(objingOwner instanceof IEnumeration)){
                    IOperation result = this.objingModelFactory.createOperation();
                    try{
                        result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                                IOperation.class, XMIStereotypes.UML2TEMPLATESIGNATURE));
            
                    }catch(StereotypeNotFoundException e){
                        e.printStackTrace(Modelio.err); 
            
                    }
                    PartialCreationImportVisitor.this.objingElt = result;
                }
                PartialCreationImportVisitor.this.objingElt = null;
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1691f958-4583-11e0-b54c-00137279a832")
        public Object caseTestIdentityAction(TestIdentityAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16945bae-4583-11e0-b54c-00137279a832")
        public Object caseTimeConstraint(TimeConstraint ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1696be08-4583-11e0-b54c-00137279a832")
        public Object caseTimeEvent(TimeEvent ecoreElt) {
            ecoreElt.getOwner();
            IEvent result = this.objingModelFactory.createEvent();
            result.setKind(ObEventTypeEnum.TIME_EVENT);
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("1696be0e-4583-11e0-b54c-00137279a832")
        public Object caseTimeExpression(TimeExpression ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16992065-4583-11e0-b54c-00137279a832")
        public Object caseTimeInterval(TimeInterval ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("169b82bc-4583-11e0-b54c-00137279a832")
        public Object caseTimeObservation(TimeObservation ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("169de516-4583-11e0-b54c-00137279a832")
        public Object caseTransition(Transition ecoreElt) {
            if (EcoreModelNavigation.isInternalTransition(ecoreElt)) {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createInternalTransition();
            } else {
                PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createTransition();
            }
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("169de51c-4583-11e0-b54c-00137279a832")
        public Object caseTrigger(Trigger ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16a04773-4583-11e0-b54c-00137279a832")
        public Object caseUnmarshallAction(UnmarshallAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16a2a9ca-4583-11e0-b54c-00137279a832")
        public Object caseUsage(Usage ecoreElt) {
            PartialCreationImportVisitor.this.objingElt =  new ArrayList<IModelElement>();;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16a50c24-4583-11e0-b54c-00137279a832")
        public Object caseUseCase(UseCase ecoreElt) {
            PartialCreationImportVisitor.this.objingElt = this.objingModelFactory.createUseCase();
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16a50c2a-4583-11e0-b54c-00137279a832")
        public Object caseValuePin(ValuePin ecoreElt) {
            IInputPin result = this.objingModelFactory.createInputPin();
            try{
                result.addExtension(Modelio.getInstance().getModelingSession().getMetamodelExtensions().getStereotype(
                        IInputPin.class, XMIStereotypes.UML2VALUE));
            }catch(StereotypeNotFoundException e){
                e.printStackTrace(Modelio.err);
            }
                      
            PartialCreationImportVisitor.this.objingElt = result;
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16a76e82-4583-11e0-b54c-00137279a832")
        public Object caseValueSpecificationAction(ValueSpecificationAction ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @Override
        @objid ("16a9d0d8-4583-11e0-b54c-00137279a832")
        public Object caseVariable(Variable ecoreElt) {
            // TODO map ecore to objing
            return PartialCreationImportVisitor.this.defaut;
        }

        @objid ("5d087451-5d68-11e1-bceb-0027103f347d")
        public CreationImportMapper() {
        }

    }

}
