/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.Element;

@objid ("16a9d0de-4583-11e0-b54c-00137279a832")
public class PartialImportMap {
    @objid ("16a9d0df-4583-11e0-b54c-00137279a832")
    private static PartialImportMap theSingleInstance;

    @objid ("16ac3332-4583-11e0-b54c-00137279a832")
    private Map<Element, Object> modelMap;


    @objid ("16ac3336-4583-11e0-b54c-00137279a832")
    private PartialImportMap() {
        modelMap = new HashMap<Element, Object>();
    }

    @objid ("16ac3338-4583-11e0-b54c-00137279a832")
    public static PartialImportMap getInstance() {
        if (theSingleInstance == null)
            theSingleInstance = new PartialImportMap();
        return theSingleInstance;
    }

    @objid ("16ac333c-4583-11e0-b54c-00137279a832")
    public void clear() {
        modelMap.clear();
    }

    @objid ("16ac333e-4583-11e0-b54c-00137279a832")
    public boolean containsKey(Object key) {
        return modelMap.containsKey(key);
    }

    @objid ("16ae958c-4583-11e0-b54c-00137279a832")
    public boolean containsValue(Object val) {
        return modelMap.containsValue(val);
    }

    @objid ("16ae9591-4583-11e0-b54c-00137279a832")
    public Object get(Element key) {
        return modelMap.get(key);
    }

    @objid ("16ae9596-4583-11e0-b54c-00137279a832")
    public boolean isEmpty() {
        return modelMap.isEmpty();
    }

    @objid ("16ae959a-4583-11e0-b54c-00137279a832")
    public Set<Element> keySet() {
        return modelMap.keySet();
    }

    @objid ("16b0f7ea-4583-11e0-b54c-00137279a832")
    public Object put(Element key, Object value) {
        return modelMap.put(key, value);
    }

    @objid ("16b0f7f0-4583-11e0-b54c-00137279a832")
    public Object remove(Object key) {
        return modelMap.remove(key);
    }

    @objid ("16b35a40-4583-11e0-b54c-00137279a832")
    public int size() {
        return modelMap.size();
    }

    @objid ("16b35a44-4583-11e0-b54c-00137279a832")
    public Collection<Object> values() {
        return modelMap.values();
    }

}
