/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import java.util.ArrayList;
import java.util.List;
import com.modeliosoft.modelio.api.model.IUmlModel;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.util.ReverseProperties;
import org.eclipse.uml2.uml.*;
import org.eclipse.uml2.uml.Abstraction;
import org.eclipse.uml2.uml.AcceptCallAction;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.ActionExecutionSpecification;
import org.eclipse.uml2.uml.ActionInputPin;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.ActivityFinalNode;
import org.eclipse.uml2.uml.ActivityParameterNode;
import org.eclipse.uml2.uml.ActivityPartition;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.AddStructuralFeatureValueAction;
import org.eclipse.uml2.uml.AddVariableValueAction;
import org.eclipse.uml2.uml.AnyReceiveEvent;
import org.eclipse.uml2.uml.Artifact;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.AssociationClass;
import org.eclipse.uml2.uml.BehaviorExecutionSpecification;
import org.eclipse.uml2.uml.BroadcastSignalAction;
import org.eclipse.uml2.uml.CallBehaviorAction;
import org.eclipse.uml2.uml.CallEvent;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.CentralBufferNode;
import org.eclipse.uml2.uml.ChangeEvent;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.ClassifierTemplateParameter;
import org.eclipse.uml2.uml.Clause;
import org.eclipse.uml2.uml.ClearAssociationAction;
import org.eclipse.uml2.uml.ClearStructuralFeatureAction;
import org.eclipse.uml2.uml.ClearVariableAction;
import org.eclipse.uml2.uml.Collaboration;
import org.eclipse.uml2.uml.CollaborationUse;
import org.eclipse.uml2.uml.CombinedFragment;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.CommunicationPath;
import org.eclipse.uml2.uml.Component;
import org.eclipse.uml2.uml.ComponentRealization;
import org.eclipse.uml2.uml.ConditionalNode;
import org.eclipse.uml2.uml.ConnectableElementTemplateParameter;
import org.eclipse.uml2.uml.ConnectionPointReference;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.eclipse.uml2.uml.ConsiderIgnoreFragment;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.Continuation;
import org.eclipse.uml2.uml.ControlFlow;
import org.eclipse.uml2.uml.CreateLinkAction;
import org.eclipse.uml2.uml.CreateLinkObjectAction;
import org.eclipse.uml2.uml.CreateObjectAction;
import org.eclipse.uml2.uml.CreationEvent;
import org.eclipse.uml2.uml.DataStoreNode;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.DecisionNode;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.Deployment;
import org.eclipse.uml2.uml.DeploymentSpecification;
import org.eclipse.uml2.uml.DestroyLinkAction;
import org.eclipse.uml2.uml.DestroyObjectAction;
import org.eclipse.uml2.uml.DestructionEvent;
import org.eclipse.uml2.uml.Device;
import org.eclipse.uml2.uml.Duration;
import org.eclipse.uml2.uml.DurationConstraint;
import org.eclipse.uml2.uml.DurationInterval;
import org.eclipse.uml2.uml.DurationObservation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ElementImport;
import org.eclipse.uml2.uml.Enumeration;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.ExceptionHandler;
import org.eclipse.uml2.uml.ExecutionEnvironment;
import org.eclipse.uml2.uml.ExecutionEvent;
import org.eclipse.uml2.uml.ExecutionOccurrenceSpecification;
import org.eclipse.uml2.uml.ExpansionNode;
import org.eclipse.uml2.uml.ExpansionRegion;
import org.eclipse.uml2.uml.Expression;
import org.eclipse.uml2.uml.Extend;
import org.eclipse.uml2.uml.Extension;
import org.eclipse.uml2.uml.ExtensionEnd;
import org.eclipse.uml2.uml.ExtensionPoint;
import org.eclipse.uml2.uml.FinalState;
import org.eclipse.uml2.uml.FlowFinalNode;
import org.eclipse.uml2.uml.ForkNode;
import org.eclipse.uml2.uml.FunctionBehavior;
import org.eclipse.uml2.uml.Gate;
import org.eclipse.uml2.uml.GeneralOrdering;
import org.eclipse.uml2.uml.Generalization;
import org.eclipse.uml2.uml.GeneralizationSet;
import org.eclipse.uml2.uml.Image;
import org.eclipse.uml2.uml.Include;
import org.eclipse.uml2.uml.InformationFlow;
import org.eclipse.uml2.uml.InformationItem;
import org.eclipse.uml2.uml.InitialNode;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.InstanceSpecification;
import org.eclipse.uml2.uml.InstanceValue;
import org.eclipse.uml2.uml.Interaction;
import org.eclipse.uml2.uml.InteractionConstraint;
import org.eclipse.uml2.uml.InteractionOperand;
import org.eclipse.uml2.uml.InteractionUse;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.eclipse.uml2.uml.InterruptibleActivityRegion;
import org.eclipse.uml2.uml.Interval;
import org.eclipse.uml2.uml.IntervalConstraint;
import org.eclipse.uml2.uml.JoinNode;
import org.eclipse.uml2.uml.Lifeline;
import org.eclipse.uml2.uml.LinkEndCreationData;
import org.eclipse.uml2.uml.LinkEndData;
import org.eclipse.uml2.uml.LinkEndDestructionData;
import org.eclipse.uml2.uml.LiteralBoolean;
import org.eclipse.uml2.uml.LiteralInteger;
import org.eclipse.uml2.uml.LiteralNull;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.LiteralUnlimitedNatural;
import org.eclipse.uml2.uml.LoopNode;
import org.eclipse.uml2.uml.Manifestation;
import org.eclipse.uml2.uml.MergeNode;
import org.eclipse.uml2.uml.Message;
import org.eclipse.uml2.uml.MessageOccurrenceSpecification;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.Node;
import org.eclipse.uml2.uml.ObjectFlow;
import org.eclipse.uml2.uml.OccurrenceSpecification;
import org.eclipse.uml2.uml.OpaqueAction;
import org.eclipse.uml2.uml.OpaqueBehavior;
import org.eclipse.uml2.uml.OpaqueExpression;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.OperationTemplateParameter;
import org.eclipse.uml2.uml.OutputPin;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageImport;
import org.eclipse.uml2.uml.PackageMerge;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.ParameterSet;
import org.eclipse.uml2.uml.PartDecomposition;
import org.eclipse.uml2.uml.Pin;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.PrimitiveType;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.ProfileApplication;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.ProtocolConformance;
import org.eclipse.uml2.uml.ProtocolStateMachine;
import org.eclipse.uml2.uml.ProtocolTransition;
import org.eclipse.uml2.uml.Pseudostate;
import org.eclipse.uml2.uml.QualifierValue;
import org.eclipse.uml2.uml.RaiseExceptionAction;
import org.eclipse.uml2.uml.ReadExtentAction;
import org.eclipse.uml2.uml.ReadIsClassifiedObjectAction;
import org.eclipse.uml2.uml.ReadLinkAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction;
import org.eclipse.uml2.uml.ReadSelfAction;
import org.eclipse.uml2.uml.ReadStructuralFeatureAction;
import org.eclipse.uml2.uml.ReadVariableAction;
import org.eclipse.uml2.uml.Realization;
import org.eclipse.uml2.uml.ReceiveOperationEvent;
import org.eclipse.uml2.uml.ReceiveSignalEvent;
import org.eclipse.uml2.uml.Reception;
import org.eclipse.uml2.uml.ReclassifyObjectAction;
import org.eclipse.uml2.uml.RedefinableTemplateSignature;
import org.eclipse.uml2.uml.ReduceAction;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction;
import org.eclipse.uml2.uml.RemoveVariableValueAction;
import org.eclipse.uml2.uml.ReplyAction;
import org.eclipse.uml2.uml.SendObjectAction;
import org.eclipse.uml2.uml.SendOperationEvent;
import org.eclipse.uml2.uml.SendSignalAction;
import org.eclipse.uml2.uml.SendSignalEvent;
import org.eclipse.uml2.uml.SequenceNode;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.SignalEvent;
import org.eclipse.uml2.uml.Slot;
import org.eclipse.uml2.uml.StartClassifierBehaviorAction;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateInvariant;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.StringExpression;
import org.eclipse.uml2.uml.StructuredActivityNode;
import org.eclipse.uml2.uml.Substitution;
import org.eclipse.uml2.uml.TemplateBinding;
import org.eclipse.uml2.uml.TemplateParameter;
import org.eclipse.uml2.uml.TemplateParameterSubstitution;
import org.eclipse.uml2.uml.TemplateSignature;
import org.eclipse.uml2.uml.TestIdentityAction;
import org.eclipse.uml2.uml.TimeConstraint;
import org.eclipse.uml2.uml.TimeEvent;
import org.eclipse.uml2.uml.TimeExpression;
import org.eclipse.uml2.uml.TimeInterval;
import org.eclipse.uml2.uml.TimeObservation;
import org.eclipse.uml2.uml.Transition;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.UnmarshallAction;
import org.eclipse.uml2.uml.Usage;
import org.eclipse.uml2.uml.UseCase;
import org.eclipse.uml2.uml.ValuePin;
import org.eclipse.uml2.uml.ValueSpecificationAction;
import org.eclipse.uml2.uml.Variable;
import org.eclipse.uml2.uml.util.UMLSwitch;

@objid ("16ba814e-4583-11e0-b54c-00137279a832")
public class SequenceDiagramEltCreationVisitor {
    @objid ("16ba814f-4583-11e0-b54c-00137279a832")
    private Object objingElt;

    @objid ("16ba8150-4583-11e0-b54c-00137279a832")
    private CreationImportMapper mapper;

    @objid ("16ba8151-4583-11e0-b54c-00137279a832")
    private PartialImportMap partialMap;

    @objid ("16ba8152-4583-11e0-b54c-00137279a832")
    private IUmlModel objingModelFactory = Modelio.getInstance()
			.getModelingSession().getModel();

    @objid ("6f563996-1a76-11e1-8103-0027103f347d")
    private final int defaut = 42;


    @objid ("16ba8153-4583-11e0-b54c-00137279a832")
    public SequenceDiagramEltCreationVisitor() {
        objingElt = null;
        mapper = new CreationImportMapper();
        partialMap = PartialImportMap.getInstance();
    }

    @objid ("6f5660a9-1a76-11e1-8103-0027103f347d")
    public Object createPartialIjingElt(final Element ecoreElt) {
        if (ecoreElt != null) {
            objingElt = null;
            Object objingEltFromMap = partialMap.get(ecoreElt);
            if (objingEltFromMap == null) {
                mapper.accept(ecoreElt);
                partialMap.put(ecoreElt, objingElt);
                objingEltFromMap = objingElt;
            }
            return objingEltFromMap;
        } else{
            Modelio.err.println("Ecore element is null.");
            throw new RuntimeException("Ecore element is null.");
        }
    }

    @objid ("16ba8159-4583-11e0-b54c-00137279a832")
    private class CreationImportMapper extends UMLSwitch<Object> {

        @objid ("16ba815a-4583-11e0-b54c-00137279a832")
        public void accept(Element ecoreElt) {
            doSwitch(ecoreElt);
        }

        @Override
        @objid ("16ba815d-4583-11e0-b54c-00137279a832")
        public Object caseAbstraction(Abstraction ecoreElt) {
            // objingElt = new ArrayList<IAbstraction>();
            return defaut;
        }

        @Override
        @objid ("16bce3ab-4583-11e0-b54c-00137279a832")
        public Object caseAcceptCallAction(AcceptCallAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16bce3b1-4583-11e0-b54c-00137279a832")
        public Object caseAcceptEventAction(AcceptEventAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16bf4602-4583-11e0-b54c-00137279a832")
        public Object caseActionExecutionSpecification(ActionExecutionSpecification ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createExecutionSpecification();
            return defaut;
        }

        @Override
        @objid ("16bf4608-4583-11e0-b54c-00137279a832")
        public Object caseActionInputPin(ActionInputPin ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16bf460e-4583-11e0-b54c-00137279a832")
        public Object caseActivity(Activity ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createActivity();
            return defaut;
        }

        @Override
        @objid ("16c1a85f-4583-11e0-b54c-00137279a832")
        public Object caseActivityFinalNode(ActivityFinalNode ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16c1a865-4583-11e0-b54c-00137279a832")
        public Object caseActivityParameterNode(ActivityParameterNode ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createActivityParameterNode();
            return defaut;
        }

        @Override
        @objid ("16c40ab6-4583-11e0-b54c-00137279a832")
        public Object caseActivityPartition(ActivityPartition ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createActivityPartition();
            return defaut;
        }

        @Override
        @objid ("16c40abc-4583-11e0-b54c-00137279a832")
        public Object caseActor(Actor ecoreElt) {
            // objingElt = objingModelFactory.createActor();
            return defaut;
        }

        @Override
        @objid ("16c40ac2-4583-11e0-b54c-00137279a832")
        public Object caseAddStructuralFeatureValueAction(AddStructuralFeatureValueAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16c66d14-4583-11e0-b54c-00137279a832")
        public Object caseAddVariableValueAction(AddVariableValueAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16c66d1a-4583-11e0-b54c-00137279a832")
        public Object caseAnyReceiveEvent(AnyReceiveEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16c8cf6b-4583-11e0-b54c-00137279a832")
        public Object caseArtifact(Artifact ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createArtifact();
            return defaut;
        }

        @Override
        @objid ("16c8cf71-4583-11e0-b54c-00137279a832")
        public Object caseAssociation(Association ecoreElt) {
            // objingElt = objingModelFactory.createAssociation();
            return defaut;
        }

        @Override
        @objid ("16cb31c4-4583-11e0-b54c-00137279a832")
        public Object caseAssociationClass(AssociationClass ecoreElt) {
            // // Creation of the association class
            // IClassAssociation objingClassAssociation = Modelio
            // .getInstance().getModelingSession().getModel()
            // .createClassAssociation();
            // // Creation of the Class
            // IClass objingClass = Modelio.getInstance()
            // .getModelingSession().getModel().createClass();
            // // Creation of the Association
            // IAssociation objingAssociation = Modelio.getInstance()
            // .getModelingSession().getModel().createAssociation();
            // // Set of the class and Association
            // objingClassAssociation.setClassPart(objingClass);
            // objingClassAssociation.setAssociationPart(objingAssociation);
            // objingElt = objingClass;
            return defaut;
        }

        @Override
        @objid ("16cb31ca-4583-11e0-b54c-00137279a832")
        public Object caseBehaviorExecutionSpecification(BehaviorExecutionSpecification ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createExecutionSpecification();
            return defaut;
        }

        @Override
        @objid ("16cb31d0-4583-11e0-b54c-00137279a832")
        public Object caseBroadcastSignalAction(BroadcastSignalAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16cd9422-4583-11e0-b54c-00137279a832")
        public Object caseCallBehaviorAction(CallBehaviorAction ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createCallBehaviorAction();
            return defaut;
        }

        @Override
        @objid ("16cd9428-4583-11e0-b54c-00137279a832")
        public Object caseCallEvent(CallEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16cff679-4583-11e0-b54c-00137279a832")
        public Object caseCallOperationAction(CallOperationAction ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createCallOperationAction();
            return defaut;
        }

        @Override
        @objid ("16cff67f-4583-11e0-b54c-00137279a832")
        public Object caseCentralBufferNode(CentralBufferNode ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createCentralBufferNode();
            return defaut;
        }

        @Override
        @objid ("16d258d2-4583-11e0-b54c-00137279a832")
        public Object caseChangeEvent(ChangeEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16d258d8-4583-11e0-b54c-00137279a832")
        public Object caseClass(Class ecoreElt) {
            // objingElt = objingModelFactory.createClass();
            return defaut;
        }

        @Override
        @objid ("16d4bb2c-4583-11e0-b54c-00137279a832")
        public Object caseClassifierTemplateParameter(ClassifierTemplateParameter ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16d4bb32-4583-11e0-b54c-00137279a832")
        public Object caseClause(Clause ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createClause();
            return defaut;
        }

        @Override
        @objid ("16d4bb38-4583-11e0-b54c-00137279a832")
        public Object caseClearAssociationAction(ClearAssociationAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16d71d8a-4583-11e0-b54c-00137279a832")
        public Object caseClearStructuralFeatureAction(ClearStructuralFeatureAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16d71d90-4583-11e0-b54c-00137279a832")
        public Object caseClearVariableAction(ClearVariableAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16d97fe2-4583-11e0-b54c-00137279a832")
        public Object caseCollaboration(Collaboration ecoreElt) {
            // objingElt = objingModelFactory.createCollaboration();
            return defaut;
        }

        @Override
        @objid ("16d97fe8-4583-11e0-b54c-00137279a832")
        public Object caseCollaborationUse(CollaborationUse ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createCollaborationUse();
            return defaut;
        }

        @Override
        @objid ("16dbe23b-4583-11e0-b54c-00137279a832")
        public Object caseCombinedFragment(CombinedFragment ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createCombinedFragment();
            return defaut;
        }

        @Override
        @objid ("16dbe241-4583-11e0-b54c-00137279a832")
        public Object caseComment(Comment ecoreElt) {
            // objingElt = new ArrayList<INote>();
            return defaut;
        }

        @Override
        @objid ("16de4494-4583-11e0-b54c-00137279a832")
        public Object caseCommunicationPath(CommunicationPath ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16de449a-4583-11e0-b54c-00137279a832")
        public Object caseComponent(Component ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createComponent();
            return defaut;
        }

        @Override
        @objid ("16e0a6ee-4583-11e0-b54c-00137279a832")
        public Object caseComponentRealization(ComponentRealization ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16e0a6f4-4583-11e0-b54c-00137279a832")
        public Object caseConditionalNode(ConditionalNode ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createConditionalNode();
            return defaut;
        }

        @Override
        @objid ("16e30948-4583-11e0-b54c-00137279a832")
        public Object caseConnectableElementTemplateParameter(ConnectableElementTemplateParameter ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16e3094e-4583-11e0-b54c-00137279a832")
        public Object caseConnectionPointReference(ConnectionPointReference ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createConnectionPointReference();
            return defaut;
        }

        @Override
        @objid ("16e30954-4583-11e0-b54c-00137279a832")
        public Object caseConnector(Connector ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createConnector();
            return defaut;
        }

        @Override
        @objid ("16e56ba6-4583-11e0-b54c-00137279a832")
        public Object caseConnectorEnd(ConnectorEnd ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createConnectorEnd();
            return defaut;
        }

        @Override
        @objid ("16e56bac-4583-11e0-b54c-00137279a832")
        public Object caseConsiderIgnoreFragment(ConsiderIgnoreFragment ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createCombinedFragment();
            return defaut;
        }

        @Override
        @objid ("16e7ce00-4583-11e0-b54c-00137279a832")
        public Object caseConstraint(Constraint ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createConstraint();
            return defaut;
        }

        @Override
        @objid ("16e7ce06-4583-11e0-b54c-00137279a832")
        public Object caseContinuation(Continuation ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16ea305a-4583-11e0-b54c-00137279a832")
        public Object caseControlFlow(ControlFlow ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createControlFlow();
            return defaut;
        }

        @Override
        @objid ("16ea3060-4583-11e0-b54c-00137279a832")
        public Object caseCreateLinkAction(CreateLinkAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16ec92b1-4583-11e0-b54c-00137279a832")
        public Object caseCreateLinkObjectAction(CreateLinkObjectAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16ec92b7-4583-11e0-b54c-00137279a832")
        public Object caseCreateObjectAction(CreateObjectAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16eef50b-4583-11e0-b54c-00137279a832")
        public Object caseCreationEvent(CreationEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16f15764-4583-11e0-b54c-00137279a832")
        public Object caseDataStoreNode(DataStoreNode ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createDataStoreNode();
            return defaut;
        }

        @Override
        @objid ("16f1576a-4583-11e0-b54c-00137279a832")
        public Object caseDataType(DataType ecoreElt) {
            // if (!(ecoreElt instanceof PrimitiveType))
            // objingElt = objingModelFactory.createDataType();
            return defaut;
        }

        @Override
        @objid ("16f3b9be-4583-11e0-b54c-00137279a832")
        public Object caseDecisionNode(DecisionNode ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16f3b9c4-4583-11e0-b54c-00137279a832")
        public Object caseDependency(Dependency ecoreElt) {
            // objingElt = new ArrayList<IDependency>();
            return defaut;
        }

        @Override
        @objid ("16f61c18-4583-11e0-b54c-00137279a832")
        public Object caseDeployment(Deployment ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16f61c1e-4583-11e0-b54c-00137279a832")
        public Object caseDeploymentSpecification(DeploymentSpecification ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16f87e72-4583-11e0-b54c-00137279a832")
        public Object caseDestroyLinkAction(DestroyLinkAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16f87e78-4583-11e0-b54c-00137279a832")
        public Object caseDestroyObjectAction(DestroyObjectAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16fae0cc-4583-11e0-b54c-00137279a832")
        public Object caseDestructionEvent(DestructionEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16fae0d2-4583-11e0-b54c-00137279a832")
        public Object caseDevice(Device ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16fd4326-4583-11e0-b54c-00137279a832")
        public Object caseDuration(Duration ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16fd432c-4583-11e0-b54c-00137279a832")
        public Object caseDurationConstraint(DurationConstraint ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createDurationConstraint();
            return defaut;
        }

        @Override
        @objid ("16ffa580-4583-11e0-b54c-00137279a832")
        public Object caseDurationInterval(DurationInterval ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("16ffa586-4583-11e0-b54c-00137279a832")
        public Object caseDurationObservation(DurationObservation ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("170207db-4583-11e0-b54c-00137279a832")
        public Object caseElementImport(ElementImport ecoreElt) {
            // objingElt = objingModelFactory.createElementImport();
            return defaut;
        }

        @Override
        @objid ("170207e1-4583-11e0-b54c-00137279a832")
        public Object caseEnumeration(Enumeration ecoreElt) {
            // objingElt = objingModelFactory.createEnumeration();
            return defaut;
        }

        @Override
        @objid ("17046a35-4583-11e0-b54c-00137279a832")
        public Object caseEnumerationLiteral(EnumerationLiteral ecoreElt) {
            // objingElt = objingModelFactory.createEnumerationLiteral();
            return defaut;
        }

        @Override
        @objid ("17046a3b-4583-11e0-b54c-00137279a832")
        public Object caseExceptionHandler(ExceptionHandler ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1706cc8f-4583-11e0-b54c-00137279a832")
        public Object caseExecutionEnvironment(ExecutionEnvironment ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1706cc95-4583-11e0-b54c-00137279a832")
        public Object caseExecutionEvent(ExecutionEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17092eec-4583-11e0-b54c-00137279a832")
        public Object caseExecutionOccurrenceSpecification(ExecutionOccurrenceSpecification ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory
                    .createExecutionOccurenceSpecification();
            return defaut;
        }

        @Override
        @objid ("17092ef2-4583-11e0-b54c-00137279a832")
        public Object caseExpansionNode(ExpansionNode ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("170b9146-4583-11e0-b54c-00137279a832")
        public Object caseExpansionRegion(ExpansionRegion ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("170b914c-4583-11e0-b54c-00137279a832")
        public Object caseExpression(Expression ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("170df3a0-4583-11e0-b54c-00137279a832")
        public Object caseExtend(Extend ecoreElt) {
            // objingElt = objingModelFactory.createUseCaseDependency();
            return defaut;
        }

        @Override
        @objid ("171055f6-4583-11e0-b54c-00137279a832")
        public Object caseExtension(Extension ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("171055fc-4583-11e0-b54c-00137279a832")
        public Object caseExtensionEnd(ExtensionEnd ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1712b850-4583-11e0-b54c-00137279a832")
        public Object caseExtensionPoint(ExtensionPoint ecoreElt) {
            // objingElt = objingModelFactory.createExtensionPoint();
            return defaut;
        }

        @Override
        @objid ("1712b856-4583-11e0-b54c-00137279a832")
        public Object caseFinalState(FinalState ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17151aaa-4583-11e0-b54c-00137279a832")
        public Object caseFlowFinalNode(FlowFinalNode ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createFlowFinalNode();
            return defaut;
        }

        @Override
        @objid ("17151ab0-4583-11e0-b54c-00137279a832")
        public Object caseForkNode(ForkNode ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17177d05-4583-11e0-b54c-00137279a832")
        public Object caseFunctionBehavior(FunctionBehavior ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17177d0b-4583-11e0-b54c-00137279a832")
        public Object caseGate(Gate ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createGate();
            return defaut;
        }

        @Override
        @objid ("1719df62-4583-11e0-b54c-00137279a832")
        public Object caseGeneralOrdering(GeneralOrdering ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createGeneralOrdering();
            return defaut;
        }

        @Override
        @objid ("1719df68-4583-11e0-b54c-00137279a832")
        public Object caseGeneralization(Generalization ecoreElt) {
            // objingElt = objingModelFactory.createGeneralization();
            return defaut;
        }

        @Override
        @objid ("171c41bd-4583-11e0-b54c-00137279a832")
        public Object caseGeneralizationSet(GeneralizationSet ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("171ea412-4583-11e0-b54c-00137279a832")
        public Object caseImage(Image ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("171ea418-4583-11e0-b54c-00137279a832")
        public Object caseInclude(Include ecoreElt) {
            // objingElt = objingModelFactory.createUseCaseDependency();
            return defaut;
        }

        @Override
        @objid ("1721066c-4583-11e0-b54c-00137279a832")
        public Object caseInformationFlow(InformationFlow ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createInformationFlow();
            return defaut;
        }

        @Override
        @objid ("17210672-4583-11e0-b54c-00137279a832")
        public Object caseInformationItem(InformationItem ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("172368c7-4583-11e0-b54c-00137279a832")
        public Object caseInitialNode(InitialNode ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createInitialNode();
            return defaut;
        }

        @Override
        @objid ("172368cd-4583-11e0-b54c-00137279a832")
        public Object caseInputPin(InputPin ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createInputPin();
            return defaut;
        }

        @Override
        @objid ("1725cb24-4583-11e0-b54c-00137279a832")
        public Object caseInstanceSpecification(InstanceSpecification ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17282d7a-4583-11e0-b54c-00137279a832")
        public Object caseInstanceValue(InstanceValue ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17282d80-4583-11e0-b54c-00137279a832")
        public Object caseInteraction(Interaction ecoreElt) {
            // objingElt = objingModelFactory.createInteraction();
            return defaut;
        }

        @Override
        @objid ("172a8fd4-4583-11e0-b54c-00137279a832")
        public Object caseInteractionConstraint(InteractionConstraint ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("172a8fda-4583-11e0-b54c-00137279a832")
        public Object caseInteractionOperand(InteractionOperand ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createInteractionOperand();
            return defaut;
        }

        @Override
        @objid ("172cf22f-4583-11e0-b54c-00137279a832")
        public Object caseInteractionUse(InteractionUse ecoreElt) {
            ReverseProperties revProp = ReverseProperties.getInstance();
            List<ILifeline> oCoveredList = new ArrayList<ILifeline>();
            
            for (Object eCoveredLL : ecoreElt.getCovereds()) {
                ILifeline oCoveredLL = (ILifeline) revProp.getMappedElement((Lifeline) eCoveredLL);
            
                if (oCoveredLL != null)
                    oCoveredList.add(oCoveredLL);
            }
            
            if (oCoveredList.size() > 0) {
                 objingElt = objingModelFactory.createInteractionUse();
            }
             objingElt = null;
            return defaut;
        }

        @Override
        @objid ("172cf235-4583-11e0-b54c-00137279a832")
        public Object caseInterface(Interface ecoreElt) {
            // objingElt = objingModelFactory.createInterface();
            return defaut;
        }

        @Override
        @objid ("172f548c-4583-11e0-b54c-00137279a832")
        public Object caseInterfaceRealization(InterfaceRealization ecoreElt) {
            // objingElt = objingModelFactory.createInterfaceRealization();
            return defaut;
        }

        @Override
        @objid ("1731b6e2-4583-11e0-b54c-00137279a832")
        public Object caseInterruptibleActivityRegion(InterruptibleActivityRegion ecoreElt) {
            // TODO assert mapping is correct
            // objingElt =
            // objingModelFactory.createInterruptibleActivityRegion();
            return defaut;
        }

        @Override
        @objid ("1731b6e8-4583-11e0-b54c-00137279a832")
        public Object caseInterval(Interval ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1734193c-4583-11e0-b54c-00137279a832")
        public Object caseIntervalConstraint(IntervalConstraint ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17341942-4583-11e0-b54c-00137279a832")
        public Object caseJoinNode(JoinNode ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17367b98-4583-11e0-b54c-00137279a832")
        public Object caseLifeline(Lifeline ecoreElt) {
            // Particular case of a sequence diagram element
            // objingElt = objingModelFactory.createLifeline();
            return defaut;
        }

        @Override
        @objid ("1738ddf0-4583-11e0-b54c-00137279a832")
        public Object caseLinkEndCreationData(LinkEndCreationData ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1738ddf6-4583-11e0-b54c-00137279a832")
        public Object caseLinkEndData(LinkEndData ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("173b404a-4583-11e0-b54c-00137279a832")
        public Object caseLinkEndDestructionData(LinkEndDestructionData ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("173b4050-4583-11e0-b54c-00137279a832")
        public Object caseLiteralBoolean(LiteralBoolean ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("173da2a5-4583-11e0-b54c-00137279a832")
        public Object caseLiteralInteger(LiteralInteger ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("173da2ab-4583-11e0-b54c-00137279a832")
        public Object caseLiteralNull(LiteralNull ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17400503-4583-11e0-b54c-00137279a832")
        public Object caseLiteralString(LiteralString ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17426758-4583-11e0-b54c-00137279a832")
        public Object caseLiteralUnlimitedNatural(LiteralUnlimitedNatural ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1742675e-4583-11e0-b54c-00137279a832")
        public Object caseLoopNode(LoopNode ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createLoopNode();
            return defaut;
        }

        @Override
        @objid ("1744c9b3-4583-11e0-b54c-00137279a832")
        public Object caseManifestation(Manifestation ecoreElt) {
            // objingElt = new ArrayList<IManifestation>();
            return defaut;
        }

        @Override
        @objid ("17472c0c-4583-11e0-b54c-00137279a832")
        public Object caseMergeNode(MergeNode ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17472c12-4583-11e0-b54c-00137279a832")
        public Object caseMessage(Message ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createMessage();
            return defaut;
        }

        @Override
        @objid ("17498e66-4583-11e0-b54c-00137279a832")
        public Object caseMessageOccurrenceSpecification(MessageOccurrenceSpecification ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory
                    .createExecutionOccurenceSpecification();
            return defaut;
        }

        @Override
        @objid ("17498e6c-4583-11e0-b54c-00137279a832")
        public Object caseModel(Model ecoreElt) {
            // TODO map ecore to objing
            // if (externalElementsPkg == null) {
            // externalElementsPkg = objingModelFactory.createPackage();
            // externalElementsPkg.setName("External");
            // externalElementsPkg.setOwner(objingModelFactory.getRoot());
            // }
            // objingElt = externalElementsPkg;
            return defaut;
        }

        @Override
        @objid ("174bf0c4-4583-11e0-b54c-00137279a832")
        public Object caseNode(Node ecoreElt) {
            // objingElt = objingModelFactory.createNode();
            return defaut;
        }

        @Override
        @objid ("174e531a-4583-11e0-b54c-00137279a832")
        public Object caseObjectFlow(ObjectFlow ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createObjectFlow();
            return defaut;
        }

        @Override
        @objid ("174e5320-4583-11e0-b54c-00137279a832")
        public Object caseOccurrenceSpecification(OccurrenceSpecification ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory
                    .createExecutionOccurenceSpecification();
            return defaut;
        }

        @Override
        @objid ("1750b575-4583-11e0-b54c-00137279a832")
        public Object caseOpaqueAction(OpaqueAction ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createOpaqueAction();
            return defaut;
        }

        @Override
        @objid ("175317ce-4583-11e0-b54c-00137279a832")
        public Object caseOpaqueBehavior(OpaqueBehavior ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createOpaqueBehavior();
            return defaut;
        }

        @Override
        @objid ("175317d4-4583-11e0-b54c-00137279a832")
        public Object caseOpaqueExpression(OpaqueExpression ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17557a2c-4583-11e0-b54c-00137279a832")
        public Object caseOperation(Operation ecoreElt) {
            // objingElt = objingModelFactory.createOperation();
            return defaut;
        }

        @Override
        @objid ("1757dc82-4583-11e0-b54c-00137279a832")
        public Object caseOperationTemplateParameter(OperationTemplateParameter ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1757dc88-4583-11e0-b54c-00137279a832")
        public Object caseOutputPin(OutputPin ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createOutputPin();
            return defaut;
        }

        @Override
        @objid ("175a3edd-4583-11e0-b54c-00137279a832")
        public Object casePackage(Package ecoreElt) {
            // objingElt = objingModelFactory.createPackage();
            return defaut;
        }

        @Override
        @objid ("175ca136-4583-11e0-b54c-00137279a832")
        public Object casePackageImport(PackageImport ecoreElt) {
            // objingElt = objingModelFactory.createPackageImport();
            return defaut;
        }

        @Override
        @objid ("175ca13c-4583-11e0-b54c-00137279a832")
        public Object casePackageMerge(PackageMerge ecoreElt) {
            // objingElt = objingModelFactory.createPackageMerge();
            return defaut;
        }

        @Override
        @objid ("175f0391-4583-11e0-b54c-00137279a832")
        public Object caseParameter(Parameter ecoreElt) {
            // objingElt = objingModelFactory.createParameter();
            return defaut;
        }

        @Override
        @objid ("176165ea-4583-11e0-b54c-00137279a832")
        public Object caseParameterSet(ParameterSet ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("176165f0-4583-11e0-b54c-00137279a832")
        public Object casePartDecomposition(PartDecomposition ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createPartDecomposition();
            return defaut;
        }

        @Override
        @objid ("1763c844-4583-11e0-b54c-00137279a832")
        public Object casePin(Pin ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1763c84a-4583-11e0-b54c-00137279a832")
        public Object casePort(Port ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createPort();
            return defaut;
        }

        @Override
        @objid ("17662aa3-4583-11e0-b54c-00137279a832")
        public Object casePrimitiveType(PrimitiveType ecoreElt) {
            // IDataType primitiveType = ObjingModelNavigation
            // .getPrimitiveType(ecoreElt);
            //
            // if (primitiveType == null)
            // objingElt = objingModelFactory.getUmlTypes().UNDEFINED;
            return defaut;
        }

        @Override
        @objid ("17688cf8-4583-11e0-b54c-00137279a832")
        public Object caseProfile(Profile ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17688cfe-4583-11e0-b54c-00137279a832")
        public Object caseProfileApplication(ProfileApplication ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("176aef56-4583-11e0-b54c-00137279a832")
        public Object caseProperty(Property ecoreElt) {
            // if (ecoreElt.getAssociation() != null)
            // objingElt = objingModelFactory.createAssociationEnd();
            // else
            // objingElt = objingModelFactory.createAttribute();
            return defaut;
        }

        @Override
        @objid ("176d51ac-4583-11e0-b54c-00137279a832")
        public Object caseProtocolConformance(ProtocolConformance ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("176d51b2-4583-11e0-b54c-00137279a832")
        public Object caseProtocolStateMachine(ProtocolStateMachine ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("176fb40a-4583-11e0-b54c-00137279a832")
        public Object caseProtocolTransition(ProtocolTransition ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17721660-4583-11e0-b54c-00137279a832")
        public Object casePseudostate(Pseudostate ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17721666-4583-11e0-b54c-00137279a832")
        public Object caseQualifierValue(QualifierValue ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("177478be-4583-11e0-b54c-00137279a832")
        public Object caseRaiseExceptionAction(RaiseExceptionAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1776db14-4583-11e0-b54c-00137279a832")
        public Object caseReadExtentAction(ReadExtentAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1776db1a-4583-11e0-b54c-00137279a832")
        public Object caseReadIsClassifiedObjectAction(ReadIsClassifiedObjectAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17793d73-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkAction(ReadLinkAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("177b9fc8-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkObjectEndAction(ReadLinkObjectEndAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("177e0222-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkObjectEndQualifierAction(ReadLinkObjectEndQualifierAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("177e0228-4583-11e0-b54c-00137279a832")
        public Object caseReadSelfAction(ReadSelfAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1780647c-4583-11e0-b54c-00137279a832")
        public Object caseReadStructuralFeatureAction(ReadStructuralFeatureAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1782c6d6-4583-11e0-b54c-00137279a832")
        public Object caseReadVariableAction(ReadVariableAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1782c6dc-4583-11e0-b54c-00137279a832")
        public Object caseRealization(Realization ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17852931-4583-11e0-b54c-00137279a832")
        public Object caseReceiveOperationEvent(ReceiveOperationEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17878b8a-4583-11e0-b54c-00137279a832")
        public Object caseReceiveSignalEvent(ReceiveSignalEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17878b90-4583-11e0-b54c-00137279a832")
        public Object caseReception(Reception ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1789ede8-4583-11e0-b54c-00137279a832")
        public Object caseReclassifyObjectAction(ReclassifyObjectAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("178c503e-4583-11e0-b54c-00137279a832")
        public Object caseRedefinableTemplateSignature(RedefinableTemplateSignature ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("178c5044-4583-11e0-b54c-00137279a832")
        public Object caseReduceAction(ReduceAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("178eb29c-4583-11e0-b54c-00137279a832")
        public Object caseRegion(Region ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("179114f2-4583-11e0-b54c-00137279a832")
        public Object caseRemoveStructuralFeatureValueAction(RemoveStructuralFeatureValueAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1793774c-4583-11e0-b54c-00137279a832")
        public Object caseRemoveVariableValueAction(RemoveVariableValueAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17937752-4583-11e0-b54c-00137279a832")
        public Object caseReplyAction(ReplyAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("1795d9a7-4583-11e0-b54c-00137279a832")
        public Object caseSendObjectAction(SendObjectAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17983c00-4583-11e0-b54c-00137279a832")
        public Object caseSendOperationEvent(SendOperationEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17983c06-4583-11e0-b54c-00137279a832")
        public Object caseSendSignalAction(SendSignalAction ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createSendSignalAction();
            return defaut;
        }

        @Override
        @objid ("179a9e5d-4583-11e0-b54c-00137279a832")
        public Object caseSendSignalEvent(SendSignalEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("179d00b4-4583-11e0-b54c-00137279a832")
        public Object caseSequenceNode(SequenceNode ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("179f630e-4583-11e0-b54c-00137279a832")
        public Object caseSignal(Signal ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createSignal();
            return defaut;
        }

        @Override
        @objid ("17a1c568-4583-11e0-b54c-00137279a832")
        public Object caseSignalEvent(SignalEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17a1c56e-4583-11e0-b54c-00137279a832")
        public Object caseSlot(Slot ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17a427c3-4583-11e0-b54c-00137279a832")
        public Object caseStartClassifierBehaviorAction(StartClassifierBehaviorAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17a68a1c-4583-11e0-b54c-00137279a832")
        public Object caseState(State ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createState();
            return defaut;
        }

        @Override
        @objid ("17a68a22-4583-11e0-b54c-00137279a832")
        public Object caseStateInvariant(StateInvariant ecoreElt) {
            // Particular case of a sequence diagram element
            objingElt = objingModelFactory.createStateInvariant();
            return defaut;
        }

        @Override
        @objid ("17a8ec7a-4583-11e0-b54c-00137279a832")
        public Object caseStateMachine(StateMachine ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createStateMachine();
            return defaut;
        }

        @Override
        @objid ("17ab4ed1-4583-11e0-b54c-00137279a832")
        public Object caseStereotype(Stereotype ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17adb12a-4583-11e0-b54c-00137279a832")
        public Object caseStringExpression(StringExpression ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17adb130-4583-11e0-b54c-00137279a832")
        public Object caseStructuredActivityNode(StructuredActivityNode ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createStructuredActivityNode();
            return defaut;
        }

        @Override
        @objid ("17b01388-4583-11e0-b54c-00137279a832")
        public Object caseSubstitution(Substitution ecoreElt) {
            // objingElt = objingModelFactory.createSubstitution();
            return defaut;
        }

        @Override
        @objid ("17b275de-4583-11e0-b54c-00137279a832")
        public Object caseTemplateBinding(TemplateBinding ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createTemplateBinding();
            return defaut;
        }

        @Override
        @objid ("17b4d838-4583-11e0-b54c-00137279a832")
        public Object caseTemplateParameter(TemplateParameter ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createTemplateParameter();
            return defaut;
        }

        @Override
        @objid ("17b4d83e-4583-11e0-b54c-00137279a832")
        public Object caseTemplateParameterSubstitution(TemplateParameterSubstitution ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory
            // .createTemplateParameterSubstitution();
            return defaut;
        }

        @Override
        @objid ("17b73a94-4583-11e0-b54c-00137279a832")
        public Object caseTemplateSignature(TemplateSignature ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17b99cec-4583-11e0-b54c-00137279a832")
        public Object caseTestIdentityAction(TestIdentityAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17bbff46-4583-11e0-b54c-00137279a832")
        public Object caseTimeConstraint(TimeConstraint ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17bbff4c-4583-11e0-b54c-00137279a832")
        public Object caseTimeEvent(TimeEvent ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17be61a2-4583-11e0-b54c-00137279a832")
        public Object caseTimeExpression(TimeExpression ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17c0c3fa-4583-11e0-b54c-00137279a832")
        public Object caseTimeInterval(TimeInterval ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17c32654-4583-11e0-b54c-00137279a832")
        public Object caseTimeObservation(TimeObservation ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17c3265a-4583-11e0-b54c-00137279a832")
        public Object caseTransition(Transition ecoreElt) {
            // TODO assert mapping is correct
            // objingElt = objingModelFactory.createTransition();
            return defaut;
        }

        @Override
        @objid ("17c588b0-4583-11e0-b54c-00137279a832")
        public Object caseTrigger(Trigger ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17c7eb08-4583-11e0-b54c-00137279a832")
        public Object caseUnmarshallAction(UnmarshallAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17ca4d62-4583-11e0-b54c-00137279a832")
        public Object caseUsage(Usage ecoreElt) {
            // objingElt = new ArrayList<IUsage>();
            return defaut;
        }

        @Override
        @objid ("17ca4d68-4583-11e0-b54c-00137279a832")
        public Object caseUseCase(UseCase ecoreElt) {
            // objingElt = objingModelFactory.createUseCase();
            return defaut;
        }

        @Override
        @objid ("17ccafc0-4583-11e0-b54c-00137279a832")
        public Object caseValuePin(ValuePin ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17cf1216-4583-11e0-b54c-00137279a832")
        public Object caseValueSpecificationAction(ValueSpecificationAction ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

        @Override
        @objid ("17d17470-4583-11e0-b54c-00137279a832")
        public Object caseVariable(Variable ecoreElt) {
            // TODO map ecore to objing
            return defaut;
        }

    }

}
