/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.ActionExecutionSpecificationImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.BehaviorExecutionSpecificationImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.CombinedFragmentImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.ConsiderIgnoreFragmentImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.ContinuationImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.ExecutionOccurrenceSpecificationImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.ExecutionSpecificationImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.GateImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.InteractionOperandImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.InteractionUseImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.MessageImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.MessageOccurrenceSpecificationImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.OccurrenceSpecificationImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.PartDecompositionImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.SequenceElementImportMapper;
import com.modeliosoft.modelio.xmi.model.ecore.sequence.StateInvariantImportMapper;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.ActionExecutionSpecification;
import org.eclipse.uml2.uml.BehaviorExecutionSpecification;
import org.eclipse.uml2.uml.CombinedFragment;
import org.eclipse.uml2.uml.ConsiderIgnoreFragment;
import org.eclipse.uml2.uml.Continuation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ExecutionOccurrenceSpecification;
import org.eclipse.uml2.uml.ExecutionSpecification;
import org.eclipse.uml2.uml.Gate;
import org.eclipse.uml2.uml.Interaction;
import org.eclipse.uml2.uml.InteractionOperand;
import org.eclipse.uml2.uml.InteractionUse;
import org.eclipse.uml2.uml.Message;
import org.eclipse.uml2.uml.MessageOccurrenceSpecification;
import org.eclipse.uml2.uml.OccurrenceSpecification;
import org.eclipse.uml2.uml.PartDecomposition;
import org.eclipse.uml2.uml.StateInvariant;
import org.eclipse.uml2.uml.util.UMLSwitch;

@objid ("17d17476-4583-11e0-b54c-00137279a832")
public class SequenceElementVisitor {
    @objid ("17d17477-4583-11e0-b54c-00137279a832")
    private SequenceElementImportMapper mapper;

    @objid ("17d17478-4583-11e0-b54c-00137279a832")
    private SequenceElementMappingSelector selector;


    @objid ("17d17479-4583-11e0-b54c-00137279a832")
    public SequenceElementVisitor() {
        selector = new SequenceElementMappingSelector();
    }

    @objid ("17d3d6ca-4583-11e0-b54c-00137279a832")
    public SequenceElementImportMapper getSequenceImportMapper(Element eltToMap) {
        mapper = null;
        selector.doSwitch(eltToMap);
        return mapper;
    }

    @objid ("17d3d6cf-4583-11e0-b54c-00137279a832")
    private class SequenceElementMappingSelector extends UMLSwitch<Object> {
        @objid ("af029ae8-2b14-11e1-8e26-0027103f347d")
        private static final int result = 42;


        @Override
        @objid ("17d3d6d0-4583-11e0-b54c-00137279a832")
        public Object doSwitch(EObject inputElement) {
            if (inputElement != null)
                return super.doSwitch(inputElement);
            else
                return null;
        }

        @Override
        @objid ("17d3d6d5-4583-11e0-b54c-00137279a832")
        public Object caseActionExecutionSpecification(ActionExecutionSpecification element) {
            mapper = new ActionExecutionSpecificationImportMapper(element);
            return result;
        }

        @Override
        @objid ("17d63925-4583-11e0-b54c-00137279a832")
        public Object caseBehaviorExecutionSpecification(BehaviorExecutionSpecification element) {
            mapper = new BehaviorExecutionSpecificationImportMapper(element);
            return result;
        }

        @Override
        @objid ("17d6392b-4583-11e0-b54c-00137279a832")
        public Object caseCombinedFragment(CombinedFragment element) {
            mapper = new CombinedFragmentImportMapper(element);
            return result;
        }

        @Override
        @objid ("17d63931-4583-11e0-b54c-00137279a832")
        public Object caseConsiderIgnoreFragment(ConsiderIgnoreFragment element) {
            mapper = new ConsiderIgnoreFragmentImportMapper(element);
            return result;
        }

        @Override
        @objid ("17d89b82-4583-11e0-b54c-00137279a832")
        public Object caseContinuation(Continuation element) {
            mapper = new ContinuationImportMapper(element);
            return result;
        }

        @Override
        @objid ("17d89b88-4583-11e0-b54c-00137279a832")
        public Object caseExecutionOccurrenceSpecification(ExecutionOccurrenceSpecification element) {
            mapper = new ExecutionOccurrenceSpecificationImportMapper(element);
            return result;
        }

        @Override
        @objid ("17dafdd9-4583-11e0-b54c-00137279a832")
        public Object caseExecutionSpecification(ExecutionSpecification element) {
            mapper = new ExecutionSpecificationImportMapper(element);
            return result;
        }

        @Override
        @objid ("17dafddf-4583-11e0-b54c-00137279a832")
        public Object caseGate(Gate element) {
            mapper = new GateImportMapper(element);
            return result;
        }

        @Override
        @objid ("17dafde5-4583-11e0-b54c-00137279a832")
        public Object caseInteraction(Interaction element) {
            // mapper = new InteractionImportMapper(element);
            return result;
        }

        @Override
        @objid ("17dd6037-4583-11e0-b54c-00137279a832")
        public Object caseInteractionOperand(InteractionOperand element) {
            mapper = new InteractionOperandImportMapper(element);
            return result;
        }

        @Override
        @objid ("17dd603d-4583-11e0-b54c-00137279a832")
        public Object caseInteractionUse(InteractionUse element) {
            mapper = new InteractionUseImportMapper(element);
            return result;
        }

        @Override
        @objid ("17dfc28d-4583-11e0-b54c-00137279a832")
        public Object caseMessage(Message element) {
            mapper = new MessageImportMapper(element);
            return result;
        }

        @Override
        @objid ("17dfc293-4583-11e0-b54c-00137279a832")
        public Object caseMessageOccurrenceSpecification(MessageOccurrenceSpecification element) {
            mapper = new MessageOccurrenceSpecificationImportMapper(element);
            return result;
        }

        @Override
        @objid ("17e224e6-4583-11e0-b54c-00137279a832")
        public Object caseOccurrenceSpecification(OccurrenceSpecification element) {
            mapper = new OccurrenceSpecificationImportMapper(element);
            return result;
        }

        @Override
        @objid ("17e224ec-4583-11e0-b54c-00137279a832")
        public Object casePartDecomposition(PartDecomposition element) {
            mapper = new PartDecompositionImportMapper(element);
            return result;
        }

        @Override
        @objid ("17e224f2-4583-11e0-b54c-00137279a832")
        public Object caseStateInvariant(StateInvariant element) {
            mapper = new StateInvariantImportMapper(element);
            return result;
        }

    }

}
