/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

@objid ("17e48744-4583-11e0-b54c-00137279a832")
public class TotalImportMap {
    @objid ("17e48745-4583-11e0-b54c-00137279a832")
    private static TotalImportMap theSingleInstance;

    @objid ("17e48746-4583-11e0-b54c-00137279a832")
    private Map<Object, Object> modelMap;


    @objid ("17e4874a-4583-11e0-b54c-00137279a832")
    private TotalImportMap() {
        modelMap = new HashMap<Object, Object>();
    }

    @objid ("17e4874c-4583-11e0-b54c-00137279a832")
    public static TotalImportMap getInstance() {
        if (theSingleInstance == null)
            theSingleInstance = new TotalImportMap();
        return theSingleInstance;
    }

    @objid ("17e6e99b-4583-11e0-b54c-00137279a832")
    public void clear() {
        modelMap.clear();
    }

    @objid ("17e6e99d-4583-11e0-b54c-00137279a832")
    public boolean containsKey(Object key) {
        return modelMap.containsKey(key);
    }

    @objid ("17e6e9a2-4583-11e0-b54c-00137279a832")
    public boolean containsValue(Object val) {
        return modelMap.containsValue(val);
    }

    @objid ("17e6e9a7-4583-11e0-b54c-00137279a832")
    public Object get(Object key) {
        return modelMap.get(key);
    }

    @objid ("17e94bf5-4583-11e0-b54c-00137279a832")
    public boolean isEmpty() {
        return modelMap.isEmpty();
    }

    @objid ("17e94bf9-4583-11e0-b54c-00137279a832")
    public Set<Object> keySet() {
        return modelMap.keySet();
    }

    @objid ("17e94bff-4583-11e0-b54c-00137279a832")
    public Object put(Object key, Object value) {
        return modelMap.put(key, value);
    }

    @objid ("17ebae4f-4583-11e0-b54c-00137279a832")
    public Object remove(Object key) {
        return modelMap.remove(key);
    }

    @objid ("17ebae54-4583-11e0-b54c-00137279a832")
    public int size() {
        return modelMap.size();
    }

    @objid ("17ebae58-4583-11e0-b54c-00137279a832")
    public Collection<Object> values() {
        return modelMap.values();
    }

}
