/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import com.modeliosoft.modelio.api.model.analyst.IDictionary;
import com.modeliosoft.modelio.api.model.analyst.IEnumeratedPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IProperty;
import com.modeliosoft.modelio.api.model.analyst.IPropertyEnumerationLitteral;
import com.modeliosoft.modelio.api.model.analyst.IPropertySet;
import com.modeliosoft.modelio.api.model.analyst.IPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValue;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValueSet;
import com.modeliosoft.modelio.api.model.analyst.IRequirement;
import com.modeliosoft.modelio.api.model.analyst.IRequirementContainer;
import com.modeliosoft.modelio.api.model.analyst.IRequirementElement;
import com.modeliosoft.modelio.api.model.analyst.ITerm;
import com.modeliosoft.modelio.api.model.extension.IProject;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptCallEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptChangeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptTimeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityParameterNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallBehaviorAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallOperationAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICentralBufferNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IClause;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IConditionalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IControlFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDataStoreNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDecisionMergeNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IFlowFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IForkJoinNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInitialNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInstanceNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInterruptibleActivityRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ILoopNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IMessageFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IObjectFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOutputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IValuePin;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehaviorParameter;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IOpaqueBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ICombinedFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IDurationConstraint;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionOccurenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGate;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGeneralOrdering;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionOperand;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionUse;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IPartDecomposition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IChoicePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IConnectionPointReference;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IDeepHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEntryPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IExitPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IFinalState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IForkPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInitialPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInternalTransition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJoinPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJunctionPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IShallowHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateInvariant;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITerminatePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.information.IInformationFlow;
import com.modeliosoft.modelio.api.model.uml.information.IInformationItem;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IAbstraction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IConstraint;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElementRealization;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalNote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalTaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INoteType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IUsage;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IAttribute;
import com.modeliosoft.modelio.api.model.uml.statik.IAttributeLink;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IBinding;
import com.modeliosoft.modelio.api.model.uml.statik.IClass;
import com.modeliosoft.modelio.api.model.uml.statik.IClassAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaboration;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.model.uml.statik.IConnector;
import com.modeliosoft.modelio.api.model.uml.statik.IConnectorEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IDataFlow;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IElementImport;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralization;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IManifestation;
import com.modeliosoft.modelio.api.model.uml.statik.INamespaceUse;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageImport;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.model.uml.statik.IProvidedInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IRaisedException;
import com.modeliosoft.modelio.api.model.uml.statik.IRequiredInterface;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameterSubstitution;
import com.modeliosoft.modelio.api.model.uml.usecase.IActor;
import com.modeliosoft.modelio.api.model.uml.usecase.IExtensionPoint;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCaseDependency;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.generation.IParseModelBehavior;
import com.modeliosoft.modelio.xmi.gui.ProgressBarComposite;
import com.modeliosoft.modelio.xmi.plugin.XMITagTypes;

@objid ("18f1f0fa-4583-11e0-b54c-00137279a832")
public class XMIVisitBehavior implements IParseModelBehavior {
    @objid ("18f1f0fb-4583-11e0-b54c-00137279a832")
    private ProgressBarComposite theProgressBar = null;


    @objid ("18f1f0fc-4583-11e0-b54c-00137279a832")
    public XMIVisitBehavior(ProgressBarComposite progressBar) {
        this.theProgressBar = progressBar;
    }

    @objid ("18f1f0ff-4583-11e0-b54c-00137279a832")
    public ProgressBarComposite getProgressBar() {
        return theProgressBar;
    }

    @objid ("18f1f103-4583-11e0-b54c-00137279a832")
    public void visitAssociationEnd(IAssociationEnd arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f1f106-4583-11e0-b54c-00137279a832")
    public void visitAttribute(IAttribute arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f1f109-4583-11e0-b54c-00137279a832")
    public void visitClass(IClass arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f45354-4583-11e0-b54c-00137279a832")
    public void visitPackage(IPackage arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f45357-4583-11e0-b54c-00137279a832")
    public void visitTaggedValue(ITaggedValue arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f4535a-4583-11e0-b54c-00137279a832")
    public void visitAssociation(IAssociation arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f4535d-4583-11e0-b54c-00137279a832")
    public void visitOperation(IOperation arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f45360-4583-11e0-b54c-00137279a832")
    public void visitParameter(IParameter arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f45363-4583-11e0-b54c-00137279a832")
    public void visitActor(IActor arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f6b5af-4583-11e0-b54c-00137279a832")
    public void visitComponent(IComponent arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f6b5b2-4583-11e0-b54c-00137279a832")
    public void visitGeneralization(IGeneralization arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f6b5b5-4583-11e0-b54c-00137279a832")
    public void visitElementImport(IElementImport arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f6b5b8-4583-11e0-b54c-00137279a832")
    public void visitRaisedException(IRaisedException arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f6b5bb-4583-11e0-b54c-00137279a832")
    public void visitRegion(IRegion arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f91808-4583-11e0-b54c-00137279a832")
    public void visitDataType(IDataType arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f9180b-4583-11e0-b54c-00137279a832")
    public void visitInterface(IInterface arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f9180e-4583-11e0-b54c-00137279a832")
    public void visitEnumeration(IEnumeration arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f91811-4583-11e0-b54c-00137279a832")
    public void visitEnumerationLiteral(IEnumerationLiteral arg0) {
        visitModelElement(arg0);
    }

    @objid ("18f91814-4583-11e0-b54c-00137279a832")
    public void visitDependency(IDependency arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fb7a62-4583-11e0-b54c-00137279a832")
    public void visitNote(INote arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fb7a65-4583-11e0-b54c-00137279a832")
    public void visitConstraint(IConstraint arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fb7a68-4583-11e0-b54c-00137279a832")
    public void visitPackageImport(IPackageImport arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fb7a6b-4583-11e0-b54c-00137279a832")
    public void visitPackageMerge(IPackageMerge arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fb7a6e-4583-11e0-b54c-00137279a832")
    public void visitUsage(IUsage arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fddcbc-4583-11e0-b54c-00137279a832")
    public void visitAbstraction(IAbstraction arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fddcbf-4583-11e0-b54c-00137279a832")
    public void visitInterfaceRealization(IInterfaceRealization arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fddcc2-4583-11e0-b54c-00137279a832")
    public void visitDataFlow(IDataFlow arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fddcc5-4583-11e0-b54c-00137279a832")
    public void visitAcceptCallEventAction(IAcceptCallEventAction arg0) {
        visitModelElement(arg0);
    }

    @objid ("18fddcc8-4583-11e0-b54c-00137279a832")
    public void visitAcceptChangeEventAction(IAcceptChangeEventAction arg0) {
        visitModelElement(arg0);
    }

    @objid ("19003f16-4583-11e0-b54c-00137279a832")
    public void visitAcceptSignalAction(IAcceptSignalAction arg0) {
        visitModelElement(arg0);
    }

    @objid ("19003f19-4583-11e0-b54c-00137279a832")
    public void visitAcceptTimeEventAction(IAcceptTimeEventAction arg0) {
        visitModelElement(arg0);
    }

    @objid ("19003f1c-4583-11e0-b54c-00137279a832")
    public void visitActivity(IActivity arg0) {
        visitModelElement(arg0);
    }

    @objid ("19003f1f-4583-11e0-b54c-00137279a832")
    public void visitActivityParameterNode(IActivityParameterNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("19003f22-4583-11e0-b54c-00137279a832")
    public void visitActivityPartition(IActivityPartition arg0) {
        visitModelElement(arg0);
    }

    @objid ("1902a172-4583-11e0-b54c-00137279a832")
    public void visitArtifact(IArtifact arg0) {
        visitModelElement(arg0);
    }

    @objid ("1902a175-4583-11e0-b54c-00137279a832")
    public void visitAttributeLink(IAttributeLink arg0) {
        visitModelElement(arg0);
    }

    @objid ("1902a178-4583-11e0-b54c-00137279a832")
    public void visitBehaviorParameter(IBehaviorParameter arg0) {
        visitModelElement(arg0);
    }

    @objid ("1902a17b-4583-11e0-b54c-00137279a832")
    public void visitBindableInstance(IBindableInstance arg0) {
        visitModelElement(arg0);
    }

    @objid ("190503ca-4583-11e0-b54c-00137279a832")
    public void visitBinding(IBinding arg0) {
        visitModelElement(arg0);
    }

    @objid ("190503cd-4583-11e0-b54c-00137279a832")
    public void visitCallBehaviorAction(ICallBehaviorAction arg0) {
        visitModelElement(arg0);
    }

    @objid ("190503d0-4583-11e0-b54c-00137279a832")
    public void visitCallOperationAction(ICallOperationAction arg0) {
        visitModelElement(arg0);
    }

    @objid ("190503d3-4583-11e0-b54c-00137279a832")
    public void visitCentralBufferNode(ICentralBufferNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("19076624-4583-11e0-b54c-00137279a832")
    public void visitChoicePseudoState(IChoicePseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("19076627-4583-11e0-b54c-00137279a832")
    public void visitClassAssociation(IClassAssociation arg0) {
        visitModelElement(arg0);
    }

    @objid ("1907662a-4583-11e0-b54c-00137279a832")
    public void visitClause(IClause arg0) {
        visitModelElement(arg0);
    }

    @objid ("1907662d-4583-11e0-b54c-00137279a832")
    public void visitCollaboration(ICollaboration arg0) {
        visitModelElement(arg0);
    }

    @objid ("1909c87e-4583-11e0-b54c-00137279a832")
    public void visitCollaborationUse(ICollaborationUse arg0) {
        visitModelElement(arg0);
    }

    @objid ("1909c881-4583-11e0-b54c-00137279a832")
    public void visitCombinedFragment(ICombinedFragment arg0) {
        visitModelElement(arg0);
    }

    @objid ("1909c884-4583-11e0-b54c-00137279a832")
    public void visitConditionalNode(IConditionalNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("1909c887-4583-11e0-b54c-00137279a832")
    public void visitConnectionPointReference(IConnectionPointReference arg0) {
        visitModelElement(arg0);
    }

    @objid ("190c2ad8-4583-11e0-b54c-00137279a832")
    public void visitConnector(IConnector arg0) {
        visitModelElement(arg0);
    }

    @objid ("190c2adb-4583-11e0-b54c-00137279a832")
    public void visitConnectorEnd(IConnectorEnd arg0) {
        visitModelElement(arg0);
    }

    @objid ("190c2ade-4583-11e0-b54c-00137279a832")
    public void visitControlFlow(IControlFlow arg0) {
        visitModelElement(arg0);
    }

    @objid ("190c2ae1-4583-11e0-b54c-00137279a832")
    public void visitDataStoreNode(IDataStoreNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("190e8d32-4583-11e0-b54c-00137279a832")
    public void visitDecisionMergeNode(IDecisionMergeNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("190e8d35-4583-11e0-b54c-00137279a832")
    public void visitDeepHistoryPseudoState(IDeepHistoryPseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("190e8d38-4583-11e0-b54c-00137279a832")
    public void visitDictionary(IDictionary arg0) {
        visitModelElement(arg0);
    }

    @objid ("190e8d3b-4583-11e0-b54c-00137279a832")
    public void visitDurationConstraint(IDurationConstraint arg0) {
        visitModelElement(arg0);
    }

    @objid ("1910ef8c-4583-11e0-b54c-00137279a832")
    public void visitElementRealization(IElementRealization arg0) {
        visitModelElement(arg0);
    }

    @objid ("1910ef8f-4583-11e0-b54c-00137279a832")
    public void visitEntryPointPseudoState(IEntryPointPseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("1910ef92-4583-11e0-b54c-00137279a832")
    public void visitEnumeratedPropertyType(IEnumeratedPropertyType arg0) {
        visitModelElement(arg0);
    }

    @objid ("1910ef95-4583-11e0-b54c-00137279a832")
    public void visitEvent(IEvent arg0) {
        visitModelElement(arg0);
    }

    @objid ("191351e8-4583-11e0-b54c-00137279a832")
    public void visitExecutionOccurenceSpecification(IExecutionOccurenceSpecification arg0) {
        visitModelElement(arg0);
    }

    @objid ("191351eb-4583-11e0-b54c-00137279a832")
    public void visitExecutionSpecification(IExecutionSpecification arg0) {
        visitModelElement(arg0);
    }

    @objid ("191351ee-4583-11e0-b54c-00137279a832")
    public void visitExitPointPseudoState(IExitPointPseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("1915b440-4583-11e0-b54c-00137279a832")
    public void visitExtensionPoint(IExtensionPoint arg0) {
        visitModelElement(arg0);
    }

    @objid ("1915b443-4583-11e0-b54c-00137279a832")
    public void visitFinalState(IFinalState arg0) {
        visitModelElement(arg0);
    }

    @objid ("1915b446-4583-11e0-b54c-00137279a832")
    public void visitFlowFinalNode(IFlowFinalNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("1915b449-4583-11e0-b54c-00137279a832")
    public void visitForkJoinNode(IForkJoinNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("1918169a-4583-11e0-b54c-00137279a832")
    public void visitForkPseudoState(IForkPseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("1918169d-4583-11e0-b54c-00137279a832")
    public void visitGate(IGate arg0) {
        visitModelElement(arg0);
    }

    @objid ("191816a0-4583-11e0-b54c-00137279a832")
    public void visitGeneralOrdering(IGeneralOrdering arg0) {
        // visitModelElement(arg0);
        // TODO
    }

    @objid ("191a78f4-4583-11e0-b54c-00137279a832")
    public void visitInformationFlow(IInformationFlow arg0) {
        visitModelElement(arg0);
    }

    @objid ("191a78f7-4583-11e0-b54c-00137279a832")
    public void visitInformationItem(IInformationItem arg0) {
        visitModelElement(arg0);
    }

    @objid ("191a78fa-4583-11e0-b54c-00137279a832")
    public void visitInitialNode(IInitialNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("191cdb4e-4583-11e0-b54c-00137279a832")
    public void visitInitialPseudoState(IInitialPseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("191cdb51-4583-11e0-b54c-00137279a832")
    public void visitInputPin(IInputPin arg0) {
        visitModelElement(arg0);
    }

    @objid ("191cdb54-4583-11e0-b54c-00137279a832")
    public void visitInstance(IInstance arg0) {
        visitModelElement(arg0);
    }

    @objid ("191cdb57-4583-11e0-b54c-00137279a832")
    public void visitInstanceNode(IInstanceNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("191f3da8-4583-11e0-b54c-00137279a832")
    public void visitInteraction(IInteraction arg0) {
        visitModelElement(arg0);
    }

    @objid ("191f3dab-4583-11e0-b54c-00137279a832")
    public void visitInteractionOperand(IInteractionOperand arg0) {
        visitModelElement(arg0);
    }

    @objid ("191f3dae-4583-11e0-b54c-00137279a832")
    public void visitInteractionUse(IInteractionUse arg0) {
        visitModelElement(arg0);
    }

    @objid ("1921a002-4583-11e0-b54c-00137279a832")
    public void visitInternalTransition(IInternalTransition arg0) {
        visitModelElement(arg0);
    }

    @objid ("1921a005-4583-11e0-b54c-00137279a832")
    public void visitInterruptibleActivityRegion(IInterruptibleActivityRegion arg0) {
        visitModelElement(arg0);
    }

    @objid ("1921a008-4583-11e0-b54c-00137279a832")
    public void visitJoinPseudoState(IJoinPseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("1924025c-4583-11e0-b54c-00137279a832")
    public void visitJunctionPseudoState(IJunctionPseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("1924025f-4583-11e0-b54c-00137279a832")
    public void visitLifeline(ILifeline arg0) {
        visitModelElement(arg0);
    }

    @objid ("19240262-4583-11e0-b54c-00137279a832")
    public void visitLink(ILink arg0) {
        visitModelElement(arg0);
    }

    @objid ("192664b6-4583-11e0-b54c-00137279a832")
    public void visitLinkEnd(ILinkEnd arg0) {
        visitModelElement(arg0);
    }

    @objid ("192664b9-4583-11e0-b54c-00137279a832")
    public void visitLocalNote(ILocalNote arg0) {
        // visitModelElement(arg0);
        // TODO
    }

    @objid ("192664bc-4583-11e0-b54c-00137279a832")
    public void visitLocalTaggedValue(ILocalTaggedValue arg0) {
        visitModelElement(arg0);
    }

    @objid ("1928c710-4583-11e0-b54c-00137279a832")
    public void visitLoopNode(ILoopNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("1928c713-4583-11e0-b54c-00137279a832")
    public void visitManifestation(IManifestation arg0) {
        visitModelElement(arg0);
    }

    @objid ("192b296a-4583-11e0-b54c-00137279a832")
    public void visitMessage(IMessage arg0) {
        visitModelElement(arg0);
    }

    @objid ("192b296d-4583-11e0-b54c-00137279a832")
    public void visitMessageFlow(IMessageFlow arg0) {
        visitModelElement(arg0);
    }

    @objid ("192b2970-4583-11e0-b54c-00137279a832")
    public void visitNamespaceUse(INamespaceUse arg0) {
        // visitModelElement(arg0);
        // TODO
    }

    @objid ("192d8bc4-4583-11e0-b54c-00137279a832")
    public void visitNode(INode arg0) {
        visitModelElement(arg0);
    }

    @objid ("192d8bc7-4583-11e0-b54c-00137279a832")
    public void visitNoteType(INoteType arg0) {
        visitModelElement(arg0);
    }

    @objid ("192d8bca-4583-11e0-b54c-00137279a832")
    public void visitObjectFlow(IObjectFlow arg0) {
        visitModelElement(arg0);
    }

    @objid ("192fee1e-4583-11e0-b54c-00137279a832")
    public void visitOpaqueAction(IOpaqueAction arg0) {
        visitModelElement(arg0);
    }

    @objid ("192fee21-4583-11e0-b54c-00137279a832")
    public void visitOpaqueBehavior(IOpaqueBehavior arg0) {
        visitModelElement(arg0);
    }

    @objid ("192fee24-4583-11e0-b54c-00137279a832")
    public void visitOutputPin(IOutputPin arg0) {
        visitModelElement(arg0);
    }

    @objid ("19325078-4583-11e0-b54c-00137279a832")
    public void visitPartDecomposition(IPartDecomposition arg0) {
        visitModelElement(arg0);
    }

    @objid ("1932507b-4583-11e0-b54c-00137279a832")
    public void visitPort(IPort arg0) {
        visitModelElement(arg0);
    }

    @objid ("1932507e-4583-11e0-b54c-00137279a832")
    public void visitProject(IProject arg0) {
        visitModelElement(arg0);
    }

    @objid ("1934b2d2-4583-11e0-b54c-00137279a832")
    public void visitProperty(IProperty arg0) {
        visitModelElement(arg0);
    }

    @objid ("1934b2d5-4583-11e0-b54c-00137279a832")
    public void visitPropertyEnumerationLitteral(IPropertyEnumerationLitteral arg0) {
        visitModelElement(arg0);
    }

    @objid ("1934b2d8-4583-11e0-b54c-00137279a832")
    public void visitPropertySet(IPropertySet arg0) {
        visitModelElement(arg0);
    }

    @objid ("1937152c-4583-11e0-b54c-00137279a832")
    public void visitPropertyType(IPropertyType arg0) {
        visitModelElement(arg0);
    }

    @objid ("1937152f-4583-11e0-b54c-00137279a832")
    public void visitPropertyValue(IPropertyValue arg0) {
        // visitModelElement(arg0);
        // TODO
    }

    @objid ("19397786-4583-11e0-b54c-00137279a832")
    public void visitPropertyValueSet(IPropertyValueSet arg0) {
        // visitModelElement(arg0);
        // TODO
    }

    @objid ("19397789-4583-11e0-b54c-00137279a832")
    public void visitProvidedInterface(IProvidedInterface arg0) {
        visitModelElement(arg0);
    }

    @objid ("193bd9e0-4583-11e0-b54c-00137279a832")
    public void visitRequiredInterface(IRequiredInterface arg0) {
        visitModelElement(arg0);
    }

    @objid ("193bd9e3-4583-11e0-b54c-00137279a832")
    public void visitRequirement(IRequirement arg0) {
        visitModelElement(arg0);
    }

    @objid ("193bd9e6-4583-11e0-b54c-00137279a832")
    public void visitRequirementContainer(IRequirementContainer arg0) {
        visitModelElement(arg0);
    }

    @objid ("193e3c3b-4583-11e0-b54c-00137279a832")
    public void visitRequirementElement(IRequirementElement arg0) {
        visitModelElement(arg0);
    }

    @objid ("193e3c3e-4583-11e0-b54c-00137279a832")
    public void visitSendSignalAction(ISendSignalAction arg0) {
        visitModelElement(arg0);
    }

    @objid ("19409e94-4583-11e0-b54c-00137279a832")
    public void visitShallowHistoryPseudoState(IShallowHistoryPseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("19409e97-4583-11e0-b54c-00137279a832")
    public void visitSignal(ISignal arg0) {
        visitModelElement(arg0);
    }

    @objid ("19409e9a-4583-11e0-b54c-00137279a832")
    public void visitState(IState arg0) {
        visitModelElement(arg0);
    }

    @objid ("194300ee-4583-11e0-b54c-00137279a832")
    public void visitStateInvariant(IStateInvariant arg0) {
        visitModelElement(arg0);
    }

    @objid ("194300f1-4583-11e0-b54c-00137279a832")
    public void visitStateMachine(IStateMachine arg0) {
        visitModelElement(arg0);
    }

    @objid ("19456348-4583-11e0-b54c-00137279a832")
    public void visitStereotype(IStereotype arg0) {
        visitModelElement(arg0);
    }

    @objid ("1945634b-4583-11e0-b54c-00137279a832")
    public void visitStructuredActivityNode(IStructuredActivityNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("1945634e-4583-11e0-b54c-00137279a832")
    public void visitSubstitution(ISubstitution arg0) {
        visitModelElement(arg0);
    }

    @objid ("1947c5a2-4583-11e0-b54c-00137279a832")
    public void visitTagParameter(ITagParameter arg0) {
        // visitModelElement(arg0);
        // TODO
    }

    @objid ("1947c5a5-4583-11e0-b54c-00137279a832")
    public void visitTagType(ITagType arg0) {
        visitModelElement(arg0);
    }

    @objid ("194a27fc-4583-11e0-b54c-00137279a832")
    public void visitTemplateBinding(ITemplateBinding arg0) {
        visitModelElement(arg0);
    }

    @objid ("194a27ff-4583-11e0-b54c-00137279a832")
    public void visitTemplateParameter(ITemplateParameter arg0) {
        visitModelElement(arg0);
    }

    @objid ("194a2802-4583-11e0-b54c-00137279a832")
    public void visitTemplateParameterSubstitution(ITemplateParameterSubstitution arg0) {
        visitModelElement(arg0);
    }

    @objid ("194c8a56-4583-11e0-b54c-00137279a832")
    public void visitTerm(ITerm arg0) {
        visitModelElement(arg0);
    }

    @objid ("194c8a59-4583-11e0-b54c-00137279a832")
    public void visitTerminatePseudoState(ITerminatePseudoState arg0) {
        visitModelElement(arg0);
    }

    @objid ("194eecb0-4583-11e0-b54c-00137279a832")
    public void visitTransition(ITransition arg0) {
        visitModelElement(arg0);
    }

    @objid ("194eecb3-4583-11e0-b54c-00137279a832")
    public void visitUseCase(IUseCase arg0) {
        visitModelElement(arg0);
    }

    @objid ("194eecb6-4583-11e0-b54c-00137279a832")
    public void visitUseCaseDependency(IUseCaseDependency arg0) {
        visitModelElement(arg0);
    }

    @objid ("19514f0a-4583-11e0-b54c-00137279a832")
    public void visitActivityFinalNode(IActivityFinalNode arg0) {
        visitModelElement(arg0);
    }

    @objid ("19514f0d-4583-11e0-b54c-00137279a832")
    private void visitModelElement(IModelElement arg0) {
        //        boolean isTagged = false;
        //        for (ITaggedValue tag : arg0.getTag()) {
        //            if (XMITagTypes.MODELELEMENT_XMIIMPORTED.equals(tag.getDefinition()
        //                    .getName())) {
        //                isTagged = true;
        //                break;
        //            }
        //        }
        //                
        //        DestructiveUpdateMap updateMap = DestructiveUpdateMap.getInstance();
        //        if (isTagged) {
        //            // If the element is not in the map, add it.
        //            if (updateMap.HTag_get(arg0.getIdentifier()) == null)
        //                updateMap.HTag_put(arg0.getIdentifier(), arg0);
        //        } else {
        //            // If the element is not in the map, add it.
        //            if (updateMap.HSuppr_get(arg0.getIdentifier()) == null)
        //                updateMap.HSuppr_put(arg0.getIdentifier(), arg0);
        //        }
    }

    @Override
    @objid ("a9f563a1-5c0e-11e1-9a0a-0027103f347d")
    public void visitValuePin(final IValuePin arg0) {
        visitModelElement(arg0);
    }

}
