/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.util;

import java.util.HashMap;
import com.modeliosoft.modelio.api.model.analyst.IDictionary;
import com.modeliosoft.modelio.api.model.analyst.IDictionaryElement;
import com.modeliosoft.modelio.api.model.analyst.IEnumeratedPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IProperty;
import com.modeliosoft.modelio.api.model.analyst.IPropertyEnumerationLitteral;
import com.modeliosoft.modelio.api.model.analyst.IPropertySet;
import com.modeliosoft.modelio.api.model.analyst.IPropertyType;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValue;
import com.modeliosoft.modelio.api.model.analyst.IPropertyValueSet;
import com.modeliosoft.modelio.api.model.analyst.IRequirement;
import com.modeliosoft.modelio.api.model.analyst.IRequirementContainer;
import com.modeliosoft.modelio.api.model.analyst.IRequirementElement;
import com.modeliosoft.modelio.api.model.analyst.ITerm;
import com.modeliosoft.modelio.api.model.diagrams.IAbstractDiagram;
import com.modeliosoft.modelio.api.model.extension.IProject;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptCallEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptChangeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IAcceptTimeEventAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivity;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityEdge;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityGroup;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityParameterNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallBehaviorAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICallOperationAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ICentralBufferNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IClause;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IConditionalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IControlFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IControlNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDataStoreNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IDecisionMergeNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IFlowFinalNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IForkJoinNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInitialNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInstanceNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IInterruptibleActivityRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ILoopNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IMessageFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IObjectFlow;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IObjectNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOpaqueAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IOutputPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IPin;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.ISendSignalAction;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IStructuredActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehaviorParameter;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IOpaqueBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.behavior.communication.ICommunicationChannel;
import com.modeliosoft.modelio.api.model.uml.behavior.communication.ICommunicationInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.communication.ICommunicationMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.communication.ICommunicationNode;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ICombinedFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IDurationConstraint;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionOccurenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IExecutionSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGate;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IGeneralOrdering;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteraction;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionOperand;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionUse;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessageEnd;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IOccurrenceSpecification;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IPartDecomposition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IAbstractPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IChoicePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IConnectionPointReference;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IDeepHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEntryPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IExitPointPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IForkPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInitialPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInternalTransition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJoinPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IJunctionPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IShallowHistoryPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateInvariant;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateMachine;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateVertex;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITerminatePseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.information.IInformationFlow;
import com.modeliosoft.modelio.api.model.uml.information.IInformationItem;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IAbstraction;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IConstraint;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElementRealization;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalNote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ILocalTaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INoteType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagParameter;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITagType;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IUsage;
import com.modeliosoft.modelio.api.model.uml.statik.IArtifact;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IAttribute;
import com.modeliosoft.modelio.api.model.uml.statik.IAttributeLink;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IBinding;
import com.modeliosoft.modelio.api.model.uml.statik.IClass;
import com.modeliosoft.modelio.api.model.uml.statik.IClassAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaboration;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.model.uml.statik.IConnector;
import com.modeliosoft.modelio.api.model.uml.statik.IConnectorEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IDataFlow;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IElementImport;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumeration;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.api.model.uml.statik.IFeature;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralClass;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralization;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IManifestation;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.INamespaceUse;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageImport;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.model.uml.statik.IProvidedInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IRaisedException;
import com.modeliosoft.modelio.api.model.uml.statik.IRequiredInterface;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameterSubstitution;
import com.modeliosoft.modelio.api.model.uml.usecase.IActor;
import com.modeliosoft.modelio.api.model.uml.usecase.IExtensionPoint;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCaseDependency;
import com.modeliosoft.modelio.api.utils.DefaultMetamodelVisitor;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

/**
 * Visitor of composition relationship
 * @author ebrosse
 */
@objid ("199410ed-4583-11e0-b54c-00137279a832")
public class CompositionOwnerVisitor {
    @objid ("1996733c-4583-11e0-b54c-00137279a832")
    private IElement theParent;

    @objid ("1996733d-4583-11e0-b54c-00137279a832")
    private HashMap<IElement, IElement> ownershipMap;

    @objid ("19967341-4583-11e0-b54c-00137279a832")
    private CompositionOwnerSelector selector;


    @objid ("19967342-4583-11e0-b54c-00137279a832")
    public CompositionOwnerVisitor() {
        this.ownershipMap = new HashMap<IElement, IElement>();
        this.selector = new CompositionOwnerSelector();
    }

    @objid ("19967344-4583-11e0-b54c-00137279a832")
    public IElement getCompositionOwner(IElement theChild) {
        this.theParent = this.ownershipMap.get(theChild);
        if (this.theParent == null) {
            this.selector.launchVisit(theChild);
            this.ownershipMap.put(theChild, this.theParent);
        }
        return this.theParent;
    }

    @objid ("19967349-4583-11e0-b54c-00137279a832")
    private class CompositionOwnerSelector extends DefaultMetamodelVisitor {

        @objid ("1996734a-4583-11e0-b54c-00137279a832")
        public void launchVisit(IElement theChild) {
            theChild.accept(this);
        }

        @Override
        @objid ("1998d596-4583-11e0-b54c-00137279a832")
        public Object visitAbstractDiagram(IAbstractDiagram child) {
            if (theParent == null)
                super.visitAbstractDiagram(child);
            return null;
        }

        @Override
        @objid ("1998d59c-4583-11e0-b54c-00137279a832")
        public Object visitAbstractPseudoState(IAbstractPseudoState child) {
            if (theParent == null)
                theParent = child.getParent();
                        
            if (theParent == null)
                super.visitAbstractPseudoState(child);
            return null;
        }

        @Override
        @objid ("1998d5a2-4583-11e0-b54c-00137279a832")
        public Object visitAbstraction(IAbstraction child) {
            if (theParent == null)
                super.visitAbstraction(child);
            return null;
        }

        @Override
        @objid ("199b37f1-4583-11e0-b54c-00137279a832")
        public Object visitAcceptCallEventAction(IAcceptCallEventAction child) {
            if (theParent == null)
                super.visitAcceptCallEventAction(child);
            return null;
        }

        @Override
        @objid ("199b37f7-4583-11e0-b54c-00137279a832")
        public Object visitAcceptChangeEventAction(IAcceptChangeEventAction child) {
            if (theParent == null)
                super.visitAcceptChangeEventAction(child);
            return null;
        }

        @Override
        @objid ("199d9a4a-4583-11e0-b54c-00137279a832")
        public Object visitAcceptSignalAction(IAcceptSignalAction child) {
            if (theParent == null)
                super.visitAcceptSignalAction(child);
            return null;
        }

        @Override
        @objid ("199d9a50-4583-11e0-b54c-00137279a832")
        public Object visitAcceptTimeEventAction(IAcceptTimeEventAction child) {
            if (theParent == null)
                super.visitAcceptTimeEventAction(child);
            return null;
        }

        @Override
        @objid ("199d9a56-4583-11e0-b54c-00137279a832")
        public Object visitActivity(IActivity child) {
            if (theParent == null)
                super.visitActivity(child);
            return null;
        }

        @Override
        @objid ("199ffca7-4583-11e0-b54c-00137279a832")
        public Object visitActivityAction(IActivityAction child) {
            if (theParent == null)
                super.visitActivityAction(child);
            return null;
        }

        @Override
        @objid ("199ffcad-4583-11e0-b54c-00137279a832")
        public Object visitActivityEdge(IActivityEdge child) {
            if (theParent == null)
                theParent = child.getSource();
                        
            if (theParent == null)
                super.visitActivityEdge(child);
            return null;
        }

        @Override
        @objid ("19a25efe-4583-11e0-b54c-00137279a832")
        public Object visitActivityFinalNode(IActivityFinalNode child) {
            if (theParent == null)
                super.visitActivityFinalNode(child);
            return null;
        }

        @Override
        @objid ("19a25f04-4583-11e0-b54c-00137279a832")
        public Object visitActivityGroup(IActivityGroup child) {
            if (theParent == null)
                theParent = child.getInActivity();
                        
            if (theParent == null)
                super.visitActivityGroup(child);
            return null;
        }

        @Override
        @objid ("19a25f0a-4583-11e0-b54c-00137279a832")
        public Object visitActivityNode(IActivityNode child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                theParent = child.getOwnerClause();
                        
            if (theParent == null)
                theParent = child.getOwnerNode();
                        
            if (theParent == null)
                theParent = child.getOwnerPartition();
                        
            if (theParent == null)
                super.visitActivityNode(child);
            return null;
        }

        @Override
        @objid ("19a4c15c-4583-11e0-b54c-00137279a832")
        public Object visitActivityParameterNode(IActivityParameterNode child) {
            if (theParent == null)
                super.visitActivityParameterNode(child);
            return null;
        }

        @Override
        @objid ("19a4c162-4583-11e0-b54c-00137279a832")
        public Object visitActivityPartition(IActivityPartition child) {
            if (theParent == null)
                theParent = child.getSuperPartition();
                        
            if (theParent == null)
                super.visitActivityPartition(child);
            return null;
        }

        @Override
        @objid ("19a723b3-4583-11e0-b54c-00137279a832")
        public Object visitActor(IActor child) {
            if (theParent == null)
                super.visitActor(child);
            return null;
        }

        @Override
        @objid ("19a723b9-4583-11e0-b54c-00137279a832")
        public Object visitArtifact(IArtifact child) {
            if (theParent == null)
                super.visitArtifact(child);
            return null;
        }

        @Override
        @objid ("19a9860c-4583-11e0-b54c-00137279a832")
        public Object visitAssociation(IAssociation child) {
            if (theParent == null)
                super.visitAssociation(child);
            return null;
        }

        @Override
        @objid ("19a98612-4583-11e0-b54c-00137279a832")
        public Object visitAssociationEnd(IAssociationEnd child) {
            if (theParent == null)
                super.visitAssociationEnd(child);
            return null;
        }

        @Override
        @objid ("19a98618-4583-11e0-b54c-00137279a832")
        public Object visitAttribute(IAttribute child) {
            if (theParent == null)
                theParent = child.getQualified();
                        
            if (theParent == null)
                super.visitAttribute(child);
            return null;
        }

        @Override
        @objid ("19abe86a-4583-11e0-b54c-00137279a832")
        public Object visitAttributeLink(IAttributeLink child) {
            if (theParent == null)
                theParent = child.getAttributed();
                        
            if (theParent == null)
                super.visitAttributeLink(child);
            return null;
        }

        @Override
        @objid ("19abe870-4583-11e0-b54c-00137279a832")
        public Object visitBehavior(IBehavior child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                theParent = child.getOwnerOperation();
                        
            if (theParent == null)
                super.visitBehavior(child);
            return null;
        }

        @Override
        @objid ("19ae4ac2-4583-11e0-b54c-00137279a832")
        public Object visitBehaviorParameter(IBehaviorParameter child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitBehaviorParameter(child);
            return null;
        }

        @Override
        @objid ("19ae4ac8-4583-11e0-b54c-00137279a832")
        public Object visitBindableInstance(IBindableInstance child) {
            if (theParent == null)
                theParent = child.getCluster();
                        
            if (theParent == null)
                theParent = child.getInternalOwner();
                        
            if (theParent == null)
                super.visitBindableInstance(child);
            return null;
        }

        @Override
        @objid ("19b0ad1b-4583-11e0-b54c-00137279a832")
        public Object visitBinding(IBinding child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitBinding(child);
            return null;
        }

        @Override
        @objid ("19b0ad21-4583-11e0-b54c-00137279a832")
        public Object visitCallAction(ICallAction child) {
            if (theParent == null)
                super.visitCallAction(child);
            return null;
        }

        @Override
        @objid ("19b30f74-4583-11e0-b54c-00137279a832")
        public Object visitCallBehaviorAction(ICallBehaviorAction child) {
            if (theParent == null)
                super.visitCallBehaviorAction(child);
            return null;
        }

        @Override
        @objid ("19b30f7a-4583-11e0-b54c-00137279a832")
        public Object visitCallOperationAction(ICallOperationAction child) {
            if (theParent == null)
                super.visitCallOperationAction(child);
            return null;
        }

        @Override
        @objid ("19b30f80-4583-11e0-b54c-00137279a832")
        public Object visitCentralBufferNode(ICentralBufferNode child) {
            if (theParent == null)
                super.visitCentralBufferNode(child);
            return null;
        }

        @Override
        @objid ("19b571d2-4583-11e0-b54c-00137279a832")
        public Object visitChoicePseudoState(IChoicePseudoState child) {
            if (theParent == null)
                super.visitChoicePseudoState(child);
            return null;
        }

        @Override
        @objid ("19b571d8-4583-11e0-b54c-00137279a832")
        public Object visitClass(IClass child) {
            if (theParent == null)
                super.visitClass(child);
            return null;
        }

        @Override
        @objid ("19b7d42a-4583-11e0-b54c-00137279a832")
        public Object visitClassAssociation(IClassAssociation child) {
            if (theParent == null)
                theParent = child.getAssociationPart();
                        
            if (theParent == null)
                super.visitClassAssociation(child);
            return null;
        }

        @Override
        @objid ("19b7d430-4583-11e0-b54c-00137279a832")
        public Object visitClassifier(IClassifier child) {
            if (theParent == null)
                super.visitClassifier(child);
            return null;
        }

        @Override
        @objid ("19ba3683-4583-11e0-b54c-00137279a832")
        public Object visitClause(IClause child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitClause(child);
            return null;
        }

        @Override
        @objid ("19ba3689-4583-11e0-b54c-00137279a832")
        public Object visitCollaboration(ICollaboration child) {
            if (theParent == null)
                theParent = child.getBRepresented();
                        
            if (theParent == null)
                theParent = child.getORepresented();
                        
            if (theParent == null)
                super.visitCollaboration(child);
            return null;
        }

        @Override
        @objid ("19bc98dc-4583-11e0-b54c-00137279a832")
        public Object visitCollaborationUse(ICollaborationUse child) {
            if (theParent == null)
                theParent = child.getNRepresented();
                        
            if (theParent == null)
                theParent = child.getORepresented();
                        
            if (theParent == null)
                super.visitCollaborationUse(child);
            return null;
        }

        @Override
        @objid ("19bc98e2-4583-11e0-b54c-00137279a832")
        public Object visitCombinedFragment(ICombinedFragment child) {
            if (theParent == null)
                super.visitCombinedFragment(child);
            return null;
        }

        @Override
        @objid ("19befb36-4583-11e0-b54c-00137279a832")
        public Object visitCommunicationChannel(ICommunicationChannel child) {
            if (theParent == null)
                theParent = child.getStart();
                        
            if (theParent == null)
                super.visitCommunicationChannel(child);
            return null;
        }

        @Override
        @objid ("19befb3c-4583-11e0-b54c-00137279a832")
        public Object visitCommunicationInteraction(ICommunicationInteraction child) {
            if (theParent == null)
                super.visitCommunicationInteraction(child);
            return null;
        }

        @Override
        @objid ("19c15d90-4583-11e0-b54c-00137279a832")
        public Object visitCommunicationMessage(ICommunicationMessage child) {
            if (theParent == null)
                theParent = child.getChannel();
                        
            if (theParent == null)
                theParent = child.getInvertedChannel();
                        
            if (theParent == null)
                super.visitCommunicationMessage(child);
            return null;
        }

        @Override
        @objid ("19c15d96-4583-11e0-b54c-00137279a832")
        public Object visitCommunicationNode(ICommunicationNode child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitCommunicationNode(child);
            return null;
        }

        @Override
        @objid ("19c3bfea-4583-11e0-b54c-00137279a832")
        public Object visitComponent(IComponent child) {
            if (theParent == null)
                super.visitComponent(child);
            return null;
        }

        @Override
        @objid ("19c3bff0-4583-11e0-b54c-00137279a832")
        public Object visitConditionalNode(IConditionalNode child) {
            if (theParent == null)
                super.visitConditionalNode(child);
            return null;
        }

        @Override
        @objid ("19c3bff6-4583-11e0-b54c-00137279a832")
        public Object visitConnectionPointReference(IConnectionPointReference child) {
            if (theParent == null)
                theParent = child.getOwnerState();
                        
            if (theParent == null)
                super.visitConnectionPointReference(child);
            return null;
        }

        @Override
        @objid ("19c62249-4583-11e0-b54c-00137279a832")
        public Object visitConnector(IConnector child) {
            if (theParent == null)
                super.visitConnector(child);
            return null;
        }

        @Override
        @objid ("19c6224f-4583-11e0-b54c-00137279a832")
        public Object visitConnectorEnd(IConnectorEnd child) {
            if (theParent == null)
                super.visitConnectorEnd(child);
            return null;
        }

        @Override
        @objid ("19c884a2-4583-11e0-b54c-00137279a832")
        public Object visitConstraint(IConstraint child) {
            //                        if (theParent == null)
            //                            theParent = child.getConstrainedElement();
            
                        if (theParent == null)
                            super.visitConstraint(child);
            return null;
        }

        @Override
        @objid ("19c884a8-4583-11e0-b54c-00137279a832")
        public Object visitControlFlow(IControlFlow child) {
            if (theParent == null)
                super.visitControlFlow(child);
            return null;
        }

        @Override
        @objid ("19cae6fc-4583-11e0-b54c-00137279a832")
        public Object visitControlNode(IControlNode child) {
            if (theParent == null)
                super.visitControlNode(child);
            return null;
        }

        @Override
        @objid ("19cae702-4583-11e0-b54c-00137279a832")
        public Object visitDataFlow(IDataFlow child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitDataFlow(child);
            return null;
        }

        @Override
        @objid ("19cd4955-4583-11e0-b54c-00137279a832")
        public Object visitDataStoreNode(IDataStoreNode child) {
            if (theParent == null)
                super.visitDataStoreNode(child);
            return null;
        }

        @Override
        @objid ("19cd495b-4583-11e0-b54c-00137279a832")
        public Object visitDataType(IDataType child) {
            if (theParent == null)
                super.visitDataType(child);
            return null;
        }

        @Override
        @objid ("19cfabae-4583-11e0-b54c-00137279a832")
        public Object visitDecisionMergeNode(IDecisionMergeNode child) {
            if (theParent == null)
                super.visitDecisionMergeNode(child);
            return null;
        }

        @Override
        @objid ("19cfabb4-4583-11e0-b54c-00137279a832")
        public Object visitDeepHistoryPseudoState(IDeepHistoryPseudoState child) {
            if (theParent == null)
                super.visitDeepHistoryPseudoState(child);
            return null;
        }

        @Override
        @objid ("19d20e0a-4583-11e0-b54c-00137279a832")
        public Object visitDependency(IDependency child) {
            if (theParent == null)
                theParent = child.getImpacted();
                        
            if (theParent == null)
                super.visitDependency(child);
            return null;
        }

        @Override
        @objid ("19d20e10-4583-11e0-b54c-00137279a832")
        public Object visitDictionary(IDictionary child) {
            if (theParent == null)
                theParent = child.getRepresented();
                        
            if (theParent == null)
                super.visitDictionary(child);
            return null;
        }

        @Override
        @objid ("19d47064-4583-11e0-b54c-00137279a832")
        public Object visitDictionaryElement(IDictionaryElement child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitDictionaryElement(child);
            return null;
        }

        @Override
        @objid ("19d4706a-4583-11e0-b54c-00137279a832")
        public Object visitDurationConstraint(IDurationConstraint child) {
            if (theParent == null)
                super.visitDurationConstraint(child);
            return null;
        }

        @Override
        @objid ("19d6d2be-4583-11e0-b54c-00137279a832")
        public Object visitElement(IElement child) {
            if (theParent == null)
                super.visitElement(child);
            return null;
        }

        @Override
        @objid ("19d6d2c4-4583-11e0-b54c-00137279a832")
        public Object visitElementImport(IElementImport child) {
            if (theParent == null)
                theParent = child.getImportingNameSpace();
                        
            if (theParent == null)
                theParent = child.getImportingOperation();
                        
            if (theParent == null)
                super.visitElementImport(child);
            return null;
        }

        @Override
        @objid ("19d93518-4583-11e0-b54c-00137279a832")
        public Object visitElementRealization(IElementRealization child) {
            if (theParent == null)
                super.visitElementRealization(child);
            return null;
        }

        @Override
        @objid ("19d9351e-4583-11e0-b54c-00137279a832")
        public Object visitEntryPointPseudoState(IEntryPointPseudoState child) {
            if (theParent == null)
                theParent = child.getEntryOf();
            
            if (theParent == null)
                theParent = child.getEntryOfMachine();
            
            
            if (theParent == null)
                super.visitEntryPointPseudoState(child);
            return null;
        }

        @Override
        @objid ("19db9772-4583-11e0-b54c-00137279a832")
        public Object visitEnumeratedPropertyType(IEnumeratedPropertyType child) {
            if (theParent == null)
                super.visitEnumeratedPropertyType(child);
            return null;
        }

        @Override
        @objid ("19db9778-4583-11e0-b54c-00137279a832")
        public Object visitEnumeration(IEnumeration child) {
            if (theParent == null)
                super.visitEnumeration(child);
            return null;
        }

        @Override
        @objid ("19ddf9cd-4583-11e0-b54c-00137279a832")
        public Object visitEnumerationLiteral(IEnumerationLiteral child) {
            if (theParent == null)
                theParent = child.getValuated();
                        
            if (theParent == null)
                super.visitEnumerationLiteral(child);
            return null;
        }

        @Override
        @objid ("19e05c22-4583-11e0-b54c-00137279a832")
        public Object visitEvent(IEvent child) {
            if (theParent == null)
                theParent = child.getComposed();
                        
            if (theParent == null)
                super.visitEvent(child);
            return null;
        }

        @Override
        @objid ("19e05c28-4583-11e0-b54c-00137279a832")
        public Object visitExecutionOccurenceSpecification(IExecutionOccurenceSpecification child) {
            if (theParent == null)
                super.visitExecutionOccurenceSpecification(child);
            return null;
        }

        @Override
        @objid ("19e2be7c-4583-11e0-b54c-00137279a832")
        public Object visitExecutionSpecification(IExecutionSpecification child) {
            if (theParent == null)
                super.visitExecutionSpecification(child);
            return null;
        }

        @Override
        @objid ("19e2be82-4583-11e0-b54c-00137279a832")
        public Object visitExitPointPseudoState(IExitPointPseudoState child) {
            if (theParent == null)
                theParent = child.getExitOf();
            
            if (theParent == null)
                theParent = child.getExitOfMachine();
            
            if (theParent == null)
                super.visitExitPointPseudoState(child);
            return null;
        }

        @Override
        @objid ("19e520d6-4583-11e0-b54c-00137279a832")
        public Object visitExtensionPoint(IExtensionPoint child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitExtensionPoint(child);
            return null;
        }

        @Override
        @objid ("19e520dc-4583-11e0-b54c-00137279a832")
        public Object visitFeature(IFeature child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitFeature(child);
            return null;
        }

        @Override
        @objid ("19e78331-4583-11e0-b54c-00137279a832")
        public Object visitFinalNode(IFinalNode child) {
            if (theParent == null)
                super.visitFinalNode(child);
            return null;
        }

        @Override
        @objid ("19e78337-4583-11e0-b54c-00137279a832")
        public Object visitFlowFinalNode(IFlowFinalNode child) {
            if (theParent == null)
                super.visitFlowFinalNode(child);
            return null;
        }

        @Override
        @objid ("19e9e58b-4583-11e0-b54c-00137279a832")
        public Object visitForkJoinNode(IForkJoinNode child) {
            if (theParent == null)
                super.visitForkJoinNode(child);
            return null;
        }

        @Override
        @objid ("19e9e591-4583-11e0-b54c-00137279a832")
        public Object visitForkPseudoState(IForkPseudoState child) {
            if (theParent == null)
                super.visitForkPseudoState(child);
            return null;
        }

        @Override
        @objid ("19ec47e8-4583-11e0-b54c-00137279a832")
        public Object visitGate(IGate child) {
            if (theParent == null)
                theParent = child.getOwnerFragment();
                        
            if (theParent == null)
                theParent = child.getOwnerInteraction();
                        
            if (theParent == null)
                theParent = child.getOwnerUse();
                        
            if (theParent == null)
                super.visitGate(child);
            return null;
        }

        @Override
        @objid ("19ec47ee-4583-11e0-b54c-00137279a832")
        public Object visitGeneralClass(IGeneralClass child) {
            if (theParent == null)
                super.visitGeneralClass(child);
            return null;
        }

        @Override
        @objid ("19eeaa42-4583-11e0-b54c-00137279a832")
        public Object visitGeneralOrdering(IGeneralOrdering child) {
            if (theParent == null)
                theParent = child.getBefore();
                        
            if (theParent == null)
                super.visitGeneralOrdering(child);
            return null;
        }

        @Override
        @objid ("19f10c98-4583-11e0-b54c-00137279a832")
        public Object visitGeneralization(IGeneralization child) {
            if (theParent == null)
                theParent = child.getSubType();
                        
            if (theParent == null)
                super.visitGeneralization(child);
            return null;
        }

        @Override
        @objid ("19f10c9e-4583-11e0-b54c-00137279a832")
        public Object visitInformationFlow(IInformationFlow child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitInformationFlow(child);
            return null;
        }

        @Override
        @objid ("19f36ef2-4583-11e0-b54c-00137279a832")
        public Object visitInformationItem(IInformationItem child) {
            if (theParent == null)
                super.visitInformationItem(child);
            return null;
        }

        @Override
        @objid ("19f36ef8-4583-11e0-b54c-00137279a832")
        public Object visitInitialNode(IInitialNode child) {
            if (theParent == null)
                super.visitInitialNode(child);
            return null;
        }

        @Override
        @objid ("19f5d14c-4583-11e0-b54c-00137279a832")
        public Object visitInitialPseudoState(IInitialPseudoState child) {
            if (theParent == null)
                super.visitInitialPseudoState(child);
            return null;
        }

        @Override
        @objid ("19f5d152-4583-11e0-b54c-00137279a832")
        public Object visitInputPin(IInputPin child) {
            if (theParent == null)
                theParent = child.getInputing();
                        
            if (theParent == null)
                super.visitInputPin(child);
            return null;
        }

        @Override
        @objid ("19f833aa-4583-11e0-b54c-00137279a832")
        public Object visitInstance(IInstance child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitInstance(child);
            return null;
        }

        @Override
        @objid ("19fa9600-4583-11e0-b54c-00137279a832")
        public Object visitInstanceNode(IInstanceNode child) {
            if (theParent == null)
                super.visitInstanceNode(child);
            return null;
        }

        @Override
        @objid ("19fa9606-4583-11e0-b54c-00137279a832")
        public Object visitInteraction(IInteraction child) {
            if (theParent == null)
                super.visitInteraction(child);
            return null;
        }

        @Override
        @objid ("19fcf85a-4583-11e0-b54c-00137279a832")
        public Object visitInteractionFragment(IInteractionFragment child) {
            if (theParent == null)
                theParent = child.getEnclosingInteraction();
                        
            if (theParent == null)
                theParent = child.getEnclosingOperand();
                        
            if (theParent == null)
                super.visitInteractionFragment(child);
            return null;
        }

        @Override
        @objid ("19fcf860-4583-11e0-b54c-00137279a832")
        public Object visitInteractionOperand(IInteractionOperand child) {
            if (theParent == null)
                theParent = child.getOwnerFragment();
                        
            if (theParent == null)
                super.visitInteractionOperand(child);
            return null;
        }

        @Override
        @objid ("19ff5ab4-4583-11e0-b54c-00137279a832")
        public Object visitInteractionUse(IInteractionUse child) {
            if (theParent == null)
                super.visitInteractionUse(child);
            return null;
        }

        @Override
        @objid ("19ff5aba-4583-11e0-b54c-00137279a832")
        public Object visitInterface(IInterface child) {
            if (theParent == null)
                super.visitInterface(child);
            return null;
        }

        @Override
        @objid ("1a01bd0f-4583-11e0-b54c-00137279a832")
        public Object visitInterfaceRealization(IInterfaceRealization child) {
            if (theParent == null)
                theParent = child.getImplementer();
                        
            if (theParent == null)
                super.visitInterfaceRealization(child);
            return null;
        }

        @Override
        @objid ("1a01bd15-4583-11e0-b54c-00137279a832")
        public Object visitInternalTransition(IInternalTransition child) {
            if (theParent == null)
                theParent = child.getSComposed();
                        
            if (theParent == null)
                super.visitInternalTransition(child);
            return null;
        }

        @Override
        @objid ("1a041f6c-4583-11e0-b54c-00137279a832")
        public Object visitInterruptibleActivityRegion(IInterruptibleActivityRegion child) {
            if (theParent == null)
                super.visitInterruptibleActivityRegion(child);
            return null;
        }

        @Override
        @objid ("1a0681c2-4583-11e0-b54c-00137279a832")
        public Object visitJoinPseudoState(IJoinPseudoState child) {
            if (theParent == null)
                super.visitJoinPseudoState(child);
            return null;
        }

        @Override
        @objid ("1a0681c8-4583-11e0-b54c-00137279a832")
        public Object visitJunctionPseudoState(IJunctionPseudoState child) {
            if (theParent == null)
                super.visitJunctionPseudoState(child);
            return null;
        }

        @Override
        @objid ("1a08e41e-4583-11e0-b54c-00137279a832")
        public Object visitLifeline(ILifeline child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitLifeline(child);
            return null;
        }

        @Override
        @objid ("1a08e424-4583-11e0-b54c-00137279a832")
        public Object visitLink(ILink child) {
            if (theParent == null)
                super.visitLink(child);
            return null;
        }

        @Override
        @objid ("1a08e42a-4583-11e0-b54c-00137279a832")
        public Object visitLinkEnd(ILinkEnd child) {
            if (theParent == null)
                theParent = child.getLinkNode();
                        
            if (theParent == null)
                super.visitLinkEnd(child);
            return null;
        }

        @Override
        @objid ("1a08e430-4583-11e0-b54c-00137279a832")
        public Object visitLocalNote(ILocalNote child) {
            if (theParent == null)
                super.visitLocalNote(child);
            return null;
        }

        @Override
        @objid ("1a0b4677-4583-11e0-b54c-00137279a832")
        public Object visitLocalTaggedValue(ILocalTaggedValue child) {
            if (theParent == null)
                super.visitLocalTaggedValue(child);
            return null;
        }

        @Override
        @objid ("1a0da8d0-4583-11e0-b54c-00137279a832")
        public Object visitLoopNode(ILoopNode child) {
            if (theParent == null)
                super.visitLoopNode(child);
            return null;
        }

        @Override
        @objid ("1a0da8d6-4583-11e0-b54c-00137279a832")
        public Object visitManifestation(IManifestation child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitManifestation(child);
            return null;
        }

        @Override
        @objid ("1a126d84-4583-11e0-b54c-00137279a832")
        public Object visitMessage(IMessage child) {
            if (theParent == null)
                theParent = child.getSendEvent();
                        
            if (theParent == null)
                super.visitMessage(child);
            return null;
        }

        @Override
        @objid ("1a14cfe2-4583-11e0-b54c-00137279a832")
        public Object visitMessageEnd(IMessageEnd child) {
            if (theParent == null)
                super.visitMessageEnd(child);
            return null;
        }

        @Override
        @objid ("1a173238-4583-11e0-b54c-00137279a832")
        public Object visitMessageFlow(IMessageFlow child) {
            if (theParent == null)
                theParent = child.getSourcePartition();
                        
            if (theParent == null)
                super.visitMessageFlow(child);
            return null;
        }

        @Override
        @objid ("1a17323e-4583-11e0-b54c-00137279a832")
        public Object visitModelElement(IModelElement child) {
            if (theParent == null)
                theParent = child.getOwnerTemplateParameter();
                        
            if (theParent == null)
                super.visitModelElement(child);
            return null;
        }

        @Override
        @objid ("1a199492-4583-11e0-b54c-00137279a832")
        public Object visitModelTree(IModelTree child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitModelTree(child);
            return null;
        }

        @Override
        @objid ("1a199498-4583-11e0-b54c-00137279a832")
        public Object visitNameSpace(INameSpace child) {
            if (theParent == null)
                super.visitNameSpace(child);
            return null;
        }

        @Override
        @objid ("1a1bf6f0-4583-11e0-b54c-00137279a832")
        public Object visitNamespaceUse(INamespaceUse child) {
            if (theParent == null)
                super.visitNamespaceUse(child);
            return null;
        }

        @Override
        @objid ("1a1e5946-4583-11e0-b54c-00137279a832")
        public Object visitNode(INode child) {
            if (theParent == null)
                super.visitNode(child);
            return null;
        }

        @Override
        @objid ("1a1e594c-4583-11e0-b54c-00137279a832")
        public Object visitNote(INote child) {
            if (theParent == null)
                theParent = child.getSubject();
                        
            if (theParent == null)
                super.visitNote(child);
            return null;
        }

        @Override
        @objid ("1a20bba1-4583-11e0-b54c-00137279a832")
        public Object visitNoteType(INoteType child) {
            //                        if (theParent == null)
            //                            theParent = child.getDocumented();
            
                        if (theParent == null)
                            super.visitNoteType(child);
            return null;
        }

        @Override
        @objid ("1a20bba7-4583-11e0-b54c-00137279a832")
        public Object visitObjectFlow(IObjectFlow child) {
            if (theParent == null)
                super.visitObjectFlow(child);
            return null;
        }

        @Override
        @objid ("1a231dfe-4583-11e0-b54c-00137279a832")
        public Object visitObjectNode(IObjectNode child) {
            if (theParent == null)
                super.visitObjectNode(child);
            return null;
        }

        @Override
        @objid ("1a258054-4583-11e0-b54c-00137279a832")
        public Object visitOccurrenceSpecification(IOccurrenceSpecification child) {
            if (theParent == null)
                super.visitOccurrenceSpecification(child);
            return null;
        }

        @Override
        @objid ("1a25805a-4583-11e0-b54c-00137279a832")
        public Object visitOpaqueAction(IOpaqueAction child) {
            if (theParent == null)
                super.visitOpaqueAction(child);
            return null;
        }

        @Override
        @objid ("1a27e2af-4583-11e0-b54c-00137279a832")
        public Object visitOpaqueBehavior(IOpaqueBehavior child) {
            if (theParent == null)
                super.visitOpaqueBehavior(child);
            return null;
        }

        @Override
        @objid ("1a2a4508-4583-11e0-b54c-00137279a832")
        public Object visitOperation(IOperation child) {
            if (theParent == null)
                super.visitOperation(child);
            return null;
        }

        @Override
        @objid ("1a2a450e-4583-11e0-b54c-00137279a832")
        public Object visitOutputPin(IOutputPin child) {
            if (theParent == null)
                theParent = child.getOutputing();
                        
            if (theParent == null)
                super.visitOutputPin(child);
            return null;
        }

        @Override
        @objid ("1a2ca762-4583-11e0-b54c-00137279a832")
        public Object visitPackage(IPackage child) {
            if (theParent == null)
                super.visitPackage(child);
            return null;
        }

        @Override
        @objid ("1a2ca768-4583-11e0-b54c-00137279a832")
        public Object visitPackageImport(IPackageImport child) {
            if (theParent == null)
                theParent = child.getImportingNameSpace();
                        
            if (theParent == null)
                theParent = child.getImportingOperation();
                        
            if (theParent == null)
                super.visitPackageImport(child);
            return null;
        }

        @Override
        @objid ("1a2f09c0-4583-11e0-b54c-00137279a832")
        public Object visitPackageMerge(IPackageMerge child) {
            if (theParent == null)
                theParent = child.getReceivingPackage();
                        
            if (theParent == null)
                super.visitPackageMerge(child);
            return null;
        }

        @Override
        @objid ("1a316c16-4583-11e0-b54c-00137279a832")
        public Object visitParameter(IParameter child) {
            if (theParent == null)
                theParent = child.getComposed();
                        
            if (theParent == null)
                theParent = child.getReturned();
                        
            if (theParent == null)
                super.visitParameter(child);
            return null;
        }

        @Override
        @objid ("1a316c1c-4583-11e0-b54c-00137279a832")
        public Object visitPartDecomposition(IPartDecomposition child) {
            if (theParent == null)
                super.visitPartDecomposition(child);
            return null;
        }

        @Override
        @objid ("1a33ce71-4583-11e0-b54c-00137279a832")
        public Object visitPin(IPin child) {
            if (theParent == null)
                super.visitPin(child);
            return null;
        }

        @Override
        @objid ("1a3630ca-4583-11e0-b54c-00137279a832")
        public Object visitPort(IPort child) {
            if (theParent == null)
                super.visitPort(child);
            return null;
        }

        @Override
        @objid ("1a3630d0-4583-11e0-b54c-00137279a832")
        public Object visitProject(IProject child) {
            if (theParent == null)
                super.visitProject(child);
            return null;
        }

        @Override
        @objid ("1a389324-4583-11e0-b54c-00137279a832")
        public Object visitProperty(IProperty child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitProperty(child);
            return null;
        }

        @Override
        @objid ("1a38932a-4583-11e0-b54c-00137279a832")
        public Object visitPropertyEnumerationLitteral(IPropertyEnumerationLitteral child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitPropertyEnumerationLitteral(child);
            return null;
        }

        @Override
        @objid ("1a3af582-4583-11e0-b54c-00137279a832")
        public Object visitPropertySet(IPropertySet child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitPropertySet(child);
            return null;
        }

        @Override
        @objid ("1a3d57d8-4583-11e0-b54c-00137279a832")
        public Object visitPropertyType(IPropertyType child) {
            if (theParent == null)
                theParent = child.getCompositionOwner();
                        
            if (theParent == null)
                super.visitPropertyType(child);
            return null;
        }

        @Override
        @objid ("1a3d57de-4583-11e0-b54c-00137279a832")
        public Object visitPropertyValue(IPropertyValue child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitPropertyValue(child);
            return null;
        }

        @Override
        @objid ("1a3fba34-4583-11e0-b54c-00137279a832")
        public Object visitPropertyValueSet(IPropertyValueSet child) {
            if (theParent == null)
                theParent = child.getDefaultValued();
                        
            if (theParent == null)
                theParent = child.getDefaultValuedDictionary();
                        
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                theParent = child.getOwnerTerm();
                        
            if (theParent == null)
                super.visitPropertyValueSet(child);
            return null;
        }

        @Override
        @objid ("1a421c8c-4583-11e0-b54c-00137279a832")
        public Object visitProvidedInterface(IProvidedInterface child) {
            if (theParent == null)
                theParent = child.getProviding();
                        
            if (theParent == null)
                super.visitProvidedInterface(child);
            return null;
        }

        @Override
        @objid ("1a447ee7-4583-11e0-b54c-00137279a832")
        public Object visitRaisedException(IRaisedException child) {
            if (theParent == null)
                theParent = child.getThrower();
                        
            if (theParent == null)
                super.visitRaisedException(child);
            return null;
        }

        @Override
        @objid ("1a46e140-4583-11e0-b54c-00137279a832")
        public Object visitRequiredInterface(IRequiredInterface child) {
            if (theParent == null)
                theParent = child.getRequiring();
                        
            if (theParent == null)
                super.visitRequiredInterface(child);
            return null;
        }

        @Override
        @objid ("1a46e146-4583-11e0-b54c-00137279a832")
        public Object visitRequirement(IRequirement child) {
            if (theParent == null)
                super.visitRequirement(child);
            return null;
        }

        @Override
        @objid ("1a49439b-4583-11e0-b54c-00137279a832")
        public Object visitRequirementContainer(IRequirementContainer child) {
            if (theParent == null)
                theParent = child.getRepresented();
                        
            if (theParent == null)
                super.visitRequirementContainer(child);
            return null;
        }

        @Override
        @objid ("1a4ba5f4-4583-11e0-b54c-00137279a832")
        public Object visitRequirementElement(IRequirementElement child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitRequirementElement(child);
            return null;
        }

        @Override
        @objid ("1a4ba5fa-4583-11e0-b54c-00137279a832")
        public Object visitSendSignalAction(ISendSignalAction child) {
            if (theParent == null)
                super.visitSendSignalAction(child);
            return null;
        }

        @Override
        @objid ("1a506aa9-4583-11e0-b54c-00137279a832")
        public Object visitShallowHistoryPseudoState(IShallowHistoryPseudoState child) {
            if (theParent == null)
                super.visitShallowHistoryPseudoState(child);
            return null;
        }

        @Override
        @objid ("1a52cd02-4583-11e0-b54c-00137279a832")
        public Object visitSignal(ISignal child) {
            if (theParent == null)
                super.visitSignal(child);
            return null;
        }

        @Override
        @objid ("1a52cd08-4583-11e0-b54c-00137279a832")
        public Object visitState(IState child) {
            if (theParent == null)
                theParent = child.getParent();
                        
                        //            if (theParent == null)
                        //                theParent = child.getRepresented();
                        
            if (theParent == null)
                super.visitState(child);
            return null;
        }

        @Override
        @objid ("1a552f5d-4583-11e0-b54c-00137279a832")
        public Object visitStateInvariant(IStateInvariant child) {
            if (theParent == null)
                super.visitStateInvariant(child);
            return null;
        }

        @Override
        @objid ("1a5791b6-4583-11e0-b54c-00137279a832")
        public Object visitStateMachine(IStateMachine child) {
            if (theParent == null)
                super.visitStateMachine(child);
            return null;
        }

        @Override
        @objid ("1a5791bc-4583-11e0-b54c-00137279a832")
        public Object visitStateVertex(IStateVertex child) {
            if (theParent == null)
                super.visitStateVertex(child);
            return null;
        }

        @Override
        @objid ("1a59f411-4583-11e0-b54c-00137279a832")
        public Object visitStereotype(IStereotype child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
               super.visitStereotype(child);
            return null;
        }

        @Override
        @objid ("1a5c566a-4583-11e0-b54c-00137279a832")
        public Object visitStructuredActivityNode(IStructuredActivityNode child) {
            if (theParent == null)
                super.visitStructuredActivityNode(child);
            return null;
        }

        @Override
        @objid ("1a5eb8c4-4583-11e0-b54c-00137279a832")
        public Object visitSubstitution(ISubstitution child) {
            if (theParent == null)
                theParent = child.getSubstitutingClassifier();
                        
            if (theParent == null)
                super.visitSubstitution(child);
            return null;
        }

        @Override
        @objid ("1a5eb8ca-4583-11e0-b54c-00137279a832")
        public Object visitTagParameter(ITagParameter child) {
            if (theParent == null)
                theParent = child.getAnnoted();
                        
            if (theParent == null)
                theParent = child.getQualified();
                        
            if (theParent == null)
                super.visitTagParameter(child);
            return null;
        }

        @Override
        @objid ("1a611b1f-4583-11e0-b54c-00137279a832")
        public Object visitTagType(ITagType child) {
            //                        if (theParent == null)
            //                            theParent = child.getAttributed();
            
                        if (theParent == null)
                            super.visitTagType(child);
            return null;
        }

        @Override
        @objid ("1a637d78-4583-11e0-b54c-00137279a832")
        public Object visitTaggedValue(ITaggedValue child) {
            if (theParent == null)
                theParent = child.getAnnoted();
                        
            if (theParent == null)
                super.visitTaggedValue(child);
            return null;
        }

        @Override
        @objid ("1a637d7e-4583-11e0-b54c-00137279a832")
        public Object visitTemplateBinding(ITemplateBinding child) {
            if (theParent == null)
                theParent = child.getBoundElement();
                        
            if (theParent == null)
                theParent = child.getBoundOperation();
                        
            if (theParent == null)
                super.visitTemplateBinding(child);
            return null;
        }

        @Override
        @objid ("1a65dfd4-4583-11e0-b54c-00137279a832")
        public Object visitTemplateParameter(ITemplateParameter child) {
            if (theParent == null)
                theParent = child.getParameterized();
                        
            if (theParent == null)
                theParent = child.getParameterizedOperation();
                        
            if (theParent == null)
                super.visitTemplateParameter(child);
            return null;
        }

        @Override
        @objid ("1a68422c-4583-11e0-b54c-00137279a832")
        public Object visitTemplateParameterSubstitution(ITemplateParameterSubstitution child) {
            if (theParent == null)
                theParent = child.getOwner();
                        
            if (theParent == null)
                super.visitTemplateParameterSubstitution(child);
            return null;
        }

        @Override
        @objid ("1a6aa486-4583-11e0-b54c-00137279a832")
        public Object visitTerm(ITerm child) {
            if (theParent == null)
                super.visitTerm(child);
            return null;
        }

        @Override
        @objid ("1a6aa48c-4583-11e0-b54c-00137279a832")
        public Object visitTerminatePseudoState(ITerminatePseudoState child) {
            if (theParent == null)
                super.visitTerminatePseudoState(child);
            return null;
        }

        @Override
        @objid ("1a6d06e1-4583-11e0-b54c-00137279a832")
        public Object visitTransition(ITransition child) {
            if (theParent == null)
                theParent = child.getSource();
                        
            if (theParent == null)
                super.visitTransition(child);
            return null;
        }

        @Override
        @objid ("1a6f693a-4583-11e0-b54c-00137279a832")
        public Object visitUsage(IUsage child) {
            if (theParent == null)
                super.visitUsage(child);
            return null;
        }

        @Override
        @objid ("1a6f6940-4583-11e0-b54c-00137279a832")
        public Object visitUseCase(IUseCase child) {
            if (theParent == null)
                super.visitUseCase(child);
            return null;
        }

        @Override
        @objid ("1a71cb95-4583-11e0-b54c-00137279a832")
        public Object visitUseCaseDependency(IUseCaseDependency child) {
            if (theParent == null)
                super.visitUseCaseDependency(child);
            return null;
        }

    }

}
