/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.util;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import com.modeliosoft.modelio.api.model.uml.behavior.common.ISignal;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IClass;
import com.modeliosoft.modelio.api.model.uml.statik.IClassifier;
import com.modeliosoft.modelio.api.model.uml.statik.IComponent;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.model.uml.statik.INameSpace;
import com.modeliosoft.modelio.api.model.uml.statik.INode;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.usecase.IActor;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCase;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import com.modeliosoft.modelio.xmi.plugin.XMI;
import org.eclipse.emf.common.util.EList;
import org.eclipse.uml2.uml.Abstraction;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.Action;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.ActivityNode;
import org.eclipse.uml2.uml.ActivityPartition;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.BehaviorExecutionSpecification;
import org.eclipse.uml2.uml.CallAction;
import org.eclipse.uml2.uml.CallBehaviorAction;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.ChangeEvent;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.Clause;
import org.eclipse.uml2.uml.CombinedFragment;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.ConditionalNode;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Event;
import org.eclipse.uml2.uml.ExecutionEvent;
import org.eclipse.uml2.uml.ExecutionSpecification;
import org.eclipse.uml2.uml.Gate;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.InstanceSpecification;
import org.eclipse.uml2.uml.InstanceValue;
import org.eclipse.uml2.uml.Interaction;
import org.eclipse.uml2.uml.InteractionFragment;
import org.eclipse.uml2.uml.InteractionOperand;
import org.eclipse.uml2.uml.InteractionUse;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.Lifeline;
import org.eclipse.uml2.uml.Message;
import org.eclipse.uml2.uml.MessageEnd;
import org.eclipse.uml2.uml.MessageOccurrenceSpecification;
import org.eclipse.uml2.uml.MessageSort;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.MultiplicityElement;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.OccurrenceSpecification;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.OutputPin;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageImport;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.ParameterDirectionKind;
import org.eclipse.uml2.uml.PartDecomposition;
import org.eclipse.uml2.uml.Pin;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.ReceiveOperationEvent;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.SignalEvent;
import org.eclipse.uml2.uml.Slot;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.StructuredActivityNode;
import org.eclipse.uml2.uml.TimeEvent;
import org.eclipse.uml2.uml.Transition;
import org.eclipse.uml2.uml.TransitionKind;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.Usage;
import org.eclipse.uml2.uml.ValueSpecification;
import org.eclipse.uml2.uml.Vertex;

@objid ("1a742dee-4583-11e0-b54c-00137279a832")
public class EcoreModelNavigation {

    @objid ("1a742def-4583-11e0-b54c-00137279a832")
    public static void attachAssocToNearestPkg(IModelTree currentElt, Association ecoreAssoc) {
        GenerationProperties genProp = GenerationProperties.getInstance();
        
        IPackage nearestIjingPkg = ObjingModelNavigation.getNearestPackage(currentElt);
        Namespace nearestEcorePkg = (Namespace) genProp.getMappedElement(nearestIjingPkg);
        
        if (nearestEcorePkg instanceof Package) {
            ((Package) nearestEcorePkg).getPackagedElements().add(ecoreAssoc);
        }
    }

    @objid ("1a742df3-4583-11e0-b54c-00137279a832")
    public static List<Property> getOppositeAssociationEnds(Property p1) throws AssociationNotFoundException {
        Association assoc = p1.getAssociation();
        
        if (assoc != null) {
            List<Property> oppositeEnds = new ArrayList<Property>();
            for (Object ecoreEnd : assoc.getMemberEnds()) {
                if (!ecoreEnd.equals(p1))
                    oppositeEnds.add((Property) ecoreEnd);
            }
            return oppositeEnds;
        } else {
            throw new AssociationNotFoundException("The Property \""
                    + p1.getName() + "\" is not connected to an Association.");
        }
    }

    @objid ("1a742df9-4583-11e0-b54c-00137279a832")
    public static Interaction getMostEnclosingInteraction(InteractionFragment ecoreIF) {
        InteractionFragment ecoreEnclosing = null;
        ecoreEnclosing = ecoreIF.getEnclosingInteraction();
        if (ecoreEnclosing == null) {
            ecoreEnclosing = ecoreIF.getEnclosingOperand();
            if (ecoreEnclosing == null) {
                Element owner = ecoreIF.getOwner();
                if (owner instanceof InteractionFragment)
                    ecoreEnclosing = (InteractionFragment) owner;
            }
        }
        
        if (!(ecoreEnclosing instanceof Interaction))
            ecoreEnclosing = getMostEnclosingInteraction(ecoreEnclosing);
        return (Interaction) ecoreEnclosing;
    }

    @objid ("1a742dfe-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getEnclosing(InteractionFragment sequenceElt) {
        InteractionFragment enclosing = null;
        enclosing = sequenceElt.getEnclosingInteraction();
        if (enclosing == null)
            enclosing = sequenceElt.getEnclosingOperand();
        return enclosing;
    }

    @objid ("1a769049-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getEnclosing(Message message) {
        InteractionFragment enclosing = null;
        MessageEnd event = null;
        event = message.getSendEvent();
        if (!(event instanceof MessageOccurrenceSpecification))
            event = message.getReceiveEvent();
        
        if (event instanceof MessageOccurrenceSpecification) {
            MessageOccurrenceSpecification end = (MessageOccurrenceSpecification) event;
            enclosing = end.getEnclosingInteraction();
            if (enclosing == null)
                enclosing = end.getEnclosingOperand();
        }
        return enclosing;
    }

    @objid ("1a76904e-4583-11e0-b54c-00137279a832")
    public static InteractionOperand getPreviousOperand(InteractionOperand ecoreElement) {
        Element ecoreOwner = ecoreElement.getOwner();
        if (ecoreOwner instanceof CombinedFragment) {
            CombinedFragment ecoreCF = (CombinedFragment) ecoreOwner;
            EList<?> ecoreOpList = ecoreCF.getOperands();
            if (ecoreOpList != null && ecoreOpList.size() > 0) {
                int index = ecoreOpList.indexOf(ecoreElement);
                if (index > 0)
                    return (InteractionOperand) ecoreOpList.get(index - 1);
            }
        }
        return null;
    }

    @objid ("1a769053-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getPreviousFragmentInInteraction(InteractionFragment ecoreElement) {
        Interaction interaction = ecoreElement.getEnclosingInteraction();
        if (interaction != null) {
            EList<?> fragments = interaction.getFragments();
            if (fragments != null && fragments.size() > 0) {
                int index = fragments.indexOf(ecoreElement);
                if (index > 0) {
                    InteractionFragment previous = (InteractionFragment) fragments
                    .get(index - 1);
                    if (previous instanceof ExecutionSpecification)
                        previous = getPreviousFragmentInInteraction(previous);
                    else if (previous instanceof PartDecomposition)
                        previous = getPreviousFragmentInInteraction(previous);
                    return previous;
                }
            }
        }
        return null;
    }

    @objid ("1a78f2a6-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getPreviousFragmentInInteraction(Message ecoreElement) {
        MessageOccurrenceSpecification end = null;
        MessageEnd msgEnd = null;
        msgEnd = ecoreElement.getSendEvent();
        if (!(msgEnd instanceof MessageOccurrenceSpecification))
            msgEnd = ecoreElement.getReceiveEvent();
        
        if (msgEnd instanceof MessageOccurrenceSpecification)
            end = (MessageOccurrenceSpecification) msgEnd;
        
        if (end != null){
            Interaction interaction = end.getEnclosingInteraction();
            if (interaction != null) {
                EList<?> fragments = interaction.getFragments();
                if (fragments != null && fragments.size() > 0) {
                    int index = fragments.indexOf(end);
                    if (index > 0) {
                        InteractionFragment previous = (InteractionFragment) fragments
                        .get(index - 1);
                        if (previous instanceof ExecutionSpecification)
                            previous = getPreviousFragmentInInteraction(previous);
                        else if (previous instanceof PartDecomposition)
                            previous = getPreviousFragmentInInteraction(previous);
                        return previous;
                    }
                }
            }
        }
        return null;
    }

    @objid ("1a78f2ab-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getNextFragmentInInteraction(InteractionFragment ecoreElement) {
        Interaction interaction = ecoreElement.getEnclosingInteraction();
        if (interaction != null) {
            EList<?> fragments = interaction.getFragments();
            if (fragments != null && fragments.size() > 0) {
                int index = fragments.indexOf(ecoreElement);
                if (index < (fragments.size() -1)) {
                    InteractionFragment previous = (InteractionFragment) fragments
                    .get(index + 1);
                    if (previous instanceof ExecutionSpecification)
                        previous = getPreviousFragmentInInteraction(previous);
                    else if (previous instanceof PartDecomposition)
                        previous = getPreviousFragmentInInteraction(previous);
                    return previous;
                }
            }
        }
        return null;
    }

    @objid ("1a7b54fc-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getNextFragmentInInteraction(Message ecoreElement) {
        MessageOccurrenceSpecification end = null;
        MessageEnd msgEnd = null;
        msgEnd = ecoreElement.getSendEvent();
        if (!(msgEnd instanceof MessageOccurrenceSpecification))
            msgEnd = ecoreElement.getReceiveEvent();
        
        if (msgEnd instanceof MessageOccurrenceSpecification)
            end = (MessageOccurrenceSpecification) msgEnd;
        
        if (end != null){
            Interaction interaction = end.getEnclosingInteraction();
            if (interaction != null) {
                EList<?> fragments = interaction.getFragments();
                if (fragments != null && fragments.size() > 0) {
                    int index = fragments.indexOf(end);
                    if (index < (fragments.size() -1)) {
                        InteractionFragment previous = (InteractionFragment) fragments
                        .get(index + 1);
                        if (previous instanceof ExecutionSpecification)
                            previous = getPreviousFragmentInInteraction(previous);
                        else if (previous instanceof PartDecomposition)
                            previous = getPreviousFragmentInInteraction(previous);
                        return previous;
                    }
                }
            }
        }
        return null;
    }

    @objid ("1a7b5501-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getPreviousFragmentInOperand(InteractionFragment ecoreElement) {
        InteractionOperand operand = ecoreElement.getEnclosingOperand();
        if (operand != null) {
            EList<?> fragments = operand.getFragments();
            if (fragments != null && fragments.size() > 0) {
                int index = fragments.indexOf(ecoreElement);
                if (index > 0) {
                    InteractionFragment previous = (InteractionFragment) fragments
                    .get(index - 1);
                    if (previous instanceof ExecutionSpecification)
                        previous = getPreviousFragmentInInteraction(previous);
                    else if (previous instanceof PartDecomposition)
                        previous = getPreviousFragmentInInteraction(previous);
                    return previous;
                }
            }
        }
        return null;
    }

    @objid ("1a7b5506-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getPreviousFragmentInOperand(Message ecoreElement) {
        MessageOccurrenceSpecification end = null;
        MessageEnd msgEnd = null;
        msgEnd = ecoreElement.getSendEvent();
        if (!(msgEnd instanceof MessageOccurrenceSpecification))
            msgEnd = ecoreElement.getReceiveEvent();
        
        if (msgEnd instanceof MessageOccurrenceSpecification)
            end = (MessageOccurrenceSpecification) msgEnd;
        
        if (end != null){
            InteractionOperand operand = end.getEnclosingOperand();
            if (operand != null) {
                EList<?> fragments = operand.getFragments();
                if (fragments != null && fragments.size() > 0) {
                    int index = fragments.indexOf(end);
                    if (index > 0) {
                        InteractionFragment previous = (InteractionFragment) fragments
                        .get(index - 1);
                        if (previous instanceof ExecutionSpecification)
                            previous = getPreviousFragmentInInteraction(previous);
                        else if (previous instanceof PartDecomposition)
                            previous = getPreviousFragmentInInteraction(previous);
                        return previous;
                    }
                }
            }
        }
        return null;
    }

    @objid ("1a7db756-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getNextFragmentInOperand(InteractionFragment ecoreElement) {
        InteractionOperand operand = ecoreElement.getEnclosingOperand();
        if (operand != null) {
            EList<?> fragments = operand.getFragments();
            if (fragments != null && fragments.size() > 0) {
                int index = fragments.indexOf(ecoreElement);
                if (index < (fragments.size() -1)) {
                    InteractionFragment previous = (InteractionFragment) fragments
                    .get(index - 1);
                    if (previous instanceof ExecutionSpecification)
                        previous = getPreviousFragmentInInteraction(previous);
                    else if (previous instanceof PartDecomposition)
                        previous = getPreviousFragmentInInteraction(previous);
                    return previous;
                }
            }
        }
        return null;
    }

    @objid ("1a7db75b-4583-11e0-b54c-00137279a832")
    public static InteractionFragment getNextFragmentInOperand(Message ecoreElement) {
        MessageOccurrenceSpecification end = null;
        MessageEnd msgEnd = null;
        msgEnd = ecoreElement.getSendEvent();
        if (!(msgEnd instanceof MessageOccurrenceSpecification))
            msgEnd = ecoreElement.getReceiveEvent();
        
        if (msgEnd instanceof MessageOccurrenceSpecification)
            end = (MessageOccurrenceSpecification) msgEnd;
        
        if (end != null){
            InteractionOperand operand = end.getEnclosingOperand();
            if (operand != null) {
                EList<?> fragments = operand.getFragments();
                if (fragments != null && fragments.size() > 0) {
                    int index = fragments.indexOf(end);
                    if (index < (fragments.size() -1)) {
                        InteractionFragment previous = (InteractionFragment) fragments
                        .get(index - 1);
                        if (previous instanceof ExecutionSpecification)
                            previous = getPreviousFragmentInInteraction(previous);
                        else if (previous instanceof PartDecomposition)
                            previous = getPreviousFragmentInInteraction(previous);
                        return previous;
                    }
                }
            }
        }
        return null;
    }

    @objid ("1a7db760-4583-11e0-b54c-00137279a832")
    public static Gate getFormalGate(Interaction referedInteraction, Gate actualGate) {
        Gate referedGate = null;
        if (referedInteraction != null) {
            String actualName = actualGate.getName();
            for (Object gate : referedInteraction.getFormalGates()) {            
                Gate formalGate = (Gate) gate;
                String formalName = formalGate.getName();
                if (actualName != null && formalName != null
                        && actualName.equals(formalName)) {
                    referedGate = formalGate;
                    break;
                }
            }
        }
        return referedGate;
    }

    @objid ("1a8019b2-4583-11e0-b54c-00137279a832")
    public static Message getReplyMessage(Message message) {
        boolean isSynchronous = false;
        MessageSort msgSort = message.getMessageSort();
        if (msgSort.getValue() == MessageSort.SYNCH_CALL)
            isSynchronous = true;
        
        if (isSynchronous) {
            MessageEnd receiveEnd = message.getReceiveEvent();
            if (receiveEnd != null){
        
                Lifeline coveredLL = null;
        
                if (receiveEnd instanceof MessageOccurrenceSpecification)
                    coveredLL =(Lifeline) ((MessageOccurrenceSpecification)receiveEnd).getCovereds().get(0);
                else if (receiveEnd instanceof Gate)
                    coveredLL =(Lifeline) ((InteractionUse)((Gate)receiveEnd).getOwner()).getCovereds().get(0);
        
                if (coveredLL != null){
                    EList<?> coveringFragments = coveredLL.getCoveredBys();
                    int index = coveringFragments.indexOf(receiveEnd);
                    int fragmentsNumber = coveringFragments.size();
                    int indexOfEOS = index + 1;
                    if (indexOfEOS < coveringFragments.size()){ // EBR
                        InteractionFragment next = (InteractionFragment) coveringFragments
                        .get(indexOfEOS);
                        while (indexOfEOS < fragmentsNumber - 1
                                && !(next instanceof ExecutionSpecification)) {
                            next = (InteractionFragment) coveringFragments
                            .get(++indexOfEOS);
                        }
        
                        if (next instanceof ExecutionSpecification) {
                            OccurrenceSpecification finishEnd = ((ExecutionSpecification) next)
                            .getFinish();
                            if (finishEnd instanceof MessageOccurrenceSpecification) {
                                return ((MessageOccurrenceSpecification) finishEnd)
                                .getMessage();
                            }
                        }
                    }
                }
        
                return null;
        
            }
        }
        return null; //EBR
    }

    @objid ("1a8019b7-4583-11e0-b54c-00137279a832")
    public static boolean isLostMessage(Message message) {
        boolean isLost = false;
        MessageEnd receiveEnd = message.getReceiveEvent();
        
        if (receiveEnd == null)
            isLost = true;
        else if (receiveEnd instanceof MessageOccurrenceSpecification) {
            MessageOccurrenceSpecification end = (MessageOccurrenceSpecification) receiveEnd;
            EList<?> covereds = end.getCovereds();
            if (covereds == null || covereds.size() == 0)
                isLost = true;
        }
        return isLost;
    }

    @objid ("1a8019bc-4583-11e0-b54c-00137279a832")
    public static boolean isFoundMessage(Message message) {
        boolean isFound = false;
        MessageEnd sendEnd = message.getSendEvent();
        
        if (sendEnd == null)
            isFound = true;
        else if (sendEnd instanceof MessageOccurrenceSpecification) {
            MessageOccurrenceSpecification end = (MessageOccurrenceSpecification) sendEnd;
            EList<?> covereds = end.getCovereds();
            if (covereds == null || covereds.size() == 0)
                isFound = true;
        }
        return isFound;
    }

    @objid ("1a827c0b-4583-11e0-b54c-00137279a832")
    public static Interaction getMostEnclosingInteraction(Message ecoreElement) {
        MessageEnd end = ecoreElement.getSendEvent();
        if (!(end instanceof MessageOccurrenceSpecification))
            end = ecoreElement.getReceiveEvent();
        
        if (end instanceof MessageOccurrenceSpecification)
            return getMostEnclosingInteraction((MessageOccurrenceSpecification) end);
        else
            return null;
    }

    @objid ("1a827c0f-4583-11e0-b54c-00137279a832")
    public static Interaction getMostEnclosingInteraction(Gate ecoreGate) {
        Message message = ecoreGate.getMessage();
        if (message != null) {
            MessageEnd end = message.getSendEvent();
            if (end == null || end.equals(ecoreGate))
                end = message.getReceiveEvent();
        
            if (end instanceof MessageOccurrenceSpecification) {
                return getMostEnclosingInteraction((MessageOccurrenceSpecification) end);
            }
        }
        return null;
    }

    @objid ("1a827c14-4583-11e0-b54c-00137279a832")
    public static Gate getFormalGate(Gate actualGate) {
        Element gateOwner = actualGate.getOwner();
        if (gateOwner instanceof InteractionUse) {
            Interaction refered = ((InteractionUse) gateOwner).getRefersTo();
            return getFormalGate(refered, actualGate);
        }
        return null;
    }

    @objid ("1a84de68-4583-11e0-b54c-00137279a832")
    public static Gate getReferedGate(Gate ecoreGate) {
        Gate referedGate = null;
        
        if (!isFormalGate(ecoreGate)) {
            Element owner = ecoreGate.getOwner();
            if (owner instanceof InteractionUse)
                referedGate = getFormalGate(ecoreGate);
        }
        // else: case of a formal Gate. As we can't get the Interactions that
        // refer
        // to another Interaction, it is not possible to get the related actual
        // Gates (Ecore limitation due to unidirectional meta-relations).
        return referedGate;
    }

    @objid ("1a84de6d-4583-11e0-b54c-00137279a832")
    public static BehaviorExecutionSpecification getFinalExecutionSpecification(MessageOccurrenceSpecification executionSpecification) {
        EList<?> covereds = executionSpecification.getCovereds();
        
        if (covereds.size() > 0){
            Lifeline lifeline = (Lifeline) covereds.get(0);
            EList<?> fragmentsList =  lifeline.getCoveredBys();
        
            for (Object fragment : fragmentsList){
                if (fragment instanceof BehaviorExecutionSpecification){
                    BehaviorExecutionSpecification behaviorExecutionSpecification = (BehaviorExecutionSpecification) fragment;
                    if (behaviorExecutionSpecification.getFinish().equals(executionSpecification))
                        return behaviorExecutionSpecification;
                }
            }
        
        }
        return null;
    }

    @objid ("1a84de72-4583-11e0-b54c-00137279a832")
    public static boolean isFormalGate(Gate ecoreGate) {
        Interaction enclosing = getMostEnclosingInteraction(ecoreGate);
        
        for (Object formal : enclosing.getFormalGates()) {
            if (formal.equals(ecoreGate))
                return true;
        }
        return false;
    }

    @objid ("1a8740c0-4583-11e0-b54c-00137279a832")
    public static boolean isInClause(ActivityNode node) {
        StructuredActivityNode structuredNode = node.getInStructuredNode();
        
        if (structuredNode instanceof ConditionalNode) {
            for (Object clause : ((ConditionalNode) structuredNode)
                    .getClauses()) {
                for (Object innerNode : ((Clause) clause).getTests()) {
                    if (innerNode.equals(node))
                        return true;
                }
        
                for (Object innerNode : ((Clause) clause).getBodies()) {
                    if (innerNode.equals(node))
                        return true;
                }
            }
        }
        return false;
    }

    @objid ("1a8740c5-4583-11e0-b54c-00137279a832")
    public static Clause getOwnerClause(ActivityNode node) {
        StructuredActivityNode structuredNode = node.getInStructuredNode();
        
        if (structuredNode instanceof ConditionalNode) {
            for (Object clause : ((ConditionalNode) structuredNode)
                    .getClauses()) {
                for (Object innerNode : ((Clause) clause).getTests()) {
                    if (innerNode.equals(node))
                        return (Clause) clause;
                }
        
                for (Object innerNode : ((Clause) clause).getBodies()) {
                    if (innerNode.equals(node))
                        return (Clause) clause;
                }
            }
        }
        return null;
    }

    @objid ("1a8740ca-4583-11e0-b54c-00137279a832")
    public static boolean isInPartition(ActivityNode node) {
        EList<?> partitionList = node.getInPartitions();
        if (partitionList != null && partitionList.size() > 0)
            return true;
        else
            return false;
    }

    @objid ("1a89a319-4583-11e0-b54c-00137279a832")
    public static List<ActivityPartition> getOwnerPartitions(ActivityNode node) {
        List<ActivityPartition> partitionList = new ArrayList<ActivityPartition>();
        for (Object partition : node.getInPartitions()) {
            partitionList.add((ActivityPartition) partition);
        }
        return partitionList;
    }

    @objid ("1a89a320-4583-11e0-b54c-00137279a832")
    public static ActivityPartition getLeafPartition(List<ActivityPartition> ecorePartitions) {
        for (ActivityPartition currentPartition : ecorePartitions) {
            EList<?> subPartitions = currentPartition.getSubpartitions();
            if (subPartitions == null || subPartitions.size() == 0)
                return currentPartition;
        }
        return null;
    }

    @objid ("1a8c0572-4583-11e0-b54c-00137279a832")
    public static boolean isInStructuredActivityNode(ActivityNode node) {
        StructuredActivityNode structuredNode = node.getInStructuredNode();
        if (structuredNode != null)
            return true;
        else
            return false;
    }

    @objid ("1a8c0576-4583-11e0-b54c-00137279a832")
    public static StructuredActivityNode getOwnerStructuredActivityNode(ActivityNode node) {
        return node.getInStructuredNode();
    }

    @objid ("1a8c057b-4583-11e0-b54c-00137279a832")
    public static boolean isInActivity(ActivityNode node) {
        Activity activity = node.getActivity();
        if (activity != null)
            return true;
        else
            return false;
    }

    @objid ("1a8e67cc-4583-11e0-b54c-00137279a832")
    public static Activity getOwnerActivity(ActivityNode node) {
        return node.getActivity();
    }

    @objid ("1a8e67d1-4583-11e0-b54c-00137279a832")
    public static boolean hasReceiveOperationEvent(AcceptEventAction action) {
        for (Object trigger : action.getTriggers()) {
            Event event = ((Trigger) trigger).getEvent();
            if (event instanceof ReceiveOperationEvent)
                return true;
        }
        return false;
    }

    @objid ("1a8e67d6-4583-11e0-b54c-00137279a832")
    public static boolean hasSignalEvent(AcceptEventAction action) {
        for (Object trigger : action.getTriggers()) {
            Event event = ((Trigger) trigger).getEvent();
            if (event instanceof SignalEvent)
                return true;
        }
        return false;
    }

    @objid ("1a90ca26-4583-11e0-b54c-00137279a832")
    public static boolean hasChangeEvent(AcceptEventAction action) {
        for (Object trigger : action.getTriggers()) {
            Event event = ((Trigger) trigger).getEvent();
            if (event instanceof ChangeEvent)
                return true;
        }
        return false;
    }

    @objid ("1a90ca2b-4583-11e0-b54c-00137279a832")
    public static boolean hasTimeEvent(AcceptEventAction action) {
        for (Object trigger : action.getTriggers()) {
            Event event = ((Trigger) trigger).getEvent();
            if (event instanceof TimeEvent)
                return true;
        }
        return false;
    }

    @objid ("1a90ca30-4583-11e0-b54c-00137279a832")
    public static List<Parameter> getMatchedParameters(InputPin pin) {
        CallAction pinOwner = (CallAction) pin.getOwner();
        List<Parameter> paramList = new ArrayList<Parameter>();
        
        if (pinOwner instanceof CallOperationAction) {
            Operation operation = ((CallOperationAction) pinOwner)
            .getOperation();
            if (operation != null) {
                for (Parameter param : operation.getOwnedParameters()) {
                    if (param.getDirection().equals(ParameterDirectionKind.IN_LITERAL) 
                            || param.getDirection().equals(ParameterDirectionKind.INOUT_LITERAL) )
                        paramList.add( param);
                }
            }
        } else if (pinOwner instanceof CallBehaviorAction) {
            Behavior behavior = ((CallBehaviorAction) pinOwner).getBehavior();
            if (behavior != null) {
                for (Parameter param : behavior.getOwnedParameters()) {
                    if (param.getDirection().equals(ParameterDirectionKind.IN_LITERAL) 
                            || param.getDirection().equals(ParameterDirectionKind.INOUT_LITERAL) )
                        paramList.add( param);
                }
            }
        }
        return paramList;
    }

    @objid ("1a932c81-4583-11e0-b54c-00137279a832")
    public static boolean isCondition(Constraint constraint) {
        for (Object constrainedElt : constraint.getConstrainedElements()) {
            if (constrainedElt instanceof Transition)
                return true;
        }
        return false;
    }

    @objid ("1a932c86-4583-11e0-b54c-00137279a832")
    public static Region getMostEnclosingRegion(Vertex vertex) {
        Region region = vertex.getContainer();
        if (region != null) {
            StateMachine ownerSM = region.getStateMachine();
            if (ownerSM != null)
                return region;
        
            State ownerState = region.getState();
            if (ownerState != null)
                return getMostEnclosingRegion(ownerState);
        }
        return null;
    }

    @objid ("1a932c8b-4583-11e0-b54c-00137279a832")
    public static StateMachine getMostEnclosingStateMachine(Vertex vertex) {
        Region region = getMostEnclosingRegion(vertex);
        if (region != null)
            return region.getStateMachine();
        return null;
    }

    @objid ("1a958edc-4583-11e0-b54c-00137279a832")
    public static StateMachine getMostEnclosingStateMachine(Transition transition) {
        Region region = transition.getContainer();
        
        if (region != null) {
            StateMachine ownerSM = region.getStateMachine();
            if (ownerSM != null)
                return ownerSM;
        
            State ownerState = region.getState();
            if (ownerState != null)
                return getMostEnclosingStateMachine(ownerState);
        }
        return null;
    }

    @objid ("1a958ee1-4583-11e0-b54c-00137279a832")
    public static boolean isChildOfRootRegion(Vertex state) {
        Region rootRegion = getMostEnclosingRegion(state);
        Region container = state.getContainer();
        if (container != null && container.equals(rootRegion))
            return true;
        return false;
    }

    @objid ("1a97f135-4583-11e0-b54c-00137279a832")
    public static boolean hasUniqueRootRegion(StateMachine stateMachine) {
        EList<?> rootRegionList = stateMachine.getRegions();
        if (rootRegionList.size() == 1)
            return true;
        return false;
    }

    @objid ("1a97f13a-4583-11e0-b54c-00137279a832")
    public static boolean isEffectsBehavior(Behavior behavior) {
        return (behavior.getOwner() instanceof Transition);
    }

    @objid ("1a9a538e-4583-11e0-b54c-00137279a832")
    public static boolean isTriggerEvent(ExecutionEvent event) {
        return (event.getOwner() instanceof Trigger);
    }

    @objid ("1a9a5393-4583-11e0-b54c-00137279a832")
    public static boolean isInternalTransition(Transition transition) {
        if (TransitionKind.INTERNAL_LITERAL.equals(transition.getKind()))
            return true;
        return false;
    }

    @objid ("1a9a5398-4583-11e0-b54c-00137279a832")
    public static boolean isMergedBehavior(Behavior behavior) {
        for (Object clientDependency : behavior.getClientDependencies()) {
            for (Object ecoreSupplier : ((Dependency) clientDependency)
                    .getSuppliers()) {
                if (ecoreSupplier instanceof Signal)
                    return true;
            }
        }
        return false;
    }

    @objid ("1a9cb5e8-4583-11e0-b54c-00137279a832")
    public static boolean isModelChild(Element element) {
        List<Element> listRoot = new ArrayList<Element>();
        Set<Package> roots = ReverseProperties.getInstance().getEcoreModel();
        listRoot.addAll(roots);
        for(Package root : roots){
            for (Object packageImport : root.getPackageImports()){
                listRoot.add(((PackageImport) packageImport).getImportedPackage());
            }
        }
        
        List<Package> listPackages = topOwners(element);
        
        for (Object pack : listRoot){
            if (listPackages.contains(pack))
                return true;
        }
        return false;
    }

    @objid ("1a9cb5ed-4583-11e0-b54c-00137279a832")
    public static List<Package> topOwners(Element element) {
        List<Package> listPackages = new ArrayList<Package>();
        
        if (element instanceof Package)
            listPackages.add((Package) element);
        
        Element owner = element.getOwner();
        while (owner != null) {
        
            if (owner instanceof Package)
                listPackages.add((Package) owner);
        
            element = owner;
            owner = element.getOwner();        
        }
        return listPackages;
    }

    @objid ("1a9f1844-4583-11e0-b54c-00137279a832")
    public static Package getRoot(Package ecorePackage) {
        Element root = ecorePackage;
        while (!(root instanceof Model) && (root.getOwner() != null)){
            root = root.getOwner();
        }
        if (root instanceof Package)
            return (Package) root;
        else 
            return ecorePackage;
    }

    @objid ("1a9f1848-4583-11e0-b54c-00137279a832")
    public static IModelTree getNearestDataTypeOwner(Element ecoreElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        Element ecoreParent = ecoreElt;
        IElement objParent = (IElement) revProp.getMappedElement(ecoreParent);
        while (!((objParent instanceof IPackage) 
                ||(objParent instanceof IComponent)
                ||(objParent instanceof IClass)
                ||(objParent instanceof IInterface)
                ||(objParent instanceof ISignal)) 
                && (ecoreParent.getOwner() != null)){
            ecoreParent = ecoreParent.getOwner();
            objParent = (IElement) revProp.getMappedElement(ecoreParent);
        }
        if ((objParent instanceof IPackage) 
                ||(objParent instanceof IComponent)
                ||(objParent instanceof IClass)
                ||(objParent instanceof IInterface)
                ||(objParent instanceof ISignal))
            return (IModelTree) objParent;
        else 
            return null;
    }

    @objid ("1a9f184c-4583-11e0-b54c-00137279a832")
    public static INameSpace getNearestNameSpace(Element ecoreElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        Element ecoreParent = ecoreElt;
        IElement objParent = (IElement) revProp.getMappedElement(ecoreParent);
        while (!(objParent instanceof INameSpace)  
                && (ecoreParent.getOwner() != null)){
            ecoreParent = ecoreParent.getOwner();
            objParent = (IElement) revProp.getMappedElement(ecoreParent);
        }
        if (objParent instanceof INameSpace) 
            return (INameSpace) objParent;
        else 
            return null;
    }

    @objid ("1aa17a9c-4583-11e0-b54c-00137279a832")
    public static IModelTree getNearestEnumerationOwner(Element ecoreElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        Element ecoreParent = ecoreElt;
        IElement objParent = (IElement) revProp.getMappedElement(ecoreParent);
        while (!((objParent instanceof IPackage) 
                ||(objParent instanceof IComponent)
                ||(objParent instanceof IClass)
                ||(objParent instanceof IInterface)
                ||(objParent instanceof ISignal)
                ||(objParent instanceof ITemplateParameter)) 
                && (ecoreParent.getOwner() != null)){
            ecoreParent = ecoreParent.getOwner();
            objParent = (IElement) revProp.getMappedElement(ecoreParent);
        }
        if ((objParent instanceof IPackage) 
                ||(objParent instanceof IComponent)
                ||(objParent instanceof IClass)
                ||(objParent instanceof IInterface)
                ||(objParent instanceof ISignal)
                ||(objParent instanceof ITemplateParameter))
            return (IModelTree) objParent;
        else 
            return null;
    }

    @objid ("1aa17aa0-4583-11e0-b54c-00137279a832")
    public static IModelTree getNearestStateMachineOwner(Element ecoreElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        Element ecoreParent = ecoreElt;
        IElement objParent = (IElement) revProp.getMappedElement(ecoreParent);
        while (!((objParent instanceof INameSpace) 
                ||(objParent instanceof IOperation)) 
                && (ecoreParent.getOwner() != null)){
            ecoreParent = ecoreParent.getOwner();
            objParent = (IElement) revProp.getMappedElement(ecoreParent);
        }
        if ((objParent instanceof INameSpace) 
                ||(objParent instanceof IOperation))
            return (IModelTree) objParent;
        else 
            return null;
    }

    @objid ("1aa17aa4-4583-11e0-b54c-00137279a832")
    public static INameSpace getNearestOpaqueBehaviorOwner(Element ecoreElt) {
        ReverseProperties revProp = ReverseProperties.getInstance();
        Element ecoreParent = ecoreElt;
        IElement objParent = (IElement) revProp.getMappedElement(ecoreParent);
        while (!(objParent instanceof INameSpace ) 
                && (ecoreParent.getOwner() != null)){
            ecoreParent = ecoreParent.getOwner();
            objParent = (IElement) revProp.getMappedElement(ecoreParent);
        }
        if (objParent instanceof INameSpace) 
            return (INameSpace) objParent;
        else 
            return null;
    }

    @objid ("6e3f8b32-1a76-11e1-8103-0027103f347d")
    public static boolean isAssocEnd(final Property ecoreElement) {
        if (!(ecoreElement.getOwner() instanceof Stereotype)){
        
            return (ecoreElement.getAssociation() != null);
        
        }
        return false;
    }

    @objid ("6e3fd956-1a76-11e1-8103-0027103f347d")
    public static boolean isPart(final Property ecoreElement) {
        if (!(ecoreElement.getOwner() instanceof Stereotype)){
            return ((ecoreElement.isComposite()  && ((ecoreElement.getAssociation() == null))
                    && (!(ecoreElement.getOwner() instanceof Interface))) ||
                    (ecoreElement.getOwner() instanceof Interaction || 
                            ((ecoreElement.getOwner() != null) && (ecoreElement.getOwner().getOwner() instanceof Interaction))));
        
        }
        return false;
    }

    @objid ("6e400069-1a76-11e1-8103-0027103f347d")
    public static boolean isPort(final Property ecoreElement) {
        return (ecoreElement instanceof Port);
    }

    @objid ("6e40277d-1a76-11e1-8103-0027103f347d")
    private static boolean isValidPropertyOwner(final Type ecoreType) {
        if (ecoreType != null) {
            Object objingOwner = ReverseProperties.getInstance().getMappedElement(ecoreType);
            if ((objingOwner != null) 
                    && ((objingOwner instanceof IClassifier) && 
                            ((objingOwner instanceof IClass) || (objingOwner instanceof IInterface) || (objingOwner instanceof IComponent)
                                    || (objingOwner instanceof IActor) || (objingOwner instanceof IDataType) || (objingOwner instanceof INode) 
                                    || (objingOwner instanceof ISignal)|| (objingOwner instanceof IUseCase)))){
                return true;
            }
        }
        return false;
    }

    @objid ("6e40759e-1a76-11e1-8103-0027103f347d")
    public static boolean isValid(final Property ecoreElement) {
        List<Property> oppositeEnds;
        try {
            oppositeEnds = EcoreModelNavigation
            .getOppositeAssociationEnds(ecoreElement);
        
            int nbEnds = oppositeEnds.size();
        
            if (nbEnds == 1) {
                // Case of a binary Association
                return isValidPropertyOwner(oppositeEnds.get(0).getType());
            } else if (nbEnds > 1) {// (in Ecore, an association may have only
                // one member end (which does
                // not have any sense ...)
                // Case of a N ary association
                return isValidPropertyOwner( ecoreElement.getType());
            }
        } catch (AssociationNotFoundException e) {
            e.printStackTrace(Modelio.err);
        }
        return false;
    }

    @objid ("6e409cb1-1a76-11e1-8103-0027103f347d")
    public static boolean hasTwoValidEnds(final Association ecoreElement) {
        int endNumber = 0;
        for (Object memberEnd : ecoreElement.getMemberEnds()) {
            if ((memberEnd instanceof Property) && (isValid((Property) memberEnd)))
                endNumber++;
        
        }
        return endNumber > 1;
    }

    @objid ("6e40c3c5-1a76-11e1-8103-0027103f347d")
    public static boolean isMetaclass(final Class ecoreClass) {
        boolean isMetaclass = false;
        for (Stereotype ster : ecoreClass.getAppliedStereotypes()){
            if (ster.getName().equals("Metaclass")){
                isMetaclass = true;
                break;
            }
        }
        
        if (!isMetaclass){
            return false;
        }
        
        Element owner = ecoreClass.getOwner();
        return ((owner instanceof Model ) &&
                ((Model)owner).getName().equals(UMLMetamodel.getInstance().getUMLMetamodel().getName()));
    }

    @objid ("6e4111e6-1a76-11e1-8103-0027103f347d")
    public static void unsupportedOwnedWithIj(final IElement objingOwner, final IModelElement objingElement) {
        String eltName = objingElement.getName();
        String eltClassName = objingElement.getClass().getSimpleName()
        .substring(2);
        String ownerClassName = objingOwner.getClass().getSimpleName()
        .substring(2);
        XMILogs.getInstance().writelnInLog(
                XMI.I18N.getMessage("logFile.warning.unsupportedOwnerImport",
                        eltName, eltClassName, ownerClassName));
    }

    @objid ("6e4138fa-1a76-11e1-8103-0027103f347d")
    public static boolean isNotNull(final String text) {
        return (text != null);
    }

    @objid ("6e41871c-1a76-11e1-8103-0027103f347d")
    public static boolean isLinked(final Constraint ecoreElement) {
        EList<?> ecoreConstrainedElts = ecoreElement.getConstrainedElements();
        
        if (ecoreConstrainedElts.size() > 0) {
            for (Object elt : ecoreConstrainedElts) {
                if ( (elt instanceof Element) && (elt != null)){
                    Element ecoreConstrainedElt = (Element) elt;
                    Object object =  ReverseProperties.getInstance().getMappedElement(ecoreConstrainedElt);
        
                    if ((object instanceof IModelElement) || (ecoreConstrainedElt instanceof Abstraction)
                            || (ecoreConstrainedElt instanceof Comment) || (ecoreConstrainedElt instanceof Usage))
                        return  true;
        
        
                }
            }
        }
        return false;
    }

    @objid ("6e41ae2e-1a76-11e1-8103-0027103f347d")
    public static boolean isInAction(final ActivityNode ecoreElement) {
        return (ecoreElement.getOwner() instanceof Action);
    }

    @objid ("6e41d542-1a76-11e1-8103-0027103f347d")
    private static List<IElement> getIjSlots(final InstanceSpecification ecoreLink) {
        List<IElement> result = new  ArrayList<IElement>();
        EList<Slot> slots = ecoreLink.getSlots();
        ReverseProperties revProp = ReverseProperties.getInstance();
        for (Slot slot: slots ){
            EList<ValueSpecification> values = slot.getValues();
            for (ValueSpecification value :values){
                if ((value instanceof InstanceValue) && (((InstanceValue) value).getInstance() != null)){
                    result.add((IElement)revProp.getMappedElement(((InstanceValue ) value).getInstance()));
                }
            }
        }
        return result;
    }

    @objid ("6e422364-1a76-11e1-8103-0027103f347d")
    public static boolean isLink(final InstanceSpecification ecoreLink) {
        List<IElement> objEnds = EcoreModelNavigation.getIjSlots(ecoreLink);
        if (objEnds.size() >= 2){
            for (IElement objEnd : objEnds){
                if (!(objEnd instanceof IInstance)){
                    return false;
                }
            }
        }else{
            return false;
        }
        return true;
    }

    @objid ("6e424a79-1a76-11e1-8103-0027103f347d")
    public static boolean isConnector(final InstanceSpecification ecoreLink) {
        List<IElement> objEnds = EcoreModelNavigation.getIjSlots(ecoreLink);
        
        if (objEnds.size() >= 2){
            for (IElement objEnd : objEnds){
                if (!(objEnd instanceof IInstance) || !(objEnd instanceof IBindableInstance)){
                    return false;
                }
            }
        }else{
            return false;
        }
        return true;
    }

    @objid ("6e42989a-1a76-11e1-8103-0027103f347d")
    public static boolean isAssocInstance(final InstanceSpecification ecoreLink) {
        EList<Classifier> types = ecoreLink.getClassifiers();
        ReverseProperties revProp = ReverseProperties.getInstance();
        
        for (Classifier currentType : types){
            if (!(revProp.getMappedElement(currentType) instanceof IAssociation))
                return false;
        }
        return true;
    }

    @objid ("6e42bfae-1a76-11e1-8103-0027103f347d")
    public static String getMultiplicityMax(final MultiplicityElement ecoreElt) {
        ValueSpecification upperValue = ecoreElt.getUpperValue();
        if (upperValue != null) {
            String multMax = upperValue.stringValue();
            if (multMax != null)
                return multMax;
            else
                return "0";
        }else
            return "1";
    }

    @objid ("6e430dd0-1a76-11e1-8103-0027103f347d")
    public static String getMultiplicityMin(final MultiplicityElement ecoreElt) {
        ValueSpecification lowerValue = ecoreElt.getLowerValue();
        if (lowerValue != null) {
            String multMin = lowerValue.stringValue();
            if (multMin != null)
                return multMin;
            else return "0";
        }else 
            return "1";
    }

    @objid ("6e4334e2-1a76-11e1-8103-0027103f347d")
    public static int getOrdering(final Pin pin) {
        int result = 0;
        CallAction pinOwner = (CallAction) pin.getOwner();
        for (Element ownedElt : pinOwner.getOwnedElements()){
            if (ownedElt.equals(pin))
                return result;
            else if (ownedElt instanceof Pin){
                result++;
            }
        }
        return result;
    }

    @objid ("6e438306-1a76-11e1-8103-0027103f347d")
    public static int getOrdering(final Parameter parameter) {
        int result = 0;
        Element paramOwner =  parameter.getOwner();
        for (Element ownedElt : paramOwner.getOwnedElements()){
            if (ownedElt.equals(parameter))
                return result;
            else if (ownedElt instanceof Parameter){
                result++;
            }
        }
        return result;
    }

    @objid ("6e43aa19-1a76-11e1-8103-0027103f347d")
    public static List<Parameter> getMatchedParameters(final OutputPin pin) {
        CallAction pinOwner = (CallAction) pin.getOwner();
        List<Parameter> paramList = new ArrayList<Parameter>();
        
        if (pinOwner instanceof CallOperationAction) {
            Operation operation = ((CallOperationAction) pinOwner)
            .getOperation();
            if (operation != null) {
                for (Parameter param : operation.getOwnedParameters()) {
                    if (!(param.getDirection().equals(ParameterDirectionKind.IN_LITERAL)))
                        paramList.add( param);
                }
            }
        } else if (pinOwner instanceof CallBehaviorAction) {
            Behavior behavior = ((CallBehaviorAction) pinOwner).getBehavior();
            if (behavior != null) {
                for (Parameter param : behavior.getOwnedParameters()) {
                    if (!(param.getDirection().equals(ParameterDirectionKind.IN_LITERAL)))
                        paramList.add( param);
                }
            }
        }
        return paramList;
    }

}
