/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.util;

import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.utils.IObListFilter;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

@objid ("1aa17aa8-4583-11e0-b54c-00137279a832")
public class ExcludeElementFilter implements IObListFilter {
    @objid ("1aa3dcf6-4583-11e0-b54c-00137279a832")
    private IElement excludedElt;


    @objid ("1aa3dcf7-4583-11e0-b54c-00137279a832")
    public ExcludeElementFilter(IElement newExcludedElt) {
        excludedElt = newExcludedElt;
    }

    @objid ("1aa3dcfa-4583-11e0-b54c-00137279a832")
    public boolean select(IElement eltToBeFiltered) {
        return !excludedElt.equals(eltToBeFiltered);
    }

    @objid ("1aa3dcff-4583-11e0-b54c-00137279a832")
    public IElement getExcludedElt() {
        // Automatically generated method. Please delete this comment before entering specific code.
        return this.excludedElt;
    }

}
