/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  

package com.modeliosoft.modelio.xmi.util;

import java.util.List;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.emf.ecore.EAnnotation;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.Pin;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.ValueSpecification;

@objid ("1bc6bbdb-4583-11e0-b54c-00137279a832")
public class ObjingEAnnotation extends XMIEAnnotation {
	@objid ("1bc6bbde-4583-11e0-b54c-00137279a832")
	public static final String ELT_ID = "ID";

	@objid ("1bc6bbe2-4583-11e0-b54c-00137279a832")
	public static final String IS_MAIN = "isMain";

	public static final String ECOREID = "EcoreId";

	@objid ("1bc91e37-4583-11e0-b54c-00137279a832")
	public static final String IS_ELEMENTARY = "isPrimitive";

	@objid ("1bc91e39-4583-11e0-b54c-00137279a832")
	public static final String TYPE_CONSTRAINT = "TypeConstraint";

	@objid ("1bc91e3b-4583-11e0-b54c-00137279a832")
	public static final String IS_DERIVED = "isDerived";

	@objid ("1bc91e3d-4583-11e0-b54c-00137279a832")
	public static final String IS_ABSTRACT = "isAbstract";

	@objid ("1bc91e3f-4583-11e0-b54c-00137279a832")
	public static final String ACCESS_MODE = "AccessMode";

	@objid ("1bcb808f-4583-11e0-b54c-00137279a832")
	public static final String READ_VALUE = "read";

	@objid ("1bcb8091-4583-11e0-b54c-00137279a832")
	public static final String WRITE_VALUE = "write";

	@objid ("1bcb8093-4583-11e0-b54c-00137279a832")
	public static final String READ_WRITE_VALUE = "read_write";

	@objid ("1bcb8095-4583-11e0-b54c-00137279a832")
	public static final String ACCESS_NONE_VALUE = "no_access";

	@objid ("1bcb8097-4583-11e0-b54c-00137279a832")
	public static final String IS_CREATE = "isCreate";

	@objid ("1bcb8099-4583-11e0-b54c-00137279a832")
	public static final String IS_DESTROY = "isDestroy";

	@objid ("1bcde2e9-4583-11e0-b54c-00137279a832")
	public static final String DISCRIMINATOR = "Discriminator";

	@objid ("1bcde2eb-4583-11e0-b54c-00137279a832")
	public static final String ELT_IMPORT_PATH = "ElementImportPath";

	@objid ("1bd04545-4583-11e0-b54c-00137279a832")
	public static final String NOTE_TYPE_NAME = "NoteType_Name";

	@objid ("1bd04547-4583-11e0-b54c-00137279a832")
	public static final String ELT_NAME = "Name";

	@objid ("1bd04549-4583-11e0-b54c-00137279a832")
	public static final String SUPPLIER_QUALIFIED_NAME = "SupplierQualifiedName";

	@objid ("1bd0454b-4583-11e0-b54c-00137279a832")
	public static final String IS_CONCURRENT = "isConcurrent";

	@objid ("1bd0454d-4583-11e0-b54c-00137279a832")
	public static final String IS_TARGET_IS_CLASS = "isTargetIsClass";

	@objid ("1bd2a79d-4583-11e0-b54c-00137279a832")
	public static final String EFFECT = "Effect";

	@objid ("1bd2a79f-4583-11e0-b54c-00137279a832")
	public static final String IS_EXPANSION = "isExpansion";

	@objid ("1bd2a7a1-4583-11e0-b54c-00137279a832")
	private static GenerationProperties genProp = GenerationProperties
	.getInstance();

	@objid ("1bd2a7a2-4583-11e0-b54c-00137279a832")
	public static final String IS_FLOW = "isFlow";

	@objid ("1bd2a7a4-4583-11e0-b54c-00137279a832")
	public static final String TAGTYPE = "TagType";

	@objid ("1bd2a7a6-4583-11e0-b54c-00137279a832")
	public static final String STEREOTYPE = "Stereotype";

	@objid ("1bd509f7-4583-11e0-b54c-00137279a832")
	public static final String TAGGEDVALUE = "TaggedValue";

	@objid ("1bd509f9-4583-11e0-b54c-00137279a832")
	public static final String OWNER = "Owner";

	@objid ("1bd509fb-4583-11e0-b54c-00137279a832")
	public static final String MULTI_MAX = "MultiMax";

	@objid ("1bd509fd-4583-11e0-b54c-00137279a832")
	public static final String MULTI_MIN = "MultiMin";

	@objid ("1bd509ff-4583-11e0-b54c-00137279a832")
	public static final String IS_COMBINEDUPLICATE = "isCombineDuplicate";

	@objid ("1bd76c51-4583-11e0-b54c-00137279a832")
	public static final String IS_REPRESENTED = "isRepresented";

	@objid ("1bd76c53-4583-11e0-b54c-00137279a832")
	public static final String JOINSPEC = "JoinSpecification";

	@objid ("1bd76c55-4583-11e0-b54c-00137279a832")
	public static final String IS_BASE = "isBase";

	@objid ("1bd76c57-4583-11e0-b54c-00137279a832")
	public static final String IS_BEHAVIOR = "isBehavior";

	@objid ("1bd9ceaa-4583-11e0-b54c-00137279a832")
	public static final String IS_LINK = "isLink";

	@objid ("1bd9ceac-4583-11e0-b54c-00137279a832")
	public static final String IS_OBASE = "isOBase";

	@objid ("1bd9ceae-4583-11e0-b54c-00137279a832")
	public static final String IS_PBASE = "isPBase";

	@objid ("1bd9ceb0-4583-11e0-b54c-00137279a832")
	public static final String IS_PORT = "isPort";

	@objid ("1bd9ceb2-4583-11e0-b54c-00137279a832")
	public static final String IS_SERVICE = "isService";

	@objid ("1bdc3105-4583-11e0-b54c-00137279a832")
	public static final String IS_BINDABLEINSTANCE = "isBindableInstance";

	@objid ("1bdc3107-4583-11e0-b54c-00137279a832")
	public static final String IS_CONSTANT = "isConstant";

	@objid ("1bdc3109-4583-11e0-b54c-00137279a832")
	public static final String IS_DELETED = "isDeleted";

	@objid ("1bdc310b-4583-11e0-b54c-00137279a832")
	public static final String IS_EVENT = "isEvent";

	@objid ("1bde935e-4583-11e0-b54c-00137279a832")
	public static final String IS_EXCEPTION = "isException";

	@objid ("1bde9360-4583-11e0-b54c-00137279a832")
	public static final String NUMBER_REQUIRED_INTERFACE = "NumberRequiredInterface";

	@objid ("1bde9362-4583-11e0-b54c-00137279a832")
	public static final String NUMBER_PROVIDED_INTERFACE = "NumberProvidedInterface";

	@objid ("1bde9364-4583-11e0-b54c-00137279a832")
	public static final String IS_DEFAULT_STEREOTYPE = "isDefaultStereotype";

	@objid ("1bde9366-4583-11e0-b54c-00137279a832")
	public static final String IS_TAGPARAMETER = "isTagParameter";

	@objid ("1be0f5b9-4583-11e0-b54c-00137279a832")
	public static final String IS_CONNECTOR = "isConnector";

	@objid ("1be0f5bb-4583-11e0-b54c-00137279a832")
	public static final String IS_UNDEFINED = "isUndefined";

	@objid ("1be0f5bd-4583-11e0-b54c-00137279a832")
	public static final String IS_INSTANTIABLE = "isInstantiable";

	@objid ("1be0f5bf-4583-11e0-b54c-00137279a832")
	public static final String IS_LEAF = "isLeaf";

	@objid ("1be35813-4583-11e0-b54c-00137279a832")
	public static final String IS_ROOT = "isRoot";

	@objid ("1be35815-4583-11e0-b54c-00137279a832")
	public static final String IS_NAVIGABLE = "isNavigable";

	@objid ("1be35817-4583-11e0-b54c-00137279a832")
	public static final String IS_NOTYPE = "isNoType";

	@objid ("1be35819-4583-11e0-b54c-00137279a832")
	public static final String IS_ORDERED = "isOrdered";

	@objid ("1be5ba6d-4583-11e0-b54c-00137279a832")
	public static final String IS_UNIQUE = "isUnique";

	@objid ("1be5ba6f-4583-11e0-b54c-00137279a832")
	public static final String IS_PROVIDED_INTERFACE = "isProvidedInterface";

	@objid ("1be5ba71-4583-11e0-b54c-00137279a832")
	public static final String IS_REQUIRED_INTERFACE = "isRequiredInterface";

	@objid ("1be5ba73-4583-11e0-b54c-00137279a832")
	public static final String VALUE = "Value";

	@objid ("1be81cc7-4583-11e0-b54c-00137279a832")
	public static final String ICONTYPE = "IconType";

	@objid ("1be81cc9-4583-11e0-b54c-00137279a832")
	public static final String IS_ATTRIBUTELINK = "isAttributeLink";

	@objid ("1be81ccb-4583-11e0-b54c-00137279a832")
	public static final String SIGNAL = "Signal";

	@objid ("1be81ccd-4583-11e0-b54c-00137279a832")
	public static final String VISIBILITY = "Visibility";

	@objid ("1bea7f21-4583-11e0-b54c-00137279a832")
	public static final String RECEIVED_EVENT = "ReceivedEvent";

	@objid ("1bea7f23-4583-11e0-b54c-00137279a832")
	public static final String IS_REENTRANT = "isReentrant";

	@objid ("1bea7f25-4583-11e0-b54c-00137279a832")
	public static final String TYPE = "Type";

	@objid ("1bece17a-4583-11e0-b54c-00137279a832")
	public static final String POSTCONDITION = "postCondition";

	@objid ("1bece17c-4583-11e0-b54c-00137279a832")
	public static final String IS_HIDDEN = "isHidden";

	@objid ("1bece17e-4583-11e0-b54c-00137279a832")
	public static final String IS_SIGNATUREPART = "isSignaturePart";

	@objid ("1bece180-4583-11e0-b54c-00137279a832")
	public static final String LABEL = "Label";

	@objid ("1bef43d5-4583-11e0-b54c-00137279a832")
	public static final String IS_REFERENCE = "isReference";

	@objid ("1bef43d7-4583-11e0-b54c-00137279a832")
	public static final String MODULE = "Module";

	@objid ("1bef43d9-4583-11e0-b54c-00137279a832")
	public static final String BASECLASS = "BaseClass";

	@objid ("1bf1a62e-4583-11e0-b54c-00137279a832")
	public static final String IS_VALUEPARAMETER = "isValueParameter";

	@objid ("1bf1a630-4583-11e0-b54c-00137279a832")
	public static final String IS_NOTETYPE = "isNoteType";

	@objid ("1bf1a632-4583-11e0-b54c-00137279a832")
	public static final String IS_NAMED_WITH_CONVENTION = "isNamedWithConvention";

	@objid ("6d9e60f2-1a76-11e1-8103-0027103f347d")
	public static final String IS_REQUIREMENT_CONTAINER = "isRequirementContainer";

	@objid ("6d9ed628-1a76-11e1-8103-0027103f347d")
	public static final String IS_OWNED_BY_ASSOCIATION = "isOwnedByAssociation";

	@objid ("6d9f244c-1a76-11e1-8103-0027103f347d")
	public static final String IS_OWNED_BY_ASSOCIATION_CLASS = "isOwnedByAssociationClass";

	@objid ("6d9f7270-1a76-11e1-8103-0027103f347d")
	public static final String IS_ROUNDTRIP = "isRoundTrip";

	@objid ("33187cfb-2b22-11e1-8e26-0027103f347d")
	public static final String EXPORTERVERSION = "exporterVersion";

	@objid ("12a3038a-abf1-11e1-9002-0027103f347d")
	public static final String PORT_DIRECTION = "PortDirection";


	@objid ("1bf4088d-4583-11e0-b54c-00137279a832")
	public static boolean hasObjingID(Element ecoreElt) {
		return hasEAnnotationContent(ecoreElt, OBJING_NAME, ELT_ID);
	}

	@objid ("1bf66ae2-4583-11e0-b54c-00137279a832")
	public static void setMain(Element ecoreElt, boolean isMain) {
		if (genProp.isRoundtripEnabled() && (isMain)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_MAIN);
	}

	@objid ("1bf66ae6-4583-11e0-b54c-00137279a832")
	public static void setTagParameter(Element ecoreElt, boolean isTagParameter) {
		if (genProp.isRoundtripEnabled() && (isTagParameter)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_TAGPARAMETER);
	}

	@objid ("1bf66aea-4583-11e0-b54c-00137279a832")
	public static void setPrimitive(Element ecoreElt, boolean isPrimitive) {
		if (genProp.isRoundtripEnabled() && (isPrimitive)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_ELEMENTARY);
	}

	@objid ("1bf66aee-4583-11e0-b54c-00137279a832")
	public static boolean isPrimitive(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_ELEMENTARY);
	}

	@objid ("1bf66af2-4583-11e0-b54c-00137279a832")
	public static boolean isProvidedInterface(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_PROVIDED_INTERFACE);
	}

	@objid ("1bf8cd3c-4583-11e0-b54c-00137279a832")
	public static boolean isRequiredInterface(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_REQUIRED_INTERFACE);
	}

	@objid ("1bf8cd40-4583-11e0-b54c-00137279a832")
	public static void setNavigable(Element ecoreElt, boolean isNavigable) {
		if (genProp.isRoundtripEnabled() && (isNavigable)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_NAVIGABLE);
	}

	@objid ("1bf8cd44-4583-11e0-b54c-00137279a832")
	public static boolean isNavigable(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_NAVIGABLE);
	}

	@objid ("1bf8cd48-4583-11e0-b54c-00137279a832")
	public static void setUndefined(Element ecoreElt, boolean isUndefined) {
		if (genProp.isRoundtripEnabled() && (isUndefined)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_UNDEFINED);
	}

	@objid ("1bf8cd4c-4583-11e0-b54c-00137279a832")
	public static boolean isUndefined(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_UNDEFINED);
	}

	@objid ("1bfb2f96-4583-11e0-b54c-00137279a832")
	public static void setConstant(Element ecoreElt, boolean isConstant) {
		if (genProp.isRoundtripEnabled() && (isConstant)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_CONSTANT);
	}

	@objid ("1bfb2f9a-4583-11e0-b54c-00137279a832")
	public static boolean isConstant(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_CONSTANT);
	}

	@objid ("1bfb2f9e-4583-11e0-b54c-00137279a832")
	public static void setEvent(Element ecoreElt, boolean isEvent) {
		if (genProp.isRoundtripEnabled() && (isEvent)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_EVENT);
	}

	@objid ("1bfb2fa2-4583-11e0-b54c-00137279a832")
	public static boolean isEvent(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_EVENT);
	}

	@objid ("1bfb2fa6-4583-11e0-b54c-00137279a832")
	public static void setReentrant(Element ecoreElt, boolean isReentrant) {
		if (genProp.isRoundtripEnabled() && (isReentrant)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_REENTRANT);
	}

	@objid ("1bfd91f0-4583-11e0-b54c-00137279a832")
	public static boolean isReentrant(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_REENTRANT);
	}

	@objid ("1bfd91f4-4583-11e0-b54c-00137279a832")
	public static void setException(Element ecoreElt, boolean isException) {
		if (genProp.isRoundtripEnabled() && (isException)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_EXCEPTION);
	}

	@objid ("1bfd91f8-4583-11e0-b54c-00137279a832")
	public static boolean isException(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_EXCEPTION);
	}

	@objid ("1bfd91fc-4583-11e0-b54c-00137279a832")
	public static void setOrdered(Element ecoreElt, boolean isOrdered) {
		if (genProp.isRoundtripEnabled() && (isOrdered)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_ORDERED);
	}

	@objid ("1c0256a4-4583-11e0-b54c-00137279a832")
	public static boolean isOrdered(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_ORDERED);
	}

	@objid ("1c0256a8-4583-11e0-b54c-00137279a832")
	public static void setUnique(Element ecoreElt, boolean isUnique) {
		if (genProp.isRoundtripEnabled() && (isUnique)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_UNIQUE);
	}

	@objid ("1c04b8fe-4583-11e0-b54c-00137279a832")
	public static boolean isUnique(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_UNIQUE);
	}

	@objid ("1c04b902-4583-11e0-b54c-00137279a832")
	public static void setDefaultStereotype(Stereotype ecoreElt, boolean isUndefined) {
		if (genProp.isRoundtripEnabled() && (isUndefined)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_DEFAULT_STEREOTYPE);
	}

	@objid ("1c04b906-4583-11e0-b54c-00137279a832")
	public static boolean isDefaultStereotype(Stereotype ecoreElt) {
		return getBooleanContent(ecoreElt, IS_DEFAULT_STEREOTYPE);
	}

	@objid ("1c04b90a-4583-11e0-b54c-00137279a832")
	public static void setInstantiable(Element ecoreElt, boolean isInstantiable) {
		if (genProp.isRoundtripEnabled() && (isInstantiable)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_INSTANTIABLE);
	}

	@objid ("1c04b90e-4583-11e0-b54c-00137279a832")
	public static boolean isInstantiable(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_INSTANTIABLE);
	}

	@objid ("1c071b5a-4583-11e0-b54c-00137279a832")
	public static void setLeaf(Element ecoreElt, boolean isLeaf) {
		if (genProp.isRoundtripEnabled() && (isLeaf)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_LEAF);
	}

	@objid ("1c071b5e-4583-11e0-b54c-00137279a832")
	public static boolean isLeaf(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_LEAF);
	}

	@objid ("1c071b62-4583-11e0-b54c-00137279a832")
	public static void setLink(Element ecoreElt, boolean isLink) {
		if (genProp.isRoundtripEnabled() && (isLink)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_LINK);
	}

	@objid ("1c071b66-4583-11e0-b54c-00137279a832")
	public static boolean isLink(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_LINK);
	}

	@objid ("1c097db5-4583-11e0-b54c-00137279a832")
	public static void setProvidedInterface(Element ecoreElt, boolean isProvidedInterface) {
		if (genProp.isRoundtripEnabled() && (isProvidedInterface)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_PROVIDED_INTERFACE);
	}

	@objid ("1c097db9-4583-11e0-b54c-00137279a832")
	public static void setRequiredInterface(Element ecoreElt, boolean isRequiredInterface) {
		if (genProp.isRoundtripEnabled() && (isRequiredInterface)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_REQUIRED_INTERFACE);
	}

	@objid ("1c097dbd-4583-11e0-b54c-00137279a832")
	public static void setRoot(Element ecoreElt, boolean isRoot) {
		if (genProp.isRoundtripEnabled() && (isRoot)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_ROOT);
	}

	@objid ("1c097dc1-4583-11e0-b54c-00137279a832")
	public static boolean isRoot(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_ROOT);
	}

	@objid ("1c0be00e-4583-11e0-b54c-00137279a832")
	public static void setConnector(Element ecoreElt, boolean isConnector) {
		if (genProp.isRoundtripEnabled() && (isConnector)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_CONNECTOR);
	}

	@objid ("1c0be012-4583-11e0-b54c-00137279a832")
	public static boolean isConnector(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_CONNECTOR);
	}

	@objid ("1c0be016-4583-11e0-b54c-00137279a832")
	public static void setBindableInstance(Element ecoreElt, boolean isBindableInstance) {
		if (genProp.isRoundtripEnabled() && (isBindableInstance)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_BINDABLEINSTANCE);
	}

	@objid ("1c0e4266-4583-11e0-b54c-00137279a832")
	public static boolean isBindableInstance(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_BINDABLEINSTANCE);
	}

	@objid ("1c0e426a-4583-11e0-b54c-00137279a832")
	public static void setBase(Element ecoreElt, boolean isBase) {
		if (genProp.isRoundtripEnabled() && (isBase)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_BASE);
	}

	@objid ("1c0e426e-4583-11e0-b54c-00137279a832")
	public static void setBehavior(Element ecoreElt, boolean isBehavior) {
		if (genProp.isRoundtripEnabled() && (isBehavior)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_BEHAVIOR);
	}

	@objid ("1c0e4272-4583-11e0-b54c-00137279a832")
	public static void setService(Element ecoreElt, boolean isService) {
		if (genProp.isRoundtripEnabled() && (isService)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_SERVICE);
	}

	@objid ("1c10a4c0-4583-11e0-b54c-00137279a832")
	public static boolean isBase(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_BASE);
	}

	@objid ("1c10a4c4-4583-11e0-b54c-00137279a832")
	public static boolean isBehavior(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_BEHAVIOR);
	}

	@objid ("1c10a4c8-4583-11e0-b54c-00137279a832")
	public static boolean isService(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_SERVICE);
	}

	@objid ("1c10a4cc-4583-11e0-b54c-00137279a832")
	public static void setPBase(Element ecoreElt, boolean isPBase) {
		if (genProp.isRoundtripEnabled() && (isPBase)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_PBASE);
	}

	@objid ("1c13071a-4583-11e0-b54c-00137279a832")
	public static boolean isPBase(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_PBASE);
	}

	@objid ("1c13071e-4583-11e0-b54c-00137279a832")
	public static void setDeleted(Element ecoreElt, boolean isDeleted) {
		if (genProp.isRoundtripEnabled() && (isDeleted)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_DELETED);
	}

	@objid ("1c130722-4583-11e0-b54c-00137279a832")
	public static boolean isDeleted(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_DELETED);
	}

	@objid ("1c130726-4583-11e0-b54c-00137279a832")
	public static void setReprensentation(Element ecoreElt, boolean isRepresentation) {
		if (genProp.isRoundtripEnabled() && (isRepresentation)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_REPRESENTED);
	}

	@objid ("1c156974-4583-11e0-b54c-00137279a832")
	public static boolean isRepresentation(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_REPRESENTED);
	}

	@objid ("1c156978-4583-11e0-b54c-00137279a832")
	public static void setOBase(Element ecoreElt, boolean isOBase) {
		if (genProp.isRoundtripEnabled() && (isOBase)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_OBASE);
	}

	@objid ("1c15697c-4583-11e0-b54c-00137279a832")
	public static boolean isOBase(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_OBASE);
	}

	@objid ("1c17cbce-4583-11e0-b54c-00137279a832")
	public static void setPort(Element ecoreElt, boolean isPort) {
		if (genProp.isRoundtripEnabled() && (isPort)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_PORT);
	}

	@objid ("1c17cbd2-4583-11e0-b54c-00137279a832")
	public static boolean isPort(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_PORT);
	}

	@objid ("1c17cbd6-4583-11e0-b54c-00137279a832")
	public static void setNoType(Element ecoreElt, boolean isNoType) {
		if (genProp.isRoundtripEnabled() && (isNoType)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_NOTYPE);
	}

	@objid ("1c17cbda-4583-11e0-b54c-00137279a832")
	public static boolean isNoType(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_NOTYPE);
	}

	@objid ("1c1a2e2a-4583-11e0-b54c-00137279a832")
	public static void setTypeConstraint(Element ecoreElt, String typeConstraint) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					TYPE_CONSTRAINT, typeConstraint);
	}

	@objid ("1c1a2e2e-4583-11e0-b54c-00137279a832")
	public static String getTypeConstraint(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, TYPE_CONSTRAINT);
	}

	@objid ("1c1a2e33-4583-11e0-b54c-00137279a832")
	public static String getTagType(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, TAGTYPE);
	}

	@objid ("1c1c9084-4583-11e0-b54c-00137279a832")
	public static String getTaggedValue(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, TAGGEDVALUE);
	}

	@objid ("1c1c9089-4583-11e0-b54c-00137279a832")
	public static void setTaggedValue(Element ecoreElt, String taggedValue) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					TAGGEDVALUE, taggedValue);
	}


	public static void setEcoreId(Element ecoreElt, String ecoreId) {
		setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
				ECOREID, ecoreId);
	}

	@objid ("1c1ef2dc-4583-11e0-b54c-00137279a832")
	public static void setOwner(Element ecoreElt, String ownerId) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					OWNER, ownerId);
	}

	@objid ("1c1ef2e0-4583-11e0-b54c-00137279a832")
	public static void setMultiMin(Element ecoreElt, String multiMin) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					MULTI_MIN, multiMin);
	}

	@objid ("1c1ef2e4-4583-11e0-b54c-00137279a832")
	public static String getMultiMin(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, MULTI_MIN );
	}

	@objid ("1c215536-4583-11e0-b54c-00137279a832")
	public static void setType(Element ecoreElt, String type) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					TYPE, type);
	}

	@objid ("1c21553a-4583-11e0-b54c-00137279a832")
	public static String getType(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, TYPE );
	}

	@objid ("1c21553f-4583-11e0-b54c-00137279a832")
	public static void setMultiMax(Element ecoreElt, String multiMax) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					MULTI_MAX, multiMax);
	}

	@objid ("1c23b790-4583-11e0-b54c-00137279a832")
	public static String getMultiMax(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, MULTI_MAX);
	}

	@objid ("1c23b795-4583-11e0-b54c-00137279a832")
	public static void setDynamicDependency(Element ecoreElt, boolean isDerived) {
		if (genProp.isRoundtripEnabled() && (isDerived)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_DERIVED);
	}

	@objid ("1c23b799-4583-11e0-b54c-00137279a832")
	public static boolean isDynamicDependency(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_DERIVED);
	}

	@objid ("1c2619ea-4583-11e0-b54c-00137279a832")
	public static boolean isMain(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_MAIN);
	}

	@objid ("1c2619ee-4583-11e0-b54c-00137279a832")
	public static boolean isTagParameter(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_TAGPARAMETER);
	}

	@objid ("1c287c44-4583-11e0-b54c-00137279a832")
	public static void setAbstract(Element ecoreElt, boolean isAbstract) {
		if (genProp.isRoundtripEnabled() && (isAbstract)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_ABSTRACT);
	}

	@objid ("1c287c48-4583-11e0-b54c-00137279a832")
	public static boolean isAbstract(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_ABSTRACT);
	}

	@objid ("1c287c4c-4583-11e0-b54c-00137279a832")
	public static void setAccessMode(Element ecoreElt, String accessMode) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, ACCESS_MODE,
					accessMode);
	}

	@objid ("1c2ade9f-4583-11e0-b54c-00137279a832")
	public static String getAccessMode(Element ecoreElt) {
		return getAndDestroyEAnnotationContent(ecoreElt, OBJING_NAME, ACCESS_MODE);
	}

	@objid ("1c2adea4-4583-11e0-b54c-00137279a832")
	public static EAnnotation getOrCreateObjingEAnnotation(Element ecoreElt) {
		EAnnotation ea = null;
		if (genProp.isRoundtripEnabled()) {
			ea = getEAnnotation(ecoreElt, OBJING_NAME);
			if (ea == null)
				ea = createEAnnotation(ecoreElt, OBJING_NAME);
		}
		return ea;
	}

	@objid ("1c2d40f8-4583-11e0-b54c-00137279a832")
	public static void setCreate(Element ecoreElt, boolean isCreate) {
		if (genProp.isRoundtripEnabled() && (isCreate)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_CREATE);
	}

	@objid ("1c2d40fc-4583-11e0-b54c-00137279a832")
	public static void setDestroy(Element ecoreElt, boolean isDestroy) {
		if (genProp.isRoundtripEnabled() && (isDestroy)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_DESTROY);
	}

	@objid ("1c2d4100-4583-11e0-b54c-00137279a832")
	public static void setDiscriminator(Element ecoreElt, String discriminator) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, DISCRIMINATOR,
					discriminator);
	}

	@objid ("1c2fa352-4583-11e0-b54c-00137279a832")
	public static String getDiscriminator(Element ecoreElt) {
		return getAndDestroyEAnnotationContent(ecoreElt, OBJING_NAME, DISCRIMINATOR);
	}

	@objid ("1c2fa357-4583-11e0-b54c-00137279a832")
	public static void setImportedElement(Element ecoreElt, String eltPath) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					ELT_IMPORT_PATH, eltPath);
	}

	@objid ("1c2fa35b-4583-11e0-b54c-00137279a832")
	public static String getImportedElement(Element ecoreElt) {
		return getAndDestroyEAnnotationContent(ecoreElt, OBJING_NAME, ELT_IMPORT_PATH);
	}

	@objid ("1c36ca60-4583-11e0-b54c-00137279a832")
	public static void setJoinSpec(Element ecoreElt, String value) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, JOINSPEC,
					value);
	}

	@objid ("1c36ca64-4583-11e0-b54c-00137279a832")
	public static String getJoinSpec(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, JOINSPEC);
	}

	@objid ("1c36ca69-4583-11e0-b54c-00137279a832")
	public static void setCombineDuplicate(Element ecoreElt, boolean isCombineDuplicate) {
		if (genProp.isRoundtripEnabled() && (isCombineDuplicate)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_COMBINEDUPLICATE);
	}

	@objid ("1c392cbb-4583-11e0-b54c-00137279a832")
	public static boolean isCombineDuplicate(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_COMBINEDUPLICATE);
	}

	@objid ("1c392cbf-4583-11e0-b54c-00137279a832")
	public static boolean existsConstraintInEA(final EAnnotation eAnnotation, final Constraint constraint) {
		String constrName = constraint.getName();
		ValueSpecification valueSpecif = constraint.getSpecification();
		if (valueSpecif instanceof LiteralString) {
			LiteralString stringValue = (LiteralString) valueSpecif;
			String constrBody = stringValue.getValue();

			for (Object content : eAnnotation.getContents()) {
				if (content instanceof Constraint) {
					Constraint currentConstraint = (Constraint) content;
					String currentConstrName = currentConstraint.getName();
					ValueSpecification currentValueSpecif = currentConstraint
							.getSpecification();
					if (currentValueSpecif instanceof LiteralString) {
						LiteralString currentStringValue = (LiteralString) currentValueSpecif;
						String currentConstrBody = currentStringValue
								.getValue();

						if (constrName.equals(currentConstrName)
								&& constrBody.equals(currentConstrBody)) {
							return true;
						}
					}
				}
			}
		}
		return false;
	}

	@objid ("1c3b8f14-4583-11e0-b54c-00137279a832")
	public static boolean existsActualInEA(EAnnotation in_EA, Comment in_Constraint) {
		//        String in_ConstrName = in_Constraint.getName();
		//        ValueSpecification in_valueSpecif = in_Constraint.getSpecification();
		//        if (in_valueSpecif instanceof LiteralString) {
		//            LiteralString in_stringValue = (LiteralString) in_valueSpecif;
		//            String in_ConstrBody = in_stringValue.getValue();
		//
		//            for (Object content : in_EA.getContents()) {
		//                if (content instanceof Constraint) {
		//                    Constraint currentConstraint = (Constraint) content;
		//                    String currentConstrName = currentConstraint.getName();
		//                    ValueSpecification currentValueSpecif = currentConstraint
		//                    .getSpecification();
		//                    if (currentValueSpecif instanceof LiteralString) {
		//                        LiteralString currentStringValue = (LiteralString) currentValueSpecif;
		//                        String currentConstrBody = currentStringValue
		//                        .getValue();
		//
		//                        if (in_ConstrName.equals(currentConstrName)
		//                                && in_ConstrBody.equals(currentConstrBody)) {
		//                            return true;
		//                        }
		//                    }
		//                }
		//            }
		//        }
		return false;
	}

	@objid ("1c3b8f1a-4583-11e0-b54c-00137279a832")
	public static void setNumberRequiredInterface(Element ecoreElt, Integer value) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					NUMBER_REQUIRED_INTERFACE, String.valueOf(value));
	}

	@objid ("1c3df16e-4583-11e0-b54c-00137279a832")
	public static Integer getNumberRequiredInterface(Element ecoreElt) {
		String temp = getEAnnotationContent(ecoreElt, OBJING_NAME,
				NUMBER_REQUIRED_INTERFACE);
		if ((temp != null) && (!temp.equals("")))
			return Integer.valueOf(temp);
		else 
			return 0;
	}

	@objid ("1c3df172-4583-11e0-b54c-00137279a832")
	public static void setNumberProvidedInterface(Element ecoreElt, Integer value) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					NUMBER_PROVIDED_INTERFACE,  String.valueOf(value));
	}

	@objid ("1c3df176-4583-11e0-b54c-00137279a832")
	public static Integer getNumberProvidedInterface(Element ecoreElt) {
		String temp = getEAnnotationContent(ecoreElt, OBJING_NAME,
				NUMBER_PROVIDED_INTERFACE);
		if ((temp != null) && (!temp.equals("")))
			return Integer.valueOf(temp);
		else 
			return 0;
	}

	@objid ("1c4053c8-4583-11e0-b54c-00137279a832")
	public static void setTagType(Element ecoreElt, String value) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					TAGTYPE, value);
	}

	@objid ("1c4053cc-4583-11e0-b54c-00137279a832")
	public static void setNoteTypeName(Element ecoreElt, String value) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					NOTE_TYPE_NAME, value);
	}

	@objid ("1c4053d0-4583-11e0-b54c-00137279a832")
	public static void setName(Element ecoreElt, String name) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, ELT_NAME, name);
	}

	@objid ("1c42b622-4583-11e0-b54c-00137279a832")
	public static void setSupplier(Element ecoreElt, String supplierName) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					SUPPLIER_QUALIFIED_NAME, supplierName);
	}

	@objid ("1c42b626-4583-11e0-b54c-00137279a832")
	public static boolean hasObjingEAnnotations(Package model) {
		if (getEAnnotation(model, OBJING_NAME) == null)
			return false;
		else
			return true;
	}

	@objid ("1c45187c-4583-11e0-b54c-00137279a832")
	public static String getNoteTypeName(Element ecoreElt) {
		return getAndDestroyEAnnotationContent(ecoreElt, OBJING_NAME, NOTE_TYPE_NAME);
	}

	@objid ("1c451881-4583-11e0-b54c-00137279a832")
	public static String getName(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, ELT_NAME);
	}

	@objid ("1c451886-4583-11e0-b54c-00137279a832")
	public static String getOwner(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, OWNER);
	}

	@objid ("1c477ada-4583-11e0-b54c-00137279a832")
	public static void setConcurrent(Element ecoreElt, boolean isConcurrent) {
		if (genProp.isRoundtripEnabled() && (isConcurrent)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_CONCURRENT);
	}

	@objid ("1c477ade-4583-11e0-b54c-00137279a832")
	public static boolean isConcurrent(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_CONCURRENT);
	}

	@objid ("1c49dd30-4583-11e0-b54c-00137279a832")
	public static boolean isStereotyped(Element ecoreElt) {
		return getBooleanContent(ecoreElt, STEREOTYPE);
	}

	@objid ("1c49dd34-4583-11e0-b54c-00137279a832")
	public static boolean isCreate(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_CREATE);
	}

	@objid ("1c4c3f8a-4583-11e0-b54c-00137279a832")
	public static boolean isDestroy(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_DESTROY);
	}

	@objid ("1c4c3f8e-4583-11e0-b54c-00137279a832")
	public static void setTargetIsClass(Property property, boolean targetIsClass) {
		if (genProp.isRoundtripEnabled() && (targetIsClass)) 
			createEAnnotation(property, OBJING_NAME,IS_TARGET_IS_CLASS);
	}

	@objid ("1c4c3f92-4583-11e0-b54c-00137279a832")
	public static boolean isTargetIsClass(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_TARGET_IS_CLASS);
	}

	@objid ("1c4ea1e4-4583-11e0-b54c-00137279a832")
	public static void setEffect(Element flow, String effect) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(flow, OBJING_NAME, EFFECT, effect);
	}

	@objid ("1c4ea1e8-4583-11e0-b54c-00137279a832")
	public static String getEffect(Element flow) {
		return getAndDestroyEAnnotationContent(flow, OBJING_NAME, EFFECT);
	}

	@objid ("1c51043e-4583-11e0-b54c-00137279a832")
	public static void setValue(Element ecoreElt, String effect) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, VALUE, effect);
	}

	@objid ("1c510442-4583-11e0-b54c-00137279a832")
	public static String getValue(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, VALUE);
	}

	@objid ("1c536698-4583-11e0-b54c-00137279a832")
	public static void setVisibility(Element ecoreElt, int enume) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, VISIBILITY, String.valueOf(enume));
	}

	@objid ("1c53669c-4583-11e0-b54c-00137279a832")
	public static int getVisibility(Element ecoreElt) {
		return Integer.valueOf(getEAnnotationContent(ecoreElt, OBJING_NAME, VISIBILITY));
	}

	@objid ("1c55c8f2-4583-11e0-b54c-00137279a832")
	public static void setExpansion(Pin pin, boolean isExpansion) {
		if (genProp.isRoundtripEnabled() && (isExpansion)) 
			createEAnnotation(pin, OBJING_NAME,IS_EXPANSION);
	}

	@objid ("1c55c8f6-4583-11e0-b54c-00137279a832")
	public static boolean isExpansion(Pin pin) {
		return getBooleanContent(pin, IS_EXPANSION);
	}

	@objid ("1c55c8fa-4583-11e0-b54c-00137279a832")
	public static void setFlow(Element ecoreElt, boolean isFlow) {
		if (genProp.isRoundtripEnabled() && (isFlow)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_FLOW);
	}

	@objid ("1c582b4c-4583-11e0-b54c-00137279a832")
	public static boolean isFlow(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_FLOW);
	}

	@objid ("1c582b50-4583-11e0-b54c-00137279a832")
	public static void setPostCondition(Element ecoreElt, String value) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, POSTCONDITION,
					value);
	}

	@objid ("1c5a8da6-4583-11e0-b54c-00137279a832")
	public static String getPostCondition(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, POSTCONDITION);
	}

	@objid ("1c5a8dab-4583-11e0-b54c-00137279a832")
	public static void setSignal(Element ecoreElt, String value) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, SIGNAL,
					value);
	}

	@objid ("1c5cf000-4583-11e0-b54c-00137279a832")
	public static String getSignal(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, SIGNAL);
	}

	public static String getEcoreId(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, ECOREID);
	}

	@objid ("1c5cf005-4583-11e0-b54c-00137279a832")
	public static void setReceivedEvent(Element ecoreElt, String value) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, RECEIVED_EVENT,
					value);
	}

	@objid ("1c5f525a-4583-11e0-b54c-00137279a832")
	public static String getReceivedEvent(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, RECEIVED_EVENT);
	}

	@objid ("1c5f525f-4583-11e0-b54c-00137279a832")
	public static void setAttributeLink(Element ecoreElt, boolean isAttributeLink) {
		if (genProp.isRoundtripEnabled() && (isAttributeLink)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_ATTRIBUTELINK);
	}

	@objid ("1c61b4b4-4583-11e0-b54c-00137279a832")
	public static boolean isAttributeLink(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_ATTRIBUTELINK);
	}

	@objid ("1c61b4b8-4583-11e0-b54c-00137279a832")
	public static void setIconType(Element ecoreElt, String effect) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, ICONTYPE, effect);
	}

	@objid ("1c61b4bc-4583-11e0-b54c-00137279a832")
	public static String getIconType(Element ecoreElt) {
		return getAndDestroyEAnnotationContent(ecoreElt, OBJING_NAME, ICONTYPE);
	}

	@objid ("1c641710-4583-11e0-b54c-00137279a832")
	public static void setLabel(Element ecoreElt, String label) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, LABEL, label);
	}

	@objid ("1c641714-4583-11e0-b54c-00137279a832")
	public static String getLabel(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, LABEL);
	}

	@objid ("1c66796a-4583-11e0-b54c-00137279a832")
	public static void setHidden(Element ecoreElt, boolean isHidden) {
		if (genProp.isRoundtripEnabled() && (isHidden)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_HIDDEN);
	}

	@objid ("1c66796e-4583-11e0-b54c-00137279a832")
	public static boolean isHidden(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_HIDDEN);
	}

	@objid ("1c68dbc3-4583-11e0-b54c-00137279a832")
	public static void setPartSignature(Element ecoreElt, boolean isPartSignature) {
		if (genProp.isRoundtripEnabled() && (isPartSignature)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_SIGNATUREPART);
	}

	@objid ("1c6b3e1c-4583-11e0-b54c-00137279a832")
	public static boolean isPartSignature(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_SIGNATUREPART);
	}

	@objid ("1c6b3e20-4583-11e0-b54c-00137279a832")
	public static void setReference(Element ecoreElt, boolean isReference) {
		if (isReference) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_REFERENCE);
	}

	@objid ("1c6da076-4583-11e0-b54c-00137279a832")
	public static boolean isReference(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_REFERENCE);
	}

	@objid ("1c7002d0-4583-11e0-b54c-00137279a832")
	public static List<String> getBaseClass(Element ecoreElt) {
		return getEAnnotationContents(ecoreElt, OBJING_NAME, BASECLASS);
	}

	@objid ("1c7002d5-4583-11e0-b54c-00137279a832")
	public static void setModule(Profile ecoreElt, String module) {
		setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, MODULE, module);
	}

	@objid ("1c72652a-4583-11e0-b54c-00137279a832")
	public static String getModule(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, MODULE);
	}

	@objid ("1c72652f-4583-11e0-b54c-00137279a832")
	public static void alwaysSetOwner(Element ecoreElt, String ownerId) {
		setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
				OWNER, ownerId);
	}

	@objid ("1c74c784-4583-11e0-b54c-00137279a832")
	public static void deleteOwner(Element ecoreElt) {
		deleteEAnnotation(ecoreElt, OBJING_NAME, OWNER);
	}

	@objid ("1c74c787-4583-11e0-b54c-00137279a832")
	public static void setValueParameter(Element ecoreElt, boolean isUnique) {
		if (genProp.isRoundtripEnabled() && (isUnique)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_VALUEPARAMETER);
	}

	@objid ("1c74c78b-4583-11e0-b54c-00137279a832")
	public static boolean isValueParameter(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_VALUEPARAMETER);
	}

	@objid ("1c7729df-4583-11e0-b54c-00137279a832")
	public static void setNoteType(Element ecoreElt, boolean isNoteType) {
		if (isNoteType) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_NOTETYPE);
	}

	@objid ("1c7729e3-4583-11e0-b54c-00137279a832")
	public static boolean isNoteType(Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_NOTETYPE);
	}

	@objid ("1c798c38-4583-11e0-b54c-00137279a832")
	public static String getObjingEAnnotation(Element ecoreElt, String name) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME,name);
	}

	@objid ("1c798c3e-4583-11e0-b54c-00137279a832")
	public static String getStereotype(Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, STEREOTYPE);
	}

	@objid ("1c7bee93-4583-11e0-b54c-00137279a832")
	public static void setNamedWithConvention(Stereotype ecoreElt, boolean isNamedWithConvention) {
		if (genProp.isRoundtripEnabled() && (isNamedWithConvention)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_NAMED_WITH_CONVENTION);
	}

	@objid ("1c7bee97-4583-11e0-b54c-00137279a832")
	public static boolean isNamedWithConvention(Stereotype ecoreElt) {
		return getBooleanContent(ecoreElt, IS_NAMED_WITH_CONVENTION);
	}

	@objid ("6dd467d6-1a76-11e1-8103-0027103f347d")
	public static boolean getRoundTrip(final Element ecoreElt) {
		return hasEAnnotationContent(ecoreElt, OBJING_NAME, IS_ROUNDTRIP);
	}

	@objid ("6dd4b5fa-1a76-11e1-8103-0027103f347d")
	public static void addObjingID(final Element ecoreElt, final String objingID) {
		addEAnnotationContent(ecoreElt, OBJING_NAME, ELT_ID, objingID);
	}

	@objid ("6dd5041e-1a76-11e1-8103-0027103f347d")
	public static List<String> getObjingIDs(final Element ecoreElt) {
		return getEAnnotationContents(ecoreElt, OBJING_NAME, ELT_ID);
	}

	@objid ("6dd57954-1a76-11e1-8103-0027103f347d")
	public static void addBaseClass(final Stereotype ecoreElt, final String baseClass) {
		if (genProp.isRoundtripEnabled())
			addEAnnotationContent(ecoreElt, OBJING_NAME, BASECLASS, baseClass);
	}

	@objid ("6dd5c778-1a76-11e1-8103-0027103f347d")
	public static boolean isRequirementContainer(final Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_REQUIREMENT_CONTAINER);
	}

	@objid ("6dd6159c-1a76-11e1-8103-0027103f347d")
	public static void setRequirementContainer(final Element ecoreElt, final boolean isRequirementContainer) {
		if (isRequirementContainer)
			createEAnnotation(ecoreElt, OBJING_NAME,IS_REQUIREMENT_CONTAINER);
	}

	@objid ("6dd6d8f6-1a76-11e1-8103-0027103f347d")
	public static boolean isOwnedByAssociation(final Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_OWNED_BY_ASSOCIATION);
	}

	@objid ("6dd7271a-1a76-11e1-8103-0027103f347d")
	public static boolean isOwnedByAssociationClass(final Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_OWNED_BY_ASSOCIATION_CLASS);
	}

	@objid ("6dd79c50-1a76-11e1-8103-0027103f347d")
	public static void setOwnedByAssociationClass(final Element ecoreElt, final boolean bool) {
		if (genProp.isRoundtripEnabled() && (bool)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_OWNED_BY_ASSOCIATION_CLASS);
	}

	@objid ("6dd7ea74-1a76-11e1-8103-0027103f347d")
	public static void setOwnedByAssociation(final Element ecoreElt, final boolean bool) {
		if (genProp.isRoundtripEnabled() && (bool)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_OWNED_BY_ASSOCIATION);
	}

	@objid ("6dd83898-1a76-11e1-8103-0027103f347d")
	public static void setRoundTrip(final Element ecoreElt, final boolean isRoundTrip) {
		if (genProp.isRoundtripEnabled() && (isRoundTrip)) 
			createEAnnotation(ecoreElt, OBJING_NAME,IS_ROUNDTRIP);
	}

	@objid ("332c539d-2b22-11e1-8e26-0027103f347d")
	public static void setExporterVersion(final Element ecoreElt, final String version) {
		setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME, EXPORTERVERSION, version);
	}

	@objid ("49687526-71b8-11e1-bffd-0027103f347d")
	public static boolean isRoundTrip(final Element ecoreElt) {
		return getBooleanContent(ecoreElt, IS_ROUNDTRIP);
	}

	@objid ("128a4b66-abf1-11e1-9002-0027103f347d")
	public static String getPortDirection(final Element ecoreElt) {
		return getEAnnotationContent(ecoreElt, OBJING_NAME, PORT_DIRECTION);
	}

	@objid ("128a9986-abf1-11e1-9002-0027103f347d")
	public static void setPortDirection(final Element ecoreElt, final String portDirection) {
		if (genProp.isRoundtripEnabled())
			setOrCreateEAnnotationContent(ecoreElt, OBJING_NAME,
					PORT_DIRECTION, portDirection);
	}

}
