/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.util;

import java.util.List;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.Action;
import org.eclipse.uml2.uml.AddStructuralFeatureValueAction;
import org.eclipse.uml2.uml.AddVariableValueAction;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.ClearAssociationAction;
import org.eclipse.uml2.uml.DestroyObjectAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.InvocationAction;
import org.eclipse.uml2.uml.LinkAction;
import org.eclipse.uml2.uml.LoopNode;
import org.eclipse.uml2.uml.OpaqueAction;
import org.eclipse.uml2.uml.RaiseExceptionAction;
import org.eclipse.uml2.uml.ReadIsClassifiedObjectAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction;
import org.eclipse.uml2.uml.ReclassifyObjectAction;
import org.eclipse.uml2.uml.ReduceAction;
import org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction;
import org.eclipse.uml2.uml.RemoveVariableValueAction;
import org.eclipse.uml2.uml.ReplyAction;
import org.eclipse.uml2.uml.SendObjectAction;
import org.eclipse.uml2.uml.SendSignalAction;
import org.eclipse.uml2.uml.StartClassifierBehaviorAction;
import org.eclipse.uml2.uml.StructuralFeatureAction;
import org.eclipse.uml2.uml.StructuredActivityNode;
import org.eclipse.uml2.uml.TestIdentityAction;
import org.eclipse.uml2.uml.UnmarshallAction;
import org.eclipse.uml2.uml.WriteStructuralFeatureAction;
import org.eclipse.uml2.uml.WriteVariableAction;
import org.eclipse.uml2.uml.util.UMLSwitch;

@objid ("1cd1c342-4583-11e0-b54c-00137279a832")
public class OwnedInputPinVisitor {
    @objid ("1cd42594-4583-11e0-b54c-00137279a832")
    private InputPinGetter getter;

    @objid ("1cd42595-4583-11e0-b54c-00137279a832")
     List<InputPin> inputPinList;


    @objid ("1cd42598-4583-11e0-b54c-00137279a832")
    public OwnedInputPinVisitor() {
        getter = new InputPinGetter();
        inputPinList = null;
    }

    @objid ("1cd4259a-4583-11e0-b54c-00137279a832")
    public List<InputPin> getInputPinList(Element owner) {
        if (inputPinList != null)
            inputPinList = null;
        getter.accept(owner);
        return inputPinList;
    }

    @objid ("1cd425a1-4583-11e0-b54c-00137279a832")
    class InputPinGetter extends UMLSwitch {

        @objid ("1cd425a2-4583-11e0-b54c-00137279a832")
        public void accept(Element ecoreElt) {
            doSwitch(ecoreElt);
        }

        @Override
        @objid ("1cd687ee-4583-11e0-b54c-00137279a832")
        public Object caseAction(Action owner) {
            inputPinList = owner.getInputs();
            return 42;
        }

        @Override
        @objid ("1cd687f4-4583-11e0-b54c-00137279a832")
        public Object caseAddStructuralFeatureValueAction(AddStructuralFeatureValueAction owner) {
            return null;
        }

        @Override
        @objid ("1cd687fa-4583-11e0-b54c-00137279a832")
        public Object caseAddVariableValueAction(AddVariableValueAction owner) {
            return null;
        }

        @Override
        @objid ("1cd8ea4b-4583-11e0-b54c-00137279a832")
        public Object caseCallOperationAction(CallOperationAction owner) {
            return null;
        }

        @Override
        @objid ("1cd8ea51-4583-11e0-b54c-00137279a832")
        public Object caseClearAssociationAction(ClearAssociationAction owner) {
            return null;
        }

        @Override
        @objid ("1cdb4ca2-4583-11e0-b54c-00137279a832")
        public Object caseDestroyObjectAction(DestroyObjectAction owner) {
            return null;
        }

        @Override
        @objid ("1cdb4ca8-4583-11e0-b54c-00137279a832")
        public Object caseInvocationAction(InvocationAction owner) {
            inputPinList = owner.getArguments();
            return 42;
        }

        @Override
        @objid ("1cdb4cae-4583-11e0-b54c-00137279a832")
        public Object caseLinkAction(LinkAction owner) {
            inputPinList = owner.getInputValues();
            return 42;
        }

        @Override
        @objid ("1cddaf00-4583-11e0-b54c-00137279a832")
        public Object caseLoopNode(LoopNode owner) {
            inputPinList = owner.getLoopVariableInputs();
            return 42;
        }

        @Override
        @objid ("1cddaf06-4583-11e0-b54c-00137279a832")
        public Object caseOpaqueAction(OpaqueAction owner) {
            inputPinList = owner.getInputValues();
            return 42;
        }

        @Override
        @objid ("1ce01157-4583-11e0-b54c-00137279a832")
        public Object caseRaiseExceptionAction(RaiseExceptionAction owner) {
            return null;
        }

        @Override
        @objid ("1ce0115d-4583-11e0-b54c-00137279a832")
        public Object caseReadIsClassifiedObjectAction(ReadIsClassifiedObjectAction owner) {
            return null;
        }

        @Override
        @objid ("1ce273b0-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkObjectEndAction(ReadLinkObjectEndAction owner) {
            return null;
        }

        @Override
        @objid ("1ce273b6-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkObjectEndQualifierAction(ReadLinkObjectEndQualifierAction owner) {
            return null;
        }

        @Override
        @objid ("1ce273bc-4583-11e0-b54c-00137279a832")
        public Object caseReclassifyObjectAction(ReclassifyObjectAction owner) {
            return null;
        }

        @Override
        @objid ("1ce4d60e-4583-11e0-b54c-00137279a832")
        public Object caseReduceAction(ReduceAction owner) {
            return null;
        }

        @Override
        @objid ("1ce4d614-4583-11e0-b54c-00137279a832")
        public Object caseRemoveStructuralFeatureValueAction(RemoveStructuralFeatureValueAction owner) {
            return null;
        }

        @Override
        @objid ("1ce73865-4583-11e0-b54c-00137279a832")
        public Object caseRemoveVariableValueAction(RemoveVariableValueAction owner) {
            return null;
        }

        @Override
        @objid ("1ce7386b-4583-11e0-b54c-00137279a832")
        public Object caseReplyAction(ReplyAction owner) {
            inputPinList = owner.getReplyValues();
            return 42;
        }

        @Override
        @objid ("1ce99abe-4583-11e0-b54c-00137279a832")
        public Object caseSendObjectAction(SendObjectAction owner) {
            return null;
        }

        @Override
        @objid ("1ce99ac4-4583-11e0-b54c-00137279a832")
        public Object caseSendSignalAction(SendSignalAction owner) {
            return null;
        }

        @Override
        @objid ("1ce99aca-4583-11e0-b54c-00137279a832")
        public Object caseStartClassifierBehaviorAction(StartClassifierBehaviorAction owner) {
            return null;
        }

        @Override
        @objid ("1cebfd1c-4583-11e0-b54c-00137279a832")
        public Object caseStructuralFeatureAction(StructuralFeatureAction owner) {
            return null;
        }

        @Override
        @objid ("1cebfd22-4583-11e0-b54c-00137279a832")
        public Object caseStructuredActivityNode(StructuredActivityNode owner) {
            inputPinList = owner.getInputs();
            return 42;
        }

        @Override
        @objid ("1cee5f74-4583-11e0-b54c-00137279a832")
        public Object caseTestIdentityAction(TestIdentityAction owner) {
            return null;
        }

        @Override
        @objid ("1cee5f7a-4583-11e0-b54c-00137279a832")
        public Object caseUnmarshallAction(UnmarshallAction owner) {
            return null;
        }

        @Override
        @objid ("1cf0c1cc-4583-11e0-b54c-00137279a832")
        public Object caseWriteStructuralFeatureAction(WriteStructuralFeatureAction owner) {
            return null;
        }

        @Override
        @objid ("1cf0c1d2-4583-11e0-b54c-00137279a832")
        public Object caseWriteVariableAction(WriteVariableAction owner) {
            return null;
        }

    }

}
