/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.util;

import java.util.List;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.uml2.uml.AcceptCallAction;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.Action;
import org.eclipse.uml2.uml.CallAction;
import org.eclipse.uml2.uml.ConditionalNode;
import org.eclipse.uml2.uml.CreateLinkObjectAction;
import org.eclipse.uml2.uml.CreateObjectAction;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.LoopNode;
import org.eclipse.uml2.uml.OpaqueAction;
import org.eclipse.uml2.uml.OutputPin;
import org.eclipse.uml2.uml.ReadExtentAction;
import org.eclipse.uml2.uml.ReadIsClassifiedObjectAction;
import org.eclipse.uml2.uml.ReadLinkAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction;
import org.eclipse.uml2.uml.ReadSelfAction;
import org.eclipse.uml2.uml.ReadStructuralFeatureAction;
import org.eclipse.uml2.uml.ReadVariableAction;
import org.eclipse.uml2.uml.ReduceAction;
import org.eclipse.uml2.uml.StructuredActivityNode;
import org.eclipse.uml2.uml.TestIdentityAction;
import org.eclipse.uml2.uml.UnmarshallAction;
import org.eclipse.uml2.uml.ValueSpecificationAction;
import org.eclipse.uml2.uml.util.UMLSwitch;

@objid ("1cf32426-4583-11e0-b54c-00137279a832")
public class OwnedOutputPinVisitor {
    @objid ("1cf32427-4583-11e0-b54c-00137279a832")
    private OutputPinGetter getter;

    @objid ("1cf32428-4583-11e0-b54c-00137279a832")
    private List<OutputPin> outputPinList;


    @objid ("1cf3242b-4583-11e0-b54c-00137279a832")
    public OwnedOutputPinVisitor() {
        getter = new OutputPinGetter();
        outputPinList = null;
    }

    @objid ("1cf3242d-4583-11e0-b54c-00137279a832")
    public List<OutputPin> getOutputPinList(Element owner) {
        if (outputPinList != null)
            outputPinList = null;
        getter.accept(owner);
        return outputPinList;
    }

    @objid ("1cf58680-4583-11e0-b54c-00137279a832")
    private class OutputPinGetter extends UMLSwitch {

        @objid ("1cf58681-4583-11e0-b54c-00137279a832")
        public void accept(Element ecoreElt) {
            doSwitch(ecoreElt);
        }

        @Override
        @objid ("1cf58684-4583-11e0-b54c-00137279a832")
        public Object caseAcceptCallAction(AcceptCallAction owner) {
            return null;
        }

        @Override
        @objid ("1cf5868a-4583-11e0-b54c-00137279a832")
        public Object caseAcceptEventAction(AcceptEventAction owner) {
            outputPinList = owner.getResults();
            return 42;
        }

        @Override
        @objid ("1cf7e8db-4583-11e0-b54c-00137279a832")
        public Object caseAction(Action owner) {
            outputPinList = owner.getOutputs();
            return 42;
        }

        @Override
        @objid ("1cf7e8e1-4583-11e0-b54c-00137279a832")
        public Object caseCallAction(CallAction owner) {
            outputPinList = owner.getResults();
            return 42;
        }

        @Override
        @objid ("1cfa4b34-4583-11e0-b54c-00137279a832")
        public Object caseConditionalNode(ConditionalNode owner) {
            outputPinList = owner.getResults();
            return 42;
        }

        @Override
        @objid ("1cfa4b3a-4583-11e0-b54c-00137279a832")
        public Object caseCreateLinkObjectAction(CreateLinkObjectAction owner) {
            return null;
        }

        @Override
        @objid ("1cfa4b40-4583-11e0-b54c-00137279a832")
        public Object caseCreateObjectAction(CreateObjectAction owner) {
            return null;
        }

        @Override
        @objid ("1cfcad90-4583-11e0-b54c-00137279a832")
        public Object caseLoopNode(LoopNode owner) {
            outputPinList = owner.getResults();
            return 42;
        }

        @Override
        @objid ("1cfcad96-4583-11e0-b54c-00137279a832")
        public Object caseOpaqueAction(OpaqueAction owner) {
            outputPinList = owner.getOutputValues();
            return 42;
        }

        @Override
        @objid ("1cff0fe8-4583-11e0-b54c-00137279a832")
        public Object caseReadExtentAction(ReadExtentAction owner) {
            return null;
        }

        @Override
        @objid ("1cff0fee-4583-11e0-b54c-00137279a832")
        public Object caseReadIsClassifiedObjectAction(ReadIsClassifiedObjectAction owner) {
            return null;
        }

        @Override
        @objid ("1cff0ff4-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkAction(ReadLinkAction owner) {
            return null;
        }

        @Override
        @objid ("1d017246-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkObjectEndAction(ReadLinkObjectEndAction owner) {
            return null;
        }

        @Override
        @objid ("1d01724c-4583-11e0-b54c-00137279a832")
        public Object caseReadLinkObjectEndQualifierAction(ReadLinkObjectEndQualifierAction owner) {
            return null;
        }

        @Override
        @objid ("1d03d49d-4583-11e0-b54c-00137279a832")
        public Object caseReadSelfAction(ReadSelfAction owner) {
            return null;
        }

        @Override
        @objid ("1d03d4a3-4583-11e0-b54c-00137279a832")
        public Object caseReadStructuralFeatureAction(ReadStructuralFeatureAction owner) {
            return null;
        }

        @Override
        @objid ("1d0636f6-4583-11e0-b54c-00137279a832")
        public Object caseReadVariableAction(ReadVariableAction owner) {
            return null;
        }

        @Override
        @objid ("1d0636fc-4583-11e0-b54c-00137279a832")
        public Object caseReduceAction(ReduceAction owner) {
            return null;
        }

        @Override
        @objid ("1d063702-4583-11e0-b54c-00137279a832")
        public Object caseStructuredActivityNode(StructuredActivityNode owner) {
            outputPinList = owner.getOutputs();
            return 42;
        }

        @Override
        @objid ("1d089954-4583-11e0-b54c-00137279a832")
        public Object caseTestIdentityAction(TestIdentityAction owner) {
            return null;
        }

        @Override
        @objid ("1d08995a-4583-11e0-b54c-00137279a832")
        public Object caseUnmarshallAction(UnmarshallAction owner) {
            outputPinList = owner.getResults();
            return 42;
        }

        @Override
        @objid ("1d0afbab-4583-11e0-b54c-00137279a832")
        public Object caseValueSpecificationAction(ValueSpecificationAction owner) {
            return null;
        }

    }

}
