/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.util;

import java.util.HashMap;
import com.modeliosoft.modelio.api.model.analyst.IAnalystProject;
import com.modeliosoft.modelio.api.model.analyst.IPropertySet;
import com.modeliosoft.modelio.api.model.analyst.IRequirement;
import com.modeliosoft.modelio.api.model.analyst.IRequirementContainer;
import com.modeliosoft.modelio.api.model.analyst.ITerm;
import com.modeliosoft.modelio.api.model.diagrams.IActivityDiagram;
import com.modeliosoft.modelio.api.model.diagrams.IBehaviorDiagram;
import com.modeliosoft.modelio.api.model.diagrams.IStaticDiagram;
import com.modeliosoft.modelio.api.model.extension.IProject;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityEdge;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityGroup;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityNode;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IActivityPartition;
import com.modeliosoft.modelio.api.model.uml.behavior.activity.IClause;
import com.modeliosoft.modelio.api.model.uml.behavior.common.IBehavior;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IInteractionFragment;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.ILifeline;
import com.modeliosoft.modelio.api.model.uml.behavior.interaction.IMessage;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IAbstractPseudoState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IConnectionPointReference;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IEvent;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IFinalState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IInternalTransition;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IRegion;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IState;
import com.modeliosoft.modelio.api.model.uml.behavior.state.IStateVertex;
import com.modeliosoft.modelio.api.model.uml.behavior.state.ITransition;
import com.modeliosoft.modelio.api.model.uml.information.IInformationFlow;
import com.modeliosoft.modelio.api.model.uml.information.IInformationItem;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IConstraint;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IDependency;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IModelElement;
import com.modeliosoft.modelio.api.model.uml.infrastructure.INote;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IProfile;
import com.modeliosoft.modelio.api.model.uml.infrastructure.IStereotype;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ISubstitution;
import com.modeliosoft.modelio.api.model.uml.infrastructure.ITaggedValue;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.IAssociationEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IAttribute;
import com.modeliosoft.modelio.api.model.uml.statik.IAttributeLink;
import com.modeliosoft.modelio.api.model.uml.statik.IBindableInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IBinding;
import com.modeliosoft.modelio.api.model.uml.statik.IClassAssociation;
import com.modeliosoft.modelio.api.model.uml.statik.ICollaborationUse;
import com.modeliosoft.modelio.api.model.uml.statik.IConnector;
import com.modeliosoft.modelio.api.model.uml.statik.IConnectorEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IDataFlow;
import com.modeliosoft.modelio.api.model.uml.statik.IDataType;
import com.modeliosoft.modelio.api.model.uml.statik.IElementImport;
import com.modeliosoft.modelio.api.model.uml.statik.IEnumerationLiteral;
import com.modeliosoft.modelio.api.model.uml.statik.IFeature;
import com.modeliosoft.modelio.api.model.uml.statik.IGeneralization;
import com.modeliosoft.modelio.api.model.uml.statik.IInstance;
import com.modeliosoft.modelio.api.model.uml.statik.IInterfaceRealization;
import com.modeliosoft.modelio.api.model.uml.statik.ILink;
import com.modeliosoft.modelio.api.model.uml.statik.ILinkEnd;
import com.modeliosoft.modelio.api.model.uml.statik.IManifestation;
import com.modeliosoft.modelio.api.model.uml.statik.IModelTree;
import com.modeliosoft.modelio.api.model.uml.statik.IOperation;
import com.modeliosoft.modelio.api.model.uml.statik.IPackage;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageImport;
import com.modeliosoft.modelio.api.model.uml.statik.IPackageMerge;
import com.modeliosoft.modelio.api.model.uml.statik.IParameter;
import com.modeliosoft.modelio.api.model.uml.statik.IPort;
import com.modeliosoft.modelio.api.model.uml.statik.IProvidedInterface;
import com.modeliosoft.modelio.api.model.uml.statik.IRaisedException;
import com.modeliosoft.modelio.api.model.uml.statik.IRequiredInterface;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateBinding;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameter;
import com.modeliosoft.modelio.api.model.uml.statik.ITemplateParameterSubstitution;
import com.modeliosoft.modelio.api.model.uml.usecase.IExtensionPoint;
import com.modeliosoft.modelio.api.model.uml.usecase.IUseCaseDependency;
import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.api.utils.DefaultMetamodelVisitor;
import com.modeliosoft.modelio.javadesigner.annotations.objid;

/**
 * This class checks if a given element is in the export scope
 * @author ebrosse
 */
@objid ("1d86f5f2-4583-11e0-b54c-00137279a832")
public class ScopeChecker {
    @objid ("1d86f5f3-4583-11e0-b54c-00137279a832")
    private IElement localRoot = null;

    @objid ("9db92877-1a76-11e1-8103-0027103f347d")
    private HashMap<IElement , Boolean> scopeMap = null;

    @objid ("1d86f5f8-4583-11e0-b54c-00137279a832")
    private ScopeSelector selector = null;

    @objid ("1d86f5fa-4583-11e0-b54c-00137279a832")
    private CompositionOwnerVisitor ownerVisitor = null;

    @objid ("6e7c9752-1a76-11e1-8103-0027103f347d")
    private Boolean theResult = null;


    @objid ("1d86f5fb-4583-11e0-b54c-00137279a832")
    public ScopeChecker(IElement localRoot, CompositionOwnerVisitor ownerVisitor) {
        this.localRoot = localRoot;
        this.scopeMap = new HashMap<IElement, Boolean>();
        this.selector = new ScopeSelector();
        this.ownerVisitor = ownerVisitor;
    }

    @objid ("1d86f5ff-4583-11e0-b54c-00137279a832")
    public boolean contains(IElement eltToTest) {
        if (eltToTest == null) {
            this.theResult = false;
        } else {
            this.theResult = this.scopeMap.get(eltToTest);
            if (this.theResult == null) {
                if (! ModelUtils.mustBeExported(eltToTest)){
                    this.theResult = false;
                }else{
                    this.selector.launchVisit(eltToTest);
                }
                this.scopeMap.put(eltToTest, this.theResult);
            }
        }
        return this.theResult;
    }

    @objid ("1d89584d-4583-11e0-b54c-00137279a832")
    private class ScopeSelector extends DefaultMetamodelVisitor {

        @objid ("1d89584e-4583-11e0-b54c-00137279a832")
        public void launchVisit(IElement eltToTest) {
            eltToTest.accept(this);
        }

        @Override
        @objid ("1d895851-4583-11e0-b54c-00137279a832")
        public Object visitAssociation(IAssociation eltToTest) {
            for (IAssociationEnd assocEnd : eltToTest.getConnection()) {
                if (!contains(ScopeChecker.this.ownerVisitor.getCompositionOwner(assocEnd)))
                    break;
            }
            return null;
        }

        @Override
        @objid ("1d895857-4583-11e0-b54c-00137279a832")
        public Object visitAssociationEnd(IAssociationEnd eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            
            if (theResult) {
                for (IAssociationEnd end : ObjingModelNavigation
                        .getOppositeAssociationEnds(eltToTest)) {
                    if (!contains(ownerVisitor.getCompositionOwner(end)))
                        break;
                }
            }
            return null;
        }

        @Override
        @objid ("1d8bbaaa-4583-11e0-b54c-00137279a832")
        public Object visitAttribute(IAttribute eltToTest) {
            IElement owner = ownerVisitor.getCompositionOwner(eltToTest);
            contains(owner);
            return null;
        }

        @Override
        @objid ("1d8bbab0-4583-11e0-b54c-00137279a832")
        public Object visitBehavior(IBehavior eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1d8e1d01-4583-11e0-b54c-00137279a832")
        public Object visitBindableInstance(IBindableInstance eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1d8e1d06-4583-11e0-b54c-00137279a832")
        public Object visitBinding(IBinding eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1d8e1d0b-4583-11e0-b54c-00137279a832")
        public Object visitClassAssociation(IClassAssociation eltToTest) {
            if (contains(eltToTest.getAssociationPart()))
                contains(eltToTest.getClassPart());
            return null;
        }

        @objid ("1d907f5b-4583-11e0-b54c-00137279a832")
        public Object visitCollaborationUse(ICollaborationUse eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1d907f60-4583-11e0-b54c-00137279a832")
        public Object visitConnectionPointReference(IConnectionPointReference eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1d907f65-4583-11e0-b54c-00137279a832")
        public Object visitConnector(IConnector eltToTest) {
            for (ILinkEnd linkEnd : eltToTest.getConnection()) {
                if (!contains(linkEnd.getLinked()))
                    break;
            }
            return null;
        }

        @objid ("1d92e1b4-4583-11e0-b54c-00137279a832")
        public Object visitConnectorEnd(IConnectorEnd eltToTest) {
            contains(eltToTest.getLinked());
            
            if (theResult) {
                for (ILinkEnd end : ObjingModelNavigation
                        .getOppositeLinkEnds(eltToTest)) {
                    IConnectorEnd connectorEnd = (IConnectorEnd) end;
                    if (!contains(connectorEnd.getLinked()))
                        break;
                }
            }
            return null;
        }

        @Override
        @objid ("1d92e1b9-4583-11e0-b54c-00137279a832")
        public Object visitConstraint(IConstraint eltToTest) {
            for (IModelElement constrainedElement : eltToTest
                    .getConstrainedElement()) {
                if (!contains(constrainedElement))
                    break;
            }
            return null;
        }

        @Override
        @objid ("1d92e1bf-4583-11e0-b54c-00137279a832")
        public Object visitDataFlow(IDataFlow eltToTest) {
            if (contains(eltToTest.getDestination()))
                contains(eltToTest.getOrigin());
            return null;
        }

        @Override
        @objid ("1d95440f-4583-11e0-b54c-00137279a832")
        public Object visitDependency(IDependency eltToTest) {
            if (contains(eltToTest.getDependsOn()))
                contains(eltToTest.getImpacted());
            return null;
        }

        @Override
        @objid ("1d954415-4583-11e0-b54c-00137279a832")
        public Object visitElement(IElement eltToTest) {
            throw new NotFoundException("Element of type "
                    + eltToTest.getClass()
                    + " has no implementation done in scope filter.");
        }

        @Override
        @objid ("1d95441a-4583-11e0-b54c-00137279a832")
        public Object visitElementImport(IElementImport eltToTest) {
            if (contains(eltToTest.getImportedElement()))
                contains(ownerVisitor.getCompositionOwner(eltToTest));
            
            // if (contains(eltToTest.getImportedElement())) {
            // IOperation importingOp = eltToTest.getImportingOperation();
            // if (importingOp != null) {
            // contains(importingOp.getOwner());
            // }
            // else {
            // contains(eltToTest.getImportingNameSpace().getOwner());
            // }
            // }
            return null;
        }

        @Override
        @objid ("1d97a66c-4583-11e0-b54c-00137279a832")
        public Object visitEnumerationLiteral(IEnumerationLiteral eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1d97a672-4583-11e0-b54c-00137279a832")
        public Object visitExtensionPoint(IExtensionPoint eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1d9a08c3-4583-11e0-b54c-00137279a832")
        public Object visitFeature(IFeature eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1d9a08c9-4583-11e0-b54c-00137279a832")
        public Object visitGeneralization(IGeneralization eltToTest) {
            if (contains(eltToTest.getSubType()))
                contains(eltToTest.getSuperType());
            return null;
        }

        @objid ("1d9c6b1c-4583-11e0-b54c-00137279a832")
        public Object visitInformationFlow(IInformationFlow eltToTest) {
            contains(eltToTest.getOwner());
            return null;
        }

        @objid ("1d9c6b21-4583-11e0-b54c-00137279a832")
        public Object visitInformationItem(IInformationItem eltToTest) {
            contains(eltToTest.getOwner());
            return null;
        }

        @Override
        @objid ("1d9c6b26-4583-11e0-b54c-00137279a832")
        public Object visitInteractionFragment(IInteractionFragment eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1d9ecd77-4583-11e0-b54c-00137279a832")
        public Object visitInterfaceRealization(IInterfaceRealization eltToTest) {
            if (contains(eltToTest.getImplemented()))
                contains(eltToTest.getImplementer());
            return null;
        }

        @Override
        @objid ("1d9ecd7d-4583-11e0-b54c-00137279a832")
        public Object visitLifeline(ILifeline eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1da12fd0-4583-11e0-b54c-00137279a832")
        public Object visitLink(ILink eltToTest) {
            for (ILinkEnd linkEnd : eltToTest.getConnection()) {
                if (!contains(linkEnd.getLinked()))
                    break;
            }
            return null;
        }

        @objid ("1da12fd5-4583-11e0-b54c-00137279a832")
        public Object visitLinkEnd(ILinkEnd eltToTest) {
            contains(eltToTest.getLinked());
            
            if (theResult) {
                for (ILinkEnd end : ObjingModelNavigation
                        .getOppositeLinkEnds(eltToTest)) {
                    if (!contains(end.getLinked()))
                        break;
                }
            }
            return null;
        }

        @Override
        @objid ("1da12fda-4583-11e0-b54c-00137279a832")
        public Object visitManifestation(IManifestation eltToTest) {
            if (contains(eltToTest.getUtilizedElement()))
                contains(eltToTest.getOwner());
            return null;
        }

        @Override
        @objid ("1da3922b-4583-11e0-b54c-00137279a832")
        public Object visitMessage(IMessage eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1da39231-4583-11e0-b54c-00137279a832")
        public Object visitModelTree(IModelTree eltToTest) {
            if (eltToTest == null)
                theResult = false;
            else if (eltToTest.equals(localRoot))
                theResult = true;
            else
                contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1da5f484-4583-11e0-b54c-00137279a832")
        public Object visitNote(INote eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1da5f48a-4583-11e0-b54c-00137279a832")
        public Object visitOperation(IOperation eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1da5f490-4583-11e0-b54c-00137279a832")
        public Object visitPackageImport(IPackageImport eltToTest) {
            if (eltToTest.equals(Modelio.getInstance().getModelingSession().getModel().getRoot()))
                theResult = true;
            
            else if (contains(eltToTest.getImportedPackage()))
                contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1da856e3-4583-11e0-b54c-00137279a832")
        public Object visitPackageMerge(IPackageMerge eltToTest) {
            if (contains(eltToTest.getMergedPackage()))
                contains(eltToTest.getReceivingPackage());
            return null;
        }

        @Override
        @objid ("1da856e9-4583-11e0-b54c-00137279a832")
        public Object visitParameter(IParameter eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1daab93c-4583-11e0-b54c-00137279a832")
        public Object visitProvidedInterface(IProvidedInterface eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1daab942-4583-11e0-b54c-00137279a832")
        public Object visitRaisedException(IRaisedException eltToTest) {
            if (contains(eltToTest.getThrownType()))
                contains(ownerVisitor.getCompositionOwner(eltToTest
                                                          .getThrower()));
            return null;
        }

        @objid ("1dad1b94-4583-11e0-b54c-00137279a832")
        public Object visitRegion(IRegion eltToTest) {
            if (eltToTest.getParent() != null)
                contains(eltToTest.getParent());
            else 
                contains(eltToTest.getRepresented());
            return null;
        }

        @objid ("1dad1b99-4583-11e0-b54c-00137279a832")
        public Object visitRequirement(IRequirement eltToTest) {
            theResult = false;
            return null;
        }

        @objid ("1daf7dec-4583-11e0-b54c-00137279a832")
        public Object visitRequirementContainer(IRequirementContainer eltToTest) {
            theResult = false;
            return null;
        }

        @objid ("1daf7df1-4583-11e0-b54c-00137279a832")
        public Object visitRequiredInterface(IRequiredInterface eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1daf7df6-4583-11e0-b54c-00137279a832")
        public Object visitStereotype(IStereotype eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1db1e046-4583-11e0-b54c-00137279a832")
        public Object visitSubstitution(ISubstitution eltToTest) {
            if (contains(eltToTest.getContract()))
                contains(eltToTest.getSubstitutingClassifier());
            return null;
        }

        @objid ("1db1e04c-4583-11e0-b54c-00137279a832")
        public Object visitTaggedValue(ITaggedValue eltToTest) {
            contains(eltToTest.getAnnoted());
            return null;
        }

        @Override
        @objid ("1db1e051-4583-11e0-b54c-00137279a832")
        public Object visitTemplateParameter(ITemplateParameter eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1db442a4-4583-11e0-b54c-00137279a832")
        public Object visitUseCaseDependency(IUseCaseDependency eltToTest) {
            if (contains(eltToTest.getTarget()))
                contains(eltToTest.getOrigin());
            return null;
        }

        @Override
        @objid ("1db442aa-4583-11e0-b54c-00137279a832")
        public Object visitAttributeLink(IAttributeLink eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1db6a4fe-4583-11e0-b54c-00137279a832")
        public Object visitInstance(IInstance eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1db6a504-4583-11e0-b54c-00137279a832")
        public Object visitPort(IPort eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1db90758-4583-11e0-b54c-00137279a832")
        public Object visitActivityEdge(IActivityEdge eltToTest) {
            if (contains(eltToTest.getSource()))
                contains(eltToTest.getTarget());
            return null;
        }

        @Override
        @objid ("1db9075e-4583-11e0-b54c-00137279a832")
        public Object visitActivityGroup(IActivityGroup eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1dbb69b2-4583-11e0-b54c-00137279a832")
        public Object visitActivityNode(IActivityNode eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1dbb69b8-4583-11e0-b54c-00137279a832")
        public Object visitActivityPartition(IActivityPartition eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1dbdcc0a-4583-11e0-b54c-00137279a832")
        public Object visitClause(IClause eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1dbdcc10-4583-11e0-b54c-00137279a832")
        public Object visitAbstractPseudoState(IAbstractPseudoState eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1dc02e64-4583-11e0-b54c-00137279a832")
        public Object visitFinalState(IFinalState eltToTest) {
            contains(eltToTest.getParent());
            return null;
        }

        @Override
        @objid ("1dc02e6a-4583-11e0-b54c-00137279a832")
        public Object visitState(IState eltToTest) {
            contains(eltToTest.getParent());
            return null;
        }

        @Override
        @objid ("1dc290be-4583-11e0-b54c-00137279a832")
        public Object visitTransition(ITransition eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1dc290c4-4583-11e0-b54c-00137279a832")
        public Object visitInternalTransition(IInternalTransition eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1dc4f318-4583-11e0-b54c-00137279a832")
        public Object visitEvent(IEvent eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1dc4f31d-4583-11e0-b54c-00137279a832")
        public Object visitTerm(ITerm eltToTest) {
            theResult = false;
            return null;
        }

        @Override
        @objid ("1dc75570-4583-11e0-b54c-00137279a832")
        public Object visitActivityDiagram(IActivityDiagram eltToTest) {
            theResult = false;
            return null;
        }

        @Override
        @objid ("1dc75576-4583-11e0-b54c-00137279a832")
        public Object visitBehaviorDiagram(IBehaviorDiagram eltToTest) {
            theResult = false;
            return null;
        }

        @objid ("1dc9b7ca-4583-11e0-b54c-00137279a832")
        public Object visitPropertySet(IPropertySet eltToTest) {
            theResult = false;
            return null;
        }

        @objid ("1dc9b7cf-4583-11e0-b54c-00137279a832")
        public Object visitStaticDiagram(IStaticDiagram eltToTest) {
            theResult = false;
            return null;
        }

        @objid ("1dcc1a24-4583-11e0-b54c-00137279a832")
        public Object visitTemplateBinding(ITemplateBinding eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @objid ("1dcc1a29-4583-11e0-b54c-00137279a832")
        public Object visitTemplateParameterSubstitution(ITemplateParameterSubstitution eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

        @Override
        @objid ("1dcc1a2e-4583-11e0-b54c-00137279a832")
        public Object visitProfile(IProfile eltToTest) {
            IPackage root = GenerationProperties.getInstance().getSelectedPackage();
            
            if  (root instanceof IProfile) {
                theResult = ((eltToTest).getName().contains(root.getName()))
                        && (((eltToTest).getCompositionOwner()).equals(root.getCompositionOwner()));             
            }else                
                theResult =  true;
            return null;
        }

        @Override
        @objid ("6e948d5c-1a76-11e1-8103-0027103f347d")
        public Object visitAnalystProject(final IAnalystProject eltToTest) {
            theResult = (GenerationProperties.getInstance().getSelectedPackage().equals(Modelio.getInstance().getModelingSession().getModel().getRoot()));
            return null;
        }

        @Override
        @objid ("6e94db80-1a76-11e1-8103-0027103f347d")
        public Object visitDataType(final IDataType eltToTest) {
            if (PrimitiveTypeMapper.isPredefinedType(eltToTest))
                theResult = true;
            else{
                contains(ownerVisitor.getCompositionOwner(eltToTest));
            }
            return null;
        }

        @Override
        @objid ("e7908499-469c-11e1-b92f-0027103f347d")
        public Object visitProject(final IProject eltToTest) {
            theResult = true;
            return null;
        }

        @Override
        @objid ("4f32249b-7d85-11e1-9422-0027103f347d")
        public Object visitStateVertex(final IStateVertex eltToTest) {
            contains(ownerVisitor.getCompositionOwner(eltToTest));
            return null;
        }

    }

}
