/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.util;

import com.modeliosoft.modelio.javadesigner.annotations.objid;

@objid ("1dce7c7f-4583-11e0-b54c-00137279a832")
public class StringConverter {
    @objid ("1dce7c80-4583-11e0-b54c-00137279a832")
    private static boolean isFilterEnabled = false;


    @objid ("1dce7c81-4583-11e0-b54c-00137279a832")
    public static boolean isFilterEnabled() {
        return isFilterEnabled;
    }

    @objid ("1dce7c85-4583-11e0-b54c-00137279a832")
    public static void setFilterEnabled(boolean activateFilter) {
        isFilterEnabled = activateFilter;
    }

    @objid ("1dce7c88-4583-11e0-b54c-00137279a832")
    public static String replaceAllSpaces(String inputString) {
        return inputString.replaceAll(" ", "");
    }

    @objid ("1dd0ded9-4583-11e0-b54c-00137279a832")
    public static Boolean getBoolean(String value) {
        try {
            if (isFilterEnabled)
                value = replaceAllSpaces(value);
            return Boolean.valueOf(value);
        } catch (Exception e) {
            return null;
        }
    }

    @objid ("1dd0dedd-4583-11e0-b54c-00137279a832")
    public static Integer getInteger(String value) {
        try {
            if (isFilterEnabled)
                value = replaceAllSpaces(value);
            return Integer.valueOf(value);
        } catch (Exception e) {
            return null;
        }
    }

    @objid ("1dd0dee1-4583-11e0-b54c-00137279a832")
    public static Long getLong(String value) {
        try {
            if (isFilterEnabled)
                value = replaceAllSpaces(value);
            return Long.valueOf(value);
        } catch (Exception e) {
            return null;
        }
    }

    @objid ("1dd34132-4583-11e0-b54c-00137279a832")
    public static String getString(long value) {
        try {
            return String.valueOf(value);
        } catch (Exception e) {
            return null;
        }
    }

}
