/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.util;

import com.modeliosoft.modelio.api.modelio.Modelio;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.URIConverter;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.UMLPackage;
import org.eclipse.uml2.uml.resource.UMLResource;
import sun.org.mozilla.javascript.internal.WrappedException;

@objid ("6ea297d4-1a76-11e1-8103-0027103f347d")
public class UMLMetamodel {
    @objid ("6ea297d5-1a76-11e1-8103-0027103f347d")
    private static UMLMetamodel INSTANCE = null;

    @objid ("6ea2e5f9-1a76-11e1-8103-0027103f347d")
    private static Model umlMetamodel = null;

    @objid ("6ea30d0a-1a76-11e1-8103-0027103f347d")
    private static Model umlLibrary = null;

    @objid ("6ea30d0b-1a76-11e1-8103-0027103f347d")
    private static Model ecoreLibrary = null;


    @objid ("6ea3341c-1a76-11e1-8103-0027103f347d")
    public Model getUMLMetamodel() {
        if (umlMetamodel == null)
            umlMetamodel = load(URI.createURI(UMLResource.UML_METAMODEL_URI));
        return umlMetamodel;
    }

    @objid ("6ea35b2f-1a76-11e1-8103-0027103f347d")
    public Model getUMLLibrary() {
        if (umlLibrary == null)
            umlLibrary = load(URI.createURI(UMLResource.UML_PRIMITIVE_TYPES_LIBRARY_URI));
        return umlLibrary;
    }

    @objid ("6ea3a953-1a76-11e1-8103-0027103f347d")
    public Model getEcoreLibrary() {
        if (ecoreLibrary == null)
            ecoreLibrary = load(URI.createURI(UMLResource.ECORE_PRIMITIVE_TYPES_LIBRARY_URI));
        return ecoreLibrary;
    }

    @objid ("6ea3f776-1a76-11e1-8103-0027103f347d")
    private Model load(final URI uriModel) {
        Model result = null;
        try {
        
            URI uri = URI.createURI(ResourceLoader.getInstance().getUMLRessource());
        
            Resource.Factory.Registry.INSTANCE.getExtensionToFactoryMap().put(UMLResource.FILE_EXTENSION, UMLResource.Factory.INSTANCE);
        
            URIConverter.URI_MAP.put(URI.createURI(UMLResource.LIBRARIES_PATHMAP), uri.appendSegment("libraries").appendSegment(""));
        
            URIConverter.URI_MAP.put(URI.createURI(UMLResource.METAMODELS_PATHMAP), uri.appendSegment("metamodels").appendSegment(""));
        
            URIConverter.URI_MAP.put(URI.createURI(UMLResource.PROFILES_PATHMAP), uri.appendSegment("profiles").appendSegment(""));
        
            ResourceSet resoureSet = new ResourceSetImpl();
            Resource resource = resoureSet.getResource(uriModel, true);
            result = (Model) EcoreUtil.getObjectByType(resource.getContents(), UMLPackage.Literals.PACKAGE);
        } catch (WrappedException we) {
            we.printStackTrace(Modelio.err);
        }
        return result;
    }

    @objid ("6ea46cac-1a76-11e1-8103-0027103f347d")
    private UMLMetamodel() {
    }

    @objid ("6ea493bf-1a76-11e1-8103-0027103f347d")
    public static UMLMetamodel getInstance() {
        if (INSTANCE == null)
            INSTANCE = new UMLMetamodel();
        return INSTANCE;
    }

}
