/*
 * Copyright 2011 Modeliosoft
 *
 * This file is part of Modelio.
 *
 * Modelio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Modelio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Modelio.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */  
                                    
package com.modeliosoft.modelio.xmi.reverse;

import java.util.HashMap;
import java.util.Map;
import com.modeliosoft.modelio.javadesigner.annotations.objid;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.uml.*;
import org.eclipse.uml2.uml.Abstraction;
import org.eclipse.uml2.uml.AcceptCallAction;
import org.eclipse.uml2.uml.AcceptEventAction;
import org.eclipse.uml2.uml.Action;
import org.eclipse.uml2.uml.ActionExecutionSpecification;
import org.eclipse.uml2.uml.ActionInputPin;
import org.eclipse.uml2.uml.Activity;
import org.eclipse.uml2.uml.ActivityEdge;
import org.eclipse.uml2.uml.ActivityFinalNode;
import org.eclipse.uml2.uml.ActivityGroup;
import org.eclipse.uml2.uml.ActivityNode;
import org.eclipse.uml2.uml.ActivityParameterNode;
import org.eclipse.uml2.uml.ActivityPartition;
import org.eclipse.uml2.uml.Actor;
import org.eclipse.uml2.uml.AddStructuralFeatureValueAction;
import org.eclipse.uml2.uml.AddVariableValueAction;
import org.eclipse.uml2.uml.AnyReceiveEvent;
import org.eclipse.uml2.uml.Artifact;
import org.eclipse.uml2.uml.Association;
import org.eclipse.uml2.uml.AssociationClass;
import org.eclipse.uml2.uml.Behavior;
import org.eclipse.uml2.uml.BehaviorExecutionSpecification;
import org.eclipse.uml2.uml.BehavioralFeature;
import org.eclipse.uml2.uml.BehavioredClassifier;
import org.eclipse.uml2.uml.BroadcastSignalAction;
import org.eclipse.uml2.uml.CallAction;
import org.eclipse.uml2.uml.CallBehaviorAction;
import org.eclipse.uml2.uml.CallEvent;
import org.eclipse.uml2.uml.CallOperationAction;
import org.eclipse.uml2.uml.CentralBufferNode;
import org.eclipse.uml2.uml.ChangeEvent;
import org.eclipse.uml2.uml.Class;
import org.eclipse.uml2.uml.Classifier;
import org.eclipse.uml2.uml.ClassifierTemplateParameter;
import org.eclipse.uml2.uml.Clause;
import org.eclipse.uml2.uml.ClearAssociationAction;
import org.eclipse.uml2.uml.ClearStructuralFeatureAction;
import org.eclipse.uml2.uml.ClearVariableAction;
import org.eclipse.uml2.uml.Collaboration;
import org.eclipse.uml2.uml.CollaborationUse;
import org.eclipse.uml2.uml.CombinedFragment;
import org.eclipse.uml2.uml.Comment;
import org.eclipse.uml2.uml.CommunicationPath;
import org.eclipse.uml2.uml.Component;
import org.eclipse.uml2.uml.ComponentRealization;
import org.eclipse.uml2.uml.ConditionalNode;
import org.eclipse.uml2.uml.ConnectableElement;
import org.eclipse.uml2.uml.ConnectableElementTemplateParameter;
import org.eclipse.uml2.uml.ConnectionPointReference;
import org.eclipse.uml2.uml.Connector;
import org.eclipse.uml2.uml.ConnectorEnd;
import org.eclipse.uml2.uml.ConsiderIgnoreFragment;
import org.eclipse.uml2.uml.Constraint;
import org.eclipse.uml2.uml.Continuation;
import org.eclipse.uml2.uml.ControlFlow;
import org.eclipse.uml2.uml.ControlNode;
import org.eclipse.uml2.uml.CreateLinkAction;
import org.eclipse.uml2.uml.CreateLinkObjectAction;
import org.eclipse.uml2.uml.CreateObjectAction;
import org.eclipse.uml2.uml.CreationEvent;
import org.eclipse.uml2.uml.DataStoreNode;
import org.eclipse.uml2.uml.DataType;
import org.eclipse.uml2.uml.DecisionNode;
import org.eclipse.uml2.uml.Dependency;
import org.eclipse.uml2.uml.DeployedArtifact;
import org.eclipse.uml2.uml.Deployment;
import org.eclipse.uml2.uml.DeploymentSpecification;
import org.eclipse.uml2.uml.DeploymentTarget;
import org.eclipse.uml2.uml.DestroyLinkAction;
import org.eclipse.uml2.uml.DestroyObjectAction;
import org.eclipse.uml2.uml.DestructionEvent;
import org.eclipse.uml2.uml.Device;
import org.eclipse.uml2.uml.DirectedRelationship;
import org.eclipse.uml2.uml.Duration;
import org.eclipse.uml2.uml.DurationConstraint;
import org.eclipse.uml2.uml.DurationInterval;
import org.eclipse.uml2.uml.DurationObservation;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.ElementImport;
import org.eclipse.uml2.uml.EncapsulatedClassifier;
import org.eclipse.uml2.uml.Enumeration;
import org.eclipse.uml2.uml.EnumerationLiteral;
import org.eclipse.uml2.uml.Event;
import org.eclipse.uml2.uml.ExceptionHandler;
import org.eclipse.uml2.uml.ExecutableNode;
import org.eclipse.uml2.uml.ExecutionEnvironment;
import org.eclipse.uml2.uml.ExecutionEvent;
import org.eclipse.uml2.uml.ExecutionOccurrenceSpecification;
import org.eclipse.uml2.uml.ExecutionSpecification;
import org.eclipse.uml2.uml.ExpansionNode;
import org.eclipse.uml2.uml.ExpansionRegion;
import org.eclipse.uml2.uml.Expression;
import org.eclipse.uml2.uml.Extend;
import org.eclipse.uml2.uml.Extension;
import org.eclipse.uml2.uml.ExtensionEnd;
import org.eclipse.uml2.uml.ExtensionPoint;
import org.eclipse.uml2.uml.Feature;
import org.eclipse.uml2.uml.FinalNode;
import org.eclipse.uml2.uml.FinalState;
import org.eclipse.uml2.uml.FlowFinalNode;
import org.eclipse.uml2.uml.ForkNode;
import org.eclipse.uml2.uml.FunctionBehavior;
import org.eclipse.uml2.uml.Gate;
import org.eclipse.uml2.uml.GeneralOrdering;
import org.eclipse.uml2.uml.Generalization;
import org.eclipse.uml2.uml.GeneralizationSet;
import org.eclipse.uml2.uml.Image;
import org.eclipse.uml2.uml.Include;
import org.eclipse.uml2.uml.InformationFlow;
import org.eclipse.uml2.uml.InformationItem;
import org.eclipse.uml2.uml.InitialNode;
import org.eclipse.uml2.uml.InputPin;
import org.eclipse.uml2.uml.InstanceSpecification;
import org.eclipse.uml2.uml.InstanceValue;
import org.eclipse.uml2.uml.Interaction;
import org.eclipse.uml2.uml.InteractionConstraint;
import org.eclipse.uml2.uml.InteractionFragment;
import org.eclipse.uml2.uml.InteractionOperand;
import org.eclipse.uml2.uml.InteractionUse;
import org.eclipse.uml2.uml.Interface;
import org.eclipse.uml2.uml.InterfaceRealization;
import org.eclipse.uml2.uml.InterruptibleActivityRegion;
import org.eclipse.uml2.uml.Interval;
import org.eclipse.uml2.uml.IntervalConstraint;
import org.eclipse.uml2.uml.InvocationAction;
import org.eclipse.uml2.uml.JoinNode;
import org.eclipse.uml2.uml.Lifeline;
import org.eclipse.uml2.uml.LinkAction;
import org.eclipse.uml2.uml.LinkEndCreationData;
import org.eclipse.uml2.uml.LinkEndData;
import org.eclipse.uml2.uml.LinkEndDestructionData;
import org.eclipse.uml2.uml.LiteralBoolean;
import org.eclipse.uml2.uml.LiteralInteger;
import org.eclipse.uml2.uml.LiteralNull;
import org.eclipse.uml2.uml.LiteralSpecification;
import org.eclipse.uml2.uml.LiteralString;
import org.eclipse.uml2.uml.LiteralUnlimitedNatural;
import org.eclipse.uml2.uml.LoopNode;
import org.eclipse.uml2.uml.Manifestation;
import org.eclipse.uml2.uml.MergeNode;
import org.eclipse.uml2.uml.Message;
import org.eclipse.uml2.uml.MessageEnd;
import org.eclipse.uml2.uml.MessageEvent;
import org.eclipse.uml2.uml.MessageOccurrenceSpecification;
import org.eclipse.uml2.uml.Model;
import org.eclipse.uml2.uml.MultiplicityElement;
import org.eclipse.uml2.uml.NamedElement;
import org.eclipse.uml2.uml.Namespace;
import org.eclipse.uml2.uml.Node;
import org.eclipse.uml2.uml.ObjectFlow;
import org.eclipse.uml2.uml.ObjectNode;
import org.eclipse.uml2.uml.Observation;
import org.eclipse.uml2.uml.OccurrenceSpecification;
import org.eclipse.uml2.uml.OpaqueAction;
import org.eclipse.uml2.uml.OpaqueBehavior;
import org.eclipse.uml2.uml.OpaqueExpression;
import org.eclipse.uml2.uml.Operation;
import org.eclipse.uml2.uml.OperationTemplateParameter;
import org.eclipse.uml2.uml.OutputPin;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.PackageImport;
import org.eclipse.uml2.uml.PackageMerge;
import org.eclipse.uml2.uml.PackageableElement;
import org.eclipse.uml2.uml.Parameter;
import org.eclipse.uml2.uml.ParameterSet;
import org.eclipse.uml2.uml.ParameterableElement;
import org.eclipse.uml2.uml.PartDecomposition;
import org.eclipse.uml2.uml.Pin;
import org.eclipse.uml2.uml.Port;
import org.eclipse.uml2.uml.PrimitiveType;
import org.eclipse.uml2.uml.Profile;
import org.eclipse.uml2.uml.ProfileApplication;
import org.eclipse.uml2.uml.Property;
import org.eclipse.uml2.uml.ProtocolConformance;
import org.eclipse.uml2.uml.ProtocolStateMachine;
import org.eclipse.uml2.uml.ProtocolTransition;
import org.eclipse.uml2.uml.Pseudostate;
import org.eclipse.uml2.uml.QualifierValue;
import org.eclipse.uml2.uml.RaiseExceptionAction;
import org.eclipse.uml2.uml.ReadExtentAction;
import org.eclipse.uml2.uml.ReadIsClassifiedObjectAction;
import org.eclipse.uml2.uml.ReadLinkAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndAction;
import org.eclipse.uml2.uml.ReadLinkObjectEndQualifierAction;
import org.eclipse.uml2.uml.ReadSelfAction;
import org.eclipse.uml2.uml.ReadStructuralFeatureAction;
import org.eclipse.uml2.uml.ReadVariableAction;
import org.eclipse.uml2.uml.Realization;
import org.eclipse.uml2.uml.ReceiveOperationEvent;
import org.eclipse.uml2.uml.ReceiveSignalEvent;
import org.eclipse.uml2.uml.Reception;
import org.eclipse.uml2.uml.ReclassifyObjectAction;
import org.eclipse.uml2.uml.RedefinableElement;
import org.eclipse.uml2.uml.RedefinableTemplateSignature;
import org.eclipse.uml2.uml.ReduceAction;
import org.eclipse.uml2.uml.Region;
import org.eclipse.uml2.uml.Relationship;
import org.eclipse.uml2.uml.RemoveStructuralFeatureValueAction;
import org.eclipse.uml2.uml.RemoveVariableValueAction;
import org.eclipse.uml2.uml.ReplyAction;
import org.eclipse.uml2.uml.SendObjectAction;
import org.eclipse.uml2.uml.SendOperationEvent;
import org.eclipse.uml2.uml.SendSignalAction;
import org.eclipse.uml2.uml.SendSignalEvent;
import org.eclipse.uml2.uml.SequenceNode;
import org.eclipse.uml2.uml.Signal;
import org.eclipse.uml2.uml.SignalEvent;
import org.eclipse.uml2.uml.Slot;
import org.eclipse.uml2.uml.StartClassifierBehaviorAction;
import org.eclipse.uml2.uml.State;
import org.eclipse.uml2.uml.StateInvariant;
import org.eclipse.uml2.uml.StateMachine;
import org.eclipse.uml2.uml.Stereotype;
import org.eclipse.uml2.uml.StringExpression;
import org.eclipse.uml2.uml.StructuralFeature;
import org.eclipse.uml2.uml.StructuralFeatureAction;
import org.eclipse.uml2.uml.StructuredActivityNode;
import org.eclipse.uml2.uml.StructuredClassifier;
import org.eclipse.uml2.uml.Substitution;
import org.eclipse.uml2.uml.TemplateBinding;
import org.eclipse.uml2.uml.TemplateParameter;
import org.eclipse.uml2.uml.TemplateParameterSubstitution;
import org.eclipse.uml2.uml.TemplateSignature;
import org.eclipse.uml2.uml.TemplateableElement;
import org.eclipse.uml2.uml.TestIdentityAction;
import org.eclipse.uml2.uml.TimeConstraint;
import org.eclipse.uml2.uml.TimeEvent;
import org.eclipse.uml2.uml.TimeExpression;
import org.eclipse.uml2.uml.TimeInterval;
import org.eclipse.uml2.uml.TimeObservation;
import org.eclipse.uml2.uml.Transition;
import org.eclipse.uml2.uml.Trigger;
import org.eclipse.uml2.uml.Type;
import org.eclipse.uml2.uml.TypedElement;
import org.eclipse.uml2.uml.UnmarshallAction;
import org.eclipse.uml2.uml.Usage;
import org.eclipse.uml2.uml.UseCase;
import org.eclipse.uml2.uml.ValuePin;
import org.eclipse.uml2.uml.ValueSpecification;
import org.eclipse.uml2.uml.ValueSpecificationAction;
import org.eclipse.uml2.uml.Variable;
import org.eclipse.uml2.uml.VariableAction;
import org.eclipse.uml2.uml.Vertex;
import org.eclipse.uml2.uml.WriteLinkAction;
import org.eclipse.uml2.uml.WriteStructuralFeatureAction;
import org.eclipse.uml2.uml.WriteVariableAction;
import org.eclipse.uml2.uml.util.UMLSwitch;

@objid ("125c526c-4583-11e0-b54c-00137279a832")
public class EParseModel extends UMLSwitch<Object> {
    @objid ("125c526d-4583-11e0-b54c-00137279a832")
    private XMIImportBehavior behavior;

    @objid ("125c526e-4583-11e0-b54c-00137279a832")
    private Map<Object, Object> visitorMap;


    @objid ("125c5273-4583-11e0-b54c-00137279a832")
    public EParseModel(XMIImportBehavior behavior, Package ecoreRootModel) {
        this.behavior = behavior;
        this.visitorMap = new HashMap<Object, Object>();
        this.visitorMap.put(ecoreRootModel, ecoreRootModel);
    }

    @Override
    @objid ("125c5277-4583-11e0-b54c-00137279a832")
    public Object caseAbstraction(Abstraction inputAbstraction) {
        Object theResult = visitorMap.get(inputAbstraction);
        if (theResult == null) {
            visitorMap.put(inputAbstraction, inputAbstraction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AbstractionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitAbstraction(inputAbstraction);
            theResult = super.caseAbstraction(inputAbstraction);
            this.doSwitch((EObject) inputAbstraction.getMapping());
        }
        return theResult;
    }

    @Override
    @objid ("12611720-4583-11e0-b54c-00137279a832")
    public Object caseAcceptCallAction(AcceptCallAction inputAcceptCallAction) {
        Object theResult = visitorMap.get(inputAcceptCallAction);
        if (theResult == null) {
            visitorMap.put(inputAcceptCallAction, inputAcceptCallAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AcceptCallActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitAcceptCallAction(inputAcceptCallAction);
            theResult = super.caseAcceptCallAction(inputAcceptCallAction);
            this.doSwitch((EObject) inputAcceptCallAction
                    .getReturnInformation());
        }
        return theResult;
    }

    @Override
    @objid ("12611726-4583-11e0-b54c-00137279a832")
    public Object caseAcceptEventAction(AcceptEventAction inputAcceptEventAction) {
        Object theResult = visitorMap.get(inputAcceptEventAction);
        if (theResult == null) {
            visitorMap.put(inputAcceptEventAction, inputAcceptEventAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AcceptEventActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitAcceptEventAction(inputAcceptEventAction);
            theResult = super.caseAcceptEventAction(inputAcceptEventAction);
            for (Object result : inputAcceptEventAction.getResults()) {
                this.doSwitch((EObject) result);
            }
            for (Object trigger : inputAcceptEventAction.getTriggers()) {
                this.doSwitch((EObject) trigger);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1261172c-4583-11e0-b54c-00137279a832")
    public Object caseAction(Action inputAction) {
        Object theResult = super.caseAction(inputAction);
        for (Object output : inputAction.getOutputs()) {
            this.doSwitch((EObject) output);
        }
        for (Object input : inputAction.getInputs()) {
            this.doSwitch((EObject) input);
        }
        this.doSwitch((EObject) inputAction.getContext());
        for (Object localPrecondition : inputAction.getLocalPreconditions()) {
            this.doSwitch((EObject) localPrecondition);
        }
        for (Object localPostcondition : inputAction.getLocalPostconditions()) {
            this.doSwitch((EObject) localPostcondition);
        }
        return theResult;
    }

    @Override
    @objid ("1263797f-4583-11e0-b54c-00137279a832")
    public Object caseActionExecutionSpecification(ActionExecutionSpecification inputActionExecutionSpecification) {
        Object theResult = visitorMap.get(inputActionExecutionSpecification);
        if (theResult == null) {
            visitorMap.put(inputActionExecutionSpecification,
                    inputActionExecutionSpecification);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActionExecutionSpecificationImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitActionExecutionSpecification(inputActionExecutionSpecification);
            theResult = super
            .caseActionExecutionSpecification(inputActionExecutionSpecification);
            this.doSwitch((EObject) inputActionExecutionSpecification
                    .getAction());
        }
        return theResult;
    }

    @Override
    @objid ("12637985-4583-11e0-b54c-00137279a832")
    public Object caseActionInputPin(ActionInputPin inputActionInputPin) {
        Object theResult = visitorMap.get(inputActionInputPin);
        if (theResult == null) {
            visitorMap.put(inputActionInputPin, inputActionInputPin);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActionInputPinImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitActionInputPin(inputActionInputPin);
            theResult = super.caseActionInputPin(inputActionInputPin);
            this.doSwitch((EObject) inputActionInputPin.getFromAction());
        }
        return theResult;
    }

    @Override
    @objid ("1265dbd6-4583-11e0-b54c-00137279a832")
    public Object caseActivity(Activity inputActivity) {
        Object theResult = visitorMap.get(inputActivity);
        if (theResult == null) {
            visitorMap.put(inputActivity, inputActivity);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActivityImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitActivity(inputActivity);
            theResult = super.caseActivity(inputActivity);
            for (Object structuredNode : inputActivity.getStructuredNodes()) {
                this.doSwitch((EObject) structuredNode);
            }
            for (Object variable : inputActivity.getVariables()) {
                this.doSwitch((EObject) variable);
            }
            for (Object node : inputActivity.getNodes()) {
                this.doSwitch((EObject) node);
            }
            for (Object edge : inputActivity.getEdges()) {
                this.doSwitch((EObject) edge);
            }
            for (Object partition : inputActivity.getPartitions()) {
                this.doSwitch((EObject) partition);
            }
            for (Object group : inputActivity.getGroups()) {
                this.doSwitch((EObject) group);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1265dbdc-4583-11e0-b54c-00137279a832")
    public Object caseActivityEdge(ActivityEdge inputActivityEdge) {
        Object theResult = super.caseActivityEdge(inputActivityEdge);
        this.doSwitch((EObject) inputActivityEdge.getActivity());
        this.doSwitch((EObject) inputActivityEdge.getSource());
        this.doSwitch((EObject) inputActivityEdge.getTarget());
        for (Object redefinedEdge : inputActivityEdge.getRedefinedEdges()) {
            this.doSwitch((EObject) redefinedEdge);
        }
        for (Object inPartition : inputActivityEdge.getInPartitions()) {
            this.doSwitch((EObject) inPartition);
        }
        this.doSwitch((EObject) inputActivityEdge.getGuard());
        this.doSwitch((EObject) inputActivityEdge.getWeight());
        this.doSwitch((EObject) inputActivityEdge.getInterrupts());
        this.doSwitch((EObject) inputActivityEdge.getInStructuredNode());
        for (Object inGroup : inputActivityEdge.getInGroups()) {
            this.doSwitch((EObject) inGroup);
        }
        return theResult;
    }

    @Override
    @objid ("12683e2e-4583-11e0-b54c-00137279a832")
    public Object caseActivityFinalNode(ActivityFinalNode inputActivityFinalNode) {
        Object theResult = visitorMap.get(inputActivityFinalNode);
        if (theResult == null) {
            visitorMap.put(inputActivityFinalNode, inputActivityFinalNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActivityFinalNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitActivityFinalNode(inputActivityFinalNode);
            theResult = super.caseActivityFinalNode(inputActivityFinalNode);
        }
        return theResult;
    }

    @Override
    @objid ("12683e34-4583-11e0-b54c-00137279a832")
    public Object caseActivityGroup(ActivityGroup inputActivityGroup) {
        Object theResult = super.caseActivityGroup(inputActivityGroup);
        for (Object subgroup : inputActivityGroup.getSubgroups()) {
            this.doSwitch((EObject) subgroup);
        }
        this.doSwitch((EObject) inputActivityGroup.getSuperGroup());
        this.doSwitch((EObject) inputActivityGroup.getInActivity());
        for (Object containedNode : inputActivityGroup.getContainedNodes()) {
            this.doSwitch((EObject) containedNode);
        }
        for (Object containedEdge : inputActivityGroup.getContainedEdges()) {
            this.doSwitch((EObject) containedEdge);
        }
        return theResult;
    }

    @Override
    @objid ("12683e3a-4583-11e0-b54c-00137279a832")
    public Object caseActivityNode(ActivityNode inputActivityNode) {
        Object theResult = super.caseActivityNode(inputActivityNode);
        this.doSwitch((EObject) inputActivityNode.getInStructuredNode());
        this.doSwitch((EObject) inputActivityNode.getActivity());
        for (Object outgoing : inputActivityNode.getOutgoings()) {
            this.doSwitch((EObject) outgoing);
        }
        for (Object incoming : inputActivityNode.getIncomings()) {
            this.doSwitch((EObject) incoming);
        }
        for (Object redefinedNode : inputActivityNode.getRedefinedNodes()) {
            this.doSwitch((EObject) redefinedNode);
        }
        for (Object inPartition : inputActivityNode.getInPartitions()) {
            this.doSwitch((EObject) inPartition);
        }
        for (Object inInterruptibleRegion : inputActivityNode
                .getInInterruptibleRegions()) {
            this.doSwitch((EObject) inInterruptibleRegion);
        }
        for (Object inGroup : inputActivityNode.getInGroups()) {
            this.doSwitch((EObject) inGroup);
        }
        return theResult;
    }

    @Override
    @objid ("126aa08c-4583-11e0-b54c-00137279a832")
    public Object caseActivityParameterNode(ActivityParameterNode inputActivityParameterNode) {
        Object theResult = visitorMap.get(inputActivityParameterNode);
        if (theResult == null) {
            visitorMap.put(inputActivityParameterNode,
                    inputActivityParameterNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActivityParameterNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitActivityParameterNode(inputActivityParameterNode);
            theResult = super
            .caseActivityParameterNode(inputActivityParameterNode);
            this.doSwitch((EObject) inputActivityParameterNode.getParameter());
        }
        return theResult;
    }

    @Override
    @objid ("126aa092-4583-11e0-b54c-00137279a832")
    public Object caseActivityPartition(ActivityPartition inputActivityPartition) {
        Object theResult = visitorMap.get(inputActivityPartition);
        if (theResult == null) {
            visitorMap.put(inputActivityPartition, inputActivityPartition);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActivityPartitionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitActivityPartition(inputActivityPartition);
            theResult = super.caseActivityPartition(inputActivityPartition);
            for (Object edge : inputActivityPartition.getEdges()) {
                this.doSwitch((EObject) edge);
            }
            for (Object node : inputActivityPartition.getNodes()) {
                this.doSwitch((EObject) node);
            }
            for (Object subpartition : inputActivityPartition
                    .getSubpartitions()) {
                this.doSwitch((EObject) subpartition);
            }
            this.doSwitch((EObject) inputActivityPartition.getSuperPartition());
            this.doSwitch((EObject) inputActivityPartition.getRepresents());
        }
        return theResult;
    }

    @Override
    @objid ("126d02e3-4583-11e0-b54c-00137279a832")
    public Object caseActor(Actor inputActor) {
        Object theResult = visitorMap.get(inputActor);
        if (theResult == null) {
            visitorMap.put(inputActor, inputActor);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ActorImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitActor(inputActor);
            theResult = super.caseActor(inputActor);
        }
        return theResult;
    }

    @Override
    @objid ("126d02e9-4583-11e0-b54c-00137279a832")
    public Object caseAddStructuralFeatureValueAction(AddStructuralFeatureValueAction inputAddStructuralFeatureValueAction) {
        Object theResult = visitorMap.get(inputAddStructuralFeatureValueAction);
        if (theResult == null) {
            visitorMap.put(inputAddStructuralFeatureValueAction,
                    inputAddStructuralFeatureValueAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AddStructuralFeatureValueActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitAddStructuralFeatureValueAction(inputAddStructuralFeatureValueAction);
            theResult = super
            .caseAddStructuralFeatureValueAction(inputAddStructuralFeatureValueAction);
            this.doSwitch((EObject) inputAddStructuralFeatureValueAction
                    .getInsertAt());
        }
        return theResult;
    }

    @Override
    @objid ("126f653c-4583-11e0-b54c-00137279a832")
    public Object caseAddVariableValueAction(AddVariableValueAction inputAddVariableValueAction) {
        Object theResult = visitorMap.get(inputAddVariableValueAction);
        if (theResult == null) {
            visitorMap.put(inputAddVariableValueAction,
                    inputAddVariableValueAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AddVariableValueActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitAddVariableValueAction(inputAddVariableValueAction);
            theResult = super
            .caseAddVariableValueAction(inputAddVariableValueAction);
            this.doSwitch((EObject) inputAddVariableValueAction.getInsertAt());
        }
        return theResult;
    }

    @Override
    @objid ("126f6542-4583-11e0-b54c-00137279a832")
    public Object caseAnyReceiveEvent(AnyReceiveEvent inputAnyReceiveEvent) {
        Object theResult = visitorMap.get(inputAnyReceiveEvent);
        if (theResult == null) {
            visitorMap.put(inputAnyReceiveEvent, inputAnyReceiveEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AnyReceiveEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitAnyReceiveEvent(inputAnyReceiveEvent);
            theResult = super.caseAnyReceiveEvent(inputAnyReceiveEvent);
        }
        return theResult;
    }

    @Override
    @objid ("126f6548-4583-11e0-b54c-00137279a832")
    public Object caseArtifact(Artifact inputArtifact) {
        Object theResult = visitorMap.get(inputArtifact);
        if (theResult == null) {
            visitorMap.put(inputArtifact, inputArtifact);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ArtifactImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitArtifact(inputArtifact);
            theResult = super.caseArtifact(inputArtifact);
            for (Object nestedArtifact : inputArtifact.getNestedArtifacts()) {
                this.doSwitch((EObject) nestedArtifact);
            }
            for (Object manifestation : inputArtifact.getManifestations()) {
                this.doSwitch((EObject) manifestation);
            }
            for (Object ownedOperation : inputArtifact.getOwnedOperations()) {
                this.doSwitch((EObject) ownedOperation);
            }
            for (Object ownedAttribute : inputArtifact.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1271c79a-4583-11e0-b54c-00137279a832")
    public Object caseAssociation(Association inputAssociation) {
        Object theResult = visitorMap.get(inputAssociation);
        if (theResult == null) {
            visitorMap.put(inputAssociation, inputAssociation);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AssociationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitAssociation(inputAssociation);
            theResult = super.caseAssociation(inputAssociation);
            for (Object ownedEnd : inputAssociation.getOwnedEnds()) {
                this.doSwitch((EObject) ownedEnd);
            }
            for (Object endType : inputAssociation.getEndTypes()) {
                this.doSwitch((EObject) endType);
            }
            for (Object memberEnd : inputAssociation.getMemberEnds()) {
                this.doSwitch((EObject) memberEnd);
            }
            for (Object navigableOwnedEnd : inputAssociation
                    .getNavigableOwnedEnds()) {
                this.doSwitch((EObject) navigableOwnedEnd);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1271c7a0-4583-11e0-b54c-00137279a832")
    public Object caseAssociationClass(AssociationClass inputAssociationClass) {
        Object theResult = visitorMap.get(inputAssociationClass);
        if (theResult == null) {
            visitorMap.put(inputAssociationClass, inputAssociationClass);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("AssociationClassImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitAssociationClass(inputAssociationClass);
            theResult = super.caseAssociationClass(inputAssociationClass);
        }
        return theResult;
    }

    @Override
    @objid ("127429f1-4583-11e0-b54c-00137279a832")
    public Object caseBehavior(Behavior inputBehavior) {
        Object theResult = super.caseBehavior(inputBehavior);
        for (Object redefinedBehavior : inputBehavior.getRedefinedBehaviors()) {
            this.doSwitch((EObject) redefinedBehavior);
        }
        this.doSwitch((EObject) inputBehavior.getSpecification());
        for (Object ownedParameter : inputBehavior.getOwnedParameters()) {
            this.doSwitch((EObject) ownedParameter);
        }
        this.doSwitch((EObject) inputBehavior.getContext());
        for (Object precondition : inputBehavior.getPreconditions()) {
            this.doSwitch((EObject) precondition);
        }
        for (Object postcondition : inputBehavior.getPostconditions()) {
            this.doSwitch((EObject) postcondition);
        }
        for (Object ownedParameterSet : inputBehavior.getOwnedParameterSets()) {
            this.doSwitch((EObject) ownedParameterSet);
        }
        return theResult;
    }

    @Override
    @objid ("127429f7-4583-11e0-b54c-00137279a832")
    public Object caseBehaviorExecutionSpecification(BehaviorExecutionSpecification inputBehaviorExecutionSpecification) {
        Object theResult = visitorMap.get(inputBehaviorExecutionSpecification);
        if (theResult == null) {
            visitorMap.put(inputBehaviorExecutionSpecification,
                    inputBehaviorExecutionSpecification);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("BehaviorExecutionSpecificationImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitBehaviorExecutionSpecification(inputBehaviorExecutionSpecification);
            theResult = super
            .caseBehaviorExecutionSpecification(inputBehaviorExecutionSpecification);
            this.doSwitch((EObject) inputBehaviorExecutionSpecification
                    .getBehavior());
        }
        return theResult;
    }

    @Override
    @objid ("12768c4b-4583-11e0-b54c-00137279a832")
    public Object caseBehavioralFeature(BehavioralFeature inputBehavioralFeature) {
        Object theResult = super.caseBehavioralFeature(inputBehavioralFeature);
        for (Object ownedParameter : inputBehavioralFeature
                .getOwnedParameters()) {
            this.doSwitch((EObject) ownedParameter);
        }
        for (Object method : inputBehavioralFeature.getMethods()) {
            this.doSwitch((EObject) method);
        }
        for (Object raisedException : inputBehavioralFeature
                .getRaisedExceptions()) {
            this.doSwitch((EObject) raisedException);
        }
        for (Object ownedParameterSet : inputBehavioralFeature
                .getOwnedParameterSets()) {
            this.doSwitch((EObject) ownedParameterSet);
        }
        return theResult;
    }

    @Override
    @objid ("12768c51-4583-11e0-b54c-00137279a832")
    public Object caseBehavioredClassifier(BehavioredClassifier inputBehavioredClassifier) {
        Object theResult = super
        .caseBehavioredClassifier(inputBehavioredClassifier);
        for (Object ownedBehavior : inputBehavioredClassifier
                .getOwnedBehaviors()) {
            this.doSwitch((EObject) ownedBehavior);
        }
        this.doSwitch((EObject) inputBehavioredClassifier
                .getClassifierBehavior());
        for (Object interfaceRealization : inputBehavioredClassifier
                .getInterfaceRealizations()) {
            this.doSwitch((EObject) interfaceRealization);
        }
        for (Object ownedTrigger : inputBehavioredClassifier.getOwnedTriggers()) {
            this.doSwitch((EObject) ownedTrigger);
        }
        return theResult;
    }

    @Override
    @objid ("1278eea4-4583-11e0-b54c-00137279a832")
    public Object caseBroadcastSignalAction(BroadcastSignalAction inputBroadcastSignalAction) {
        Object theResult = visitorMap.get(inputBroadcastSignalAction);
        if (theResult == null) {
            visitorMap.put(inputBroadcastSignalAction,
                    inputBroadcastSignalAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("BroadcastSignalActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitBroadcastSignalAction(inputBroadcastSignalAction);
            theResult = super
            .caseBroadcastSignalAction(inputBroadcastSignalAction);
            this.doSwitch((EObject) inputBroadcastSignalAction.getSignal());
        }
        return theResult;
    }

    @Override
    @objid ("1278eeaa-4583-11e0-b54c-00137279a832")
    public Object caseCallAction(CallAction inputCallAction) {
        Object theResult = super.caseCallAction(inputCallAction);
        for (Object result : inputCallAction.getResults()) {
            this.doSwitch((EObject) result);
        }
        return theResult;
    }

    @Override
    @objid ("127b50fe-4583-11e0-b54c-00137279a832")
    public Object caseCallBehaviorAction(CallBehaviorAction inputCallBehaviorAction) {
        Object theResult = visitorMap.get(inputCallBehaviorAction);
        if (theResult == null) {
            visitorMap.put(inputCallBehaviorAction, inputCallBehaviorAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CallBehaviorActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCallBehaviorAction(inputCallBehaviorAction);
            theResult = super.caseCallBehaviorAction(inputCallBehaviorAction);
            this.doSwitch((EObject) inputCallBehaviorAction.getBehavior());
        }
        return theResult;
    }

    @Override
    @objid ("127b5104-4583-11e0-b54c-00137279a832")
    public Object caseCallEvent(CallEvent inputCallEvent) {
        Object theResult = visitorMap.get(inputCallEvent);
        if (theResult == null) {
            visitorMap.put(inputCallEvent, inputCallEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CallEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCallEvent(inputCallEvent);
            theResult = super.caseCallEvent(inputCallEvent);
            this.doSwitch((EObject) inputCallEvent.getOperation());
        }
        return theResult;
    }

    @Override
    @objid ("127b510a-4583-11e0-b54c-00137279a832")
    public Object caseCallOperationAction(CallOperationAction inputCallOperationAction) {
        Object theResult = visitorMap.get(inputCallOperationAction);
        if (theResult == null) {
            visitorMap.put(inputCallOperationAction, inputCallOperationAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CallOperationActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCallOperationAction(inputCallOperationAction);
            theResult = super.caseCallOperationAction(inputCallOperationAction);
            this.doSwitch((EObject) inputCallOperationAction.getOperation());
            this.doSwitch((EObject) inputCallOperationAction.getTarget());
        }
        return theResult;
    }

    @Override
    @objid ("127db35c-4583-11e0-b54c-00137279a832")
    public Object caseCentralBufferNode(CentralBufferNode inputCentralBufferNode) {
        Object theResult = visitorMap.get(inputCentralBufferNode);
        if (theResult == null) {
            visitorMap.put(inputCentralBufferNode, inputCentralBufferNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CentralBufferNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCentralBufferNode(inputCentralBufferNode);
            theResult = super.caseCentralBufferNode(inputCentralBufferNode);
        }
        return theResult;
    }

    @Override
    @objid ("127db362-4583-11e0-b54c-00137279a832")
    public Object caseChangeEvent(ChangeEvent inputChangeEvent) {
        Object theResult = visitorMap.get(inputChangeEvent);
        if (theResult == null) {
            visitorMap.put(inputChangeEvent, inputChangeEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ChangeEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitChangeEvent(inputChangeEvent);
            theResult = super.caseChangeEvent(inputChangeEvent);
            this.doSwitch((EObject) inputChangeEvent.getChangeExpression());
        }
        return theResult;
    }

    @Override
    @objid ("128015b3-4583-11e0-b54c-00137279a832")
    public Object caseClass(Class inputClass) {
        Object theResult = visitorMap.get(inputClass);
        if (theResult == null) {
            visitorMap.put(inputClass, inputClass);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClassImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitClass(inputClass);
            theResult = super.caseClass(inputClass);
            for (Object nestedClassifier : inputClass.getNestedClassifiers()) {
                this.doSwitch((EObject) nestedClassifier);
            }
            for (Object ownedAttribute : inputClass.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
            for (Object ownedOperation : inputClass.getOwnedOperations()) {
                this.doSwitch((EObject) ownedOperation);
            }
            for (Object superClass : inputClass.getSuperClasses()) {
                this.doSwitch((EObject) superClass);
            }
            for (Object ownedReception : inputClass.getOwnedReceptions()) {
                this.doSwitch((EObject) ownedReception);
            }
            for (Object extension : inputClass.getExtensions()) {
                this.doSwitch((EObject) extension);
            }
        }
        return theResult;
    }

    @Override
    @objid ("128015b9-4583-11e0-b54c-00137279a832")
    public Object caseClassifier(Classifier inputClassifier) {
        Object theResult = super.caseClassifier(inputClassifier);
        for (Object generalization : inputClassifier.getGeneralizations()) {
            this.doSwitch((EObject) generalization);
        }
        for (Object feature : inputClassifier.getFeatures()) {
            this.doSwitch((EObject) feature);
        }
        for (Object inheritedMember : inputClassifier.getInheritedMembers()) {
            this.doSwitch((EObject) inheritedMember);
        }
        for (Object redefinedClassifier : inputClassifier
                .getRedefinedClassifiers()) {
            this.doSwitch((EObject) redefinedClassifier);
        }
        for (Object general : inputClassifier.getGenerals()) {
            this.doSwitch((EObject) general);
        }
        for (Object substitution : inputClassifier.getSubstitutions()) {
            this.doSwitch((EObject) substitution);
        }
        for (Object attribute : inputClassifier.getAttributes()) {
            this.doSwitch((EObject) attribute);
        }
        this.doSwitch((EObject) inputClassifier.getRepresentation());
        for (Object collaborationUse : inputClassifier.getCollaborationUses()) {
            this.doSwitch((EObject) collaborationUse);
        }
        for (Object ownedUseCase : inputClassifier.getOwnedUseCases()) {
            this.doSwitch((EObject) ownedUseCase);
        }
        for (Object useCase : inputClassifier.getUseCases()) {
            this.doSwitch((EObject) useCase);
        }
        for (Object powertypeExtent : inputClassifier.getPowertypeExtents()) {
            this.doSwitch((EObject) powertypeExtent);
        }
        this.doSwitch((EObject) inputClassifier.getOwnedTemplateSignature());
        this.doSwitch((EObject) inputClassifier.getTemplateParameter());
        return theResult;
    }

    @Override
    @objid ("1282780d-4583-11e0-b54c-00137279a832")
    public Object caseClassifierTemplateParameter(ClassifierTemplateParameter inputClassifierTemplateParameter) {
        Object theResult = visitorMap.get(inputClassifierTemplateParameter);
        if (theResult == null) {
            visitorMap.put(inputClassifierTemplateParameter,
                    inputClassifierTemplateParameter);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClassifierTemplateParameterImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitClassifierTemplateParameter(inputClassifierTemplateParameter);
            theResult = super
            .caseClassifierTemplateParameter(inputClassifierTemplateParameter);
            this.doSwitch((EObject) inputClassifierTemplateParameter
                    .getParameteredElement());
            //            this.doSwitch((EObject) inputClassifierTemplateParameter
            //                    .getDefaultClassifier());
            this.doSwitch((EObject) inputClassifierTemplateParameter
                    .getDefault());
            //            this.doSwitch((EObject) inputClassifierTemplateParameter
            //                    .getConstrainingClassifier());
        
            for (Object constrainingClassifier : inputClassifierTemplateParameter
                    .getConstrainingClassifiers()) {
                this.doSwitch((EObject) constrainingClassifier);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12827813-4583-11e0-b54c-00137279a832")
    public Object caseClause(Clause inputClause) {
        Object theResult = visitorMap.get(inputClause);
        if (theResult == null) {
            visitorMap.put(inputClause, inputClause);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClauseImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitClause(inputClause);
            theResult = super.caseClause(inputClause);
            for (Object test : inputClause.getTests()) {
                this.doSwitch((EObject) test);
            }
            for (Object body : inputClause.getBodies()) {
                this.doSwitch((EObject) body);
            }
            for (Object predecessorClause : inputClause.getPredecessorClauses()) {
                this.doSwitch((EObject) predecessorClause);
            }
            for (Object successorClause : inputClause.getSuccessorClauses()) {
                this.doSwitch((EObject) successorClause);
            }
            this.doSwitch((EObject) inputClause.getDecider());
            for (Object bodyOutput : inputClause.getBodyOutputs()) {
                this.doSwitch((EObject) bodyOutput);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1284da66-4583-11e0-b54c-00137279a832")
    public Object caseClearAssociationAction(ClearAssociationAction inputClearAssociationAction) {
        Object theResult = visitorMap.get(inputClearAssociationAction);
        if (theResult == null) {
            visitorMap.put(inputClearAssociationAction,
                    inputClearAssociationAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClearAssociationActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitClearAssociationAction(inputClearAssociationAction);
            theResult = super
            .caseClearAssociationAction(inputClearAssociationAction);
            this.doSwitch((EObject) inputClearAssociationAction.getObject());
            this.doSwitch((EObject) inputClearAssociationAction
                    .getAssociation());
        }
        return theResult;
    }

    @Override
    @objid ("1284da6c-4583-11e0-b54c-00137279a832")
    public Object caseClearStructuralFeatureAction(ClearStructuralFeatureAction inputClearStructuralFeatureAction) {
        Object theResult = visitorMap.get(inputClearStructuralFeatureAction);
        if (theResult == null) {
            visitorMap.put(inputClearStructuralFeatureAction,
                    inputClearStructuralFeatureAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClearStructuralFeatureActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitClearStructuralFeatureAction(inputClearStructuralFeatureAction);
            theResult = super
            .caseClearStructuralFeatureAction(inputClearStructuralFeatureAction);
        }
        return theResult;
    }

    @Override
    @objid ("12873cc0-4583-11e0-b54c-00137279a832")
    public Object caseClearVariableAction(ClearVariableAction inputClearVariableAction) {
        Object theResult = visitorMap.get(inputClearVariableAction);
        if (theResult == null) {
            visitorMap.put(inputClearVariableAction, inputClearVariableAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ClearVariableActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitClearVariableAction(inputClearVariableAction);
            theResult = super.caseClearVariableAction(inputClearVariableAction);
        }
        return theResult;
    }

    @Override
    @objid ("12873cc6-4583-11e0-b54c-00137279a832")
    public Object caseCollaboration(Collaboration inputCollaboration) {
        Object theResult = visitorMap.get(inputCollaboration);
        if (theResult == null) {
            visitorMap.put(inputCollaboration, inputCollaboration);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CollaborationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCollaboration(inputCollaboration);
            theResult = super.caseCollaboration(inputCollaboration);
            for (Object collaborationRole : inputCollaboration
                    .getCollaborationRoles()) {
                this.doSwitch((EObject) collaborationRole);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12873ccc-4583-11e0-b54c-00137279a832")
    public Object caseCollaborationUse(CollaborationUse inputCollaborationUse) {
        Object theResult = visitorMap.get(inputCollaborationUse);
        if (theResult == null) {
            visitorMap.put(inputCollaborationUse, inputCollaborationUse);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CollaborationUseImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCollaborationUse(inputCollaborationUse);
            theResult = super.caseCollaborationUse(inputCollaborationUse);
            this.doSwitch((EObject) inputCollaborationUse.getType());
            for (Object roleBinding : inputCollaborationUse.getRoleBindings()) {
                this.doSwitch((EObject) roleBinding);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12899f1f-4583-11e0-b54c-00137279a832")
    public Object caseCombinedFragment(CombinedFragment inputCombinedFragment) {
        Object theResult = visitorMap.get(inputCombinedFragment);
        if (theResult == null) {
            visitorMap.put(inputCombinedFragment, inputCombinedFragment);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CombinedFragmentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCombinedFragment(inputCombinedFragment);
            theResult = super.caseCombinedFragment(inputCombinedFragment);
            for (Object operand : inputCombinedFragment.getOperands()) {
                this.doSwitch((EObject) operand);
            }
            for (Object cfragmentGate : inputCombinedFragment
                    .getCfragmentGates()) {
                this.doSwitch((EObject) cfragmentGate);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12899f25-4583-11e0-b54c-00137279a832")
    public Object caseComment(Comment inputComment) {
        Object theResult = visitorMap.get(inputComment);
        if (theResult == null) {
            visitorMap.put(inputComment, inputComment);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CommentImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitComment(inputComment);
            theResult = super.caseComment(inputComment);
            for (Object annotatedElement : inputComment.getAnnotatedElements()) {
                this.doSwitch((EObject) annotatedElement);
            }
        }
        return theResult;
    }

    @Override
    @objid ("128c0178-4583-11e0-b54c-00137279a832")
    public Object caseCommunicationPath(CommunicationPath inputCommunicationPath) {
        Object theResult = visitorMap.get(inputCommunicationPath);
        if (theResult == null) {
            visitorMap.put(inputCommunicationPath, inputCommunicationPath);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CommunicationPathImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCommunicationPath(inputCommunicationPath);
            theResult = super.caseCommunicationPath(inputCommunicationPath);
        }
        return theResult;
    }

    @Override
    @objid ("128c017e-4583-11e0-b54c-00137279a832")
    public Object caseComponent(Component inputComponent) {
        Object theResult = visitorMap.get(inputComponent);
        if (theResult == null) {
            visitorMap.put(inputComponent, inputComponent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ComponentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitComponent(inputComponent);
            theResult = super.caseComponent(inputComponent);
            for (Object required : inputComponent.getRequireds()) {
                this.doSwitch((EObject) required);
            }
            for (Object provided : inputComponent.getProvideds()) {
                this.doSwitch((EObject) provided);
            }
            for (Object realization : inputComponent.getRealizations()) {
                this.doSwitch((EObject) realization);
            }
            for (Object packagedElement : inputComponent.getPackagedElements()) {
                this.doSwitch((EObject) packagedElement);
            }
        }
        return theResult;
    }

    @Override
    @objid ("128e63d2-4583-11e0-b54c-00137279a832")
    public Object caseComponentRealization(ComponentRealization inputComponentRealization) {
        Object theResult = visitorMap.get(inputComponentRealization);
        if (theResult == null) {
            visitorMap
            .put(inputComponentRealization, inputComponentRealization);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ComponentRealizationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitComponentRealization(inputComponentRealization);
            theResult = super
            .caseComponentRealization(inputComponentRealization);
            this.doSwitch((EObject) inputComponentRealization.getAbstraction());
        
            //            this.doSwitch((EObject) inputComponentRealization
            //                    .getRealizingClassifier());
        
            for (Object realization : inputComponentRealization.getRealizingClassifiers()) {
                this.doSwitch((EObject) realization);
            }
        }
        return theResult;
    }

    @Override
    @objid ("128e63d8-4583-11e0-b54c-00137279a832")
    public Object caseConditionalNode(ConditionalNode inputConditionalNode) {
        Object theResult = visitorMap.get(inputConditionalNode);
        if (theResult == null) {
            visitorMap.put(inputConditionalNode, inputConditionalNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConditionalNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitConditionalNode(inputConditionalNode);
            theResult = super.caseConditionalNode(inputConditionalNode);
            for (Object clause : inputConditionalNode.getClauses()) {
                this.doSwitch((EObject) clause);
            }
            for (Object result : inputConditionalNode.getResults()) {
                this.doSwitch((EObject) result);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1290c62b-4583-11e0-b54c-00137279a832")
    public Object caseConnectableElement(ConnectableElement inputConnectableElement) {
        Object theResult = super
        .caseConnectableElement(inputConnectableElement);
        for (Object end : inputConnectableElement.getEnds()) {
            this.doSwitch((EObject) end);
        }
        this.doSwitch((EObject) inputConnectableElement.getTemplateParameter());
        return theResult;
    }

    @Override
    @objid ("1290c631-4583-11e0-b54c-00137279a832")
    public Object caseConnectableElementTemplateParameter(ConnectableElementTemplateParameter inputConnectableElementTemplateParameter) {
        Object theResult = visitorMap
        .get(inputConnectableElementTemplateParameter);
        if (theResult == null) {
            visitorMap.put(inputConnectableElementTemplateParameter,
                    inputConnectableElementTemplateParameter);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConnectableElementTemplateParameterImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitConnectableElementTemplateParameter(inputConnectableElementTemplateParameter);
            theResult = super
            .caseConnectableElementTemplateParameter(inputConnectableElementTemplateParameter);
            this.doSwitch((EObject) inputConnectableElementTemplateParameter
                    .getParameteredElement());
        }
        return theResult;
    }

    @Override
    @objid ("12932883-4583-11e0-b54c-00137279a832")
    public Object caseConnectionPointReference(ConnectionPointReference inputConnectionPointReference) {
        Object theResult = visitorMap.get(inputConnectionPointReference);
        if (theResult == null) {
            visitorMap.put(inputConnectionPointReference,
                    inputConnectionPointReference);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConnectionPointReferenceImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior
            .visitConnectionPointReference(inputConnectionPointReference);
            theResult = super
            .caseConnectionPointReference(inputConnectionPointReference);
            for (Object entry : inputConnectionPointReference.getEntries()) {
                this.doSwitch((EObject) entry);
            }
            this.doSwitch((EObject) inputConnectionPointReference.getState());
            for (Object exit : inputConnectionPointReference.getExits()) {
                this.doSwitch((EObject) exit);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12932889-4583-11e0-b54c-00137279a832")
    public Object caseConnector(Connector inputConnector) {
        Object theResult = visitorMap.get(inputConnector);
        if (theResult == null) {
            visitorMap.put(inputConnector, inputConnector);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConnectorImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitConnector(inputConnector);
            theResult = super.caseConnector(inputConnector);
            this.doSwitch((EObject) inputConnector.getType());
            for (Object redefinedConnector : inputConnector
                    .getRedefinedConnectors()) {
                this.doSwitch((EObject) redefinedConnector);
            }
            for (Object end : inputConnector.getEnds()) {
                this.doSwitch((EObject) end);
            }
            for (Object contract : inputConnector.getContracts()) {
                this.doSwitch((EObject) contract);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12958ade-4583-11e0-b54c-00137279a832")
    public Object caseConnectorEnd(ConnectorEnd inputConnectorEnd) {
        Object theResult = visitorMap.get(inputConnectorEnd);
        if (theResult == null) {
            visitorMap.put(inputConnectorEnd, inputConnectorEnd);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConnectorEndImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitConnectorEnd(inputConnectorEnd);
            theResult = super.caseConnectorEnd(inputConnectorEnd);
            this.doSwitch((EObject) inputConnectorEnd.getDefiningEnd());
            this.doSwitch((EObject) inputConnectorEnd.getRole());
            this.doSwitch((EObject) inputConnectorEnd.getPartWithPort());
        }
        return theResult;
    }

    @Override
    @objid ("12958ae4-4583-11e0-b54c-00137279a832")
    public Object caseConsiderIgnoreFragment(ConsiderIgnoreFragment inputConsiderIgnoreFragment) {
        Object theResult = visitorMap.get(inputConsiderIgnoreFragment);
        if (theResult == null) {
            visitorMap.put(inputConsiderIgnoreFragment,
                    inputConsiderIgnoreFragment);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConsiderIgnoreFragmentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitConsiderIgnoreFragment(inputConsiderIgnoreFragment);
            theResult = super
            .caseConsiderIgnoreFragment(inputConsiderIgnoreFragment);
            for (Object message : inputConsiderIgnoreFragment.getMessages()) {
                this.doSwitch((EObject) message);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1297ed38-4583-11e0-b54c-00137279a832")
    public Object caseConstraint(Constraint inputConstraint) {
        Object theResult = visitorMap.get(inputConstraint);
        if (theResult == null) {
            visitorMap.put(inputConstraint, inputConstraint);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitConstraint(inputConstraint);
            theResult = super.caseConstraint(inputConstraint);
            for (Object constrainedElement : inputConstraint
                    .getConstrainedElements()) {
                this.doSwitch((EObject) constrainedElement);
            }
            this.doSwitch((EObject) inputConstraint.getSpecification());
            this.doSwitch((EObject) inputConstraint.getContext());
        }
        return theResult;
    }

    @Override
    @objid ("1297ed3e-4583-11e0-b54c-00137279a832")
    public Object caseContinuation(Continuation inputContinuation) {
        Object theResult = visitorMap.get(inputContinuation);
        if (theResult == null) {
            visitorMap.put(inputContinuation, inputContinuation);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ContinuationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitContinuation(inputContinuation);
            theResult = super.caseContinuation(inputContinuation);
        }
        return theResult;
    }

    @Override
    @objid ("129a4f92-4583-11e0-b54c-00137279a832")
    public Object caseControlFlow(ControlFlow inputControlFlow) {
        Object theResult = visitorMap.get(inputControlFlow);
        if (theResult == null) {
            visitorMap.put(inputControlFlow, inputControlFlow);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ControlFlowImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitControlFlow(inputControlFlow);
            theResult = super.caseControlFlow(inputControlFlow);
        }
        return theResult;
    }

    @Override
    @objid ("129a4f98-4583-11e0-b54c-00137279a832")
    public Object caseControlNode(ControlNode inputControlNode) {
        return super.caseControlNode(inputControlNode);
    }

    @Override
    @objid ("129cb1ec-4583-11e0-b54c-00137279a832")
    public Object caseCreateLinkAction(CreateLinkAction inputCreateLinkAction) {
        Object theResult = visitorMap.get(inputCreateLinkAction);
        if (theResult == null) {
            visitorMap.put(inputCreateLinkAction, inputCreateLinkAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CreateLinkActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCreateLinkAction(inputCreateLinkAction);
            theResult = super.caseCreateLinkAction(inputCreateLinkAction);
            for (Object endData : inputCreateLinkAction.getEndData()) {
                this.doSwitch((EObject) endData);
            }
        }
        return theResult;
    }

    @Override
    @objid ("129cb1f2-4583-11e0-b54c-00137279a832")
    public Object caseCreateLinkObjectAction(CreateLinkObjectAction inputCreateLinkObjectAction) {
        Object theResult = visitorMap.get(inputCreateLinkObjectAction);
        if (theResult == null) {
            visitorMap.put(inputCreateLinkObjectAction,
                    inputCreateLinkObjectAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CreateLinkObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCreateLinkObjectAction(inputCreateLinkObjectAction);
            theResult = super
            .caseCreateLinkObjectAction(inputCreateLinkObjectAction);
            this.doSwitch((EObject) inputCreateLinkObjectAction.getResult());
        }
        return theResult;
    }

    @Override
    @objid ("129f1447-4583-11e0-b54c-00137279a832")
    public Object caseCreateObjectAction(CreateObjectAction inputCreateObjectAction) {
        Object theResult = visitorMap.get(inputCreateObjectAction);
        if (theResult == null) {
            visitorMap.put(inputCreateObjectAction, inputCreateObjectAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CreateObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCreateObjectAction(inputCreateObjectAction);
            theResult = super.caseCreateObjectAction(inputCreateObjectAction);
            this.doSwitch((EObject) inputCreateObjectAction.getClassifier());
            this.doSwitch((EObject) inputCreateObjectAction.getResult());
        }
        return theResult;
    }

    @Override
    @objid ("129f144d-4583-11e0-b54c-00137279a832")
    public Object caseCreationEvent(CreationEvent inputCreationEvent) {
        Object theResult = visitorMap.get(inputCreationEvent);
        if (theResult == null) {
            visitorMap.put(inputCreationEvent, inputCreationEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("CreationEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitCreationEvent(inputCreationEvent);
            theResult = super.caseCreationEvent(inputCreationEvent);
        }
        return theResult;
    }

    @Override
    @objid ("12a176a2-4583-11e0-b54c-00137279a832")
    public Object caseDataStoreNode(DataStoreNode inputDataStoreNode) {
        Object theResult = visitorMap.get(inputDataStoreNode);
        if (theResult == null) {
            visitorMap.put(inputDataStoreNode, inputDataStoreNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DataStoreNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDataStoreNode(inputDataStoreNode);
            theResult = super.caseDataStoreNode(inputDataStoreNode);
        }
        return theResult;
    }

    @Override
    @objid ("12a176a8-4583-11e0-b54c-00137279a832")
    public Object caseDataType(DataType inputDataType) {
        Object theResult = visitorMap.get(inputDataType);
        if (theResult == null) {
            visitorMap.put(inputDataType, inputDataType);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DataTypeImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitDataType(inputDataType);
            theResult = super.caseDataType(inputDataType);
            for (Object ownedAttribute : inputDataType.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
            for (Object ownedOperation : inputDataType.getOwnedOperations()) {
                this.doSwitch((EObject) ownedOperation);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12a3d8fc-4583-11e0-b54c-00137279a832")
    public Object caseDecisionNode(DecisionNode inputDecisionNode) {
        Object theResult = visitorMap.get(inputDecisionNode);
        if (theResult == null) {
            visitorMap.put(inputDecisionNode, inputDecisionNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DecisionNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDecisionNode(inputDecisionNode);
            theResult = super.caseDecisionNode(inputDecisionNode);
            this.doSwitch((EObject) inputDecisionNode.getDecisionInput());
        }
        return theResult;
    }

    @Override
    @objid ("12a3d902-4583-11e0-b54c-00137279a832")
    public Object caseDependency(Dependency inputDependency) {
        Object theResult = visitorMap.get(inputDependency);
        if (theResult == null) {
            visitorMap.put(inputDependency, inputDependency);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DependencyImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDependency(inputDependency);
            theResult = super.caseDependency(inputDependency);
            for (Object supplier : inputDependency.getSuppliers()) {
                this.doSwitch((EObject) supplier);
            }
            for (Object client : inputDependency.getClients()) {
                this.doSwitch((EObject) client);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12a63b56-4583-11e0-b54c-00137279a832")
    public Object caseDeployedArtifact(DeployedArtifact inputDeployedArtifact) {
        return super.caseDeployedArtifact(inputDeployedArtifact);
    }

    @Override
    @objid ("12a63b5c-4583-11e0-b54c-00137279a832")
    public Object caseDeployment(Deployment inputDeployment) {
        Object theResult = visitorMap.get(inputDeployment);
        if (theResult == null) {
            visitorMap.put(inputDeployment, inputDeployment);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DeploymentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDeployment(inputDeployment);
            theResult = super.caseDeployment(inputDeployment);
            for (Object deployedArtifact : inputDeployment
                    .getDeployedArtifacts()) {
                this.doSwitch((EObject) deployedArtifact);
            }
            this.doSwitch((EObject) inputDeployment.getLocation());
            for (Object configuration : inputDeployment.getConfigurations()) {
                this.doSwitch((EObject) configuration);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12a89db0-4583-11e0-b54c-00137279a832")
    public Object caseDeploymentSpecification(DeploymentSpecification inputDeploymentSpecification) {
        Object theResult = visitorMap.get(inputDeploymentSpecification);
        if (theResult == null) {
            visitorMap.put(inputDeploymentSpecification,
                    inputDeploymentSpecification);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DeploymentSpecificationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDeploymentSpecification(inputDeploymentSpecification);
            theResult = super
            .caseDeploymentSpecification(inputDeploymentSpecification);
            this.doSwitch((EObject) inputDeploymentSpecification
                    .getDeployment());
        }
        return theResult;
    }

    @Override
    @objid ("12ab0006-4583-11e0-b54c-00137279a832")
    public Object caseDeploymentTarget(DeploymentTarget inputDeploymentTarget) {
        Object theResult = super.caseDeploymentTarget(inputDeploymentTarget);
        for (Object deployment : inputDeploymentTarget.getDeployments()) {
            this.doSwitch((EObject) deployment);
        }
        for (Object deployedElement : inputDeploymentTarget
                .getDeployedElements()) {
            this.doSwitch((EObject) deployedElement);
        }
        return theResult;
    }

    @Override
    @objid ("12ab000c-4583-11e0-b54c-00137279a832")
    public Object caseDestroyLinkAction(DestroyLinkAction inputDestroyLinkAction) {
        Object theResult = visitorMap.get(inputDestroyLinkAction);
        if (theResult == null) {
            visitorMap.put(inputDestroyLinkAction, inputDestroyLinkAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DestroyLinkActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDestroyLinkAction(inputDestroyLinkAction);
            theResult = super.caseDestroyLinkAction(inputDestroyLinkAction);
            for (Object endData : inputDestroyLinkAction.getEndData()) {
                this.doSwitch((EObject) endData);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12ad6260-4583-11e0-b54c-00137279a832")
    public Object caseDestroyObjectAction(DestroyObjectAction inputDestroyObjectAction) {
        Object theResult = visitorMap.get(inputDestroyObjectAction);
        if (theResult == null) {
            visitorMap.put(inputDestroyObjectAction, inputDestroyObjectAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DestroyObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDestroyObjectAction(inputDestroyObjectAction);
            theResult = super.caseDestroyObjectAction(inputDestroyObjectAction);
            this.doSwitch((EObject) inputDestroyObjectAction.getTarget());
        }
        return theResult;
    }

    @Override
    @objid ("12ad6266-4583-11e0-b54c-00137279a832")
    public Object caseDestructionEvent(DestructionEvent inputDestructionEvent) {
        Object theResult = visitorMap.get(inputDestructionEvent);
        if (theResult == null) {
            visitorMap.put(inputDestructionEvent, inputDestructionEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DestructionEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDestructionEvent(inputDestructionEvent);
            theResult = super.caseDestructionEvent(inputDestructionEvent);
        }
        return theResult;
    }

    @Override
    @objid ("12afc4ba-4583-11e0-b54c-00137279a832")
    public Object caseDevice(Device inputDevice) {
        Object theResult = visitorMap.get(inputDevice);
        if (theResult == null) {
            visitorMap.put(inputDevice, inputDevice);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DeviceImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitDevice(inputDevice);
            theResult = super.caseDevice(inputDevice);
        }
        return theResult;
    }

    @Override
    @objid ("12afc4c0-4583-11e0-b54c-00137279a832")
    public Object caseDirectedRelationship(DirectedRelationship inputDirectedRelationship) {
        Object theResult = super
        .caseDirectedRelationship(inputDirectedRelationship);
        for (Object source : inputDirectedRelationship.getSources()) {
            this.doSwitch((EObject) source);
        }
        for (Object target : inputDirectedRelationship.getTargets()) {
            this.doSwitch((EObject) target);
        }
        return theResult;
    }

    @Override
    @objid ("12b22714-4583-11e0-b54c-00137279a832")
    public Object caseDuration(Duration inputDuration) {
        Object theResult = visitorMap.get(inputDuration);
        if (theResult == null) {
            visitorMap.put(inputDuration, inputDuration);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DurationImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitDuration(inputDuration);
            theResult = super.caseDuration(inputDuration);
            this.doSwitch((EObject) inputDuration.getExpr());
            for (Object observation : inputDuration.getObservations()) {
                this.doSwitch((EObject) observation);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12b2271a-4583-11e0-b54c-00137279a832")
    public Object caseDurationConstraint(DurationConstraint inputDurationConstraint) {
        Object theResult = visitorMap.get(inputDurationConstraint);
        if (theResult == null) {
            visitorMap.put(inputDurationConstraint, inputDurationConstraint);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DurationConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDurationConstraint(inputDurationConstraint);
            theResult = super.caseDurationConstraint(inputDurationConstraint);
            this.doSwitch((EObject) inputDurationConstraint.getSpecification());
        }
        return theResult;
    }

    @Override
    @objid ("12b4896f-4583-11e0-b54c-00137279a832")
    public Object caseDurationInterval(DurationInterval inputDurationInterval) {
        Object theResult = visitorMap.get(inputDurationInterval);
        if (theResult == null) {
            visitorMap.put(inputDurationInterval, inputDurationInterval);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DurationIntervalImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDurationInterval(inputDurationInterval);
            theResult = super.caseDurationInterval(inputDurationInterval);
            this.doSwitch((EObject) inputDurationInterval.getMin());
            this.doSwitch((EObject) inputDurationInterval.getMax());
        }
        return theResult;
    }

    @Override
    @objid ("12b48975-4583-11e0-b54c-00137279a832")
    public Object caseDurationObservation(final DurationObservation inputDurationIservation) {
        Object theResult = visitorMap.get(inputDurationIservation);
        if (theResult == null) {
            visitorMap.put(inputDurationIservation, inputDurationIservation);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("DurationIservationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitDurationObservation(inputDurationIservation);
            theResult = super.caseDurationObservation(inputDurationIservation);
            for (Object event : inputDurationIservation.getEvents()) {
                this.doSwitch((EObject) event);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12b6ebcc-4583-11e0-b54c-00137279a832")
    public Object caseElement(Element inputElement) {
        Object theResult = super.caseElement(inputElement);
        for (Object ownedElement : inputElement.getOwnedElements()) {
            this.doSwitch((EObject) ownedElement);
        }
        this.doSwitch((EObject) inputElement.getOwner());
        for (Object ownedComment : inputElement.getOwnedComments()) {
            this.doSwitch((EObject) ownedComment);
        }
        return theResult;
    }

    @Override
    @objid ("12b94e22-4583-11e0-b54c-00137279a832")
    public Object caseElementImport(ElementImport inputElementImport) {
        Object theResult = visitorMap.get(inputElementImport);
        if (theResult == null) {
            visitorMap.put(inputElementImport, inputElementImport);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ElementImportImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitElementImport(inputElementImport);
            theResult = super.caseElementImport(inputElementImport);
            this.doSwitch((EObject) inputElementImport.getImportedElement());
            this.doSwitch((EObject) inputElementImport.getImportingNamespace());
        }
        return theResult;
    }

    @Override
    @objid ("12b94e28-4583-11e0-b54c-00137279a832")
    public Object caseEncapsulatedClassifier(EncapsulatedClassifier inputEncapsulatedClassifier) {
        Object theResult = super
        .caseEncapsulatedClassifier(inputEncapsulatedClassifier);
        for (Object ownedPort : inputEncapsulatedClassifier.getOwnedPorts()) {
            this.doSwitch((EObject) ownedPort);
        }
        return theResult;
    }

    @Override
    @objid ("12bbb07c-4583-11e0-b54c-00137279a832")
    public Object caseEnumeration(Enumeration inputEnumeration) {
        Object theResult = visitorMap.get(inputEnumeration);
        if (theResult == null) {
            visitorMap.put(inputEnumeration, inputEnumeration);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("EnumerationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitEnumeration(inputEnumeration);
            theResult = super.caseEnumeration(inputEnumeration);
            for (Object ownedLiteral : inputEnumeration.getOwnedLiterals()) {
                this.doSwitch((EObject) ownedLiteral);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12bbb082-4583-11e0-b54c-00137279a832")
    public Object caseEnumerationLiteral(EnumerationLiteral inputEnumerationLiteral) {
        Object theResult = visitorMap.get(inputEnumerationLiteral);
        if (theResult == null) {
            visitorMap.put(inputEnumerationLiteral, inputEnumerationLiteral);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("EnumerationLiteralImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitEnumerationLiteral(inputEnumerationLiteral);
            theResult = super.caseEnumerationLiteral(inputEnumerationLiteral);
            this.doSwitch((EObject) inputEnumerationLiteral.getEnumeration());
        }
        return theResult;
    }

    @Override
    @objid ("12be12d6-4583-11e0-b54c-00137279a832")
    public Object caseEvent(Event inputEvent) {
        return super.caseEvent(inputEvent);
    }

    @Override
    @objid ("12be12dc-4583-11e0-b54c-00137279a832")
    public Object caseExceptionHandler(ExceptionHandler inputExceptionHandler) {
        Object theResult = visitorMap.get(inputExceptionHandler);
        if (theResult == null) {
            visitorMap.put(inputExceptionHandler, inputExceptionHandler);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExceptionHandlerImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExceptionHandler(inputExceptionHandler);
            theResult = super.caseExceptionHandler(inputExceptionHandler);
            this.doSwitch((EObject) inputExceptionHandler.getProtectedNode());
            this.doSwitch((EObject) inputExceptionHandler.getHandlerBody());
            this.doSwitch((EObject) inputExceptionHandler.getExceptionInput());
            for (Object exceptionType : inputExceptionHandler
                    .getExceptionTypes()) {
                this.doSwitch((EObject) exceptionType);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12c539e4-4583-11e0-b54c-00137279a832")
    public Object caseExecutableNode(ExecutableNode inputExecutableNode) {
        Object theResult = super.caseExecutableNode(inputExecutableNode);
        for (Object handler : inputExecutableNode.getHandlers()) {
            this.doSwitch((EObject) handler);
        }
        return theResult;
    }

    @Override
    @objid ("12c539ea-4583-11e0-b54c-00137279a832")
    public Object caseExecutionEnvironment(ExecutionEnvironment inputExecutionEnvironment) {
        Object theResult = visitorMap.get(inputExecutionEnvironment);
        if (theResult == null) {
            visitorMap
            .put(inputExecutionEnvironment, inputExecutionEnvironment);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExecutionEnvironmentImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExecutionEnvironment(inputExecutionEnvironment);
            theResult = super
            .caseExecutionEnvironment(inputExecutionEnvironment);
        }
        return theResult;
    }

    @Override
    @objid ("12c79c40-4583-11e0-b54c-00137279a832")
    public Object caseExecutionEvent(ExecutionEvent inputExecutionEvent) {
        Object theResult = visitorMap.get(inputExecutionEvent);
        if (theResult == null) {
            visitorMap.put(inputExecutionEvent, inputExecutionEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExecutionEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExecutionEvent(inputExecutionEvent);
            theResult = super.caseExecutionEvent(inputExecutionEvent);
        }
        return theResult;
    }

    @Override
    @objid ("12c79c46-4583-11e0-b54c-00137279a832")
    public Object caseExecutionOccurrenceSpecification(ExecutionOccurrenceSpecification inputExecutionOccurrenceSpecification) {
        Object theResult = visitorMap
        .get(inputExecutionOccurrenceSpecification);
        if (theResult == null) {
            visitorMap.put(inputExecutionOccurrenceSpecification,
                    inputExecutionOccurrenceSpecification);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExecutionOccurrenceSpecificationImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitExecutionOccurrenceSpecification(inputExecutionOccurrenceSpecification);
            theResult = super
            .caseExecutionOccurrenceSpecification(inputExecutionOccurrenceSpecification);
            this.doSwitch((EObject) inputExecutionOccurrenceSpecification
                    .getExecution());
            this.doSwitch((EObject) inputExecutionOccurrenceSpecification
                    .getEvent());
        }
        return theResult;
    }

    @Override
    @objid ("12c9fe9d-4583-11e0-b54c-00137279a832")
    public Object caseExecutionSpecification(ExecutionSpecification inputExecutionSpecification) {
        Object theResult = super
        .caseExecutionSpecification(inputExecutionSpecification);
        this.doSwitch((EObject) inputExecutionSpecification.getStart());
        this.doSwitch((EObject) inputExecutionSpecification.getFinish());
        return theResult;
    }

    @Override
    @objid ("12cc60f2-4583-11e0-b54c-00137279a832")
    public Object caseExpansionNode(ExpansionNode inputExpansionNode) {
        Object theResult = visitorMap.get(inputExpansionNode);
        if (theResult == null) {
            visitorMap.put(inputExpansionNode, inputExpansionNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExpansionNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExpansionNode(inputExpansionNode);
            theResult = super.caseExpansionNode(inputExpansionNode);
            this.doSwitch((EObject) inputExpansionNode.getRegionAsOutput());
            this.doSwitch((EObject) inputExpansionNode.getRegionAsInput());
        }
        return theResult;
    }

    @Override
    @objid ("12cc60f8-4583-11e0-b54c-00137279a832")
    public Object caseExpansionRegion(ExpansionRegion inputExpansionRegion) {
        Object theResult = visitorMap.get(inputExpansionRegion);
        if (theResult == null) {
            visitorMap.put(inputExpansionRegion, inputExpansionRegion);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExpansionRegionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExpansionRegion(inputExpansionRegion);
            theResult = super.caseExpansionRegion(inputExpansionRegion);
            for (Object outputElement : inputExpansionRegion
                    .getOutputElements()) {
                this.doSwitch((EObject) outputElement);
            }
            for (Object inputElement : inputExpansionRegion.getInputElements()) {
                this.doSwitch((EObject) inputElement);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12cec34c-4583-11e0-b54c-00137279a832")
    public Object caseExpression(Expression inputExpression) {
        Object theResult = visitorMap.get(inputExpression);
        if (theResult == null) {
            visitorMap.put(inputExpression, inputExpression);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExpressionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExpression(inputExpression);
            theResult = super.caseExpression(inputExpression);
            for (Object operand : inputExpression.getOperands()) {
                this.doSwitch((EObject) operand);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12cec352-4583-11e0-b54c-00137279a832")
    public Object caseExtend(Extend inputExtend) {
        Object theResult = visitorMap.get(inputExtend);
        if (theResult == null) {
            visitorMap.put(inputExtend, inputExtend);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExtendImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitExtend(inputExtend);
            theResult = super.caseExtend(inputExtend);
            this.doSwitch((EObject) inputExtend.getExtendedCase());
            this.doSwitch((EObject) inputExtend.getExtension());
            this.doSwitch((EObject) inputExtend.getCondition());
            for (Object extensionLocation : inputExtend.getExtensionLocations()) {
                this.doSwitch((EObject) extensionLocation);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12d125a8-4583-11e0-b54c-00137279a832")
    public Object caseExtension(Extension inputExtension) {
        Object theResult = visitorMap.get(inputExtension);
        if (theResult == null) {
            visitorMap.put(inputExtension, inputExtension);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExtensionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExtension(inputExtension);
            theResult = super.caseExtension(inputExtension);
            this.doSwitch((EObject) inputExtension.getMetaclass());
            // this.doSwitch((EObject)inputExtension.getOwnedEnd());
            for (Object ownedEnd : inputExtension.getOwnedEnds()) {
                this.doSwitch((EObject) ownedEnd);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12d125ae-4583-11e0-b54c-00137279a832")
    public Object caseExtensionEnd(ExtensionEnd inputExtensionEnd) {
        Object theResult = visitorMap.get(inputExtensionEnd);
        if (theResult == null) {
            visitorMap.put(inputExtensionEnd, inputExtensionEnd);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExtensionEndImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExtensionEnd(inputExtensionEnd);
            theResult = super.caseExtensionEnd(inputExtensionEnd);
            this.doSwitch((EObject) inputExtensionEnd.getType());
        }
        return theResult;
    }

    @Override
    @objid ("12d38804-4583-11e0-b54c-00137279a832")
    public Object caseExtensionPoint(ExtensionPoint inputExtensionPoint) {
        Object theResult = visitorMap.get(inputExtensionPoint);
        if (theResult == null) {
            visitorMap.put(inputExtensionPoint, inputExtensionPoint);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ExtensionPointImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitExtensionPoint(inputExtensionPoint);
            theResult = super.caseExtensionPoint(inputExtensionPoint);
            this.doSwitch((EObject) inputExtensionPoint.getUseCase());
        }
        return theResult;
    }

    @Override
    @objid ("12d5ea5a-4583-11e0-b54c-00137279a832")
    public Object caseFeature(Feature inputFeature) {
        Object theResult = super.caseFeature(inputFeature);
        for (Object featuringClassifier : inputFeature
                .getFeaturingClassifiers()) {
            this.doSwitch((EObject) featuringClassifier);
        }
        return theResult;
    }

    @Override
    @objid ("12d5ea60-4583-11e0-b54c-00137279a832")
    public Object caseFinalNode(FinalNode inputFinalNode) {
        return super.caseFinalNode(inputFinalNode);
    }

    @Override
    @objid ("12d84cb6-4583-11e0-b54c-00137279a832")
    public Object caseFinalState(FinalState inputFinalState) {
        Object theResult = visitorMap.get(inputFinalState);
        if (theResult == null) {
            visitorMap.put(inputFinalState, inputFinalState);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("FinalStateImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitFinalState(inputFinalState);
            theResult = super.caseFinalState(inputFinalState);
        }
        return theResult;
    }

    @Override
    @objid ("12daaf0e-4583-11e0-b54c-00137279a832")
    public Object caseFlowFinalNode(FlowFinalNode inputFlowFinalNode) {
        Object theResult = visitorMap.get(inputFlowFinalNode);
        if (theResult == null) {
            visitorMap.put(inputFlowFinalNode, inputFlowFinalNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("FlowFinalNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitFlowFinalNode(inputFlowFinalNode);
            theResult = super.caseFlowFinalNode(inputFlowFinalNode);
        }
        return theResult;
    }

    @Override
    @objid ("12daaf14-4583-11e0-b54c-00137279a832")
    public Object caseForkNode(ForkNode inputForkNode) {
        Object theResult = visitorMap.get(inputForkNode);
        if (theResult == null) {
            visitorMap.put(inputForkNode, inputForkNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ForkNodeImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitForkNode(inputForkNode);
            theResult = super.caseForkNode(inputForkNode);
        }
        return theResult;
    }

    @Override
    @objid ("12dd116c-4583-11e0-b54c-00137279a832")
    public Object caseFunctionBehavior(FunctionBehavior inputFunctionBehavior) {
        Object theResult = visitorMap.get(inputFunctionBehavior);
        if (theResult == null) {
            visitorMap.put(inputFunctionBehavior, inputFunctionBehavior);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("FunctionBehaviorImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitFunctionBehavior(inputFunctionBehavior);
            theResult = super.caseFunctionBehavior(inputFunctionBehavior);
        }
        return theResult;
    }

    @Override
    @objid ("12df73c2-4583-11e0-b54c-00137279a832")
    public Object caseGate(Gate inputGate) {
        Object theResult = visitorMap.get(inputGate);
        if (theResult == null) {
            visitorMap.put(inputGate, inputGate);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("GateImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitGate(inputGate);
            theResult = super.caseGate(inputGate);
        }
        return theResult;
    }

    @Override
    @objid ("12df73c8-4583-11e0-b54c-00137279a832")
    public Object caseGeneralOrdering(GeneralOrdering inputGeneralOrdering) {
        Object theResult = visitorMap.get(inputGeneralOrdering);
        if (theResult == null) {
            visitorMap.put(inputGeneralOrdering, inputGeneralOrdering);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("GeneralOrderingImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitGeneralOrdering(inputGeneralOrdering);
            theResult = super.caseGeneralOrdering(inputGeneralOrdering);
            this.doSwitch((EObject) inputGeneralOrdering.getBefore());
            this.doSwitch((EObject) inputGeneralOrdering.getAfter());
        }
        return theResult;
    }

    @Override
    @objid ("12e1d61c-4583-11e0-b54c-00137279a832")
    public Object caseGeneralization(Generalization inputGeneralization) {
        Object theResult = visitorMap.get(inputGeneralization);
        if (theResult == null) {
            visitorMap.put(inputGeneralization, inputGeneralization);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("GeneralizationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitGeneralization(inputGeneralization);
            theResult = super.caseGeneralization(inputGeneralization);
            this.doSwitch((EObject) inputGeneralization.getSpecific());
            this.doSwitch((EObject) inputGeneralization.getGeneral());
            for (Object generalizationSet : inputGeneralization
                    .getGeneralizationSets()) {
                this.doSwitch((EObject) generalizationSet);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12e1d622-4583-11e0-b54c-00137279a832")
    public Object caseGeneralizationSet(GeneralizationSet inputGeneralizationSet) {
        Object theResult = visitorMap.get(inputGeneralizationSet);
        if (theResult == null) {
            visitorMap.put(inputGeneralizationSet, inputGeneralizationSet);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("GeneralizationSetImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitGeneralizationSet(inputGeneralizationSet);
            theResult = super.caseGeneralizationSet(inputGeneralizationSet);
            this.doSwitch((EObject) inputGeneralizationSet.getPowertype());
            for (Object generalization : inputGeneralizationSet
                    .getGeneralizations()) {
                this.doSwitch((EObject) generalization);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12e4387a-4583-11e0-b54c-00137279a832")
    public Object caseImage(Image inputImage) {
        Object theResult = visitorMap.get(inputImage);
        if (theResult == null) {
            visitorMap.put(inputImage, inputImage);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ImageImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitImage(inputImage);
            theResult = super.caseImage(inputImage);
        }
        return theResult;
    }

    @Override
    @objid ("12e69ad0-4583-11e0-b54c-00137279a832")
    public Object caseInclude(Include inputInclude) {
        Object theResult = visitorMap.get(inputInclude);
        if (theResult == null) {
            visitorMap.put(inputInclude, inputInclude);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("IncludeImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitInclude(inputInclude);
            theResult = super.caseInclude(inputInclude);
            this.doSwitch((EObject) inputInclude.getIncludingCase());
            this.doSwitch((EObject) inputInclude.getAddition());
        }
        return theResult;
    }

    @Override
    @objid ("12e69ad6-4583-11e0-b54c-00137279a832")
    public Object caseInformationFlow(InformationFlow inputInformationFlow) {
        Object theResult = visitorMap.get(inputInformationFlow);
        if (theResult == null) {
            visitorMap.put(inputInformationFlow, inputInformationFlow);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InformationFlowImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInformationFlow(inputInformationFlow);
            theResult = super.caseInformationFlow(inputInformationFlow);
            for (Object realization : inputInformationFlow.getRealizations()) {
                this.doSwitch((EObject) realization);
            }
            for (Object conveyed : inputInformationFlow.getConveyeds()) {
                this.doSwitch((EObject) conveyed);
            }
            for (Object informationSource : inputInformationFlow
                    .getInformationSources()) {
                this.doSwitch((EObject) informationSource);
            }
            for (Object informationTarget : inputInformationFlow
                    .getInformationTargets()) {
                this.doSwitch((EObject) informationTarget);
            }
            for (Object realizingActivityEdge : inputInformationFlow
                    .getRealizingActivityEdges()) {
                this.doSwitch((EObject) realizingActivityEdge);
            }
            for (Object realizingConnector : inputInformationFlow
                    .getRealizingConnectors()) {
                this.doSwitch((EObject) realizingConnector);
            }
            for (Object realizingMessage : inputInformationFlow
                    .getRealizingMessages()) {
                this.doSwitch((EObject) realizingMessage);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12e8fd2b-4583-11e0-b54c-00137279a832")
    public Object caseInformationItem(InformationItem inputInformationItem) {
        Object theResult = visitorMap.get(inputInformationItem);
        if (theResult == null) {
            visitorMap.put(inputInformationItem, inputInformationItem);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InformationItemImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInformationItem(inputInformationItem);
            theResult = super.caseInformationItem(inputInformationItem);
            for (Object represented : inputInformationItem.getRepresenteds()) {
                this.doSwitch((EObject) represented);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12e8fd31-4583-11e0-b54c-00137279a832")
    public Object caseInitialNode(InitialNode inputInitialNode) {
        Object theResult = visitorMap.get(inputInitialNode);
        if (theResult == null) {
            visitorMap.put(inputInitialNode, inputInitialNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InitialNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInitialNode(inputInitialNode);
            theResult = super.caseInitialNode(inputInitialNode);
        }
        return theResult;
    }

    @Override
    @objid ("12eb5f88-4583-11e0-b54c-00137279a832")
    public Object caseInputPin(InputPin inputInputPin) {
        Object theResult = visitorMap.get(inputInputPin);
        if (theResult == null) {
            visitorMap.put(inputInputPin, inputInputPin);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InputPinImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitInputPin(inputInputPin);
            theResult = super.caseInputPin(inputInputPin);
        }
        return theResult;
    }

    @Override
    @objid ("12edc1de-4583-11e0-b54c-00137279a832")
    public Object caseInstanceSpecification(InstanceSpecification inputInstanceSpecification) {
        Object theResult = visitorMap.get(inputInstanceSpecification);
        if (theResult == null) {
            visitorMap.put(inputInstanceSpecification,
                    inputInstanceSpecification);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InstanceSpecificationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInstanceSpecification(inputInstanceSpecification);
            theResult = super
            .caseInstanceSpecification(inputInstanceSpecification);
            for (Object classifier : inputInstanceSpecification
                    .getClassifiers()) {
                this.doSwitch((EObject) classifier);
            }
            for (Object slot : inputInstanceSpecification.getSlots()) {
                this.doSwitch((EObject) slot);
            }
            this.doSwitch((EObject) inputInstanceSpecification
                    .getSpecification());
        }
        return theResult;
    }

    @Override
    @objid ("12edc1e4-4583-11e0-b54c-00137279a832")
    public Object caseInstanceValue(InstanceValue inputInstanceValue) {
        Object theResult = visitorMap.get(inputInstanceValue);
        if (theResult == null) {
            visitorMap.put(inputInstanceValue, inputInstanceValue);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InstanceValueImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInstanceValue(inputInstanceValue);
            theResult = super.caseInstanceValue(inputInstanceValue);
            this.doSwitch((EObject) inputInstanceValue.getInstance());
        }
        return theResult;
    }

    @Override
    @objid ("12f02439-4583-11e0-b54c-00137279a832")
    public Object caseInteraction(Interaction inputInteraction) {
        Object theResult = visitorMap.get(inputInteraction);
        if (theResult == null) {
            visitorMap.put(inputInteraction, inputInteraction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InteractionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInteraction(inputInteraction);
            theResult = super.caseInteraction(inputInteraction);
            for (Object lifeline : inputInteraction.getLifelines()) {
                this.doSwitch((EObject) lifeline);
            }
            for (Object message : inputInteraction.getMessages()) {
                this.doSwitch((EObject) message);
            }
            for (Object fragment : inputInteraction.getFragments()) {
                this.doSwitch((EObject) fragment);
            }
            for (Object action : inputInteraction.getActions()) {
                this.doSwitch((EObject) action);
            }
            for (Object formalGate : inputInteraction.getFormalGates()) {
                this.doSwitch((EObject) formalGate);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12f0243f-4583-11e0-b54c-00137279a832")
    public Object caseInteractionConstraint(InteractionConstraint inputInteractionConstraint) {
        Object theResult = visitorMap.get(inputInteractionConstraint);
        if (theResult == null) {
            visitorMap.put(inputInteractionConstraint,
                    inputInteractionConstraint);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InteractionConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInteractionConstraint(inputInteractionConstraint);
            theResult = super
            .caseInteractionConstraint(inputInteractionConstraint);
            this.doSwitch((EObject) inputInteractionConstraint.getMinint());
            this.doSwitch((EObject) inputInteractionConstraint.getMaxint());
        }
        return theResult;
    }

    @Override
    @objid ("12f28696-4583-11e0-b54c-00137279a832")
    public Object caseInteractionFragment(InteractionFragment inputInteractionFragment) {
        Object theResult = super
        .caseInteractionFragment(inputInteractionFragment);
        for (Object covered : inputInteractionFragment.getCovereds()) {
            this.doSwitch((EObject) covered);
        }
        for (Object generalOrdering : inputInteractionFragment
                .getGeneralOrderings()) {
            this.doSwitch((EObject) generalOrdering);
        }
        this.doSwitch((EObject) inputInteractionFragment
                .getEnclosingInteraction());
        this.doSwitch((EObject) inputInteractionFragment.getEnclosingOperand());
        return theResult;
    }

    @Override
    @objid ("12f4e8ec-4583-11e0-b54c-00137279a832")
    public Object caseInteractionOperand(InteractionOperand inputInteractionOperand) {
        Object theResult = visitorMap.get(inputInteractionOperand);
        if (theResult == null) {
            visitorMap.put(inputInteractionOperand, inputInteractionOperand);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InteractionOperandImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInteractionOperand(inputInteractionOperand);
            theResult = super.caseInteractionOperand(inputInteractionOperand);
            this.doSwitch((EObject) inputInteractionOperand.getGuard());
            for (Object fragment : inputInteractionOperand.getFragments()) {
                this.doSwitch((EObject) fragment);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12f4e8f2-4583-11e0-b54c-00137279a832")
    public Object caseInteractionUse(InteractionUse inputInteractionUse) {
        Object theResult = visitorMap.get(inputInteractionUse);
        if (theResult == null) {
            visitorMap.put(inputInteractionUse, inputInteractionUse);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InteractionUseImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInteractionUse(inputInteractionUse);
            theResult = super.caseInteractionUse(inputInteractionUse);
            this.doSwitch((EObject) inputInteractionUse.getRefersTo());
            for (Object actualGate : inputInteractionUse.getActualGates()) {
                this.doSwitch((EObject) actualGate);
            }
            for (Object argument : inputInteractionUse.getArguments()) {
                this.doSwitch((EObject) argument);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12f74b47-4583-11e0-b54c-00137279a832")
    public Object caseInterface(Interface inputInterface) {
        Object theResult = visitorMap.get(inputInterface);
        if (theResult == null) {
            visitorMap.put(inputInterface, inputInterface);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InterfaceImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInterface(inputInterface);
            theResult = super.caseInterface(inputInterface);
            for (Object ownedAttribute : inputInterface.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
            for (Object ownedOperation : inputInterface.getOwnedOperations()) {
                this.doSwitch((EObject) ownedOperation);
            }
            for (Object nestedClassifier : inputInterface
                    .getNestedClassifiers()) {
                this.doSwitch((EObject) nestedClassifier);
            }
            for (Object redefinedInterface : inputInterface
                    .getRedefinedInterfaces()) {
                this.doSwitch((EObject) redefinedInterface);
            }
            for (Object ownedReception : inputInterface.getOwnedReceptions()) {
                this.doSwitch((EObject) ownedReception);
            }
            this.doSwitch((EObject) inputInterface.getProtocol());
        }
        return theResult;
    }

    @Override
    @objid ("12f74b4d-4583-11e0-b54c-00137279a832")
    public Object caseInterfaceRealization(InterfaceRealization inputInterfaceRealization) {
        Object theResult = visitorMap.get(inputInterfaceRealization);
        if (theResult == null) {
            visitorMap
            .put(inputInterfaceRealization, inputInterfaceRealization);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InterfaceRealizationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitInterfaceRealization(inputInterfaceRealization);
            theResult = super
            .caseInterfaceRealization(inputInterfaceRealization);
            this.doSwitch((EObject) inputInterfaceRealization.getContract());
            this.doSwitch((EObject) inputInterfaceRealization
                    .getImplementingClassifier());
        }
        return theResult;
    }

    @Override
    @objid ("12f9ada5-4583-11e0-b54c-00137279a832")
    public Object caseInterruptibleActivityRegion(InterruptibleActivityRegion inputInterruptibleActivityRegion) {
        Object theResult = visitorMap.get(inputInterruptibleActivityRegion);
        if (theResult == null) {
            visitorMap.put(inputInterruptibleActivityRegion,
                    inputInterruptibleActivityRegion);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("InterruptibleActivityRegionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitInterruptibleActivityRegion(inputInterruptibleActivityRegion);
            theResult = super
            .caseInterruptibleActivityRegion(inputInterruptibleActivityRegion);
            for (Object interruptingEdge : inputInterruptibleActivityRegion
                    .getInterruptingEdges()) {
                this.doSwitch((EObject) interruptingEdge);
            }
            for (Object node : inputInterruptibleActivityRegion.getNodes()) {
                this.doSwitch((EObject) node);
            }
        }
        return theResult;
    }

    @Override
    @objid ("12fc0ffa-4583-11e0-b54c-00137279a832")
    public Object caseInterval(Interval inputInterval) {
        Object theResult = visitorMap.get(inputInterval);
        if (theResult == null) {
            visitorMap.put(inputInterval, inputInterval);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("IntervalImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitInterval(inputInterval);
            theResult = super.caseInterval(inputInterval);
            this.doSwitch((EObject) inputInterval.getMin());
            this.doSwitch((EObject) inputInterval.getMax());
        }
        return theResult;
    }

    @Override
    @objid ("12fc1000-4583-11e0-b54c-00137279a832")
    public Object caseIntervalConstraint(IntervalConstraint inputIntervalConstraint) {
        Object theResult = visitorMap.get(inputIntervalConstraint);
        if (theResult == null) {
            visitorMap.put(inputIntervalConstraint, inputIntervalConstraint);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("IntervalConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitIntervalConstraint(inputIntervalConstraint);
            theResult = super.caseIntervalConstraint(inputIntervalConstraint);
            this.doSwitch((EObject) inputIntervalConstraint.getSpecification());
        }
        return theResult;
    }

    @Override
    @objid ("12fe7255-4583-11e0-b54c-00137279a832")
    public Object caseInvocationAction(InvocationAction inputInvocationAction) {
        Object theResult = super.caseInvocationAction(inputInvocationAction);
        for (Object argument : inputInvocationAction.getArguments()) {
            this.doSwitch((EObject) argument);
        }
        this.doSwitch((EObject) inputInvocationAction.getOnPort());
        return theResult;
    }

    @Override
    @objid ("13033708-4583-11e0-b54c-00137279a832")
    public Object caseJoinNode(JoinNode inputJoinNode) {
        Object theResult = visitorMap.get(inputJoinNode);
        if (theResult == null) {
            visitorMap.put(inputJoinNode, inputJoinNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("JoinNodeImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitJoinNode(inputJoinNode);
            theResult = super.caseJoinNode(inputJoinNode);
            this.doSwitch((EObject) inputJoinNode.getJoinSpec());
        }
        return theResult;
    }

    @Override
    @objid ("1303370e-4583-11e0-b54c-00137279a832")
    public Object caseLifeline(Lifeline inputLifeline) {
        Object theResult = visitorMap.get(inputLifeline);
        if (theResult == null) {
            visitorMap.put(inputLifeline, inputLifeline);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LifelineImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitLifeline(inputLifeline);
            theResult = super.caseLifeline(inputLifeline);
            for (Object coveredBy : inputLifeline.getCoveredBys()) {
                this.doSwitch((EObject) coveredBy);
            }
            this.doSwitch((EObject) inputLifeline.getRepresents());
            this.doSwitch((EObject) inputLifeline.getInteraction());
            this.doSwitch((EObject) inputLifeline.getSelector());
            this.doSwitch((EObject) inputLifeline.getDecomposedAs());
        }
        return theResult;
    }

    @Override
    @objid ("13059966-4583-11e0-b54c-00137279a832")
    public Object caseLinkAction(LinkAction inputLinkAction) {
        Object theResult = super.caseLinkAction(inputLinkAction);
        for (Object endData : inputLinkAction.getEndData()) {
            this.doSwitch((EObject) endData);
        }
        for (Object inputValue : inputLinkAction.getInputValues()) {
            this.doSwitch((EObject) inputValue);
        }
        return theResult;
    }

    @Override
    @objid ("1307fbbc-4583-11e0-b54c-00137279a832")
    public Object caseLinkEndCreationData(LinkEndCreationData inputLinkEndCreationData) {
        Object theResult = visitorMap.get(inputLinkEndCreationData);
        if (theResult == null) {
            visitorMap.put(inputLinkEndCreationData, inputLinkEndCreationData);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LinkEndCreationDataImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitLinkEndCreationData(inputLinkEndCreationData);
            theResult = super.caseLinkEndCreationData(inputLinkEndCreationData);
            this.doSwitch((EObject) inputLinkEndCreationData.getInsertAt());
        }
        return theResult;
    }

    @Override
    @objid ("1307fbc2-4583-11e0-b54c-00137279a832")
    public Object caseLinkEndData(LinkEndData inputLinkEndData) {
        Object theResult = visitorMap.get(inputLinkEndData);
        if (theResult == null) {
            visitorMap.put(inputLinkEndData, inputLinkEndData);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LinkEndDataImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitLinkEndData(inputLinkEndData);
            theResult = super.caseLinkEndData(inputLinkEndData);
            this.doSwitch((EObject) inputLinkEndData.getValue());
            this.doSwitch((EObject) inputLinkEndData.getEnd());
            for (Object qualifier : inputLinkEndData.getQualifiers()) {
                this.doSwitch((EObject) qualifier);
            }
        }
        return theResult;
    }

    @Override
    @objid ("130a5e17-4583-11e0-b54c-00137279a832")
    public Object caseLinkEndDestructionData(LinkEndDestructionData inputLinkEndDestructionData) {
        Object theResult = visitorMap.get(inputLinkEndDestructionData);
        if (theResult == null) {
            visitorMap.put(inputLinkEndDestructionData,
                    inputLinkEndDestructionData);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LinkEndDestructionDataImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitLinkEndDestructionData(inputLinkEndDestructionData);
            theResult = super
            .caseLinkEndDestructionData(inputLinkEndDestructionData);
            this.doSwitch((EObject) inputLinkEndDestructionData.getDestroyAt());
        }
        return theResult;
    }

    @Override
    @objid ("130cc070-4583-11e0-b54c-00137279a832")
    public Object caseLiteralBoolean(LiteralBoolean inputLiteralBoolean) {
        Object theResult = visitorMap.get(inputLiteralBoolean);
        if (theResult == null) {
            visitorMap.put(inputLiteralBoolean, inputLiteralBoolean);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralBooleanImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitLiteralBoolean(inputLiteralBoolean);
            theResult = super.caseLiteralBoolean(inputLiteralBoolean);
        }
        return theResult;
    }

    @Override
    @objid ("130cc076-4583-11e0-b54c-00137279a832")
    public Object caseLiteralInteger(LiteralInteger inputLiteralInteger) {
        Object theResult = visitorMap.get(inputLiteralInteger);
        if (theResult == null) {
            visitorMap.put(inputLiteralInteger, inputLiteralInteger);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralIntegerImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitLiteralInteger(inputLiteralInteger);
            theResult = super.caseLiteralInteger(inputLiteralInteger);
        }
        return theResult;
    }

    @Override
    @objid ("130f22cb-4583-11e0-b54c-00137279a832")
    public Object caseLiteralNull(LiteralNull inputLiteralNull) {
        Object theResult = visitorMap.get(inputLiteralNull);
        if (theResult == null) {
            visitorMap.put(inputLiteralNull, inputLiteralNull);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralNullImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitLiteralNull(inputLiteralNull);
            theResult = super.caseLiteralNull(inputLiteralNull);
        }
        return theResult;
    }

    @Override
    @objid ("13118524-4583-11e0-b54c-00137279a832")
    public Object caseLiteralSpecification(LiteralSpecification inputLiteralSpecification) {
        Object theResult = super
        .caseLiteralSpecification(inputLiteralSpecification);
        return theResult;
    }

    @Override
    @objid ("1311852a-4583-11e0-b54c-00137279a832")
    public Object caseLiteralString(LiteralString inputLiteralString) {
        Object theResult = visitorMap.get(inputLiteralString);
        if (theResult == null) {
            visitorMap.put(inputLiteralString, inputLiteralString);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralStringImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitLiteralString(inputLiteralString);
            theResult = super.caseLiteralString(inputLiteralString);
        }
        return theResult;
    }

    @Override
    @objid ("1313e77e-4583-11e0-b54c-00137279a832")
    public Object caseLiteralUnlimitedNatural(LiteralUnlimitedNatural inputLiteralUnlimitedNatural) {
        Object theResult = visitorMap.get(inputLiteralUnlimitedNatural);
        if (theResult == null) {
            visitorMap.put(inputLiteralUnlimitedNatural,
                    inputLiteralUnlimitedNatural);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LiteralUnlimitedNaturalImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitLiteralUnlimitedNatural(inputLiteralUnlimitedNatural);
            theResult = super
            .caseLiteralUnlimitedNatural(inputLiteralUnlimitedNatural);
        }
        return theResult;
    }

    @Override
    @objid ("1313e784-4583-11e0-b54c-00137279a832")
    public Object caseLoopNode(LoopNode inputLoopNode) {
        Object theResult = visitorMap.get(inputLoopNode);
        if (theResult == null) {
            visitorMap.put(inputLoopNode, inputLoopNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("LoopNodeImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitLoopNode(inputLoopNode);
            theResult = super.caseLoopNode(inputLoopNode);
            for (Object bodyPart : inputLoopNode.getBodyParts()) {
                this.doSwitch((EObject) bodyPart);
            }
            for (Object setupPart : inputLoopNode.getSetupParts()) {
                this.doSwitch((EObject) setupPart);
            }
            this.doSwitch((EObject) inputLoopNode.getDecider());
            for (Object test : inputLoopNode.getTests()) {
                this.doSwitch((EObject) test);
            }
            for (Object result : inputLoopNode.getResults()) {
                this.doSwitch((EObject) result);
            }
            for (Object loopVariable : inputLoopNode.getLoopVariables()) {
                this.doSwitch((EObject) loopVariable);
            }
            for (Object bodyOutput : inputLoopNode.getBodyOutputs()) {
                this.doSwitch((EObject) bodyOutput);
            }
            for (Object loopVariableInput : inputLoopNode
                    .getLoopVariableInputs()) {
                this.doSwitch((EObject) loopVariableInput);
            }
        }
        return theResult;
    }

    @Override
    @objid ("131649dc-4583-11e0-b54c-00137279a832")
    public Object caseManifestation(Manifestation inputManifestation) {
        Object theResult = visitorMap.get(inputManifestation);
        if (theResult == null) {
            visitorMap.put(inputManifestation, inputManifestation);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ManifestationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitManifestation(inputManifestation);
            theResult = super.caseManifestation(inputManifestation);
            this.doSwitch((EObject) inputManifestation.getUtilizedElement());
        }
        return theResult;
    }

    @Override
    @objid ("1318ac32-4583-11e0-b54c-00137279a832")
    public Object caseMergeNode(MergeNode inputMergeNode) {
        Object theResult = visitorMap.get(inputMergeNode);
        if (theResult == null) {
            visitorMap.put(inputMergeNode, inputMergeNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("MergeNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitMergeNode(inputMergeNode);
            theResult = super.caseMergeNode(inputMergeNode);
        }
        return theResult;
    }

    @Override
    @objid ("1318ac38-4583-11e0-b54c-00137279a832")
    public Object caseMessage(Message inputMessage) {
        Object theResult = visitorMap.get(inputMessage);
        if (theResult == null) {
            visitorMap.put(inputMessage, inputMessage);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("MessageImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitMessage(inputMessage);
            theResult = super.caseMessage(inputMessage);
            this.doSwitch((EObject) inputMessage.getReceiveEvent());
            this.doSwitch((EObject) inputMessage.getSendEvent());
            this.doSwitch((EObject) inputMessage.getConnector());
            this.doSwitch((EObject) inputMessage.getInteraction());
            for (Object argument : inputMessage.getArguments()) {
                this.doSwitch((EObject) argument);
            }
            this.doSwitch((EObject) inputMessage.getSignature());
        }
        return theResult;
    }

    @Override
    @objid ("131b0e90-4583-11e0-b54c-00137279a832")
    public Object caseMessageEnd(MessageEnd inputMessageEnd) {
        Object theResult = super.caseMessageEnd(inputMessageEnd);
        this.doSwitch((EObject) inputMessageEnd.getMessage());
        return theResult;
    }

    @Override
    @objid ("131d70e6-4583-11e0-b54c-00137279a832")
    public Object caseMessageEvent(MessageEvent inputMessageEvent) {
        return super.caseMessageEvent(inputMessageEvent);
    }

    @Override
    @objid ("131d70ec-4583-11e0-b54c-00137279a832")
    public Object caseMessageOccurrenceSpecification(MessageOccurrenceSpecification inputMessageOccurrenceSpecification) {
        Object theResult = visitorMap.get(inputMessageOccurrenceSpecification);
        if (theResult == null) {
            visitorMap.put(inputMessageOccurrenceSpecification,
                    inputMessageOccurrenceSpecification);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("MessageOccurrenceSpecificationImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitMessageOccurrenceSpecification(inputMessageOccurrenceSpecification);
            theResult = super
            .caseMessageOccurrenceSpecification(inputMessageOccurrenceSpecification);
        }
        return theResult;
    }

    @Override
    @objid ("131fd344-4583-11e0-b54c-00137279a832")
    public Object caseModel(Model inputModel) {
        Object theResult = visitorMap.get(inputModel);
        if (theResult == null) {
            visitorMap.put(inputModel, inputModel);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ModelImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitModel(inputModel);
            // ReverseProperties revProp = ReverseProperties.getInstance();
            // ModelImpl rootMdl = revProp.getEcoreModel();
            // if (rootMdl.getName().equals(inputModel.getName()))
            theResult = super.caseModel(inputModel);
        }
        return theResult;
    }

    @Override
    @objid ("1322359a-4583-11e0-b54c-00137279a832")
    public Object caseMultiplicityElement(MultiplicityElement inputMultiplicityElement) {
        Object theResult = super
        .caseMultiplicityElement(inputMultiplicityElement);
        this.doSwitch((EObject) inputMultiplicityElement.getUpperValue());
        this.doSwitch((EObject) inputMultiplicityElement.getLowerValue());
        return theResult;
    }

    @Override
    @objid ("132235a0-4583-11e0-b54c-00137279a832")
    public Object caseNamedElement(NamedElement inputNamedElement) {
        Object theResult = super.caseNamedElement(inputNamedElement);
        for (Object clientDependency : inputNamedElement
                .getClientDependencies()) {
            this.doSwitch((EObject) clientDependency);
        }
        this.doSwitch((EObject) inputNamedElement.getNamespace());
        this.doSwitch((EObject) inputNamedElement.getNameExpression());
        return theResult;
    }

    @Override
    @objid ("132497f8-4583-11e0-b54c-00137279a832")
    public Object caseNamespace(Namespace inputNamespace) {
        Object theResult = super.caseNamespace(inputNamespace);
        for (Object elementImport : inputNamespace.getElementImports()) {
            this.doSwitch((EObject) elementImport);
        }
        for (Object packageImport : inputNamespace.getPackageImports()) {
            this.doSwitch((EObject) packageImport);
        }
        for (Object ownedRule : inputNamespace.getOwnedRules()) {
            this.doSwitch((EObject) ownedRule);
        }
        for (Object member : inputNamespace.getMembers()) {
            this.doSwitch((EObject) member);
        }
        for (Object importedMember : inputNamespace.getImportedMembers()) {
            this.doSwitch((EObject) importedMember);
        }
        for (Object ownedMember : inputNamespace.getOwnedMembers()) {
            this.doSwitch((EObject) ownedMember);
        }
        return theResult;
    }

    @Override
    @objid ("1326fa4e-4583-11e0-b54c-00137279a832")
    public Object caseNode(Node inputNode) {
        Object theResult = visitorMap.get(inputNode);
        if (theResult == null) {
            visitorMap.put(inputNode, inputNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("NodeImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitNode(inputNode);
            theResult = super.caseNode(inputNode);
            for (Object nestedNode : inputNode.getNestedNodes()) {
                this.doSwitch((EObject) nestedNode);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1326fa54-4583-11e0-b54c-00137279a832")
    public Object caseObjectFlow(ObjectFlow inputObjectFlow) {
        Object theResult = visitorMap.get(inputObjectFlow);
        if (theResult == null) {
            visitorMap.put(inputObjectFlow, inputObjectFlow);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ObjectFlowImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitObjectFlow(inputObjectFlow);
            theResult = super.caseObjectFlow(inputObjectFlow);
            this.doSwitch((EObject) inputObjectFlow.getTransformation());
            this.doSwitch((EObject) inputObjectFlow.getSelection());
        }
        return theResult;
    }

    @Override
    @objid ("13295cac-4583-11e0-b54c-00137279a832")
    public Object caseObjectNode(ObjectNode inputObjectNode) {
        Object theResult = super.caseObjectNode(inputObjectNode);
        this.doSwitch((EObject) inputObjectNode.getUpperBound());
        for (Object inState : inputObjectNode.getInStates()) {
            this.doSwitch((EObject) inState);
        }
        this.doSwitch((EObject) inputObjectNode.getSelection());
        return theResult;
    }

    @Override
    @objid ("132bbf02-4583-11e0-b54c-00137279a832")
    public Object caseObservation(final Observation inputIservation) {
        return super.caseObservation(inputIservation);
    }

    @Override
    @objid ("132bbf08-4583-11e0-b54c-00137279a832")
    public Object caseOccurrenceSpecification(OccurrenceSpecification inputOccurrenceSpecification) {
        Object theResult = visitorMap.get(inputOccurrenceSpecification);
        if (theResult == null) {
            visitorMap.put(inputOccurrenceSpecification,
                    inputOccurrenceSpecification);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OccurrenceSpecificationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitOccurrenceSpecification(inputOccurrenceSpecification);
            theResult = super
            .caseOccurrenceSpecification(inputOccurrenceSpecification);
            // this.doSwitch((EObject)inputOccurrenceSpecification.getCovered());
            for (Object covered : inputOccurrenceSpecification.getCovereds()) {
                this.doSwitch((EObject) covered);
            }
            for (Object toAfter : inputOccurrenceSpecification.getToAfters()) {
                this.doSwitch((EObject) toAfter);
            }
            for (Object toBefore : inputOccurrenceSpecification.getToBefores()) {
                this.doSwitch((EObject) toBefore);
            }
            this.doSwitch((EObject) inputOccurrenceSpecification.getEvent());
        }
        return theResult;
    }

    @Override
    @objid ("132e2161-4583-11e0-b54c-00137279a832")
    public Object caseOpaqueAction(OpaqueAction inputOpaqueAction) {
        Object theResult = visitorMap.get(inputOpaqueAction);
        if (theResult == null) {
            visitorMap.put(inputOpaqueAction, inputOpaqueAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OpaqueActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitOpaqueAction(inputOpaqueAction);
            theResult = super.caseOpaqueAction(inputOpaqueAction);
            for (Object inputValue : inputOpaqueAction.getInputValues()) {
                this.doSwitch((EObject) inputValue);
            }
            for (Object outputValue : inputOpaqueAction.getOutputValues()) {
                this.doSwitch((EObject) outputValue);
            }
        }
        return theResult;
    }

    @Override
    @objid ("133083ba-4583-11e0-b54c-00137279a832")
    public Object caseOpaqueBehavior(OpaqueBehavior inputOpaqueBehavior) {
        Object theResult = visitorMap.get(inputOpaqueBehavior);
        if (theResult == null) {
            visitorMap.put(inputOpaqueBehavior, inputOpaqueBehavior);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OpaqueBehaviorImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitOpaqueBehavior(inputOpaqueBehavior);
            theResult = super.caseOpaqueBehavior(inputOpaqueBehavior);
        }
        return theResult;
    }

    @Override
    @objid ("1332e610-4583-11e0-b54c-00137279a832")
    public Object caseOpaqueExpression(OpaqueExpression inputOpaqueExpression) {
        Object theResult = visitorMap.get(inputOpaqueExpression);
        if (theResult == null) {
            visitorMap.put(inputOpaqueExpression, inputOpaqueExpression);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OpaqueExpressionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitOpaqueExpression(inputOpaqueExpression);
            theResult = super.caseOpaqueExpression(inputOpaqueExpression);
            this.doSwitch((EObject) inputOpaqueExpression.getResult());
            this.doSwitch((EObject) inputOpaqueExpression.getBehavior());
        }
        return theResult;
    }

    @Override
    @objid ("1335486a-4583-11e0-b54c-00137279a832")
    public Object caseOperation(Operation inputOperation) {
        Object theResult = visitorMap.get(inputOperation);
        if (theResult == null) {
            visitorMap.put(inputOperation, inputOperation);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OperationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitOperation(inputOperation);
            theResult = super.caseOperation(inputOperation);
            this.doSwitch((EObject) inputOperation.getClass_());
            for (Object precondition : inputOperation.getPreconditions()) {
                this.doSwitch((EObject) precondition);
            }
            for (Object postcondition : inputOperation.getPostconditions()) {
                this.doSwitch((EObject) postcondition);
            }
            for (Object redefinedOperation : inputOperation
                    .getRedefinedOperations()) {
                this.doSwitch((EObject) redefinedOperation);
            }
            this.doSwitch((EObject) inputOperation.getDatatype());
            this.doSwitch((EObject) inputOperation.getBodyCondition());
            this.doSwitch((EObject) inputOperation.getType());
            for (Object ownedParameter : inputOperation.getOwnedParameters()) {
                this.doSwitch((EObject) ownedParameter);
            }
            for (Object raisedException : inputOperation.getRaisedExceptions()) {
                this.doSwitch((EObject) raisedException);
            }
            this.doSwitch((EObject) inputOperation.getInterface());
            this.doSwitch((EObject) inputOperation.getTemplateParameter());
        }
        return theResult;
    }

    @Override
    @objid ("13354870-4583-11e0-b54c-00137279a832")
    public Object caseOperationTemplateParameter(OperationTemplateParameter inputOperationTemplateParameter) {
        Object theResult = visitorMap.get(inputOperationTemplateParameter);
        if (theResult == null) {
            visitorMap.put(inputOperationTemplateParameter,
                    inputOperationTemplateParameter);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OperationTemplateParameterImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitOperationTemplateParameter(inputOperationTemplateParameter);
            theResult = super
            .caseOperationTemplateParameter(inputOperationTemplateParameter);
            this.doSwitch((EObject) inputOperationTemplateParameter
                    .getParameteredElement());
        }
        return theResult;
    }

    @Override
    @objid ("1337aac5-4583-11e0-b54c-00137279a832")
    public Object caseOutputPin(OutputPin inputOutputPin) {
        Object theResult = visitorMap.get(inputOutputPin);
        if (theResult == null) {
            visitorMap.put(inputOutputPin, inputOutputPin);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("OutputPinImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitOutputPin(inputOutputPin);
            theResult = super.caseOutputPin(inputOutputPin);
        }
        return theResult;
    }

    @Override
    @objid ("133a0d1e-4583-11e0-b54c-00137279a832")
    public Object casePackage(Package inputPackage) {
        Object theResult = visitorMap.get(inputPackage);
        if (theResult == null) {
            visitorMap.put(inputPackage, inputPackage);
        }
        
        if (inputPackage instanceof Model)
            return theResult;
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PackageImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitPackage(inputPackage);
            theResult = super.casePackage(inputPackage);
            for (Object packageMerge : inputPackage.getPackageMerges()) {
                this.doSwitch((EObject) packageMerge);
            }
            for (Object packagedElement : inputPackage.getPackagedElements()) {
                this.doSwitch((EObject) packagedElement);
            }
            for (Object ownedType : inputPackage.getOwnedTypes()) {
                this.doSwitch((EObject) ownedType);
            }
            for (Object nestedPackage : inputPackage.getNestedPackages()) {
                this.doSwitch((EObject) nestedPackage);
            }
            this.doSwitch((EObject) inputPackage.getNestingPackage());
            for (Object profileApplication : inputPackage
                    .getProfileApplications()) {
                this.doSwitch((EObject) profileApplication);
            }
        }
        return theResult;
    }

    @Override
    @objid ("133a0d24-4583-11e0-b54c-00137279a832")
    public Object casePackageImport(PackageImport inputPackageImport) {
        Object theResult = visitorMap.get(inputPackageImport);
        if (theResult == null) {
            visitorMap.put(inputPackageImport, inputPackageImport);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PackageImportImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitPackageImport(inputPackageImport);
            theResult = super.casePackageImport(inputPackageImport);
            this.doSwitch((EObject) inputPackageImport.getImportingNamespace());
            this.doSwitch((EObject) inputPackageImport.getImportedPackage());
        }
        return theResult;
    }

    @Override
    @objid ("133c6f7a-4583-11e0-b54c-00137279a832")
    public Object casePackageMerge(PackageMerge inputPackageMerge) {
        Object theResult = visitorMap.get(inputPackageMerge);
        if (theResult == null) {
            visitorMap.put(inputPackageMerge, inputPackageMerge);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PackageMergeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitPackageMerge(inputPackageMerge);
            theResult = super.casePackageMerge(inputPackageMerge);
            this.doSwitch((EObject) inputPackageMerge.getReceivingPackage());
            this.doSwitch((EObject) inputPackageMerge.getMergedPackage());
        }
        return theResult;
    }

    @Override
    @objid ("133ed1d2-4583-11e0-b54c-00137279a832")
    public Object casePackageableElement(PackageableElement inputPackageableElement) {
        Object theResult = super
        .casePackageableElement(inputPackageableElement);
        return theResult;
    }

    @Override
    @objid ("133ed1d8-4583-11e0-b54c-00137279a832")
    public Object caseParameter(Parameter inputParameter) {
        Object theResult = visitorMap.get(inputParameter);
        if (theResult == null) {
            visitorMap.put(inputParameter, inputParameter);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ParameterImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitParameter(inputParameter);
            theResult = super.caseParameter(inputParameter);
            this.doSwitch((EObject) inputParameter.getDefaultValue());
            this.doSwitch((EObject) inputParameter.getOperation());
            for (Object parameterSet : inputParameter.getParameterSets()) {
                this.doSwitch((EObject) parameterSet);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13413430-4583-11e0-b54c-00137279a832")
    public Object caseParameterSet(ParameterSet inputParameterSet) {
        Object theResult = visitorMap.get(inputParameterSet);
        if (theResult == null) {
            visitorMap.put(inputParameterSet, inputParameterSet);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ParameterSetImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitParameterSet(inputParameterSet);
            theResult = super.caseParameterSet(inputParameterSet);
            for (Object parameter : inputParameterSet.getParameters()) {
                this.doSwitch((EObject) parameter);
            }
            for (Object condition : inputParameterSet.getConditions()) {
                this.doSwitch((EObject) condition);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13439686-4583-11e0-b54c-00137279a832")
    public Object caseParameterableElement(ParameterableElement inputParameterableElement) {
        Object theResult = super
        .caseParameterableElement(inputParameterableElement);
        this.doSwitch((EObject) inputParameterableElement
                .getTemplateParameter());
        this.doSwitch((EObject) inputParameterableElement
                .getOwningTemplateParameter());
        return theResult;
    }

    @Override
    @objid ("1345f8e0-4583-11e0-b54c-00137279a832")
    public Object casePartDecomposition(PartDecomposition inputPartDecomposition) {
        Object theResult = visitorMap.get(inputPartDecomposition);
        if (theResult == null) {
            visitorMap.put(inputPartDecomposition, inputPartDecomposition);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PartDecompositionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitPartDecomposition(inputPartDecomposition);
            theResult = super.casePartDecomposition(inputPartDecomposition);
        }
        return theResult;
    }

    @Override
    @objid ("1345f8e6-4583-11e0-b54c-00137279a832")
    public Object casePin(Pin inputPin) {
        Object theResult = visitorMap.get(inputPin);
        if (theResult == null) {
            visitorMap.put(inputPin, inputPin);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PinImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitPin(inputPin);
            theResult = super.casePin(inputPin);
        }
        return theResult;
    }

    @Override
    @objid ("13485b3b-4583-11e0-b54c-00137279a832")
    public Object casePort(Port inputPort) {
        Object theResult = visitorMap.get(inputPort);
        if (theResult == null) {
            visitorMap.put(inputPort, inputPort);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PortImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitPort(inputPort);
            theResult = super.casePort(inputPort);
            for (Object required : inputPort.getRequireds()) {
                this.doSwitch((EObject) required);
            }
            for (Object redefinedPort : inputPort.getRedefinedPorts()) {
                this.doSwitch((EObject) redefinedPort);
            }
            for (Object provided : inputPort.getProvideds()) {
                this.doSwitch((EObject) provided);
            }
            this.doSwitch((EObject) inputPort.getProtocol());
        }
        return theResult;
    }

    @Override
    @objid ("134abd94-4583-11e0-b54c-00137279a832")
    public Object casePrimitiveType(PrimitiveType inputPrimitiveType) {
        Object theResult = visitorMap.get(inputPrimitiveType);
        if (theResult == null) {
            visitorMap.put(inputPrimitiveType, inputPrimitiveType);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PrimitiveTypeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitPrimitiveType(inputPrimitiveType);
            theResult = super.casePrimitiveType(inputPrimitiveType);
        }
        return theResult;
    }

    @Override
    @objid ("134abd9a-4583-11e0-b54c-00137279a832")
    public Object caseProfile(Profile inputProfile) {
        Object theResult = visitorMap.get(inputProfile);
        if (theResult == null) {
            visitorMap.put(inputProfile, inputProfile);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProfileImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitProfile(inputProfile);
            theResult = super.caseProfile(inputProfile);
            for (Object ownedStereotype : inputProfile.getOwnedStereotypes()) {
                this.doSwitch((EObject) ownedStereotype);
            }
            for (Object metaclassReference : inputProfile
                    .getMetaclassReferences()) {
                this.doSwitch((EObject) metaclassReference);
            }
            for (Object metamodelReference : inputProfile
                    .getMetamodelReferences()) {
                this.doSwitch((EObject) metamodelReference);
            }
        }
        return theResult;
    }

    @Override
    @objid ("134d1ff2-4583-11e0-b54c-00137279a832")
    public Object caseProfileApplication(ProfileApplication inputProfileApplication) {
        Object theResult = visitorMap.get(inputProfileApplication);
        if (theResult == null) {
            visitorMap.put(inputProfileApplication, inputProfileApplication);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProfileApplicationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitProfileApplication(inputProfileApplication);
            theResult = super.caseProfileApplication(inputProfileApplication);
            this
            .doSwitch((EObject) inputProfileApplication
                    .getAppliedProfile());
            this.doSwitch((EObject) inputProfileApplication
                    .getApplyingPackage());
        }
        return theResult;
    }

    @Override
    @objid ("134f8249-4583-11e0-b54c-00137279a832")
    public Object caseProperty(Property inputProperty) {
        Object theResult = visitorMap.get(inputProperty);
        if (theResult == null) {
            visitorMap.put(inputProperty, inputProperty);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PropertyImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitProperty(inputProperty);
            theResult = super.caseProperty(inputProperty);
            this.doSwitch((EObject) inputProperty.getClass_());
            for (Object redefinedProperty : inputProperty
                    .getRedefinedProperties()) {
                this.doSwitch((EObject) redefinedProperty);
            }
            this.doSwitch((EObject) inputProperty.getOwningAssociation());
            this.doSwitch((EObject) inputProperty.getDatatype());
            this.doSwitch((EObject) inputProperty.getDefaultValue());
            this.doSwitch((EObject) inputProperty.getOpposite());
            for (Object subsettedProperty : inputProperty
                    .getSubsettedProperties()) {
                this.doSwitch((EObject) subsettedProperty);
            }
            this.doSwitch((EObject) inputProperty.getAssociation());
            for (Object qualifier : inputProperty.getQualifiers()) {
                this.doSwitch((EObject) qualifier);
            }
            this.doSwitch((EObject) inputProperty.getAssociationEnd());
        }
        return theResult;
    }

    @Override
    @objid ("1351e4a2-4583-11e0-b54c-00137279a832")
    public Object caseProtocolConformance(ProtocolConformance inputProtocolConformance) {
        Object theResult = visitorMap.get(inputProtocolConformance);
        if (theResult == null) {
            visitorMap.put(inputProtocolConformance, inputProtocolConformance);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProtocolConformanceImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitProtocolConformance(inputProtocolConformance);
            theResult = super.caseProtocolConformance(inputProtocolConformance);
            this.doSwitch((EObject) inputProtocolConformance
                    .getSpecificMachine());
            this.doSwitch((EObject) inputProtocolConformance
                    .getGeneralMachine());
        }
        return theResult;
    }

    @Override
    @objid ("1351e4a8-4583-11e0-b54c-00137279a832")
    public Object caseProtocolStateMachine(ProtocolStateMachine inputProtocolStateMachine) {
        Object theResult = visitorMap.get(inputProtocolStateMachine);
        if (theResult == null) {
            visitorMap
            .put(inputProtocolStateMachine, inputProtocolStateMachine);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProtocolStateMachineImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitProtocolStateMachine(inputProtocolStateMachine);
            theResult = super
            .caseProtocolStateMachine(inputProtocolStateMachine);
            for (Object conformance : inputProtocolStateMachine
                    .getConformances()) {
                this.doSwitch((EObject) conformance);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13544700-4583-11e0-b54c-00137279a832")
    public Object caseProtocolTransition(ProtocolTransition inputProtocolTransition) {
        Object theResult = visitorMap.get(inputProtocolTransition);
        if (theResult == null) {
            visitorMap.put(inputProtocolTransition, inputProtocolTransition);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ProtocolTransitionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitProtocolTransition(inputProtocolTransition);
            theResult = super.caseProtocolTransition(inputProtocolTransition);
            this.doSwitch((EObject) inputProtocolTransition.getPostCondition());
            for (Object referred : inputProtocolTransition.getReferreds()) {
                this.doSwitch((EObject) referred);
            }
            this.doSwitch((EObject) inputProtocolTransition.getPreCondition());
        }
        return theResult;
    }

    @Override
    @objid ("1356a956-4583-11e0-b54c-00137279a832")
    public Object casePseudostate(Pseudostate inputPseudostate) {
        Object theResult = visitorMap.get(inputPseudostate);
        if (theResult == null) {
            visitorMap.put(inputPseudostate, inputPseudostate);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("PseudostateImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitPseudostate(inputPseudostate);
            theResult = super.casePseudostate(inputPseudostate);
            this.doSwitch((EObject) inputPseudostate.getStateMachine());
            this.doSwitch((EObject) inputPseudostate.getState());
        }
        return theResult;
    }

    @Override
    @objid ("13590bb0-4583-11e0-b54c-00137279a832")
    public Object caseQualifierValue(QualifierValue inputQualifierValue) {
        Object theResult = visitorMap.get(inputQualifierValue);
        if (theResult == null) {
            visitorMap.put(inputQualifierValue, inputQualifierValue);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("QualifierValueImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitQualifierValue(inputQualifierValue);
            theResult = super.caseQualifierValue(inputQualifierValue);
            this.doSwitch((EObject) inputQualifierValue.getQualifier());
            this.doSwitch((EObject) inputQualifierValue.getValue());
        }
        return theResult;
    }

    @Override
    @objid ("13590bb6-4583-11e0-b54c-00137279a832")
    public Object caseRaiseExceptionAction(RaiseExceptionAction inputRaiseExceptionAction) {
        Object theResult = visitorMap.get(inputRaiseExceptionAction);
        if (theResult == null) {
            visitorMap
            .put(inputRaiseExceptionAction, inputRaiseExceptionAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RaiseExceptionActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitRaiseExceptionAction(inputRaiseExceptionAction);
            theResult = super
            .caseRaiseExceptionAction(inputRaiseExceptionAction);
            this.doSwitch((EObject) inputRaiseExceptionAction.getException());
        }
        return theResult;
    }

    @Override
    @objid ("135b6e0c-4583-11e0-b54c-00137279a832")
    public Object caseReadExtentAction(ReadExtentAction inputReadExtentAction) {
        Object theResult = visitorMap.get(inputReadExtentAction);
        if (theResult == null) {
            visitorMap.put(inputReadExtentAction, inputReadExtentAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadExtentActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReadExtentAction(inputReadExtentAction);
            theResult = super.caseReadExtentAction(inputReadExtentAction);
            this.doSwitch((EObject) inputReadExtentAction.getResult());
            this.doSwitch((EObject) inputReadExtentAction.getClassifier());
        }
        return theResult;
    }

    @Override
    @objid ("135dd064-4583-11e0-b54c-00137279a832")
    public Object caseReadIsClassifiedObjectAction(ReadIsClassifiedObjectAction inputReadIsClassifiedObjectAction) {
        Object theResult = visitorMap.get(inputReadIsClassifiedObjectAction);
        if (theResult == null) {
            visitorMap.put(inputReadIsClassifiedObjectAction,
                    inputReadIsClassifiedObjectAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadIsClassifiedObjectActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitReadIsClassifiedObjectAction(inputReadIsClassifiedObjectAction);
            theResult = super
            .caseReadIsClassifiedObjectAction(inputReadIsClassifiedObjectAction);
            this.doSwitch((EObject) inputReadIsClassifiedObjectAction
                    .getClassifier());
            this.doSwitch((EObject) inputReadIsClassifiedObjectAction
                    .getResult());
            this.doSwitch((EObject) inputReadIsClassifiedObjectAction
                    .getObject());
        }
        return theResult;
    }

    @Override
    @objid ("136032be-4583-11e0-b54c-00137279a832")
    public Object caseReadLinkAction(ReadLinkAction inputReadLinkAction) {
        Object theResult = visitorMap.get(inputReadLinkAction);
        if (theResult == null) {
            visitorMap.put(inputReadLinkAction, inputReadLinkAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadLinkActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReadLinkAction(inputReadLinkAction);
            theResult = super.caseReadLinkAction(inputReadLinkAction);
            this.doSwitch((EObject) inputReadLinkAction.getResult());
        }
        return theResult;
    }

    @Override
    @objid ("136032c4-4583-11e0-b54c-00137279a832")
    public Object caseReadLinkObjectEndAction(ReadLinkObjectEndAction inputReadLinkObjectEndAction) {
        Object theResult = visitorMap.get(inputReadLinkObjectEndAction);
        if (theResult == null) {
            visitorMap.put(inputReadLinkObjectEndAction,
                    inputReadLinkObjectEndAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadLinkObjectEndActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReadLinkObjectEndAction(inputReadLinkObjectEndAction);
            theResult = super
            .caseReadLinkObjectEndAction(inputReadLinkObjectEndAction);
            this.doSwitch((EObject) inputReadLinkObjectEndAction.getObject());
            this.doSwitch((EObject) inputReadLinkObjectEndAction.getEnd());
            this.doSwitch((EObject) inputReadLinkObjectEndAction.getResult());
        }
        return theResult;
    }

    @Override
    @objid ("13629519-4583-11e0-b54c-00137279a832")
    public Object caseReadLinkObjectEndQualifierAction(ReadLinkObjectEndQualifierAction inputReadLinkObjectEndQualifierAction) {
        Object theResult = visitorMap
        .get(inputReadLinkObjectEndQualifierAction);
        if (theResult == null) {
            visitorMap.put(inputReadLinkObjectEndQualifierAction,
                    inputReadLinkObjectEndQualifierAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadLinkObjectEndQualifierActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitReadLinkObjectEndQualifierAction(inputReadLinkObjectEndQualifierAction);
            theResult = super
            .caseReadLinkObjectEndQualifierAction(inputReadLinkObjectEndQualifierAction);
            this.doSwitch((EObject) inputReadLinkObjectEndQualifierAction
                    .getObject());
            this.doSwitch((EObject) inputReadLinkObjectEndQualifierAction
                    .getResult());
            this.doSwitch((EObject) inputReadLinkObjectEndQualifierAction
                    .getQualifier());
        }
        return theResult;
    }

    @Override
    @objid ("1364f772-4583-11e0-b54c-00137279a832")
    public Object caseReadSelfAction(ReadSelfAction inputReadSelfAction) {
        Object theResult = visitorMap.get(inputReadSelfAction);
        if (theResult == null) {
            visitorMap.put(inputReadSelfAction, inputReadSelfAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadSelfActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReadSelfAction(inputReadSelfAction);
            theResult = super.caseReadSelfAction(inputReadSelfAction);
            this.doSwitch((EObject) inputReadSelfAction.getResult());
        }
        return theResult;
    }

    @Override
    @objid ("136759cc-4583-11e0-b54c-00137279a832")
    public Object caseReadStructuralFeatureAction(ReadStructuralFeatureAction inputReadStructuralFeatureAction) {
        Object theResult = visitorMap.get(inputReadStructuralFeatureAction);
        if (theResult == null) {
            visitorMap.put(inputReadStructuralFeatureAction,
                    inputReadStructuralFeatureAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadStructuralFeatureActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitReadStructuralFeatureAction(inputReadStructuralFeatureAction);
            theResult = super
            .caseReadStructuralFeatureAction(inputReadStructuralFeatureAction);
            this.doSwitch((EObject) inputReadStructuralFeatureAction
                    .getResult());
        }
        return theResult;
    }

    @Override
    @objid ("136759d2-4583-11e0-b54c-00137279a832")
    public Object caseReadVariableAction(ReadVariableAction inputReadVariableAction) {
        Object theResult = visitorMap.get(inputReadVariableAction);
        if (theResult == null) {
            visitorMap.put(inputReadVariableAction, inputReadVariableAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReadVariableActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReadVariableAction(inputReadVariableAction);
            theResult = super.caseReadVariableAction(inputReadVariableAction);
            this.doSwitch((EObject) inputReadVariableAction.getResult());
        }
        return theResult;
    }

    @Override
    @objid ("1369bc2a-4583-11e0-b54c-00137279a832")
    public Object caseRealization(Realization inputRealization) {
        Object theResult = visitorMap.get(inputRealization);
        if (theResult == null) {
            visitorMap.put(inputRealization, inputRealization);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RealizationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitRealization(inputRealization);
            theResult = super.caseRealization(inputRealization);
        }
        return theResult;
    }

    @Override
    @objid ("136c1e80-4583-11e0-b54c-00137279a832")
    public Object caseReceiveOperationEvent(ReceiveOperationEvent inputReceiveOperationEvent) {
        Object theResult = visitorMap.get(inputReceiveOperationEvent);
        if (theResult == null) {
            visitorMap.put(inputReceiveOperationEvent,
                    inputReceiveOperationEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReceiveOperationEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReceiveOperationEvent(inputReceiveOperationEvent);
            theResult = super
            .caseReceiveOperationEvent(inputReceiveOperationEvent);
            this.doSwitch((EObject) inputReceiveOperationEvent.getOperation());
        }
        return theResult;
    }

    @Override
    @objid ("136e80da-4583-11e0-b54c-00137279a832")
    public Object caseReceiveSignalEvent(ReceiveSignalEvent inputReceiveSignalEvent) {
        Object theResult = visitorMap.get(inputReceiveSignalEvent);
        if (theResult == null) {
            visitorMap.put(inputReceiveSignalEvent, inputReceiveSignalEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReceiveSignalEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReceiveSignalEvent(inputReceiveSignalEvent);
            theResult = super.caseReceiveSignalEvent(inputReceiveSignalEvent);
            this.doSwitch((EObject) inputReceiveSignalEvent.getSignal());
        }
        return theResult;
    }

    @Override
    @objid ("136e80e0-4583-11e0-b54c-00137279a832")
    public Object caseReception(Reception inputReception) {
        Object theResult = visitorMap.get(inputReception);
        if (theResult == null) {
            visitorMap.put(inputReception, inputReception);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReceptionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReception(inputReception);
            theResult = super.caseReception(inputReception);
            this.doSwitch((EObject) inputReception.getSignal());
        }
        return theResult;
    }

    @Override
    @objid ("1370e338-4583-11e0-b54c-00137279a832")
    public Object caseReclassifyObjectAction(ReclassifyObjectAction inputReclassifyObjectAction) {
        Object theResult = visitorMap.get(inputReclassifyObjectAction);
        if (theResult == null) {
            visitorMap.put(inputReclassifyObjectAction,
                    inputReclassifyObjectAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReclassifyObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReclassifyObjectAction(inputReclassifyObjectAction);
            theResult = super
            .caseReclassifyObjectAction(inputReclassifyObjectAction);
            for (Object oldClassifier : inputReclassifyObjectAction
                    .getOldClassifiers()) {
                this.doSwitch((EObject) oldClassifier);
            }
            for (Object newClassifier : inputReclassifyObjectAction
                    .getNewClassifiers()) {
                this.doSwitch((EObject) newClassifier);
            }
            this.doSwitch((EObject) inputReclassifyObjectAction.getObject());
        }
        return theResult;
    }

    @Override
    @objid ("1373458e-4583-11e0-b54c-00137279a832")
    public Object caseRedefinableElement(RedefinableElement inputRedefinableElement) {
        Object theResult = super
        .caseRedefinableElement(inputRedefinableElement);
        for (Object redefinedElement : inputRedefinableElement
                .getRedefinedElements()) {
            this.doSwitch((EObject) redefinedElement);
        }
        for (Object redefinitionContext : inputRedefinableElement
                .getRedefinitionContexts()) {
            this.doSwitch((EObject) redefinitionContext);
        }
        return theResult;
    }

    @Override
    @objid ("1375a7e8-4583-11e0-b54c-00137279a832")
    public Object caseRedefinableTemplateSignature(RedefinableTemplateSignature inputRedefinableTemplateSignature) {
        Object theResult = visitorMap.get(inputRedefinableTemplateSignature);
        if (theResult == null) {
            visitorMap.put(inputRedefinableTemplateSignature,
                    inputRedefinableTemplateSignature);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RedefinableTemplateSignatureImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitRedefinableTemplateSignature(inputRedefinableTemplateSignature);
            theResult = super
            .caseRedefinableTemplateSignature(inputRedefinableTemplateSignature);
            this.doSwitch((EObject) inputRedefinableTemplateSignature
                    .getClassifier());
            for (Object extendedSignature : inputRedefinableTemplateSignature
                    .getExtendedSignatures()) {
                this.doSwitch((EObject) extendedSignature);
            }
            for (Object inheritedParameter : inputRedefinableTemplateSignature
                    .getInheritedParameters()) {
                this.doSwitch((EObject) inheritedParameter);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13780a42-4583-11e0-b54c-00137279a832")
    public Object caseReduceAction(ReduceAction inputReduceAction) {
        Object theResult = visitorMap.get(inputReduceAction);
        if (theResult == null) {
            visitorMap.put(inputReduceAction, inputReduceAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReduceActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReduceAction(inputReduceAction);
            theResult = super.caseReduceAction(inputReduceAction);
            this.doSwitch((EObject) inputReduceAction.getReducer());
            this.doSwitch((EObject) inputReduceAction.getResult());
            this.doSwitch((EObject) inputReduceAction.getCollection());
        }
        return theResult;
    }

    @Override
    @objid ("13780a48-4583-11e0-b54c-00137279a832")
    public Object caseRegion(Region inputRegion) {
        Object theResult = visitorMap.get(inputRegion);
        if (theResult == null) {
            visitorMap.put(inputRegion, inputRegion);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RegionImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitRegion(inputRegion);
            theResult = super.caseRegion(inputRegion);
            for (Object subvertex : inputRegion.getSubvertices()) {
                this.doSwitch((EObject) subvertex);
            }
            for (Object transition : inputRegion.getTransitions()) {
                this.doSwitch((EObject) transition);
            }
            this.doSwitch((EObject) inputRegion.getStateMachine());
            this.doSwitch((EObject) inputRegion.getState());
            this.doSwitch((EObject) inputRegion.getExtendedRegion());
            // this.doSwitch((EObject)inputRegion.getRedefinitionContext());
            for (Object redefinitionContext : inputRegion
                    .getRedefinitionContexts()) {
                this.doSwitch((EObject) redefinitionContext);
            }
        }
        return theResult;
    }

    @Override
    @objid ("137a6ca0-4583-11e0-b54c-00137279a832")
    public Object caseRelationship(Relationship inputRelationship) {
        Object theResult = super.caseRelationship(inputRelationship);
        for (Object relatedElement : inputRelationship.getRelatedElements()) {
            this.doSwitch((EObject) relatedElement);
        }
        return theResult;
    }

    @Override
    @objid ("137ccef6-4583-11e0-b54c-00137279a832")
    public Object caseRemoveStructuralFeatureValueAction(RemoveStructuralFeatureValueAction inputRemoveStructuralFeatureValueAction) {
        Object theResult = visitorMap
        .get(inputRemoveStructuralFeatureValueAction);
        if (theResult == null) {
            visitorMap.put(inputRemoveStructuralFeatureValueAction,
                    inputRemoveStructuralFeatureValueAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RemoveStructuralFeatureValueActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitRemoveStructuralFeatureValueAction(inputRemoveStructuralFeatureValueAction);
            theResult = super
            .caseRemoveStructuralFeatureValueAction(inputRemoveStructuralFeatureValueAction);
            this.doSwitch((EObject) inputRemoveStructuralFeatureValueAction
                    .getRemoveAt());
        }
        return theResult;
    }

    @Override
    @objid ("137f3150-4583-11e0-b54c-00137279a832")
    public Object caseRemoveVariableValueAction(RemoveVariableValueAction inputRemoveVariableValueAction) {
        Object theResult = visitorMap.get(inputRemoveVariableValueAction);
        if (theResult == null) {
            visitorMap.put(inputRemoveVariableValueAction,
                    inputRemoveVariableValueAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("RemoveVariableValueActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitRemoveVariableValueAction(inputRemoveVariableValueAction);
            theResult = super
            .caseRemoveVariableValueAction(inputRemoveVariableValueAction);
            this.doSwitch((EObject) inputRemoveVariableValueAction
                    .getRemoveAt());
        }
        return theResult;
    }

    @Override
    @objid ("138193aa-4583-11e0-b54c-00137279a832")
    public Object caseReplyAction(ReplyAction inputReplyAction) {
        Object theResult = visitorMap.get(inputReplyAction);
        if (theResult == null) {
            visitorMap.put(inputReplyAction, inputReplyAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ReplyActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitReplyAction(inputReplyAction);
            theResult = super.caseReplyAction(inputReplyAction);
            this.doSwitch((EObject) inputReplyAction.getReplyToCall());
            this.doSwitch((EObject) inputReplyAction.getReturnInformation());
            for (Object replyValue : inputReplyAction.getReplyValues()) {
                this.doSwitch((EObject) replyValue);
            }
        }
        return theResult;
    }

    @Override
    @objid ("138193b0-4583-11e0-b54c-00137279a832")
    public Object caseSendObjectAction(SendObjectAction inputSendObjectAction) {
        Object theResult = visitorMap.get(inputSendObjectAction);
        if (theResult == null) {
            visitorMap.put(inputSendObjectAction, inputSendObjectAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SendObjectActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitSendObjectAction(inputSendObjectAction);
            theResult = super.caseSendObjectAction(inputSendObjectAction);
            this.doSwitch((EObject) inputSendObjectAction.getTarget());
            this.doSwitch((EObject) inputSendObjectAction.getRequest());
        }
        return theResult;
    }

    @Override
    @objid ("1383f605-4583-11e0-b54c-00137279a832")
    public Object caseSendOperationEvent(SendOperationEvent inputSendOperationEvent) {
        Object theResult = visitorMap.get(inputSendOperationEvent);
        if (theResult == null) {
            visitorMap.put(inputSendOperationEvent, inputSendOperationEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SendOperationEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitSendOperationEvent(inputSendOperationEvent);
            theResult = super.caseSendOperationEvent(inputSendOperationEvent);
            this.doSwitch((EObject) inputSendOperationEvent.getOperation());
        }
        return theResult;
    }

    @Override
    @objid ("1386585e-4583-11e0-b54c-00137279a832")
    public Object caseSendSignalAction(SendSignalAction inputSendSignalAction) {
        Object theResult = visitorMap.get(inputSendSignalAction);
        if (theResult == null) {
            visitorMap.put(inputSendSignalAction, inputSendSignalAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SendSignalActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitSendSignalAction(inputSendSignalAction);
            theResult = super.caseSendSignalAction(inputSendSignalAction);
            this.doSwitch((EObject) inputSendSignalAction.getTarget());
            this.doSwitch((EObject) inputSendSignalAction.getSignal());
        }
        return theResult;
    }

    @Override
    @objid ("1388bab8-4583-11e0-b54c-00137279a832")
    public Object caseSendSignalEvent(SendSignalEvent inputSendSignalEvent) {
        Object theResult = visitorMap.get(inputSendSignalEvent);
        if (theResult == null) {
            visitorMap.put(inputSendSignalEvent, inputSendSignalEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SendSignalEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitSendSignalEvent(inputSendSignalEvent);
            theResult = super.caseSendSignalEvent(inputSendSignalEvent);
            this.doSwitch((EObject) inputSendSignalEvent.getSignal());
        }
        return theResult;
    }

    @Override
    @objid ("1388babe-4583-11e0-b54c-00137279a832")
    public Object caseSequenceNode(SequenceNode inputSequenceNode) {
        Object theResult = visitorMap.get(inputSequenceNode);
        if (theResult == null) {
            visitorMap.put(inputSequenceNode, inputSequenceNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SequenceNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitSequenceNode(inputSequenceNode);
            theResult = super.caseSequenceNode(inputSequenceNode);
            for (Object executableNode : inputSequenceNode.getExecutableNodes()) {
                this.doSwitch((EObject) executableNode);
            }
        }
        return theResult;
    }

    @Override
    @objid ("138b1d16-4583-11e0-b54c-00137279a832")
    public Object caseSignal(Signal inputSignal) {
        Object theResult = visitorMap.get(inputSignal);
        if (theResult == null) {
            visitorMap.put(inputSignal, inputSignal);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SignalImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitSignal(inputSignal);
            theResult = super.caseSignal(inputSignal);
            for (Object ownedAttribute : inputSignal.getOwnedAttributes()) {
                this.doSwitch((EObject) ownedAttribute);
            }
        }
        return theResult;
    }

    @Override
    @objid ("138d7f6c-4583-11e0-b54c-00137279a832")
    public Object caseSignalEvent(SignalEvent inputSignalEvent) {
        Object theResult = visitorMap.get(inputSignalEvent);
        if (theResult == null) {
            visitorMap.put(inputSignalEvent, inputSignalEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SignalEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitSignalEvent(inputSignalEvent);
            theResult = super.caseSignalEvent(inputSignalEvent);
            this.doSwitch((EObject) inputSignalEvent.getSignal());
        }
        return theResult;
    }

    @Override
    @objid ("138fe1c6-4583-11e0-b54c-00137279a832")
    public Object caseSlot(Slot inputSlot) {
        Object theResult = visitorMap.get(inputSlot);
        if (theResult == null) {
            visitorMap.put(inputSlot, inputSlot);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SlotImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitSlot(inputSlot);
            theResult = super.caseSlot(inputSlot);
            this.doSwitch((EObject) inputSlot.getOwningInstance());
            this.doSwitch((EObject) inputSlot.getDefiningFeature());
            for (Object value : inputSlot.getValues()) {
                this.doSwitch((EObject) value);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13924420-4583-11e0-b54c-00137279a832")
    public Object caseStartClassifierBehaviorAction(StartClassifierBehaviorAction inputStartClassifierBehaviorAction) {
        Object theResult = visitorMap.get(inputStartClassifierBehaviorAction);
        if (theResult == null) {
            visitorMap.put(inputStartClassifierBehaviorAction,
                    inputStartClassifierBehaviorAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StartClassifierBehaviorActionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitStartClassifierBehaviorAction(inputStartClassifierBehaviorAction);
            theResult = super
            .caseStartClassifierBehaviorAction(inputStartClassifierBehaviorAction);
            this.doSwitch((EObject) inputStartClassifierBehaviorAction
                    .getObject());
        }
        return theResult;
    }

    @Override
    @objid ("13924426-4583-11e0-b54c-00137279a832")
    public Object caseState(State inputState) {
        Object theResult = visitorMap.get(inputState);
        if (theResult == null) {
            visitorMap.put(inputState, inputState);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StateImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitState(inputState);
            theResult = super.caseState(inputState);
            this.doSwitch((EObject) inputState.getSubmachine());
            for (Object connection : inputState.getConnections()) {
                this.doSwitch((EObject) connection);
            }
            this.doSwitch((EObject) inputState.getRedefinedState());
            for (Object region : inputState.getRegions()) {
                this.doSwitch((EObject) region);
            }
            // this.doSwitch((EObject)inputState.getRedefinitionContext());
            for (Object redefinitionContext : inputState
                    .getRedefinitionContexts()) {
                this.doSwitch((EObject) redefinitionContext);
            }
            this.doSwitch((EObject) inputState.getStateInvariant());
            this.doSwitch((EObject) inputState.getEntry());
            this.doSwitch((EObject) inputState.getExit());
            this.doSwitch((EObject) inputState.getDoActivity());
            for (Object connectionPoint : inputState.getConnectionPoints()) {
                this.doSwitch((EObject) connectionPoint);
            }
            for (Object deferrableTrigger : inputState.getDeferrableTriggers()) {
                this.doSwitch((EObject) deferrableTrigger);
            }
        }
        return theResult;
    }

    @Override
    @objid ("1394a67b-4583-11e0-b54c-00137279a832")
    public Object caseStateInvariant(StateInvariant inputStateInvariant) {
        Object theResult = visitorMap.get(inputStateInvariant);
        if (theResult == null) {
            visitorMap.put(inputStateInvariant, inputStateInvariant);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StateInvariantImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitStateInvariant(inputStateInvariant);
            theResult = super.caseStateInvariant(inputStateInvariant);
            this.doSwitch((EObject) inputStateInvariant.getInvariant());
            // this.doSwitch((EObject)inputStateInvariant.getCovered());
            for (Object covered : inputStateInvariant.getCovereds()) {
                this.doSwitch((EObject) covered);
            }
        }
        return theResult;
    }

    @Override
    @objid ("139708d4-4583-11e0-b54c-00137279a832")
    public Object caseStateMachine(StateMachine inputStateMachine) {
        Object theResult = visitorMap.get(inputStateMachine);
        if (theResult == null) {
            visitorMap.put(inputStateMachine, inputStateMachine);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StateMachineImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitStateMachine(inputStateMachine);
            theResult = super.caseStateMachine(inputStateMachine);
            for (Object region : inputStateMachine.getRegions()) {
                this.doSwitch((EObject) region);
            }
            for (Object connectionPoint : inputStateMachine
                    .getConnectionPoints()) {
                this.doSwitch((EObject) connectionPoint);
            }
            for (Object extendedStateMachine : inputStateMachine
                    .getExtendedStateMachines()) {
                this.doSwitch((EObject) extendedStateMachine);
            }
            for (Object submachineState : inputStateMachine
                    .getSubmachineStates()) {
                this.doSwitch((EObject) submachineState);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13996b2e-4583-11e0-b54c-00137279a832")
    public Object caseStereotype(Stereotype inputStereotype) {
        Object theResult = visitorMap.get(inputStereotype);
        if (theResult == null) {
            visitorMap.put(inputStereotype, inputStereotype);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StereotypeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitStereotype(inputStereotype);
            theResult = super.caseStereotype(inputStereotype);
            for (Object icon : inputStereotype.getIcons()) {
                this.doSwitch((EObject) icon);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13996b34-4583-11e0-b54c-00137279a832")
    public Object caseStringExpression(StringExpression inputStringExpression) {
        Object theResult = visitorMap.get(inputStringExpression);
        if (theResult == null) {
            visitorMap.put(inputStringExpression, inputStringExpression);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StringExpressionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitStringExpression(inputStringExpression);
            theResult = super.caseStringExpression(inputStringExpression);
            for (Object subExpression : inputStringExpression
                    .getSubExpressions()) {
                this.doSwitch((EObject) subExpression);
            }
            this
            .doSwitch((EObject) inputStringExpression
                    .getOwningExpression());
        }
        return theResult;
    }

    @Override
    @objid ("13996b3a-4583-11e0-b54c-00137279a832")
    public Object caseStructuralFeature(StructuralFeature inputStructuralFeature) {
        return super.caseStructuralFeature(inputStructuralFeature);
    }

    @Override
    @objid ("139bcd88-4583-11e0-b54c-00137279a832")
    public Object caseStructuralFeatureAction(StructuralFeatureAction inputStructuralFeatureAction) {
        Object theResult = super
        .caseStructuralFeatureAction(inputStructuralFeatureAction);
        this.doSwitch((EObject) inputStructuralFeatureAction
                .getStructuralFeature());
        this.doSwitch((EObject) inputStructuralFeatureAction.getObject());
        return theResult;
    }

    @Override
    @objid ("139e2fe2-4583-11e0-b54c-00137279a832")
    public Object caseStructuredActivityNode(StructuredActivityNode inputStructuredActivityNode) {
        Object theResult = visitorMap.get(inputStructuredActivityNode);
        if (theResult == null) {
            visitorMap.put(inputStructuredActivityNode,
                    inputStructuredActivityNode);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("StructuredActivityNodeImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitStructuredActivityNode(inputStructuredActivityNode);
            theResult = super
            .caseStructuredActivityNode(inputStructuredActivityNode);
            for (Object variable : inputStructuredActivityNode.getVariables()) {
                this.doSwitch((EObject) variable);
            }
            for (Object node : inputStructuredActivityNode.getNodes()) {
                this.doSwitch((EObject) node);
            }
            this.doSwitch((EObject) inputStructuredActivityNode.getActivity());
            for (Object edge : inputStructuredActivityNode.getEdges()) {
                this.doSwitch((EObject) edge);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13a0923c-4583-11e0-b54c-00137279a832")
    public Object caseStructuredClassifier(StructuredClassifier inputStructuredClassifier) {
        Object theResult = super
        .caseStructuredClassifier(inputStructuredClassifier);
        for (Object ownedAttribute : inputStructuredClassifier
                .getOwnedAttributes()) {
            this.doSwitch((EObject) ownedAttribute);
        }
        for (Object part : inputStructuredClassifier.getParts()) {
            this.doSwitch((EObject) part);
        }
        for (Object role : inputStructuredClassifier.getRoles()) {
            this.doSwitch((EObject) role);
        }
        for (Object ownedConnector : inputStructuredClassifier
                .getOwnedConnectors()) {
            this.doSwitch((EObject) ownedConnector);
        }
        return theResult;
    }

    @Override
    @objid ("13a09242-4583-11e0-b54c-00137279a832")
    public Object caseSubstitution(Substitution inputSubstitution) {
        Object theResult = visitorMap.get(inputSubstitution);
        if (theResult == null) {
            visitorMap.put(inputSubstitution, inputSubstitution);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("SubstitutionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitSubstitution(inputSubstitution);
            theResult = super.caseSubstitution(inputSubstitution);
            this.doSwitch((EObject) inputSubstitution.getContract());
            this.doSwitch((EObject) inputSubstitution
                    .getSubstitutingClassifier());
        }
        return theResult;
    }

    @Override
    @objid ("13a2f497-4583-11e0-b54c-00137279a832")
    public Object caseTemplateBinding(TemplateBinding inputTemplateBinding) {
        Object theResult = visitorMap.get(inputTemplateBinding);
        if (theResult == null) {
            visitorMap.put(inputTemplateBinding, inputTemplateBinding);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TemplateBindingImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTemplateBinding(inputTemplateBinding);
            theResult = super.caseTemplateBinding(inputTemplateBinding);
            this.doSwitch((EObject) inputTemplateBinding.getBoundElement());
            this.doSwitch((EObject) inputTemplateBinding.getSignature());
            for (Object parameterSubstitution : inputTemplateBinding
                    .getParameterSubstitutions()) {
                this.doSwitch((EObject) parameterSubstitution);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13aa1ba4-4583-11e0-b54c-00137279a832")
    public Object caseTemplateParameter(TemplateParameter inputTemplateParameter) {
        Object theResult = visitorMap.get(inputTemplateParameter);
        if (theResult == null) {
            visitorMap.put(inputTemplateParameter, inputTemplateParameter);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TemplateParameterImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTemplateParameter(inputTemplateParameter);
            theResult = super.caseTemplateParameter(inputTemplateParameter);
            this.doSwitch((EObject) inputTemplateParameter.getSignature());
            this.doSwitch((EObject) inputTemplateParameter
                    .getParameteredElement());
            this.doSwitch((EObject) inputTemplateParameter
                    .getOwnedParameteredElement());
            this.doSwitch((EObject) inputTemplateParameter.getDefault());
            this.doSwitch((EObject) inputTemplateParameter.getOwnedDefault());
        }
        return theResult;
    }

    @Override
    @objid ("13aa1baa-4583-11e0-b54c-00137279a832")
    public Object caseTemplateParameterSubstitution(TemplateParameterSubstitution inputTemplateParameterSubstitution) {
        Object theResult = visitorMap.get(inputTemplateParameterSubstitution);
        if (theResult == null) {
            visitorMap.put(inputTemplateParameterSubstitution,
                    inputTemplateParameterSubstitution);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TemplateParameterSubstitutionImpl".equals(theResult
                        .getClass().getSimpleName()))) {
            behavior
            .visitTemplateParameterSubstitution(inputTemplateParameterSubstitution);
            theResult = super
            .caseTemplateParameterSubstitution(inputTemplateParameterSubstitution);
            this.doSwitch((EObject) inputTemplateParameterSubstitution
                    .getFormal());
            this.doSwitch((EObject) inputTemplateParameterSubstitution
                    .getTemplateBinding());
            //            for (Object actual : inputTemplateParameterSubstitution
                    //                    .getActuals()) {
            //                this.doSwitch((EObject) actual);
            //            }
            //            for (Object ownedActual : inputTemplateParameterSubstitution
            //                    .getOwnedActuals()) {
            //                this.doSwitch((EObject) ownedActual);
            //            }
        
            this.doSwitch((EObject) inputTemplateParameterSubstitution.getActual());
        
            this.doSwitch((EObject)  inputTemplateParameterSubstitution.getOwnedActual());
        
        }
        return theResult;
    }

    @Override
    @objid ("13ac7e00-4583-11e0-b54c-00137279a832")
    public Object caseTemplateSignature(TemplateSignature inputTemplateSignature) {
        Object theResult = visitorMap.get(inputTemplateSignature);
        if (theResult == null) {
            visitorMap.put(inputTemplateSignature, inputTemplateSignature);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TemplateSignatureImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTemplateSignature(inputTemplateSignature);
            theResult = super.caseTemplateSignature(inputTemplateSignature);
            for (Object parameter : inputTemplateSignature.getParameters()) {
                this.doSwitch((EObject) parameter);
            }
            for (Object ownedParameter : inputTemplateSignature
                    .getOwnedParameters()) {
                this.doSwitch((EObject) ownedParameter);
            }
            this.doSwitch((EObject) inputTemplateSignature.getTemplate());
        }
        return theResult;
    }

    @Override
    @objid ("13aee058-4583-11e0-b54c-00137279a832")
    public Object caseTemplateableElement(TemplateableElement inputTemplateableElement) {
        Object theResult = super
        .caseTemplateableElement(inputTemplateableElement);
        for (Object templateBinding : inputTemplateableElement
                .getTemplateBindings()) {
            this.doSwitch((EObject) templateBinding);
        }
        this.doSwitch((EObject) inputTemplateableElement
                .getOwnedTemplateSignature());
        return theResult;
    }

    @Override
    @objid ("13b142b2-4583-11e0-b54c-00137279a832")
    public Object caseTestIdentityAction(TestIdentityAction inputTestIdentityAction) {
        Object theResult = visitorMap.get(inputTestIdentityAction);
        if (theResult == null) {
            visitorMap.put(inputTestIdentityAction, inputTestIdentityAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TestIdentityActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTestIdentityAction(inputTestIdentityAction);
            theResult = super.caseTestIdentityAction(inputTestIdentityAction);
            this.doSwitch((EObject) inputTestIdentityAction.getFirst());
            this.doSwitch((EObject) inputTestIdentityAction.getSecond());
            this.doSwitch((EObject) inputTestIdentityAction.getResult());
        }
        return theResult;
    }

    @Override
    @objid ("13b3a50c-4583-11e0-b54c-00137279a832")
    public Object caseTimeConstraint(TimeConstraint inputTimeConstraint) {
        Object theResult = visitorMap.get(inputTimeConstraint);
        if (theResult == null) {
            visitorMap.put(inputTimeConstraint, inputTimeConstraint);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeConstraintImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTimeConstraint(inputTimeConstraint);
            theResult = super.caseTimeConstraint(inputTimeConstraint);
            this.doSwitch((EObject) inputTimeConstraint.getSpecification());
        }
        return theResult;
    }

    @Override
    @objid ("13b3a512-4583-11e0-b54c-00137279a832")
    public Object caseTimeEvent(TimeEvent inputTimeEvent) {
        Object theResult = visitorMap.get(inputTimeEvent);
        if (theResult == null) {
            visitorMap.put(inputTimeEvent, inputTimeEvent);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeEventImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTimeEvent(inputTimeEvent);
            theResult = super.caseTimeEvent(inputTimeEvent);
            this.doSwitch((EObject) inputTimeEvent.getWhen());
        }
        return theResult;
    }

    @Override
    @objid ("13b6076a-4583-11e0-b54c-00137279a832")
    public Object caseTimeExpression(TimeExpression inputTimeExpression) {
        Object theResult = visitorMap.get(inputTimeExpression);
        if (theResult == null) {
            visitorMap.put(inputTimeExpression, inputTimeExpression);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeExpressionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTimeExpression(inputTimeExpression);
            theResult = super.caseTimeExpression(inputTimeExpression);
            this.doSwitch((EObject) inputTimeExpression.getExpr());
            for (Object observation : inputTimeExpression.getObservations()) {
                this.doSwitch((EObject) observation);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13b869c1-4583-11e0-b54c-00137279a832")
    public Object caseTimeInterval(TimeInterval inputTimeInterval) {
        Object theResult = visitorMap.get(inputTimeInterval);
        if (theResult == null) {
            visitorMap.put(inputTimeInterval, inputTimeInterval);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeIntervalImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTimeInterval(inputTimeInterval);
            theResult = super.caseTimeInterval(inputTimeInterval);
            this.doSwitch((EObject) inputTimeInterval.getMax());
            this.doSwitch((EObject) inputTimeInterval.getMin());
        }
        return theResult;
    }

    @Override
    @objid ("13bacc1e-4583-11e0-b54c-00137279a832")
    public Object caseTimeObservation(final TimeObservation inputTimeIservation) {
        Object theResult = visitorMap.get(inputTimeIservation);
        if (theResult == null) {
            visitorMap.put(inputTimeIservation, inputTimeIservation);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TimeIservationImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTimeIservation(inputTimeIservation);
            theResult = super.caseTimeObservation(inputTimeIservation);
            this.doSwitch((EObject) inputTimeIservation.getEvent());
        }
        return theResult;
    }

    @Override
    @objid ("13bd2e75-4583-11e0-b54c-00137279a832")
    public Object caseTransition(Transition inputTransition) {
        Object theResult = visitorMap.get(inputTransition);
        if (theResult == null) {
            visitorMap.put(inputTransition, inputTransition);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TransitionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitTransition(inputTransition);
            theResult = super.caseTransition(inputTransition);
            this.doSwitch((EObject) inputTransition.getContainer());
            this.doSwitch((EObject) inputTransition.getSource());
            this.doSwitch((EObject) inputTransition.getTarget());
            this.doSwitch((EObject) inputTransition.getRedefinedTransition());
            this.doSwitch((EObject) inputTransition.getGuard());
            // this.doSwitch((EObject)inputTransition.getRedefinitionContext());
            for (Object redefinitionContext : inputTransition
                    .getRedefinitionContexts()) {
                this.doSwitch((EObject) redefinitionContext);
            }
            this.doSwitch((EObject) inputTransition.getEffect());
            for (Object trigger : inputTransition.getTriggers()) {
                this.doSwitch((EObject) trigger);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13bf90ce-4583-11e0-b54c-00137279a832")
    public Object caseTrigger(Trigger inputTrigger) {
        Object theResult = visitorMap.get(inputTrigger);
        if (theResult == null) {
            visitorMap.put(inputTrigger, inputTrigger);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("TriggerImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitTrigger(inputTrigger);
            theResult = super.caseTrigger(inputTrigger);
            this.doSwitch((EObject) inputTrigger.getEvent());
            for (Object port : inputTrigger.getPorts()) {
                this.doSwitch((EObject) port);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13c1f328-4583-11e0-b54c-00137279a832")
    public Object caseType(Type inputType) {
        Object theResult = super.caseType(inputType);
        this.doSwitch((EObject) inputType.getPackage());
        return theResult;
    }

    @Override
    @objid ("13c45582-4583-11e0-b54c-00137279a832")
    public Object caseTypedElement(TypedElement inputTypedElement) {
        Object theResult = super.caseTypedElement(inputTypedElement);
        this.doSwitch((EObject) inputTypedElement.getType());
        return theResult;
    }

    @Override
    @objid ("13c45588-4583-11e0-b54c-00137279a832")
    public Object caseUnmarshallAction(UnmarshallAction inputUnmarshallAction) {
        Object theResult = visitorMap.get(inputUnmarshallAction);
        if (theResult == null) {
            visitorMap.put(inputUnmarshallAction, inputUnmarshallAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("UnmarshallActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior.visitUnmarshallAction(inputUnmarshallAction);
            theResult = super.caseUnmarshallAction(inputUnmarshallAction);
            for (Object result : inputUnmarshallAction.getResults()) {
                this.doSwitch((EObject) result);
            }
            this.doSwitch((EObject) inputUnmarshallAction.getUnmarshallType());
            this.doSwitch((EObject) inputUnmarshallAction.getObject());
        }
        return theResult;
    }

    @Override
    @objid ("13c6b7e0-4583-11e0-b54c-00137279a832")
    public Object caseUsage(Usage inputUsage) {
        Object theResult = visitorMap.get(inputUsage);
        if (theResult == null) {
            visitorMap.put(inputUsage, inputUsage);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("UsageImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitUsage(inputUsage);
            theResult = super.caseUsage(inputUsage);
        }
        return theResult;
    }

    @Override
    @objid ("13c91a37-4583-11e0-b54c-00137279a832")
    public Object caseUseCase(UseCase inputUseCase) {
        Object theResult = visitorMap.get(inputUseCase);
        if (theResult == null) {
            visitorMap.put(inputUseCase, inputUseCase);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("UseCaseImpl".equals(theResult.getClass().getSimpleName()))) {
            behavior.visitUseCase(inputUseCase);
            theResult = super.caseUseCase(inputUseCase);
            for (Object include : inputUseCase.getIncludes()) {
                this.doSwitch((EObject) include);
            }
            for (Object extend : inputUseCase.getExtends()) {
                this.doSwitch((EObject) extend);
            }
            for (Object extensionPoint : inputUseCase.getExtensionPoints()) {
                this.doSwitch((EObject) extensionPoint);
            }
            for (Object subject : inputUseCase.getSubjects()) {
                this.doSwitch((EObject) subject);
            }
        }
        return theResult;
    }

    @Override
    @objid ("13cb7c90-4583-11e0-b54c-00137279a832")
    public Object caseValuePin(ValuePin inputValuePin) {
        Object theResult = visitorMap.get(inputValuePin);
        if (theResult == null) {
            visitorMap.put(inputValuePin, inputValuePin);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ValuePinImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitValuePin(inputValuePin);
            theResult = super.caseValuePin(inputValuePin);
            this.doSwitch((EObject) inputValuePin.getValue());
        }
        return theResult;
    }

    @Override
    @objid ("13cddeea-4583-11e0-b54c-00137279a832")
    public Object caseValueSpecification(ValueSpecification inputValueSpecification) {
        return super.caseValueSpecification(inputValueSpecification);
    }

    @Override
    @objid ("13d04144-4583-11e0-b54c-00137279a832")
    public Object caseValueSpecificationAction(ValueSpecificationAction inputValueSpecificationAction) {
        Object theResult = visitorMap.get(inputValueSpecificationAction);
        if (theResult == null) {
            visitorMap.put(inputValueSpecificationAction,
                    inputValueSpecificationAction);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("ValueSpecificationActionImpl".equals(theResult.getClass()
                        .getSimpleName()))) {
            behavior
            .visitValueSpecificationAction(inputValueSpecificationAction);
            theResult = super
            .caseValueSpecificationAction(inputValueSpecificationAction);
            this.doSwitch((EObject) inputValueSpecificationAction.getValue());
            this.doSwitch((EObject) inputValueSpecificationAction.getResult());
        }
        return theResult;
    }

    @Override
    @objid ("13d2a39e-4583-11e0-b54c-00137279a832")
    public Object caseVariable(Variable inputVariable) {
        Object theResult = visitorMap.get(inputVariable);
        if (theResult == null) {
            visitorMap.put(inputVariable, inputVariable);
        }
        
        // In particular case of this concrete element is inherited by another
        // concrete element, it
        // shall be in the visitorMap. Also do call the treatment defined at the
        // current super level:
        if (theResult == null
                || !("VariableImpl"
                        .equals(theResult.getClass().getSimpleName()))) {
            behavior.visitVariable(inputVariable);
            theResult = super.caseVariable(inputVariable);
            this.doSwitch((EObject) inputVariable.getScope());
            this.doSwitch((EObject) inputVariable.getActivityScope());
        }
        return theResult;
    }

    @Override
    @objid ("13d2a3a4-4583-11e0-b54c-00137279a832")
    public Object caseVariableAction(VariableAction inputVariableAction) {
        Object theResult = super.caseVariableAction(inputVariableAction);
        this.doSwitch((EObject) inputVariableAction.getVariable());
        return theResult;
    }

    @Override
    @objid ("13d505fc-4583-11e0-b54c-00137279a832")
    public Object caseVertex(Vertex inputVertex) {
        Object theResult = super.caseVertex(inputVertex);
        this.doSwitch((EObject) inputVertex.getContainer());
        for (Object outgoing : inputVertex.getOutgoings()) {
            this.doSwitch((EObject) outgoing);
        }
        for (Object incoming : inputVertex.getIncomings()) {
            this.doSwitch((EObject) incoming);
        }
        return theResult;
    }

    @Override
    @objid ("13d76853-4583-11e0-b54c-00137279a832")
    public Object caseWriteLinkAction(WriteLinkAction inputWriteLinkAction) {
        return super.caseWriteLinkAction(inputWriteLinkAction);
    }

    @Override
    @objid ("13d9caac-4583-11e0-b54c-00137279a832")
    public Object caseWriteStructuralFeatureAction(WriteStructuralFeatureAction inputWriteStructuralFeatureAction) {
        Object theResult = super
        .caseWriteStructuralFeatureAction(inputWriteStructuralFeatureAction);
        this.doSwitch((EObject) inputWriteStructuralFeatureAction.getValue());
        return theResult;
    }

    @Override
    @objid ("13dc2d06-4583-11e0-b54c-00137279a832")
    public Object caseWriteVariableAction(WriteVariableAction inputWriteVariableAction) {
        Object theResult = super
        .caseWriteVariableAction(inputWriteVariableAction);
        this.doSwitch((EObject) inputWriteVariableAction.getValue());
        return theResult;
    }

    @Override
    @objid ("13de8f60-4583-11e0-b54c-00137279a832")
    public Object doSwitch(EObject inputElement) {
        if (inputElement != null)
            return super.doSwitch(inputElement);
        else
            return null;
    }

}
